#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 3206
#define LARGE_STATE_COUNT 714
#define SYMBOL_COUNT 299
#define ALIAS_COUNT 8
#define TOKEN_COUNT 141
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_QMARK_QMARK = 86,
  anon_sym_instanceof = 87,
  anon_sym_BANG = 88,
  anon_sym_TILDE = 89,
  anon_sym_void = 90,
  anon_sym_delete = 91,
  anon_sym_PLUS_PLUS = 92,
  anon_sym_DASH_DASH = 93,
  anon_sym_DQUOTE = 94,
  aux_sym_string_token1 = 95,
  anon_sym_SQUOTE = 96,
  aux_sym_string_token2 = 97,
  sym_escape_sequence = 98,
  sym_comment = 99,
  anon_sym_BQUOTE = 100,
  anon_sym_DOLLAR_LBRACE = 101,
  anon_sym_SLASH2 = 102,
  sym_regex_pattern = 103,
  sym_regex_flags = 104,
  sym_number = 105,
  anon_sym_target = 106,
  sym_this = 107,
  sym_super = 108,
  sym_true = 109,
  sym_false = 110,
  sym_null = 111,
  sym_undefined = 112,
  anon_sym_AT = 113,
  anon_sym_static = 114,
  anon_sym_abstract = 115,
  anon_sym_get = 116,
  anon_sym_set = 117,
  anon_sym_declare = 118,
  anon_sym_public = 119,
  anon_sym_private = 120,
  anon_sym_protected = 121,
  anon_sym_module = 122,
  anon_sym_any = 123,
  anon_sym_number = 124,
  anon_sym_boolean = 125,
  anon_sym_string = 126,
  anon_sym_symbol = 127,
  anon_sym_require = 128,
  anon_sym_implements = 129,
  anon_sym_global = 130,
  anon_sym_interface = 131,
  anon_sym_extends = 132,
  anon_sym_enum = 133,
  sym_readonly = 134,
  anon_sym_is = 135,
  anon_sym_keyof = 136,
  anon_sym_LBRACE_PIPE = 137,
  anon_sym_PIPE_RBRACE = 138,
  sym__automatic_semicolon = 139,
  sym__template_chars = 140,
  sym_program = 141,
  sym_export_statement = 142,
  sym_export_clause = 143,
  sym__import_export_specifier = 144,
  sym__declaration = 145,
  sym_import = 146,
  sym_import_statement = 147,
  sym_import_clause = 148,
  sym__from_clause = 149,
  sym_namespace_import = 150,
  sym_named_imports = 151,
  sym_expression_statement = 152,
  sym_variable_declaration = 153,
  sym_lexical_declaration = 154,
  sym_variable_declarator = 155,
  sym_statement_block = 156,
  sym_if_statement = 157,
  sym_switch_statement = 158,
  sym_for_statement = 159,
  sym_for_in_statement = 160,
  sym__for_header = 161,
  sym_while_statement = 162,
  sym_do_statement = 163,
  sym_try_statement = 164,
  sym_with_statement = 165,
  sym_break_statement = 166,
  sym_continue_statement = 167,
  sym_debugger_statement = 168,
  sym_return_statement = 169,
  sym_throw_statement = 170,
  sym_empty_statement = 171,
  sym_labeled_statement = 172,
  sym_switch_body = 173,
  sym_switch_case = 174,
  sym_switch_default = 175,
  sym_catch_clause = 176,
  sym_finally_clause = 177,
  sym_parenthesized_expression = 178,
  sym__expression = 179,
  sym_yield_expression = 180,
  sym_object = 181,
  sym_assignment_pattern = 182,
  sym_array = 183,
  sym_nested_identifier = 184,
  sym_class = 185,
  sym_class_declaration = 186,
  sym_class_heritage = 187,
  sym_function = 188,
  sym_function_declaration = 189,
  sym_generator_function = 190,
  sym_generator_function_declaration = 191,
  sym_arrow_function = 192,
  sym__call_signature = 193,
  sym_call_expression = 194,
  sym_new_expression = 195,
  sym_await_expression = 196,
  sym_member_expression = 197,
  sym_subscript_expression = 198,
  sym_assignment_expression = 199,
  sym_augmented_assignment_expression = 200,
  sym__initializer = 201,
  sym_spread_element = 202,
  sym_ternary_expression = 203,
  sym_binary_expression = 204,
  sym_unary_expression = 205,
  sym_update_expression = 206,
  sym_sequence_expression = 207,
  sym_string = 208,
  sym_template_string = 209,
  sym_template_substitution = 210,
  sym_regex = 211,
  sym_meta_property = 212,
  sym_arguments = 213,
  sym_decorator = 214,
  sym_decorator_member_expression = 215,
  sym_decorator_call_expression = 216,
  sym_class_body = 217,
  sym_public_field_definition = 218,
  sym_formal_parameters = 219,
  sym_rest_parameter = 220,
  sym_method_definition = 221,
  sym_pair = 222,
  sym__property_name = 223,
  sym_computed_property_name = 224,
  sym_non_null_expression = 225,
  sym_method_signature = 226,
  sym_abstract_method_signature = 227,
  sym_function_signature = 228,
  sym_type_assertion = 229,
  sym_as_expression = 230,
  sym_import_require_clause = 231,
  sym_implements_clause = 232,
  sym_ambient_declaration = 233,
  sym_abstract_class_declaration = 234,
  sym_module = 235,
  sym_internal_module = 236,
  sym__module = 237,
  sym_import_alias = 238,
  sym_nested_type_identifier = 239,
  sym_interface_declaration = 240,
  sym_extends_clause = 241,
  sym_enum_declaration = 242,
  sym_enum_body = 243,
  sym_enum_assignment = 244,
  sym_type_alias_declaration = 245,
  sym_accessibility_modifier = 246,
  sym_required_parameter = 247,
  sym_optional_parameter = 248,
  sym__parameter_name = 249,
  sym_type_annotation = 250,
  sym__type = 251,
  sym_constructor_type = 252,
  sym__primary_type = 253,
  sym_generic_type = 254,
  sym_type_predicate = 255,
  sym_type_query = 256,
  sym_index_type_query = 257,
  sym_lookup_type = 258,
  sym_mapped_type_clause = 259,
  sym_literal_type = 260,
  sym__number = 261,
  sym_existential_type = 262,
  sym_flow_maybe_type = 263,
  sym_parenthesized_type = 264,
  sym_predefined_type = 265,
  sym_type_arguments = 266,
  sym_object_type = 267,
  sym_call_signature = 268,
  sym_property_signature = 269,
  sym_type_parameters = 270,
  sym_type_parameter = 271,
  sym_default_type = 272,
  sym_constraint = 273,
  sym_construct_signature = 274,
  sym_index_signature = 275,
  sym_array_type = 276,
  sym_tuple_type = 277,
  sym_union_type = 278,
  sym_intersection_type = 279,
  sym_function_type = 280,
  aux_sym_program_repeat1 = 281,
  aux_sym_export_statement_repeat1 = 282,
  aux_sym_export_clause_repeat1 = 283,
  aux_sym_named_imports_repeat1 = 284,
  aux_sym_variable_declaration_repeat1 = 285,
  aux_sym_switch_body_repeat1 = 286,
  aux_sym_object_repeat1 = 287,
  aux_sym_array_repeat1 = 288,
  aux_sym_string_repeat1 = 289,
  aux_sym_string_repeat2 = 290,
  aux_sym_template_string_repeat1 = 291,
  aux_sym_class_body_repeat1 = 292,
  aux_sym_formal_parameters_repeat1 = 293,
  aux_sym_implements_clause_repeat1 = 294,
  aux_sym_extends_clause_repeat1 = 295,
  aux_sym_enum_body_repeat1 = 296,
  aux_sym_object_type_repeat1 = 297,
  aux_sym_type_parameters_repeat1 = 298,
  alias_sym_array_pattern = 299,
  alias_sym_export_specifier = 300,
  alias_sym_import_specifier = 301,
  alias_sym_object_pattern = 302,
  alias_sym_property_identifier = 303,
  alias_sym_shorthand_property_identifier = 304,
  alias_sym_statement_identifier = 305,
  alias_sym_type_identifier = 306,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "??",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [sym_readonly] = sym_readonly,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type] = sym__type,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_export_specifier] = alias_sym_export_specifier,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_source = 31,
  field_type = 32,
  field_type_arguments = 33,
  field_type_parameters = 34,
  field_value = 35,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[187] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 23, .length = 2},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [29] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 29, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 29, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 3},
  [40] = {.index = 40, .length = 1},
  [41] = {.index = 41, .length = 2},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 1},
  [46] = {.index = 50, .length = 3},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 2},
  [50] = {.index = 56, .length = 1},
  [51] = {.index = 57, .length = 2},
  [52] = {.index = 59, .length = 4},
  [53] = {.index = 63, .length = 2},
  [54] = {.index = 65, .length = 2},
  [55] = {.index = 63, .length = 2},
  [56] = {.index = 65, .length = 2},
  [57] = {.index = 20, .length = 2},
  [58] = {.index = 23, .length = 2},
  [59] = {.index = 25, .length = 2},
  [60] = {.index = 67, .length = 3},
  [61] = {.index = 10, .length = 2},
  [62] = {.index = 54, .length = 2},
  [63] = {.index = 70, .length = 3},
  [64] = {.index = 20, .length = 2},
  [65] = {.index = 20, .length = 2},
  [66] = {.index = 73, .length = 4},
  [67] = {.index = 77, .length = 3},
  [68] = {.index = 80, .length = 2},
  [69] = {.index = 82, .length = 1},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 1},
  [72] = {.index = 85, .length = 1},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 20, .length = 2},
  [75] = {.index = 88, .length = 2},
  [76] = {.index = 90, .length = 5},
  [77] = {.index = 86, .length = 2},
  [78] = {.index = 95, .length = 1},
  [79] = {.index = 96, .length = 3},
  [80] = {.index = 96, .length = 3},
  [81] = {.index = 96, .length = 3},
  [82] = {.index = 99, .length = 2},
  [83] = {.index = 101, .length = 3},
  [87] = {.index = 104, .length = 1},
  [88] = {.index = 105, .length = 3},
  [89] = {.index = 108, .length = 4},
  [90] = {.index = 112, .length = 2},
  [91] = {.index = 114, .length = 2},
  [92] = {.index = 116, .length = 2},
  [93] = {.index = 118, .length = 3},
  [94] = {.index = 121, .length = 2},
  [95] = {.index = 123, .length = 2},
  [96] = {.index = 125, .length = 4},
  [97] = {.index = 123, .length = 2},
  [98] = {.index = 129, .length = 4},
  [99] = {.index = 133, .length = 4},
  [100] = {.index = 137, .length = 5},
  [101] = {.index = 142, .length = 3},
  [102] = {.index = 142, .length = 3},
  [103] = {.index = 145, .length = 2},
  [104] = {.index = 99, .length = 2},
  [105] = {.index = 147, .length = 3},
  [106] = {.index = 150, .length = 2},
  [107] = {.index = 152, .length = 3},
  [108] = {.index = 155, .length = 2},
  [109] = {.index = 157, .length = 5},
  [110] = {.index = 162, .length = 2},
  [111] = {.index = 164, .length = 1},
  [112] = {.index = 165, .length = 3},
  [113] = {.index = 168, .length = 1},
  [114] = {.index = 169, .length = 1},
  [115] = {.index = 170, .length = 1},
  [116] = {.index = 171, .length = 2},
  [117] = {.index = 173, .length = 1},
  [118] = {.index = 174, .length = 2},
  [119] = {.index = 176, .length = 4},
  [120] = {.index = 180, .length = 2},
  [121] = {.index = 182, .length = 2},
  [122] = {.index = 184, .length = 2},
  [123] = {.index = 186, .length = 3},
  [124] = {.index = 189, .length = 4},
  [125] = {.index = 193, .length = 4},
  [126] = {.index = 197, .length = 5},
  [127] = {.index = 202, .length = 2},
  [128] = {.index = 204, .length = 3},
  [129] = {.index = 207, .length = 3},
  [130] = {.index = 210, .length = 2},
  [131] = {.index = 212, .length = 3},
  [132] = {.index = 215, .length = 4},
  [133] = {.index = 219, .length = 3},
  [134] = {.index = 222, .length = 2},
  [135] = {.index = 224, .length = 5},
  [136] = {.index = 229, .length = 3},
  [137] = {.index = 232, .length = 2},
  [138] = {.index = 232, .length = 2},
  [139] = {.index = 234, .length = 3},
  [140] = {.index = 232, .length = 2},
  [141] = {.index = 232, .length = 2},
  [142] = {.index = 237, .length = 2},
  [143] = {.index = 239, .length = 4},
  [144] = {.index = 243, .length = 2},
  [145] = {.index = 245, .length = 2},
  [146] = {.index = 247, .length = 1},
  [147] = {.index = 248, .length = 2},
  [148] = {.index = 250, .length = 2},
  [149] = {.index = 252, .length = 3},
  [150] = {.index = 255, .length = 3},
  [151] = {.index = 258, .length = 5},
  [152] = {.index = 263, .length = 3},
  [154] = {.index = 266, .length = 4},
  [155] = {.index = 270, .length = 5},
  [156] = {.index = 275, .length = 2},
  [157] = {.index = 275, .length = 2},
  [158] = {.index = 275, .length = 2},
  [159] = {.index = 275, .length = 2},
  [160] = {.index = 277, .length = 4},
  [161] = {.index = 281, .length = 2},
  [162] = {.index = 281, .length = 2},
  [163] = {.index = 281, .length = 2},
  [164] = {.index = 283, .length = 4},
  [165] = {.index = 287, .length = 4},
  [166] = {.index = 291, .length = 2},
  [167] = {.index = 293, .length = 2},
  [168] = {.index = 295, .length = 2},
  [169] = {.index = 297, .length = 3},
  [170] = {.index = 300, .length = 3},
  [171] = {.index = 303, .length = 2},
  [172] = {.index = 305, .length = 5},
  [173] = {.index = 310, .length = 5},
  [174] = {.index = 315, .length = 4},
  [175] = {.index = 319, .length = 4},
  [176] = {.index = 323, .length = 2},
  [177] = {.index = 325, .length = 3},
  [178] = {.index = 328, .length = 2},
  [179] = {.index = 330, .length = 3},
  [180] = {.index = 333, .length = 5},
  [181] = {.index = 338, .length = 5},
  [182] = {.index = 343, .length = 4},
  [183] = {.index = 347, .length = 4},
  [184] = {.index = 351, .length = 3},
  [185] = {.index = 354, .length = 5},
  [186] = {.index = 359, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_parameters, 0},
    {field_return_type, 1},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_label, 0},
  [23] =
    {field_object, 0},
    {field_property, 2},
  [25] =
    {field_body, 2},
    {field_parameter, 0},
  [27] =
    {field_body, 1},
    {field_name, 0},
  [29] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [31] =
    {field_name, 0},
    {field_type, 1},
  [33] =
    {field_condition, 1},
    {field_consequence, 2},
  [35] =
    {field_body, 2},
    {field_value, 1},
  [37] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [40] =
    {field_value, 1, .inherited = true},
  [41] =
    {field_body, 2},
    {field_condition, 1},
  [43] =
    {field_body, 1},
    {field_handler, 2},
  [45] =
    {field_body, 1},
    {field_finalizer, 2},
  [47] =
    {field_body, 2},
    {field_object, 1},
  [49] =
    {field_label, 1},
  [50] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_body, 2},
    {field_name, 1},
  [56] =
    {field_body, 2},
  [57] =
    {field_body, 2},
    {field_type_parameters, 1},
  [59] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [63] =
    {field_arguments, 2},
    {field_constructor, 1},
  [65] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [67] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [70] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [73] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [77] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [80] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [82] =
    {field_source, 1},
  [83] =
    {field_source, 2, .inherited = true},
  [84] =
    {field_value, 2},
  [85] =
    {field_name, 1},
  [86] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [88] =
    {field_key, 0},
    {field_value, 2},
  [90] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [95] =
    {field_value, 1},
  [96] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [99] =
    {field_body, 3},
    {field_name, 2},
  [101] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [104] =
    {field_value, 2, .inherited = true},
  [105] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [108] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [112] =
    {field_module, 0},
    {field_name, 2},
  [114] =
    {field_flags, 3},
    {field_pattern, 1},
  [116] =
    {field_body, 3},
    {field_name, 1},
  [118] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [121] =
    {field_body, 3},
    {field_type_parameters, 1},
  [123] =
    {field_body, 3},
    {field_parameter, 1},
  [125] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [129] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [133] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [137] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [142] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [145] =
    {field_index, 2},
    {field_object, 0},
  [147] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [150] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [152] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [155] =
    {field_alias, 2},
    {field_name, 0},
  [157] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [162] =
    {field_name, 1},
    {field_value, 3},
  [164] =
    {field_source, 3, .inherited = true},
  [165] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [168] =
    {field_decorator, 1, .inherited = true},
  [169] =
    {field_decorator, 2, .inherited = true},
  [170] =
    {field_value, 3, .inherited = true},
  [171] =
    {field_body, 1},
    {field_condition, 3},
  [173] =
    {field_name, 2},
  [174] =
    {field_name, 1},
    {field_type, 2},
  [176] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [180] =
    {field_name, 0},
    {field_type, 2},
  [182] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [184] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [186] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [189] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [193] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [197] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [202] =
    {field_body, 4},
    {field_name, 2},
  [204] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [207] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [210] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [212] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [215] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [219] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [222] =
    {field_alias, 3},
    {field_name, 1},
  [224] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [229] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [232] =
    {field_left, 1},
    {field_right, 3},
  [234] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [237] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [239] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [243] =
    {field_name, 2},
    {field_type, 3},
  [245] =
    {field_name, 1},
    {field_type, 3},
  [247] =
    {field_name, 3},
  [248] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [250] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [252] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [255] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [258] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [263] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [266] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [270] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [275] =
    {field_left, 2},
    {field_right, 4},
  [277] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [281] =
    {field_body, 4},
    {field_parameter, 2},
  [283] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [287] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [291] =
    {field_name, 2},
    {field_type, 4},
  [293] =
    {field_name, 3},
    {field_type, 4},
  [295] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [297] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [300] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [303] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [305] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [310] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [315] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [319] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [323] =
    {field_name, 3},
    {field_type, 5},
  [325] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [328] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [330] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [333] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [338] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [343] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [347] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [351] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [354] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [359] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[187][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [31] = {
    [0] = alias_sym_object_pattern,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_array_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [38] = {
    [1] = alias_sym_object_pattern,
  },
  [39] = {
    [1] = alias_sym_array_pattern,
  },
  [45] = {
    [1] = alias_sym_statement_identifier,
  },
  [47] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = sym_identifier,
  },
  [54] = {
    [1] = sym_identifier,
  },
  [58] = {
    [2] = alias_sym_property_identifier,
  },
  [61] = {
    [0] = sym_identifier,
  },
  [64] = {
    [0] = alias_sym_object_pattern,
  },
  [65] = {
    [0] = alias_sym_array_pattern,
  },
  [73] = {
    [1] = alias_sym_export_specifier,
  },
  [74] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [77] = {
    [1] = alias_sym_import_specifier,
  },
  [80] = {
    [0] = alias_sym_object_pattern,
  },
  [81] = {
    [0] = alias_sym_array_pattern,
  },
  [84] = {
    [2] = sym_identifier,
  },
  [85] = {
    [2] = alias_sym_object_pattern,
  },
  [86] = {
    [2] = alias_sym_array_pattern,
  },
  [90] = {
    [2] = alias_sym_type_identifier,
  },
  [92] = {
    [1] = alias_sym_type_identifier,
  },
  [93] = {
    [1] = alias_sym_type_identifier,
  },
  [95] = {
    [1] = sym_identifier,
  },
  [101] = {
    [1] = sym_identifier,
  },
  [104] = {
    [2] = alias_sym_type_identifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [110] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [1] = alias_sym_type_identifier,
  },
  [127] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [2] = alias_sym_type_identifier,
  },
  [132] = {
    [2] = alias_sym_type_identifier,
  },
  [136] = {
    [1] = alias_sym_type_identifier,
  },
  [137] = {
    [1] = sym_identifier,
  },
  [140] = {
    [1] = alias_sym_object_pattern,
  },
  [141] = {
    [1] = alias_sym_array_pattern,
  },
  [152] = {
    [2] = alias_sym_type_identifier,
  },
  [153] = {
    [3] = alias_sym_property_identifier,
  },
  [154] = {
    [2] = alias_sym_type_identifier,
  },
  [156] = {
    [2] = sym_identifier,
  },
  [158] = {
    [2] = alias_sym_object_pattern,
  },
  [159] = {
    [2] = alias_sym_array_pattern,
  },
  [162] = {
    [2] = alias_sym_object_pattern,
  },
  [163] = {
    [2] = alias_sym_array_pattern,
  },
};

static inline bool sym_identifier_character_set_1(int32_t lookahead) {
  return
    lookahead == 0 ||
    (0 <= lookahead && lookahead <= '#') ||
    ('%' <= lookahead && lookahead <= '/') ||
    (':' <= lookahead && lookahead <= '@') ||
    ('[' <= lookahead && lookahead <= '^') ||
    lookahead == '`' ||
    ('{' <= lookahead && lookahead <= '~') ||
    lookahead == 160 ||
    lookahead == 8203 ||
    lookahead == 8288 ||
    lookahead == 65279;
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(188);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(20)
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0) ADVANCE(162);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(157);
      if (lookahead == '\r') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(154);
      if (lookahead != 0) ADVANCE(155);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(150);
      if (lookahead == '\r') ADVANCE(165);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(26)
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(174);
      if (lookahead != 0) ADVANCE(175);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead)) ADVANCE(188);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(27);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(65);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(144);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(188);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(24);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(24);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(188);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(32);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0) ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(22);
      if (lookahead != 0) ADVANCE(23);
      END_STATE();
    case 24:
      if (lookahead == '.') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 26:
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(26)
      END_STATE();
    case 27:
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 28:
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 30:
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(168);
      if (lookahead != 0) ADVANCE(163);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(172);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '}') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 38:
      if (lookahead == '}') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 39:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 40:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(188);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(28);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(175);
      END_STATE();
    case 61:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(187);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(120);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(188);
      END_STATE();
    case 62:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(107);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead)) ADVANCE(188);
      END_STATE();
    case 63:
      if (eof) ADVANCE(64);
      if (lookahead == '!') ADVANCE(144);
      if (lookahead == '"') ADVANCE(149);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(156);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(178);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(189);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(171);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(126);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(63)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead) &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(188);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(135);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(190);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(115);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(143);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(113);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(108);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(191);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(157);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(150);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(188);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(163);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(167);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(170);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(21);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(30);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == '0') ADVANCE(183);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(41);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(48);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(177);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(185);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (lookahead == '{') ADVANCE(172);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(30);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 63},
  [2] = {.lex_state = 63},
  [3] = {.lex_state = 63},
  [4] = {.lex_state = 63},
  [5] = {.lex_state = 63},
  [6] = {.lex_state = 63},
  [7] = {.lex_state = 63},
  [8] = {.lex_state = 63},
  [9] = {.lex_state = 63},
  [10] = {.lex_state = 63},
  [11] = {.lex_state = 63},
  [12] = {.lex_state = 63},
  [13] = {.lex_state = 63},
  [14] = {.lex_state = 63},
  [15] = {.lex_state = 63},
  [16] = {.lex_state = 63},
  [17] = {.lex_state = 63},
  [18] = {.lex_state = 63},
  [19] = {.lex_state = 63},
  [20] = {.lex_state = 63},
  [21] = {.lex_state = 63},
  [22] = {.lex_state = 63},
  [23] = {.lex_state = 63},
  [24] = {.lex_state = 63},
  [25] = {.lex_state = 63},
  [26] = {.lex_state = 63},
  [27] = {.lex_state = 63},
  [28] = {.lex_state = 63},
  [29] = {.lex_state = 63},
  [30] = {.lex_state = 63},
  [31] = {.lex_state = 63},
  [32] = {.lex_state = 63},
  [33] = {.lex_state = 63},
  [34] = {.lex_state = 63},
  [35] = {.lex_state = 63},
  [36] = {.lex_state = 63},
  [37] = {.lex_state = 63},
  [38] = {.lex_state = 63},
  [39] = {.lex_state = 63},
  [40] = {.lex_state = 63},
  [41] = {.lex_state = 63},
  [42] = {.lex_state = 63},
  [43] = {.lex_state = 63},
  [44] = {.lex_state = 63},
  [45] = {.lex_state = 63},
  [46] = {.lex_state = 63},
  [47] = {.lex_state = 63},
  [48] = {.lex_state = 6, .external_lex_state = 2},
  [49] = {.lex_state = 6, .external_lex_state = 2},
  [50] = {.lex_state = 6, .external_lex_state = 2},
  [51] = {.lex_state = 6, .external_lex_state = 3},
  [52] = {.lex_state = 6, .external_lex_state = 2},
  [53] = {.lex_state = 6, .external_lex_state = 2},
  [54] = {.lex_state = 6, .external_lex_state = 2},
  [55] = {.lex_state = 6, .external_lex_state = 3},
  [56] = {.lex_state = 6, .external_lex_state = 2},
  [57] = {.lex_state = 6, .external_lex_state = 2},
  [58] = {.lex_state = 6, .external_lex_state = 2},
  [59] = {.lex_state = 6, .external_lex_state = 3},
  [60] = {.lex_state = 6, .external_lex_state = 3},
  [61] = {.lex_state = 6, .external_lex_state = 2},
  [62] = {.lex_state = 6, .external_lex_state = 3},
  [63] = {.lex_state = 6, .external_lex_state = 3},
  [64] = {.lex_state = 6, .external_lex_state = 3},
  [65] = {.lex_state = 6, .external_lex_state = 2},
  [66] = {.lex_state = 6, .external_lex_state = 3},
  [67] = {.lex_state = 6, .external_lex_state = 3},
  [68] = {.lex_state = 6, .external_lex_state = 3},
  [69] = {.lex_state = 7, .external_lex_state = 3},
  [70] = {.lex_state = 6, .external_lex_state = 3},
  [71] = {.lex_state = 6, .external_lex_state = 2},
  [72] = {.lex_state = 6, .external_lex_state = 3},
  [73] = {.lex_state = 7, .external_lex_state = 3},
  [74] = {.lex_state = 6, .external_lex_state = 3},
  [75] = {.lex_state = 6, .external_lex_state = 3},
  [76] = {.lex_state = 7, .external_lex_state = 3},
  [77] = {.lex_state = 6, .external_lex_state = 3},
  [78] = {.lex_state = 6, .external_lex_state = 3},
  [79] = {.lex_state = 6, .external_lex_state = 3},
  [80] = {.lex_state = 6, .external_lex_state = 3},
  [81] = {.lex_state = 6, .external_lex_state = 2},
  [82] = {.lex_state = 6, .external_lex_state = 3},
  [83] = {.lex_state = 6, .external_lex_state = 3},
  [84] = {.lex_state = 6, .external_lex_state = 3},
  [85] = {.lex_state = 6, .external_lex_state = 3},
  [86] = {.lex_state = 6, .external_lex_state = 3},
  [87] = {.lex_state = 14},
  [88] = {.lex_state = 14},
  [89] = {.lex_state = 14},
  [90] = {.lex_state = 14},
  [91] = {.lex_state = 14},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 14},
  [94] = {.lex_state = 14},
  [95] = {.lex_state = 14},
  [96] = {.lex_state = 62, .external_lex_state = 3},
  [97] = {.lex_state = 62, .external_lex_state = 2},
  [98] = {.lex_state = 14},
  [99] = {.lex_state = 14},
  [100] = {.lex_state = 62, .external_lex_state = 3},
  [101] = {.lex_state = 14},
  [102] = {.lex_state = 14},
  [103] = {.lex_state = 62, .external_lex_state = 2},
  [104] = {.lex_state = 14},
  [105] = {.lex_state = 14},
  [106] = {.lex_state = 14},
  [107] = {.lex_state = 14},
  [108] = {.lex_state = 14},
  [109] = {.lex_state = 62, .external_lex_state = 3},
  [110] = {.lex_state = 8, .external_lex_state = 3},
  [111] = {.lex_state = 62, .external_lex_state = 3},
  [112] = {.lex_state = 62, .external_lex_state = 2},
  [113] = {.lex_state = 8, .external_lex_state = 3},
  [114] = {.lex_state = 62, .external_lex_state = 3},
  [115] = {.lex_state = 62, .external_lex_state = 3},
  [116] = {.lex_state = 62, .external_lex_state = 3},
  [117] = {.lex_state = 62, .external_lex_state = 2},
  [118] = {.lex_state = 62, .external_lex_state = 2},
  [119] = {.lex_state = 62, .external_lex_state = 2},
  [120] = {.lex_state = 62, .external_lex_state = 2},
  [121] = {.lex_state = 62, .external_lex_state = 2},
  [122] = {.lex_state = 62, .external_lex_state = 2},
  [123] = {.lex_state = 62, .external_lex_state = 2},
  [124] = {.lex_state = 62, .external_lex_state = 2},
  [125] = {.lex_state = 62, .external_lex_state = 2},
  [126] = {.lex_state = 62, .external_lex_state = 2},
  [127] = {.lex_state = 62, .external_lex_state = 2},
  [128] = {.lex_state = 62, .external_lex_state = 2},
  [129] = {.lex_state = 62, .external_lex_state = 2},
  [130] = {.lex_state = 62, .external_lex_state = 2},
  [131] = {.lex_state = 62, .external_lex_state = 2},
  [132] = {.lex_state = 62, .external_lex_state = 2},
  [133] = {.lex_state = 62, .external_lex_state = 2},
  [134] = {.lex_state = 62, .external_lex_state = 2},
  [135] = {.lex_state = 62, .external_lex_state = 2},
  [136] = {.lex_state = 62, .external_lex_state = 2},
  [137] = {.lex_state = 62, .external_lex_state = 2},
  [138] = {.lex_state = 62, .external_lex_state = 2},
  [139] = {.lex_state = 62, .external_lex_state = 2},
  [140] = {.lex_state = 62, .external_lex_state = 2},
  [141] = {.lex_state = 62, .external_lex_state = 2},
  [142] = {.lex_state = 62, .external_lex_state = 2},
  [143] = {.lex_state = 62, .external_lex_state = 2},
  [144] = {.lex_state = 63},
  [145] = {.lex_state = 63},
  [146] = {.lex_state = 63},
  [147] = {.lex_state = 63},
  [148] = {.lex_state = 63},
  [149] = {.lex_state = 63},
  [150] = {.lex_state = 63},
  [151] = {.lex_state = 63},
  [152] = {.lex_state = 63},
  [153] = {.lex_state = 63},
  [154] = {.lex_state = 63},
  [155] = {.lex_state = 63},
  [156] = {.lex_state = 63},
  [157] = {.lex_state = 63},
  [158] = {.lex_state = 63},
  [159] = {.lex_state = 63},
  [160] = {.lex_state = 63},
  [161] = {.lex_state = 63},
  [162] = {.lex_state = 63},
  [163] = {.lex_state = 63},
  [164] = {.lex_state = 63},
  [165] = {.lex_state = 63},
  [166] = {.lex_state = 63},
  [167] = {.lex_state = 6, .external_lex_state = 2},
  [168] = {.lex_state = 6, .external_lex_state = 2},
  [169] = {.lex_state = 6, .external_lex_state = 2},
  [170] = {.lex_state = 63},
  [171] = {.lex_state = 63},
  [172] = {.lex_state = 63},
  [173] = {.lex_state = 63},
  [174] = {.lex_state = 63},
  [175] = {.lex_state = 63},
  [176] = {.lex_state = 63, .external_lex_state = 4},
  [177] = {.lex_state = 63},
  [178] = {.lex_state = 6, .external_lex_state = 2},
  [179] = {.lex_state = 6, .external_lex_state = 2},
  [180] = {.lex_state = 6, .external_lex_state = 2},
  [181] = {.lex_state = 63},
  [182] = {.lex_state = 6, .external_lex_state = 2},
  [183] = {.lex_state = 63},
  [184] = {.lex_state = 6, .external_lex_state = 2},
  [185] = {.lex_state = 63},
  [186] = {.lex_state = 63},
  [187] = {.lex_state = 63},
  [188] = {.lex_state = 63},
  [189] = {.lex_state = 63},
  [190] = {.lex_state = 63},
  [191] = {.lex_state = 63},
  [192] = {.lex_state = 63},
  [193] = {.lex_state = 63},
  [194] = {.lex_state = 63},
  [195] = {.lex_state = 63},
  [196] = {.lex_state = 63},
  [197] = {.lex_state = 63},
  [198] = {.lex_state = 63},
  [199] = {.lex_state = 63},
  [200] = {.lex_state = 63},
  [201] = {.lex_state = 63},
  [202] = {.lex_state = 63},
  [203] = {.lex_state = 63},
  [204] = {.lex_state = 63},
  [205] = {.lex_state = 63},
  [206] = {.lex_state = 63},
  [207] = {.lex_state = 63},
  [208] = {.lex_state = 63},
  [209] = {.lex_state = 63},
  [210] = {.lex_state = 63},
  [211] = {.lex_state = 63},
  [212] = {.lex_state = 63},
  [213] = {.lex_state = 63},
  [214] = {.lex_state = 63},
  [215] = {.lex_state = 63},
  [216] = {.lex_state = 63},
  [217] = {.lex_state = 63},
  [218] = {.lex_state = 63},
  [219] = {.lex_state = 63},
  [220] = {.lex_state = 63},
  [221] = {.lex_state = 63},
  [222] = {.lex_state = 63},
  [223] = {.lex_state = 63},
  [224] = {.lex_state = 63},
  [225] = {.lex_state = 63},
  [226] = {.lex_state = 63},
  [227] = {.lex_state = 63},
  [228] = {.lex_state = 63},
  [229] = {.lex_state = 63},
  [230] = {.lex_state = 63},
  [231] = {.lex_state = 63},
  [232] = {.lex_state = 63},
  [233] = {.lex_state = 63},
  [234] = {.lex_state = 63},
  [235] = {.lex_state = 63},
  [236] = {.lex_state = 63},
  [237] = {.lex_state = 63},
  [238] = {.lex_state = 63},
  [239] = {.lex_state = 63},
  [240] = {.lex_state = 63},
  [241] = {.lex_state = 63},
  [242] = {.lex_state = 63},
  [243] = {.lex_state = 63},
  [244] = {.lex_state = 63},
  [245] = {.lex_state = 63},
  [246] = {.lex_state = 63},
  [247] = {.lex_state = 63},
  [248] = {.lex_state = 63},
  [249] = {.lex_state = 63},
  [250] = {.lex_state = 63},
  [251] = {.lex_state = 63},
  [252] = {.lex_state = 63},
  [253] = {.lex_state = 63},
  [254] = {.lex_state = 63},
  [255] = {.lex_state = 63},
  [256] = {.lex_state = 63},
  [257] = {.lex_state = 63},
  [258] = {.lex_state = 63},
  [259] = {.lex_state = 63},
  [260] = {.lex_state = 63},
  [261] = {.lex_state = 63},
  [262] = {.lex_state = 63},
  [263] = {.lex_state = 63},
  [264] = {.lex_state = 63},
  [265] = {.lex_state = 63},
  [266] = {.lex_state = 63},
  [267] = {.lex_state = 63},
  [268] = {.lex_state = 63},
  [269] = {.lex_state = 63},
  [270] = {.lex_state = 63},
  [271] = {.lex_state = 63},
  [272] = {.lex_state = 63},
  [273] = {.lex_state = 63},
  [274] = {.lex_state = 63},
  [275] = {.lex_state = 63},
  [276] = {.lex_state = 63},
  [277] = {.lex_state = 63},
  [278] = {.lex_state = 63},
  [279] = {.lex_state = 63},
  [280] = {.lex_state = 63},
  [281] = {.lex_state = 63},
  [282] = {.lex_state = 63},
  [283] = {.lex_state = 63},
  [284] = {.lex_state = 63},
  [285] = {.lex_state = 63},
  [286] = {.lex_state = 63},
  [287] = {.lex_state = 63},
  [288] = {.lex_state = 63},
  [289] = {.lex_state = 63},
  [290] = {.lex_state = 63},
  [291] = {.lex_state = 63},
  [292] = {.lex_state = 63},
  [293] = {.lex_state = 63},
  [294] = {.lex_state = 63},
  [295] = {.lex_state = 63},
  [296] = {.lex_state = 63},
  [297] = {.lex_state = 63},
  [298] = {.lex_state = 63},
  [299] = {.lex_state = 63},
  [300] = {.lex_state = 63},
  [301] = {.lex_state = 63},
  [302] = {.lex_state = 63},
  [303] = {.lex_state = 63},
  [304] = {.lex_state = 63},
  [305] = {.lex_state = 63},
  [306] = {.lex_state = 63},
  [307] = {.lex_state = 63},
  [308] = {.lex_state = 63},
  [309] = {.lex_state = 63},
  [310] = {.lex_state = 63},
  [311] = {.lex_state = 63},
  [312] = {.lex_state = 63},
  [313] = {.lex_state = 63},
  [314] = {.lex_state = 63},
  [315] = {.lex_state = 63},
  [316] = {.lex_state = 63},
  [317] = {.lex_state = 63},
  [318] = {.lex_state = 63},
  [319] = {.lex_state = 63},
  [320] = {.lex_state = 63},
  [321] = {.lex_state = 63},
  [322] = {.lex_state = 63},
  [323] = {.lex_state = 63},
  [324] = {.lex_state = 63},
  [325] = {.lex_state = 63},
  [326] = {.lex_state = 63},
  [327] = {.lex_state = 63},
  [328] = {.lex_state = 63},
  [329] = {.lex_state = 63},
  [330] = {.lex_state = 63},
  [331] = {.lex_state = 63},
  [332] = {.lex_state = 63},
  [333] = {.lex_state = 63},
  [334] = {.lex_state = 63},
  [335] = {.lex_state = 63},
  [336] = {.lex_state = 63},
  [337] = {.lex_state = 63},
  [338] = {.lex_state = 63},
  [339] = {.lex_state = 63},
  [340] = {.lex_state = 63},
  [341] = {.lex_state = 63},
  [342] = {.lex_state = 63},
  [343] = {.lex_state = 63},
  [344] = {.lex_state = 63},
  [345] = {.lex_state = 63},
  [346] = {.lex_state = 63},
  [347] = {.lex_state = 63},
  [348] = {.lex_state = 63},
  [349] = {.lex_state = 63},
  [350] = {.lex_state = 63},
  [351] = {.lex_state = 63},
  [352] = {.lex_state = 6, .external_lex_state = 2},
  [353] = {.lex_state = 63},
  [354] = {.lex_state = 63},
  [355] = {.lex_state = 63},
  [356] = {.lex_state = 63},
  [357] = {.lex_state = 63},
  [358] = {.lex_state = 63},
  [359] = {.lex_state = 63},
  [360] = {.lex_state = 63},
  [361] = {.lex_state = 6, .external_lex_state = 2},
  [362] = {.lex_state = 63},
  [363] = {.lex_state = 63},
  [364] = {.lex_state = 63},
  [365] = {.lex_state = 63},
  [366] = {.lex_state = 63},
  [367] = {.lex_state = 63},
  [368] = {.lex_state = 63},
  [369] = {.lex_state = 63},
  [370] = {.lex_state = 63},
  [371] = {.lex_state = 63},
  [372] = {.lex_state = 63},
  [373] = {.lex_state = 63},
  [374] = {.lex_state = 63},
  [375] = {.lex_state = 63},
  [376] = {.lex_state = 63},
  [377] = {.lex_state = 63},
  [378] = {.lex_state = 63},
  [379] = {.lex_state = 63},
  [380] = {.lex_state = 63},
  [381] = {.lex_state = 63},
  [382] = {.lex_state = 63},
  [383] = {.lex_state = 63},
  [384] = {.lex_state = 63},
  [385] = {.lex_state = 63},
  [386] = {.lex_state = 63},
  [387] = {.lex_state = 63},
  [388] = {.lex_state = 63},
  [389] = {.lex_state = 63},
  [390] = {.lex_state = 63},
  [391] = {.lex_state = 63},
  [392] = {.lex_state = 63},
  [393] = {.lex_state = 63},
  [394] = {.lex_state = 63},
  [395] = {.lex_state = 63},
  [396] = {.lex_state = 63},
  [397] = {.lex_state = 63},
  [398] = {.lex_state = 63},
  [399] = {.lex_state = 63},
  [400] = {.lex_state = 63},
  [401] = {.lex_state = 63},
  [402] = {.lex_state = 63},
  [403] = {.lex_state = 63},
  [404] = {.lex_state = 63},
  [405] = {.lex_state = 63},
  [406] = {.lex_state = 63},
  [407] = {.lex_state = 63},
  [408] = {.lex_state = 63},
  [409] = {.lex_state = 63},
  [410] = {.lex_state = 63},
  [411] = {.lex_state = 63},
  [412] = {.lex_state = 63},
  [413] = {.lex_state = 63},
  [414] = {.lex_state = 63},
  [415] = {.lex_state = 63},
  [416] = {.lex_state = 63},
  [417] = {.lex_state = 63},
  [418] = {.lex_state = 63},
  [419] = {.lex_state = 63},
  [420] = {.lex_state = 63},
  [421] = {.lex_state = 63},
  [422] = {.lex_state = 63},
  [423] = {.lex_state = 63},
  [424] = {.lex_state = 63},
  [425] = {.lex_state = 63},
  [426] = {.lex_state = 63},
  [427] = {.lex_state = 63},
  [428] = {.lex_state = 63},
  [429] = {.lex_state = 63},
  [430] = {.lex_state = 63},
  [431] = {.lex_state = 63},
  [432] = {.lex_state = 63},
  [433] = {.lex_state = 63},
  [434] = {.lex_state = 63},
  [435] = {.lex_state = 63},
  [436] = {.lex_state = 63},
  [437] = {.lex_state = 63},
  [438] = {.lex_state = 63},
  [439] = {.lex_state = 63},
  [440] = {.lex_state = 63},
  [441] = {.lex_state = 63},
  [442] = {.lex_state = 63},
  [443] = {.lex_state = 63},
  [444] = {.lex_state = 63},
  [445] = {.lex_state = 63},
  [446] = {.lex_state = 63},
  [447] = {.lex_state = 63},
  [448] = {.lex_state = 63},
  [449] = {.lex_state = 63},
  [450] = {.lex_state = 63},
  [451] = {.lex_state = 63},
  [452] = {.lex_state = 63},
  [453] = {.lex_state = 63},
  [454] = {.lex_state = 63},
  [455] = {.lex_state = 63},
  [456] = {.lex_state = 63},
  [457] = {.lex_state = 63},
  [458] = {.lex_state = 63},
  [459] = {.lex_state = 63},
  [460] = {.lex_state = 63},
  [461] = {.lex_state = 63},
  [462] = {.lex_state = 63},
  [463] = {.lex_state = 63},
  [464] = {.lex_state = 63},
  [465] = {.lex_state = 63},
  [466] = {.lex_state = 63},
  [467] = {.lex_state = 63},
  [468] = {.lex_state = 63},
  [469] = {.lex_state = 63},
  [470] = {.lex_state = 63},
  [471] = {.lex_state = 63},
  [472] = {.lex_state = 63},
  [473] = {.lex_state = 63},
  [474] = {.lex_state = 63},
  [475] = {.lex_state = 63},
  [476] = {.lex_state = 63},
  [477] = {.lex_state = 63},
  [478] = {.lex_state = 63},
  [479] = {.lex_state = 63},
  [480] = {.lex_state = 63},
  [481] = {.lex_state = 63},
  [482] = {.lex_state = 63},
  [483] = {.lex_state = 63},
  [484] = {.lex_state = 63},
  [485] = {.lex_state = 63},
  [486] = {.lex_state = 63},
  [487] = {.lex_state = 63},
  [488] = {.lex_state = 63},
  [489] = {.lex_state = 63},
  [490] = {.lex_state = 63},
  [491] = {.lex_state = 63},
  [492] = {.lex_state = 63},
  [493] = {.lex_state = 63},
  [494] = {.lex_state = 63},
  [495] = {.lex_state = 63},
  [496] = {.lex_state = 63},
  [497] = {.lex_state = 63},
  [498] = {.lex_state = 6, .external_lex_state = 2},
  [499] = {.lex_state = 6, .external_lex_state = 2},
  [500] = {.lex_state = 63},
  [501] = {.lex_state = 63},
  [502] = {.lex_state = 6, .external_lex_state = 2},
  [503] = {.lex_state = 63},
  [504] = {.lex_state = 63},
  [505] = {.lex_state = 63},
  [506] = {.lex_state = 63},
  [507] = {.lex_state = 63},
  [508] = {.lex_state = 63},
  [509] = {.lex_state = 63},
  [510] = {.lex_state = 63},
  [511] = {.lex_state = 63},
  [512] = {.lex_state = 63},
  [513] = {.lex_state = 63},
  [514] = {.lex_state = 63},
  [515] = {.lex_state = 63},
  [516] = {.lex_state = 63},
  [517] = {.lex_state = 63},
  [518] = {.lex_state = 63},
  [519] = {.lex_state = 63},
  [520] = {.lex_state = 63},
  [521] = {.lex_state = 63},
  [522] = {.lex_state = 63},
  [523] = {.lex_state = 63},
  [524] = {.lex_state = 63},
  [525] = {.lex_state = 63},
  [526] = {.lex_state = 63},
  [527] = {.lex_state = 63},
  [528] = {.lex_state = 63},
  [529] = {.lex_state = 63},
  [530] = {.lex_state = 63},
  [531] = {.lex_state = 6, .external_lex_state = 2},
  [532] = {.lex_state = 62, .external_lex_state = 3},
  [533] = {.lex_state = 6, .external_lex_state = 2},
  [534] = {.lex_state = 6, .external_lex_state = 2},
  [535] = {.lex_state = 6, .external_lex_state = 2},
  [536] = {.lex_state = 6, .external_lex_state = 2},
  [537] = {.lex_state = 62, .external_lex_state = 3},
  [538] = {.lex_state = 6, .external_lex_state = 2},
  [539] = {.lex_state = 62, .external_lex_state = 3},
  [540] = {.lex_state = 6, .external_lex_state = 2},
  [541] = {.lex_state = 6, .external_lex_state = 2},
  [542] = {.lex_state = 6, .external_lex_state = 2},
  [543] = {.lex_state = 63},
  [544] = {.lex_state = 62, .external_lex_state = 2},
  [545] = {.lex_state = 6, .external_lex_state = 2},
  [546] = {.lex_state = 63, .external_lex_state = 4},
  [547] = {.lex_state = 62, .external_lex_state = 2},
  [548] = {.lex_state = 63, .external_lex_state = 4},
  [549] = {.lex_state = 63},
  [550] = {.lex_state = 62, .external_lex_state = 2},
  [551] = {.lex_state = 6, .external_lex_state = 3},
  [552] = {.lex_state = 63},
  [553] = {.lex_state = 6, .external_lex_state = 3},
  [554] = {.lex_state = 63},
  [555] = {.lex_state = 63},
  [556] = {.lex_state = 63, .external_lex_state = 4},
  [557] = {.lex_state = 15},
  [558] = {.lex_state = 63, .external_lex_state = 4},
  [559] = {.lex_state = 63},
  [560] = {.lex_state = 15},
  [561] = {.lex_state = 63, .external_lex_state = 4},
  [562] = {.lex_state = 6, .external_lex_state = 3},
  [563] = {.lex_state = 6, .external_lex_state = 2},
  [564] = {.lex_state = 15},
  [565] = {.lex_state = 63},
  [566] = {.lex_state = 15},
  [567] = {.lex_state = 63, .external_lex_state = 4},
  [568] = {.lex_state = 7, .external_lex_state = 3},
  [569] = {.lex_state = 6, .external_lex_state = 2},
  [570] = {.lex_state = 63, .external_lex_state = 4},
  [571] = {.lex_state = 6, .external_lex_state = 2},
  [572] = {.lex_state = 15},
  [573] = {.lex_state = 63, .external_lex_state = 4},
  [574] = {.lex_state = 6, .external_lex_state = 2},
  [575] = {.lex_state = 8, .external_lex_state = 3},
  [576] = {.lex_state = 6, .external_lex_state = 2},
  [577] = {.lex_state = 63},
  [578] = {.lex_state = 63},
  [579] = {.lex_state = 63},
  [580] = {.lex_state = 8, .external_lex_state = 3},
  [581] = {.lex_state = 63},
  [582] = {.lex_state = 63},
  [583] = {.lex_state = 6, .external_lex_state = 2},
  [584] = {.lex_state = 63},
  [585] = {.lex_state = 6, .external_lex_state = 2},
  [586] = {.lex_state = 63},
  [587] = {.lex_state = 6, .external_lex_state = 3},
  [588] = {.lex_state = 8, .external_lex_state = 3},
  [589] = {.lex_state = 63},
  [590] = {.lex_state = 6, .external_lex_state = 2},
  [591] = {.lex_state = 63, .external_lex_state = 4},
  [592] = {.lex_state = 6, .external_lex_state = 3},
  [593] = {.lex_state = 6, .external_lex_state = 3},
  [594] = {.lex_state = 63},
  [595] = {.lex_state = 6, .external_lex_state = 3},
  [596] = {.lex_state = 63},
  [597] = {.lex_state = 63},
  [598] = {.lex_state = 63},
  [599] = {.lex_state = 63},
  [600] = {.lex_state = 6, .external_lex_state = 3},
  [601] = {.lex_state = 63, .external_lex_state = 4},
  [602] = {.lex_state = 7, .external_lex_state = 3},
  [603] = {.lex_state = 63, .external_lex_state = 4},
  [604] = {.lex_state = 6, .external_lex_state = 3},
  [605] = {.lex_state = 6, .external_lex_state = 3},
  [606] = {.lex_state = 63, .external_lex_state = 4},
  [607] = {.lex_state = 63, .external_lex_state = 4},
  [608] = {.lex_state = 63},
  [609] = {.lex_state = 63},
  [610] = {.lex_state = 63, .external_lex_state = 4},
  [611] = {.lex_state = 6, .external_lex_state = 3},
  [612] = {.lex_state = 63, .external_lex_state = 4},
  [613] = {.lex_state = 63, .external_lex_state = 4},
  [614] = {.lex_state = 63, .external_lex_state = 4},
  [615] = {.lex_state = 63, .external_lex_state = 4},
  [616] = {.lex_state = 63, .external_lex_state = 4},
  [617] = {.lex_state = 6, .external_lex_state = 3},
  [618] = {.lex_state = 6, .external_lex_state = 3},
  [619] = {.lex_state = 63, .external_lex_state = 4},
  [620] = {.lex_state = 63},
  [621] = {.lex_state = 63},
  [622] = {.lex_state = 63},
  [623] = {.lex_state = 63},
  [624] = {.lex_state = 63},
  [625] = {.lex_state = 63},
  [626] = {.lex_state = 63},
  [627] = {.lex_state = 63},
  [628] = {.lex_state = 63},
  [629] = {.lex_state = 63},
  [630] = {.lex_state = 63},
  [631] = {.lex_state = 63},
  [632] = {.lex_state = 63},
  [633] = {.lex_state = 63},
  [634] = {.lex_state = 63},
  [635] = {.lex_state = 63},
  [636] = {.lex_state = 63},
  [637] = {.lex_state = 63},
  [638] = {.lex_state = 63},
  [639] = {.lex_state = 63},
  [640] = {.lex_state = 63},
  [641] = {.lex_state = 63},
  [642] = {.lex_state = 63},
  [643] = {.lex_state = 63},
  [644] = {.lex_state = 63},
  [645] = {.lex_state = 63},
  [646] = {.lex_state = 63},
  [647] = {.lex_state = 6, .external_lex_state = 3},
  [648] = {.lex_state = 63},
  [649] = {.lex_state = 63},
  [650] = {.lex_state = 63},
  [651] = {.lex_state = 63},
  [652] = {.lex_state = 63},
  [653] = {.lex_state = 6, .external_lex_state = 2},
  [654] = {.lex_state = 63},
  [655] = {.lex_state = 63},
  [656] = {.lex_state = 63},
  [657] = {.lex_state = 63},
  [658] = {.lex_state = 63},
  [659] = {.lex_state = 63},
  [660] = {.lex_state = 63},
  [661] = {.lex_state = 63},
  [662] = {.lex_state = 63},
  [663] = {.lex_state = 63},
  [664] = {.lex_state = 63},
  [665] = {.lex_state = 63},
  [666] = {.lex_state = 63},
  [667] = {.lex_state = 63},
  [668] = {.lex_state = 63},
  [669] = {.lex_state = 63},
  [670] = {.lex_state = 63},
  [671] = {.lex_state = 63},
  [672] = {.lex_state = 63},
  [673] = {.lex_state = 63},
  [674] = {.lex_state = 63},
  [675] = {.lex_state = 63},
  [676] = {.lex_state = 63},
  [677] = {.lex_state = 63},
  [678] = {.lex_state = 63},
  [679] = {.lex_state = 63},
  [680] = {.lex_state = 63},
  [681] = {.lex_state = 63},
  [682] = {.lex_state = 63},
  [683] = {.lex_state = 63},
  [684] = {.lex_state = 63},
  [685] = {.lex_state = 63},
  [686] = {.lex_state = 63},
  [687] = {.lex_state = 63},
  [688] = {.lex_state = 63},
  [689] = {.lex_state = 63},
  [690] = {.lex_state = 63},
  [691] = {.lex_state = 63},
  [692] = {.lex_state = 63},
  [693] = {.lex_state = 63},
  [694] = {.lex_state = 63},
  [695] = {.lex_state = 63},
  [696] = {.lex_state = 63},
  [697] = {.lex_state = 63},
  [698] = {.lex_state = 6, .external_lex_state = 3},
  [699] = {.lex_state = 6, .external_lex_state = 3},
  [700] = {.lex_state = 6, .external_lex_state = 3},
  [701] = {.lex_state = 6, .external_lex_state = 3},
  [702] = {.lex_state = 6, .external_lex_state = 3},
  [703] = {.lex_state = 6, .external_lex_state = 3},
  [704] = {.lex_state = 63},
  [705] = {.lex_state = 63},
  [706] = {.lex_state = 63},
  [707] = {.lex_state = 63},
  [708] = {.lex_state = 63},
  [709] = {.lex_state = 63},
  [710] = {.lex_state = 63},
  [711] = {.lex_state = 63},
  [712] = {.lex_state = 63},
  [713] = {.lex_state = 63},
  [714] = {.lex_state = 6, .external_lex_state = 3},
  [715] = {.lex_state = 6, .external_lex_state = 2},
  [716] = {.lex_state = 6, .external_lex_state = 2},
  [717] = {.lex_state = 6, .external_lex_state = 2},
  [718] = {.lex_state = 6, .external_lex_state = 2},
  [719] = {.lex_state = 6, .external_lex_state = 2},
  [720] = {.lex_state = 6, .external_lex_state = 2},
  [721] = {.lex_state = 6, .external_lex_state = 2},
  [722] = {.lex_state = 6, .external_lex_state = 3},
  [723] = {.lex_state = 7, .external_lex_state = 3},
  [724] = {.lex_state = 6, .external_lex_state = 3},
  [725] = {.lex_state = 6, .external_lex_state = 2},
  [726] = {.lex_state = 6, .external_lex_state = 2},
  [727] = {.lex_state = 6, .external_lex_state = 2},
  [728] = {.lex_state = 6, .external_lex_state = 2},
  [729] = {.lex_state = 6, .external_lex_state = 2},
  [730] = {.lex_state = 6, .external_lex_state = 2},
  [731] = {.lex_state = 6, .external_lex_state = 2},
  [732] = {.lex_state = 6, .external_lex_state = 3},
  [733] = {.lex_state = 6, .external_lex_state = 3},
  [734] = {.lex_state = 63},
  [735] = {.lex_state = 6, .external_lex_state = 3},
  [736] = {.lex_state = 63},
  [737] = {.lex_state = 6, .external_lex_state = 3},
  [738] = {.lex_state = 63},
  [739] = {.lex_state = 63},
  [740] = {.lex_state = 6, .external_lex_state = 3},
  [741] = {.lex_state = 6, .external_lex_state = 3},
  [742] = {.lex_state = 63},
  [743] = {.lex_state = 63},
  [744] = {.lex_state = 63},
  [745] = {.lex_state = 6, .external_lex_state = 3},
  [746] = {.lex_state = 7, .external_lex_state = 3},
  [747] = {.lex_state = 6, .external_lex_state = 3},
  [748] = {.lex_state = 6, .external_lex_state = 3},
  [749] = {.lex_state = 6, .external_lex_state = 3},
  [750] = {.lex_state = 6, .external_lex_state = 2},
  [751] = {.lex_state = 6, .external_lex_state = 3},
  [752] = {.lex_state = 6, .external_lex_state = 3},
  [753] = {.lex_state = 6, .external_lex_state = 3},
  [754] = {.lex_state = 6, .external_lex_state = 2},
  [755] = {.lex_state = 6, .external_lex_state = 2},
  [756] = {.lex_state = 6, .external_lex_state = 3},
  [757] = {.lex_state = 6, .external_lex_state = 2},
  [758] = {.lex_state = 6, .external_lex_state = 3},
  [759] = {.lex_state = 6, .external_lex_state = 3},
  [760] = {.lex_state = 6, .external_lex_state = 2},
  [761] = {.lex_state = 6, .external_lex_state = 3},
  [762] = {.lex_state = 6, .external_lex_state = 3},
  [763] = {.lex_state = 6, .external_lex_state = 3},
  [764] = {.lex_state = 6, .external_lex_state = 2},
  [765] = {.lex_state = 6, .external_lex_state = 2},
  [766] = {.lex_state = 6, .external_lex_state = 3},
  [767] = {.lex_state = 6, .external_lex_state = 2},
  [768] = {.lex_state = 63},
  [769] = {.lex_state = 6, .external_lex_state = 2},
  [770] = {.lex_state = 6, .external_lex_state = 2},
  [771] = {.lex_state = 6, .external_lex_state = 2},
  [772] = {.lex_state = 15},
  [773] = {.lex_state = 6, .external_lex_state = 2},
  [774] = {.lex_state = 6, .external_lex_state = 3},
  [775] = {.lex_state = 6, .external_lex_state = 3},
  [776] = {.lex_state = 6, .external_lex_state = 3},
  [777] = {.lex_state = 6, .external_lex_state = 3},
  [778] = {.lex_state = 6, .external_lex_state = 2},
  [779] = {.lex_state = 15},
  [780] = {.lex_state = 6, .external_lex_state = 2},
  [781] = {.lex_state = 6, .external_lex_state = 2},
  [782] = {.lex_state = 63},
  [783] = {.lex_state = 15},
  [784] = {.lex_state = 6, .external_lex_state = 3},
  [785] = {.lex_state = 15},
  [786] = {.lex_state = 7, .external_lex_state = 3},
  [787] = {.lex_state = 15},
  [788] = {.lex_state = 6, .external_lex_state = 3},
  [789] = {.lex_state = 6, .external_lex_state = 2},
  [790] = {.lex_state = 6, .external_lex_state = 2},
  [791] = {.lex_state = 15},
  [792] = {.lex_state = 15},
  [793] = {.lex_state = 15},
  [794] = {.lex_state = 6, .external_lex_state = 3},
  [795] = {.lex_state = 6, .external_lex_state = 3},
  [796] = {.lex_state = 7, .external_lex_state = 3},
  [797] = {.lex_state = 15},
  [798] = {.lex_state = 15},
  [799] = {.lex_state = 7, .external_lex_state = 3},
  [800] = {.lex_state = 15},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 6, .external_lex_state = 3},
  [803] = {.lex_state = 7, .external_lex_state = 3},
  [804] = {.lex_state = 15},
  [805] = {.lex_state = 6, .external_lex_state = 3},
  [806] = {.lex_state = 15},
  [807] = {.lex_state = 15},
  [808] = {.lex_state = 15},
  [809] = {.lex_state = 6, .external_lex_state = 2},
  [810] = {.lex_state = 6, .external_lex_state = 3},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 15},
  [813] = {.lex_state = 15},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 15},
  [817] = {.lex_state = 6, .external_lex_state = 3},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 15},
  [820] = {.lex_state = 15},
  [821] = {.lex_state = 6, .external_lex_state = 2},
  [822] = {.lex_state = 15},
  [823] = {.lex_state = 15},
  [824] = {.lex_state = 6, .external_lex_state = 2},
  [825] = {.lex_state = 6, .external_lex_state = 3},
  [826] = {.lex_state = 6, .external_lex_state = 2},
  [827] = {.lex_state = 6, .external_lex_state = 3},
  [828] = {.lex_state = 15},
  [829] = {.lex_state = 15},
  [830] = {.lex_state = 15},
  [831] = {.lex_state = 15},
  [832] = {.lex_state = 15},
  [833] = {.lex_state = 6, .external_lex_state = 2},
  [834] = {.lex_state = 15},
  [835] = {.lex_state = 6, .external_lex_state = 2},
  [836] = {.lex_state = 15},
  [837] = {.lex_state = 6, .external_lex_state = 2},
  [838] = {.lex_state = 15},
  [839] = {.lex_state = 15},
  [840] = {.lex_state = 6, .external_lex_state = 2},
  [841] = {.lex_state = 15},
  [842] = {.lex_state = 15},
  [843] = {.lex_state = 15},
  [844] = {.lex_state = 6, .external_lex_state = 2},
  [845] = {.lex_state = 15},
  [846] = {.lex_state = 15},
  [847] = {.lex_state = 6, .external_lex_state = 2},
  [848] = {.lex_state = 6, .external_lex_state = 2},
  [849] = {.lex_state = 6, .external_lex_state = 2},
  [850] = {.lex_state = 15},
  [851] = {.lex_state = 15},
  [852] = {.lex_state = 15},
  [853] = {.lex_state = 6, .external_lex_state = 2},
  [854] = {.lex_state = 15},
  [855] = {.lex_state = 15},
  [856] = {.lex_state = 15},
  [857] = {.lex_state = 15},
  [858] = {.lex_state = 15},
  [859] = {.lex_state = 15},
  [860] = {.lex_state = 15},
  [861] = {.lex_state = 15},
  [862] = {.lex_state = 15},
  [863] = {.lex_state = 6, .external_lex_state = 2},
  [864] = {.lex_state = 15},
  [865] = {.lex_state = 15},
  [866] = {.lex_state = 15},
  [867] = {.lex_state = 15},
  [868] = {.lex_state = 6, .external_lex_state = 3},
  [869] = {.lex_state = 6, .external_lex_state = 3},
  [870] = {.lex_state = 6, .external_lex_state = 2},
  [871] = {.lex_state = 6, .external_lex_state = 3},
  [872] = {.lex_state = 7, .external_lex_state = 3},
  [873] = {.lex_state = 15},
  [874] = {.lex_state = 6, .external_lex_state = 2},
  [875] = {.lex_state = 6, .external_lex_state = 2},
  [876] = {.lex_state = 6, .external_lex_state = 2},
  [877] = {.lex_state = 15},
  [878] = {.lex_state = 6, .external_lex_state = 3},
  [879] = {.lex_state = 15},
  [880] = {.lex_state = 15},
  [881] = {.lex_state = 15},
  [882] = {.lex_state = 15},
  [883] = {.lex_state = 7, .external_lex_state = 3},
  [884] = {.lex_state = 15},
  [885] = {.lex_state = 15},
  [886] = {.lex_state = 15},
  [887] = {.lex_state = 15},
  [888] = {.lex_state = 15},
  [889] = {.lex_state = 6, .external_lex_state = 2},
  [890] = {.lex_state = 6, .external_lex_state = 2},
  [891] = {.lex_state = 15},
  [892] = {.lex_state = 15},
  [893] = {.lex_state = 15},
  [894] = {.lex_state = 15},
  [895] = {.lex_state = 6, .external_lex_state = 2},
  [896] = {.lex_state = 15},
  [897] = {.lex_state = 6, .external_lex_state = 2},
  [898] = {.lex_state = 15},
  [899] = {.lex_state = 6, .external_lex_state = 3},
  [900] = {.lex_state = 15},
  [901] = {.lex_state = 15},
  [902] = {.lex_state = 15},
  [903] = {.lex_state = 6, .external_lex_state = 3},
  [904] = {.lex_state = 15},
  [905] = {.lex_state = 15},
  [906] = {.lex_state = 15},
  [907] = {.lex_state = 6, .external_lex_state = 2},
  [908] = {.lex_state = 15},
  [909] = {.lex_state = 15},
  [910] = {.lex_state = 15},
  [911] = {.lex_state = 15},
  [912] = {.lex_state = 6, .external_lex_state = 2},
  [913] = {.lex_state = 15},
  [914] = {.lex_state = 15},
  [915] = {.lex_state = 15},
  [916] = {.lex_state = 15},
  [917] = {.lex_state = 15},
  [918] = {.lex_state = 15},
  [919] = {.lex_state = 15},
  [920] = {.lex_state = 15},
  [921] = {.lex_state = 15},
  [922] = {.lex_state = 15},
  [923] = {.lex_state = 15},
  [924] = {.lex_state = 15},
  [925] = {.lex_state = 6, .external_lex_state = 3},
  [926] = {.lex_state = 15},
  [927] = {.lex_state = 15},
  [928] = {.lex_state = 15},
  [929] = {.lex_state = 15},
  [930] = {.lex_state = 15},
  [931] = {.lex_state = 15},
  [932] = {.lex_state = 15},
  [933] = {.lex_state = 15},
  [934] = {.lex_state = 15},
  [935] = {.lex_state = 6, .external_lex_state = 2},
  [936] = {.lex_state = 15},
  [937] = {.lex_state = 15},
  [938] = {.lex_state = 6, .external_lex_state = 3},
  [939] = {.lex_state = 15},
  [940] = {.lex_state = 15},
  [941] = {.lex_state = 15},
  [942] = {.lex_state = 15},
  [943] = {.lex_state = 6, .external_lex_state = 3},
  [944] = {.lex_state = 6, .external_lex_state = 3},
  [945] = {.lex_state = 6, .external_lex_state = 2},
  [946] = {.lex_state = 6, .external_lex_state = 2},
  [947] = {.lex_state = 6, .external_lex_state = 2},
  [948] = {.lex_state = 6, .external_lex_state = 3},
  [949] = {.lex_state = 6, .external_lex_state = 3},
  [950] = {.lex_state = 6, .external_lex_state = 2},
  [951] = {.lex_state = 6, .external_lex_state = 3},
  [952] = {.lex_state = 6, .external_lex_state = 3},
  [953] = {.lex_state = 6, .external_lex_state = 3},
  [954] = {.lex_state = 7, .external_lex_state = 3},
  [955] = {.lex_state = 6, .external_lex_state = 3},
  [956] = {.lex_state = 6, .external_lex_state = 3},
  [957] = {.lex_state = 6, .external_lex_state = 3},
  [958] = {.lex_state = 6, .external_lex_state = 3},
  [959] = {.lex_state = 6, .external_lex_state = 3},
  [960] = {.lex_state = 6, .external_lex_state = 2},
  [961] = {.lex_state = 6, .external_lex_state = 3},
  [962] = {.lex_state = 6, .external_lex_state = 3},
  [963] = {.lex_state = 6, .external_lex_state = 3},
  [964] = {.lex_state = 7, .external_lex_state = 3},
  [965] = {.lex_state = 6, .external_lex_state = 2},
  [966] = {.lex_state = 7, .external_lex_state = 3},
  [967] = {.lex_state = 6, .external_lex_state = 3},
  [968] = {.lex_state = 6, .external_lex_state = 3},
  [969] = {.lex_state = 6, .external_lex_state = 3},
  [970] = {.lex_state = 7, .external_lex_state = 3},
  [971] = {.lex_state = 6, .external_lex_state = 3},
  [972] = {.lex_state = 6, .external_lex_state = 3},
  [973] = {.lex_state = 6, .external_lex_state = 3},
  [974] = {.lex_state = 6, .external_lex_state = 2},
  [975] = {.lex_state = 7, .external_lex_state = 3},
  [976] = {.lex_state = 6, .external_lex_state = 3},
  [977] = {.lex_state = 6, .external_lex_state = 2},
  [978] = {.lex_state = 6, .external_lex_state = 3},
  [979] = {.lex_state = 7, .external_lex_state = 3},
  [980] = {.lex_state = 7, .external_lex_state = 3},
  [981] = {.lex_state = 7, .external_lex_state = 3},
  [982] = {.lex_state = 6, .external_lex_state = 2},
  [983] = {.lex_state = 6, .external_lex_state = 3},
  [984] = {.lex_state = 6, .external_lex_state = 3},
  [985] = {.lex_state = 7, .external_lex_state = 3},
  [986] = {.lex_state = 6, .external_lex_state = 3},
  [987] = {.lex_state = 7, .external_lex_state = 3},
  [988] = {.lex_state = 6, .external_lex_state = 3},
  [989] = {.lex_state = 7, .external_lex_state = 3},
  [990] = {.lex_state = 7, .external_lex_state = 3},
  [991] = {.lex_state = 6, .external_lex_state = 3},
  [992] = {.lex_state = 6, .external_lex_state = 3},
  [993] = {.lex_state = 7, .external_lex_state = 3},
  [994] = {.lex_state = 6, .external_lex_state = 2},
  [995] = {.lex_state = 6, .external_lex_state = 3},
  [996] = {.lex_state = 6, .external_lex_state = 3},
  [997] = {.lex_state = 6, .external_lex_state = 3},
  [998] = {.lex_state = 6, .external_lex_state = 3},
  [999] = {.lex_state = 6, .external_lex_state = 3},
  [1000] = {.lex_state = 7, .external_lex_state = 3},
  [1001] = {.lex_state = 6, .external_lex_state = 2},
  [1002] = {.lex_state = 6, .external_lex_state = 3},
  [1003] = {.lex_state = 6, .external_lex_state = 3},
  [1004] = {.lex_state = 6, .external_lex_state = 3},
  [1005] = {.lex_state = 6, .external_lex_state = 3},
  [1006] = {.lex_state = 6, .external_lex_state = 3},
  [1007] = {.lex_state = 6, .external_lex_state = 3},
  [1008] = {.lex_state = 6, .external_lex_state = 2},
  [1009] = {.lex_state = 6, .external_lex_state = 3},
  [1010] = {.lex_state = 6, .external_lex_state = 3},
  [1011] = {.lex_state = 6, .external_lex_state = 3},
  [1012] = {.lex_state = 6, .external_lex_state = 3},
  [1013] = {.lex_state = 6, .external_lex_state = 3},
  [1014] = {.lex_state = 6, .external_lex_state = 3},
  [1015] = {.lex_state = 6, .external_lex_state = 3},
  [1016] = {.lex_state = 63},
  [1017] = {.lex_state = 63},
  [1018] = {.lex_state = 63, .external_lex_state = 4},
  [1019] = {.lex_state = 63, .external_lex_state = 4},
  [1020] = {.lex_state = 6, .external_lex_state = 3},
  [1021] = {.lex_state = 63, .external_lex_state = 4},
  [1022] = {.lex_state = 62, .external_lex_state = 2},
  [1023] = {.lex_state = 63},
  [1024] = {.lex_state = 63},
  [1025] = {.lex_state = 6, .external_lex_state = 3},
  [1026] = {.lex_state = 63, .external_lex_state = 4},
  [1027] = {.lex_state = 63},
  [1028] = {.lex_state = 6, .external_lex_state = 3},
  [1029] = {.lex_state = 63, .external_lex_state = 4},
  [1030] = {.lex_state = 63, .external_lex_state = 4},
  [1031] = {.lex_state = 63},
  [1032] = {.lex_state = 63},
  [1033] = {.lex_state = 63},
  [1034] = {.lex_state = 63},
  [1035] = {.lex_state = 63},
  [1036] = {.lex_state = 63},
  [1037] = {.lex_state = 63},
  [1038] = {.lex_state = 63},
  [1039] = {.lex_state = 63},
  [1040] = {.lex_state = 63},
  [1041] = {.lex_state = 63},
  [1042] = {.lex_state = 63},
  [1043] = {.lex_state = 63},
  [1044] = {.lex_state = 63},
  [1045] = {.lex_state = 63},
  [1046] = {.lex_state = 62, .external_lex_state = 3},
  [1047] = {.lex_state = 63},
  [1048] = {.lex_state = 62, .external_lex_state = 3},
  [1049] = {.lex_state = 63},
  [1050] = {.lex_state = 63},
  [1051] = {.lex_state = 62, .external_lex_state = 3},
  [1052] = {.lex_state = 63},
  [1053] = {.lex_state = 62, .external_lex_state = 3},
  [1054] = {.lex_state = 62, .external_lex_state = 3},
  [1055] = {.lex_state = 63},
  [1056] = {.lex_state = 62, .external_lex_state = 3},
  [1057] = {.lex_state = 63},
  [1058] = {.lex_state = 62, .external_lex_state = 3},
  [1059] = {.lex_state = 62, .external_lex_state = 3},
  [1060] = {.lex_state = 62, .external_lex_state = 3},
  [1061] = {.lex_state = 62, .external_lex_state = 3},
  [1062] = {.lex_state = 62, .external_lex_state = 3},
  [1063] = {.lex_state = 62, .external_lex_state = 3},
  [1064] = {.lex_state = 62, .external_lex_state = 3},
  [1065] = {.lex_state = 62, .external_lex_state = 3},
  [1066] = {.lex_state = 62, .external_lex_state = 3},
  [1067] = {.lex_state = 62, .external_lex_state = 3},
  [1068] = {.lex_state = 62, .external_lex_state = 2},
  [1069] = {.lex_state = 62, .external_lex_state = 2},
  [1070] = {.lex_state = 62, .external_lex_state = 2},
  [1071] = {.lex_state = 62, .external_lex_state = 3},
  [1072] = {.lex_state = 62, .external_lex_state = 3},
  [1073] = {.lex_state = 62, .external_lex_state = 3},
  [1074] = {.lex_state = 62, .external_lex_state = 2},
  [1075] = {.lex_state = 62, .external_lex_state = 3},
  [1076] = {.lex_state = 62, .external_lex_state = 3},
  [1077] = {.lex_state = 62, .external_lex_state = 2},
  [1078] = {.lex_state = 62, .external_lex_state = 3},
  [1079] = {.lex_state = 62, .external_lex_state = 3},
  [1080] = {.lex_state = 62, .external_lex_state = 2},
  [1081] = {.lex_state = 62, .external_lex_state = 2},
  [1082] = {.lex_state = 62, .external_lex_state = 2},
  [1083] = {.lex_state = 62, .external_lex_state = 2},
  [1084] = {.lex_state = 62, .external_lex_state = 3},
  [1085] = {.lex_state = 62, .external_lex_state = 3},
  [1086] = {.lex_state = 62, .external_lex_state = 3},
  [1087] = {.lex_state = 62, .external_lex_state = 3},
  [1088] = {.lex_state = 62, .external_lex_state = 3},
  [1089] = {.lex_state = 62, .external_lex_state = 3},
  [1090] = {.lex_state = 62, .external_lex_state = 3},
  [1091] = {.lex_state = 62, .external_lex_state = 3},
  [1092] = {.lex_state = 62, .external_lex_state = 2},
  [1093] = {.lex_state = 62, .external_lex_state = 3},
  [1094] = {.lex_state = 62, .external_lex_state = 3},
  [1095] = {.lex_state = 62, .external_lex_state = 3},
  [1096] = {.lex_state = 62, .external_lex_state = 3},
  [1097] = {.lex_state = 62, .external_lex_state = 3},
  [1098] = {.lex_state = 62, .external_lex_state = 3},
  [1099] = {.lex_state = 62, .external_lex_state = 3},
  [1100] = {.lex_state = 62, .external_lex_state = 3},
  [1101] = {.lex_state = 62, .external_lex_state = 3},
  [1102] = {.lex_state = 62, .external_lex_state = 3},
  [1103] = {.lex_state = 62, .external_lex_state = 3},
  [1104] = {.lex_state = 62, .external_lex_state = 3},
  [1105] = {.lex_state = 62, .external_lex_state = 3},
  [1106] = {.lex_state = 62, .external_lex_state = 3},
  [1107] = {.lex_state = 62, .external_lex_state = 3},
  [1108] = {.lex_state = 62, .external_lex_state = 3},
  [1109] = {.lex_state = 62, .external_lex_state = 3},
  [1110] = {.lex_state = 62, .external_lex_state = 2},
  [1111] = {.lex_state = 62, .external_lex_state = 2},
  [1112] = {.lex_state = 62, .external_lex_state = 3},
  [1113] = {.lex_state = 62, .external_lex_state = 3},
  [1114] = {.lex_state = 62, .external_lex_state = 2},
  [1115] = {.lex_state = 62, .external_lex_state = 2},
  [1116] = {.lex_state = 62, .external_lex_state = 3},
  [1117] = {.lex_state = 62, .external_lex_state = 3},
  [1118] = {.lex_state = 62, .external_lex_state = 3},
  [1119] = {.lex_state = 62, .external_lex_state = 2},
  [1120] = {.lex_state = 62, .external_lex_state = 2},
  [1121] = {.lex_state = 62, .external_lex_state = 2},
  [1122] = {.lex_state = 62, .external_lex_state = 3},
  [1123] = {.lex_state = 62, .external_lex_state = 2},
  [1124] = {.lex_state = 62, .external_lex_state = 3},
  [1125] = {.lex_state = 62, .external_lex_state = 2},
  [1126] = {.lex_state = 62, .external_lex_state = 3},
  [1127] = {.lex_state = 62, .external_lex_state = 2},
  [1128] = {.lex_state = 62, .external_lex_state = 3},
  [1129] = {.lex_state = 15},
  [1130] = {.lex_state = 62, .external_lex_state = 3},
  [1131] = {.lex_state = 62, .external_lex_state = 3},
  [1132] = {.lex_state = 62, .external_lex_state = 2},
  [1133] = {.lex_state = 62, .external_lex_state = 3},
  [1134] = {.lex_state = 62, .external_lex_state = 2},
  [1135] = {.lex_state = 62, .external_lex_state = 3},
  [1136] = {.lex_state = 62, .external_lex_state = 3},
  [1137] = {.lex_state = 62, .external_lex_state = 3},
  [1138] = {.lex_state = 62, .external_lex_state = 3},
  [1139] = {.lex_state = 62, .external_lex_state = 3},
  [1140] = {.lex_state = 62, .external_lex_state = 3},
  [1141] = {.lex_state = 15},
  [1142] = {.lex_state = 62, .external_lex_state = 2},
  [1143] = {.lex_state = 62, .external_lex_state = 3},
  [1144] = {.lex_state = 62, .external_lex_state = 2},
  [1145] = {.lex_state = 62, .external_lex_state = 3},
  [1146] = {.lex_state = 62, .external_lex_state = 2},
  [1147] = {.lex_state = 62, .external_lex_state = 3},
  [1148] = {.lex_state = 62, .external_lex_state = 3},
  [1149] = {.lex_state = 62, .external_lex_state = 3},
  [1150] = {.lex_state = 62, .external_lex_state = 3},
  [1151] = {.lex_state = 62, .external_lex_state = 3},
  [1152] = {.lex_state = 62, .external_lex_state = 3},
  [1153] = {.lex_state = 62, .external_lex_state = 3},
  [1154] = {.lex_state = 62, .external_lex_state = 3},
  [1155] = {.lex_state = 62, .external_lex_state = 2},
  [1156] = {.lex_state = 62, .external_lex_state = 3},
  [1157] = {.lex_state = 62, .external_lex_state = 3},
  [1158] = {.lex_state = 62, .external_lex_state = 3},
  [1159] = {.lex_state = 62, .external_lex_state = 2},
  [1160] = {.lex_state = 8, .external_lex_state = 3},
  [1161] = {.lex_state = 62, .external_lex_state = 3},
  [1162] = {.lex_state = 62, .external_lex_state = 2},
  [1163] = {.lex_state = 62, .external_lex_state = 3},
  [1164] = {.lex_state = 62, .external_lex_state = 3},
  [1165] = {.lex_state = 62, .external_lex_state = 2},
  [1166] = {.lex_state = 62, .external_lex_state = 3},
  [1167] = {.lex_state = 62, .external_lex_state = 2},
  [1168] = {.lex_state = 62, .external_lex_state = 3},
  [1169] = {.lex_state = 62, .external_lex_state = 2},
  [1170] = {.lex_state = 62, .external_lex_state = 2},
  [1171] = {.lex_state = 62, .external_lex_state = 2},
  [1172] = {.lex_state = 62, .external_lex_state = 3},
  [1173] = {.lex_state = 62, .external_lex_state = 3},
  [1174] = {.lex_state = 62, .external_lex_state = 2},
  [1175] = {.lex_state = 62, .external_lex_state = 3},
  [1176] = {.lex_state = 62, .external_lex_state = 3},
  [1177] = {.lex_state = 62, .external_lex_state = 3},
  [1178] = {.lex_state = 62, .external_lex_state = 2},
  [1179] = {.lex_state = 62, .external_lex_state = 3},
  [1180] = {.lex_state = 62, .external_lex_state = 3},
  [1181] = {.lex_state = 62, .external_lex_state = 3},
  [1182] = {.lex_state = 62, .external_lex_state = 3},
  [1183] = {.lex_state = 62, .external_lex_state = 3},
  [1184] = {.lex_state = 62, .external_lex_state = 3},
  [1185] = {.lex_state = 62, .external_lex_state = 2},
  [1186] = {.lex_state = 62, .external_lex_state = 3},
  [1187] = {.lex_state = 62, .external_lex_state = 3},
  [1188] = {.lex_state = 62, .external_lex_state = 3},
  [1189] = {.lex_state = 62, .external_lex_state = 3},
  [1190] = {.lex_state = 15},
  [1191] = {.lex_state = 62, .external_lex_state = 2},
  [1192] = {.lex_state = 62, .external_lex_state = 2},
  [1193] = {.lex_state = 62, .external_lex_state = 2},
  [1194] = {.lex_state = 15},
  [1195] = {.lex_state = 62, .external_lex_state = 3},
  [1196] = {.lex_state = 62, .external_lex_state = 2},
  [1197] = {.lex_state = 62, .external_lex_state = 2},
  [1198] = {.lex_state = 62, .external_lex_state = 2},
  [1199] = {.lex_state = 62, .external_lex_state = 2},
  [1200] = {.lex_state = 62, .external_lex_state = 3},
  [1201] = {.lex_state = 62, .external_lex_state = 3},
  [1202] = {.lex_state = 62, .external_lex_state = 3},
  [1203] = {.lex_state = 62, .external_lex_state = 3},
  [1204] = {.lex_state = 62, .external_lex_state = 3},
  [1205] = {.lex_state = 62, .external_lex_state = 3},
  [1206] = {.lex_state = 62, .external_lex_state = 3},
  [1207] = {.lex_state = 62, .external_lex_state = 3},
  [1208] = {.lex_state = 62, .external_lex_state = 2},
  [1209] = {.lex_state = 62, .external_lex_state = 3},
  [1210] = {.lex_state = 62, .external_lex_state = 3},
  [1211] = {.lex_state = 62, .external_lex_state = 3},
  [1212] = {.lex_state = 62, .external_lex_state = 3},
  [1213] = {.lex_state = 62, .external_lex_state = 2},
  [1214] = {.lex_state = 62, .external_lex_state = 3},
  [1215] = {.lex_state = 62, .external_lex_state = 3},
  [1216] = {.lex_state = 62, .external_lex_state = 3},
  [1217] = {.lex_state = 62, .external_lex_state = 2},
  [1218] = {.lex_state = 62, .external_lex_state = 2},
  [1219] = {.lex_state = 62, .external_lex_state = 3},
  [1220] = {.lex_state = 62, .external_lex_state = 3},
  [1221] = {.lex_state = 62, .external_lex_state = 3},
  [1222] = {.lex_state = 62, .external_lex_state = 3},
  [1223] = {.lex_state = 62, .external_lex_state = 3},
  [1224] = {.lex_state = 62, .external_lex_state = 3},
  [1225] = {.lex_state = 62, .external_lex_state = 3},
  [1226] = {.lex_state = 62, .external_lex_state = 3},
  [1227] = {.lex_state = 15},
  [1228] = {.lex_state = 62, .external_lex_state = 3},
  [1229] = {.lex_state = 62, .external_lex_state = 2},
  [1230] = {.lex_state = 62, .external_lex_state = 2},
  [1231] = {.lex_state = 62, .external_lex_state = 3},
  [1232] = {.lex_state = 62, .external_lex_state = 3},
  [1233] = {.lex_state = 62, .external_lex_state = 3},
  [1234] = {.lex_state = 62, .external_lex_state = 3},
  [1235] = {.lex_state = 62, .external_lex_state = 3},
  [1236] = {.lex_state = 62, .external_lex_state = 2},
  [1237] = {.lex_state = 62, .external_lex_state = 3},
  [1238] = {.lex_state = 62, .external_lex_state = 3},
  [1239] = {.lex_state = 62, .external_lex_state = 3},
  [1240] = {.lex_state = 62, .external_lex_state = 3},
  [1241] = {.lex_state = 62, .external_lex_state = 3},
  [1242] = {.lex_state = 15},
  [1243] = {.lex_state = 62, .external_lex_state = 2},
  [1244] = {.lex_state = 62, .external_lex_state = 2},
  [1245] = {.lex_state = 62, .external_lex_state = 3},
  [1246] = {.lex_state = 62, .external_lex_state = 3},
  [1247] = {.lex_state = 62, .external_lex_state = 3},
  [1248] = {.lex_state = 62, .external_lex_state = 2},
  [1249] = {.lex_state = 62, .external_lex_state = 3},
  [1250] = {.lex_state = 62, .external_lex_state = 3},
  [1251] = {.lex_state = 62, .external_lex_state = 3},
  [1252] = {.lex_state = 62, .external_lex_state = 3},
  [1253] = {.lex_state = 62, .external_lex_state = 3},
  [1254] = {.lex_state = 62, .external_lex_state = 3},
  [1255] = {.lex_state = 62, .external_lex_state = 2},
  [1256] = {.lex_state = 62, .external_lex_state = 3},
  [1257] = {.lex_state = 62, .external_lex_state = 3},
  [1258] = {.lex_state = 62, .external_lex_state = 3},
  [1259] = {.lex_state = 62, .external_lex_state = 3},
  [1260] = {.lex_state = 62, .external_lex_state = 3},
  [1261] = {.lex_state = 62, .external_lex_state = 3},
  [1262] = {.lex_state = 62, .external_lex_state = 3},
  [1263] = {.lex_state = 62, .external_lex_state = 3},
  [1264] = {.lex_state = 62, .external_lex_state = 3},
  [1265] = {.lex_state = 62, .external_lex_state = 3},
  [1266] = {.lex_state = 62, .external_lex_state = 3},
  [1267] = {.lex_state = 62, .external_lex_state = 3},
  [1268] = {.lex_state = 62, .external_lex_state = 3},
  [1269] = {.lex_state = 62, .external_lex_state = 3},
  [1270] = {.lex_state = 62, .external_lex_state = 2},
  [1271] = {.lex_state = 62, .external_lex_state = 3},
  [1272] = {.lex_state = 62, .external_lex_state = 3},
  [1273] = {.lex_state = 62, .external_lex_state = 3},
  [1274] = {.lex_state = 62, .external_lex_state = 2},
  [1275] = {.lex_state = 8, .external_lex_state = 3},
  [1276] = {.lex_state = 62, .external_lex_state = 2},
  [1277] = {.lex_state = 62, .external_lex_state = 2},
  [1278] = {.lex_state = 62, .external_lex_state = 3},
  [1279] = {.lex_state = 62, .external_lex_state = 3},
  [1280] = {.lex_state = 62, .external_lex_state = 3},
  [1281] = {.lex_state = 62, .external_lex_state = 2},
  [1282] = {.lex_state = 62, .external_lex_state = 3},
  [1283] = {.lex_state = 62, .external_lex_state = 3},
  [1284] = {.lex_state = 62, .external_lex_state = 3},
  [1285] = {.lex_state = 62, .external_lex_state = 3},
  [1286] = {.lex_state = 8, .external_lex_state = 3},
  [1287] = {.lex_state = 62, .external_lex_state = 3},
  [1288] = {.lex_state = 62, .external_lex_state = 3},
  [1289] = {.lex_state = 62, .external_lex_state = 3},
  [1290] = {.lex_state = 62, .external_lex_state = 3},
  [1291] = {.lex_state = 62, .external_lex_state = 3},
  [1292] = {.lex_state = 62, .external_lex_state = 2},
  [1293] = {.lex_state = 62, .external_lex_state = 3},
  [1294] = {.lex_state = 8, .external_lex_state = 3},
  [1295] = {.lex_state = 62, .external_lex_state = 2},
  [1296] = {.lex_state = 63},
  [1297] = {.lex_state = 8, .external_lex_state = 3},
  [1298] = {.lex_state = 62, .external_lex_state = 3},
  [1299] = {.lex_state = 62, .external_lex_state = 3},
  [1300] = {.lex_state = 62, .external_lex_state = 3},
  [1301] = {.lex_state = 62, .external_lex_state = 3},
  [1302] = {.lex_state = 62, .external_lex_state = 3},
  [1303] = {.lex_state = 62, .external_lex_state = 3},
  [1304] = {.lex_state = 62, .external_lex_state = 3},
  [1305] = {.lex_state = 62, .external_lex_state = 3},
  [1306] = {.lex_state = 62, .external_lex_state = 3},
  [1307] = {.lex_state = 62, .external_lex_state = 3},
  [1308] = {.lex_state = 62, .external_lex_state = 3},
  [1309] = {.lex_state = 62, .external_lex_state = 3},
  [1310] = {.lex_state = 62, .external_lex_state = 3},
  [1311] = {.lex_state = 62, .external_lex_state = 3},
  [1312] = {.lex_state = 62, .external_lex_state = 3},
  [1313] = {.lex_state = 62, .external_lex_state = 3},
  [1314] = {.lex_state = 62, .external_lex_state = 3},
  [1315] = {.lex_state = 62, .external_lex_state = 3},
  [1316] = {.lex_state = 62, .external_lex_state = 2},
  [1317] = {.lex_state = 62, .external_lex_state = 3},
  [1318] = {.lex_state = 62, .external_lex_state = 3},
  [1319] = {.lex_state = 62, .external_lex_state = 3},
  [1320] = {.lex_state = 8, .external_lex_state = 3},
  [1321] = {.lex_state = 62, .external_lex_state = 2},
  [1322] = {.lex_state = 8, .external_lex_state = 3},
  [1323] = {.lex_state = 62, .external_lex_state = 3},
  [1324] = {.lex_state = 62, .external_lex_state = 3},
  [1325] = {.lex_state = 62, .external_lex_state = 3},
  [1326] = {.lex_state = 8, .external_lex_state = 3},
  [1327] = {.lex_state = 62, .external_lex_state = 3},
  [1328] = {.lex_state = 62, .external_lex_state = 3},
  [1329] = {.lex_state = 62, .external_lex_state = 2},
  [1330] = {.lex_state = 8, .external_lex_state = 3},
  [1331] = {.lex_state = 8, .external_lex_state = 3},
  [1332] = {.lex_state = 62, .external_lex_state = 3},
  [1333] = {.lex_state = 8, .external_lex_state = 3},
  [1334] = {.lex_state = 62, .external_lex_state = 3},
  [1335] = {.lex_state = 8, .external_lex_state = 3},
  [1336] = {.lex_state = 62, .external_lex_state = 3},
  [1337] = {.lex_state = 8, .external_lex_state = 3},
  [1338] = {.lex_state = 8, .external_lex_state = 3},
  [1339] = {.lex_state = 63},
  [1340] = {.lex_state = 63},
  [1341] = {.lex_state = 8, .external_lex_state = 3},
  [1342] = {.lex_state = 8, .external_lex_state = 3},
  [1343] = {.lex_state = 8, .external_lex_state = 3},
  [1344] = {.lex_state = 62, .external_lex_state = 3},
  [1345] = {.lex_state = 62, .external_lex_state = 3},
  [1346] = {.lex_state = 8, .external_lex_state = 3},
  [1347] = {.lex_state = 62, .external_lex_state = 3},
  [1348] = {.lex_state = 62, .external_lex_state = 3},
  [1349] = {.lex_state = 8, .external_lex_state = 3},
  [1350] = {.lex_state = 62, .external_lex_state = 2},
  [1351] = {.lex_state = 8, .external_lex_state = 3},
  [1352] = {.lex_state = 8, .external_lex_state = 3},
  [1353] = {.lex_state = 62, .external_lex_state = 3},
  [1354] = {.lex_state = 62, .external_lex_state = 3},
  [1355] = {.lex_state = 8, .external_lex_state = 3},
  [1356] = {.lex_state = 8, .external_lex_state = 3},
  [1357] = {.lex_state = 62, .external_lex_state = 3},
  [1358] = {.lex_state = 62, .external_lex_state = 3},
  [1359] = {.lex_state = 63},
  [1360] = {.lex_state = 62, .external_lex_state = 2},
  [1361] = {.lex_state = 62, .external_lex_state = 3},
  [1362] = {.lex_state = 62, .external_lex_state = 2},
  [1363] = {.lex_state = 62, .external_lex_state = 3},
  [1364] = {.lex_state = 62, .external_lex_state = 3},
  [1365] = {.lex_state = 62, .external_lex_state = 2},
  [1366] = {.lex_state = 8, .external_lex_state = 3},
  [1367] = {.lex_state = 62, .external_lex_state = 2},
  [1368] = {.lex_state = 62, .external_lex_state = 3},
  [1369] = {.lex_state = 8, .external_lex_state = 3},
  [1370] = {.lex_state = 8, .external_lex_state = 3},
  [1371] = {.lex_state = 8, .external_lex_state = 3},
  [1372] = {.lex_state = 8, .external_lex_state = 3},
  [1373] = {.lex_state = 62, .external_lex_state = 3},
  [1374] = {.lex_state = 62, .external_lex_state = 3},
  [1375] = {.lex_state = 62, .external_lex_state = 2},
  [1376] = {.lex_state = 62, .external_lex_state = 2},
  [1377] = {.lex_state = 62, .external_lex_state = 3},
  [1378] = {.lex_state = 8, .external_lex_state = 3},
  [1379] = {.lex_state = 8, .external_lex_state = 3},
  [1380] = {.lex_state = 8, .external_lex_state = 3},
  [1381] = {.lex_state = 62, .external_lex_state = 3},
  [1382] = {.lex_state = 9, .external_lex_state = 3},
  [1383] = {.lex_state = 62, .external_lex_state = 3},
  [1384] = {.lex_state = 62, .external_lex_state = 2},
  [1385] = {.lex_state = 8, .external_lex_state = 3},
  [1386] = {.lex_state = 62, .external_lex_state = 2},
  [1387] = {.lex_state = 62, .external_lex_state = 2},
  [1388] = {.lex_state = 63},
  [1389] = {.lex_state = 62, .external_lex_state = 3},
  [1390] = {.lex_state = 62, .external_lex_state = 2},
  [1391] = {.lex_state = 62, .external_lex_state = 3},
  [1392] = {.lex_state = 62, .external_lex_state = 3},
  [1393] = {.lex_state = 8, .external_lex_state = 3},
  [1394] = {.lex_state = 62, .external_lex_state = 3},
  [1395] = {.lex_state = 62, .external_lex_state = 2},
  [1396] = {.lex_state = 62, .external_lex_state = 2},
  [1397] = {.lex_state = 8, .external_lex_state = 3},
  [1398] = {.lex_state = 62, .external_lex_state = 3},
  [1399] = {.lex_state = 8, .external_lex_state = 3},
  [1400] = {.lex_state = 62, .external_lex_state = 3},
  [1401] = {.lex_state = 62, .external_lex_state = 2},
  [1402] = {.lex_state = 62, .external_lex_state = 3},
  [1403] = {.lex_state = 62, .external_lex_state = 2},
  [1404] = {.lex_state = 62, .external_lex_state = 2},
  [1405] = {.lex_state = 8, .external_lex_state = 3},
  [1406] = {.lex_state = 63},
  [1407] = {.lex_state = 8, .external_lex_state = 2},
  [1408] = {.lex_state = 62, .external_lex_state = 2},
  [1409] = {.lex_state = 62, .external_lex_state = 2},
  [1410] = {.lex_state = 62, .external_lex_state = 2},
  [1411] = {.lex_state = 62, .external_lex_state = 2},
  [1412] = {.lex_state = 62, .external_lex_state = 2},
  [1413] = {.lex_state = 62, .external_lex_state = 2},
  [1414] = {.lex_state = 62, .external_lex_state = 3},
  [1415] = {.lex_state = 63, .external_lex_state = 4},
  [1416] = {.lex_state = 62, .external_lex_state = 3},
  [1417] = {.lex_state = 63, .external_lex_state = 4},
  [1418] = {.lex_state = 62, .external_lex_state = 2},
  [1419] = {.lex_state = 62, .external_lex_state = 2},
  [1420] = {.lex_state = 63},
  [1421] = {.lex_state = 9, .external_lex_state = 2},
  [1422] = {.lex_state = 63},
  [1423] = {.lex_state = 62, .external_lex_state = 2},
  [1424] = {.lex_state = 63},
  [1425] = {.lex_state = 63},
  [1426] = {.lex_state = 62, .external_lex_state = 3},
  [1427] = {.lex_state = 62, .external_lex_state = 3},
  [1428] = {.lex_state = 62, .external_lex_state = 2},
  [1429] = {.lex_state = 62, .external_lex_state = 3},
  [1430] = {.lex_state = 62, .external_lex_state = 2},
  [1431] = {.lex_state = 63},
  [1432] = {.lex_state = 62, .external_lex_state = 2},
  [1433] = {.lex_state = 62, .external_lex_state = 2},
  [1434] = {.lex_state = 62, .external_lex_state = 3},
  [1435] = {.lex_state = 63},
  [1436] = {.lex_state = 62, .external_lex_state = 3},
  [1437] = {.lex_state = 62, .external_lex_state = 2},
  [1438] = {.lex_state = 63},
  [1439] = {.lex_state = 62, .external_lex_state = 2},
  [1440] = {.lex_state = 62, .external_lex_state = 2},
  [1441] = {.lex_state = 63},
  [1442] = {.lex_state = 62, .external_lex_state = 3},
  [1443] = {.lex_state = 63},
  [1444] = {.lex_state = 63},
  [1445] = {.lex_state = 63, .external_lex_state = 4},
  [1446] = {.lex_state = 63, .external_lex_state = 4},
  [1447] = {.lex_state = 62, .external_lex_state = 2},
  [1448] = {.lex_state = 62, .external_lex_state = 2},
  [1449] = {.lex_state = 62, .external_lex_state = 2},
  [1450] = {.lex_state = 62, .external_lex_state = 3},
  [1451] = {.lex_state = 63, .external_lex_state = 4},
  [1452] = {.lex_state = 63, .external_lex_state = 4},
  [1453] = {.lex_state = 63, .external_lex_state = 4},
  [1454] = {.lex_state = 62, .external_lex_state = 2},
  [1455] = {.lex_state = 62, .external_lex_state = 2},
  [1456] = {.lex_state = 63, .external_lex_state = 4},
  [1457] = {.lex_state = 62, .external_lex_state = 2},
  [1458] = {.lex_state = 62, .external_lex_state = 2},
  [1459] = {.lex_state = 62, .external_lex_state = 3},
  [1460] = {.lex_state = 62, .external_lex_state = 2},
  [1461] = {.lex_state = 62, .external_lex_state = 2},
  [1462] = {.lex_state = 62, .external_lex_state = 2},
  [1463] = {.lex_state = 62, .external_lex_state = 2},
  [1464] = {.lex_state = 62, .external_lex_state = 3},
  [1465] = {.lex_state = 8, .external_lex_state = 3},
  [1466] = {.lex_state = 8, .external_lex_state = 3},
  [1467] = {.lex_state = 62, .external_lex_state = 3},
  [1468] = {.lex_state = 62, .external_lex_state = 2},
  [1469] = {.lex_state = 63, .external_lex_state = 4},
  [1470] = {.lex_state = 62, .external_lex_state = 3},
  [1471] = {.lex_state = 62, .external_lex_state = 2},
  [1472] = {.lex_state = 62, .external_lex_state = 3},
  [1473] = {.lex_state = 62, .external_lex_state = 2},
  [1474] = {.lex_state = 63, .external_lex_state = 4},
  [1475] = {.lex_state = 63, .external_lex_state = 4},
  [1476] = {.lex_state = 62, .external_lex_state = 3},
  [1477] = {.lex_state = 62, .external_lex_state = 2},
  [1478] = {.lex_state = 63},
  [1479] = {.lex_state = 62, .external_lex_state = 2},
  [1480] = {.lex_state = 63},
  [1481] = {.lex_state = 62, .external_lex_state = 2},
  [1482] = {.lex_state = 62, .external_lex_state = 2},
  [1483] = {.lex_state = 62, .external_lex_state = 2},
  [1484] = {.lex_state = 62, .external_lex_state = 2},
  [1485] = {.lex_state = 62, .external_lex_state = 2},
  [1486] = {.lex_state = 62, .external_lex_state = 2},
  [1487] = {.lex_state = 62, .external_lex_state = 2},
  [1488] = {.lex_state = 62, .external_lex_state = 2},
  [1489] = {.lex_state = 62, .external_lex_state = 3},
  [1490] = {.lex_state = 62, .external_lex_state = 2},
  [1491] = {.lex_state = 63},
  [1492] = {.lex_state = 62, .external_lex_state = 2},
  [1493] = {.lex_state = 62, .external_lex_state = 2},
  [1494] = {.lex_state = 62, .external_lex_state = 3},
  [1495] = {.lex_state = 63, .external_lex_state = 4},
  [1496] = {.lex_state = 62, .external_lex_state = 2},
  [1497] = {.lex_state = 62, .external_lex_state = 3},
  [1498] = {.lex_state = 62, .external_lex_state = 2},
  [1499] = {.lex_state = 62, .external_lex_state = 2},
  [1500] = {.lex_state = 62, .external_lex_state = 3},
  [1501] = {.lex_state = 62, .external_lex_state = 2},
  [1502] = {.lex_state = 62, .external_lex_state = 2},
  [1503] = {.lex_state = 62, .external_lex_state = 3},
  [1504] = {.lex_state = 62, .external_lex_state = 3},
  [1505] = {.lex_state = 62, .external_lex_state = 2},
  [1506] = {.lex_state = 62, .external_lex_state = 2},
  [1507] = {.lex_state = 8, .external_lex_state = 3},
  [1508] = {.lex_state = 62, .external_lex_state = 2},
  [1509] = {.lex_state = 62, .external_lex_state = 2},
  [1510] = {.lex_state = 62, .external_lex_state = 2},
  [1511] = {.lex_state = 62, .external_lex_state = 3},
  [1512] = {.lex_state = 62, .external_lex_state = 2},
  [1513] = {.lex_state = 62, .external_lex_state = 2},
  [1514] = {.lex_state = 63, .external_lex_state = 4},
  [1515] = {.lex_state = 8, .external_lex_state = 3},
  [1516] = {.lex_state = 62, .external_lex_state = 2},
  [1517] = {.lex_state = 62, .external_lex_state = 2},
  [1518] = {.lex_state = 62, .external_lex_state = 2},
  [1519] = {.lex_state = 62, .external_lex_state = 2},
  [1520] = {.lex_state = 62, .external_lex_state = 2},
  [1521] = {.lex_state = 62, .external_lex_state = 2},
  [1522] = {.lex_state = 62, .external_lex_state = 3},
  [1523] = {.lex_state = 63, .external_lex_state = 4},
  [1524] = {.lex_state = 62, .external_lex_state = 2},
  [1525] = {.lex_state = 62, .external_lex_state = 2},
  [1526] = {.lex_state = 62, .external_lex_state = 2},
  [1527] = {.lex_state = 62, .external_lex_state = 3},
  [1528] = {.lex_state = 8, .external_lex_state = 3},
  [1529] = {.lex_state = 8, .external_lex_state = 2},
  [1530] = {.lex_state = 8, .external_lex_state = 3},
  [1531] = {.lex_state = 63, .external_lex_state = 4},
  [1532] = {.lex_state = 62, .external_lex_state = 2},
  [1533] = {.lex_state = 62, .external_lex_state = 3},
  [1534] = {.lex_state = 8, .external_lex_state = 3},
  [1535] = {.lex_state = 62, .external_lex_state = 3},
  [1536] = {.lex_state = 8, .external_lex_state = 3},
  [1537] = {.lex_state = 62, .external_lex_state = 2},
  [1538] = {.lex_state = 62, .external_lex_state = 3},
  [1539] = {.lex_state = 62, .external_lex_state = 2},
  [1540] = {.lex_state = 62, .external_lex_state = 2},
  [1541] = {.lex_state = 62, .external_lex_state = 2},
  [1542] = {.lex_state = 62, .external_lex_state = 2},
  [1543] = {.lex_state = 63, .external_lex_state = 4},
  [1544] = {.lex_state = 62, .external_lex_state = 3},
  [1545] = {.lex_state = 62, .external_lex_state = 3},
  [1546] = {.lex_state = 62, .external_lex_state = 2},
  [1547] = {.lex_state = 62, .external_lex_state = 2},
  [1548] = {.lex_state = 8, .external_lex_state = 3},
  [1549] = {.lex_state = 8, .external_lex_state = 3},
  [1550] = {.lex_state = 62, .external_lex_state = 3},
  [1551] = {.lex_state = 62, .external_lex_state = 2},
  [1552] = {.lex_state = 8, .external_lex_state = 3},
  [1553] = {.lex_state = 62, .external_lex_state = 2},
  [1554] = {.lex_state = 8, .external_lex_state = 3},
  [1555] = {.lex_state = 62, .external_lex_state = 2},
  [1556] = {.lex_state = 62, .external_lex_state = 2},
  [1557] = {.lex_state = 62, .external_lex_state = 2},
  [1558] = {.lex_state = 62, .external_lex_state = 2},
  [1559] = {.lex_state = 62, .external_lex_state = 2},
  [1560] = {.lex_state = 62, .external_lex_state = 2},
  [1561] = {.lex_state = 62, .external_lex_state = 2},
  [1562] = {.lex_state = 62, .external_lex_state = 2},
  [1563] = {.lex_state = 62, .external_lex_state = 2},
  [1564] = {.lex_state = 62, .external_lex_state = 2},
  [1565] = {.lex_state = 62, .external_lex_state = 2},
  [1566] = {.lex_state = 62, .external_lex_state = 2},
  [1567] = {.lex_state = 62, .external_lex_state = 2},
  [1568] = {.lex_state = 62, .external_lex_state = 3},
  [1569] = {.lex_state = 62, .external_lex_state = 2},
  [1570] = {.lex_state = 62, .external_lex_state = 2},
  [1571] = {.lex_state = 62, .external_lex_state = 2},
  [1572] = {.lex_state = 62, .external_lex_state = 2},
  [1573] = {.lex_state = 62, .external_lex_state = 3},
  [1574] = {.lex_state = 62, .external_lex_state = 3},
  [1575] = {.lex_state = 62, .external_lex_state = 2},
  [1576] = {.lex_state = 62, .external_lex_state = 2},
  [1577] = {.lex_state = 62, .external_lex_state = 2},
  [1578] = {.lex_state = 62, .external_lex_state = 2},
  [1579] = {.lex_state = 62, .external_lex_state = 2},
  [1580] = {.lex_state = 62, .external_lex_state = 2},
  [1581] = {.lex_state = 62, .external_lex_state = 2},
  [1582] = {.lex_state = 62, .external_lex_state = 3},
  [1583] = {.lex_state = 62, .external_lex_state = 3},
  [1584] = {.lex_state = 62, .external_lex_state = 2},
  [1585] = {.lex_state = 8, .external_lex_state = 2},
  [1586] = {.lex_state = 62, .external_lex_state = 2},
  [1587] = {.lex_state = 62, .external_lex_state = 2},
  [1588] = {.lex_state = 62, .external_lex_state = 2},
  [1589] = {.lex_state = 62, .external_lex_state = 2},
  [1590] = {.lex_state = 62, .external_lex_state = 2},
  [1591] = {.lex_state = 62, .external_lex_state = 2},
  [1592] = {.lex_state = 62, .external_lex_state = 3},
  [1593] = {.lex_state = 62, .external_lex_state = 3},
  [1594] = {.lex_state = 62, .external_lex_state = 3},
  [1595] = {.lex_state = 62, .external_lex_state = 3},
  [1596] = {.lex_state = 62, .external_lex_state = 2},
  [1597] = {.lex_state = 62, .external_lex_state = 3},
  [1598] = {.lex_state = 62, .external_lex_state = 3},
  [1599] = {.lex_state = 62, .external_lex_state = 2},
  [1600] = {.lex_state = 62, .external_lex_state = 2},
  [1601] = {.lex_state = 62, .external_lex_state = 2},
  [1602] = {.lex_state = 62, .external_lex_state = 2},
  [1603] = {.lex_state = 62, .external_lex_state = 3},
  [1604] = {.lex_state = 8, .external_lex_state = 3},
  [1605] = {.lex_state = 62, .external_lex_state = 3},
  [1606] = {.lex_state = 62, .external_lex_state = 3},
  [1607] = {.lex_state = 62, .external_lex_state = 3},
  [1608] = {.lex_state = 62, .external_lex_state = 3},
  [1609] = {.lex_state = 8, .external_lex_state = 3},
  [1610] = {.lex_state = 62, .external_lex_state = 2},
  [1611] = {.lex_state = 62, .external_lex_state = 3},
  [1612] = {.lex_state = 62, .external_lex_state = 2},
  [1613] = {.lex_state = 62, .external_lex_state = 2},
  [1614] = {.lex_state = 62, .external_lex_state = 2},
  [1615] = {.lex_state = 8, .external_lex_state = 3},
  [1616] = {.lex_state = 8, .external_lex_state = 3},
  [1617] = {.lex_state = 62, .external_lex_state = 2},
  [1618] = {.lex_state = 62, .external_lex_state = 2},
  [1619] = {.lex_state = 62, .external_lex_state = 2},
  [1620] = {.lex_state = 62, .external_lex_state = 3},
  [1621] = {.lex_state = 62, .external_lex_state = 3},
  [1622] = {.lex_state = 62, .external_lex_state = 3},
  [1623] = {.lex_state = 62, .external_lex_state = 3},
  [1624] = {.lex_state = 62, .external_lex_state = 3},
  [1625] = {.lex_state = 62, .external_lex_state = 2},
  [1626] = {.lex_state = 62, .external_lex_state = 2},
  [1627] = {.lex_state = 62, .external_lex_state = 3},
  [1628] = {.lex_state = 62, .external_lex_state = 2},
  [1629] = {.lex_state = 62, .external_lex_state = 2},
  [1630] = {.lex_state = 62, .external_lex_state = 3},
  [1631] = {.lex_state = 8, .external_lex_state = 3},
  [1632] = {.lex_state = 8, .external_lex_state = 3},
  [1633] = {.lex_state = 62, .external_lex_state = 3},
  [1634] = {.lex_state = 62, .external_lex_state = 2},
  [1635] = {.lex_state = 62, .external_lex_state = 2},
  [1636] = {.lex_state = 62, .external_lex_state = 2},
  [1637] = {.lex_state = 62, .external_lex_state = 2},
  [1638] = {.lex_state = 62, .external_lex_state = 2},
  [1639] = {.lex_state = 62, .external_lex_state = 3},
  [1640] = {.lex_state = 62, .external_lex_state = 3},
  [1641] = {.lex_state = 62, .external_lex_state = 2},
  [1642] = {.lex_state = 8, .external_lex_state = 3},
  [1643] = {.lex_state = 62, .external_lex_state = 3},
  [1644] = {.lex_state = 62, .external_lex_state = 2},
  [1645] = {.lex_state = 62, .external_lex_state = 2},
  [1646] = {.lex_state = 62, .external_lex_state = 3},
  [1647] = {.lex_state = 62, .external_lex_state = 2},
  [1648] = {.lex_state = 8, .external_lex_state = 3},
  [1649] = {.lex_state = 62, .external_lex_state = 3},
  [1650] = {.lex_state = 62, .external_lex_state = 3},
  [1651] = {.lex_state = 62, .external_lex_state = 3},
  [1652] = {.lex_state = 62, .external_lex_state = 3},
  [1653] = {.lex_state = 8, .external_lex_state = 3},
  [1654] = {.lex_state = 62, .external_lex_state = 3},
  [1655] = {.lex_state = 62, .external_lex_state = 3},
  [1656] = {.lex_state = 62, .external_lex_state = 3},
  [1657] = {.lex_state = 62, .external_lex_state = 3},
  [1658] = {.lex_state = 62, .external_lex_state = 3},
  [1659] = {.lex_state = 62, .external_lex_state = 3},
  [1660] = {.lex_state = 62, .external_lex_state = 3},
  [1661] = {.lex_state = 62, .external_lex_state = 3},
  [1662] = {.lex_state = 62, .external_lex_state = 3},
  [1663] = {.lex_state = 62, .external_lex_state = 2},
  [1664] = {.lex_state = 62, .external_lex_state = 2},
  [1665] = {.lex_state = 62, .external_lex_state = 3},
  [1666] = {.lex_state = 62, .external_lex_state = 3},
  [1667] = {.lex_state = 62, .external_lex_state = 3},
  [1668] = {.lex_state = 62, .external_lex_state = 3},
  [1669] = {.lex_state = 62, .external_lex_state = 3},
  [1670] = {.lex_state = 62, .external_lex_state = 2},
  [1671] = {.lex_state = 62, .external_lex_state = 3},
  [1672] = {.lex_state = 62, .external_lex_state = 3},
  [1673] = {.lex_state = 63, .external_lex_state = 4},
  [1674] = {.lex_state = 9, .external_lex_state = 3},
  [1675] = {.lex_state = 62, .external_lex_state = 2},
  [1676] = {.lex_state = 62, .external_lex_state = 2},
  [1677] = {.lex_state = 63, .external_lex_state = 4},
  [1678] = {.lex_state = 62, .external_lex_state = 3},
  [1679] = {.lex_state = 63, .external_lex_state = 4},
  [1680] = {.lex_state = 63, .external_lex_state = 4},
  [1681] = {.lex_state = 62, .external_lex_state = 3},
  [1682] = {.lex_state = 62, .external_lex_state = 3},
  [1683] = {.lex_state = 62, .external_lex_state = 3},
  [1684] = {.lex_state = 62, .external_lex_state = 3},
  [1685] = {.lex_state = 62, .external_lex_state = 2},
  [1686] = {.lex_state = 62, .external_lex_state = 2},
  [1687] = {.lex_state = 62, .external_lex_state = 2},
  [1688] = {.lex_state = 62, .external_lex_state = 2},
  [1689] = {.lex_state = 62, .external_lex_state = 3},
  [1690] = {.lex_state = 62, .external_lex_state = 3},
  [1691] = {.lex_state = 62, .external_lex_state = 2},
  [1692] = {.lex_state = 62, .external_lex_state = 3},
  [1693] = {.lex_state = 62, .external_lex_state = 3},
  [1694] = {.lex_state = 63, .external_lex_state = 4},
  [1695] = {.lex_state = 62, .external_lex_state = 2},
  [1696] = {.lex_state = 62, .external_lex_state = 3},
  [1697] = {.lex_state = 62, .external_lex_state = 3},
  [1698] = {.lex_state = 62, .external_lex_state = 2},
  [1699] = {.lex_state = 62, .external_lex_state = 3},
  [1700] = {.lex_state = 62, .external_lex_state = 3},
  [1701] = {.lex_state = 62, .external_lex_state = 2},
  [1702] = {.lex_state = 11, .external_lex_state = 3},
  [1703] = {.lex_state = 62, .external_lex_state = 3},
  [1704] = {.lex_state = 62, .external_lex_state = 3},
  [1705] = {.lex_state = 62, .external_lex_state = 3},
  [1706] = {.lex_state = 62, .external_lex_state = 3},
  [1707] = {.lex_state = 62, .external_lex_state = 3},
  [1708] = {.lex_state = 8, .external_lex_state = 3},
  [1709] = {.lex_state = 63, .external_lex_state = 4},
  [1710] = {.lex_state = 62, .external_lex_state = 3},
  [1711] = {.lex_state = 63, .external_lex_state = 4},
  [1712] = {.lex_state = 63, .external_lex_state = 4},
  [1713] = {.lex_state = 63, .external_lex_state = 4},
  [1714] = {.lex_state = 62, .external_lex_state = 3},
  [1715] = {.lex_state = 63, .external_lex_state = 4},
  [1716] = {.lex_state = 63, .external_lex_state = 4},
  [1717] = {.lex_state = 63, .external_lex_state = 4},
  [1718] = {.lex_state = 8, .external_lex_state = 3},
  [1719] = {.lex_state = 8, .external_lex_state = 3},
  [1720] = {.lex_state = 8, .external_lex_state = 3},
  [1721] = {.lex_state = 62, .external_lex_state = 2},
  [1722] = {.lex_state = 62, .external_lex_state = 2},
  [1723] = {.lex_state = 63, .external_lex_state = 4},
  [1724] = {.lex_state = 63, .external_lex_state = 4},
  [1725] = {.lex_state = 63, .external_lex_state = 4},
  [1726] = {.lex_state = 63, .external_lex_state = 4},
  [1727] = {.lex_state = 8, .external_lex_state = 3},
  [1728] = {.lex_state = 63, .external_lex_state = 4},
  [1729] = {.lex_state = 63, .external_lex_state = 4},
  [1730] = {.lex_state = 63, .external_lex_state = 4},
  [1731] = {.lex_state = 63, .external_lex_state = 4},
  [1732] = {.lex_state = 63, .external_lex_state = 4},
  [1733] = {.lex_state = 63, .external_lex_state = 4},
  [1734] = {.lex_state = 62, .external_lex_state = 3},
  [1735] = {.lex_state = 8, .external_lex_state = 3},
  [1736] = {.lex_state = 8, .external_lex_state = 3},
  [1737] = {.lex_state = 63, .external_lex_state = 4},
  [1738] = {.lex_state = 63, .external_lex_state = 4},
  [1739] = {.lex_state = 8, .external_lex_state = 3},
  [1740] = {.lex_state = 8, .external_lex_state = 3},
  [1741] = {.lex_state = 8, .external_lex_state = 3},
  [1742] = {.lex_state = 8, .external_lex_state = 3},
  [1743] = {.lex_state = 8, .external_lex_state = 3},
  [1744] = {.lex_state = 8, .external_lex_state = 3},
  [1745] = {.lex_state = 8, .external_lex_state = 3},
  [1746] = {.lex_state = 8, .external_lex_state = 3},
  [1747] = {.lex_state = 8, .external_lex_state = 3},
  [1748] = {.lex_state = 8, .external_lex_state = 3},
  [1749] = {.lex_state = 8, .external_lex_state = 3},
  [1750] = {.lex_state = 8, .external_lex_state = 3},
  [1751] = {.lex_state = 8, .external_lex_state = 3},
  [1752] = {.lex_state = 8, .external_lex_state = 3},
  [1753] = {.lex_state = 8, .external_lex_state = 3},
  [1754] = {.lex_state = 8, .external_lex_state = 3},
  [1755] = {.lex_state = 8, .external_lex_state = 3},
  [1756] = {.lex_state = 8, .external_lex_state = 3},
  [1757] = {.lex_state = 8, .external_lex_state = 3},
  [1758] = {.lex_state = 8, .external_lex_state = 3},
  [1759] = {.lex_state = 8, .external_lex_state = 3},
  [1760] = {.lex_state = 8, .external_lex_state = 3},
  [1761] = {.lex_state = 8, .external_lex_state = 3},
  [1762] = {.lex_state = 8, .external_lex_state = 3},
  [1763] = {.lex_state = 8, .external_lex_state = 3},
  [1764] = {.lex_state = 8, .external_lex_state = 3},
  [1765] = {.lex_state = 8, .external_lex_state = 3},
  [1766] = {.lex_state = 8, .external_lex_state = 3},
  [1767] = {.lex_state = 8, .external_lex_state = 3},
  [1768] = {.lex_state = 8, .external_lex_state = 3},
  [1769] = {.lex_state = 62, .external_lex_state = 2},
  [1770] = {.lex_state = 62, .external_lex_state = 3},
  [1771] = {.lex_state = 8, .external_lex_state = 3},
  [1772] = {.lex_state = 8, .external_lex_state = 3},
  [1773] = {.lex_state = 8, .external_lex_state = 3},
  [1774] = {.lex_state = 62, .external_lex_state = 3},
  [1775] = {.lex_state = 8, .external_lex_state = 3},
  [1776] = {.lex_state = 8, .external_lex_state = 3},
  [1777] = {.lex_state = 8, .external_lex_state = 3},
  [1778] = {.lex_state = 8, .external_lex_state = 3},
  [1779] = {.lex_state = 8, .external_lex_state = 3},
  [1780] = {.lex_state = 62, .external_lex_state = 3},
  [1781] = {.lex_state = 8, .external_lex_state = 3},
  [1782] = {.lex_state = 8, .external_lex_state = 3},
  [1783] = {.lex_state = 62, .external_lex_state = 3},
  [1784] = {.lex_state = 8, .external_lex_state = 3},
  [1785] = {.lex_state = 8, .external_lex_state = 3},
  [1786] = {.lex_state = 62, .external_lex_state = 3},
  [1787] = {.lex_state = 8, .external_lex_state = 3},
  [1788] = {.lex_state = 8, .external_lex_state = 3},
  [1789] = {.lex_state = 8, .external_lex_state = 3},
  [1790] = {.lex_state = 8, .external_lex_state = 3},
  [1791] = {.lex_state = 8, .external_lex_state = 3},
  [1792] = {.lex_state = 8, .external_lex_state = 3},
  [1793] = {.lex_state = 8, .external_lex_state = 3},
  [1794] = {.lex_state = 8, .external_lex_state = 3},
  [1795] = {.lex_state = 8, .external_lex_state = 3},
  [1796] = {.lex_state = 8, .external_lex_state = 3},
  [1797] = {.lex_state = 62, .external_lex_state = 2},
  [1798] = {.lex_state = 8, .external_lex_state = 3},
  [1799] = {.lex_state = 8, .external_lex_state = 3},
  [1800] = {.lex_state = 8, .external_lex_state = 3},
  [1801] = {.lex_state = 8, .external_lex_state = 3},
  [1802] = {.lex_state = 8, .external_lex_state = 3},
  [1803] = {.lex_state = 63, .external_lex_state = 4},
  [1804] = {.lex_state = 8, .external_lex_state = 3},
  [1805] = {.lex_state = 8, .external_lex_state = 3},
  [1806] = {.lex_state = 63, .external_lex_state = 4},
  [1807] = {.lex_state = 8, .external_lex_state = 3},
  [1808] = {.lex_state = 63, .external_lex_state = 4},
  [1809] = {.lex_state = 8, .external_lex_state = 3},
  [1810] = {.lex_state = 8, .external_lex_state = 3},
  [1811] = {.lex_state = 8, .external_lex_state = 3},
  [1812] = {.lex_state = 8, .external_lex_state = 3},
  [1813] = {.lex_state = 8, .external_lex_state = 3},
  [1814] = {.lex_state = 8, .external_lex_state = 3},
  [1815] = {.lex_state = 8, .external_lex_state = 3},
  [1816] = {.lex_state = 62, .external_lex_state = 3},
  [1817] = {.lex_state = 8, .external_lex_state = 3},
  [1818] = {.lex_state = 8, .external_lex_state = 3},
  [1819] = {.lex_state = 8, .external_lex_state = 3},
  [1820] = {.lex_state = 8, .external_lex_state = 3},
  [1821] = {.lex_state = 8, .external_lex_state = 3},
  [1822] = {.lex_state = 8, .external_lex_state = 3},
  [1823] = {.lex_state = 8, .external_lex_state = 3},
  [1824] = {.lex_state = 62, .external_lex_state = 3},
  [1825] = {.lex_state = 8, .external_lex_state = 3},
  [1826] = {.lex_state = 8, .external_lex_state = 3},
  [1827] = {.lex_state = 63, .external_lex_state = 4},
  [1828] = {.lex_state = 8, .external_lex_state = 3},
  [1829] = {.lex_state = 63, .external_lex_state = 4},
  [1830] = {.lex_state = 8, .external_lex_state = 3},
  [1831] = {.lex_state = 8, .external_lex_state = 3},
  [1832] = {.lex_state = 8, .external_lex_state = 3},
  [1833] = {.lex_state = 8, .external_lex_state = 3},
  [1834] = {.lex_state = 8, .external_lex_state = 3},
  [1835] = {.lex_state = 8, .external_lex_state = 3},
  [1836] = {.lex_state = 63, .external_lex_state = 4},
  [1837] = {.lex_state = 8, .external_lex_state = 3},
  [1838] = {.lex_state = 8, .external_lex_state = 3},
  [1839] = {.lex_state = 8, .external_lex_state = 3},
  [1840] = {.lex_state = 8, .external_lex_state = 3},
  [1841] = {.lex_state = 63, .external_lex_state = 4},
  [1842] = {.lex_state = 63, .external_lex_state = 4},
  [1843] = {.lex_state = 63, .external_lex_state = 4},
  [1844] = {.lex_state = 63},
  [1845] = {.lex_state = 62, .external_lex_state = 3},
  [1846] = {.lex_state = 62, .external_lex_state = 3},
  [1847] = {.lex_state = 63, .external_lex_state = 4},
  [1848] = {.lex_state = 63},
  [1849] = {.lex_state = 63},
  [1850] = {.lex_state = 63, .external_lex_state = 4},
  [1851] = {.lex_state = 63},
  [1852] = {.lex_state = 62, .external_lex_state = 3},
  [1853] = {.lex_state = 63, .external_lex_state = 4},
  [1854] = {.lex_state = 63},
  [1855] = {.lex_state = 62, .external_lex_state = 3},
  [1856] = {.lex_state = 62, .external_lex_state = 3},
  [1857] = {.lex_state = 63},
  [1858] = {.lex_state = 63, .external_lex_state = 4},
  [1859] = {.lex_state = 63, .external_lex_state = 4},
  [1860] = {.lex_state = 63, .external_lex_state = 4},
  [1861] = {.lex_state = 63, .external_lex_state = 4},
  [1862] = {.lex_state = 63},
  [1863] = {.lex_state = 63, .external_lex_state = 4},
  [1864] = {.lex_state = 63},
  [1865] = {.lex_state = 63},
  [1866] = {.lex_state = 62, .external_lex_state = 3},
  [1867] = {.lex_state = 62, .external_lex_state = 3},
  [1868] = {.lex_state = 63, .external_lex_state = 4},
  [1869] = {.lex_state = 63, .external_lex_state = 4},
  [1870] = {.lex_state = 63, .external_lex_state = 4},
  [1871] = {.lex_state = 62, .external_lex_state = 3},
  [1872] = {.lex_state = 62, .external_lex_state = 3},
  [1873] = {.lex_state = 62, .external_lex_state = 3},
  [1874] = {.lex_state = 63},
  [1875] = {.lex_state = 63},
  [1876] = {.lex_state = 63, .external_lex_state = 4},
  [1877] = {.lex_state = 63, .external_lex_state = 4},
  [1878] = {.lex_state = 63},
  [1879] = {.lex_state = 63, .external_lex_state = 4},
  [1880] = {.lex_state = 62, .external_lex_state = 3},
  [1881] = {.lex_state = 63},
  [1882] = {.lex_state = 63, .external_lex_state = 4},
  [1883] = {.lex_state = 63, .external_lex_state = 4},
  [1884] = {.lex_state = 63},
  [1885] = {.lex_state = 63},
  [1886] = {.lex_state = 63},
  [1887] = {.lex_state = 63},
  [1888] = {.lex_state = 63},
  [1889] = {.lex_state = 63},
  [1890] = {.lex_state = 63},
  [1891] = {.lex_state = 63},
  [1892] = {.lex_state = 63},
  [1893] = {.lex_state = 63},
  [1894] = {.lex_state = 63},
  [1895] = {.lex_state = 63},
  [1896] = {.lex_state = 63, .external_lex_state = 4},
  [1897] = {.lex_state = 63},
  [1898] = {.lex_state = 63},
  [1899] = {.lex_state = 63},
  [1900] = {.lex_state = 63},
  [1901] = {.lex_state = 63},
  [1902] = {.lex_state = 63},
  [1903] = {.lex_state = 63},
  [1904] = {.lex_state = 63},
  [1905] = {.lex_state = 63},
  [1906] = {.lex_state = 63},
  [1907] = {.lex_state = 63},
  [1908] = {.lex_state = 63},
  [1909] = {.lex_state = 63},
  [1910] = {.lex_state = 63},
  [1911] = {.lex_state = 63},
  [1912] = {.lex_state = 63},
  [1913] = {.lex_state = 63},
  [1914] = {.lex_state = 63},
  [1915] = {.lex_state = 63},
  [1916] = {.lex_state = 63},
  [1917] = {.lex_state = 63},
  [1918] = {.lex_state = 63},
  [1919] = {.lex_state = 63},
  [1920] = {.lex_state = 63},
  [1921] = {.lex_state = 63},
  [1922] = {.lex_state = 63},
  [1923] = {.lex_state = 63},
  [1924] = {.lex_state = 63},
  [1925] = {.lex_state = 63},
  [1926] = {.lex_state = 63},
  [1927] = {.lex_state = 63},
  [1928] = {.lex_state = 63},
  [1929] = {.lex_state = 63},
  [1930] = {.lex_state = 63},
  [1931] = {.lex_state = 63},
  [1932] = {.lex_state = 63},
  [1933] = {.lex_state = 63},
  [1934] = {.lex_state = 63},
  [1935] = {.lex_state = 63},
  [1936] = {.lex_state = 63},
  [1937] = {.lex_state = 63},
  [1938] = {.lex_state = 63},
  [1939] = {.lex_state = 63, .external_lex_state = 4},
  [1940] = {.lex_state = 63, .external_lex_state = 4},
  [1941] = {.lex_state = 63},
  [1942] = {.lex_state = 63},
  [1943] = {.lex_state = 63},
  [1944] = {.lex_state = 63, .external_lex_state = 4},
  [1945] = {.lex_state = 63, .external_lex_state = 4},
  [1946] = {.lex_state = 63},
  [1947] = {.lex_state = 63},
  [1948] = {.lex_state = 63, .external_lex_state = 4},
  [1949] = {.lex_state = 63, .external_lex_state = 4},
  [1950] = {.lex_state = 63},
  [1951] = {.lex_state = 63},
  [1952] = {.lex_state = 63},
  [1953] = {.lex_state = 63, .external_lex_state = 4},
  [1954] = {.lex_state = 63, .external_lex_state = 4},
  [1955] = {.lex_state = 63, .external_lex_state = 4},
  [1956] = {.lex_state = 63},
  [1957] = {.lex_state = 63, .external_lex_state = 4},
  [1958] = {.lex_state = 63, .external_lex_state = 4},
  [1959] = {.lex_state = 63},
  [1960] = {.lex_state = 63},
  [1961] = {.lex_state = 63, .external_lex_state = 4},
  [1962] = {.lex_state = 63},
  [1963] = {.lex_state = 63, .external_lex_state = 4},
  [1964] = {.lex_state = 63},
  [1965] = {.lex_state = 63, .external_lex_state = 4},
  [1966] = {.lex_state = 63},
  [1967] = {.lex_state = 63, .external_lex_state = 4},
  [1968] = {.lex_state = 63, .external_lex_state = 4},
  [1969] = {.lex_state = 63},
  [1970] = {.lex_state = 63},
  [1971] = {.lex_state = 63},
  [1972] = {.lex_state = 63, .external_lex_state = 4},
  [1973] = {.lex_state = 63},
  [1974] = {.lex_state = 63},
  [1975] = {.lex_state = 63},
  [1976] = {.lex_state = 63},
  [1977] = {.lex_state = 63},
  [1978] = {.lex_state = 63},
  [1979] = {.lex_state = 63},
  [1980] = {.lex_state = 63},
  [1981] = {.lex_state = 63},
  [1982] = {.lex_state = 63},
  [1983] = {.lex_state = 63},
  [1984] = {.lex_state = 63},
  [1985] = {.lex_state = 63},
  [1986] = {.lex_state = 63},
  [1987] = {.lex_state = 63},
  [1988] = {.lex_state = 63},
  [1989] = {.lex_state = 63},
  [1990] = {.lex_state = 63},
  [1991] = {.lex_state = 63},
  [1992] = {.lex_state = 63},
  [1993] = {.lex_state = 63},
  [1994] = {.lex_state = 63},
  [1995] = {.lex_state = 63},
  [1996] = {.lex_state = 63},
  [1997] = {.lex_state = 63},
  [1998] = {.lex_state = 63},
  [1999] = {.lex_state = 63},
  [2000] = {.lex_state = 63},
  [2001] = {.lex_state = 63},
  [2002] = {.lex_state = 63},
  [2003] = {.lex_state = 63},
  [2004] = {.lex_state = 63},
  [2005] = {.lex_state = 63},
  [2006] = {.lex_state = 63},
  [2007] = {.lex_state = 63},
  [2008] = {.lex_state = 63},
  [2009] = {.lex_state = 63},
  [2010] = {.lex_state = 63},
  [2011] = {.lex_state = 63},
  [2012] = {.lex_state = 63},
  [2013] = {.lex_state = 63},
  [2014] = {.lex_state = 63},
  [2015] = {.lex_state = 63},
  [2016] = {.lex_state = 63},
  [2017] = {.lex_state = 63, .external_lex_state = 4},
  [2018] = {.lex_state = 63, .external_lex_state = 4},
  [2019] = {.lex_state = 63},
  [2020] = {.lex_state = 63, .external_lex_state = 4},
  [2021] = {.lex_state = 63},
  [2022] = {.lex_state = 63, .external_lex_state = 4},
  [2023] = {.lex_state = 63, .external_lex_state = 4},
  [2024] = {.lex_state = 63},
  [2025] = {.lex_state = 63, .external_lex_state = 4},
  [2026] = {.lex_state = 63, .external_lex_state = 4},
  [2027] = {.lex_state = 63, .external_lex_state = 4},
  [2028] = {.lex_state = 63},
  [2029] = {.lex_state = 63, .external_lex_state = 4},
  [2030] = {.lex_state = 63, .external_lex_state = 4},
  [2031] = {.lex_state = 63, .external_lex_state = 4},
  [2032] = {.lex_state = 63, .external_lex_state = 4},
  [2033] = {.lex_state = 63, .external_lex_state = 4},
  [2034] = {.lex_state = 63, .external_lex_state = 4},
  [2035] = {.lex_state = 63, .external_lex_state = 4},
  [2036] = {.lex_state = 63, .external_lex_state = 4},
  [2037] = {.lex_state = 63, .external_lex_state = 4},
  [2038] = {.lex_state = 63, .external_lex_state = 4},
  [2039] = {.lex_state = 63, .external_lex_state = 4},
  [2040] = {.lex_state = 63, .external_lex_state = 4},
  [2041] = {.lex_state = 63, .external_lex_state = 4},
  [2042] = {.lex_state = 63},
  [2043] = {.lex_state = 63, .external_lex_state = 4},
  [2044] = {.lex_state = 63, .external_lex_state = 4},
  [2045] = {.lex_state = 63, .external_lex_state = 4},
  [2046] = {.lex_state = 63, .external_lex_state = 4},
  [2047] = {.lex_state = 63, .external_lex_state = 4},
  [2048] = {.lex_state = 63},
  [2049] = {.lex_state = 63, .external_lex_state = 4},
  [2050] = {.lex_state = 63},
  [2051] = {.lex_state = 63, .external_lex_state = 4},
  [2052] = {.lex_state = 63, .external_lex_state = 4},
  [2053] = {.lex_state = 63},
  [2054] = {.lex_state = 63},
  [2055] = {.lex_state = 63, .external_lex_state = 4},
  [2056] = {.lex_state = 63, .external_lex_state = 4},
  [2057] = {.lex_state = 63},
  [2058] = {.lex_state = 63, .external_lex_state = 4},
  [2059] = {.lex_state = 63, .external_lex_state = 4},
  [2060] = {.lex_state = 63, .external_lex_state = 4},
  [2061] = {.lex_state = 63, .external_lex_state = 4},
  [2062] = {.lex_state = 63, .external_lex_state = 4},
  [2063] = {.lex_state = 63, .external_lex_state = 4},
  [2064] = {.lex_state = 63, .external_lex_state = 4},
  [2065] = {.lex_state = 63, .external_lex_state = 4},
  [2066] = {.lex_state = 63, .external_lex_state = 4},
  [2067] = {.lex_state = 63, .external_lex_state = 4},
  [2068] = {.lex_state = 63, .external_lex_state = 4},
  [2069] = {.lex_state = 63, .external_lex_state = 4},
  [2070] = {.lex_state = 63, .external_lex_state = 4},
  [2071] = {.lex_state = 63, .external_lex_state = 4},
  [2072] = {.lex_state = 63, .external_lex_state = 4},
  [2073] = {.lex_state = 63, .external_lex_state = 4},
  [2074] = {.lex_state = 63, .external_lex_state = 4},
  [2075] = {.lex_state = 63, .external_lex_state = 4},
  [2076] = {.lex_state = 63},
  [2077] = {.lex_state = 63, .external_lex_state = 4},
  [2078] = {.lex_state = 63, .external_lex_state = 4},
  [2079] = {.lex_state = 63, .external_lex_state = 4},
  [2080] = {.lex_state = 63, .external_lex_state = 4},
  [2081] = {.lex_state = 63, .external_lex_state = 4},
  [2082] = {.lex_state = 63, .external_lex_state = 4},
  [2083] = {.lex_state = 63, .external_lex_state = 4},
  [2084] = {.lex_state = 63, .external_lex_state = 4},
  [2085] = {.lex_state = 63, .external_lex_state = 4},
  [2086] = {.lex_state = 63, .external_lex_state = 4},
  [2087] = {.lex_state = 63},
  [2088] = {.lex_state = 63},
  [2089] = {.lex_state = 63, .external_lex_state = 4},
  [2090] = {.lex_state = 63, .external_lex_state = 4},
  [2091] = {.lex_state = 63, .external_lex_state = 4},
  [2092] = {.lex_state = 63, .external_lex_state = 4},
  [2093] = {.lex_state = 63},
  [2094] = {.lex_state = 63, .external_lex_state = 4},
  [2095] = {.lex_state = 63},
  [2096] = {.lex_state = 63, .external_lex_state = 4},
  [2097] = {.lex_state = 63, .external_lex_state = 4},
  [2098] = {.lex_state = 63},
  [2099] = {.lex_state = 63, .external_lex_state = 4},
  [2100] = {.lex_state = 63, .external_lex_state = 4},
  [2101] = {.lex_state = 63, .external_lex_state = 4},
  [2102] = {.lex_state = 63, .external_lex_state = 4},
  [2103] = {.lex_state = 63, .external_lex_state = 4},
  [2104] = {.lex_state = 63, .external_lex_state = 4},
  [2105] = {.lex_state = 63},
  [2106] = {.lex_state = 63, .external_lex_state = 4},
  [2107] = {.lex_state = 63},
  [2108] = {.lex_state = 63, .external_lex_state = 4},
  [2109] = {.lex_state = 63, .external_lex_state = 4},
  [2110] = {.lex_state = 63, .external_lex_state = 4},
  [2111] = {.lex_state = 63},
  [2112] = {.lex_state = 63},
  [2113] = {.lex_state = 63},
  [2114] = {.lex_state = 63},
  [2115] = {.lex_state = 63},
  [2116] = {.lex_state = 63},
  [2117] = {.lex_state = 63},
  [2118] = {.lex_state = 63, .external_lex_state = 4},
  [2119] = {.lex_state = 63},
  [2120] = {.lex_state = 63},
  [2121] = {.lex_state = 63},
  [2122] = {.lex_state = 63},
  [2123] = {.lex_state = 63},
  [2124] = {.lex_state = 63},
  [2125] = {.lex_state = 63},
  [2126] = {.lex_state = 63},
  [2127] = {.lex_state = 63},
  [2128] = {.lex_state = 63},
  [2129] = {.lex_state = 63},
  [2130] = {.lex_state = 63, .external_lex_state = 4},
  [2131] = {.lex_state = 63},
  [2132] = {.lex_state = 63, .external_lex_state = 4},
  [2133] = {.lex_state = 63, .external_lex_state = 4},
  [2134] = {.lex_state = 63},
  [2135] = {.lex_state = 63},
  [2136] = {.lex_state = 63, .external_lex_state = 4},
  [2137] = {.lex_state = 63, .external_lex_state = 4},
  [2138] = {.lex_state = 63},
  [2139] = {.lex_state = 63},
  [2140] = {.lex_state = 63},
  [2141] = {.lex_state = 63},
  [2142] = {.lex_state = 63},
  [2143] = {.lex_state = 63},
  [2144] = {.lex_state = 63},
  [2145] = {.lex_state = 63},
  [2146] = {.lex_state = 63, .external_lex_state = 4},
  [2147] = {.lex_state = 63},
  [2148] = {.lex_state = 63, .external_lex_state = 4},
  [2149] = {.lex_state = 63},
  [2150] = {.lex_state = 63},
  [2151] = {.lex_state = 63},
  [2152] = {.lex_state = 63},
  [2153] = {.lex_state = 63},
  [2154] = {.lex_state = 63, .external_lex_state = 4},
  [2155] = {.lex_state = 63, .external_lex_state = 4},
  [2156] = {.lex_state = 0, .external_lex_state = 4},
  [2157] = {.lex_state = 63},
  [2158] = {.lex_state = 63, .external_lex_state = 4},
  [2159] = {.lex_state = 63},
  [2160] = {.lex_state = 0, .external_lex_state = 4},
  [2161] = {.lex_state = 63},
  [2162] = {.lex_state = 63},
  [2163] = {.lex_state = 63},
  [2164] = {.lex_state = 63},
  [2165] = {.lex_state = 63},
  [2166] = {.lex_state = 63},
  [2167] = {.lex_state = 63},
  [2168] = {.lex_state = 14},
  [2169] = {.lex_state = 63},
  [2170] = {.lex_state = 63},
  [2171] = {.lex_state = 0, .external_lex_state = 4},
  [2172] = {.lex_state = 63},
  [2173] = {.lex_state = 63},
  [2174] = {.lex_state = 63, .external_lex_state = 4},
  [2175] = {.lex_state = 63},
  [2176] = {.lex_state = 0, .external_lex_state = 4},
  [2177] = {.lex_state = 0, .external_lex_state = 4},
  [2178] = {.lex_state = 63},
  [2179] = {.lex_state = 63},
  [2180] = {.lex_state = 63},
  [2181] = {.lex_state = 63},
  [2182] = {.lex_state = 63, .external_lex_state = 4},
  [2183] = {.lex_state = 14},
  [2184] = {.lex_state = 63},
  [2185] = {.lex_state = 0, .external_lex_state = 4},
  [2186] = {.lex_state = 63},
  [2187] = {.lex_state = 0, .external_lex_state = 4},
  [2188] = {.lex_state = 63},
  [2189] = {.lex_state = 63},
  [2190] = {.lex_state = 63, .external_lex_state = 4},
  [2191] = {.lex_state = 63},
  [2192] = {.lex_state = 0, .external_lex_state = 4},
  [2193] = {.lex_state = 63, .external_lex_state = 4},
  [2194] = {.lex_state = 63, .external_lex_state = 4},
  [2195] = {.lex_state = 63, .external_lex_state = 4},
  [2196] = {.lex_state = 63, .external_lex_state = 4},
  [2197] = {.lex_state = 63},
  [2198] = {.lex_state = 63, .external_lex_state = 4},
  [2199] = {.lex_state = 63, .external_lex_state = 4},
  [2200] = {.lex_state = 63, .external_lex_state = 4},
  [2201] = {.lex_state = 63},
  [2202] = {.lex_state = 63, .external_lex_state = 4},
  [2203] = {.lex_state = 63},
  [2204] = {.lex_state = 63},
  [2205] = {.lex_state = 63},
  [2206] = {.lex_state = 63, .external_lex_state = 4},
  [2207] = {.lex_state = 63, .external_lex_state = 4},
  [2208] = {.lex_state = 63},
  [2209] = {.lex_state = 63, .external_lex_state = 4},
  [2210] = {.lex_state = 63},
  [2211] = {.lex_state = 63},
  [2212] = {.lex_state = 63},
  [2213] = {.lex_state = 63},
  [2214] = {.lex_state = 63},
  [2215] = {.lex_state = 0, .external_lex_state = 4},
  [2216] = {.lex_state = 63},
  [2217] = {.lex_state = 63},
  [2218] = {.lex_state = 63},
  [2219] = {.lex_state = 0, .external_lex_state = 4},
  [2220] = {.lex_state = 0, .external_lex_state = 4},
  [2221] = {.lex_state = 63},
  [2222] = {.lex_state = 63},
  [2223] = {.lex_state = 63},
  [2224] = {.lex_state = 63},
  [2225] = {.lex_state = 63},
  [2226] = {.lex_state = 63},
  [2227] = {.lex_state = 63},
  [2228] = {.lex_state = 18, .external_lex_state = 5},
  [2229] = {.lex_state = 63},
  [2230] = {.lex_state = 0, .external_lex_state = 4},
  [2231] = {.lex_state = 0, .external_lex_state = 4},
  [2232] = {.lex_state = 63},
  [2233] = {.lex_state = 63},
  [2234] = {.lex_state = 63},
  [2235] = {.lex_state = 63},
  [2236] = {.lex_state = 63},
  [2237] = {.lex_state = 63},
  [2238] = {.lex_state = 63},
  [2239] = {.lex_state = 0, .external_lex_state = 4},
  [2240] = {.lex_state = 18, .external_lex_state = 5},
  [2241] = {.lex_state = 63},
  [2242] = {.lex_state = 63},
  [2243] = {.lex_state = 18, .external_lex_state = 5},
  [2244] = {.lex_state = 63},
  [2245] = {.lex_state = 0, .external_lex_state = 4},
  [2246] = {.lex_state = 63},
  [2247] = {.lex_state = 0, .external_lex_state = 4},
  [2248] = {.lex_state = 63},
  [2249] = {.lex_state = 0, .external_lex_state = 4},
  [2250] = {.lex_state = 0, .external_lex_state = 4},
  [2251] = {.lex_state = 0, .external_lex_state = 4},
  [2252] = {.lex_state = 63},
  [2253] = {.lex_state = 63},
  [2254] = {.lex_state = 63},
  [2255] = {.lex_state = 63},
  [2256] = {.lex_state = 18, .external_lex_state = 5},
  [2257] = {.lex_state = 63},
  [2258] = {.lex_state = 63},
  [2259] = {.lex_state = 63},
  [2260] = {.lex_state = 63},
  [2261] = {.lex_state = 63},
  [2262] = {.lex_state = 63},
  [2263] = {.lex_state = 63},
  [2264] = {.lex_state = 63},
  [2265] = {.lex_state = 63},
  [2266] = {.lex_state = 0, .external_lex_state = 4},
  [2267] = {.lex_state = 0, .external_lex_state = 4},
  [2268] = {.lex_state = 63, .external_lex_state = 4},
  [2269] = {.lex_state = 63},
  [2270] = {.lex_state = 18, .external_lex_state = 5},
  [2271] = {.lex_state = 63},
  [2272] = {.lex_state = 63},
  [2273] = {.lex_state = 63},
  [2274] = {.lex_state = 18, .external_lex_state = 5},
  [2275] = {.lex_state = 0, .external_lex_state = 4},
  [2276] = {.lex_state = 0, .external_lex_state = 4},
  [2277] = {.lex_state = 63},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 0},
  [2280] = {.lex_state = 0, .external_lex_state = 4},
  [2281] = {.lex_state = 63},
  [2282] = {.lex_state = 63},
  [2283] = {.lex_state = 63},
  [2284] = {.lex_state = 14},
  [2285] = {.lex_state = 18, .external_lex_state = 5},
  [2286] = {.lex_state = 0, .external_lex_state = 4},
  [2287] = {.lex_state = 63},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 63},
  [2290] = {.lex_state = 63},
  [2291] = {.lex_state = 0, .external_lex_state = 4},
  [2292] = {.lex_state = 63},
  [2293] = {.lex_state = 63},
  [2294] = {.lex_state = 63},
  [2295] = {.lex_state = 0, .external_lex_state = 4},
  [2296] = {.lex_state = 63, .external_lex_state = 4},
  [2297] = {.lex_state = 63},
  [2298] = {.lex_state = 0, .external_lex_state = 4},
  [2299] = {.lex_state = 63},
  [2300] = {.lex_state = 0, .external_lex_state = 4},
  [2301] = {.lex_state = 0, .external_lex_state = 4},
  [2302] = {.lex_state = 63},
  [2303] = {.lex_state = 63},
  [2304] = {.lex_state = 63},
  [2305] = {.lex_state = 63},
  [2306] = {.lex_state = 0},
  [2307] = {.lex_state = 63},
  [2308] = {.lex_state = 63},
  [2309] = {.lex_state = 63},
  [2310] = {.lex_state = 63},
  [2311] = {.lex_state = 63},
  [2312] = {.lex_state = 63},
  [2313] = {.lex_state = 63},
  [2314] = {.lex_state = 63},
  [2315] = {.lex_state = 0, .external_lex_state = 4},
  [2316] = {.lex_state = 63},
  [2317] = {.lex_state = 0, .external_lex_state = 4},
  [2318] = {.lex_state = 63},
  [2319] = {.lex_state = 63},
  [2320] = {.lex_state = 0, .external_lex_state = 4},
  [2321] = {.lex_state = 63},
  [2322] = {.lex_state = 0, .external_lex_state = 4},
  [2323] = {.lex_state = 0, .external_lex_state = 4},
  [2324] = {.lex_state = 63},
  [2325] = {.lex_state = 63},
  [2326] = {.lex_state = 63},
  [2327] = {.lex_state = 63},
  [2328] = {.lex_state = 63},
  [2329] = {.lex_state = 63},
  [2330] = {.lex_state = 0, .external_lex_state = 4},
  [2331] = {.lex_state = 63},
  [2332] = {.lex_state = 0, .external_lex_state = 4},
  [2333] = {.lex_state = 63},
  [2334] = {.lex_state = 63},
  [2335] = {.lex_state = 0, .external_lex_state = 4},
  [2336] = {.lex_state = 63},
  [2337] = {.lex_state = 0, .external_lex_state = 4},
  [2338] = {.lex_state = 0, .external_lex_state = 4},
  [2339] = {.lex_state = 0, .external_lex_state = 4},
  [2340] = {.lex_state = 0, .external_lex_state = 4},
  [2341] = {.lex_state = 63},
  [2342] = {.lex_state = 63},
  [2343] = {.lex_state = 63},
  [2344] = {.lex_state = 63},
  [2345] = {.lex_state = 0, .external_lex_state = 4},
  [2346] = {.lex_state = 7},
  [2347] = {.lex_state = 0, .external_lex_state = 4},
  [2348] = {.lex_state = 63},
  [2349] = {.lex_state = 0, .external_lex_state = 4},
  [2350] = {.lex_state = 63},
  [2351] = {.lex_state = 0, .external_lex_state = 4},
  [2352] = {.lex_state = 0, .external_lex_state = 4},
  [2353] = {.lex_state = 0, .external_lex_state = 4},
  [2354] = {.lex_state = 0, .external_lex_state = 4},
  [2355] = {.lex_state = 0, .external_lex_state = 4},
  [2356] = {.lex_state = 63},
  [2357] = {.lex_state = 63},
  [2358] = {.lex_state = 63},
  [2359] = {.lex_state = 0, .external_lex_state = 4},
  [2360] = {.lex_state = 63},
  [2361] = {.lex_state = 0, .external_lex_state = 4},
  [2362] = {.lex_state = 0, .external_lex_state = 4},
  [2363] = {.lex_state = 0, .external_lex_state = 4},
  [2364] = {.lex_state = 63},
  [2365] = {.lex_state = 63, .external_lex_state = 4},
  [2366] = {.lex_state = 63},
  [2367] = {.lex_state = 63},
  [2368] = {.lex_state = 7},
  [2369] = {.lex_state = 0, .external_lex_state = 4},
  [2370] = {.lex_state = 0, .external_lex_state = 4},
  [2371] = {.lex_state = 0, .external_lex_state = 4},
  [2372] = {.lex_state = 0, .external_lex_state = 4},
  [2373] = {.lex_state = 63},
  [2374] = {.lex_state = 63},
  [2375] = {.lex_state = 14},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 0, .external_lex_state = 4},
  [2378] = {.lex_state = 63, .external_lex_state = 4},
  [2379] = {.lex_state = 63},
  [2380] = {.lex_state = 0, .external_lex_state = 4},
  [2381] = {.lex_state = 63},
  [2382] = {.lex_state = 0, .external_lex_state = 4},
  [2383] = {.lex_state = 63},
  [2384] = {.lex_state = 0, .external_lex_state = 4},
  [2385] = {.lex_state = 0, .external_lex_state = 4},
  [2386] = {.lex_state = 0, .external_lex_state = 4},
  [2387] = {.lex_state = 0, .external_lex_state = 4},
  [2388] = {.lex_state = 0, .external_lex_state = 4},
  [2389] = {.lex_state = 0, .external_lex_state = 4},
  [2390] = {.lex_state = 0, .external_lex_state = 4},
  [2391] = {.lex_state = 0, .external_lex_state = 4},
  [2392] = {.lex_state = 0, .external_lex_state = 4},
  [2393] = {.lex_state = 63},
  [2394] = {.lex_state = 63},
  [2395] = {.lex_state = 63, .external_lex_state = 4},
  [2396] = {.lex_state = 0, .external_lex_state = 4},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 0, .external_lex_state = 4},
  [2399] = {.lex_state = 63, .external_lex_state = 4},
  [2400] = {.lex_state = 0, .external_lex_state = 4},
  [2401] = {.lex_state = 0, .external_lex_state = 4},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 0, .external_lex_state = 4},
  [2404] = {.lex_state = 0, .external_lex_state = 4},
  [2405] = {.lex_state = 0, .external_lex_state = 4},
  [2406] = {.lex_state = 0, .external_lex_state = 4},
  [2407] = {.lex_state = 63},
  [2408] = {.lex_state = 63},
  [2409] = {.lex_state = 63},
  [2410] = {.lex_state = 63},
  [2411] = {.lex_state = 0, .external_lex_state = 4},
  [2412] = {.lex_state = 63},
  [2413] = {.lex_state = 63},
  [2414] = {.lex_state = 0, .external_lex_state = 4},
  [2415] = {.lex_state = 0, .external_lex_state = 4},
  [2416] = {.lex_state = 63},
  [2417] = {.lex_state = 63},
  [2418] = {.lex_state = 0, .external_lex_state = 4},
  [2419] = {.lex_state = 63},
  [2420] = {.lex_state = 63},
  [2421] = {.lex_state = 63},
  [2422] = {.lex_state = 0, .external_lex_state = 4},
  [2423] = {.lex_state = 63},
  [2424] = {.lex_state = 63},
  [2425] = {.lex_state = 0, .external_lex_state = 4},
  [2426] = {.lex_state = 0, .external_lex_state = 4},
  [2427] = {.lex_state = 0, .external_lex_state = 4},
  [2428] = {.lex_state = 63},
  [2429] = {.lex_state = 63},
  [2430] = {.lex_state = 0, .external_lex_state = 4},
  [2431] = {.lex_state = 0, .external_lex_state = 4},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 63},
  [2434] = {.lex_state = 0, .external_lex_state = 4},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 0, .external_lex_state = 4},
  [2437] = {.lex_state = 63},
  [2438] = {.lex_state = 63},
  [2439] = {.lex_state = 0, .external_lex_state = 4},
  [2440] = {.lex_state = 14},
  [2441] = {.lex_state = 0, .external_lex_state = 4},
  [2442] = {.lex_state = 0, .external_lex_state = 4},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 63},
  [2445] = {.lex_state = 0, .external_lex_state = 4},
  [2446] = {.lex_state = 0, .external_lex_state = 4},
  [2447] = {.lex_state = 0, .external_lex_state = 4},
  [2448] = {.lex_state = 63},
  [2449] = {.lex_state = 0, .external_lex_state = 4},
  [2450] = {.lex_state = 63},
  [2451] = {.lex_state = 63},
  [2452] = {.lex_state = 63},
  [2453] = {.lex_state = 0, .external_lex_state = 4},
  [2454] = {.lex_state = 63},
  [2455] = {.lex_state = 0, .external_lex_state = 4},
  [2456] = {.lex_state = 63},
  [2457] = {.lex_state = 63},
  [2458] = {.lex_state = 63},
  [2459] = {.lex_state = 0, .external_lex_state = 4},
  [2460] = {.lex_state = 63},
  [2461] = {.lex_state = 63},
  [2462] = {.lex_state = 63},
  [2463] = {.lex_state = 0, .external_lex_state = 4},
  [2464] = {.lex_state = 0, .external_lex_state = 4},
  [2465] = {.lex_state = 63},
  [2466] = {.lex_state = 63, .external_lex_state = 4},
  [2467] = {.lex_state = 63},
  [2468] = {.lex_state = 63, .external_lex_state = 4},
  [2469] = {.lex_state = 0, .external_lex_state = 4},
  [2470] = {.lex_state = 0, .external_lex_state = 4},
  [2471] = {.lex_state = 63},
  [2472] = {.lex_state = 63},
  [2473] = {.lex_state = 63, .external_lex_state = 4},
  [2474] = {.lex_state = 63},
  [2475] = {.lex_state = 0, .external_lex_state = 4},
  [2476] = {.lex_state = 63, .external_lex_state = 4},
  [2477] = {.lex_state = 0, .external_lex_state = 4},
  [2478] = {.lex_state = 0, .external_lex_state = 4},
  [2479] = {.lex_state = 0, .external_lex_state = 4},
  [2480] = {.lex_state = 63, .external_lex_state = 4},
  [2481] = {.lex_state = 63},
  [2482] = {.lex_state = 63},
  [2483] = {.lex_state = 63},
  [2484] = {.lex_state = 0, .external_lex_state = 4},
  [2485] = {.lex_state = 63, .external_lex_state = 4},
  [2486] = {.lex_state = 0, .external_lex_state = 4},
  [2487] = {.lex_state = 63},
  [2488] = {.lex_state = 63, .external_lex_state = 4},
  [2489] = {.lex_state = 0, .external_lex_state = 4},
  [2490] = {.lex_state = 63},
  [2491] = {.lex_state = 0},
  [2492] = {.lex_state = 0, .external_lex_state = 4},
  [2493] = {.lex_state = 63, .external_lex_state = 4},
  [2494] = {.lex_state = 63},
  [2495] = {.lex_state = 0, .external_lex_state = 4},
  [2496] = {.lex_state = 0, .external_lex_state = 4},
  [2497] = {.lex_state = 0, .external_lex_state = 4},
  [2498] = {.lex_state = 63},
  [2499] = {.lex_state = 63},
  [2500] = {.lex_state = 63},
  [2501] = {.lex_state = 63},
  [2502] = {.lex_state = 63},
  [2503] = {.lex_state = 63},
  [2504] = {.lex_state = 63},
  [2505] = {.lex_state = 0, .external_lex_state = 4},
  [2506] = {.lex_state = 63},
  [2507] = {.lex_state = 0, .external_lex_state = 4},
  [2508] = {.lex_state = 63},
  [2509] = {.lex_state = 0, .external_lex_state = 4},
  [2510] = {.lex_state = 0, .external_lex_state = 4},
  [2511] = {.lex_state = 63},
  [2512] = {.lex_state = 63},
  [2513] = {.lex_state = 63},
  [2514] = {.lex_state = 1},
  [2515] = {.lex_state = 0, .external_lex_state = 4},
  [2516] = {.lex_state = 3},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 63},
  [2519] = {.lex_state = 63, .external_lex_state = 4},
  [2520] = {.lex_state = 63, .external_lex_state = 4},
  [2521] = {.lex_state = 63},
  [2522] = {.lex_state = 63, .external_lex_state = 4},
  [2523] = {.lex_state = 63, .external_lex_state = 4},
  [2524] = {.lex_state = 63, .external_lex_state = 4},
  [2525] = {.lex_state = 63, .external_lex_state = 4},
  [2526] = {.lex_state = 63},
  [2527] = {.lex_state = 63},
  [2528] = {.lex_state = 0},
  [2529] = {.lex_state = 63},
  [2530] = {.lex_state = 1},
  [2531] = {.lex_state = 3},
  [2532] = {.lex_state = 1},
  [2533] = {.lex_state = 63},
  [2534] = {.lex_state = 63, .external_lex_state = 4},
  [2535] = {.lex_state = 63, .external_lex_state = 4},
  [2536] = {.lex_state = 3},
  [2537] = {.lex_state = 63},
  [2538] = {.lex_state = 63, .external_lex_state = 4},
  [2539] = {.lex_state = 63},
  [2540] = {.lex_state = 0},
  [2541] = {.lex_state = 63},
  [2542] = {.lex_state = 0, .external_lex_state = 4},
  [2543] = {.lex_state = 63},
  [2544] = {.lex_state = 63, .external_lex_state = 4},
  [2545] = {.lex_state = 63},
  [2546] = {.lex_state = 63},
  [2547] = {.lex_state = 0},
  [2548] = {.lex_state = 63},
  [2549] = {.lex_state = 0, .external_lex_state = 4},
  [2550] = {.lex_state = 0},
  [2551] = {.lex_state = 3},
  [2552] = {.lex_state = 1},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 63},
  [2555] = {.lex_state = 0},
  [2556] = {.lex_state = 1},
  [2557] = {.lex_state = 3},
  [2558] = {.lex_state = 63, .external_lex_state = 4},
  [2559] = {.lex_state = 0, .external_lex_state = 4},
  [2560] = {.lex_state = 0, .external_lex_state = 4},
  [2561] = {.lex_state = 3},
  [2562] = {.lex_state = 1},
  [2563] = {.lex_state = 0, .external_lex_state = 4},
  [2564] = {.lex_state = 63},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 0, .external_lex_state = 4},
  [2567] = {.lex_state = 0},
  [2568] = {.lex_state = 1},
  [2569] = {.lex_state = 3},
  [2570] = {.lex_state = 63},
  [2571] = {.lex_state = 0},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 18, .external_lex_state = 5},
  [2574] = {.lex_state = 63},
  [2575] = {.lex_state = 63},
  [2576] = {.lex_state = 63},
  [2577] = {.lex_state = 63},
  [2578] = {.lex_state = 63},
  [2579] = {.lex_state = 63},
  [2580] = {.lex_state = 63},
  [2581] = {.lex_state = 63, .external_lex_state = 4},
  [2582] = {.lex_state = 1},
  [2583] = {.lex_state = 63},
  [2584] = {.lex_state = 1},
  [2585] = {.lex_state = 3},
  [2586] = {.lex_state = 63},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 1},
  [2589] = {.lex_state = 63},
  [2590] = {.lex_state = 63},
  [2591] = {.lex_state = 3},
  [2592] = {.lex_state = 63},
  [2593] = {.lex_state = 3},
  [2594] = {.lex_state = 1},
  [2595] = {.lex_state = 3},
  [2596] = {.lex_state = 63},
  [2597] = {.lex_state = 1},
  [2598] = {.lex_state = 1},
  [2599] = {.lex_state = 63},
  [2600] = {.lex_state = 3},
  [2601] = {.lex_state = 63},
  [2602] = {.lex_state = 63, .external_lex_state = 4},
  [2603] = {.lex_state = 0, .external_lex_state = 4},
  [2604] = {.lex_state = 63, .external_lex_state = 4},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 63},
  [2607] = {.lex_state = 3},
  [2608] = {.lex_state = 63},
  [2609] = {.lex_state = 0, .external_lex_state = 4},
  [2610] = {.lex_state = 63},
  [2611] = {.lex_state = 0, .external_lex_state = 4},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 0},
  [2614] = {.lex_state = 63},
  [2615] = {.lex_state = 0},
  [2616] = {.lex_state = 0, .external_lex_state = 4},
  [2617] = {.lex_state = 0},
  [2618] = {.lex_state = 0},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 0},
  [2621] = {.lex_state = 63},
  [2622] = {.lex_state = 63},
  [2623] = {.lex_state = 63},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 0},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 63},
  [2628] = {.lex_state = 63},
  [2629] = {.lex_state = 0},
  [2630] = {.lex_state = 0},
  [2631] = {.lex_state = 0},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 63},
  [2634] = {.lex_state = 0},
  [2635] = {.lex_state = 0},
  [2636] = {.lex_state = 63},
  [2637] = {.lex_state = 0},
  [2638] = {.lex_state = 63},
  [2639] = {.lex_state = 63},
  [2640] = {.lex_state = 63},
  [2641] = {.lex_state = 7},
  [2642] = {.lex_state = 0, .external_lex_state = 4},
  [2643] = {.lex_state = 63},
  [2644] = {.lex_state = 0, .external_lex_state = 4},
  [2645] = {.lex_state = 63},
  [2646] = {.lex_state = 63},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 0},
  [2649] = {.lex_state = 0, .external_lex_state = 4},
  [2650] = {.lex_state = 63},
  [2651] = {.lex_state = 0},
  [2652] = {.lex_state = 63},
  [2653] = {.lex_state = 0, .external_lex_state = 4},
  [2654] = {.lex_state = 0},
  [2655] = {.lex_state = 0},
  [2656] = {.lex_state = 0},
  [2657] = {.lex_state = 0, .external_lex_state = 4},
  [2658] = {.lex_state = 63},
  [2659] = {.lex_state = 0, .external_lex_state = 4},
  [2660] = {.lex_state = 0, .external_lex_state = 4},
  [2661] = {.lex_state = 0},
  [2662] = {.lex_state = 0},
  [2663] = {.lex_state = 0, .external_lex_state = 4},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 0},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 63},
  [2669] = {.lex_state = 0},
  [2670] = {.lex_state = 0},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 0, .external_lex_state = 4},
  [2674] = {.lex_state = 63},
  [2675] = {.lex_state = 0, .external_lex_state = 4},
  [2676] = {.lex_state = 0},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 0},
  [2679] = {.lex_state = 63},
  [2680] = {.lex_state = 63},
  [2681] = {.lex_state = 0},
  [2682] = {.lex_state = 63},
  [2683] = {.lex_state = 7},
  [2684] = {.lex_state = 0},
  [2685] = {.lex_state = 0},
  [2686] = {.lex_state = 0},
  [2687] = {.lex_state = 63},
  [2688] = {.lex_state = 63, .external_lex_state = 4},
  [2689] = {.lex_state = 63},
  [2690] = {.lex_state = 63},
  [2691] = {.lex_state = 63, .external_lex_state = 4},
  [2692] = {.lex_state = 0, .external_lex_state = 4},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 0},
  [2695] = {.lex_state = 63},
  [2696] = {.lex_state = 63},
  [2697] = {.lex_state = 0},
  [2698] = {.lex_state = 0, .external_lex_state = 4},
  [2699] = {.lex_state = 63},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 63},
  [2702] = {.lex_state = 0},
  [2703] = {.lex_state = 0, .external_lex_state = 4},
  [2704] = {.lex_state = 0},
  [2705] = {.lex_state = 0, .external_lex_state = 4},
  [2706] = {.lex_state = 63},
  [2707] = {.lex_state = 0},
  [2708] = {.lex_state = 0},
  [2709] = {.lex_state = 0},
  [2710] = {.lex_state = 0},
  [2711] = {.lex_state = 7},
  [2712] = {.lex_state = 0},
  [2713] = {.lex_state = 0},
  [2714] = {.lex_state = 0},
  [2715] = {.lex_state = 63},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0, .external_lex_state = 4},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 0, .external_lex_state = 4},
  [2723] = {.lex_state = 63},
  [2724] = {.lex_state = 0, .external_lex_state = 4},
  [2725] = {.lex_state = 0, .external_lex_state = 4},
  [2726] = {.lex_state = 0, .external_lex_state = 4},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 0},
  [2729] = {.lex_state = 63},
  [2730] = {.lex_state = 63},
  [2731] = {.lex_state = 0},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 63},
  [2735] = {.lex_state = 0, .external_lex_state = 4},
  [2736] = {.lex_state = 63},
  [2737] = {.lex_state = 63},
  [2738] = {.lex_state = 0},
  [2739] = {.lex_state = 0, .external_lex_state = 4},
  [2740] = {.lex_state = 63, .external_lex_state = 4},
  [2741] = {.lex_state = 0, .external_lex_state = 4},
  [2742] = {.lex_state = 63},
  [2743] = {.lex_state = 0, .external_lex_state = 4},
  [2744] = {.lex_state = 0},
  [2745] = {.lex_state = 0, .external_lex_state = 4},
  [2746] = {.lex_state = 0, .external_lex_state = 4},
  [2747] = {.lex_state = 0},
  [2748] = {.lex_state = 63, .external_lex_state = 4},
  [2749] = {.lex_state = 0, .external_lex_state = 4},
  [2750] = {.lex_state = 0},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 63},
  [2755] = {.lex_state = 0},
  [2756] = {.lex_state = 0},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 63},
  [2759] = {.lex_state = 63},
  [2760] = {.lex_state = 0},
  [2761] = {.lex_state = 0},
  [2762] = {.lex_state = 0, .external_lex_state = 4},
  [2763] = {.lex_state = 0},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 63},
  [2766] = {.lex_state = 0},
  [2767] = {.lex_state = 0, .external_lex_state = 4},
  [2768] = {.lex_state = 0},
  [2769] = {.lex_state = 0},
  [2770] = {.lex_state = 0},
  [2771] = {.lex_state = 0},
  [2772] = {.lex_state = 63, .external_lex_state = 4},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 63},
  [2775] = {.lex_state = 0},
  [2776] = {.lex_state = 0},
  [2777] = {.lex_state = 63, .external_lex_state = 4},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 63},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 0},
  [2782] = {.lex_state = 0, .external_lex_state = 4},
  [2783] = {.lex_state = 0, .external_lex_state = 4},
  [2784] = {.lex_state = 63, .external_lex_state = 4},
  [2785] = {.lex_state = 0},
  [2786] = {.lex_state = 0},
  [2787] = {.lex_state = 0},
  [2788] = {.lex_state = 0},
  [2789] = {.lex_state = 0},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 63},
  [2792] = {.lex_state = 63},
  [2793] = {.lex_state = 63},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 0, .external_lex_state = 4},
  [2796] = {.lex_state = 63},
  [2797] = {.lex_state = 63},
  [2798] = {.lex_state = 63},
  [2799] = {.lex_state = 63},
  [2800] = {.lex_state = 63},
  [2801] = {.lex_state = 0, .external_lex_state = 4},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 63},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 0},
  [2806] = {.lex_state = 63},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 0},
  [2809] = {.lex_state = 63},
  [2810] = {.lex_state = 0},
  [2811] = {.lex_state = 63},
  [2812] = {.lex_state = 63},
  [2813] = {.lex_state = 63},
  [2814] = {.lex_state = 0},
  [2815] = {.lex_state = 0, .external_lex_state = 4},
  [2816] = {.lex_state = 0, .external_lex_state = 4},
  [2817] = {.lex_state = 63},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 63},
  [2820] = {.lex_state = 0, .external_lex_state = 4},
  [2821] = {.lex_state = 0, .external_lex_state = 4},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 63},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 63},
  [2826] = {.lex_state = 0},
  [2827] = {.lex_state = 0},
  [2828] = {.lex_state = 0},
  [2829] = {.lex_state = 0, .external_lex_state = 4},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 63},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 0, .external_lex_state = 4},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 0},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 63},
  [2840] = {.lex_state = 0, .external_lex_state = 4},
  [2841] = {.lex_state = 0, .external_lex_state = 4},
  [2842] = {.lex_state = 63},
  [2843] = {.lex_state = 63},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 63},
  [2847] = {.lex_state = 63},
  [2848] = {.lex_state = 63},
  [2849] = {.lex_state = 63},
  [2850] = {.lex_state = 0},
  [2851] = {.lex_state = 63},
  [2852] = {.lex_state = 0},
  [2853] = {.lex_state = 63},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 0},
  [2856] = {.lex_state = 0},
  [2857] = {.lex_state = 0},
  [2858] = {.lex_state = 63},
  [2859] = {.lex_state = 63},
  [2860] = {.lex_state = 63},
  [2861] = {.lex_state = 63},
  [2862] = {.lex_state = 0, .external_lex_state = 4},
  [2863] = {.lex_state = 63},
  [2864] = {.lex_state = 0},
  [2865] = {.lex_state = 0, .external_lex_state = 4},
  [2866] = {.lex_state = 63},
  [2867] = {.lex_state = 63},
  [2868] = {.lex_state = 63},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 63},
  [2871] = {.lex_state = 63},
  [2872] = {.lex_state = 0, .external_lex_state = 4},
  [2873] = {.lex_state = 0, .external_lex_state = 4},
  [2874] = {.lex_state = 0, .external_lex_state = 4},
  [2875] = {.lex_state = 63},
  [2876] = {.lex_state = 0, .external_lex_state = 4},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 63},
  [2879] = {.lex_state = 63},
  [2880] = {.lex_state = 63},
  [2881] = {.lex_state = 63},
  [2882] = {.lex_state = 63},
  [2883] = {.lex_state = 63},
  [2884] = {.lex_state = 63},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 63},
  [2887] = {.lex_state = 63},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 63},
  [2891] = {.lex_state = 63},
  [2892] = {.lex_state = 63},
  [2893] = {.lex_state = 63},
  [2894] = {.lex_state = 0, .external_lex_state = 4},
  [2895] = {.lex_state = 63},
  [2896] = {.lex_state = 63},
  [2897] = {.lex_state = 63},
  [2898] = {.lex_state = 63},
  [2899] = {.lex_state = 63},
  [2900] = {.lex_state = 0},
  [2901] = {.lex_state = 63},
  [2902] = {.lex_state = 63},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 63},
  [2905] = {.lex_state = 63},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 63},
  [2908] = {.lex_state = 63},
  [2909] = {.lex_state = 63},
  [2910] = {.lex_state = 63},
  [2911] = {.lex_state = 63},
  [2912] = {.lex_state = 63},
  [2913] = {.lex_state = 63},
  [2914] = {.lex_state = 0},
  [2915] = {.lex_state = 63},
  [2916] = {.lex_state = 63},
  [2917] = {.lex_state = 0, .external_lex_state = 4},
  [2918] = {.lex_state = 63},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 63},
  [2921] = {.lex_state = 63},
  [2922] = {.lex_state = 63},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 63},
  [2925] = {.lex_state = 63},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 63},
  [2929] = {.lex_state = 63},
  [2930] = {.lex_state = 63},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 63},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 63},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 63},
  [2937] = {.lex_state = 63},
  [2938] = {.lex_state = 63},
  [2939] = {.lex_state = 0},
  [2940] = {.lex_state = 63},
  [2941] = {.lex_state = 63},
  [2942] = {.lex_state = 63},
  [2943] = {.lex_state = 63},
  [2944] = {.lex_state = 63},
  [2945] = {.lex_state = 63},
  [2946] = {.lex_state = 63},
  [2947] = {.lex_state = 63},
  [2948] = {.lex_state = 63},
  [2949] = {.lex_state = 63},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 63},
  [2952] = {.lex_state = 63},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 63},
  [2955] = {.lex_state = 63},
  [2956] = {.lex_state = 63},
  [2957] = {.lex_state = 63},
  [2958] = {.lex_state = 63},
  [2959] = {.lex_state = 63},
  [2960] = {.lex_state = 63},
  [2961] = {.lex_state = 63},
  [2962] = {.lex_state = 0},
  [2963] = {.lex_state = 0},
  [2964] = {.lex_state = 63},
  [2965] = {.lex_state = 63},
  [2966] = {.lex_state = 63},
  [2967] = {.lex_state = 63},
  [2968] = {.lex_state = 0},
  [2969] = {.lex_state = 63},
  [2970] = {.lex_state = 63},
  [2971] = {.lex_state = 0, .external_lex_state = 4},
  [2972] = {.lex_state = 63},
  [2973] = {.lex_state = 63},
  [2974] = {.lex_state = 63},
  [2975] = {.lex_state = 63},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 63},
  [2978] = {.lex_state = 63},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 63},
  [2981] = {.lex_state = 0},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 0},
  [2984] = {.lex_state = 63},
  [2985] = {.lex_state = 63},
  [2986] = {.lex_state = 63},
  [2987] = {.lex_state = 63},
  [2988] = {.lex_state = 63},
  [2989] = {.lex_state = 63},
  [2990] = {.lex_state = 63},
  [2991] = {.lex_state = 63},
  [2992] = {.lex_state = 0},
  [2993] = {.lex_state = 63},
  [2994] = {.lex_state = 63},
  [2995] = {.lex_state = 0},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 63},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 63},
  [3002] = {.lex_state = 63},
  [3003] = {.lex_state = 63},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 63},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 0},
  [3008] = {.lex_state = 0},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 0},
  [3016] = {.lex_state = 0},
  [3017] = {.lex_state = 15},
  [3018] = {.lex_state = 0},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 63},
  [3021] = {.lex_state = 0},
  [3022] = {.lex_state = 0},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 63},
  [3028] = {.lex_state = 0},
  [3029] = {.lex_state = 63},
  [3030] = {.lex_state = 0},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 0},
  [3034] = {.lex_state = 0},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 63},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 0},
  [3040] = {.lex_state = 63},
  [3041] = {.lex_state = 0},
  [3042] = {.lex_state = 63},
  [3043] = {.lex_state = 0},
  [3044] = {.lex_state = 0},
  [3045] = {.lex_state = 0},
  [3046] = {.lex_state = 5},
  [3047] = {.lex_state = 0},
  [3048] = {.lex_state = 0},
  [3049] = {.lex_state = 0},
  [3050] = {.lex_state = 0},
  [3051] = {.lex_state = 63},
  [3052] = {.lex_state = 63},
  [3053] = {.lex_state = 0},
  [3054] = {.lex_state = 63},
  [3055] = {.lex_state = 63},
  [3056] = {.lex_state = 0},
  [3057] = {.lex_state = 0},
  [3058] = {.lex_state = 63},
  [3059] = {.lex_state = 63},
  [3060] = {.lex_state = 63},
  [3061] = {.lex_state = 0},
  [3062] = {.lex_state = 0},
  [3063] = {.lex_state = 63},
  [3064] = {.lex_state = 0},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 15},
  [3067] = {.lex_state = 63},
  [3068] = {.lex_state = 63},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 0},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 0},
  [3073] = {.lex_state = 63},
  [3074] = {.lex_state = 0},
  [3075] = {.lex_state = 63},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 63},
  [3078] = {.lex_state = 63},
  [3079] = {.lex_state = 63},
  [3080] = {.lex_state = 63},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 63},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 63},
  [3085] = {.lex_state = 0},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 0},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 63},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 0},
  [3094] = {.lex_state = 63},
  [3095] = {.lex_state = 63},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 15},
  [3099] = {.lex_state = 0},
  [3100] = {.lex_state = 63},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 0},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 0},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 0},
  [3110] = {.lex_state = 63},
  [3111] = {.lex_state = 63},
  [3112] = {.lex_state = 63},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 63},
  [3115] = {.lex_state = 0},
  [3116] = {.lex_state = 63},
  [3117] = {.lex_state = 63},
  [3118] = {.lex_state = 63},
  [3119] = {.lex_state = 0},
  [3120] = {.lex_state = 63},
  [3121] = {.lex_state = 0},
  [3122] = {.lex_state = 0},
  [3123] = {.lex_state = 63},
  [3124] = {.lex_state = 63},
  [3125] = {.lex_state = 0},
  [3126] = {.lex_state = 63},
  [3127] = {.lex_state = 63},
  [3128] = {.lex_state = 63},
  [3129] = {.lex_state = 5},
  [3130] = {.lex_state = 0},
  [3131] = {.lex_state = 63},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 63},
  [3135] = {.lex_state = 0},
  [3136] = {.lex_state = 63},
  [3137] = {.lex_state = 63},
  [3138] = {.lex_state = 63},
  [3139] = {.lex_state = 63},
  [3140] = {.lex_state = 63},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 0},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 63},
  [3146] = {.lex_state = 63},
  [3147] = {.lex_state = 63},
  [3148] = {.lex_state = 63},
  [3149] = {.lex_state = 0},
  [3150] = {.lex_state = 63},
  [3151] = {.lex_state = 0},
  [3152] = {.lex_state = 0},
  [3153] = {.lex_state = 0},
  [3154] = {.lex_state = 63},
  [3155] = {.lex_state = 15},
  [3156] = {.lex_state = 0},
  [3157] = {.lex_state = 0},
  [3158] = {.lex_state = 63},
  [3159] = {.lex_state = 63},
  [3160] = {.lex_state = 5},
  [3161] = {.lex_state = 63},
  [3162] = {.lex_state = 63},
  [3163] = {.lex_state = 63},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 63},
  [3166] = {.lex_state = 63},
  [3167] = {.lex_state = 63},
  [3168] = {.lex_state = 63},
  [3169] = {.lex_state = 63},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 63},
  [3172] = {.lex_state = 63},
  [3173] = {.lex_state = 0},
  [3174] = {.lex_state = 63},
  [3175] = {.lex_state = 63},
  [3176] = {.lex_state = 63},
  [3177] = {.lex_state = 63},
  [3178] = {.lex_state = 63},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 63},
  [3182] = {.lex_state = 63},
  [3183] = {.lex_state = 63},
  [3184] = {.lex_state = 0},
  [3185] = {.lex_state = 0},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 63},
  [3188] = {.lex_state = 63},
  [3189] = {.lex_state = 63},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 0},
  [3192] = {.lex_state = 0},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 5},
  [3195] = {.lex_state = 0},
  [3196] = {.lex_state = 63},
  [3197] = {.lex_state = 63},
  [3198] = {.lex_state = 63},
  [3199] = {.lex_state = 63},
  [3200] = {.lex_state = 63},
  [3201] = {.lex_state = 63},
  [3202] = {.lex_state = 63},
  [3203] = {.lex_state = 63},
  [3204] = {.lex_state = 0},
  [3205] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3180),
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(19),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(19),
    [sym_abstract_class_declaration] = STATE(19),
    [sym_module] = STATE(19),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(19),
    [sym_interface_declaration] = STATE(19),
    [sym_enum_declaration] = STATE(19),
    [sym_type_alias_declaration] = STATE(19),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [2] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1532),
    [sym_assignment_pattern] = STATE(2654),
    [sym_array] = STATE(1524),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_spread_element] = STATE(2654),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1546),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_method_definition] = STATE(2654),
    [sym_pair] = STATE(2654),
    [sym__property_name] = STATE(2159),
    [sym_computed_property_name] = STATE(2159),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(22),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_accessibility_modifier] = STATE(1985),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(13),
    [sym_lexical_declaration] = STATE(13),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1532),
    [sym_assignment_pattern] = STATE(2654),
    [sym_array] = STATE(1524),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(13),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(13),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(13),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_spread_element] = STATE(2654),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1546),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_method_definition] = STATE(2654),
    [sym_pair] = STATE(2654),
    [sym__property_name] = STATE(2159),
    [sym_computed_property_name] = STATE(2159),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(13),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(13),
    [sym_abstract_class_declaration] = STATE(13),
    [sym_module] = STATE(13),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(13),
    [sym_interface_declaration] = STATE(13),
    [sym_enum_declaration] = STATE(13),
    [sym_type_alias_declaration] = STATE(13),
    [sym_accessibility_modifier] = STATE(1985),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [4] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(13),
    [sym_lexical_declaration] = STATE(13),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1532),
    [sym_assignment_pattern] = STATE(2654),
    [sym_array] = STATE(1524),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(13),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(13),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(13),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_spread_element] = STATE(2654),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1546),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_method_definition] = STATE(2654),
    [sym_pair] = STATE(2654),
    [sym__property_name] = STATE(2159),
    [sym_computed_property_name] = STATE(2159),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(13),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(13),
    [sym_abstract_class_declaration] = STATE(13),
    [sym_module] = STATE(13),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(13),
    [sym_interface_declaration] = STATE(13),
    [sym_enum_declaration] = STATE(13),
    [sym_type_alias_declaration] = STATE(13),
    [sym_accessibility_modifier] = STATE(1985),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [aux_sym_object_repeat1] = STATE(2753),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [5] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1532),
    [sym_assignment_pattern] = STATE(2612),
    [sym_array] = STATE(1524),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_spread_element] = STATE(2612),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1546),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_method_definition] = STATE(2612),
    [sym_pair] = STATE(2612),
    [sym__property_name] = STATE(2159),
    [sym_computed_property_name] = STATE(2159),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(23),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_accessibility_modifier] = STATE(1985),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [aux_sym_object_repeat1] = STATE(2613),
    [sym_identifier] = ACTIONS(151),
    [anon_sym_export] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_type] = ACTIONS(159),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(161),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(165),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(167),
    [anon_sym_declare] = ACTIONS(169),
    [anon_sym_public] = ACTIONS(171),
    [anon_sym_private] = ACTIONS(171),
    [anon_sym_protected] = ACTIONS(171),
    [anon_sym_module] = ACTIONS(173),
    [anon_sym_any] = ACTIONS(175),
    [anon_sym_number] = ACTIONS(175),
    [anon_sym_boolean] = ACTIONS(175),
    [anon_sym_string] = ACTIONS(175),
    [anon_sym_symbol] = ACTIONS(175),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(177),
  },
  [6] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1532),
    [sym_assignment_pattern] = STATE(2678),
    [sym_array] = STATE(1524),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_spread_element] = STATE(2678),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1546),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_method_definition] = STATE(2678),
    [sym_pair] = STATE(2678),
    [sym__property_name] = STATE(2159),
    [sym_computed_property_name] = STATE(2159),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(15),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_accessibility_modifier] = STATE(1985),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [aux_sym_object_repeat1] = STATE(2676),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_export] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_type] = ACTIONS(187),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(189),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(191),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(195),
    [anon_sym_set] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(197),
    [anon_sym_public] = ACTIONS(199),
    [anon_sym_private] = ACTIONS(199),
    [anon_sym_protected] = ACTIONS(199),
    [anon_sym_module] = ACTIONS(201),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(205),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_export] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_namespace] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(226),
    [anon_sym_import] = ACTIONS(229),
    [anon_sym_var] = ACTIONS(232),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(244),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_await] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(256),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(268),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_debugger] = ACTIONS(274),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_void] = ACTIONS(316),
    [anon_sym_delete] = ACTIONS(226),
    [anon_sym_PLUS_PLUS] = ACTIONS(319),
    [anon_sym_DASH_DASH] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [sym_number] = ACTIONS(331),
    [sym_this] = ACTIONS(334),
    [sym_super] = ACTIONS(337),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_null] = ACTIONS(334),
    [sym_undefined] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(346),
    [anon_sym_get] = ACTIONS(343),
    [anon_sym_set] = ACTIONS(343),
    [anon_sym_declare] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(343),
    [anon_sym_private] = ACTIONS(343),
    [anon_sym_protected] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_any] = ACTIONS(343),
    [anon_sym_number] = ACTIONS(343),
    [anon_sym_boolean] = ACTIONS(343),
    [anon_sym_string] = ACTIONS(343),
    [anon_sym_symbol] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(358),
    [sym_readonly] = ACTIONS(343),
  },
  [8] = {
    [sym_export_statement] = STATE(10),
    [sym__declaration] = STATE(10),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(10),
    [sym_lexical_declaration] = STATE(10),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(10),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(10),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(10),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(10),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(10),
    [sym_abstract_class_declaration] = STATE(10),
    [sym_module] = STATE(10),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(10),
    [sym_interface_declaration] = STATE(10),
    [sym_enum_declaration] = STATE(10),
    [sym_type_alias_declaration] = STATE(10),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [10] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [11] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(9),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(9),
    [sym_abstract_class_declaration] = STATE(9),
    [sym_module] = STATE(9),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_type_alias_declaration] = STATE(9),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [13] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [14] = {
    [sym_export_statement] = STATE(27),
    [sym__declaration] = STATE(27),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(27),
    [sym_lexical_declaration] = STATE(27),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(27),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(27),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(27),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(27),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(27),
    [sym_abstract_class_declaration] = STATE(27),
    [sym_module] = STATE(27),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(27),
    [sym_interface_declaration] = STATE(27),
    [sym_enum_declaration] = STATE(27),
    [sym_type_alias_declaration] = STATE(27),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [16] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(12),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [17] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(15),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [18] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(23),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [19] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [21] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(22),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [22] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [23] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [24] = {
    [sym_export_statement] = STATE(13),
    [sym__declaration] = STATE(13),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(13),
    [sym_lexical_declaration] = STATE(13),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(13),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(13),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(13),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(13),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(13),
    [sym_abstract_class_declaration] = STATE(13),
    [sym_module] = STATE(13),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(13),
    [sym_interface_declaration] = STATE(13),
    [sym_enum_declaration] = STATE(13),
    [sym_type_alias_declaration] = STATE(13),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [26] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(25),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [27] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [28] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(20),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [29] = {
    [sym_export_statement] = STATE(696),
    [sym__declaration] = STATE(696),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(696),
    [sym_expression_statement] = STATE(696),
    [sym_variable_declaration] = STATE(696),
    [sym_lexical_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_if_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_for_statement] = STATE(696),
    [sym_for_in_statement] = STATE(696),
    [sym_while_statement] = STATE(696),
    [sym_do_statement] = STATE(696),
    [sym_try_statement] = STATE(696),
    [sym_with_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_continue_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(696),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(696),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(696),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(696),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(696),
    [sym_abstract_class_declaration] = STATE(696),
    [sym_module] = STATE(696),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_enum_declaration] = STATE(696),
    [sym_type_alias_declaration] = STATE(696),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [30] = {
    [sym_export_statement] = STATE(623),
    [sym__declaration] = STATE(623),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(623),
    [sym_expression_statement] = STATE(623),
    [sym_variable_declaration] = STATE(623),
    [sym_lexical_declaration] = STATE(623),
    [sym_statement_block] = STATE(623),
    [sym_if_statement] = STATE(623),
    [sym_switch_statement] = STATE(623),
    [sym_for_statement] = STATE(623),
    [sym_for_in_statement] = STATE(623),
    [sym_while_statement] = STATE(623),
    [sym_do_statement] = STATE(623),
    [sym_try_statement] = STATE(623),
    [sym_with_statement] = STATE(623),
    [sym_break_statement] = STATE(623),
    [sym_continue_statement] = STATE(623),
    [sym_debugger_statement] = STATE(623),
    [sym_return_statement] = STATE(623),
    [sym_throw_statement] = STATE(623),
    [sym_empty_statement] = STATE(623),
    [sym_labeled_statement] = STATE(623),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(623),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(623),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(623),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(623),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(623),
    [sym_abstract_class_declaration] = STATE(623),
    [sym_module] = STATE(623),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(623),
    [sym_interface_declaration] = STATE(623),
    [sym_enum_declaration] = STATE(623),
    [sym_type_alias_declaration] = STATE(623),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [31] = {
    [sym_export_statement] = STATE(679),
    [sym__declaration] = STATE(679),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(679),
    [sym_expression_statement] = STATE(679),
    [sym_variable_declaration] = STATE(679),
    [sym_lexical_declaration] = STATE(679),
    [sym_statement_block] = STATE(679),
    [sym_if_statement] = STATE(679),
    [sym_switch_statement] = STATE(679),
    [sym_for_statement] = STATE(679),
    [sym_for_in_statement] = STATE(679),
    [sym_while_statement] = STATE(679),
    [sym_do_statement] = STATE(679),
    [sym_try_statement] = STATE(679),
    [sym_with_statement] = STATE(679),
    [sym_break_statement] = STATE(679),
    [sym_continue_statement] = STATE(679),
    [sym_debugger_statement] = STATE(679),
    [sym_return_statement] = STATE(679),
    [sym_throw_statement] = STATE(679),
    [sym_empty_statement] = STATE(679),
    [sym_labeled_statement] = STATE(679),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(679),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(679),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(679),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(679),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(679),
    [sym_abstract_class_declaration] = STATE(679),
    [sym_module] = STATE(679),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(679),
    [sym_interface_declaration] = STATE(679),
    [sym_enum_declaration] = STATE(679),
    [sym_type_alias_declaration] = STATE(679),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [32] = {
    [sym_export_statement] = STATE(677),
    [sym__declaration] = STATE(677),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(677),
    [sym_expression_statement] = STATE(677),
    [sym_variable_declaration] = STATE(677),
    [sym_lexical_declaration] = STATE(677),
    [sym_statement_block] = STATE(677),
    [sym_if_statement] = STATE(677),
    [sym_switch_statement] = STATE(677),
    [sym_for_statement] = STATE(677),
    [sym_for_in_statement] = STATE(677),
    [sym_while_statement] = STATE(677),
    [sym_do_statement] = STATE(677),
    [sym_try_statement] = STATE(677),
    [sym_with_statement] = STATE(677),
    [sym_break_statement] = STATE(677),
    [sym_continue_statement] = STATE(677),
    [sym_debugger_statement] = STATE(677),
    [sym_return_statement] = STATE(677),
    [sym_throw_statement] = STATE(677),
    [sym_empty_statement] = STATE(677),
    [sym_labeled_statement] = STATE(677),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(677),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(677),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(677),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(677),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(677),
    [sym_abstract_class_declaration] = STATE(677),
    [sym_module] = STATE(677),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(677),
    [sym_interface_declaration] = STATE(677),
    [sym_enum_declaration] = STATE(677),
    [sym_type_alias_declaration] = STATE(677),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [33] = {
    [sym_export_statement] = STATE(696),
    [sym__declaration] = STATE(696),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(696),
    [sym_expression_statement] = STATE(696),
    [sym_variable_declaration] = STATE(696),
    [sym_lexical_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_if_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_for_statement] = STATE(696),
    [sym_for_in_statement] = STATE(696),
    [sym_while_statement] = STATE(696),
    [sym_do_statement] = STATE(696),
    [sym_try_statement] = STATE(696),
    [sym_with_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_continue_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(696),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(696),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(696),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(696),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(696),
    [sym_abstract_class_declaration] = STATE(696),
    [sym_module] = STATE(696),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_enum_declaration] = STATE(696),
    [sym_type_alias_declaration] = STATE(696),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [34] = {
    [sym_export_statement] = STATE(684),
    [sym__declaration] = STATE(684),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_variable_declaration] = STATE(684),
    [sym_lexical_declaration] = STATE(684),
    [sym_statement_block] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_for_in_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_try_statement] = STATE(684),
    [sym_with_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_throw_statement] = STATE(684),
    [sym_empty_statement] = STATE(684),
    [sym_labeled_statement] = STATE(684),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(684),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(684),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(684),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(684),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(684),
    [sym_abstract_class_declaration] = STATE(684),
    [sym_module] = STATE(684),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(684),
    [sym_interface_declaration] = STATE(684),
    [sym_enum_declaration] = STATE(684),
    [sym_type_alias_declaration] = STATE(684),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [35] = {
    [sym_export_statement] = STATE(677),
    [sym__declaration] = STATE(677),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(677),
    [sym_expression_statement] = STATE(677),
    [sym_variable_declaration] = STATE(677),
    [sym_lexical_declaration] = STATE(677),
    [sym_statement_block] = STATE(677),
    [sym_if_statement] = STATE(677),
    [sym_switch_statement] = STATE(677),
    [sym_for_statement] = STATE(677),
    [sym_for_in_statement] = STATE(677),
    [sym_while_statement] = STATE(677),
    [sym_do_statement] = STATE(677),
    [sym_try_statement] = STATE(677),
    [sym_with_statement] = STATE(677),
    [sym_break_statement] = STATE(677),
    [sym_continue_statement] = STATE(677),
    [sym_debugger_statement] = STATE(677),
    [sym_return_statement] = STATE(677),
    [sym_throw_statement] = STATE(677),
    [sym_empty_statement] = STATE(677),
    [sym_labeled_statement] = STATE(677),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(677),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(677),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(677),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(677),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(677),
    [sym_abstract_class_declaration] = STATE(677),
    [sym_module] = STATE(677),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(677),
    [sym_interface_declaration] = STATE(677),
    [sym_enum_declaration] = STATE(677),
    [sym_type_alias_declaration] = STATE(677),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [36] = {
    [sym_export_statement] = STATE(681),
    [sym__declaration] = STATE(681),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(681),
    [sym_expression_statement] = STATE(681),
    [sym_variable_declaration] = STATE(681),
    [sym_lexical_declaration] = STATE(681),
    [sym_statement_block] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_switch_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_for_in_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(681),
    [sym_try_statement] = STATE(681),
    [sym_with_statement] = STATE(681),
    [sym_break_statement] = STATE(681),
    [sym_continue_statement] = STATE(681),
    [sym_debugger_statement] = STATE(681),
    [sym_return_statement] = STATE(681),
    [sym_throw_statement] = STATE(681),
    [sym_empty_statement] = STATE(681),
    [sym_labeled_statement] = STATE(681),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(681),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(681),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(681),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(681),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(681),
    [sym_abstract_class_declaration] = STATE(681),
    [sym_module] = STATE(681),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(681),
    [sym_interface_declaration] = STATE(681),
    [sym_enum_declaration] = STATE(681),
    [sym_type_alias_declaration] = STATE(681),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [37] = {
    [sym_export_statement] = STATE(675),
    [sym__declaration] = STATE(675),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(675),
    [sym_expression_statement] = STATE(675),
    [sym_variable_declaration] = STATE(675),
    [sym_lexical_declaration] = STATE(675),
    [sym_statement_block] = STATE(675),
    [sym_if_statement] = STATE(675),
    [sym_switch_statement] = STATE(675),
    [sym_for_statement] = STATE(675),
    [sym_for_in_statement] = STATE(675),
    [sym_while_statement] = STATE(675),
    [sym_do_statement] = STATE(675),
    [sym_try_statement] = STATE(675),
    [sym_with_statement] = STATE(675),
    [sym_break_statement] = STATE(675),
    [sym_continue_statement] = STATE(675),
    [sym_debugger_statement] = STATE(675),
    [sym_return_statement] = STATE(675),
    [sym_throw_statement] = STATE(675),
    [sym_empty_statement] = STATE(675),
    [sym_labeled_statement] = STATE(675),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(675),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(675),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(675),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(675),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(675),
    [sym_abstract_class_declaration] = STATE(675),
    [sym_module] = STATE(675),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(675),
    [sym_interface_declaration] = STATE(675),
    [sym_enum_declaration] = STATE(675),
    [sym_type_alias_declaration] = STATE(675),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [38] = {
    [sym_export_statement] = STATE(3128),
    [sym__declaration] = STATE(3128),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(3128),
    [sym_expression_statement] = STATE(3128),
    [sym_variable_declaration] = STATE(3128),
    [sym_lexical_declaration] = STATE(3128),
    [sym_statement_block] = STATE(3128),
    [sym_if_statement] = STATE(3128),
    [sym_switch_statement] = STATE(3128),
    [sym_for_statement] = STATE(3128),
    [sym_for_in_statement] = STATE(3128),
    [sym_while_statement] = STATE(3128),
    [sym_do_statement] = STATE(3128),
    [sym_try_statement] = STATE(3128),
    [sym_with_statement] = STATE(3128),
    [sym_break_statement] = STATE(3128),
    [sym_continue_statement] = STATE(3128),
    [sym_debugger_statement] = STATE(3128),
    [sym_return_statement] = STATE(3128),
    [sym_throw_statement] = STATE(3128),
    [sym_empty_statement] = STATE(3128),
    [sym_labeled_statement] = STATE(3128),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(3128),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(3128),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(3128),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(3128),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(3128),
    [sym_abstract_class_declaration] = STATE(3128),
    [sym_module] = STATE(3128),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(3128),
    [sym_interface_declaration] = STATE(3128),
    [sym_enum_declaration] = STATE(3128),
    [sym_type_alias_declaration] = STATE(3128),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [39] = {
    [sym_export_statement] = STATE(684),
    [sym__declaration] = STATE(684),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(684),
    [sym_expression_statement] = STATE(684),
    [sym_variable_declaration] = STATE(684),
    [sym_lexical_declaration] = STATE(684),
    [sym_statement_block] = STATE(684),
    [sym_if_statement] = STATE(684),
    [sym_switch_statement] = STATE(684),
    [sym_for_statement] = STATE(684),
    [sym_for_in_statement] = STATE(684),
    [sym_while_statement] = STATE(684),
    [sym_do_statement] = STATE(684),
    [sym_try_statement] = STATE(684),
    [sym_with_statement] = STATE(684),
    [sym_break_statement] = STATE(684),
    [sym_continue_statement] = STATE(684),
    [sym_debugger_statement] = STATE(684),
    [sym_return_statement] = STATE(684),
    [sym_throw_statement] = STATE(684),
    [sym_empty_statement] = STATE(684),
    [sym_labeled_statement] = STATE(684),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(684),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(684),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(684),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(684),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(684),
    [sym_abstract_class_declaration] = STATE(684),
    [sym_module] = STATE(684),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(684),
    [sym_interface_declaration] = STATE(684),
    [sym_enum_declaration] = STATE(684),
    [sym_type_alias_declaration] = STATE(684),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [40] = {
    [sym_export_statement] = STATE(2806),
    [sym__declaration] = STATE(2806),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(2806),
    [sym_expression_statement] = STATE(2806),
    [sym_variable_declaration] = STATE(2806),
    [sym_lexical_declaration] = STATE(2806),
    [sym_statement_block] = STATE(2806),
    [sym_if_statement] = STATE(2806),
    [sym_switch_statement] = STATE(2806),
    [sym_for_statement] = STATE(2806),
    [sym_for_in_statement] = STATE(2806),
    [sym_while_statement] = STATE(2806),
    [sym_do_statement] = STATE(2806),
    [sym_try_statement] = STATE(2806),
    [sym_with_statement] = STATE(2806),
    [sym_break_statement] = STATE(2806),
    [sym_continue_statement] = STATE(2806),
    [sym_debugger_statement] = STATE(2806),
    [sym_return_statement] = STATE(2806),
    [sym_throw_statement] = STATE(2806),
    [sym_empty_statement] = STATE(2806),
    [sym_labeled_statement] = STATE(2806),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(2806),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(2806),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(2806),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(2806),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(2806),
    [sym_abstract_class_declaration] = STATE(2806),
    [sym_module] = STATE(2806),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(2806),
    [sym_interface_declaration] = STATE(2806),
    [sym_enum_declaration] = STATE(2806),
    [sym_type_alias_declaration] = STATE(2806),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [41] = {
    [sym_export_statement] = STATE(675),
    [sym__declaration] = STATE(675),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(675),
    [sym_expression_statement] = STATE(675),
    [sym_variable_declaration] = STATE(675),
    [sym_lexical_declaration] = STATE(675),
    [sym_statement_block] = STATE(675),
    [sym_if_statement] = STATE(675),
    [sym_switch_statement] = STATE(675),
    [sym_for_statement] = STATE(675),
    [sym_for_in_statement] = STATE(675),
    [sym_while_statement] = STATE(675),
    [sym_do_statement] = STATE(675),
    [sym_try_statement] = STATE(675),
    [sym_with_statement] = STATE(675),
    [sym_break_statement] = STATE(675),
    [sym_continue_statement] = STATE(675),
    [sym_debugger_statement] = STATE(675),
    [sym_return_statement] = STATE(675),
    [sym_throw_statement] = STATE(675),
    [sym_empty_statement] = STATE(675),
    [sym_labeled_statement] = STATE(675),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(675),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(675),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(675),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(675),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(675),
    [sym_abstract_class_declaration] = STATE(675),
    [sym_module] = STATE(675),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(675),
    [sym_interface_declaration] = STATE(675),
    [sym_enum_declaration] = STATE(675),
    [sym_type_alias_declaration] = STATE(675),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [42] = {
    [sym_export_statement] = STATE(637),
    [sym__declaration] = STATE(637),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(637),
    [sym_expression_statement] = STATE(637),
    [sym_variable_declaration] = STATE(637),
    [sym_lexical_declaration] = STATE(637),
    [sym_statement_block] = STATE(637),
    [sym_if_statement] = STATE(637),
    [sym_switch_statement] = STATE(637),
    [sym_for_statement] = STATE(637),
    [sym_for_in_statement] = STATE(637),
    [sym_while_statement] = STATE(637),
    [sym_do_statement] = STATE(637),
    [sym_try_statement] = STATE(637),
    [sym_with_statement] = STATE(637),
    [sym_break_statement] = STATE(637),
    [sym_continue_statement] = STATE(637),
    [sym_debugger_statement] = STATE(637),
    [sym_return_statement] = STATE(637),
    [sym_throw_statement] = STATE(637),
    [sym_empty_statement] = STATE(637),
    [sym_labeled_statement] = STATE(637),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(637),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(637),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(637),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(637),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(637),
    [sym_abstract_class_declaration] = STATE(637),
    [sym_module] = STATE(637),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(637),
    [sym_interface_declaration] = STATE(637),
    [sym_enum_declaration] = STATE(637),
    [sym_type_alias_declaration] = STATE(637),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [43] = {
    [sym_export_statement] = STATE(681),
    [sym__declaration] = STATE(681),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(681),
    [sym_expression_statement] = STATE(681),
    [sym_variable_declaration] = STATE(681),
    [sym_lexical_declaration] = STATE(681),
    [sym_statement_block] = STATE(681),
    [sym_if_statement] = STATE(681),
    [sym_switch_statement] = STATE(681),
    [sym_for_statement] = STATE(681),
    [sym_for_in_statement] = STATE(681),
    [sym_while_statement] = STATE(681),
    [sym_do_statement] = STATE(681),
    [sym_try_statement] = STATE(681),
    [sym_with_statement] = STATE(681),
    [sym_break_statement] = STATE(681),
    [sym_continue_statement] = STATE(681),
    [sym_debugger_statement] = STATE(681),
    [sym_return_statement] = STATE(681),
    [sym_throw_statement] = STATE(681),
    [sym_empty_statement] = STATE(681),
    [sym_labeled_statement] = STATE(681),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(681),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(681),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(681),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(681),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(681),
    [sym_abstract_class_declaration] = STATE(681),
    [sym_module] = STATE(681),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(681),
    [sym_interface_declaration] = STATE(681),
    [sym_enum_declaration] = STATE(681),
    [sym_type_alias_declaration] = STATE(681),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [44] = {
    [sym_export_statement] = STATE(627),
    [sym__declaration] = STATE(627),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(627),
    [sym_expression_statement] = STATE(627),
    [sym_variable_declaration] = STATE(627),
    [sym_lexical_declaration] = STATE(627),
    [sym_statement_block] = STATE(627),
    [sym_if_statement] = STATE(627),
    [sym_switch_statement] = STATE(627),
    [sym_for_statement] = STATE(627),
    [sym_for_in_statement] = STATE(627),
    [sym_while_statement] = STATE(627),
    [sym_do_statement] = STATE(627),
    [sym_try_statement] = STATE(627),
    [sym_with_statement] = STATE(627),
    [sym_break_statement] = STATE(627),
    [sym_continue_statement] = STATE(627),
    [sym_debugger_statement] = STATE(627),
    [sym_return_statement] = STATE(627),
    [sym_throw_statement] = STATE(627),
    [sym_empty_statement] = STATE(627),
    [sym_labeled_statement] = STATE(627),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(627),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(627),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(627),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(627),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(627),
    [sym_abstract_class_declaration] = STATE(627),
    [sym_module] = STATE(627),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(627),
    [sym_interface_declaration] = STATE(627),
    [sym_enum_declaration] = STATE(627),
    [sym_type_alias_declaration] = STATE(627),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [45] = {
    [sym_export_statement] = STATE(637),
    [sym__declaration] = STATE(637),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(637),
    [sym_expression_statement] = STATE(637),
    [sym_variable_declaration] = STATE(637),
    [sym_lexical_declaration] = STATE(637),
    [sym_statement_block] = STATE(637),
    [sym_if_statement] = STATE(637),
    [sym_switch_statement] = STATE(637),
    [sym_for_statement] = STATE(637),
    [sym_for_in_statement] = STATE(637),
    [sym_while_statement] = STATE(637),
    [sym_do_statement] = STATE(637),
    [sym_try_statement] = STATE(637),
    [sym_with_statement] = STATE(637),
    [sym_break_statement] = STATE(637),
    [sym_continue_statement] = STATE(637),
    [sym_debugger_statement] = STATE(637),
    [sym_return_statement] = STATE(637),
    [sym_throw_statement] = STATE(637),
    [sym_empty_statement] = STATE(637),
    [sym_labeled_statement] = STATE(637),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(637),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(637),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(637),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(637),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(637),
    [sym_abstract_class_declaration] = STATE(637),
    [sym_module] = STATE(637),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(637),
    [sym_interface_declaration] = STATE(637),
    [sym_enum_declaration] = STATE(637),
    [sym_type_alias_declaration] = STATE(637),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [46] = {
    [sym_export_statement] = STATE(679),
    [sym__declaration] = STATE(679),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(679),
    [sym_expression_statement] = STATE(679),
    [sym_variable_declaration] = STATE(679),
    [sym_lexical_declaration] = STATE(679),
    [sym_statement_block] = STATE(679),
    [sym_if_statement] = STATE(679),
    [sym_switch_statement] = STATE(679),
    [sym_for_statement] = STATE(679),
    [sym_for_in_statement] = STATE(679),
    [sym_while_statement] = STATE(679),
    [sym_do_statement] = STATE(679),
    [sym_try_statement] = STATE(679),
    [sym_with_statement] = STATE(679),
    [sym_break_statement] = STATE(679),
    [sym_continue_statement] = STATE(679),
    [sym_debugger_statement] = STATE(679),
    [sym_return_statement] = STATE(679),
    [sym_throw_statement] = STATE(679),
    [sym_empty_statement] = STATE(679),
    [sym_labeled_statement] = STATE(679),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(679),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(679),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(679),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(679),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(679),
    [sym_abstract_class_declaration] = STATE(679),
    [sym_module] = STATE(679),
    [sym_internal_module] = STATE(1481),
    [sym_import_alias] = STATE(679),
    [sym_interface_declaration] = STATE(679),
    [sym_enum_declaration] = STATE(679),
    [sym_type_alias_declaration] = STATE(679),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2444),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [47] = {
    [sym_export_statement] = STATE(623),
    [sym__declaration] = STATE(623),
    [sym_import] = STATE(1292),
    [sym_import_statement] = STATE(623),
    [sym_expression_statement] = STATE(623),
    [sym_variable_declaration] = STATE(623),
    [sym_lexical_declaration] = STATE(623),
    [sym_statement_block] = STATE(623),
    [sym_if_statement] = STATE(623),
    [sym_switch_statement] = STATE(623),
    [sym_for_statement] = STATE(623),
    [sym_for_in_statement] = STATE(623),
    [sym_while_statement] = STATE(623),
    [sym_do_statement] = STATE(623),
    [sym_try_statement] = STATE(623),
    [sym_with_statement] = STATE(623),
    [sym_break_statement] = STATE(623),
    [sym_continue_statement] = STATE(623),
    [sym_debugger_statement] = STATE(623),
    [sym_return_statement] = STATE(623),
    [sym_throw_statement] = STATE(623),
    [sym_empty_statement] = STATE(623),
    [sym_labeled_statement] = STATE(623),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_class_declaration] = STATE(623),
    [sym_function] = STATE(1132),
    [sym_function_declaration] = STATE(623),
    [sym_generator_function] = STATE(1292),
    [sym_generator_function_declaration] = STATE(623),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_function_signature] = STATE(623),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_ambient_declaration] = STATE(623),
    [sym_abstract_class_declaration] = STATE(623),
    [sym_module] = STATE(623),
    [sym_internal_module] = STATE(128),
    [sym_import_alias] = STATE(623),
    [sym_interface_declaration] = STATE(623),
    [sym_enum_declaration] = STATE(623),
    [sym_type_alias_declaration] = STATE(623),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2458),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [48] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [aux_sym_object_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [49] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [aux_sym_object_repeat1] = STATE(2788),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [50] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [aux_sym_object_repeat1] = STATE(2635),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [51] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1151),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(96),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_RPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_RBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [52] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1641),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(97),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
    [sym__automatic_semicolon] = ACTIONS(503),
  },
  [53] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_PIPE_RBRACE] = ACTIONS(558),
    [sym__automatic_semicolon] = ACTIONS(558),
  },
  [54] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [55] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [56] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(595),
    [anon_sym_of] = ACTIONS(598),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [57] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [58] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [59] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1151),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(100),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_RPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_COLON] = ACTIONS(503),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [60] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [61] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [62] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [63] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1151),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(96),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [anon_sym_implements] = ACTIONS(495),
    [sym_readonly] = ACTIONS(493),
  },
  [64] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [65] = {
    [sym_import] = STATE(1505),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1505),
    [sym_yield_expression] = STATE(1505),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1505),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1505),
    [sym_arrow_function] = STATE(1505),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1505),
    [sym_new_expression] = STATE(1505),
    [sym_await_expression] = STATE(1505),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1505),
    [sym_augmented_assignment_expression] = STATE(1505),
    [sym_ternary_expression] = STATE(1505),
    [sym_binary_expression] = STATE(1505),
    [sym_unary_expression] = STATE(1505),
    [sym_update_expression] = STATE(1505),
    [sym_string] = STATE(1505),
    [sym_template_string] = STATE(1505),
    [sym_regex] = STATE(1505),
    [sym_meta_property] = STATE(1505),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1505),
    [sym_type_assertion] = STATE(1505),
    [sym_as_expression] = STATE(1505),
    [sym_internal_module] = STATE(1505),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(674),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(676),
    [sym_false] = ACTIONS(676),
    [sym_null] = ACTIONS(676),
    [sym_undefined] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [66] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [67] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [68] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [69] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1741),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(110),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(693),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(503),
  },
  [70] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [71] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1641),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(97),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
    [sym__automatic_semicolon] = ACTIONS(503),
  },
  [72] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1151),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(100),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_COLON] = ACTIONS(503),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(700),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [73] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1372),
    [sym_type_assertion] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_EQ_GT] = ACTIONS(693),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS_EQ] = ACTIONS(734),
    [anon_sym_DASH_EQ] = ACTIONS(734),
    [anon_sym_STAR_EQ] = ACTIONS(734),
    [anon_sym_SLASH_EQ] = ACTIONS(734),
    [anon_sym_PERCENT_EQ] = ACTIONS(734),
    [anon_sym_CARET_EQ] = ACTIONS(734),
    [anon_sym_AMP_EQ] = ACTIONS(734),
    [anon_sym_PIPE_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_LT_EQ] = ACTIONS(734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(734),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(752),
    [sym_this] = ACTIONS(754),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_undefined] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [74] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [75] = {
    [sym_import] = STATE(1373),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS_EQ] = ACTIONS(786),
    [anon_sym_DASH_EQ] = ACTIONS(786),
    [anon_sym_STAR_EQ] = ACTIONS(786),
    [anon_sym_SLASH_EQ] = ACTIONS(786),
    [anon_sym_PERCENT_EQ] = ACTIONS(786),
    [anon_sym_CARET_EQ] = ACTIONS(786),
    [anon_sym_AMP_EQ] = ACTIONS(786),
    [anon_sym_PIPE_EQ] = ACTIONS(786),
    [anon_sym_GT_GT_EQ] = ACTIONS(786),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_LT_EQ] = ACTIONS(786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(798),
    [sym_this] = ACTIONS(800),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(800),
    [sym_false] = ACTIONS(800),
    [sym_null] = ACTIONS(800),
    [sym_undefined] = ACTIONS(800),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(768),
  },
  [76] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1372),
    [sym_type_assertion] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_EQ_GT] = ACTIONS(693),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS_EQ] = ACTIONS(734),
    [anon_sym_DASH_EQ] = ACTIONS(734),
    [anon_sym_STAR_EQ] = ACTIONS(734),
    [anon_sym_SLASH_EQ] = ACTIONS(734),
    [anon_sym_PERCENT_EQ] = ACTIONS(734),
    [anon_sym_CARET_EQ] = ACTIONS(734),
    [anon_sym_AMP_EQ] = ACTIONS(734),
    [anon_sym_PIPE_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_LT_EQ] = ACTIONS(734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(734),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(752),
    [sym_this] = ACTIONS(754),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_undefined] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [77] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_arguments] = STATE(1151),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(96),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_RBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [78] = {
    [sym_import] = STATE(1658),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1658),
    [sym_yield_expression] = STATE(1658),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1658),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1658),
    [sym_arrow_function] = STATE(1658),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1658),
    [sym_new_expression] = STATE(1658),
    [sym_await_expression] = STATE(1658),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1658),
    [sym_augmented_assignment_expression] = STATE(1658),
    [sym_ternary_expression] = STATE(1658),
    [sym_binary_expression] = STATE(1658),
    [sym_unary_expression] = STATE(1658),
    [sym_update_expression] = STATE(1658),
    [sym_string] = STATE(1658),
    [sym_template_string] = STATE(1658),
    [sym_regex] = STATE(1658),
    [sym_meta_property] = STATE(1658),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1658),
    [sym_type_assertion] = STATE(1658),
    [sym_as_expression] = STATE(1658),
    [sym_internal_module] = STATE(1658),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(700),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS_EQ] = ACTIONS(820),
    [anon_sym_DASH_EQ] = ACTIONS(820),
    [anon_sym_STAR_EQ] = ACTIONS(820),
    [anon_sym_SLASH_EQ] = ACTIONS(820),
    [anon_sym_PERCENT_EQ] = ACTIONS(820),
    [anon_sym_CARET_EQ] = ACTIONS(820),
    [anon_sym_AMP_EQ] = ACTIONS(820),
    [anon_sym_PIPE_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_LT_LT_EQ] = ACTIONS(820),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(832),
    [sym_this] = ACTIONS(834),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_null] = ACTIONS(834),
    [sym_undefined] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [79] = {
    [sym_import] = STATE(1373),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS_EQ] = ACTIONS(786),
    [anon_sym_DASH_EQ] = ACTIONS(786),
    [anon_sym_STAR_EQ] = ACTIONS(786),
    [anon_sym_SLASH_EQ] = ACTIONS(786),
    [anon_sym_PERCENT_EQ] = ACTIONS(786),
    [anon_sym_CARET_EQ] = ACTIONS(786),
    [anon_sym_AMP_EQ] = ACTIONS(786),
    [anon_sym_PIPE_EQ] = ACTIONS(786),
    [anon_sym_GT_GT_EQ] = ACTIONS(786),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_LT_EQ] = ACTIONS(786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(798),
    [sym_this] = ACTIONS(800),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(800),
    [sym_false] = ACTIONS(800),
    [sym_null] = ACTIONS(800),
    [sym_undefined] = ACTIONS(800),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(768),
  },
  [80] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [81] = {
    [sym_import] = STATE(1505),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1505),
    [sym_yield_expression] = STATE(1505),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1505),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1505),
    [sym_arrow_function] = STATE(1505),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1505),
    [sym_new_expression] = STATE(1505),
    [sym_await_expression] = STATE(1505),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1505),
    [sym_augmented_assignment_expression] = STATE(1505),
    [sym_ternary_expression] = STATE(1505),
    [sym_binary_expression] = STATE(1505),
    [sym_unary_expression] = STATE(1505),
    [sym_update_expression] = STATE(1505),
    [sym_string] = STATE(1505),
    [sym_template_string] = STATE(1505),
    [sym_regex] = STATE(1505),
    [sym_meta_property] = STATE(1505),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1505),
    [sym_type_assertion] = STATE(1505),
    [sym_as_expression] = STATE(1505),
    [sym_internal_module] = STATE(1505),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(674),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(676),
    [sym_false] = ACTIONS(676),
    [sym_null] = ACTIONS(676),
    [sym_undefined] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [82] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(604),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [83] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(595),
    [anon_sym_of] = ACTIONS(598),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [84] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [85] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(836),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [86] = {
    [sym_import] = STATE(1658),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1658),
    [sym_yield_expression] = STATE(1658),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1658),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1658),
    [sym_arrow_function] = STATE(1658),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1658),
    [sym_new_expression] = STATE(1658),
    [sym_await_expression] = STATE(1658),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1658),
    [sym_augmented_assignment_expression] = STATE(1658),
    [sym_ternary_expression] = STATE(1658),
    [sym_binary_expression] = STATE(1658),
    [sym_unary_expression] = STATE(1658),
    [sym_update_expression] = STATE(1658),
    [sym_string] = STATE(1658),
    [sym_template_string] = STATE(1658),
    [sym_regex] = STATE(1658),
    [sym_meta_property] = STATE(1658),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1658),
    [sym_type_assertion] = STATE(1658),
    [sym_as_expression] = STATE(1658),
    [sym_internal_module] = STATE(1658),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(700),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS_EQ] = ACTIONS(820),
    [anon_sym_DASH_EQ] = ACTIONS(820),
    [anon_sym_STAR_EQ] = ACTIONS(820),
    [anon_sym_SLASH_EQ] = ACTIONS(820),
    [anon_sym_PERCENT_EQ] = ACTIONS(820),
    [anon_sym_CARET_EQ] = ACTIONS(820),
    [anon_sym_AMP_EQ] = ACTIONS(820),
    [anon_sym_PIPE_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_LT_LT_EQ] = ACTIONS(820),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(832),
    [sym_this] = ACTIONS(834),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_null] = ACTIONS(834),
    [sym_undefined] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [87] = {
    [sym_import] = STATE(1216),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1216),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1216),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1216),
    [sym_arrow_function] = STATE(1216),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1216),
    [sym_new_expression] = STATE(1216),
    [sym_await_expression] = STATE(1216),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1216),
    [sym_augmented_assignment_expression] = STATE(1216),
    [sym_ternary_expression] = STATE(1216),
    [sym_binary_expression] = STATE(1216),
    [sym_unary_expression] = STATE(1216),
    [sym_update_expression] = STATE(1216),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1816),
    [sym_template_string] = STATE(1216),
    [sym_regex] = STATE(1216),
    [sym_meta_property] = STATE(1216),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1216),
    [sym_type_assertion] = STATE(1216),
    [sym_as_expression] = STATE(1216),
    [sym_internal_module] = STATE(1216),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2627),
    [sym_constructor_type] = STATE(2627),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(343),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2627),
    [sym_intersection_type] = STATE(2627),
    [sym_function_type] = STATE(2627),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(851),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(875),
    [sym_this] = ACTIONS(877),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(881),
    [sym_undefined] = ACTIONS(881),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(885),
    [anon_sym_number] = ACTIONS(885),
    [anon_sym_boolean] = ACTIONS(885),
    [anon_sym_string] = ACTIONS(885),
    [anon_sym_symbol] = ACTIONS(885),
    [sym_readonly] = ACTIONS(887),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [88] = {
    [sym_import] = STATE(1158),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1158),
    [sym_yield_expression] = STATE(1158),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1158),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1158),
    [sym_arrow_function] = STATE(1158),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1158),
    [sym_new_expression] = STATE(1158),
    [sym_await_expression] = STATE(1158),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1158),
    [sym_augmented_assignment_expression] = STATE(1158),
    [sym_ternary_expression] = STATE(1158),
    [sym_binary_expression] = STATE(1158),
    [sym_unary_expression] = STATE(1158),
    [sym_update_expression] = STATE(1158),
    [sym_sequence_expression] = STATE(3133),
    [sym_string] = STATE(1816),
    [sym_template_string] = STATE(1158),
    [sym_regex] = STATE(1158),
    [sym_meta_property] = STATE(1158),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1158),
    [sym_type_assertion] = STATE(1158),
    [sym_as_expression] = STATE(1158),
    [sym_internal_module] = STATE(1158),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2643),
    [sym_constructor_type] = STATE(2643),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(343),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2643),
    [sym_intersection_type] = STATE(2643),
    [sym_function_type] = STATE(2643),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(851),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(875),
    [sym_this] = ACTIONS(877),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(893),
    [sym_undefined] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(885),
    [anon_sym_number] = ACTIONS(885),
    [anon_sym_boolean] = ACTIONS(885),
    [anon_sym_string] = ACTIONS(885),
    [anon_sym_symbol] = ACTIONS(885),
    [sym_readonly] = ACTIONS(887),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [89] = {
    [sym_import] = STATE(1216),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1216),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1216),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1216),
    [sym_arrow_function] = STATE(1216),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1216),
    [sym_new_expression] = STATE(1216),
    [sym_await_expression] = STATE(1216),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1216),
    [sym_augmented_assignment_expression] = STATE(1216),
    [sym_ternary_expression] = STATE(1216),
    [sym_binary_expression] = STATE(1216),
    [sym_unary_expression] = STATE(1216),
    [sym_update_expression] = STATE(1216),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1816),
    [sym_template_string] = STATE(1216),
    [sym_regex] = STATE(1216),
    [sym_meta_property] = STATE(1216),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1216),
    [sym_type_assertion] = STATE(1216),
    [sym_as_expression] = STATE(1216),
    [sym_internal_module] = STATE(1216),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2643),
    [sym_constructor_type] = STATE(2643),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(343),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2643),
    [sym_intersection_type] = STATE(2643),
    [sym_function_type] = STATE(2643),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(851),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(875),
    [sym_this] = ACTIONS(877),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(881),
    [sym_undefined] = ACTIONS(881),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(885),
    [anon_sym_number] = ACTIONS(885),
    [anon_sym_boolean] = ACTIONS(885),
    [anon_sym_string] = ACTIONS(885),
    [anon_sym_symbol] = ACTIONS(885),
    [sym_readonly] = ACTIONS(887),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [90] = {
    [sym_import] = STATE(1161),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1161),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1161),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1161),
    [sym_arrow_function] = STATE(1161),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1161),
    [sym_new_expression] = STATE(1161),
    [sym_await_expression] = STATE(1161),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1161),
    [sym_augmented_assignment_expression] = STATE(1161),
    [sym_ternary_expression] = STATE(1161),
    [sym_binary_expression] = STATE(1161),
    [sym_unary_expression] = STATE(1161),
    [sym_update_expression] = STATE(1161),
    [sym_sequence_expression] = STATE(3085),
    [sym_string] = STATE(1816),
    [sym_template_string] = STATE(1161),
    [sym_regex] = STATE(1161),
    [sym_meta_property] = STATE(1161),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1161),
    [sym_type_assertion] = STATE(1161),
    [sym_as_expression] = STATE(1161),
    [sym_internal_module] = STATE(1161),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2643),
    [sym_constructor_type] = STATE(2643),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(343),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2643),
    [sym_intersection_type] = STATE(2643),
    [sym_function_type] = STATE(2643),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(851),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(873),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(875),
    [sym_this] = ACTIONS(877),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(895),
    [sym_undefined] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(885),
    [anon_sym_number] = ACTIONS(885),
    [anon_sym_boolean] = ACTIONS(885),
    [anon_sym_string] = ACTIONS(885),
    [anon_sym_symbol] = ACTIONS(885),
    [sym_readonly] = ACTIONS(887),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [91] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1348),
    [sym_yield_expression] = STATE(1348),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_await_expression] = STATE(1348),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1348),
    [sym_augmented_assignment_expression] = STATE(1348),
    [sym_spread_element] = STATE(2756),
    [sym_ternary_expression] = STATE(1348),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_update_expression] = STATE(1348),
    [sym_string] = STATE(1867),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1348),
    [sym_as_expression] = STATE(1348),
    [sym_internal_module] = STATE(1348),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2472),
    [sym_constructor_type] = STATE(2472),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2472),
    [sym_intersection_type] = STATE(2472),
    [sym_function_type] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2755),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(913),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(917),
    [sym_false] = ACTIONS(917),
    [sym_null] = ACTIONS(919),
    [sym_undefined] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(921),
    [anon_sym_number] = ACTIONS(921),
    [anon_sym_boolean] = ACTIONS(921),
    [anon_sym_string] = ACTIONS(921),
    [anon_sym_symbol] = ACTIONS(921),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [92] = {
    [sym_import] = STATE(1361),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1361),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1361),
    [sym_arrow_function] = STATE(1361),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_spread_element] = STATE(2618),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_string] = STATE(1867),
    [sym_template_string] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1361),
    [sym_type_assertion] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_internal_module] = STATE(1361),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2472),
    [sym_constructor_type] = STATE(2472),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2472),
    [sym_intersection_type] = STATE(2472),
    [sym_function_type] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2619),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(913),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(917),
    [sym_false] = ACTIONS(917),
    [sym_null] = ACTIONS(925),
    [sym_undefined] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(921),
    [anon_sym_number] = ACTIONS(921),
    [anon_sym_boolean] = ACTIONS(921),
    [anon_sym_string] = ACTIONS(921),
    [anon_sym_symbol] = ACTIONS(921),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [93] = {
    [sym_import] = STATE(1353),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_spread_element] = STATE(2669),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_string] = STATE(1867),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1353),
    [sym_type_assertion] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2454),
    [sym_constructor_type] = STATE(2454),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2454),
    [sym_intersection_type] = STATE(2454),
    [sym_function_type] = STATE(2454),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(913),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(917),
    [sym_false] = ACTIONS(917),
    [sym_null] = ACTIONS(929),
    [sym_undefined] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(921),
    [anon_sym_number] = ACTIONS(921),
    [anon_sym_boolean] = ACTIONS(921),
    [anon_sym_string] = ACTIONS(921),
    [anon_sym_symbol] = ACTIONS(921),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [94] = {
    [sym_import] = STATE(1368),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1368),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1368),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1368),
    [sym_arrow_function] = STATE(1368),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1368),
    [sym_new_expression] = STATE(1368),
    [sym_await_expression] = STATE(1368),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1368),
    [sym_augmented_assignment_expression] = STATE(1368),
    [sym_spread_element] = STATE(2731),
    [sym_ternary_expression] = STATE(1368),
    [sym_binary_expression] = STATE(1368),
    [sym_unary_expression] = STATE(1368),
    [sym_update_expression] = STATE(1368),
    [sym_string] = STATE(1867),
    [sym_template_string] = STATE(1368),
    [sym_regex] = STATE(1368),
    [sym_meta_property] = STATE(1368),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1368),
    [sym_type_assertion] = STATE(1368),
    [sym_as_expression] = STATE(1368),
    [sym_internal_module] = STATE(1368),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2472),
    [sym_constructor_type] = STATE(2472),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2472),
    [sym_intersection_type] = STATE(2472),
    [sym_function_type] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2732),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(913),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(917),
    [sym_false] = ACTIONS(917),
    [sym_null] = ACTIONS(933),
    [sym_undefined] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(921),
    [anon_sym_number] = ACTIONS(921),
    [anon_sym_boolean] = ACTIONS(921),
    [anon_sym_string] = ACTIONS(921),
    [anon_sym_symbol] = ACTIONS(921),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [95] = {
    [sym_import] = STATE(1353),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_spread_element] = STATE(2669),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_string] = STATE(1867),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1353),
    [sym_type_assertion] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2472),
    [sym_constructor_type] = STATE(2472),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2472),
    [sym_intersection_type] = STATE(2472),
    [sym_function_type] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(897),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(911),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(913),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(917),
    [sym_false] = ACTIONS(917),
    [sym_null] = ACTIONS(929),
    [sym_undefined] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(921),
    [anon_sym_number] = ACTIONS(921),
    [anon_sym_boolean] = ACTIONS(921),
    [anon_sym_string] = ACTIONS(921),
    [anon_sym_symbol] = ACTIONS(921),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [96] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_arguments] = STATE(1099),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_GT_GT_GT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_QMARK_QMARK] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [anon_sym_implements] = ACTIONS(935),
    [sym_readonly] = ACTIONS(493),
  },
  [97] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_arguments] = STATE(1578),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(937),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_GT_GT_GT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_QMARK_QMARK] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
    [sym__automatic_semicolon] = ACTIONS(937),
  },
  [98] = {
    [sym_import] = STATE(1313),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1313),
    [sym_yield_expression] = STATE(1313),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1313),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1313),
    [sym_arrow_function] = STATE(1313),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1313),
    [sym_new_expression] = STATE(1313),
    [sym_await_expression] = STATE(1313),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1313),
    [sym_augmented_assignment_expression] = STATE(1313),
    [sym_ternary_expression] = STATE(1313),
    [sym_binary_expression] = STATE(1313),
    [sym_unary_expression] = STATE(1313),
    [sym_update_expression] = STATE(1313),
    [sym_string] = STATE(1128),
    [sym_template_string] = STATE(1313),
    [sym_regex] = STATE(1313),
    [sym_meta_property] = STATE(1313),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1313),
    [sym_type_assertion] = STATE(1313),
    [sym_as_expression] = STATE(1313),
    [sym_internal_module] = STATE(1313),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(343),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(947),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(951),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_DASH] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(955),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(957),
    [sym_this] = ACTIONS(959),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_null] = ACTIONS(963),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(965),
    [anon_sym_number] = ACTIONS(965),
    [anon_sym_boolean] = ACTIONS(965),
    [anon_sym_string] = ACTIONS(965),
    [anon_sym_symbol] = ACTIONS(965),
    [sym_readonly] = ACTIONS(610),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [99] = {
    [sym_import] = STATE(1504),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1504),
    [sym_yield_expression] = STATE(1504),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3121),
    [sym_class] = STATE(1504),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1504),
    [sym_arrow_function] = STATE(1504),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1504),
    [sym_new_expression] = STATE(1504),
    [sym_await_expression] = STATE(1504),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1504),
    [sym_augmented_assignment_expression] = STATE(1504),
    [sym_ternary_expression] = STATE(1504),
    [sym_binary_expression] = STATE(1504),
    [sym_unary_expression] = STATE(1504),
    [sym_update_expression] = STATE(1504),
    [sym_string] = STATE(1423),
    [sym_template_string] = STATE(1504),
    [sym_regex] = STATE(1504),
    [sym_meta_property] = STATE(1504),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2648),
    [sym_non_null_expression] = STATE(1504),
    [sym_type_assertion] = STATE(1504),
    [sym_as_expression] = STATE(1504),
    [sym_internal_module] = STATE(1504),
    [sym_nested_type_identifier] = STATE(2055),
    [sym__type] = STATE(2130),
    [sym_constructor_type] = STATE(2130),
    [sym__primary_type] = STATE(2106),
    [sym_generic_type] = STATE(2106),
    [sym_type_predicate] = STATE(2106),
    [sym_type_query] = STATE(2106),
    [sym_index_type_query] = STATE(2106),
    [sym_lookup_type] = STATE(2106),
    [sym_literal_type] = STATE(2106),
    [sym__number] = STATE(2108),
    [sym_existential_type] = STATE(2106),
    [sym_flow_maybe_type] = STATE(2106),
    [sym_parenthesized_type] = STATE(2106),
    [sym_predefined_type] = STATE(2106),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(2106),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(2106),
    [sym_tuple_type] = STATE(2106),
    [sym_union_type] = STATE(2130),
    [sym_intersection_type] = STATE(2130),
    [sym_function_type] = STATE(2130),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(973),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(989),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(991),
    [sym_this] = ACTIONS(993),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(995),
    [sym_false] = ACTIONS(995),
    [sym_null] = ACTIONS(997),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(999),
    [anon_sym_number] = ACTIONS(999),
    [anon_sym_boolean] = ACTIONS(999),
    [anon_sym_string] = ACTIONS(999),
    [anon_sym_symbol] = ACTIONS(999),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(1001),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1003),
  },
  [100] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_arguments] = STATE(1099),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_COLON] = ACTIONS(937),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_GT_GT_GT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_QMARK_QMARK] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [101] = {
    [sym_import] = STATE(1213),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1213),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1213),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1213),
    [sym_arrow_function] = STATE(1213),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1213),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1213),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1579),
    [sym_template_string] = STATE(1213),
    [sym_regex] = STATE(1213),
    [sym_meta_property] = STATE(1213),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1213),
    [sym_type_assertion] = STATE(1213),
    [sym_as_expression] = STATE(1213),
    [sym_internal_module] = STATE(1213),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(391),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1007),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(1011),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(1017),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1023),
    [sym_this] = ACTIONS(1025),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1027),
    [sym_false] = ACTIONS(1027),
    [sym_null] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(1031),
    [anon_sym_number] = ACTIONS(1031),
    [anon_sym_boolean] = ACTIONS(1031),
    [anon_sym_string] = ACTIONS(1031),
    [anon_sym_symbol] = ACTIONS(1031),
    [sym_readonly] = ACTIONS(443),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [102] = {
    [sym_import] = STATE(1498),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1498),
    [sym_yield_expression] = STATE(1498),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1498),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1498),
    [sym_arrow_function] = STATE(1498),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1498),
    [sym_new_expression] = STATE(1498),
    [sym_await_expression] = STATE(1498),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1498),
    [sym_augmented_assignment_expression] = STATE(1498),
    [sym_ternary_expression] = STATE(1498),
    [sym_binary_expression] = STATE(1498),
    [sym_unary_expression] = STATE(1498),
    [sym_update_expression] = STATE(1498),
    [sym_string] = STATE(1769),
    [sym_template_string] = STATE(1498),
    [sym_regex] = STATE(1498),
    [sym_meta_property] = STATE(1498),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1498),
    [sym_type_assertion] = STATE(1498),
    [sym_as_expression] = STATE(1498),
    [sym_internal_module] = STATE(1498),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(360),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(1035),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(1037),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1039),
    [anon_sym_DASH] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(1041),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1043),
    [sym_this] = ACTIONS(1045),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(1051),
    [anon_sym_number] = ACTIONS(1051),
    [anon_sym_boolean] = ACTIONS(1051),
    [anon_sym_string] = ACTIONS(1051),
    [anon_sym_symbol] = ACTIONS(1051),
    [sym_readonly] = ACTIONS(644),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [103] = {
    [sym_import] = STATE(1198),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1198),
    [sym_yield_expression] = STATE(1198),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1198),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1198),
    [sym_arrow_function] = STATE(1198),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1198),
    [sym_new_expression] = STATE(1198),
    [sym_await_expression] = STATE(1198),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1198),
    [sym_augmented_assignment_expression] = STATE(1198),
    [sym_ternary_expression] = STATE(1198),
    [sym_binary_expression] = STATE(1198),
    [sym_unary_expression] = STATE(1198),
    [sym_update_expression] = STATE(1198),
    [sym_string] = STATE(1198),
    [sym_template_string] = STATE(1198),
    [sym_regex] = STATE(1198),
    [sym_meta_property] = STATE(1198),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1198),
    [sym_type_assertion] = STATE(1198),
    [sym_as_expression] = STATE(1198),
    [sym_internal_module] = STATE(1198),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(1057),
  },
  [104] = {
    [sym_import] = STATE(1275),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1275),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1275),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1275),
    [sym_arrow_function] = STATE(1275),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1275),
    [sym_new_expression] = STATE(1275),
    [sym_await_expression] = STATE(1275),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1275),
    [sym_augmented_assignment_expression] = STATE(1275),
    [sym_ternary_expression] = STATE(1275),
    [sym_binary_expression] = STATE(1275),
    [sym_unary_expression] = STATE(1275),
    [sym_update_expression] = STATE(1275),
    [sym_string] = STATE(1751),
    [sym_template_string] = STATE(1275),
    [sym_regex] = STATE(1275),
    [sym_meta_property] = STATE(1275),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1275),
    [sym_type_assertion] = STATE(1275),
    [sym_as_expression] = STATE(1275),
    [sym_internal_module] = STATE(1275),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(412),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(1063),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(1067),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(1077),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1079),
    [sym_this] = ACTIONS(1081),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1083),
    [sym_false] = ACTIONS(1083),
    [sym_null] = ACTIONS(1085),
    [sym_undefined] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(1087),
    [anon_sym_number] = ACTIONS(1087),
    [anon_sym_boolean] = ACTIONS(1087),
    [anon_sym_string] = ACTIONS(1087),
    [anon_sym_symbol] = ACTIONS(1087),
    [sym_readonly] = ACTIONS(704),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [105] = {
    [sym_import] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1660),
    [sym_yield_expression] = STATE(1660),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1660),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1660),
    [sym_arrow_function] = STATE(1660),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1660),
    [sym_new_expression] = STATE(1660),
    [sym_await_expression] = STATE(1660),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1660),
    [sym_augmented_assignment_expression] = STATE(1660),
    [sym_ternary_expression] = STATE(1660),
    [sym_binary_expression] = STATE(1660),
    [sym_unary_expression] = STATE(1660),
    [sym_update_expression] = STATE(1660),
    [sym_string] = STATE(1714),
    [sym_template_string] = STATE(1660),
    [sym_regex] = STATE(1660),
    [sym_meta_property] = STATE(1660),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1660),
    [sym_type_assertion] = STATE(1660),
    [sym_as_expression] = STATE(1660),
    [sym_internal_module] = STATE(1660),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(427),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1099),
    [sym_this] = ACTIONS(1101),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1107),
    [sym_readonly] = ACTIONS(804),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [106] = {
    [sym_import] = STATE(1684),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1684),
    [sym_yield_expression] = STATE(1684),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1684),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1684),
    [sym_arrow_function] = STATE(1684),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1684),
    [sym_new_expression] = STATE(1684),
    [sym_await_expression] = STATE(1684),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1684),
    [sym_augmented_assignment_expression] = STATE(1684),
    [sym_ternary_expression] = STATE(1684),
    [sym_binary_expression] = STATE(1684),
    [sym_unary_expression] = STATE(1684),
    [sym_update_expression] = STATE(1684),
    [sym_string] = STATE(1714),
    [sym_template_string] = STATE(1684),
    [sym_regex] = STATE(1684),
    [sym_meta_property] = STATE(1684),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1684),
    [sym_type_assertion] = STATE(1684),
    [sym_as_expression] = STATE(1684),
    [sym_internal_module] = STATE(1684),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(329),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1109),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1117),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1099),
    [sym_this] = ACTIONS(1101),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_null] = ACTIONS(1119),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(1121),
    [anon_sym_number] = ACTIONS(1121),
    [anon_sym_boolean] = ACTIONS(1121),
    [anon_sym_string] = ACTIONS(1121),
    [anon_sym_symbol] = ACTIONS(1121),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [107] = {
    [sym_import] = STATE(1204),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1128),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1204),
    [sym_type_assertion] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(493),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(1125),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(957),
    [sym_this] = ACTIONS(959),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_null] = ACTIONS(1131),
    [sym_undefined] = ACTIONS(1131),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(1133),
    [anon_sym_number] = ACTIONS(1133),
    [anon_sym_boolean] = ACTIONS(1133),
    [anon_sym_string] = ACTIONS(1133),
    [anon_sym_symbol] = ACTIONS(1133),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [108] = {
    [sym_import] = STATE(1291),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1291),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1291),
    [sym_arrow_function] = STATE(1291),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1291),
    [sym_new_expression] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_string] = STATE(1128),
    [sym_template_string] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2728),
    [sym_non_null_expression] = STATE(1291),
    [sym_type_assertion] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_nested_type_identifier] = STATE(2028),
    [sym__type] = STATE(2342),
    [sym_constructor_type] = STATE(2342),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_type_arguments] = STATE(390),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2827),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2342),
    [sym_intersection_type] = STATE(2342),
    [sym_function_type] = STATE(2342),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(1139),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(1143),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(957),
    [sym_this] = ACTIONS(959),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_null] = ACTIONS(1145),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(1147),
    [anon_sym_number] = ACTIONS(1147),
    [anon_sym_boolean] = ACTIONS(1147),
    [anon_sym_string] = ACTIONS(1147),
    [anon_sym_symbol] = ACTIONS(1147),
    [sym_readonly] = ACTIONS(768),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [109] = {
    [sym_import] = STATE(1237),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1237),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1237),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1237),
    [sym_arrow_function] = STATE(1237),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1237),
    [sym_new_expression] = STATE(1237),
    [sym_await_expression] = STATE(1237),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1237),
    [sym_augmented_assignment_expression] = STATE(1237),
    [sym_ternary_expression] = STATE(1237),
    [sym_binary_expression] = STATE(1237),
    [sym_unary_expression] = STATE(1237),
    [sym_update_expression] = STATE(1237),
    [sym_string] = STATE(1237),
    [sym_template_string] = STATE(1237),
    [sym_regex] = STATE(1237),
    [sym_meta_property] = STATE(1237),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1237),
    [sym_type_assertion] = STATE(1237),
    [sym_as_expression] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1151),
    [sym_this] = ACTIONS(1153),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [110] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_arguments] = STATE(1810),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(935),
    [anon_sym_as] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(937),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_GT_GT_GT] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(937),
    [anon_sym_QMARK_QMARK] = ACTIONS(937),
    [anon_sym_instanceof] = ACTIONS(935),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(937),
  },
  [111] = {
    [sym_import] = STATE(1302),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1302),
    [sym_arrow_function] = STATE(1302),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1302),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1302),
    [sym_type_assertion] = STATE(1302),
    [sym_as_expression] = STATE(1302),
    [sym_internal_module] = STATE(1302),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(1159),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_COLON] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1161),
    [sym_this] = ACTIONS(1163),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1163),
    [sym_false] = ACTIONS(1163),
    [sym_null] = ACTIONS(1163),
    [sym_undefined] = ACTIONS(1163),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [112] = {
    [sym_import] = STATE(1508),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1508),
    [sym_yield_expression] = STATE(1508),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1508),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1508),
    [sym_arrow_function] = STATE(1508),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1508),
    [sym_new_expression] = STATE(1508),
    [sym_await_expression] = STATE(1508),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1508),
    [sym_augmented_assignment_expression] = STATE(1508),
    [sym_ternary_expression] = STATE(1508),
    [sym_binary_expression] = STATE(1508),
    [sym_unary_expression] = STATE(1508),
    [sym_update_expression] = STATE(1508),
    [sym_string] = STATE(1508),
    [sym_template_string] = STATE(1508),
    [sym_regex] = STATE(1508),
    [sym_meta_property] = STATE(1508),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1508),
    [sym_as_expression] = STATE(1508),
    [sym_internal_module] = STATE(1508),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1167),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_undefined] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
    [sym__automatic_semicolon] = ACTIONS(1057),
  },
  [113] = {
    [sym_import] = STATE(1380),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1380),
    [sym_yield_expression] = STATE(1380),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1380),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1380),
    [sym_arrow_function] = STATE(1380),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1380),
    [sym_new_expression] = STATE(1380),
    [sym_await_expression] = STATE(1380),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1380),
    [sym_augmented_assignment_expression] = STATE(1380),
    [sym_ternary_expression] = STATE(1380),
    [sym_binary_expression] = STATE(1380),
    [sym_unary_expression] = STATE(1380),
    [sym_update_expression] = STATE(1380),
    [sym_string] = STATE(1380),
    [sym_template_string] = STATE(1380),
    [sym_regex] = STATE(1380),
    [sym_meta_property] = STATE(1380),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1380),
    [sym_type_assertion] = STATE(1380),
    [sym_as_expression] = STATE(1380),
    [sym_internal_module] = STATE(1380),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1173),
    [sym_this] = ACTIONS(1175),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1175),
    [sym_false] = ACTIONS(1175),
    [sym_null] = ACTIONS(1175),
    [sym_undefined] = ACTIONS(1175),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1057),
  },
  [114] = {
    [sym_import] = STATE(1391),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1391),
    [sym_yield_expression] = STATE(1391),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1391),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1391),
    [sym_arrow_function] = STATE(1391),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1391),
    [sym_new_expression] = STATE(1391),
    [sym_await_expression] = STATE(1391),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1391),
    [sym_augmented_assignment_expression] = STATE(1391),
    [sym_ternary_expression] = STATE(1391),
    [sym_binary_expression] = STATE(1391),
    [sym_unary_expression] = STATE(1391),
    [sym_update_expression] = STATE(1391),
    [sym_string] = STATE(1391),
    [sym_template_string] = STATE(1391),
    [sym_regex] = STATE(1391),
    [sym_meta_property] = STATE(1391),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1391),
    [sym_type_assertion] = STATE(1391),
    [sym_as_expression] = STATE(1391),
    [sym_internal_module] = STATE(1391),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(1177),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1179),
    [sym_this] = ACTIONS(1181),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1181),
    [sym_false] = ACTIONS(1181),
    [sym_null] = ACTIONS(1181),
    [sym_undefined] = ACTIONS(1181),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [anon_sym_implements] = ACTIONS(1055),
    [sym_readonly] = ACTIONS(768),
  },
  [115] = {
    [sym_import] = STATE(1538),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1538),
    [sym_yield_expression] = STATE(1538),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1538),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1538),
    [sym_arrow_function] = STATE(1538),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1538),
    [sym_new_expression] = STATE(1538),
    [sym_await_expression] = STATE(1538),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1538),
    [sym_augmented_assignment_expression] = STATE(1538),
    [sym_ternary_expression] = STATE(1538),
    [sym_binary_expression] = STATE(1538),
    [sym_unary_expression] = STATE(1538),
    [sym_update_expression] = STATE(1538),
    [sym_string] = STATE(1538),
    [sym_template_string] = STATE(1538),
    [sym_regex] = STATE(1538),
    [sym_meta_property] = STATE(1538),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1538),
    [sym_type_assertion] = STATE(1538),
    [sym_as_expression] = STATE(1538),
    [sym_internal_module] = STATE(1538),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(762),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [116] = {
    [sym_import] = STATE(1598),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1598),
    [sym_yield_expression] = STATE(1598),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1598),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1598),
    [sym_arrow_function] = STATE(1598),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1598),
    [sym_new_expression] = STATE(1598),
    [sym_await_expression] = STATE(1598),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1598),
    [sym_augmented_assignment_expression] = STATE(1598),
    [sym_ternary_expression] = STATE(1598),
    [sym_binary_expression] = STATE(1598),
    [sym_unary_expression] = STATE(1598),
    [sym_update_expression] = STATE(1598),
    [sym_string] = STATE(1598),
    [sym_template_string] = STATE(1598),
    [sym_regex] = STATE(1598),
    [sym_meta_property] = STATE(1598),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1598),
    [sym_type_assertion] = STATE(1598),
    [sym_as_expression] = STATE(1598),
    [sym_internal_module] = STATE(1598),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_as] = ACTIONS(1055),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_COLON] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1055),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(1057),
    [anon_sym_PIPE_PIPE] = ACTIONS(1057),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1057),
    [anon_sym_LT_LT] = ACTIONS(1057),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1057),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_PERCENT] = ACTIONS(1057),
    [anon_sym_STAR_STAR] = ACTIONS(1057),
    [anon_sym_LT_EQ] = ACTIONS(1057),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1057),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1057),
    [anon_sym_GT_EQ] = ACTIONS(1057),
    [anon_sym_QMARK_QMARK] = ACTIONS(1057),
    [anon_sym_instanceof] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(824),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1191),
    [sym_this] = ACTIONS(1193),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1193),
    [sym_false] = ACTIONS(1193),
    [sym_null] = ACTIONS(1193),
    [sym_undefined] = ACTIONS(1193),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(1199),
    [anon_sym_as] = ACTIONS(1199),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_in] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1199),
    [anon_sym_AMP_AMP] = ACTIONS(1201),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_GT_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1201),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_LT_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ] = ACTIONS(1199),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ] = ACTIONS(1199),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1201),
    [anon_sym_GT_EQ] = ACTIONS(1201),
    [anon_sym_QMARK_QMARK] = ACTIONS(1201),
    [anon_sym_instanceof] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [sym__automatic_semicolon] = ACTIONS(1203),
  },
  [118] = {
    [sym_statement_block] = STATE(133),
    [ts_builtin_sym_end] = ACTIONS(1205),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_default] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1207),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_var] = ACTIONS(1207),
    [anon_sym_let] = ACTIONS(1207),
    [anon_sym_const] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1207),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1207),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_do] = ACTIONS(1207),
    [anon_sym_try] = ACTIONS(1207),
    [anon_sym_with] = ACTIONS(1207),
    [anon_sym_break] = ACTIONS(1207),
    [anon_sym_continue] = ACTIONS(1207),
    [anon_sym_debugger] = ACTIONS(1207),
    [anon_sym_return] = ACTIONS(1207),
    [anon_sym_throw] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_class] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(1207),
    [anon_sym_new] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_QMARK_QMARK] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym_number] = ACTIONS(1205),
    [sym_this] = ACTIONS(1207),
    [sym_super] = ACTIONS(1207),
    [sym_true] = ACTIONS(1207),
    [sym_false] = ACTIONS(1207),
    [sym_null] = ACTIONS(1207),
    [sym_undefined] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_abstract] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1207),
    [anon_sym_protected] = ACTIONS(1207),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1207),
    [anon_sym_enum] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(1207),
    [sym__automatic_semicolon] = ACTIONS(1205),
  },
  [119] = {
    [sym_statement_block] = STATE(133),
    [ts_builtin_sym_end] = ACTIONS(1205),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_default] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(1207),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_var] = ACTIONS(1207),
    [anon_sym_let] = ACTIONS(1207),
    [anon_sym_const] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1207),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1207),
    [anon_sym_in] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_do] = ACTIONS(1207),
    [anon_sym_try] = ACTIONS(1207),
    [anon_sym_with] = ACTIONS(1207),
    [anon_sym_break] = ACTIONS(1207),
    [anon_sym_continue] = ACTIONS(1207),
    [anon_sym_debugger] = ACTIONS(1207),
    [anon_sym_return] = ACTIONS(1207),
    [anon_sym_throw] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_class] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(1207),
    [anon_sym_new] = ACTIONS(1207),
    [anon_sym_QMARK] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_QMARK_QMARK] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym_number] = ACTIONS(1205),
    [sym_this] = ACTIONS(1207),
    [sym_super] = ACTIONS(1207),
    [sym_true] = ACTIONS(1207),
    [sym_false] = ACTIONS(1207),
    [sym_null] = ACTIONS(1207),
    [sym_undefined] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_abstract] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1207),
    [anon_sym_protected] = ACTIONS(1207),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1207),
    [anon_sym_enum] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(1207),
    [sym__automatic_semicolon] = ACTIONS(1205),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1217),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1217),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1217),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_AMP_AMP] = ACTIONS(1219),
    [anon_sym_PIPE_PIPE] = ACTIONS(1219),
    [anon_sym_GT_GT] = ACTIONS(1217),
    [anon_sym_GT_GT_GT] = ACTIONS(1219),
    [anon_sym_LT_LT] = ACTIONS(1219),
    [anon_sym_AMP] = ACTIONS(1217),
    [anon_sym_CARET] = ACTIONS(1219),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1219),
    [anon_sym_STAR_STAR] = ACTIONS(1219),
    [anon_sym_LT_EQ] = ACTIONS(1219),
    [anon_sym_EQ_EQ] = ACTIONS(1217),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1219),
    [anon_sym_BANG_EQ] = ACTIONS(1217),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1219),
    [anon_sym_GT_EQ] = ACTIONS(1219),
    [anon_sym_QMARK_QMARK] = ACTIONS(1219),
    [anon_sym_instanceof] = ACTIONS(1217),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1221),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1225),
    [anon_sym_export] = ACTIONS(1225),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_type] = ACTIONS(1225),
    [anon_sym_typeof] = ACTIONS(1225),
    [anon_sym_import] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(1225),
    [anon_sym_let] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_await] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_do] = ACTIONS(1225),
    [anon_sym_try] = ACTIONS(1225),
    [anon_sym_with] = ACTIONS(1225),
    [anon_sym_break] = ACTIONS(1225),
    [anon_sym_continue] = ACTIONS(1225),
    [anon_sym_debugger] = ACTIONS(1225),
    [anon_sym_return] = ACTIONS(1225),
    [anon_sym_throw] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_case] = ACTIONS(1225),
    [anon_sym_yield] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1225),
    [anon_sym_async] = ACTIONS(1225),
    [anon_sym_function] = ACTIONS(1225),
    [anon_sym_new] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1227),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_QMARK_QMARK] = ACTIONS(1229),
    [anon_sym_instanceof] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_void] = ACTIONS(1225),
    [anon_sym_delete] = ACTIONS(1225),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1225),
    [sym_super] = ACTIONS(1225),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [sym_null] = ACTIONS(1225),
    [sym_undefined] = ACTIONS(1225),
    [anon_sym_AT] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_abstract] = ACTIONS(1225),
    [anon_sym_get] = ACTIONS(1225),
    [anon_sym_set] = ACTIONS(1225),
    [anon_sym_declare] = ACTIONS(1225),
    [anon_sym_public] = ACTIONS(1225),
    [anon_sym_private] = ACTIONS(1225),
    [anon_sym_protected] = ACTIONS(1225),
    [anon_sym_module] = ACTIONS(1225),
    [anon_sym_any] = ACTIONS(1225),
    [anon_sym_number] = ACTIONS(1225),
    [anon_sym_boolean] = ACTIONS(1225),
    [anon_sym_string] = ACTIONS(1225),
    [anon_sym_symbol] = ACTIONS(1225),
    [anon_sym_interface] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [sym_readonly] = ACTIONS(1225),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_QMARK_QMARK] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1241),
    [anon_sym_namespace] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1239),
    [anon_sym_typeof] = ACTIONS(1239),
    [anon_sym_import] = ACTIONS(1239),
    [anon_sym_var] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1239),
    [anon_sym_const] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1239),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1239),
    [anon_sym_debugger] = ACTIONS(1239),
    [anon_sym_return] = ACTIONS(1239),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1241),
    [anon_sym_class] = ACTIONS(1239),
    [anon_sym_async] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_new] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1243),
    [anon_sym_PIPE_PIPE] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_GT_GT_GT] = ACTIONS(1243),
    [anon_sym_LT_LT] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_CARET] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1243),
    [anon_sym_STAR_STAR] = ACTIONS(1243),
    [anon_sym_LT_EQ] = ACTIONS(1243),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1243),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1243),
    [anon_sym_GT_EQ] = ACTIONS(1243),
    [anon_sym_QMARK_QMARK] = ACTIONS(1243),
    [anon_sym_instanceof] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1239),
    [anon_sym_delete] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_number] = ACTIONS(1237),
    [sym_this] = ACTIONS(1239),
    [sym_super] = ACTIONS(1239),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_null] = ACTIONS(1239),
    [sym_undefined] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1239),
    [anon_sym_abstract] = ACTIONS(1239),
    [anon_sym_get] = ACTIONS(1239),
    [anon_sym_set] = ACTIONS(1239),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_public] = ACTIONS(1239),
    [anon_sym_private] = ACTIONS(1239),
    [anon_sym_protected] = ACTIONS(1239),
    [anon_sym_module] = ACTIONS(1239),
    [anon_sym_any] = ACTIONS(1239),
    [anon_sym_number] = ACTIONS(1239),
    [anon_sym_boolean] = ACTIONS(1239),
    [anon_sym_string] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1239),
    [anon_sym_enum] = ACTIONS(1239),
    [sym_readonly] = ACTIONS(1239),
    [sym__automatic_semicolon] = ACTIONS(1245),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1249),
    [anon_sym_export] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(1249),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1249),
    [anon_sym_import] = ACTIONS(1249),
    [anon_sym_var] = ACTIONS(1249),
    [anon_sym_let] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_in] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_with] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_debugger] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_throw] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1249),
    [anon_sym_GT] = ACTIONS(1249),
    [anon_sym_SLASH] = ACTIONS(1249),
    [anon_sym_DOT] = ACTIONS(1249),
    [anon_sym_class] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1249),
    [anon_sym_function] = ACTIONS(1249),
    [anon_sym_new] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(1249),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1249),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1249),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1249),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_QMARK_QMARK] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1249),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1249),
    [anon_sym_delete] = ACTIONS(1249),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [sym_number] = ACTIONS(1247),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(1249),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [sym_null] = ACTIONS(1249),
    [sym_undefined] = ACTIONS(1249),
    [anon_sym_AT] = ACTIONS(1247),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_abstract] = ACTIONS(1249),
    [anon_sym_get] = ACTIONS(1249),
    [anon_sym_set] = ACTIONS(1249),
    [anon_sym_declare] = ACTIONS(1249),
    [anon_sym_public] = ACTIONS(1249),
    [anon_sym_private] = ACTIONS(1249),
    [anon_sym_protected] = ACTIONS(1249),
    [anon_sym_module] = ACTIONS(1249),
    [anon_sym_any] = ACTIONS(1249),
    [anon_sym_number] = ACTIONS(1249),
    [anon_sym_boolean] = ACTIONS(1249),
    [anon_sym_string] = ACTIONS(1249),
    [anon_sym_symbol] = ACTIONS(1249),
    [anon_sym_interface] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [sym_readonly] = ACTIONS(1249),
    [sym__automatic_semicolon] = ACTIONS(1247),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_QMARK_QMARK] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [sym_this] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_QMARK_QMARK] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1261),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_as] = ACTIONS(1265),
    [anon_sym_namespace] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_typeof] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1265),
    [anon_sym_var] = ACTIONS(1265),
    [anon_sym_let] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_await] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_with] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_debugger] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(1265),
    [anon_sym_function] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1263),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1263),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_QMARK_QMARK] = ACTIONS(1263),
    [anon_sym_instanceof] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_void] = ACTIONS(1265),
    [anon_sym_delete] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_number] = ACTIONS(1263),
    [sym_this] = ACTIONS(1265),
    [sym_super] = ACTIONS(1265),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [sym_null] = ACTIONS(1265),
    [sym_undefined] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(1263),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_abstract] = ACTIONS(1265),
    [anon_sym_get] = ACTIONS(1265),
    [anon_sym_set] = ACTIONS(1265),
    [anon_sym_declare] = ACTIONS(1265),
    [anon_sym_public] = ACTIONS(1265),
    [anon_sym_private] = ACTIONS(1265),
    [anon_sym_protected] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_any] = ACTIONS(1265),
    [anon_sym_number] = ACTIONS(1265),
    [anon_sym_boolean] = ACTIONS(1265),
    [anon_sym_string] = ACTIONS(1265),
    [anon_sym_symbol] = ACTIONS(1265),
    [anon_sym_interface] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [sym_readonly] = ACTIONS(1265),
    [sym__automatic_semicolon] = ACTIONS(1263),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1269),
    [anon_sym_export] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_as] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_type] = ACTIONS(1269),
    [anon_sym_typeof] = ACTIONS(1269),
    [anon_sym_import] = ACTIONS(1269),
    [anon_sym_var] = ACTIONS(1269),
    [anon_sym_let] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_in] = ACTIONS(1271),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_try] = ACTIONS(1269),
    [anon_sym_with] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_debugger] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_throw] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_yield] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_SLASH] = ACTIONS(1269),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_class] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1269),
    [anon_sym_function] = ACTIONS(1269),
    [anon_sym_new] = ACTIONS(1269),
    [anon_sym_QMARK] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_GT_GT_GT] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_BANG_EQ] = ACTIONS(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1273),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_QMARK_QMARK] = ACTIONS(1273),
    [anon_sym_instanceof] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_void] = ACTIONS(1269),
    [anon_sym_delete] = ACTIONS(1269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym_number] = ACTIONS(1267),
    [sym_this] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [sym_null] = ACTIONS(1269),
    [sym_undefined] = ACTIONS(1269),
    [anon_sym_AT] = ACTIONS(1267),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_abstract] = ACTIONS(1269),
    [anon_sym_get] = ACTIONS(1269),
    [anon_sym_set] = ACTIONS(1269),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_public] = ACTIONS(1269),
    [anon_sym_private] = ACTIONS(1269),
    [anon_sym_protected] = ACTIONS(1269),
    [anon_sym_module] = ACTIONS(1269),
    [anon_sym_any] = ACTIONS(1269),
    [anon_sym_number] = ACTIONS(1269),
    [anon_sym_boolean] = ACTIONS(1269),
    [anon_sym_string] = ACTIONS(1269),
    [anon_sym_symbol] = ACTIONS(1269),
    [anon_sym_interface] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [sym_readonly] = ACTIONS(1269),
    [sym__automatic_semicolon] = ACTIONS(1273),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1277),
    [anon_sym_export] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_as] = ACTIONS(1279),
    [anon_sym_namespace] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_type] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_import] = ACTIONS(1277),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_in] = ACTIONS(1279),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_try] = ACTIONS(1277),
    [anon_sym_with] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_debugger] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_throw] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_yield] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1279),
    [anon_sym_SLASH] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1279),
    [anon_sym_class] = ACTIONS(1277),
    [anon_sym_async] = ACTIONS(1277),
    [anon_sym_function] = ACTIONS(1277),
    [anon_sym_new] = ACTIONS(1277),
    [anon_sym_QMARK] = ACTIONS(1279),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1279),
    [anon_sym_GT_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_CARET] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1279),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PERCENT] = ACTIONS(1281),
    [anon_sym_STAR_STAR] = ACTIONS(1281),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1279),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1279),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_QMARK_QMARK] = ACTIONS(1281),
    [anon_sym_instanceof] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_void] = ACTIONS(1277),
    [anon_sym_delete] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1275),
    [sym_number] = ACTIONS(1275),
    [sym_this] = ACTIONS(1277),
    [sym_super] = ACTIONS(1277),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [sym_null] = ACTIONS(1277),
    [sym_undefined] = ACTIONS(1277),
    [anon_sym_AT] = ACTIONS(1275),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_abstract] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(1277),
    [anon_sym_set] = ACTIONS(1277),
    [anon_sym_declare] = ACTIONS(1277),
    [anon_sym_public] = ACTIONS(1277),
    [anon_sym_private] = ACTIONS(1277),
    [anon_sym_protected] = ACTIONS(1277),
    [anon_sym_module] = ACTIONS(1277),
    [anon_sym_any] = ACTIONS(1277),
    [anon_sym_number] = ACTIONS(1277),
    [anon_sym_boolean] = ACTIONS(1277),
    [anon_sym_string] = ACTIONS(1277),
    [anon_sym_symbol] = ACTIONS(1277),
    [anon_sym_interface] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [sym_readonly] = ACTIONS(1277),
    [sym__automatic_semicolon] = ACTIONS(1283),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1285),
    [sym_identifier] = ACTIONS(1287),
    [anon_sym_export] = ACTIONS(1287),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_default] = ACTIONS(1287),
    [anon_sym_as] = ACTIONS(1287),
    [anon_sym_namespace] = ACTIONS(1287),
    [anon_sym_LBRACE] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_type] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1287),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1287),
    [anon_sym_const] = ACTIONS(1287),
    [anon_sym_if] = ACTIONS(1287),
    [anon_sym_else] = ACTIONS(1287),
    [anon_sym_switch] = ACTIONS(1287),
    [anon_sym_for] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1285),
    [anon_sym_await] = ACTIONS(1287),
    [anon_sym_in] = ACTIONS(1287),
    [anon_sym_while] = ACTIONS(1287),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_try] = ACTIONS(1287),
    [anon_sym_with] = ACTIONS(1287),
    [anon_sym_break] = ACTIONS(1287),
    [anon_sym_continue] = ACTIONS(1287),
    [anon_sym_debugger] = ACTIONS(1287),
    [anon_sym_return] = ACTIONS(1287),
    [anon_sym_throw] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1287),
    [anon_sym_yield] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1287),
    [anon_sym_GT] = ACTIONS(1287),
    [anon_sym_SLASH] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_class] = ACTIONS(1287),
    [anon_sym_async] = ACTIONS(1287),
    [anon_sym_function] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1287),
    [anon_sym_QMARK] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_GT_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_CARET] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_PLUS] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1287),
    [anon_sym_PERCENT] = ACTIONS(1285),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1285),
    [anon_sym_QMARK_QMARK] = ACTIONS(1285),
    [anon_sym_instanceof] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1285),
    [anon_sym_void] = ACTIONS(1287),
    [anon_sym_delete] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_SQUOTE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_number] = ACTIONS(1285),
    [sym_this] = ACTIONS(1287),
    [sym_super] = ACTIONS(1287),
    [sym_true] = ACTIONS(1287),
    [sym_false] = ACTIONS(1287),
    [sym_null] = ACTIONS(1287),
    [sym_undefined] = ACTIONS(1287),
    [anon_sym_AT] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1287),
    [anon_sym_abstract] = ACTIONS(1287),
    [anon_sym_get] = ACTIONS(1287),
    [anon_sym_set] = ACTIONS(1287),
    [anon_sym_declare] = ACTIONS(1287),
    [anon_sym_public] = ACTIONS(1287),
    [anon_sym_private] = ACTIONS(1287),
    [anon_sym_protected] = ACTIONS(1287),
    [anon_sym_module] = ACTIONS(1287),
    [anon_sym_any] = ACTIONS(1287),
    [anon_sym_number] = ACTIONS(1287),
    [anon_sym_boolean] = ACTIONS(1287),
    [anon_sym_string] = ACTIONS(1287),
    [anon_sym_symbol] = ACTIONS(1287),
    [anon_sym_interface] = ACTIONS(1287),
    [anon_sym_enum] = ACTIONS(1287),
    [sym_readonly] = ACTIONS(1287),
    [sym__automatic_semicolon] = ACTIONS(1285),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1289),
    [sym_identifier] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1291),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(1293),
    [anon_sym_namespace] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_type] = ACTIONS(1291),
    [anon_sym_typeof] = ACTIONS(1291),
    [anon_sym_import] = ACTIONS(1291),
    [anon_sym_var] = ACTIONS(1291),
    [anon_sym_let] = ACTIONS(1291),
    [anon_sym_const] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_switch] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_await] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_try] = ACTIONS(1291),
    [anon_sym_with] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1291),
    [anon_sym_continue] = ACTIONS(1291),
    [anon_sym_debugger] = ACTIONS(1291),
    [anon_sym_return] = ACTIONS(1291),
    [anon_sym_throw] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1291),
    [anon_sym_yield] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_class] = ACTIONS(1291),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1291),
    [anon_sym_new] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1295),
    [anon_sym_PIPE_PIPE] = ACTIONS(1295),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_GT_GT_GT] = ACTIONS(1295),
    [anon_sym_LT_LT] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_CARET] = ACTIONS(1295),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1295),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_LT_EQ] = ACTIONS(1295),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1295),
    [anon_sym_BANG_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1295),
    [anon_sym_GT_EQ] = ACTIONS(1295),
    [anon_sym_QMARK_QMARK] = ACTIONS(1295),
    [anon_sym_instanceof] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1289),
    [anon_sym_void] = ACTIONS(1291),
    [anon_sym_delete] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(1289),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [sym_number] = ACTIONS(1289),
    [sym_this] = ACTIONS(1291),
    [sym_super] = ACTIONS(1291),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_null] = ACTIONS(1291),
    [sym_undefined] = ACTIONS(1291),
    [anon_sym_AT] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_abstract] = ACTIONS(1291),
    [anon_sym_get] = ACTIONS(1291),
    [anon_sym_set] = ACTIONS(1291),
    [anon_sym_declare] = ACTIONS(1291),
    [anon_sym_public] = ACTIONS(1291),
    [anon_sym_private] = ACTIONS(1291),
    [anon_sym_protected] = ACTIONS(1291),
    [anon_sym_module] = ACTIONS(1291),
    [anon_sym_any] = ACTIONS(1291),
    [anon_sym_number] = ACTIONS(1291),
    [anon_sym_boolean] = ACTIONS(1291),
    [anon_sym_string] = ACTIONS(1291),
    [anon_sym_symbol] = ACTIONS(1291),
    [anon_sym_interface] = ACTIONS(1291),
    [anon_sym_enum] = ACTIONS(1291),
    [sym_readonly] = ACTIONS(1291),
    [sym__automatic_semicolon] = ACTIONS(1297),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1299),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_as] = ACTIONS(1303),
    [anon_sym_namespace] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_type] = ACTIONS(1301),
    [anon_sym_typeof] = ACTIONS(1301),
    [anon_sym_import] = ACTIONS(1301),
    [anon_sym_var] = ACTIONS(1301),
    [anon_sym_let] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [anon_sym_await] = ACTIONS(1301),
    [anon_sym_in] = ACTIONS(1303),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_try] = ACTIONS(1301),
    [anon_sym_with] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_debugger] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_throw] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_class] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1301),
    [anon_sym_function] = ACTIONS(1301),
    [anon_sym_new] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1303),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_QMARK_QMARK] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1301),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_void] = ACTIONS(1301),
    [anon_sym_delete] = ACTIONS(1301),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1299),
    [sym_number] = ACTIONS(1299),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(1301),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_AT] = ACTIONS(1299),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_abstract] = ACTIONS(1301),
    [anon_sym_get] = ACTIONS(1301),
    [anon_sym_set] = ACTIONS(1301),
    [anon_sym_declare] = ACTIONS(1301),
    [anon_sym_public] = ACTIONS(1301),
    [anon_sym_private] = ACTIONS(1301),
    [anon_sym_protected] = ACTIONS(1301),
    [anon_sym_module] = ACTIONS(1301),
    [anon_sym_any] = ACTIONS(1301),
    [anon_sym_number] = ACTIONS(1301),
    [anon_sym_boolean] = ACTIONS(1301),
    [anon_sym_string] = ACTIONS(1301),
    [anon_sym_symbol] = ACTIONS(1301),
    [anon_sym_interface] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [sym_readonly] = ACTIONS(1301),
    [sym__automatic_semicolon] = ACTIONS(1307),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1309),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_namespace] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1309),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_typeof] = ACTIONS(1311),
    [anon_sym_import] = ACTIONS(1311),
    [anon_sym_var] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_else] = ACTIONS(1311),
    [anon_sym_switch] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1309),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [anon_sym_do] = ACTIONS(1311),
    [anon_sym_try] = ACTIONS(1311),
    [anon_sym_with] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_debugger] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_throw] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1311),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_class] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(1311),
    [anon_sym_new] = ACTIONS(1311),
    [anon_sym_QMARK] = ACTIONS(1311),
    [anon_sym_AMP_AMP] = ACTIONS(1309),
    [anon_sym_PIPE_PIPE] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1311),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_PIPE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_LT_EQ] = ACTIONS(1309),
    [anon_sym_EQ_EQ] = ACTIONS(1311),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1309),
    [anon_sym_BANG_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1309),
    [anon_sym_QMARK_QMARK] = ACTIONS(1309),
    [anon_sym_instanceof] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1309),
    [anon_sym_void] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1309),
    [anon_sym_DQUOTE] = ACTIONS(1309),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1309),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_null] = ACTIONS(1311),
    [sym_undefined] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_abstract] = ACTIONS(1311),
    [anon_sym_get] = ACTIONS(1311),
    [anon_sym_set] = ACTIONS(1311),
    [anon_sym_declare] = ACTIONS(1311),
    [anon_sym_public] = ACTIONS(1311),
    [anon_sym_private] = ACTIONS(1311),
    [anon_sym_protected] = ACTIONS(1311),
    [anon_sym_module] = ACTIONS(1311),
    [anon_sym_any] = ACTIONS(1311),
    [anon_sym_number] = ACTIONS(1311),
    [anon_sym_boolean] = ACTIONS(1311),
    [anon_sym_string] = ACTIONS(1311),
    [anon_sym_symbol] = ACTIONS(1311),
    [anon_sym_interface] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [sym_readonly] = ACTIONS(1311),
    [sym__automatic_semicolon] = ACTIONS(1309),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1315),
    [anon_sym_export] = ACTIONS(1315),
    [anon_sym_STAR] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1315),
    [anon_sym_as] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1313),
    [anon_sym_COMMA] = ACTIONS(1319),
    [anon_sym_RBRACE] = ACTIONS(1313),
    [anon_sym_type] = ACTIONS(1315),
    [anon_sym_typeof] = ACTIONS(1315),
    [anon_sym_import] = ACTIONS(1315),
    [anon_sym_var] = ACTIONS(1315),
    [anon_sym_let] = ACTIONS(1315),
    [anon_sym_const] = ACTIONS(1315),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_else] = ACTIONS(1315),
    [anon_sym_switch] = ACTIONS(1315),
    [anon_sym_for] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1315),
    [anon_sym_do] = ACTIONS(1315),
    [anon_sym_try] = ACTIONS(1315),
    [anon_sym_with] = ACTIONS(1315),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_continue] = ACTIONS(1315),
    [anon_sym_debugger] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1315),
    [anon_sym_throw] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1315),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_LT] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1317),
    [anon_sym_SLASH] = ACTIONS(1315),
    [anon_sym_DOT] = ACTIONS(1317),
    [anon_sym_class] = ACTIONS(1315),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_function] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(1315),
    [anon_sym_QMARK] = ACTIONS(1317),
    [anon_sym_AMP_AMP] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1317),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PIPE] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1319),
    [anon_sym_EQ_EQ] = ACTIONS(1317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1319),
    [anon_sym_BANG_EQ] = ACTIONS(1317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1319),
    [anon_sym_QMARK_QMARK] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1313),
    [anon_sym_void] = ACTIONS(1315),
    [anon_sym_delete] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(1313),
    [anon_sym_SQUOTE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1313),
    [sym_number] = ACTIONS(1313),
    [sym_this] = ACTIONS(1315),
    [sym_super] = ACTIONS(1315),
    [sym_true] = ACTIONS(1315),
    [sym_false] = ACTIONS(1315),
    [sym_null] = ACTIONS(1315),
    [sym_undefined] = ACTIONS(1315),
    [anon_sym_AT] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1315),
    [anon_sym_abstract] = ACTIONS(1315),
    [anon_sym_get] = ACTIONS(1315),
    [anon_sym_set] = ACTIONS(1315),
    [anon_sym_declare] = ACTIONS(1315),
    [anon_sym_public] = ACTIONS(1315),
    [anon_sym_private] = ACTIONS(1315),
    [anon_sym_protected] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(1315),
    [anon_sym_any] = ACTIONS(1315),
    [anon_sym_number] = ACTIONS(1315),
    [anon_sym_boolean] = ACTIONS(1315),
    [anon_sym_string] = ACTIONS(1315),
    [anon_sym_symbol] = ACTIONS(1315),
    [anon_sym_interface] = ACTIONS(1315),
    [anon_sym_enum] = ACTIONS(1315),
    [sym_readonly] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1321),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(1325),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_default] = ACTIONS(1325),
    [anon_sym_as] = ACTIONS(1325),
    [anon_sym_namespace] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_type] = ACTIONS(1325),
    [anon_sym_typeof] = ACTIONS(1325),
    [anon_sym_import] = ACTIONS(1325),
    [anon_sym_var] = ACTIONS(1325),
    [anon_sym_let] = ACTIONS(1325),
    [anon_sym_const] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1325),
    [anon_sym_else] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1325),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_await] = ACTIONS(1325),
    [anon_sym_in] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1325),
    [anon_sym_do] = ACTIONS(1325),
    [anon_sym_try] = ACTIONS(1325),
    [anon_sym_with] = ACTIONS(1325),
    [anon_sym_break] = ACTIONS(1325),
    [anon_sym_continue] = ACTIONS(1325),
    [anon_sym_debugger] = ACTIONS(1325),
    [anon_sym_return] = ACTIONS(1325),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_case] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1323),
    [anon_sym_LT] = ACTIONS(1325),
    [anon_sym_GT] = ACTIONS(1325),
    [anon_sym_SLASH] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1325),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_function] = ACTIONS(1325),
    [anon_sym_new] = ACTIONS(1325),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_AMP_AMP] = ACTIONS(1323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1323),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_GT_GT_GT] = ACTIONS(1323),
    [anon_sym_LT_LT] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1323),
    [anon_sym_PIPE] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_PERCENT] = ACTIONS(1323),
    [anon_sym_STAR_STAR] = ACTIONS(1323),
    [anon_sym_LT_EQ] = ACTIONS(1323),
    [anon_sym_EQ_EQ] = ACTIONS(1325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1323),
    [anon_sym_BANG_EQ] = ACTIONS(1325),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1323),
    [anon_sym_GT_EQ] = ACTIONS(1323),
    [anon_sym_QMARK_QMARK] = ACTIONS(1323),
    [anon_sym_instanceof] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_void] = ACTIONS(1325),
    [anon_sym_delete] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1323),
    [sym_number] = ACTIONS(1323),
    [sym_this] = ACTIONS(1325),
    [sym_super] = ACTIONS(1325),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [sym_null] = ACTIONS(1325),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(1323),
    [anon_sym_static] = ACTIONS(1325),
    [anon_sym_abstract] = ACTIONS(1325),
    [anon_sym_get] = ACTIONS(1325),
    [anon_sym_set] = ACTIONS(1325),
    [anon_sym_declare] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1325),
    [anon_sym_private] = ACTIONS(1325),
    [anon_sym_protected] = ACTIONS(1325),
    [anon_sym_module] = ACTIONS(1325),
    [anon_sym_any] = ACTIONS(1325),
    [anon_sym_number] = ACTIONS(1325),
    [anon_sym_boolean] = ACTIONS(1325),
    [anon_sym_string] = ACTIONS(1325),
    [anon_sym_symbol] = ACTIONS(1325),
    [anon_sym_interface] = ACTIONS(1325),
    [anon_sym_enum] = ACTIONS(1325),
    [sym_readonly] = ACTIONS(1325),
    [sym__automatic_semicolon] = ACTIONS(1323),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_export] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_as] = ACTIONS(1331),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1327),
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1329),
    [anon_sym_typeof] = ACTIONS(1329),
    [anon_sym_import] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(1329),
    [anon_sym_let] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_await] = ACTIONS(1329),
    [anon_sym_in] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_try] = ACTIONS(1329),
    [anon_sym_with] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_debugger] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_throw] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_yield] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1329),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_class] = ACTIONS(1329),
    [anon_sym_async] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1329),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_QMARK] = ACTIONS(1331),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_GT_GT] = ACTIONS(1331),
    [anon_sym_GT_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_LT] = ACTIONS(1333),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PERCENT] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1333),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_QMARK_QMARK] = ACTIONS(1333),
    [anon_sym_instanceof] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1327),
    [anon_sym_void] = ACTIONS(1329),
    [anon_sym_delete] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1327),
    [sym_number] = ACTIONS(1327),
    [sym_this] = ACTIONS(1329),
    [sym_super] = ACTIONS(1329),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [sym_null] = ACTIONS(1329),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_abstract] = ACTIONS(1329),
    [anon_sym_get] = ACTIONS(1329),
    [anon_sym_set] = ACTIONS(1329),
    [anon_sym_declare] = ACTIONS(1329),
    [anon_sym_public] = ACTIONS(1329),
    [anon_sym_private] = ACTIONS(1329),
    [anon_sym_protected] = ACTIONS(1329),
    [anon_sym_module] = ACTIONS(1329),
    [anon_sym_any] = ACTIONS(1329),
    [anon_sym_number] = ACTIONS(1329),
    [anon_sym_boolean] = ACTIONS(1329),
    [anon_sym_string] = ACTIONS(1329),
    [anon_sym_symbol] = ACTIONS(1329),
    [anon_sym_interface] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [sym_readonly] = ACTIONS(1329),
    [sym__automatic_semicolon] = ACTIONS(1335),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_export] = ACTIONS(1339),
    [anon_sym_STAR] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1339),
    [anon_sym_as] = ACTIONS(1341),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_COMMA] = ACTIONS(1343),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_type] = ACTIONS(1339),
    [anon_sym_typeof] = ACTIONS(1339),
    [anon_sym_import] = ACTIONS(1339),
    [anon_sym_var] = ACTIONS(1339),
    [anon_sym_let] = ACTIONS(1339),
    [anon_sym_const] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [anon_sym_switch] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_await] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_try] = ACTIONS(1339),
    [anon_sym_with] = ACTIONS(1339),
    [anon_sym_break] = ACTIONS(1339),
    [anon_sym_continue] = ACTIONS(1339),
    [anon_sym_debugger] = ACTIONS(1339),
    [anon_sym_return] = ACTIONS(1339),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1339),
    [anon_sym_yield] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1341),
    [anon_sym_class] = ACTIONS(1339),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_new] = ACTIONS(1339),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_AMP_AMP] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1343),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1343),
    [anon_sym_LT_EQ] = ACTIONS(1343),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1343),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1343),
    [anon_sym_GT_EQ] = ACTIONS(1343),
    [anon_sym_QMARK_QMARK] = ACTIONS(1343),
    [anon_sym_instanceof] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(1339),
    [anon_sym_delete] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1337),
    [anon_sym_DQUOTE] = ACTIONS(1337),
    [anon_sym_SQUOTE] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1337),
    [sym_number] = ACTIONS(1337),
    [sym_this] = ACTIONS(1339),
    [sym_super] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_undefined] = ACTIONS(1339),
    [anon_sym_AT] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1339),
    [anon_sym_abstract] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(1339),
    [anon_sym_set] = ACTIONS(1339),
    [anon_sym_declare] = ACTIONS(1339),
    [anon_sym_public] = ACTIONS(1339),
    [anon_sym_private] = ACTIONS(1339),
    [anon_sym_protected] = ACTIONS(1339),
    [anon_sym_module] = ACTIONS(1339),
    [anon_sym_any] = ACTIONS(1339),
    [anon_sym_number] = ACTIONS(1339),
    [anon_sym_boolean] = ACTIONS(1339),
    [anon_sym_string] = ACTIONS(1339),
    [anon_sym_symbol] = ACTIONS(1339),
    [anon_sym_interface] = ACTIONS(1339),
    [anon_sym_enum] = ACTIONS(1339),
    [sym_readonly] = ACTIONS(1339),
    [sym__automatic_semicolon] = ACTIONS(1345),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_in] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_QMARK_QMARK] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [sym__automatic_semicolon] = ACTIONS(1347),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_as] = ACTIONS(1351),
    [anon_sym_namespace] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_type] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_var] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_switch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_await] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_do] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_with] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1351),
    [anon_sym_continue] = ACTIONS(1351),
    [anon_sym_debugger] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_throw] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1351),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_new] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_GT_GT] = ACTIONS(1351),
    [anon_sym_GT_GT_GT] = ACTIONS(1349),
    [anon_sym_LT_LT] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_QMARK_QMARK] = ACTIONS(1349),
    [anon_sym_instanceof] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_void] = ACTIONS(1351),
    [anon_sym_delete] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1349),
    [sym_number] = ACTIONS(1349),
    [sym_this] = ACTIONS(1351),
    [sym_super] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_undefined] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_get] = ACTIONS(1351),
    [anon_sym_set] = ACTIONS(1351),
    [anon_sym_declare] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_private] = ACTIONS(1351),
    [anon_sym_protected] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_any] = ACTIONS(1351),
    [anon_sym_number] = ACTIONS(1351),
    [anon_sym_boolean] = ACTIONS(1351),
    [anon_sym_string] = ACTIONS(1351),
    [anon_sym_symbol] = ACTIONS(1351),
    [anon_sym_interface] = ACTIONS(1351),
    [anon_sym_enum] = ACTIONS(1351),
    [sym_readonly] = ACTIONS(1351),
    [sym__automatic_semicolon] = ACTIONS(1349),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym_identifier] = ACTIONS(1355),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(1355),
    [anon_sym_import] = ACTIONS(1355),
    [anon_sym_var] = ACTIONS(1355),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_do] = ACTIONS(1355),
    [anon_sym_try] = ACTIONS(1355),
    [anon_sym_with] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_debugger] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_throw] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1355),
    [anon_sym_yield] = ACTIONS(1355),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1355),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1355),
    [anon_sym_class] = ACTIONS(1355),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(1355),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_AMP_AMP] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(1355),
    [anon_sym_GT_GT_GT] = ACTIONS(1353),
    [anon_sym_LT_LT] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PERCENT] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1355),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_QMARK_QMARK] = ACTIONS(1353),
    [anon_sym_instanceof] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_void] = ACTIONS(1355),
    [anon_sym_delete] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1353),
    [sym_number] = ACTIONS(1353),
    [sym_this] = ACTIONS(1355),
    [sym_super] = ACTIONS(1355),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_null] = ACTIONS(1355),
    [sym_undefined] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_abstract] = ACTIONS(1355),
    [anon_sym_get] = ACTIONS(1355),
    [anon_sym_set] = ACTIONS(1355),
    [anon_sym_declare] = ACTIONS(1355),
    [anon_sym_public] = ACTIONS(1355),
    [anon_sym_private] = ACTIONS(1355),
    [anon_sym_protected] = ACTIONS(1355),
    [anon_sym_module] = ACTIONS(1355),
    [anon_sym_any] = ACTIONS(1355),
    [anon_sym_number] = ACTIONS(1355),
    [anon_sym_boolean] = ACTIONS(1355),
    [anon_sym_string] = ACTIONS(1355),
    [anon_sym_symbol] = ACTIONS(1355),
    [anon_sym_interface] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [sym_readonly] = ACTIONS(1355),
    [sym__automatic_semicolon] = ACTIONS(1353),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(1357),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1359),
    [anon_sym_as] = ACTIONS(1361),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1359),
    [anon_sym_typeof] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_let] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_await] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_try] = ACTIONS(1359),
    [anon_sym_with] = ACTIONS(1359),
    [anon_sym_break] = ACTIONS(1359),
    [anon_sym_continue] = ACTIONS(1359),
    [anon_sym_debugger] = ACTIONS(1359),
    [anon_sym_return] = ACTIONS(1359),
    [anon_sym_throw] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1359),
    [anon_sym_yield] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(1361),
    [anon_sym_class] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1359),
    [anon_sym_new] = ACTIONS(1359),
    [anon_sym_QMARK] = ACTIONS(1361),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_GT_GT] = ACTIONS(1361),
    [anon_sym_GT_GT_GT] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_CARET] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1363),
    [anon_sym_STAR_STAR] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ] = ACTIONS(1361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_BANG_EQ] = ACTIONS(1361),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1363),
    [anon_sym_GT_EQ] = ACTIONS(1363),
    [anon_sym_QMARK_QMARK] = ACTIONS(1363),
    [anon_sym_instanceof] = ACTIONS(1361),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_delete] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1357),
    [sym_number] = ACTIONS(1357),
    [sym_this] = ACTIONS(1359),
    [sym_super] = ACTIONS(1359),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_null] = ACTIONS(1359),
    [sym_undefined] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_abstract] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(1359),
    [anon_sym_set] = ACTIONS(1359),
    [anon_sym_declare] = ACTIONS(1359),
    [anon_sym_public] = ACTIONS(1359),
    [anon_sym_private] = ACTIONS(1359),
    [anon_sym_protected] = ACTIONS(1359),
    [anon_sym_module] = ACTIONS(1359),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_interface] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [sym_readonly] = ACTIONS(1359),
    [sym__automatic_semicolon] = ACTIONS(1365),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(1367),
    [sym_identifier] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1369),
    [anon_sym_as] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_COMMA] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1369),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_var] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_await] = ACTIONS(1369),
    [anon_sym_in] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_try] = ACTIONS(1369),
    [anon_sym_with] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_debugger] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1369),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_GT] = ACTIONS(1369),
    [anon_sym_SLASH] = ACTIONS(1369),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1369),
    [anon_sym_AMP_AMP] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1367),
    [anon_sym_GT_GT] = ACTIONS(1369),
    [anon_sym_GT_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_PERCENT] = ACTIONS(1367),
    [anon_sym_STAR_STAR] = ACTIONS(1367),
    [anon_sym_LT_EQ] = ACTIONS(1367),
    [anon_sym_EQ_EQ] = ACTIONS(1369),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1369),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1367),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_QMARK_QMARK] = ACTIONS(1367),
    [anon_sym_instanceof] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_void] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [sym_number] = ACTIONS(1367),
    [sym_this] = ACTIONS(1369),
    [sym_super] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_undefined] = ACTIONS(1369),
    [anon_sym_AT] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1369),
    [anon_sym_abstract] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_interface] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [sym_readonly] = ACTIONS(1369),
    [sym__automatic_semicolon] = ACTIONS(1367),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(1371),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_export] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_as] = ACTIONS(1375),
    [anon_sym_namespace] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1371),
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_type] = ACTIONS(1373),
    [anon_sym_typeof] = ACTIONS(1373),
    [anon_sym_import] = ACTIONS(1373),
    [anon_sym_var] = ACTIONS(1373),
    [anon_sym_let] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1373),
    [anon_sym_in] = ACTIONS(1375),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_try] = ACTIONS(1373),
    [anon_sym_with] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_debugger] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_throw] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1373),
    [anon_sym_DOT] = ACTIONS(1375),
    [anon_sym_class] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1373),
    [anon_sym_new] = ACTIONS(1373),
    [anon_sym_QMARK] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1375),
    [anon_sym_GT_GT_GT] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PERCENT] = ACTIONS(1377),
    [anon_sym_STAR_STAR] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1377),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1377),
    [anon_sym_GT_EQ] = ACTIONS(1377),
    [anon_sym_QMARK_QMARK] = ACTIONS(1377),
    [anon_sym_instanceof] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1371),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_delete] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [sym_number] = ACTIONS(1371),
    [sym_this] = ACTIONS(1373),
    [sym_super] = ACTIONS(1373),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_undefined] = ACTIONS(1373),
    [anon_sym_AT] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_abstract] = ACTIONS(1373),
    [anon_sym_get] = ACTIONS(1373),
    [anon_sym_set] = ACTIONS(1373),
    [anon_sym_declare] = ACTIONS(1373),
    [anon_sym_public] = ACTIONS(1373),
    [anon_sym_private] = ACTIONS(1373),
    [anon_sym_protected] = ACTIONS(1373),
    [anon_sym_module] = ACTIONS(1373),
    [anon_sym_any] = ACTIONS(1373),
    [anon_sym_number] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [anon_sym_interface] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [sym_readonly] = ACTIONS(1373),
    [sym__automatic_semicolon] = ACTIONS(1379),
  },
  [144] = {
    [sym_import] = STATE(1085),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1085),
    [sym_yield_expression] = STATE(1085),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1085),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1085),
    [sym_arrow_function] = STATE(1085),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1085),
    [sym_new_expression] = STATE(1085),
    [sym_await_expression] = STATE(1085),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1085),
    [sym_augmented_assignment_expression] = STATE(1085),
    [sym_spread_element] = STATE(2747),
    [sym_ternary_expression] = STATE(1085),
    [sym_binary_expression] = STATE(1085),
    [sym_unary_expression] = STATE(1085),
    [sym_update_expression] = STATE(1085),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1085),
    [sym_template_string] = STATE(1085),
    [sym_regex] = STATE(1085),
    [sym_meta_property] = STATE(1085),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1085),
    [sym_as_expression] = STATE(1085),
    [sym_internal_module] = STATE(1085),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [aux_sym_array_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1383),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1389),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [sym_null] = ACTIONS(1393),
    [sym_undefined] = ACTIONS(1393),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [145] = {
    [sym_import] = STATE(1085),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1085),
    [sym_yield_expression] = STATE(1085),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1085),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1085),
    [sym_arrow_function] = STATE(1085),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1085),
    [sym_new_expression] = STATE(1085),
    [sym_await_expression] = STATE(1085),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1085),
    [sym_augmented_assignment_expression] = STATE(1085),
    [sym_spread_element] = STATE(2747),
    [sym_ternary_expression] = STATE(1085),
    [sym_binary_expression] = STATE(1085),
    [sym_unary_expression] = STATE(1085),
    [sym_update_expression] = STATE(1085),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1085),
    [sym_template_string] = STATE(1085),
    [sym_regex] = STATE(1085),
    [sym_meta_property] = STATE(1085),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1085),
    [sym_type_assertion] = STATE(1085),
    [sym_as_expression] = STATE(1085),
    [sym_internal_module] = STATE(1085),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [aux_sym_array_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1395),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1389),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [sym_null] = ACTIONS(1393),
    [sym_undefined] = ACTIONS(1393),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [146] = {
    [sym_import] = STATE(1075),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1075),
    [sym_yield_expression] = STATE(1075),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1075),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1075),
    [sym_arrow_function] = STATE(1075),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1075),
    [sym_new_expression] = STATE(1075),
    [sym_await_expression] = STATE(1075),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1075),
    [sym_augmented_assignment_expression] = STATE(1075),
    [sym_spread_element] = STATE(2685),
    [sym_ternary_expression] = STATE(1075),
    [sym_binary_expression] = STATE(1075),
    [sym_unary_expression] = STATE(1075),
    [sym_update_expression] = STATE(1075),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1075),
    [sym_template_string] = STATE(1075),
    [sym_regex] = STATE(1075),
    [sym_meta_property] = STATE(1075),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1075),
    [sym_type_assertion] = STATE(1075),
    [sym_as_expression] = STATE(1075),
    [sym_internal_module] = STATE(1075),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [aux_sym_array_repeat1] = STATE(2681),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1397),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1399),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [sym_null] = ACTIONS(1401),
    [sym_undefined] = ACTIONS(1401),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [147] = {
    [sym_import] = STATE(1088),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1088),
    [sym_yield_expression] = STATE(1088),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1088),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1088),
    [sym_arrow_function] = STATE(1088),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1088),
    [sym_new_expression] = STATE(1088),
    [sym_await_expression] = STATE(1088),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1088),
    [sym_augmented_assignment_expression] = STATE(1088),
    [sym_spread_element] = STATE(2710),
    [sym_ternary_expression] = STATE(1088),
    [sym_binary_expression] = STATE(1088),
    [sym_unary_expression] = STATE(1088),
    [sym_update_expression] = STATE(1088),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1088),
    [sym_template_string] = STATE(1088),
    [sym_regex] = STATE(1088),
    [sym_meta_property] = STATE(1088),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1088),
    [sym_type_assertion] = STATE(1088),
    [sym_as_expression] = STATE(1088),
    [sym_internal_module] = STATE(1088),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [aux_sym_array_repeat1] = STATE(2713),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1403),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1405),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1407),
    [sym_false] = ACTIONS(1407),
    [sym_null] = ACTIONS(1407),
    [sym_undefined] = ACTIONS(1407),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [148] = {
    [sym_import] = STATE(1292),
    [sym_expression_statement] = STATE(171),
    [sym_variable_declaration] = STATE(171),
    [sym_lexical_declaration] = STATE(171),
    [sym_empty_statement] = STATE(171),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1437),
    [sym_array] = STATE(1439),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1409),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_namespace] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1419),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1421),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_get] = ACTIONS(1411),
    [anon_sym_set] = ACTIONS(1411),
    [anon_sym_declare] = ACTIONS(1411),
    [anon_sym_public] = ACTIONS(1411),
    [anon_sym_private] = ACTIONS(1411),
    [anon_sym_protected] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1411),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [sym_readonly] = ACTIONS(1411),
  },
  [149] = {
    [sym_import] = STATE(1292),
    [sym_expression_statement] = STATE(170),
    [sym_variable_declaration] = STATE(170),
    [sym_lexical_declaration] = STATE(170),
    [sym_empty_statement] = STATE(170),
    [sym_parenthesized_expression] = STATE(965),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1437),
    [sym_array] = STATE(1439),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(965),
    [sym_subscript_expression] = STATE(965),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1409),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_namespace] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1411),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1415),
    [anon_sym_let] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1419),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1421),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1411),
    [anon_sym_get] = ACTIONS(1411),
    [anon_sym_set] = ACTIONS(1411),
    [anon_sym_declare] = ACTIONS(1411),
    [anon_sym_public] = ACTIONS(1411),
    [anon_sym_private] = ACTIONS(1411),
    [anon_sym_protected] = ACTIONS(1411),
    [anon_sym_module] = ACTIONS(1411),
    [anon_sym_any] = ACTIONS(1411),
    [anon_sym_number] = ACTIONS(1411),
    [anon_sym_boolean] = ACTIONS(1411),
    [anon_sym_string] = ACTIONS(1411),
    [anon_sym_symbol] = ACTIONS(1411),
    [sym_readonly] = ACTIONS(1411),
  },
  [150] = {
    [sym_import] = STATE(1216),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1216),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1216),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1216),
    [sym_arrow_function] = STATE(1216),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1216),
    [sym_new_expression] = STATE(1216),
    [sym_await_expression] = STATE(1216),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1216),
    [sym_augmented_assignment_expression] = STATE(1216),
    [sym_ternary_expression] = STATE(1216),
    [sym_binary_expression] = STATE(1216),
    [sym_unary_expression] = STATE(1216),
    [sym_update_expression] = STATE(1216),
    [sym_sequence_expression] = STATE(3025),
    [sym_string] = STATE(1216),
    [sym_template_string] = STATE(1216),
    [sym_regex] = STATE(1216),
    [sym_meta_property] = STATE(1216),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1216),
    [sym_type_assertion] = STATE(1216),
    [sym_as_expression] = STATE(1216),
    [sym_internal_module] = STATE(1216),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1423),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(881),
    [sym_false] = ACTIONS(881),
    [sym_null] = ACTIONS(881),
    [sym_undefined] = ACTIONS(881),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [151] = {
    [sym_import] = STATE(1158),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1158),
    [sym_yield_expression] = STATE(1158),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1158),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1158),
    [sym_arrow_function] = STATE(1158),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1158),
    [sym_new_expression] = STATE(1158),
    [sym_await_expression] = STATE(1158),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1158),
    [sym_augmented_assignment_expression] = STATE(1158),
    [sym_ternary_expression] = STATE(1158),
    [sym_binary_expression] = STATE(1158),
    [sym_unary_expression] = STATE(1158),
    [sym_update_expression] = STATE(1158),
    [sym_sequence_expression] = STATE(3133),
    [sym_string] = STATE(1158),
    [sym_template_string] = STATE(1158),
    [sym_regex] = STATE(1158),
    [sym_meta_property] = STATE(1158),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1158),
    [sym_type_assertion] = STATE(1158),
    [sym_as_expression] = STATE(1158),
    [sym_internal_module] = STATE(1158),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1425),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_undefined] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [152] = {
    [sym_import] = STATE(1161),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1161),
    [sym_object] = STATE(1568),
    [sym_array] = STATE(1573),
    [sym_class] = STATE(1161),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1161),
    [sym_arrow_function] = STATE(1161),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1161),
    [sym_new_expression] = STATE(1161),
    [sym_await_expression] = STATE(1161),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1161),
    [sym_augmented_assignment_expression] = STATE(1161),
    [sym_ternary_expression] = STATE(1161),
    [sym_binary_expression] = STATE(1161),
    [sym_unary_expression] = STATE(1161),
    [sym_update_expression] = STATE(1161),
    [sym_sequence_expression] = STATE(3085),
    [sym_string] = STATE(1161),
    [sym_template_string] = STATE(1161),
    [sym_regex] = STATE(1161),
    [sym_meta_property] = STATE(1161),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_rest_parameter] = STATE(2708),
    [sym_non_null_expression] = STATE(1161),
    [sym_type_assertion] = STATE(1161),
    [sym_as_expression] = STATE(1161),
    [sym_internal_module] = STATE(1161),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(1381),
    [anon_sym_export] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(843),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(1387),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1427),
    [sym_this] = ACTIONS(1391),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(895),
    [sym_false] = ACTIONS(895),
    [sym_null] = ACTIONS(895),
    [sym_undefined] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_any] = ACTIONS(843),
    [anon_sym_number] = ACTIONS(843),
    [anon_sym_boolean] = ACTIONS(843),
    [anon_sym_string] = ACTIONS(843),
    [anon_sym_symbol] = ACTIONS(843),
    [sym_readonly] = ACTIONS(887),
  },
  [153] = {
    [sym_import] = STATE(1344),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1344),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1344),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1344),
    [sym_arrow_function] = STATE(1344),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_await_expression] = STATE(1344),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1344),
    [sym_augmented_assignment_expression] = STATE(1344),
    [sym_spread_element] = STATE(2756),
    [sym_ternary_expression] = STATE(1344),
    [sym_binary_expression] = STATE(1344),
    [sym_unary_expression] = STATE(1344),
    [sym_update_expression] = STATE(1344),
    [sym_string] = STATE(1344),
    [sym_template_string] = STATE(1344),
    [sym_regex] = STATE(1344),
    [sym_meta_property] = STATE(1344),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1344),
    [sym_type_assertion] = STATE(1344),
    [sym_as_expression] = STATE(1344),
    [sym_internal_module] = STATE(1344),
    [sym_mapped_type_clause] = STATE(3170),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2755),
    [sym_identifier] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1431),
    [anon_sym_namespace] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(1431),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(1437),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1439),
    [sym_this] = ACTIONS(1441),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [sym_null] = ACTIONS(1441),
    [sym_undefined] = ACTIONS(1441),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_get] = ACTIONS(1431),
    [anon_sym_set] = ACTIONS(1431),
    [anon_sym_declare] = ACTIONS(1431),
    [anon_sym_public] = ACTIONS(1431),
    [anon_sym_private] = ACTIONS(1431),
    [anon_sym_protected] = ACTIONS(1431),
    [anon_sym_module] = ACTIONS(1431),
    [anon_sym_any] = ACTIONS(1431),
    [anon_sym_number] = ACTIONS(1431),
    [anon_sym_boolean] = ACTIONS(1431),
    [anon_sym_string] = ACTIONS(1431),
    [anon_sym_symbol] = ACTIONS(1431),
    [sym_readonly] = ACTIONS(1431),
  },
  [154] = {
    [sym_import] = STATE(1347),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1347),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1347),
    [sym_arrow_function] = STATE(1347),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_spread_element] = STATE(2710),
    [sym_ternary_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_update_expression] = STATE(1347),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_regex] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1347),
    [sym_type_assertion] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_internal_module] = STATE(1347),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2713),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1443),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1445),
    [sym_this] = ACTIONS(1447),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1447),
    [sym_false] = ACTIONS(1447),
    [sym_null] = ACTIONS(1447),
    [sym_undefined] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [155] = {
    [sym_import] = STATE(1368),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1368),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1368),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1368),
    [sym_arrow_function] = STATE(1368),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1368),
    [sym_new_expression] = STATE(1368),
    [sym_await_expression] = STATE(1368),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1368),
    [sym_augmented_assignment_expression] = STATE(1368),
    [sym_spread_element] = STATE(2731),
    [sym_ternary_expression] = STATE(1368),
    [sym_binary_expression] = STATE(1368),
    [sym_unary_expression] = STATE(1368),
    [sym_update_expression] = STATE(1368),
    [sym_string] = STATE(1368),
    [sym_template_string] = STATE(1368),
    [sym_regex] = STATE(1368),
    [sym_meta_property] = STATE(1368),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1368),
    [sym_type_assertion] = STATE(1368),
    [sym_as_expression] = STATE(1368),
    [sym_internal_module] = STATE(1368),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2732),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1449),
    [sym_this] = ACTIONS(933),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(933),
    [sym_false] = ACTIONS(933),
    [sym_null] = ACTIONS(933),
    [sym_undefined] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [156] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_spread_element] = STATE(2761),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1364),
    [sym_type_assertion] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1455),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1455),
    [sym_false] = ACTIONS(1455),
    [sym_null] = ACTIONS(1455),
    [sym_undefined] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [157] = {
    [sym_import] = STATE(1332),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1332),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1332),
    [sym_arrow_function] = STATE(1332),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_spread_element] = STATE(2661),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_string] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_meta_property] = STATE(1332),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1332),
    [sym_type_assertion] = STATE(1332),
    [sym_as_expression] = STATE(1332),
    [sym_internal_module] = STATE(1332),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2666),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(1457),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [158] = {
    [sym_import] = STATE(1361),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1361),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1361),
    [sym_arrow_function] = STATE(1361),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_spread_element] = STATE(2618),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_string] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1361),
    [sym_type_assertion] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_internal_module] = STATE(1361),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2619),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(925),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(925),
    [sym_false] = ACTIONS(925),
    [sym_null] = ACTIONS(925),
    [sym_undefined] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [159] = {
    [sym_import] = STATE(1377),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1377),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1377),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1377),
    [sym_arrow_function] = STATE(1377),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1377),
    [sym_new_expression] = STATE(1377),
    [sym_await_expression] = STATE(1377),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1377),
    [sym_augmented_assignment_expression] = STATE(1377),
    [sym_spread_element] = STATE(2685),
    [sym_ternary_expression] = STATE(1377),
    [sym_binary_expression] = STATE(1377),
    [sym_unary_expression] = STATE(1377),
    [sym_update_expression] = STATE(1377),
    [sym_string] = STATE(1377),
    [sym_template_string] = STATE(1377),
    [sym_regex] = STATE(1377),
    [sym_meta_property] = STATE(1377),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1377),
    [sym_type_assertion] = STATE(1377),
    [sym_as_expression] = STATE(1377),
    [sym_internal_module] = STATE(1377),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2681),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1467),
    [sym_this] = ACTIONS(1469),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_undefined] = ACTIONS(1469),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [160] = {
    [sym_import] = STATE(1416),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1416),
    [sym_yield_expression] = STATE(1416),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1416),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1416),
    [sym_arrow_function] = STATE(1416),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1416),
    [sym_new_expression] = STATE(1416),
    [sym_await_expression] = STATE(1416),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1416),
    [sym_augmented_assignment_expression] = STATE(1416),
    [sym_spread_element] = STATE(2761),
    [sym_ternary_expression] = STATE(1416),
    [sym_binary_expression] = STATE(1416),
    [sym_unary_expression] = STATE(1416),
    [sym_update_expression] = STATE(1416),
    [sym_sequence_expression] = STATE(2587),
    [sym_string] = STATE(1416),
    [sym_template_string] = STATE(1416),
    [sym_regex] = STATE(1416),
    [sym_meta_property] = STATE(1416),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1416),
    [sym_type_assertion] = STATE(1416),
    [sym_as_expression] = STATE(1416),
    [sym_internal_module] = STATE(1416),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1471),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [161] = {
    [sym_import] = STATE(1299),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1299),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1299),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1299),
    [sym_arrow_function] = STATE(1299),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1299),
    [sym_new_expression] = STATE(1299),
    [sym_await_expression] = STATE(1299),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1299),
    [sym_augmented_assignment_expression] = STATE(1299),
    [sym_spread_element] = STATE(2756),
    [sym_ternary_expression] = STATE(1299),
    [sym_binary_expression] = STATE(1299),
    [sym_unary_expression] = STATE(1299),
    [sym_update_expression] = STATE(1299),
    [sym_string] = STATE(1299),
    [sym_template_string] = STATE(1299),
    [sym_regex] = STATE(1299),
    [sym_meta_property] = STATE(1299),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1299),
    [sym_type_assertion] = STATE(1299),
    [sym_as_expression] = STATE(1299),
    [sym_internal_module] = STATE(1299),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2755),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1475),
    [sym_this] = ACTIONS(1477),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [sym_null] = ACTIONS(1477),
    [sym_undefined] = ACTIONS(1477),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [162] = {
    [sym_import] = STATE(1353),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_spread_element] = STATE(2669),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_string] = STATE(1353),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1353),
    [sym_type_assertion] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(929),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(929),
    [sym_false] = ACTIONS(929),
    [sym_null] = ACTIONS(929),
    [sym_undefined] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [163] = {
    [sym_import] = STATE(1363),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1363),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1363),
    [sym_arrow_function] = STATE(1363),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1363),
    [sym_new_expression] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_spread_element] = STATE(2731),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_string] = STATE(1363),
    [sym_template_string] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1363),
    [sym_type_assertion] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2732),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1481),
    [sym_this] = ACTIONS(1483),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1483),
    [sym_false] = ACTIONS(1483),
    [sym_null] = ACTIONS(1483),
    [sym_undefined] = ACTIONS(1483),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [164] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1348),
    [sym_yield_expression] = STATE(1348),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_await_expression] = STATE(1348),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1348),
    [sym_augmented_assignment_expression] = STATE(1348),
    [sym_spread_element] = STATE(2756),
    [sym_ternary_expression] = STATE(1348),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_update_expression] = STATE(1348),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1348),
    [sym_as_expression] = STATE(1348),
    [sym_internal_module] = STATE(1348),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2755),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1485),
    [sym_this] = ACTIONS(919),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_null] = ACTIONS(919),
    [sym_undefined] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [165] = {
    [sym_import] = STATE(1287),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1287),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1287),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1287),
    [sym_arrow_function] = STATE(1287),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1287),
    [sym_new_expression] = STATE(1287),
    [sym_await_expression] = STATE(1287),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1287),
    [sym_augmented_assignment_expression] = STATE(1287),
    [sym_spread_element] = STATE(2747),
    [sym_ternary_expression] = STATE(1287),
    [sym_binary_expression] = STATE(1287),
    [sym_unary_expression] = STATE(1287),
    [sym_update_expression] = STATE(1287),
    [sym_string] = STATE(1287),
    [sym_template_string] = STATE(1287),
    [sym_regex] = STATE(1287),
    [sym_meta_property] = STATE(1287),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1287),
    [sym_type_assertion] = STATE(1287),
    [sym_as_expression] = STATE(1287),
    [sym_internal_module] = STATE(1287),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [166] = {
    [sym_import] = STATE(1305),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1305),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1305),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1305),
    [sym_arrow_function] = STATE(1305),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1305),
    [sym_new_expression] = STATE(1305),
    [sym_await_expression] = STATE(1305),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1305),
    [sym_augmented_assignment_expression] = STATE(1305),
    [sym_spread_element] = STATE(2617),
    [sym_ternary_expression] = STATE(1305),
    [sym_binary_expression] = STATE(1305),
    [sym_unary_expression] = STATE(1305),
    [sym_update_expression] = STATE(1305),
    [sym_string] = STATE(1305),
    [sym_template_string] = STATE(1305),
    [sym_regex] = STATE(1305),
    [sym_meta_property] = STATE(1305),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1305),
    [sym_type_assertion] = STATE(1305),
    [sym_as_expression] = STATE(1305),
    [sym_internal_module] = STATE(1305),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [aux_sym_array_repeat1] = STATE(2615),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(901),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1493),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1495),
    [sym_this] = ACTIONS(1497),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [sym_null] = ACTIONS(1497),
    [sym_undefined] = ACTIONS(1497),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [167] = {
    [sym_export_clause] = STATE(2604),
    [sym__declaration] = STATE(690),
    [sym_variable_declaration] = STATE(690),
    [sym_lexical_declaration] = STATE(690),
    [sym_class_declaration] = STATE(690),
    [sym_function_declaration] = STATE(690),
    [sym_generator_function_declaration] = STATE(690),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(690),
    [sym_ambient_declaration] = STATE(690),
    [sym_abstract_class_declaration] = STATE(690),
    [sym_module] = STATE(690),
    [sym_internal_module] = STATE(690),
    [sym_import_alias] = STATE(690),
    [sym_interface_declaration] = STATE(690),
    [sym_enum_declaration] = STATE(690),
    [sym_type_alias_declaration] = STATE(690),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [aux_sym_object_repeat1] = STATE(2624),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_as] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [168] = {
    [sym_export_clause] = STATE(2604),
    [sym__declaration] = STATE(690),
    [sym_variable_declaration] = STATE(690),
    [sym_lexical_declaration] = STATE(690),
    [sym_class_declaration] = STATE(690),
    [sym_function_declaration] = STATE(690),
    [sym_generator_function_declaration] = STATE(690),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(690),
    [sym_ambient_declaration] = STATE(690),
    [sym_abstract_class_declaration] = STATE(690),
    [sym_module] = STATE(690),
    [sym_internal_module] = STATE(690),
    [sym_import_alias] = STATE(690),
    [sym_interface_declaration] = STATE(690),
    [sym_enum_declaration] = STATE(690),
    [sym_type_alias_declaration] = STATE(690),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [aux_sym_object_repeat1] = STATE(2788),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_as] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [169] = {
    [sym_export_clause] = STATE(2604),
    [sym__declaration] = STATE(690),
    [sym_variable_declaration] = STATE(690),
    [sym_lexical_declaration] = STATE(690),
    [sym_class_declaration] = STATE(690),
    [sym_function_declaration] = STATE(690),
    [sym_generator_function_declaration] = STATE(690),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(690),
    [sym_ambient_declaration] = STATE(690),
    [sym_abstract_class_declaration] = STATE(690),
    [sym_module] = STATE(690),
    [sym_internal_module] = STATE(690),
    [sym_import_alias] = STATE(690),
    [sym_interface_declaration] = STATE(690),
    [sym_enum_declaration] = STATE(690),
    [sym_type_alias_declaration] = STATE(690),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [aux_sym_object_repeat1] = STATE(2635),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1503),
    [anon_sym_as] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [170] = {
    [sym_import] = STATE(1292),
    [sym_expression_statement] = STATE(181),
    [sym_empty_statement] = STATE(181),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [171] = {
    [sym_import] = STATE(1292),
    [sym_expression_statement] = STATE(183),
    [sym_empty_statement] = STATE(183),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_sequence_expression] = STATE(2833),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [172] = {
    [sym_import] = STATE(1160),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1160),
    [sym_yield_expression] = STATE(1160),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_nested_identifier] = STATE(3031),
    [sym_class] = STATE(1160),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1160),
    [sym_arrow_function] = STATE(1160),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1160),
    [sym_new_expression] = STATE(1160),
    [sym_await_expression] = STATE(1160),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1160),
    [sym_augmented_assignment_expression] = STATE(1160),
    [sym_ternary_expression] = STATE(1160),
    [sym_binary_expression] = STATE(1160),
    [sym_unary_expression] = STATE(1160),
    [sym_update_expression] = STATE(1160),
    [sym_string] = STATE(1160),
    [sym_template_string] = STATE(1160),
    [sym_regex] = STATE(1160),
    [sym_meta_property] = STATE(1160),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1160),
    [sym_type_assertion] = STATE(1160),
    [sym_as_expression] = STATE(1160),
    [sym_internal_module] = STATE(1160),
    [sym_nested_type_identifier] = STATE(2284),
    [sym_generic_type] = STATE(2555),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(1542),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1546),
    [sym_this] = ACTIONS(1548),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1548),
    [sym_false] = ACTIONS(1548),
    [sym_null] = ACTIONS(1548),
    [sym_undefined] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [173] = {
    [sym_import] = STATE(1786),
    [sym_parenthesized_expression] = STATE(1028),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1855),
    [sym_array] = STATE(1856),
    [sym_class] = STATE(1786),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1786),
    [sym_arrow_function] = STATE(1786),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1786),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(1028),
    [sym_subscript_expression] = STATE(1028),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1786),
    [sym_template_string] = STATE(1786),
    [sym_regex] = STATE(1786),
    [sym_meta_property] = STATE(1786),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_export] = ACTIONS(1552),
    [anon_sym_namespace] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1552),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_var] = ACTIONS(1556),
    [anon_sym_let] = ACTIONS(1556),
    [anon_sym_const] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1552),
    [anon_sym_get] = ACTIONS(1552),
    [anon_sym_set] = ACTIONS(1552),
    [anon_sym_declare] = ACTIONS(1552),
    [anon_sym_public] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1552),
    [anon_sym_protected] = ACTIONS(1552),
    [anon_sym_module] = ACTIONS(1552),
    [anon_sym_any] = ACTIONS(1552),
    [anon_sym_number] = ACTIONS(1552),
    [anon_sym_boolean] = ACTIONS(1552),
    [anon_sym_string] = ACTIONS(1552),
    [anon_sym_symbol] = ACTIONS(1552),
    [sym_readonly] = ACTIONS(1552),
  },
  [174] = {
    [sym_import] = STATE(1400),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1400),
    [sym_yield_expression] = STATE(1400),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1400),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1400),
    [sym_arrow_function] = STATE(1400),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1400),
    [sym_new_expression] = STATE(1400),
    [sym_await_expression] = STATE(1400),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1400),
    [sym_augmented_assignment_expression] = STATE(1400),
    [sym_ternary_expression] = STATE(1400),
    [sym_binary_expression] = STATE(1400),
    [sym_unary_expression] = STATE(1400),
    [sym_update_expression] = STATE(1400),
    [sym_string] = STATE(1400),
    [sym_template_string] = STATE(1400),
    [sym_regex] = STATE(1400),
    [sym_meta_property] = STATE(1400),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1400),
    [sym_type_assertion] = STATE(1400),
    [sym_as_expression] = STATE(1400),
    [sym_internal_module] = STATE(1400),
    [sym_nested_type_identifier] = STATE(2356),
    [sym_generic_type] = STATE(2734),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1568),
    [sym_this] = ACTIONS(1570),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1570),
    [sym_false] = ACTIONS(1570),
    [sym_null] = ACTIONS(1570),
    [sym_undefined] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [175] = {
    [sym_import] = STATE(1238),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1238),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_nested_identifier] = STATE(3104),
    [sym_class] = STATE(1238),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1238),
    [sym_arrow_function] = STATE(1238),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_await_expression] = STATE(1238),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1238),
    [sym_augmented_assignment_expression] = STATE(1238),
    [sym_ternary_expression] = STATE(1238),
    [sym_binary_expression] = STATE(1238),
    [sym_unary_expression] = STATE(1238),
    [sym_update_expression] = STATE(1238),
    [sym_string] = STATE(1238),
    [sym_template_string] = STATE(1238),
    [sym_regex] = STATE(1238),
    [sym_meta_property] = STATE(1238),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1238),
    [sym_type_assertion] = STATE(1238),
    [sym_as_expression] = STATE(1238),
    [sym_internal_module] = STATE(1238),
    [sym_nested_type_identifier] = STATE(2234),
    [sym_generic_type] = STATE(2574),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1574),
    [sym_this] = ACTIONS(1576),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_null] = ACTIONS(1576),
    [sym_undefined] = ACTIONS(1576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [176] = {
    [sym_import] = STATE(1376),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1376),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1376),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1376),
    [sym_arrow_function] = STATE(1376),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1376),
    [sym_new_expression] = STATE(1376),
    [sym_await_expression] = STATE(1376),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1376),
    [sym_augmented_assignment_expression] = STATE(1376),
    [sym_ternary_expression] = STATE(1376),
    [sym_binary_expression] = STATE(1376),
    [sym_unary_expression] = STATE(1376),
    [sym_update_expression] = STATE(1376),
    [sym_sequence_expression] = STATE(2874),
    [sym_string] = STATE(1376),
    [sym_template_string] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_meta_property] = STATE(1376),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1376),
    [sym_type_assertion] = STATE(1376),
    [sym_as_expression] = STATE(1376),
    [sym_internal_module] = STATE(1376),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1580),
    [sym_this] = ACTIONS(1582),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1582),
    [sym_false] = ACTIONS(1582),
    [sym_null] = ACTIONS(1582),
    [sym_undefined] = ACTIONS(1582),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(1578),
  },
  [177] = {
    [sym_import] = STATE(1397),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1397),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_nested_identifier] = STATE(3031),
    [sym_class] = STATE(1397),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1397),
    [sym_arrow_function] = STATE(1397),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1397),
    [sym_new_expression] = STATE(1397),
    [sym_await_expression] = STATE(1397),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1397),
    [sym_augmented_assignment_expression] = STATE(1397),
    [sym_ternary_expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_unary_expression] = STATE(1397),
    [sym_update_expression] = STATE(1397),
    [sym_string] = STATE(1397),
    [sym_template_string] = STATE(1397),
    [sym_regex] = STATE(1397),
    [sym_meta_property] = STATE(1397),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1397),
    [sym_type_assertion] = STATE(1397),
    [sym_as_expression] = STATE(1397),
    [sym_internal_module] = STATE(1397),
    [sym_nested_type_identifier] = STATE(2375),
    [sym_generic_type] = STATE(2716),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1586),
    [sym_this] = ACTIONS(1588),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1588),
    [sym_false] = ACTIONS(1588),
    [sym_null] = ACTIONS(1588),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [178] = {
    [sym_export_clause] = STATE(2604),
    [sym__declaration] = STATE(690),
    [sym_variable_declaration] = STATE(690),
    [sym_lexical_declaration] = STATE(690),
    [sym_class_declaration] = STATE(690),
    [sym_function_declaration] = STATE(690),
    [sym_generator_function_declaration] = STATE(690),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(690),
    [sym_ambient_declaration] = STATE(690),
    [sym_abstract_class_declaration] = STATE(690),
    [sym_module] = STATE(690),
    [sym_internal_module] = STATE(690),
    [sym_import_alias] = STATE(690),
    [sym_interface_declaration] = STATE(690),
    [sym_enum_declaration] = STATE(690),
    [sym_type_alias_declaration] = STATE(690),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_as] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [179] = {
    [sym__declaration] = STATE(663),
    [sym_variable_declaration] = STATE(663),
    [sym_lexical_declaration] = STATE(663),
    [sym_class_declaration] = STATE(663),
    [sym_function_declaration] = STATE(663),
    [sym_generator_function_declaration] = STATE(663),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(663),
    [sym_ambient_declaration] = STATE(663),
    [sym_abstract_class_declaration] = STATE(663),
    [sym_module] = STATE(663),
    [sym_internal_module] = STATE(663),
    [sym_import_alias] = STATE(663),
    [sym_interface_declaration] = STATE(663),
    [sym_enum_declaration] = STATE(663),
    [sym_type_alias_declaration] = STATE(663),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [aux_sym_object_repeat1] = STATE(2624),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1594),
    [anon_sym_global] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [180] = {
    [sym__declaration] = STATE(663),
    [sym_variable_declaration] = STATE(663),
    [sym_lexical_declaration] = STATE(663),
    [sym_class_declaration] = STATE(663),
    [sym_function_declaration] = STATE(663),
    [sym_generator_function_declaration] = STATE(663),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(663),
    [sym_ambient_declaration] = STATE(663),
    [sym_abstract_class_declaration] = STATE(663),
    [sym_module] = STATE(663),
    [sym_internal_module] = STATE(663),
    [sym_import_alias] = STATE(663),
    [sym_interface_declaration] = STATE(663),
    [sym_enum_declaration] = STATE(663),
    [sym_type_alias_declaration] = STATE(663),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [aux_sym_object_repeat1] = STATE(2635),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1594),
    [anon_sym_global] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [181] = {
    [sym_import] = STATE(1450),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1450),
    [sym_yield_expression] = STATE(1450),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1450),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1450),
    [sym_arrow_function] = STATE(1450),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1450),
    [sym_new_expression] = STATE(1450),
    [sym_await_expression] = STATE(1450),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1450),
    [sym_augmented_assignment_expression] = STATE(1450),
    [sym_ternary_expression] = STATE(1450),
    [sym_binary_expression] = STATE(1450),
    [sym_unary_expression] = STATE(1450),
    [sym_update_expression] = STATE(1450),
    [sym_sequence_expression] = STATE(3205),
    [sym_string] = STATE(1450),
    [sym_template_string] = STATE(1450),
    [sym_regex] = STATE(1450),
    [sym_meta_property] = STATE(1450),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1450),
    [sym_type_assertion] = STATE(1450),
    [sym_as_expression] = STATE(1450),
    [sym_internal_module] = STATE(1450),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1600),
    [sym_this] = ACTIONS(1602),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1602),
    [sym_false] = ACTIONS(1602),
    [sym_null] = ACTIONS(1602),
    [sym_undefined] = ACTIONS(1602),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [182] = {
    [sym__declaration] = STATE(663),
    [sym_variable_declaration] = STATE(663),
    [sym_lexical_declaration] = STATE(663),
    [sym_class_declaration] = STATE(663),
    [sym_function_declaration] = STATE(663),
    [sym_generator_function_declaration] = STATE(663),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(663),
    [sym_ambient_declaration] = STATE(663),
    [sym_abstract_class_declaration] = STATE(663),
    [sym_module] = STATE(663),
    [sym_internal_module] = STATE(663),
    [sym_import_alias] = STATE(663),
    [sym_interface_declaration] = STATE(663),
    [sym_enum_declaration] = STATE(663),
    [sym_type_alias_declaration] = STATE(663),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [aux_sym_object_repeat1] = STATE(2788),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1594),
    [anon_sym_global] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [183] = {
    [sym_import] = STATE(1434),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1434),
    [sym_yield_expression] = STATE(1434),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1434),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1434),
    [sym_arrow_function] = STATE(1434),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1434),
    [sym_new_expression] = STATE(1434),
    [sym_await_expression] = STATE(1434),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1434),
    [sym_augmented_assignment_expression] = STATE(1434),
    [sym_ternary_expression] = STATE(1434),
    [sym_binary_expression] = STATE(1434),
    [sym_unary_expression] = STATE(1434),
    [sym_update_expression] = STATE(1434),
    [sym_sequence_expression] = STATE(3008),
    [sym_string] = STATE(1434),
    [sym_template_string] = STATE(1434),
    [sym_regex] = STATE(1434),
    [sym_meta_property] = STATE(1434),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1434),
    [sym_type_assertion] = STATE(1434),
    [sym_as_expression] = STATE(1434),
    [sym_internal_module] = STATE(1434),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1604),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1606),
    [sym_this] = ACTIONS(1608),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1608),
    [sym_false] = ACTIONS(1608),
    [sym_null] = ACTIONS(1608),
    [sym_undefined] = ACTIONS(1608),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [184] = {
    [sym_export_clause] = STATE(2604),
    [sym__declaration] = STATE(690),
    [sym_variable_declaration] = STATE(690),
    [sym_lexical_declaration] = STATE(690),
    [sym_class_declaration] = STATE(690),
    [sym_function_declaration] = STATE(690),
    [sym_generator_function_declaration] = STATE(690),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(690),
    [sym_ambient_declaration] = STATE(690),
    [sym_abstract_class_declaration] = STATE(690),
    [sym_module] = STATE(690),
    [sym_internal_module] = STATE(690),
    [sym_import_alias] = STATE(690),
    [sym_interface_declaration] = STATE(690),
    [sym_enum_declaration] = STATE(690),
    [sym_type_alias_declaration] = STATE(690),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_as] = ACTIONS(1505),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [185] = {
    [sym_import] = STATE(1620),
    [sym_statement_block] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1620),
    [sym_yield_expression] = STATE(1620),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1620),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1620),
    [sym_arrow_function] = STATE(1620),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1620),
    [sym_new_expression] = STATE(1620),
    [sym_await_expression] = STATE(1620),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1620),
    [sym_augmented_assignment_expression] = STATE(1620),
    [sym_ternary_expression] = STATE(1620),
    [sym_binary_expression] = STATE(1620),
    [sym_unary_expression] = STATE(1620),
    [sym_update_expression] = STATE(1620),
    [sym_string] = STATE(1620),
    [sym_template_string] = STATE(1620),
    [sym_regex] = STATE(1620),
    [sym_meta_property] = STATE(1620),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1620),
    [sym_type_assertion] = STATE(1620),
    [sym_as_expression] = STATE(1620),
    [sym_internal_module] = STATE(1620),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1612),
    [sym_this] = ACTIONS(1614),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1614),
    [sym_false] = ACTIONS(1614),
    [sym_null] = ACTIONS(1614),
    [sym_undefined] = ACTIONS(1614),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [186] = {
    [sym_import] = STATE(1278),
    [sym_statement_block] = STATE(1102),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1278),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1278),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1278),
    [sym_arrow_function] = STATE(1278),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1278),
    [sym_new_expression] = STATE(1278),
    [sym_await_expression] = STATE(1278),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1278),
    [sym_augmented_assignment_expression] = STATE(1278),
    [sym_ternary_expression] = STATE(1278),
    [sym_binary_expression] = STATE(1278),
    [sym_unary_expression] = STATE(1278),
    [sym_update_expression] = STATE(1278),
    [sym_string] = STATE(1278),
    [sym_template_string] = STATE(1278),
    [sym_regex] = STATE(1278),
    [sym_meta_property] = STATE(1278),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1278),
    [sym_type_assertion] = STATE(1278),
    [sym_as_expression] = STATE(1278),
    [sym_internal_module] = STATE(1278),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1616),
    [sym_this] = ACTIONS(1618),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1618),
    [sym_false] = ACTIONS(1618),
    [sym_null] = ACTIONS(1618),
    [sym_undefined] = ACTIONS(1618),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [187] = {
    [sym_import] = STATE(1169),
    [sym_statement_block] = STATE(1670),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1169),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1169),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1169),
    [sym_arrow_function] = STATE(1169),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1169),
    [sym_new_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1169),
    [sym_augmented_assignment_expression] = STATE(1169),
    [sym_ternary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_update_expression] = STATE(1169),
    [sym_string] = STATE(1169),
    [sym_template_string] = STATE(1169),
    [sym_regex] = STATE(1169),
    [sym_meta_property] = STATE(1169),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1169),
    [sym_type_assertion] = STATE(1169),
    [sym_as_expression] = STATE(1169),
    [sym_internal_module] = STATE(1169),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1622),
    [sym_this] = ACTIONS(1624),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1624),
    [sym_false] = ACTIONS(1624),
    [sym_null] = ACTIONS(1624),
    [sym_undefined] = ACTIONS(1624),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [188] = {
    [sym_import] = STATE(1633),
    [sym_statement_block] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1633),
    [sym_yield_expression] = STATE(1633),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1633),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1633),
    [sym_arrow_function] = STATE(1633),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1633),
    [sym_new_expression] = STATE(1633),
    [sym_await_expression] = STATE(1633),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1633),
    [sym_augmented_assignment_expression] = STATE(1633),
    [sym_ternary_expression] = STATE(1633),
    [sym_binary_expression] = STATE(1633),
    [sym_unary_expression] = STATE(1633),
    [sym_update_expression] = STATE(1633),
    [sym_string] = STATE(1633),
    [sym_template_string] = STATE(1633),
    [sym_regex] = STATE(1633),
    [sym_meta_property] = STATE(1633),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1633),
    [sym_type_assertion] = STATE(1633),
    [sym_as_expression] = STATE(1633),
    [sym_internal_module] = STATE(1633),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1626),
    [sym_this] = ACTIONS(1628),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1628),
    [sym_false] = ACTIONS(1628),
    [sym_null] = ACTIONS(1628),
    [sym_undefined] = ACTIONS(1628),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [189] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1630),
    [anon_sym_export] = ACTIONS(1632),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1632),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1638),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1640),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1632),
    [anon_sym_get] = ACTIONS(1632),
    [anon_sym_set] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1632),
    [anon_sym_public] = ACTIONS(1632),
    [anon_sym_private] = ACTIONS(1632),
    [anon_sym_protected] = ACTIONS(1632),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_any] = ACTIONS(1632),
    [anon_sym_number] = ACTIONS(1632),
    [anon_sym_boolean] = ACTIONS(1632),
    [anon_sym_string] = ACTIONS(1632),
    [anon_sym_symbol] = ACTIONS(1632),
    [sym_readonly] = ACTIONS(1632),
  },
  [190] = {
    [sym_import] = STATE(1371),
    [sym_statement_block] = STATE(1718),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1371),
    [sym_yield_expression] = STATE(1371),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1371),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1371),
    [sym_arrow_function] = STATE(1371),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1371),
    [sym_new_expression] = STATE(1371),
    [sym_await_expression] = STATE(1371),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1371),
    [sym_augmented_assignment_expression] = STATE(1371),
    [sym_ternary_expression] = STATE(1371),
    [sym_binary_expression] = STATE(1371),
    [sym_unary_expression] = STATE(1371),
    [sym_update_expression] = STATE(1371),
    [sym_string] = STATE(1371),
    [sym_template_string] = STATE(1371),
    [sym_regex] = STATE(1371),
    [sym_meta_property] = STATE(1371),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1371),
    [sym_type_assertion] = STATE(1371),
    [sym_as_expression] = STATE(1371),
    [sym_internal_module] = STATE(1371),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1648),
    [sym_this] = ACTIONS(1650),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [sym_undefined] = ACTIONS(1650),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [191] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2693),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2939),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1654),
    [anon_sym_namespace] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1660),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1654),
    [anon_sym_get] = ACTIONS(1654),
    [anon_sym_set] = ACTIONS(1654),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_public] = ACTIONS(1654),
    [anon_sym_private] = ACTIONS(1654),
    [anon_sym_protected] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1654),
    [anon_sym_any] = ACTIONS(1654),
    [anon_sym_number] = ACTIONS(1654),
    [anon_sym_boolean] = ACTIONS(1654),
    [anon_sym_string] = ACTIONS(1654),
    [anon_sym_symbol] = ACTIONS(1654),
    [sym_readonly] = ACTIONS(1654),
  },
  [192] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1662),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [193] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [194] = {
    [sym_import] = STATE(1298),
    [sym_statement_block] = STATE(1122),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1298),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1298),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1298),
    [sym_arrow_function] = STATE(1298),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1298),
    [sym_new_expression] = STATE(1298),
    [sym_await_expression] = STATE(1298),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1298),
    [sym_augmented_assignment_expression] = STATE(1298),
    [sym_ternary_expression] = STATE(1298),
    [sym_binary_expression] = STATE(1298),
    [sym_unary_expression] = STATE(1298),
    [sym_update_expression] = STATE(1298),
    [sym_string] = STATE(1298),
    [sym_template_string] = STATE(1298),
    [sym_regex] = STATE(1298),
    [sym_meta_property] = STATE(1298),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1298),
    [sym_type_assertion] = STATE(1298),
    [sym_as_expression] = STATE(1298),
    [sym_internal_module] = STATE(1298),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1666),
    [sym_this] = ACTIONS(1668),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [sym_null] = ACTIONS(1668),
    [sym_undefined] = ACTIONS(1668),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [195] = {
    [sym_import] = STATE(1627),
    [sym_statement_block] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1627),
    [sym_yield_expression] = STATE(1627),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1627),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1627),
    [sym_arrow_function] = STATE(1627),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1627),
    [sym_new_expression] = STATE(1627),
    [sym_await_expression] = STATE(1627),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1627),
    [sym_augmented_assignment_expression] = STATE(1627),
    [sym_ternary_expression] = STATE(1627),
    [sym_binary_expression] = STATE(1627),
    [sym_unary_expression] = STATE(1627),
    [sym_update_expression] = STATE(1627),
    [sym_string] = STATE(1627),
    [sym_template_string] = STATE(1627),
    [sym_regex] = STATE(1627),
    [sym_meta_property] = STATE(1627),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1627),
    [sym_type_assertion] = STATE(1627),
    [sym_as_expression] = STATE(1627),
    [sym_internal_module] = STATE(1627),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1670),
    [sym_this] = ACTIONS(1672),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_null] = ACTIONS(1672),
    [sym_undefined] = ACTIONS(1672),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [196] = {
    [sym_import] = STATE(1405),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1734),
    [sym_yield_expression] = STATE(1734),
    [sym_object] = STATE(1399),
    [sym_array] = STATE(1370),
    [sym_class] = STATE(1405),
    [sym_function] = STATE(1369),
    [sym_generator_function] = STATE(1405),
    [sym_arrow_function] = STATE(1405),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1734),
    [sym_new_expression] = STATE(1405),
    [sym_await_expression] = STATE(1734),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1734),
    [sym_augmented_assignment_expression] = STATE(1734),
    [sym_ternary_expression] = STATE(1734),
    [sym_binary_expression] = STATE(1734),
    [sym_unary_expression] = STATE(1734),
    [sym_update_expression] = STATE(1734),
    [sym_string] = STATE(1405),
    [sym_template_string] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_meta_property] = STATE(1405),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1734),
    [sym_type_assertion] = STATE(1734),
    [sym_as_expression] = STATE(1734),
    [sym_internal_module] = STATE(1734),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(1674),
    [anon_sym_export] = ACTIONS(1676),
    [anon_sym_namespace] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(1676),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(1682),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1684),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_get] = ACTIONS(1676),
    [anon_sym_set] = ACTIONS(1676),
    [anon_sym_declare] = ACTIONS(1676),
    [anon_sym_public] = ACTIONS(1676),
    [anon_sym_private] = ACTIONS(1676),
    [anon_sym_protected] = ACTIONS(1676),
    [anon_sym_module] = ACTIONS(1676),
    [anon_sym_any] = ACTIONS(1676),
    [anon_sym_number] = ACTIONS(1676),
    [anon_sym_boolean] = ACTIONS(1676),
    [anon_sym_string] = ACTIONS(1676),
    [anon_sym_symbol] = ACTIONS(1676),
    [sym_readonly] = ACTIONS(1676),
  },
  [197] = {
    [sym_import] = STATE(1693),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1693),
    [sym_yield_expression] = STATE(1693),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1693),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1693),
    [sym_arrow_function] = STATE(1693),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1693),
    [sym_new_expression] = STATE(1693),
    [sym_await_expression] = STATE(1693),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1693),
    [sym_augmented_assignment_expression] = STATE(1693),
    [sym_ternary_expression] = STATE(1693),
    [sym_binary_expression] = STATE(1693),
    [sym_unary_expression] = STATE(1693),
    [sym_update_expression] = STATE(1693),
    [sym_string] = STATE(1693),
    [sym_template_string] = STATE(1693),
    [sym_regex] = STATE(1693),
    [sym_meta_property] = STATE(1693),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1693),
    [sym_type_assertion] = STATE(1693),
    [sym_as_expression] = STATE(1693),
    [sym_internal_module] = STATE(1693),
    [sym_mapped_type_clause] = STATE(3170),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_export] = ACTIONS(1694),
    [anon_sym_namespace] = ACTIONS(1696),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1694),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1698),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1700),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1702),
    [sym_this] = ACTIONS(1704),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1704),
    [sym_false] = ACTIONS(1704),
    [sym_null] = ACTIONS(1704),
    [sym_undefined] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1694),
    [anon_sym_get] = ACTIONS(1694),
    [anon_sym_set] = ACTIONS(1694),
    [anon_sym_declare] = ACTIONS(1694),
    [anon_sym_public] = ACTIONS(1694),
    [anon_sym_private] = ACTIONS(1694),
    [anon_sym_protected] = ACTIONS(1694),
    [anon_sym_module] = ACTIONS(1694),
    [anon_sym_any] = ACTIONS(1694),
    [anon_sym_number] = ACTIONS(1694),
    [anon_sym_boolean] = ACTIONS(1694),
    [anon_sym_string] = ACTIONS(1694),
    [anon_sym_symbol] = ACTIONS(1694),
    [sym_readonly] = ACTIONS(1694),
  },
  [198] = {
    [sym_import] = STATE(1624),
    [sym_statement_block] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1624),
    [sym_yield_expression] = STATE(1624),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1624),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1624),
    [sym_arrow_function] = STATE(1624),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1624),
    [sym_new_expression] = STATE(1624),
    [sym_await_expression] = STATE(1624),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1624),
    [sym_augmented_assignment_expression] = STATE(1624),
    [sym_ternary_expression] = STATE(1624),
    [sym_binary_expression] = STATE(1624),
    [sym_unary_expression] = STATE(1624),
    [sym_update_expression] = STATE(1624),
    [sym_string] = STATE(1624),
    [sym_template_string] = STATE(1624),
    [sym_regex] = STATE(1624),
    [sym_meta_property] = STATE(1624),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1624),
    [sym_type_assertion] = STATE(1624),
    [sym_as_expression] = STATE(1624),
    [sym_internal_module] = STATE(1624),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1706),
    [sym_this] = ACTIONS(1708),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1708),
    [sym_false] = ACTIONS(1708),
    [sym_null] = ACTIONS(1708),
    [sym_undefined] = ACTIONS(1708),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [199] = {
    [sym_import] = STATE(1623),
    [sym_statement_block] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1623),
    [sym_yield_expression] = STATE(1623),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1623),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1623),
    [sym_arrow_function] = STATE(1623),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1623),
    [sym_new_expression] = STATE(1623),
    [sym_await_expression] = STATE(1623),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1623),
    [sym_augmented_assignment_expression] = STATE(1623),
    [sym_ternary_expression] = STATE(1623),
    [sym_binary_expression] = STATE(1623),
    [sym_unary_expression] = STATE(1623),
    [sym_update_expression] = STATE(1623),
    [sym_string] = STATE(1623),
    [sym_template_string] = STATE(1623),
    [sym_regex] = STATE(1623),
    [sym_meta_property] = STATE(1623),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1623),
    [sym_type_assertion] = STATE(1623),
    [sym_as_expression] = STATE(1623),
    [sym_internal_module] = STATE(1623),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1710),
    [sym_this] = ACTIONS(1712),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1712),
    [sym_false] = ACTIONS(1712),
    [sym_null] = ACTIONS(1712),
    [sym_undefined] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [200] = {
    [sym_import] = STATE(1621),
    [sym_statement_block] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1621),
    [sym_yield_expression] = STATE(1621),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1621),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1621),
    [sym_arrow_function] = STATE(1621),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1621),
    [sym_new_expression] = STATE(1621),
    [sym_await_expression] = STATE(1621),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1621),
    [sym_augmented_assignment_expression] = STATE(1621),
    [sym_ternary_expression] = STATE(1621),
    [sym_binary_expression] = STATE(1621),
    [sym_unary_expression] = STATE(1621),
    [sym_update_expression] = STATE(1621),
    [sym_string] = STATE(1621),
    [sym_template_string] = STATE(1621),
    [sym_regex] = STATE(1621),
    [sym_meta_property] = STATE(1621),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1621),
    [sym_type_assertion] = STATE(1621),
    [sym_as_expression] = STATE(1621),
    [sym_internal_module] = STATE(1621),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1714),
    [sym_this] = ACTIONS(1716),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1716),
    [sym_false] = ACTIONS(1716),
    [sym_null] = ACTIONS(1716),
    [sym_undefined] = ACTIONS(1716),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [201] = {
    [sym_import] = STATE(1383),
    [sym_statement_block] = STATE(1106),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1383),
    [sym_yield_expression] = STATE(1383),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1383),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1383),
    [sym_arrow_function] = STATE(1383),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1383),
    [sym_new_expression] = STATE(1383),
    [sym_await_expression] = STATE(1383),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1383),
    [sym_augmented_assignment_expression] = STATE(1383),
    [sym_ternary_expression] = STATE(1383),
    [sym_binary_expression] = STATE(1383),
    [sym_unary_expression] = STATE(1383),
    [sym_update_expression] = STATE(1383),
    [sym_string] = STATE(1383),
    [sym_template_string] = STATE(1383),
    [sym_regex] = STATE(1383),
    [sym_meta_property] = STATE(1383),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1383),
    [sym_type_assertion] = STATE(1383),
    [sym_as_expression] = STATE(1383),
    [sym_internal_module] = STATE(1383),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1718),
    [sym_this] = ACTIONS(1720),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1720),
    [sym_false] = ACTIONS(1720),
    [sym_null] = ACTIONS(1720),
    [sym_undefined] = ACTIONS(1720),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [202] = {
    [sym_import] = STATE(1273),
    [sym_statement_block] = STATE(1215),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1273),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1273),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1273),
    [sym_arrow_function] = STATE(1273),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_ternary_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_update_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_regex] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1273),
    [sym_type_assertion] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_internal_module] = STATE(1273),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1722),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [203] = {
    [sym_import] = STATE(1373),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1726),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(798),
    [sym_this] = ACTIONS(800),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(800),
    [sym_false] = ACTIONS(800),
    [sym_null] = ACTIONS(800),
    [sym_undefined] = ACTIONS(800),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [204] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_export] = ACTIONS(1730),
    [anon_sym_namespace] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1730),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1734),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1736),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1730),
    [anon_sym_get] = ACTIONS(1730),
    [anon_sym_set] = ACTIONS(1730),
    [anon_sym_declare] = ACTIONS(1730),
    [anon_sym_public] = ACTIONS(1730),
    [anon_sym_private] = ACTIONS(1730),
    [anon_sym_protected] = ACTIONS(1730),
    [anon_sym_module] = ACTIONS(1730),
    [anon_sym_any] = ACTIONS(1730),
    [anon_sym_number] = ACTIONS(1730),
    [anon_sym_boolean] = ACTIONS(1730),
    [anon_sym_string] = ACTIONS(1730),
    [anon_sym_symbol] = ACTIONS(1730),
    [sym_readonly] = ACTIONS(1730),
  },
  [205] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_export] = ACTIONS(1730),
    [anon_sym_namespace] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1730),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1734),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1736),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1730),
    [anon_sym_get] = ACTIONS(1730),
    [anon_sym_set] = ACTIONS(1730),
    [anon_sym_declare] = ACTIONS(1730),
    [anon_sym_public] = ACTIONS(1730),
    [anon_sym_private] = ACTIONS(1730),
    [anon_sym_protected] = ACTIONS(1730),
    [anon_sym_module] = ACTIONS(1730),
    [anon_sym_any] = ACTIONS(1730),
    [anon_sym_number] = ACTIONS(1730),
    [anon_sym_boolean] = ACTIONS(1730),
    [anon_sym_string] = ACTIONS(1730),
    [anon_sym_symbol] = ACTIONS(1730),
    [sym_readonly] = ACTIONS(1730),
  },
  [206] = {
    [sym_import] = STATE(1124),
    [sym_statement_block] = STATE(1103),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1124),
    [sym_type_assertion] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1738),
    [sym_this] = ACTIONS(1740),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1740),
    [sym_false] = ACTIONS(1740),
    [sym_null] = ACTIONS(1740),
    [sym_undefined] = ACTIONS(1740),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [207] = {
    [sym_import] = STATE(1286),
    [sym_statement_block] = STATE(1753),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1286),
    [sym_type_assertion] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1742),
    [sym_this] = ACTIONS(1744),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1744),
    [sym_false] = ACTIONS(1744),
    [sym_null] = ACTIONS(1744),
    [sym_undefined] = ACTIONS(1744),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [208] = {
    [sym_import] = STATE(1118),
    [sym_statement_block] = STATE(1106),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1118),
    [sym_yield_expression] = STATE(1118),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1118),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1118),
    [sym_arrow_function] = STATE(1118),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1118),
    [sym_new_expression] = STATE(1118),
    [sym_await_expression] = STATE(1118),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1118),
    [sym_augmented_assignment_expression] = STATE(1118),
    [sym_ternary_expression] = STATE(1118),
    [sym_binary_expression] = STATE(1118),
    [sym_unary_expression] = STATE(1118),
    [sym_update_expression] = STATE(1118),
    [sym_string] = STATE(1118),
    [sym_template_string] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_meta_property] = STATE(1118),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1118),
    [sym_type_assertion] = STATE(1118),
    [sym_as_expression] = STATE(1118),
    [sym_internal_module] = STATE(1118),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1746),
    [sym_this] = ACTIONS(1748),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1748),
    [sym_false] = ACTIONS(1748),
    [sym_null] = ACTIONS(1748),
    [sym_undefined] = ACTIONS(1748),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [209] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_nested_identifier] = STATE(2063),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1750),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [210] = {
    [sym_import] = STATE(1470),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1470),
    [sym_yield_expression] = STATE(1470),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1470),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1470),
    [sym_arrow_function] = STATE(1470),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1470),
    [sym_new_expression] = STATE(1470),
    [sym_await_expression] = STATE(1470),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1470),
    [sym_augmented_assignment_expression] = STATE(1470),
    [sym_ternary_expression] = STATE(1470),
    [sym_binary_expression] = STATE(1470),
    [sym_unary_expression] = STATE(1470),
    [sym_update_expression] = STATE(1470),
    [sym_sequence_expression] = STATE(3032),
    [sym_string] = STATE(1470),
    [sym_template_string] = STATE(1470),
    [sym_regex] = STATE(1470),
    [sym_meta_property] = STATE(1470),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1470),
    [sym_type_assertion] = STATE(1470),
    [sym_as_expression] = STATE(1470),
    [sym_internal_module] = STATE(1470),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1752),
    [sym_this] = ACTIONS(1754),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1754),
    [sym_false] = ACTIONS(1754),
    [sym_null] = ACTIONS(1754),
    [sym_undefined] = ACTIONS(1754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [211] = {
    [sym_import] = STATE(1100),
    [sym_statement_block] = STATE(1215),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1100),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1100),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1100),
    [sym_arrow_function] = STATE(1100),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1100),
    [sym_new_expression] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1100),
    [sym_augmented_assignment_expression] = STATE(1100),
    [sym_ternary_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_update_expression] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym_template_string] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_meta_property] = STATE(1100),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1100),
    [sym_as_expression] = STATE(1100),
    [sym_internal_module] = STATE(1100),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1756),
    [sym_this] = ACTIONS(1758),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1758),
    [sym_false] = ACTIONS(1758),
    [sym_null] = ACTIONS(1758),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [212] = {
    [sym_import] = STATE(1130),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1130),
    [sym_yield_expression] = STATE(1130),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1130),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1130),
    [sym_arrow_function] = STATE(1130),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1130),
    [sym_new_expression] = STATE(1130),
    [sym_await_expression] = STATE(1130),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1130),
    [sym_augmented_assignment_expression] = STATE(1130),
    [sym_ternary_expression] = STATE(1130),
    [sym_binary_expression] = STATE(1130),
    [sym_unary_expression] = STATE(1130),
    [sym_update_expression] = STATE(1130),
    [sym_sequence_expression] = STATE(2587),
    [sym_string] = STATE(1130),
    [sym_template_string] = STATE(1130),
    [sym_regex] = STATE(1130),
    [sym_meta_property] = STATE(1130),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1130),
    [sym_type_assertion] = STATE(1130),
    [sym_as_expression] = STATE(1130),
    [sym_internal_module] = STATE(1130),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1760),
    [sym_this] = ACTIONS(1762),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_null] = ACTIONS(1762),
    [sym_undefined] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [213] = {
    [sym_import] = STATE(1500),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1500),
    [sym_yield_expression] = STATE(1500),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1500),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1500),
    [sym_arrow_function] = STATE(1500),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1500),
    [sym_new_expression] = STATE(1500),
    [sym_await_expression] = STATE(1500),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1500),
    [sym_augmented_assignment_expression] = STATE(1500),
    [sym_ternary_expression] = STATE(1500),
    [sym_binary_expression] = STATE(1500),
    [sym_unary_expression] = STATE(1500),
    [sym_update_expression] = STATE(1500),
    [sym_sequence_expression] = STATE(3106),
    [sym_string] = STATE(1500),
    [sym_template_string] = STATE(1500),
    [sym_regex] = STATE(1500),
    [sym_meta_property] = STATE(1500),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(1500),
    [sym_as_expression] = STATE(1500),
    [sym_internal_module] = STATE(1500),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1764),
    [sym_this] = ACTIONS(1766),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1766),
    [sym_false] = ACTIONS(1766),
    [sym_null] = ACTIONS(1766),
    [sym_undefined] = ACTIONS(1766),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [214] = {
    [sym_import] = STATE(1503),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1503),
    [sym_yield_expression] = STATE(1503),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1503),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1503),
    [sym_arrow_function] = STATE(1503),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1503),
    [sym_new_expression] = STATE(1503),
    [sym_await_expression] = STATE(1503),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1503),
    [sym_augmented_assignment_expression] = STATE(1503),
    [sym_ternary_expression] = STATE(1503),
    [sym_binary_expression] = STATE(1503),
    [sym_unary_expression] = STATE(1503),
    [sym_update_expression] = STATE(1503),
    [sym_sequence_expression] = STATE(3102),
    [sym_string] = STATE(1503),
    [sym_template_string] = STATE(1503),
    [sym_regex] = STATE(1503),
    [sym_meta_property] = STATE(1503),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1503),
    [sym_as_expression] = STATE(1503),
    [sym_internal_module] = STATE(1503),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1768),
    [sym_this] = ACTIONS(1770),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1770),
    [sym_false] = ACTIONS(1770),
    [sym_null] = ACTIONS(1770),
    [sym_undefined] = ACTIONS(1770),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [215] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(809),
    [sym__expression] = STATE(1780),
    [sym_yield_expression] = STATE(1780),
    [sym_object] = STATE(1243),
    [sym_array] = STATE(1244),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(1248),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1780),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1780),
    [sym_member_expression] = STATE(809),
    [sym_subscript_expression] = STATE(809),
    [sym_assignment_expression] = STATE(1780),
    [sym_augmented_assignment_expression] = STATE(1780),
    [sym_ternary_expression] = STATE(1780),
    [sym_binary_expression] = STATE(1780),
    [sym_unary_expression] = STATE(1780),
    [sym_update_expression] = STATE(1780),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1780),
    [sym_type_assertion] = STATE(1780),
    [sym_as_expression] = STATE(1780),
    [sym_internal_module] = STATE(1780),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_export] = ACTIONS(1774),
    [anon_sym_namespace] = ACTIONS(1776),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1774),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1778),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1782),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1784),
    [sym_this] = ACTIONS(1786),
    [sym_super] = ACTIONS(1788),
    [sym_true] = ACTIONS(1786),
    [sym_false] = ACTIONS(1786),
    [sym_null] = ACTIONS(1786),
    [sym_undefined] = ACTIONS(1786),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1774),
    [anon_sym_get] = ACTIONS(1774),
    [anon_sym_set] = ACTIONS(1774),
    [anon_sym_declare] = ACTIONS(1774),
    [anon_sym_public] = ACTIONS(1774),
    [anon_sym_private] = ACTIONS(1774),
    [anon_sym_protected] = ACTIONS(1774),
    [anon_sym_module] = ACTIONS(1774),
    [anon_sym_any] = ACTIONS(1774),
    [anon_sym_number] = ACTIONS(1774),
    [anon_sym_boolean] = ACTIONS(1774),
    [anon_sym_string] = ACTIONS(1774),
    [anon_sym_symbol] = ACTIONS(1774),
    [sym_readonly] = ACTIONS(1774),
  },
  [216] = {
    [sym_import] = STATE(1511),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1511),
    [sym_yield_expression] = STATE(1511),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1511),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1511),
    [sym_arrow_function] = STATE(1511),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1511),
    [sym_new_expression] = STATE(1511),
    [sym_await_expression] = STATE(1511),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1511),
    [sym_augmented_assignment_expression] = STATE(1511),
    [sym_ternary_expression] = STATE(1511),
    [sym_binary_expression] = STATE(1511),
    [sym_unary_expression] = STATE(1511),
    [sym_update_expression] = STATE(1511),
    [sym_sequence_expression] = STATE(3101),
    [sym_string] = STATE(1511),
    [sym_template_string] = STATE(1511),
    [sym_regex] = STATE(1511),
    [sym_meta_property] = STATE(1511),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1511),
    [sym_type_assertion] = STATE(1511),
    [sym_as_expression] = STATE(1511),
    [sym_internal_module] = STATE(1511),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1790),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [217] = {
    [sym_import] = STATE(1786),
    [sym_variable_declarator] = STATE(2566),
    [sym_parenthesized_expression] = STATE(1025),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1083),
    [sym_array] = STATE(1082),
    [sym_class] = STATE(1786),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1786),
    [sym_arrow_function] = STATE(1786),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1786),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(1025),
    [sym_subscript_expression] = STATE(1025),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1786),
    [sym_template_string] = STATE(1786),
    [sym_regex] = STATE(1786),
    [sym_meta_property] = STATE(1786),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1802),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
    [sym_readonly] = ACTIONS(1796),
  },
  [218] = {
    [sym_import] = STATE(1786),
    [sym_variable_declarator] = STATE(2515),
    [sym_parenthesized_expression] = STATE(1025),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1083),
    [sym_array] = STATE(1082),
    [sym_class] = STATE(1786),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1786),
    [sym_arrow_function] = STATE(1786),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1786),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(1025),
    [sym_subscript_expression] = STATE(1025),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1786),
    [sym_template_string] = STATE(1786),
    [sym_regex] = STATE(1786),
    [sym_meta_property] = STATE(1786),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1802),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
    [sym_readonly] = ACTIONS(1796),
  },
  [219] = {
    [sym_import] = STATE(1658),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1658),
    [sym_yield_expression] = STATE(1658),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1658),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1658),
    [sym_arrow_function] = STATE(1658),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1658),
    [sym_new_expression] = STATE(1658),
    [sym_await_expression] = STATE(1658),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1658),
    [sym_augmented_assignment_expression] = STATE(1658),
    [sym_ternary_expression] = STATE(1658),
    [sym_binary_expression] = STATE(1658),
    [sym_unary_expression] = STATE(1658),
    [sym_update_expression] = STATE(1658),
    [sym_string] = STATE(1658),
    [sym_template_string] = STATE(1658),
    [sym_regex] = STATE(1658),
    [sym_meta_property] = STATE(1658),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1658),
    [sym_type_assertion] = STATE(1658),
    [sym_as_expression] = STATE(1658),
    [sym_internal_module] = STATE(1658),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1804),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(832),
    [sym_this] = ACTIONS(834),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_null] = ACTIONS(834),
    [sym_undefined] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [220] = {
    [sym_import] = STATE(1646),
    [sym_statement_block] = STATE(1215),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1646),
    [sym_yield_expression] = STATE(1646),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1646),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1646),
    [sym_arrow_function] = STATE(1646),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1646),
    [sym_new_expression] = STATE(1646),
    [sym_await_expression] = STATE(1646),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1646),
    [sym_augmented_assignment_expression] = STATE(1646),
    [sym_ternary_expression] = STATE(1646),
    [sym_binary_expression] = STATE(1646),
    [sym_unary_expression] = STATE(1646),
    [sym_update_expression] = STATE(1646),
    [sym_string] = STATE(1646),
    [sym_template_string] = STATE(1646),
    [sym_regex] = STATE(1646),
    [sym_meta_property] = STATE(1646),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1646),
    [sym_type_assertion] = STATE(1646),
    [sym_as_expression] = STATE(1646),
    [sym_internal_module] = STATE(1646),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1806),
    [sym_this] = ACTIONS(1808),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1808),
    [sym_false] = ACTIONS(1808),
    [sym_null] = ACTIONS(1808),
    [sym_undefined] = ACTIONS(1808),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [221] = {
    [sym_import] = STATE(1454),
    [sym_statement_block] = STATE(1670),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1454),
    [sym_yield_expression] = STATE(1454),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1454),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1454),
    [sym_arrow_function] = STATE(1454),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1454),
    [sym_new_expression] = STATE(1454),
    [sym_await_expression] = STATE(1454),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1454),
    [sym_augmented_assignment_expression] = STATE(1454),
    [sym_ternary_expression] = STATE(1454),
    [sym_binary_expression] = STATE(1454),
    [sym_unary_expression] = STATE(1454),
    [sym_update_expression] = STATE(1454),
    [sym_string] = STATE(1454),
    [sym_template_string] = STATE(1454),
    [sym_regex] = STATE(1454),
    [sym_meta_property] = STATE(1454),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1454),
    [sym_type_assertion] = STATE(1454),
    [sym_as_expression] = STATE(1454),
    [sym_internal_module] = STATE(1454),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1810),
    [sym_this] = ACTIONS(1812),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [sym_undefined] = ACTIONS(1812),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [222] = {
    [sym_import] = STATE(1284),
    [sym_statement_block] = STATE(1106),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1284),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1284),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1284),
    [sym_arrow_function] = STATE(1284),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1284),
    [sym_new_expression] = STATE(1284),
    [sym_await_expression] = STATE(1284),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1284),
    [sym_augmented_assignment_expression] = STATE(1284),
    [sym_ternary_expression] = STATE(1284),
    [sym_binary_expression] = STATE(1284),
    [sym_unary_expression] = STATE(1284),
    [sym_update_expression] = STATE(1284),
    [sym_string] = STATE(1284),
    [sym_template_string] = STATE(1284),
    [sym_regex] = STATE(1284),
    [sym_meta_property] = STATE(1284),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1284),
    [sym_type_assertion] = STATE(1284),
    [sym_as_expression] = STATE(1284),
    [sym_internal_module] = STATE(1284),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1814),
    [sym_this] = ACTIONS(1816),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1816),
    [sym_false] = ACTIONS(1816),
    [sym_null] = ACTIONS(1816),
    [sym_undefined] = ACTIONS(1816),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [223] = {
    [sym_import] = STATE(1226),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1226),
    [sym_yield_expression] = STATE(1226),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1226),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1226),
    [sym_arrow_function] = STATE(1226),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1226),
    [sym_new_expression] = STATE(1226),
    [sym_await_expression] = STATE(1226),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1226),
    [sym_augmented_assignment_expression] = STATE(1226),
    [sym_ternary_expression] = STATE(1226),
    [sym_binary_expression] = STATE(1226),
    [sym_unary_expression] = STATE(1226),
    [sym_update_expression] = STATE(1226),
    [sym_sequence_expression] = STATE(3061),
    [sym_string] = STATE(1226),
    [sym_template_string] = STATE(1226),
    [sym_regex] = STATE(1226),
    [sym_meta_property] = STATE(1226),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1226),
    [sym_type_assertion] = STATE(1226),
    [sym_as_expression] = STATE(1226),
    [sym_internal_module] = STATE(1226),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(1820),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1820),
    [sym_false] = ACTIONS(1820),
    [sym_null] = ACTIONS(1820),
    [sym_undefined] = ACTIONS(1820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [224] = {
    [sym_import] = STATE(1643),
    [sym_statement_block] = STATE(1140),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1643),
    [sym_yield_expression] = STATE(1643),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1643),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1643),
    [sym_arrow_function] = STATE(1643),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1643),
    [sym_new_expression] = STATE(1643),
    [sym_await_expression] = STATE(1643),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1643),
    [sym_augmented_assignment_expression] = STATE(1643),
    [sym_ternary_expression] = STATE(1643),
    [sym_binary_expression] = STATE(1643),
    [sym_unary_expression] = STATE(1643),
    [sym_update_expression] = STATE(1643),
    [sym_string] = STATE(1643),
    [sym_template_string] = STATE(1643),
    [sym_regex] = STATE(1643),
    [sym_meta_property] = STATE(1643),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1643),
    [sym_type_assertion] = STATE(1643),
    [sym_as_expression] = STATE(1643),
    [sym_internal_module] = STATE(1643),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1822),
    [sym_this] = ACTIONS(1824),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1824),
    [sym_false] = ACTIONS(1824),
    [sym_null] = ACTIONS(1824),
    [sym_undefined] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [225] = {
    [sym_import] = STATE(1622),
    [sym_statement_block] = STATE(1122),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1622),
    [sym_yield_expression] = STATE(1622),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1622),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1622),
    [sym_arrow_function] = STATE(1622),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1622),
    [sym_new_expression] = STATE(1622),
    [sym_await_expression] = STATE(1622),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1622),
    [sym_augmented_assignment_expression] = STATE(1622),
    [sym_ternary_expression] = STATE(1622),
    [sym_binary_expression] = STATE(1622),
    [sym_unary_expression] = STATE(1622),
    [sym_update_expression] = STATE(1622),
    [sym_string] = STATE(1622),
    [sym_template_string] = STATE(1622),
    [sym_regex] = STATE(1622),
    [sym_meta_property] = STATE(1622),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1622),
    [sym_type_assertion] = STATE(1622),
    [sym_as_expression] = STATE(1622),
    [sym_internal_module] = STATE(1622),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [226] = {
    [sym_import] = STATE(1608),
    [sym_statement_block] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1608),
    [sym_yield_expression] = STATE(1608),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1608),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1608),
    [sym_arrow_function] = STATE(1608),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1608),
    [sym_new_expression] = STATE(1608),
    [sym_await_expression] = STATE(1608),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1608),
    [sym_augmented_assignment_expression] = STATE(1608),
    [sym_ternary_expression] = STATE(1608),
    [sym_binary_expression] = STATE(1608),
    [sym_unary_expression] = STATE(1608),
    [sym_update_expression] = STATE(1608),
    [sym_string] = STATE(1608),
    [sym_template_string] = STATE(1608),
    [sym_regex] = STATE(1608),
    [sym_meta_property] = STATE(1608),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1608),
    [sym_type_assertion] = STATE(1608),
    [sym_as_expression] = STATE(1608),
    [sym_internal_module] = STATE(1608),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1830),
    [sym_this] = ACTIONS(1832),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1832),
    [sym_false] = ACTIONS(1832),
    [sym_null] = ACTIONS(1832),
    [sym_undefined] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [227] = {
    [sym_import] = STATE(1607),
    [sym_statement_block] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1607),
    [sym_yield_expression] = STATE(1607),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1607),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1607),
    [sym_arrow_function] = STATE(1607),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1607),
    [sym_new_expression] = STATE(1607),
    [sym_await_expression] = STATE(1607),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1607),
    [sym_augmented_assignment_expression] = STATE(1607),
    [sym_ternary_expression] = STATE(1607),
    [sym_binary_expression] = STATE(1607),
    [sym_unary_expression] = STATE(1607),
    [sym_update_expression] = STATE(1607),
    [sym_string] = STATE(1607),
    [sym_template_string] = STATE(1607),
    [sym_regex] = STATE(1607),
    [sym_meta_property] = STATE(1607),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1607),
    [sym_type_assertion] = STATE(1607),
    [sym_as_expression] = STATE(1607),
    [sym_internal_module] = STATE(1607),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [228] = {
    [sym_import] = STATE(1606),
    [sym_statement_block] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1606),
    [sym_yield_expression] = STATE(1606),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1606),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1606),
    [sym_arrow_function] = STATE(1606),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1606),
    [sym_new_expression] = STATE(1606),
    [sym_await_expression] = STATE(1606),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1606),
    [sym_augmented_assignment_expression] = STATE(1606),
    [sym_ternary_expression] = STATE(1606),
    [sym_binary_expression] = STATE(1606),
    [sym_unary_expression] = STATE(1606),
    [sym_update_expression] = STATE(1606),
    [sym_string] = STATE(1606),
    [sym_template_string] = STATE(1606),
    [sym_regex] = STATE(1606),
    [sym_meta_property] = STATE(1606),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1606),
    [sym_type_assertion] = STATE(1606),
    [sym_as_expression] = STATE(1606),
    [sym_internal_module] = STATE(1606),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [229] = {
    [sym_import] = STATE(1328),
    [sym_statement_block] = STATE(1140),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1328),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1328),
    [sym_arrow_function] = STATE(1328),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_string] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_meta_property] = STATE(1328),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1328),
    [sym_type_assertion] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [230] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(809),
    [sym__expression] = STATE(1780),
    [sym_yield_expression] = STATE(1780),
    [sym_object] = STATE(1243),
    [sym_array] = STATE(1244),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(1248),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1780),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1780),
    [sym_member_expression] = STATE(809),
    [sym_subscript_expression] = STATE(809),
    [sym_assignment_expression] = STATE(1780),
    [sym_augmented_assignment_expression] = STATE(1780),
    [sym_ternary_expression] = STATE(1780),
    [sym_binary_expression] = STATE(1780),
    [sym_unary_expression] = STATE(1780),
    [sym_update_expression] = STATE(1780),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1780),
    [sym_type_assertion] = STATE(1780),
    [sym_as_expression] = STATE(1780),
    [sym_internal_module] = STATE(1780),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_export] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1848),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1778),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1784),
    [sym_this] = ACTIONS(1786),
    [sym_super] = ACTIONS(1788),
    [sym_true] = ACTIONS(1786),
    [sym_false] = ACTIONS(1786),
    [sym_null] = ACTIONS(1786),
    [sym_undefined] = ACTIONS(1786),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_declare] = ACTIONS(1848),
    [anon_sym_public] = ACTIONS(1848),
    [anon_sym_private] = ACTIONS(1848),
    [anon_sym_protected] = ACTIONS(1848),
    [anon_sym_module] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [sym_readonly] = ACTIONS(1848),
  },
  [231] = {
    [sym_import] = STATE(1349),
    [sym_statement_block] = STATE(1777),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1856),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [232] = {
    [sym_import] = STATE(1280),
    [sym_statement_block] = STATE(1103),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1280),
    [sym_yield_expression] = STATE(1280),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1280),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1280),
    [sym_arrow_function] = STATE(1280),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1280),
    [sym_new_expression] = STATE(1280),
    [sym_await_expression] = STATE(1280),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1280),
    [sym_augmented_assignment_expression] = STATE(1280),
    [sym_ternary_expression] = STATE(1280),
    [sym_binary_expression] = STATE(1280),
    [sym_unary_expression] = STATE(1280),
    [sym_update_expression] = STATE(1280),
    [sym_string] = STATE(1280),
    [sym_template_string] = STATE(1280),
    [sym_regex] = STATE(1280),
    [sym_meta_property] = STATE(1280),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1280),
    [sym_type_assertion] = STATE(1280),
    [sym_as_expression] = STATE(1280),
    [sym_internal_module] = STATE(1280),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1860),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [233] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [234] = {
    [sym_import] = STATE(1175),
    [sym_statement_block] = STATE(1102),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1175),
    [sym_yield_expression] = STATE(1175),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1175),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1175),
    [sym_arrow_function] = STATE(1175),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1175),
    [sym_new_expression] = STATE(1175),
    [sym_await_expression] = STATE(1175),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1175),
    [sym_augmented_assignment_expression] = STATE(1175),
    [sym_ternary_expression] = STATE(1175),
    [sym_binary_expression] = STATE(1175),
    [sym_unary_expression] = STATE(1175),
    [sym_update_expression] = STATE(1175),
    [sym_string] = STATE(1175),
    [sym_template_string] = STATE(1175),
    [sym_regex] = STATE(1175),
    [sym_meta_property] = STATE(1175),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1175),
    [sym_as_expression] = STATE(1175),
    [sym_internal_module] = STATE(1175),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1866),
    [sym_this] = ACTIONS(1868),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1868),
    [sym_false] = ACTIONS(1868),
    [sym_null] = ACTIONS(1868),
    [sym_undefined] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [235] = {
    [sym_import] = STATE(1505),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1505),
    [sym_yield_expression] = STATE(1505),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1505),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1505),
    [sym_arrow_function] = STATE(1505),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1505),
    [sym_new_expression] = STATE(1505),
    [sym_await_expression] = STATE(1505),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1505),
    [sym_augmented_assignment_expression] = STATE(1505),
    [sym_ternary_expression] = STATE(1505),
    [sym_binary_expression] = STATE(1505),
    [sym_unary_expression] = STATE(1505),
    [sym_update_expression] = STATE(1505),
    [sym_string] = STATE(1505),
    [sym_template_string] = STATE(1505),
    [sym_regex] = STATE(1505),
    [sym_meta_property] = STATE(1505),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1505),
    [sym_type_assertion] = STATE(1505),
    [sym_as_expression] = STATE(1505),
    [sym_internal_module] = STATE(1505),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(674),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(676),
    [sym_false] = ACTIONS(676),
    [sym_null] = ACTIONS(676),
    [sym_undefined] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [236] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(809),
    [sym__expression] = STATE(1780),
    [sym_yield_expression] = STATE(1780),
    [sym_object] = STATE(1243),
    [sym_array] = STATE(1244),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(1248),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1780),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1780),
    [sym_member_expression] = STATE(809),
    [sym_subscript_expression] = STATE(809),
    [sym_assignment_expression] = STATE(1780),
    [sym_augmented_assignment_expression] = STATE(1780),
    [sym_ternary_expression] = STATE(1780),
    [sym_binary_expression] = STATE(1780),
    [sym_unary_expression] = STATE(1780),
    [sym_update_expression] = STATE(1780),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1780),
    [sym_type_assertion] = STATE(1780),
    [sym_as_expression] = STATE(1780),
    [sym_internal_module] = STATE(1780),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_export] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1848),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1778),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1854),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1784),
    [sym_this] = ACTIONS(1786),
    [sym_super] = ACTIONS(1788),
    [sym_true] = ACTIONS(1786),
    [sym_false] = ACTIONS(1786),
    [sym_null] = ACTIONS(1786),
    [sym_undefined] = ACTIONS(1786),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_declare] = ACTIONS(1848),
    [anon_sym_public] = ACTIONS(1848),
    [anon_sym_private] = ACTIONS(1848),
    [anon_sym_protected] = ACTIONS(1848),
    [anon_sym_module] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [sym_readonly] = ACTIONS(1848),
  },
  [237] = {
    [sym_import] = STATE(1432),
    [sym_statement_block] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1432),
    [sym_yield_expression] = STATE(1432),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1432),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1432),
    [sym_arrow_function] = STATE(1432),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1432),
    [sym_new_expression] = STATE(1432),
    [sym_await_expression] = STATE(1432),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1432),
    [sym_augmented_assignment_expression] = STATE(1432),
    [sym_ternary_expression] = STATE(1432),
    [sym_binary_expression] = STATE(1432),
    [sym_unary_expression] = STATE(1432),
    [sym_update_expression] = STATE(1432),
    [sym_string] = STATE(1432),
    [sym_template_string] = STATE(1432),
    [sym_regex] = STATE(1432),
    [sym_meta_property] = STATE(1432),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1432),
    [sym_type_assertion] = STATE(1432),
    [sym_as_expression] = STATE(1432),
    [sym_internal_module] = STATE(1432),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1872),
    [sym_this] = ACTIONS(1874),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1874),
    [sym_false] = ACTIONS(1874),
    [sym_null] = ACTIONS(1874),
    [sym_undefined] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [238] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1876),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [239] = {
    [sym_import] = STATE(1433),
    [sym_statement_block] = STATE(1572),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1433),
    [sym_yield_expression] = STATE(1433),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1433),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1433),
    [sym_arrow_function] = STATE(1433),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1433),
    [sym_new_expression] = STATE(1433),
    [sym_await_expression] = STATE(1433),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1433),
    [sym_augmented_assignment_expression] = STATE(1433),
    [sym_ternary_expression] = STATE(1433),
    [sym_binary_expression] = STATE(1433),
    [sym_unary_expression] = STATE(1433),
    [sym_update_expression] = STATE(1433),
    [sym_string] = STATE(1433),
    [sym_template_string] = STATE(1433),
    [sym_regex] = STATE(1433),
    [sym_meta_property] = STATE(1433),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1433),
    [sym_type_assertion] = STATE(1433),
    [sym_as_expression] = STATE(1433),
    [sym_internal_module] = STATE(1433),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1878),
    [sym_this] = ACTIONS(1880),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1880),
    [sym_false] = ACTIONS(1880),
    [sym_null] = ACTIONS(1880),
    [sym_undefined] = ACTIONS(1880),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [240] = {
    [sym_import] = STATE(1440),
    [sym_statement_block] = STATE(1551),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1440),
    [sym_yield_expression] = STATE(1440),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1440),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1440),
    [sym_arrow_function] = STATE(1440),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1440),
    [sym_new_expression] = STATE(1440),
    [sym_await_expression] = STATE(1440),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1440),
    [sym_augmented_assignment_expression] = STATE(1440),
    [sym_ternary_expression] = STATE(1440),
    [sym_binary_expression] = STATE(1440),
    [sym_unary_expression] = STATE(1440),
    [sym_update_expression] = STATE(1440),
    [sym_string] = STATE(1440),
    [sym_template_string] = STATE(1440),
    [sym_regex] = STATE(1440),
    [sym_meta_property] = STATE(1440),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1440),
    [sym_type_assertion] = STATE(1440),
    [sym_as_expression] = STATE(1440),
    [sym_internal_module] = STATE(1440),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1882),
    [sym_this] = ACTIONS(1884),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1884),
    [sym_false] = ACTIONS(1884),
    [sym_null] = ACTIONS(1884),
    [sym_undefined] = ACTIONS(1884),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [241] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(809),
    [sym__expression] = STATE(1780),
    [sym_yield_expression] = STATE(1780),
    [sym_object] = STATE(1243),
    [sym_array] = STATE(1244),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(1248),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1780),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1780),
    [sym_member_expression] = STATE(809),
    [sym_subscript_expression] = STATE(809),
    [sym_assignment_expression] = STATE(1780),
    [sym_augmented_assignment_expression] = STATE(1780),
    [sym_ternary_expression] = STATE(1780),
    [sym_binary_expression] = STATE(1780),
    [sym_unary_expression] = STATE(1780),
    [sym_update_expression] = STATE(1780),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1780),
    [sym_type_assertion] = STATE(1780),
    [sym_as_expression] = STATE(1780),
    [sym_internal_module] = STATE(1780),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_export] = ACTIONS(1774),
    [anon_sym_namespace] = ACTIONS(1776),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1774),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1778),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1780),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1782),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1784),
    [sym_this] = ACTIONS(1786),
    [sym_super] = ACTIONS(1788),
    [sym_true] = ACTIONS(1786),
    [sym_false] = ACTIONS(1786),
    [sym_null] = ACTIONS(1786),
    [sym_undefined] = ACTIONS(1786),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1774),
    [anon_sym_get] = ACTIONS(1774),
    [anon_sym_set] = ACTIONS(1774),
    [anon_sym_declare] = ACTIONS(1774),
    [anon_sym_public] = ACTIONS(1774),
    [anon_sym_private] = ACTIONS(1774),
    [anon_sym_protected] = ACTIONS(1774),
    [anon_sym_module] = ACTIONS(1774),
    [anon_sym_any] = ACTIONS(1774),
    [anon_sym_number] = ACTIONS(1774),
    [anon_sym_boolean] = ACTIONS(1774),
    [anon_sym_string] = ACTIONS(1774),
    [anon_sym_symbol] = ACTIONS(1774),
    [sym_readonly] = ACTIONS(1774),
  },
  [242] = {
    [sym_import] = STATE(1471),
    [sym_statement_block] = STATE(1540),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1471),
    [sym_yield_expression] = STATE(1471),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1471),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1471),
    [sym_arrow_function] = STATE(1471),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1471),
    [sym_new_expression] = STATE(1471),
    [sym_await_expression] = STATE(1471),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1471),
    [sym_augmented_assignment_expression] = STATE(1471),
    [sym_ternary_expression] = STATE(1471),
    [sym_binary_expression] = STATE(1471),
    [sym_unary_expression] = STATE(1471),
    [sym_update_expression] = STATE(1471),
    [sym_string] = STATE(1471),
    [sym_template_string] = STATE(1471),
    [sym_regex] = STATE(1471),
    [sym_meta_property] = STATE(1471),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1471),
    [sym_type_assertion] = STATE(1471),
    [sym_as_expression] = STATE(1471),
    [sym_internal_module] = STATE(1471),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1886),
    [sym_this] = ACTIONS(1888),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1888),
    [sym_false] = ACTIONS(1888),
    [sym_null] = ACTIONS(1888),
    [sym_undefined] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [243] = {
    [sym_import] = STATE(1489),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1489),
    [sym_yield_expression] = STATE(1489),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1489),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1489),
    [sym_arrow_function] = STATE(1489),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1489),
    [sym_new_expression] = STATE(1489),
    [sym_await_expression] = STATE(1489),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1489),
    [sym_augmented_assignment_expression] = STATE(1489),
    [sym_ternary_expression] = STATE(1489),
    [sym_binary_expression] = STATE(1489),
    [sym_unary_expression] = STATE(1489),
    [sym_update_expression] = STATE(1489),
    [sym_sequence_expression] = STATE(3108),
    [sym_string] = STATE(1489),
    [sym_template_string] = STATE(1489),
    [sym_regex] = STATE(1489),
    [sym_meta_property] = STATE(1489),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1489),
    [sym_type_assertion] = STATE(1489),
    [sym_as_expression] = STATE(1489),
    [sym_internal_module] = STATE(1489),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1890),
    [sym_this] = ACTIONS(1892),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1892),
    [sym_false] = ACTIONS(1892),
    [sym_null] = ACTIONS(1892),
    [sym_undefined] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [244] = {
    [sym_import] = STATE(1392),
    [sym_statement_block] = STATE(1140),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1392),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1392),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1392),
    [sym_arrow_function] = STATE(1392),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1392),
    [sym_new_expression] = STATE(1392),
    [sym_await_expression] = STATE(1392),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1392),
    [sym_augmented_assignment_expression] = STATE(1392),
    [sym_ternary_expression] = STATE(1392),
    [sym_binary_expression] = STATE(1392),
    [sym_unary_expression] = STATE(1392),
    [sym_update_expression] = STATE(1392),
    [sym_string] = STATE(1392),
    [sym_template_string] = STATE(1392),
    [sym_regex] = STATE(1392),
    [sym_meta_property] = STATE(1392),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1392),
    [sym_type_assertion] = STATE(1392),
    [sym_as_expression] = STATE(1392),
    [sym_internal_module] = STATE(1392),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1894),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [245] = {
    [sym_import] = STATE(1147),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1147),
    [sym_yield_expression] = STATE(1147),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1147),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1147),
    [sym_arrow_function] = STATE(1147),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1147),
    [sym_new_expression] = STATE(1147),
    [sym_await_expression] = STATE(1147),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1147),
    [sym_augmented_assignment_expression] = STATE(1147),
    [sym_ternary_expression] = STATE(1147),
    [sym_binary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym_update_expression] = STATE(1147),
    [sym_sequence_expression] = STATE(3083),
    [sym_string] = STATE(1147),
    [sym_template_string] = STATE(1147),
    [sym_regex] = STATE(1147),
    [sym_meta_property] = STATE(1147),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1147),
    [sym_type_assertion] = STATE(1147),
    [sym_as_expression] = STATE(1147),
    [sym_internal_module] = STATE(1147),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1898),
    [sym_this] = ACTIONS(1900),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1900),
    [sym_false] = ACTIONS(1900),
    [sym_null] = ACTIONS(1900),
    [sym_undefined] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [246] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_export] = ACTIONS(1904),
    [anon_sym_namespace] = ACTIONS(1906),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1908),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1910),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1904),
    [anon_sym_get] = ACTIONS(1904),
    [anon_sym_set] = ACTIONS(1904),
    [anon_sym_declare] = ACTIONS(1904),
    [anon_sym_public] = ACTIONS(1904),
    [anon_sym_private] = ACTIONS(1904),
    [anon_sym_protected] = ACTIONS(1904),
    [anon_sym_module] = ACTIONS(1904),
    [anon_sym_any] = ACTIONS(1904),
    [anon_sym_number] = ACTIONS(1904),
    [anon_sym_boolean] = ACTIONS(1904),
    [anon_sym_string] = ACTIONS(1904),
    [anon_sym_symbol] = ACTIONS(1904),
    [sym_readonly] = ACTIONS(1904),
  },
  [247] = {
    [sym_import] = STATE(1484),
    [sym_statement_block] = STATE(1614),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1484),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1484),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1484),
    [sym_arrow_function] = STATE(1484),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1484),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1484),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1484),
    [sym_template_string] = STATE(1484),
    [sym_regex] = STATE(1484),
    [sym_meta_property] = STATE(1484),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1484),
    [sym_type_assertion] = STATE(1484),
    [sym_as_expression] = STATE(1484),
    [sym_internal_module] = STATE(1484),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1912),
    [sym_this] = ACTIONS(1914),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1914),
    [sym_false] = ACTIONS(1914),
    [sym_null] = ACTIONS(1914),
    [sym_undefined] = ACTIONS(1914),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [248] = {
    [sym_import] = STATE(1442),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1442),
    [sym_yield_expression] = STATE(1442),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1442),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1442),
    [sym_arrow_function] = STATE(1442),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1442),
    [sym_new_expression] = STATE(1442),
    [sym_await_expression] = STATE(1442),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1442),
    [sym_augmented_assignment_expression] = STATE(1442),
    [sym_ternary_expression] = STATE(1442),
    [sym_binary_expression] = STATE(1442),
    [sym_unary_expression] = STATE(1442),
    [sym_update_expression] = STATE(1442),
    [sym_sequence_expression] = STATE(3164),
    [sym_string] = STATE(1442),
    [sym_template_string] = STATE(1442),
    [sym_regex] = STATE(1442),
    [sym_meta_property] = STATE(1442),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1442),
    [sym_as_expression] = STATE(1442),
    [sym_internal_module] = STATE(1442),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [249] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_export] = ACTIONS(1922),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1922),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1922),
    [anon_sym_get] = ACTIONS(1922),
    [anon_sym_set] = ACTIONS(1922),
    [anon_sym_declare] = ACTIONS(1922),
    [anon_sym_public] = ACTIONS(1922),
    [anon_sym_private] = ACTIONS(1922),
    [anon_sym_protected] = ACTIONS(1922),
    [anon_sym_module] = ACTIONS(1922),
    [anon_sym_any] = ACTIONS(1922),
    [anon_sym_number] = ACTIONS(1922),
    [anon_sym_boolean] = ACTIONS(1922),
    [anon_sym_string] = ACTIONS(1922),
    [anon_sym_symbol] = ACTIONS(1922),
    [sym_readonly] = ACTIONS(1922),
  },
  [250] = {
    [sym_import] = STATE(1497),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1497),
    [sym_yield_expression] = STATE(1497),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1497),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1497),
    [sym_arrow_function] = STATE(1497),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1497),
    [sym_new_expression] = STATE(1497),
    [sym_await_expression] = STATE(1497),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1497),
    [sym_augmented_assignment_expression] = STATE(1497),
    [sym_ternary_expression] = STATE(1497),
    [sym_binary_expression] = STATE(1497),
    [sym_unary_expression] = STATE(1497),
    [sym_update_expression] = STATE(1497),
    [sym_sequence_expression] = STATE(3099),
    [sym_string] = STATE(1497),
    [sym_template_string] = STATE(1497),
    [sym_regex] = STATE(1497),
    [sym_meta_property] = STATE(1497),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1497),
    [sym_type_assertion] = STATE(1497),
    [sym_as_expression] = STATE(1497),
    [sym_internal_module] = STATE(1497),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1932),
    [sym_false] = ACTIONS(1932),
    [sym_null] = ACTIONS(1932),
    [sym_undefined] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [251] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1464),
    [sym_yield_expression] = STATE(1464),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1464),
    [sym_await_expression] = STATE(1464),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1464),
    [sym_augmented_assignment_expression] = STATE(1464),
    [sym_ternary_expression] = STATE(1464),
    [sym_binary_expression] = STATE(1464),
    [sym_unary_expression] = STATE(1464),
    [sym_update_expression] = STATE(1464),
    [sym_sequence_expression] = STATE(3030),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1464),
    [sym_type_assertion] = STATE(1464),
    [sym_as_expression] = STATE(1464),
    [sym_internal_module] = STATE(1464),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1934),
    [sym_this] = ACTIONS(1936),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [sym_null] = ACTIONS(1936),
    [sym_undefined] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [252] = {
    [sym_import] = STATE(1230),
    [sym_statement_block] = STATE(1614),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1230),
    [sym_yield_expression] = STATE(1230),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1230),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1230),
    [sym_arrow_function] = STATE(1230),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1230),
    [sym_new_expression] = STATE(1230),
    [sym_await_expression] = STATE(1230),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1230),
    [sym_augmented_assignment_expression] = STATE(1230),
    [sym_ternary_expression] = STATE(1230),
    [sym_binary_expression] = STATE(1230),
    [sym_unary_expression] = STATE(1230),
    [sym_update_expression] = STATE(1230),
    [sym_string] = STATE(1230),
    [sym_template_string] = STATE(1230),
    [sym_regex] = STATE(1230),
    [sym_meta_property] = STATE(1230),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1230),
    [sym_type_assertion] = STATE(1230),
    [sym_as_expression] = STATE(1230),
    [sym_internal_module] = STATE(1230),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1938),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [sym_null] = ACTIONS(1940),
    [sym_undefined] = ACTIONS(1940),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [253] = {
    [sym_import] = STATE(1375),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1375),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1375),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1375),
    [sym_arrow_function] = STATE(1375),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1375),
    [sym_new_expression] = STATE(1375),
    [sym_await_expression] = STATE(1375),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1375),
    [sym_augmented_assignment_expression] = STATE(1375),
    [sym_ternary_expression] = STATE(1375),
    [sym_binary_expression] = STATE(1375),
    [sym_unary_expression] = STATE(1375),
    [sym_update_expression] = STATE(1375),
    [sym_sequence_expression] = STATE(2876),
    [sym_string] = STATE(1375),
    [sym_template_string] = STATE(1375),
    [sym_regex] = STATE(1375),
    [sym_meta_property] = STATE(1375),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1375),
    [sym_type_assertion] = STATE(1375),
    [sym_as_expression] = STATE(1375),
    [sym_internal_module] = STATE(1375),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1942),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [sym_undefined] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [254] = {
    [sym_import] = STATE(1405),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1734),
    [sym_yield_expression] = STATE(1734),
    [sym_object] = STATE(1399),
    [sym_array] = STATE(1370),
    [sym_class] = STATE(1405),
    [sym_function] = STATE(1369),
    [sym_generator_function] = STATE(1405),
    [sym_arrow_function] = STATE(1405),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1734),
    [sym_new_expression] = STATE(1405),
    [sym_await_expression] = STATE(1734),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1734),
    [sym_augmented_assignment_expression] = STATE(1734),
    [sym_ternary_expression] = STATE(1734),
    [sym_binary_expression] = STATE(1734),
    [sym_unary_expression] = STATE(1734),
    [sym_update_expression] = STATE(1734),
    [sym_string] = STATE(1405),
    [sym_template_string] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_meta_property] = STATE(1405),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1734),
    [sym_type_assertion] = STATE(1734),
    [sym_as_expression] = STATE(1734),
    [sym_internal_module] = STATE(1734),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(1674),
    [anon_sym_export] = ACTIONS(1676),
    [anon_sym_namespace] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(1676),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(1682),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1684),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(1690),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1676),
    [anon_sym_get] = ACTIONS(1676),
    [anon_sym_set] = ACTIONS(1676),
    [anon_sym_declare] = ACTIONS(1676),
    [anon_sym_public] = ACTIONS(1676),
    [anon_sym_private] = ACTIONS(1676),
    [anon_sym_protected] = ACTIONS(1676),
    [anon_sym_module] = ACTIONS(1676),
    [anon_sym_any] = ACTIONS(1676),
    [anon_sym_number] = ACTIONS(1676),
    [anon_sym_boolean] = ACTIONS(1676),
    [anon_sym_string] = ACTIONS(1676),
    [anon_sym_symbol] = ACTIONS(1676),
    [sym_readonly] = ACTIONS(1676),
  },
  [255] = {
    [sym_import] = STATE(1426),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1426),
    [sym_yield_expression] = STATE(1426),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1426),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1426),
    [sym_arrow_function] = STATE(1426),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1426),
    [sym_new_expression] = STATE(1426),
    [sym_await_expression] = STATE(1426),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1426),
    [sym_augmented_assignment_expression] = STATE(1426),
    [sym_ternary_expression] = STATE(1426),
    [sym_binary_expression] = STATE(1426),
    [sym_unary_expression] = STATE(1426),
    [sym_update_expression] = STATE(1426),
    [sym_sequence_expression] = STATE(3173),
    [sym_string] = STATE(1426),
    [sym_template_string] = STATE(1426),
    [sym_regex] = STATE(1426),
    [sym_meta_property] = STATE(1426),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1426),
    [sym_type_assertion] = STATE(1426),
    [sym_as_expression] = STATE(1426),
    [sym_internal_module] = STATE(1426),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1946),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [256] = {
    [sym_import] = STATE(1357),
    [sym_statement_block] = STATE(1215),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1357),
    [sym_yield_expression] = STATE(1357),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1357),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1357),
    [sym_arrow_function] = STATE(1357),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1357),
    [sym_new_expression] = STATE(1357),
    [sym_await_expression] = STATE(1357),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1357),
    [sym_augmented_assignment_expression] = STATE(1357),
    [sym_ternary_expression] = STATE(1357),
    [sym_binary_expression] = STATE(1357),
    [sym_unary_expression] = STATE(1357),
    [sym_update_expression] = STATE(1357),
    [sym_string] = STATE(1357),
    [sym_template_string] = STATE(1357),
    [sym_regex] = STATE(1357),
    [sym_meta_property] = STATE(1357),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1357),
    [sym_type_assertion] = STATE(1357),
    [sym_as_expression] = STATE(1357),
    [sym_internal_module] = STATE(1357),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1950),
    [sym_this] = ACTIONS(1952),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1952),
    [sym_false] = ACTIONS(1952),
    [sym_null] = ACTIONS(1952),
    [sym_undefined] = ACTIONS(1952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [257] = {
    [sym_import] = STATE(1224),
    [sym_statement_block] = STATE(1140),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1954),
    [sym_this] = ACTIONS(1956),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1956),
    [sym_false] = ACTIONS(1956),
    [sym_null] = ACTIONS(1956),
    [sym_undefined] = ACTIONS(1956),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [258] = {
    [sym_import] = STATE(1343),
    [sym_statement_block] = STATE(1802),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1343),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1343),
    [sym_arrow_function] = STATE(1343),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_ternary_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_update_expression] = STATE(1343),
    [sym_string] = STATE(1343),
    [sym_template_string] = STATE(1343),
    [sym_regex] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1343),
    [sym_type_assertion] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_internal_module] = STATE(1343),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1958),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [259] = {
    [sym_import] = STATE(1402),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1402),
    [sym_yield_expression] = STATE(1402),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1402),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1402),
    [sym_arrow_function] = STATE(1402),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1402),
    [sym_new_expression] = STATE(1402),
    [sym_await_expression] = STATE(1402),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1402),
    [sym_augmented_assignment_expression] = STATE(1402),
    [sym_ternary_expression] = STATE(1402),
    [sym_binary_expression] = STATE(1402),
    [sym_unary_expression] = STATE(1402),
    [sym_update_expression] = STATE(1402),
    [sym_sequence_expression] = STATE(3028),
    [sym_string] = STATE(1402),
    [sym_template_string] = STATE(1402),
    [sym_regex] = STATE(1402),
    [sym_meta_property] = STATE(1402),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1402),
    [sym_type_assertion] = STATE(1402),
    [sym_as_expression] = STATE(1402),
    [sym_internal_module] = STATE(1402),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1962),
    [sym_this] = ACTIONS(1964),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [sym_null] = ACTIONS(1964),
    [sym_undefined] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [260] = {
    [sym_import] = STATE(1192),
    [sym_statement_block] = STATE(1551),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1192),
    [sym_yield_expression] = STATE(1192),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1192),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1192),
    [sym_arrow_function] = STATE(1192),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1192),
    [sym_new_expression] = STATE(1192),
    [sym_await_expression] = STATE(1192),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1192),
    [sym_augmented_assignment_expression] = STATE(1192),
    [sym_ternary_expression] = STATE(1192),
    [sym_binary_expression] = STATE(1192),
    [sym_unary_expression] = STATE(1192),
    [sym_update_expression] = STATE(1192),
    [sym_string] = STATE(1192),
    [sym_template_string] = STATE(1192),
    [sym_regex] = STATE(1192),
    [sym_meta_property] = STATE(1192),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1192),
    [sym_type_assertion] = STATE(1192),
    [sym_as_expression] = STATE(1192),
    [sym_internal_module] = STATE(1192),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1966),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [261] = {
    [sym_import] = STATE(1338),
    [sym_statement_block] = STATE(1805),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1338),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1338),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1338),
    [sym_arrow_function] = STATE(1338),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_await_expression] = STATE(1338),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1338),
    [sym_augmented_assignment_expression] = STATE(1338),
    [sym_ternary_expression] = STATE(1338),
    [sym_binary_expression] = STATE(1338),
    [sym_unary_expression] = STATE(1338),
    [sym_update_expression] = STATE(1338),
    [sym_string] = STATE(1338),
    [sym_template_string] = STATE(1338),
    [sym_regex] = STATE(1338),
    [sym_meta_property] = STATE(1338),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1338),
    [sym_type_assertion] = STATE(1338),
    [sym_as_expression] = STATE(1338),
    [sym_internal_module] = STATE(1338),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1970),
    [sym_this] = ACTIONS(1972),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [sym_null] = ACTIONS(1972),
    [sym_undefined] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [262] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1654),
    [anon_sym_namespace] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1660),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1654),
    [anon_sym_get] = ACTIONS(1654),
    [anon_sym_set] = ACTIONS(1654),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_public] = ACTIONS(1654),
    [anon_sym_private] = ACTIONS(1654),
    [anon_sym_protected] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1654),
    [anon_sym_any] = ACTIONS(1654),
    [anon_sym_number] = ACTIONS(1654),
    [anon_sym_boolean] = ACTIONS(1654),
    [anon_sym_string] = ACTIONS(1654),
    [anon_sym_symbol] = ACTIONS(1654),
    [sym_readonly] = ACTIONS(1654),
  },
  [263] = {
    [sym_import] = STATE(1337),
    [sym_statement_block] = STATE(1807),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(1974),
    [sym_this] = ACTIONS(1976),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [sym_null] = ACTIONS(1976),
    [sym_undefined] = ACTIONS(1976),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [264] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1372),
    [sym_type_assertion] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(1978),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(752),
    [sym_this] = ACTIONS(754),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_undefined] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [265] = {
    [sym_import] = STATE(1345),
    [sym_statement_block] = STATE(1122),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1345),
    [sym_yield_expression] = STATE(1345),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1345),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1345),
    [sym_arrow_function] = STATE(1345),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1345),
    [sym_new_expression] = STATE(1345),
    [sym_await_expression] = STATE(1345),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1345),
    [sym_augmented_assignment_expression] = STATE(1345),
    [sym_ternary_expression] = STATE(1345),
    [sym_binary_expression] = STATE(1345),
    [sym_unary_expression] = STATE(1345),
    [sym_update_expression] = STATE(1345),
    [sym_string] = STATE(1345),
    [sym_template_string] = STATE(1345),
    [sym_regex] = STATE(1345),
    [sym_meta_property] = STATE(1345),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(1345),
    [sym_as_expression] = STATE(1345),
    [sym_internal_module] = STATE(1345),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1980),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [266] = {
    [sym_import] = STATE(1414),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1414),
    [sym_yield_expression] = STATE(1414),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1414),
    [sym_arrow_function] = STATE(1414),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1414),
    [sym_await_expression] = STATE(1414),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1414),
    [sym_augmented_assignment_expression] = STATE(1414),
    [sym_ternary_expression] = STATE(1414),
    [sym_binary_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1414),
    [sym_update_expression] = STATE(1414),
    [sym_sequence_expression] = STATE(2587),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1414),
    [sym_type_assertion] = STATE(1414),
    [sym_as_expression] = STATE(1414),
    [sym_internal_module] = STATE(1414),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1984),
    [sym_this] = ACTIONS(1986),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1986),
    [sym_false] = ACTIONS(1986),
    [sym_null] = ACTIONS(1986),
    [sym_undefined] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [267] = {
    [sym_import] = STATE(1196),
    [sym_statement_block] = STATE(1572),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1196),
    [sym_yield_expression] = STATE(1196),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1196),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1196),
    [sym_arrow_function] = STATE(1196),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1196),
    [sym_new_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1196),
    [sym_augmented_assignment_expression] = STATE(1196),
    [sym_ternary_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_update_expression] = STATE(1196),
    [sym_string] = STATE(1196),
    [sym_template_string] = STATE(1196),
    [sym_regex] = STATE(1196),
    [sym_meta_property] = STATE(1196),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1196),
    [sym_type_assertion] = STATE(1196),
    [sym_as_expression] = STATE(1196),
    [sym_internal_module] = STATE(1196),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1988),
    [sym_this] = ACTIONS(1990),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_undefined] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [268] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(1654),
    [anon_sym_namespace] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1654),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1660),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1654),
    [anon_sym_get] = ACTIONS(1654),
    [anon_sym_set] = ACTIONS(1654),
    [anon_sym_declare] = ACTIONS(1654),
    [anon_sym_public] = ACTIONS(1654),
    [anon_sym_private] = ACTIONS(1654),
    [anon_sym_protected] = ACTIONS(1654),
    [anon_sym_module] = ACTIONS(1654),
    [anon_sym_any] = ACTIONS(1654),
    [anon_sym_number] = ACTIONS(1654),
    [anon_sym_boolean] = ACTIONS(1654),
    [anon_sym_string] = ACTIONS(1654),
    [anon_sym_symbol] = ACTIONS(1654),
    [sym_readonly] = ACTIONS(1654),
  },
  [269] = {
    [sym_import] = STATE(1197),
    [sym_statement_block] = STATE(1575),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1197),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1197),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1197),
    [sym_arrow_function] = STATE(1197),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1197),
    [sym_augmented_assignment_expression] = STATE(1197),
    [sym_ternary_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_update_expression] = STATE(1197),
    [sym_string] = STATE(1197),
    [sym_template_string] = STATE(1197),
    [sym_regex] = STATE(1197),
    [sym_meta_property] = STATE(1197),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1197),
    [sym_type_assertion] = STATE(1197),
    [sym_as_expression] = STATE(1197),
    [sym_internal_module] = STATE(1197),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(1994),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1994),
    [sym_false] = ACTIONS(1994),
    [sym_null] = ACTIONS(1994),
    [sym_undefined] = ACTIONS(1994),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [270] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1540),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1144),
    [sym_yield_expression] = STATE(1144),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1144),
    [sym_await_expression] = STATE(1144),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1144),
    [sym_augmented_assignment_expression] = STATE(1144),
    [sym_ternary_expression] = STATE(1144),
    [sym_binary_expression] = STATE(1144),
    [sym_unary_expression] = STATE(1144),
    [sym_update_expression] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1144),
    [sym_as_expression] = STATE(1144),
    [sym_internal_module] = STATE(1144),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1996),
    [sym_this] = ACTIONS(1998),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1998),
    [sym_false] = ACTIONS(1998),
    [sym_null] = ACTIONS(1998),
    [sym_undefined] = ACTIONS(1998),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [271] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1902),
    [anon_sym_export] = ACTIONS(1904),
    [anon_sym_namespace] = ACTIONS(1906),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1904),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1908),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1910),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1904),
    [anon_sym_get] = ACTIONS(1904),
    [anon_sym_set] = ACTIONS(1904),
    [anon_sym_declare] = ACTIONS(1904),
    [anon_sym_public] = ACTIONS(1904),
    [anon_sym_private] = ACTIONS(1904),
    [anon_sym_protected] = ACTIONS(1904),
    [anon_sym_module] = ACTIONS(1904),
    [anon_sym_any] = ACTIONS(1904),
    [anon_sym_number] = ACTIONS(1904),
    [anon_sym_boolean] = ACTIONS(1904),
    [anon_sym_string] = ACTIONS(1904),
    [anon_sym_symbol] = ACTIONS(1904),
    [sym_readonly] = ACTIONS(1904),
  },
  [272] = {
    [sym_import] = STATE(1360),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1360),
    [sym_arrow_function] = STATE(1360),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_sequence_expression] = STATE(2829),
    [sym_string] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1360),
    [sym_type_assertion] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2000),
    [sym_this] = ACTIONS(2002),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2002),
    [sym_false] = ACTIONS(2002),
    [sym_null] = ACTIONS(2002),
    [sym_undefined] = ACTIONS(2002),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [273] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2744),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1630),
    [anon_sym_export] = ACTIONS(1632),
    [anon_sym_namespace] = ACTIONS(1634),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1632),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1638),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1640),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1632),
    [anon_sym_get] = ACTIONS(1632),
    [anon_sym_set] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1632),
    [anon_sym_public] = ACTIONS(1632),
    [anon_sym_private] = ACTIONS(1632),
    [anon_sym_protected] = ACTIONS(1632),
    [anon_sym_module] = ACTIONS(1632),
    [anon_sym_any] = ACTIONS(1632),
    [anon_sym_number] = ACTIONS(1632),
    [anon_sym_boolean] = ACTIONS(1632),
    [anon_sym_string] = ACTIONS(1632),
    [anon_sym_symbol] = ACTIONS(1632),
    [sym_readonly] = ACTIONS(1632),
  },
  [274] = {
    [sym_import] = STATE(1436),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1436),
    [sym_yield_expression] = STATE(1436),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1436),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1436),
    [sym_arrow_function] = STATE(1436),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1436),
    [sym_new_expression] = STATE(1436),
    [sym_await_expression] = STATE(1436),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1436),
    [sym_augmented_assignment_expression] = STATE(1436),
    [sym_ternary_expression] = STATE(1436),
    [sym_binary_expression] = STATE(1436),
    [sym_unary_expression] = STATE(1436),
    [sym_update_expression] = STATE(1436),
    [sym_sequence_expression] = STATE(3016),
    [sym_string] = STATE(1436),
    [sym_template_string] = STATE(1436),
    [sym_regex] = STATE(1436),
    [sym_meta_property] = STATE(1436),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1436),
    [sym_type_assertion] = STATE(1436),
    [sym_as_expression] = STATE(1436),
    [sym_internal_module] = STATE(1436),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(2006),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2006),
    [sym_false] = ACTIONS(2006),
    [sym_null] = ACTIONS(2006),
    [sym_undefined] = ACTIONS(2006),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [275] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [276] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_nested_identifier] = STATE(504),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [277] = {
    [sym_import] = STATE(1272),
    [sym_statement_block] = STATE(1102),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1272),
    [sym_type_assertion] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2012),
    [sym_this] = ACTIONS(2014),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2014),
    [sym_false] = ACTIONS(2014),
    [sym_null] = ACTIONS(2014),
    [sym_undefined] = ACTIONS(2014),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [278] = {
    [sym_import] = STATE(1381),
    [sym_statement_block] = STATE(1103),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1381),
    [sym_yield_expression] = STATE(1381),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1381),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1381),
    [sym_arrow_function] = STATE(1381),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1381),
    [sym_new_expression] = STATE(1381),
    [sym_await_expression] = STATE(1381),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1381),
    [sym_augmented_assignment_expression] = STATE(1381),
    [sym_ternary_expression] = STATE(1381),
    [sym_binary_expression] = STATE(1381),
    [sym_unary_expression] = STATE(1381),
    [sym_update_expression] = STATE(1381),
    [sym_string] = STATE(1381),
    [sym_template_string] = STATE(1381),
    [sym_regex] = STATE(1381),
    [sym_meta_property] = STATE(1381),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1381),
    [sym_type_assertion] = STATE(1381),
    [sym_as_expression] = STATE(1381),
    [sym_internal_module] = STATE(1381),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [279] = {
    [sym_import] = STATE(1429),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1429),
    [sym_yield_expression] = STATE(1429),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1429),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1429),
    [sym_arrow_function] = STATE(1429),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1429),
    [sym_new_expression] = STATE(1429),
    [sym_await_expression] = STATE(1429),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1429),
    [sym_augmented_assignment_expression] = STATE(1429),
    [sym_ternary_expression] = STATE(1429),
    [sym_binary_expression] = STATE(1429),
    [sym_unary_expression] = STATE(1429),
    [sym_update_expression] = STATE(1429),
    [sym_sequence_expression] = STATE(3000),
    [sym_string] = STATE(1429),
    [sym_template_string] = STATE(1429),
    [sym_regex] = STATE(1429),
    [sym_meta_property] = STATE(1429),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1429),
    [sym_type_assertion] = STATE(1429),
    [sym_as_expression] = STATE(1429),
    [sym_internal_module] = STATE(1429),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2020),
    [sym_this] = ACTIONS(2022),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2022),
    [sym_false] = ACTIONS(2022),
    [sym_null] = ACTIONS(2022),
    [sym_undefined] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [280] = {
    [sym_import] = STATE(1113),
    [sym_statement_block] = STATE(1122),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1113),
    [sym_yield_expression] = STATE(1113),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1113),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1113),
    [sym_arrow_function] = STATE(1113),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1113),
    [sym_new_expression] = STATE(1113),
    [sym_await_expression] = STATE(1113),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1113),
    [sym_augmented_assignment_expression] = STATE(1113),
    [sym_ternary_expression] = STATE(1113),
    [sym_binary_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_update_expression] = STATE(1113),
    [sym_string] = STATE(1113),
    [sym_template_string] = STATE(1113),
    [sym_regex] = STATE(1113),
    [sym_meta_property] = STATE(1113),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1113),
    [sym_type_assertion] = STATE(1113),
    [sym_as_expression] = STATE(1113),
    [sym_internal_module] = STATE(1113),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1610),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2024),
    [sym_this] = ACTIONS(2026),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2026),
    [sym_false] = ACTIONS(2026),
    [sym_null] = ACTIONS(2026),
    [sym_undefined] = ACTIONS(2026),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [281] = {
    [sym_import] = STATE(1059),
    [sym_parenthesized_expression] = STATE(749),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1046),
    [sym_array] = STATE(1056),
    [sym_class] = STATE(1059),
    [sym_function] = STATE(1058),
    [sym_generator_function] = STATE(1059),
    [sym_arrow_function] = STATE(1059),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1059),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(749),
    [sym_subscript_expression] = STATE(749),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1059),
    [sym_template_string] = STATE(1059),
    [sym_regex] = STATE(1059),
    [sym_meta_property] = STATE(1059),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(1920),
    [anon_sym_export] = ACTIONS(1922),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1922),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1922),
    [anon_sym_get] = ACTIONS(1922),
    [anon_sym_set] = ACTIONS(1922),
    [anon_sym_declare] = ACTIONS(1922),
    [anon_sym_public] = ACTIONS(1922),
    [anon_sym_private] = ACTIONS(1922),
    [anon_sym_protected] = ACTIONS(1922),
    [anon_sym_module] = ACTIONS(1922),
    [anon_sym_any] = ACTIONS(1922),
    [anon_sym_number] = ACTIONS(1922),
    [anon_sym_boolean] = ACTIONS(1922),
    [anon_sym_string] = ACTIONS(1922),
    [anon_sym_symbol] = ACTIONS(1922),
    [sym_readonly] = ACTIONS(1922),
  },
  [282] = {
    [sym_import] = STATE(1427),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1427),
    [sym_yield_expression] = STATE(1427),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1427),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1427),
    [sym_arrow_function] = STATE(1427),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1427),
    [sym_new_expression] = STATE(1427),
    [sym_await_expression] = STATE(1427),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1427),
    [sym_augmented_assignment_expression] = STATE(1427),
    [sym_ternary_expression] = STATE(1427),
    [sym_binary_expression] = STATE(1427),
    [sym_unary_expression] = STATE(1427),
    [sym_update_expression] = STATE(1427),
    [sym_sequence_expression] = STATE(2995),
    [sym_string] = STATE(1427),
    [sym_template_string] = STATE(1427),
    [sym_regex] = STATE(1427),
    [sym_meta_property] = STATE(1427),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1427),
    [sym_type_assertion] = STATE(1427),
    [sym_as_expression] = STATE(1427),
    [sym_internal_module] = STATE(1427),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2030),
    [sym_false] = ACTIONS(2030),
    [sym_null] = ACTIONS(2030),
    [sym_undefined] = ACTIONS(2030),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [283] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1187),
    [sym_type_assertion] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2032),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [284] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1187),
    [sym_type_assertion] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2036),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [285] = {
    [sym_import] = STATE(1217),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1217),
    [sym_yield_expression] = STATE(1217),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1217),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1217),
    [sym_arrow_function] = STATE(1217),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1217),
    [sym_new_expression] = STATE(1217),
    [sym_await_expression] = STATE(1217),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1217),
    [sym_augmented_assignment_expression] = STATE(1217),
    [sym_ternary_expression] = STATE(1217),
    [sym_binary_expression] = STATE(1217),
    [sym_unary_expression] = STATE(1217),
    [sym_update_expression] = STATE(1217),
    [sym_string] = STATE(1217),
    [sym_template_string] = STATE(1217),
    [sym_regex] = STATE(1217),
    [sym_meta_property] = STATE(1217),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1217),
    [sym_type_assertion] = STATE(1217),
    [sym_as_expression] = STATE(1217),
    [sym_internal_module] = STATE(1217),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2038),
    [sym_this] = ACTIONS(2040),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [sym_null] = ACTIONS(2040),
    [sym_undefined] = ACTIONS(2040),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [286] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1297),
    [sym_type_assertion] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2042),
    [sym_this] = ACTIONS(2044),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [sym_null] = ACTIONS(2044),
    [sym_undefined] = ACTIONS(2044),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [287] = {
    [sym_import] = STATE(1213),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1213),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1213),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1213),
    [sym_arrow_function] = STATE(1213),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1213),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1213),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1213),
    [sym_template_string] = STATE(1213),
    [sym_regex] = STATE(1213),
    [sym_meta_property] = STATE(1213),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1213),
    [sym_type_assertion] = STATE(1213),
    [sym_as_expression] = STATE(1213),
    [sym_internal_module] = STATE(1213),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2046),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [288] = {
    [sym_import] = STATE(1544),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1544),
    [sym_yield_expression] = STATE(1544),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1544),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1544),
    [sym_arrow_function] = STATE(1544),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1544),
    [sym_new_expression] = STATE(1544),
    [sym_await_expression] = STATE(1544),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1544),
    [sym_augmented_assignment_expression] = STATE(1544),
    [sym_ternary_expression] = STATE(1544),
    [sym_binary_expression] = STATE(1544),
    [sym_unary_expression] = STATE(1544),
    [sym_update_expression] = STATE(1544),
    [sym_string] = STATE(1544),
    [sym_template_string] = STATE(1544),
    [sym_regex] = STATE(1544),
    [sym_meta_property] = STATE(1544),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1544),
    [sym_type_assertion] = STATE(1544),
    [sym_as_expression] = STATE(1544),
    [sym_internal_module] = STATE(1544),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2048),
    [sym_this] = ACTIONS(2050),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2050),
    [sym_false] = ACTIONS(2050),
    [sym_null] = ACTIONS(2050),
    [sym_undefined] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [289] = {
    [sym_import] = STATE(1185),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1185),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1185),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1185),
    [sym_arrow_function] = STATE(1185),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1185),
    [sym_new_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1185),
    [sym_augmented_assignment_expression] = STATE(1185),
    [sym_ternary_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_update_expression] = STATE(1185),
    [sym_string] = STATE(1185),
    [sym_template_string] = STATE(1185),
    [sym_regex] = STATE(1185),
    [sym_meta_property] = STATE(1185),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1185),
    [sym_type_assertion] = STATE(1185),
    [sym_as_expression] = STATE(1185),
    [sym_internal_module] = STATE(1185),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2052),
    [sym_this] = ACTIONS(2054),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_undefined] = ACTIONS(2054),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [290] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1178),
    [sym_type_assertion] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2056),
    [sym_this] = ACTIONS(2058),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2058),
    [sym_false] = ACTIONS(2058),
    [sym_null] = ACTIONS(2058),
    [sym_undefined] = ACTIONS(2058),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [291] = {
    [sym_import] = STATE(1174),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1174),
    [sym_yield_expression] = STATE(1174),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1174),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1174),
    [sym_arrow_function] = STATE(1174),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1174),
    [sym_new_expression] = STATE(1174),
    [sym_await_expression] = STATE(1174),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1174),
    [sym_augmented_assignment_expression] = STATE(1174),
    [sym_ternary_expression] = STATE(1174),
    [sym_binary_expression] = STATE(1174),
    [sym_unary_expression] = STATE(1174),
    [sym_update_expression] = STATE(1174),
    [sym_string] = STATE(1174),
    [sym_template_string] = STATE(1174),
    [sym_regex] = STATE(1174),
    [sym_meta_property] = STATE(1174),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1174),
    [sym_type_assertion] = STATE(1174),
    [sym_as_expression] = STATE(1174),
    [sym_internal_module] = STATE(1174),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2060),
    [sym_this] = ACTIONS(2062),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2062),
    [sym_false] = ACTIONS(2062),
    [sym_null] = ACTIONS(2062),
    [sym_undefined] = ACTIONS(2062),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [292] = {
    [sym_import] = STATE(1171),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1171),
    [sym_yield_expression] = STATE(1171),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1171),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1171),
    [sym_arrow_function] = STATE(1171),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1171),
    [sym_new_expression] = STATE(1171),
    [sym_await_expression] = STATE(1171),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1171),
    [sym_augmented_assignment_expression] = STATE(1171),
    [sym_ternary_expression] = STATE(1171),
    [sym_binary_expression] = STATE(1171),
    [sym_unary_expression] = STATE(1171),
    [sym_update_expression] = STATE(1171),
    [sym_string] = STATE(1171),
    [sym_template_string] = STATE(1171),
    [sym_regex] = STATE(1171),
    [sym_meta_property] = STATE(1171),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1171),
    [sym_type_assertion] = STATE(1171),
    [sym_as_expression] = STATE(1171),
    [sym_internal_module] = STATE(1171),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [293] = {
    [sym_import] = STATE(1170),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1170),
    [sym_yield_expression] = STATE(1170),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1170),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1170),
    [sym_arrow_function] = STATE(1170),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1170),
    [sym_new_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1170),
    [sym_augmented_assignment_expression] = STATE(1170),
    [sym_ternary_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_update_expression] = STATE(1170),
    [sym_string] = STATE(1170),
    [sym_template_string] = STATE(1170),
    [sym_regex] = STATE(1170),
    [sym_meta_property] = STATE(1170),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1170),
    [sym_type_assertion] = STATE(1170),
    [sym_as_expression] = STATE(1170),
    [sym_internal_module] = STATE(1170),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [294] = {
    [sym_import] = STATE(1786),
    [sym_parenthesized_expression] = STATE(1025),
    [sym__expression] = STATE(1786),
    [sym_yield_expression] = STATE(1786),
    [sym_object] = STATE(1845),
    [sym_array] = STATE(1846),
    [sym_class] = STATE(1786),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1786),
    [sym_arrow_function] = STATE(1786),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1786),
    [sym_new_expression] = STATE(1786),
    [sym_await_expression] = STATE(1786),
    [sym_member_expression] = STATE(1025),
    [sym_subscript_expression] = STATE(1025),
    [sym_assignment_expression] = STATE(1786),
    [sym_augmented_assignment_expression] = STATE(1786),
    [sym_ternary_expression] = STATE(1786),
    [sym_binary_expression] = STATE(1786),
    [sym_unary_expression] = STATE(1786),
    [sym_update_expression] = STATE(1786),
    [sym_string] = STATE(1786),
    [sym_template_string] = STATE(1786),
    [sym_regex] = STATE(1786),
    [sym_meta_property] = STATE(1786),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1786),
    [sym_type_assertion] = STATE(1786),
    [sym_as_expression] = STATE(1786),
    [sym_internal_module] = STATE(1786),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(1802),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
    [sym_readonly] = ACTIONS(1796),
  },
  [295] = {
    [sym_import] = STATE(1119),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1119),
    [sym_yield_expression] = STATE(1119),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1119),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1119),
    [sym_arrow_function] = STATE(1119),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1119),
    [sym_new_expression] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1119),
    [sym_augmented_assignment_expression] = STATE(1119),
    [sym_ternary_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_update_expression] = STATE(1119),
    [sym_string] = STATE(1119),
    [sym_template_string] = STATE(1119),
    [sym_regex] = STATE(1119),
    [sym_meta_property] = STATE(1119),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1119),
    [sym_as_expression] = STATE(1119),
    [sym_internal_module] = STATE(1119),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2074),
    [sym_this] = ACTIONS(2076),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [sym_undefined] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [296] = {
    [sym_import] = STATE(1159),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1159),
    [sym_yield_expression] = STATE(1159),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1159),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1159),
    [sym_arrow_function] = STATE(1159),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1159),
    [sym_new_expression] = STATE(1159),
    [sym_await_expression] = STATE(1159),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1159),
    [sym_augmented_assignment_expression] = STATE(1159),
    [sym_ternary_expression] = STATE(1159),
    [sym_binary_expression] = STATE(1159),
    [sym_unary_expression] = STATE(1159),
    [sym_update_expression] = STATE(1159),
    [sym_string] = STATE(1159),
    [sym_template_string] = STATE(1159),
    [sym_regex] = STATE(1159),
    [sym_meta_property] = STATE(1159),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1159),
    [sym_type_assertion] = STATE(1159),
    [sym_as_expression] = STATE(1159),
    [sym_internal_module] = STATE(1159),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2078),
    [sym_this] = ACTIONS(2080),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [sym_undefined] = ACTIONS(2080),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [297] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1121),
    [sym_type_assertion] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [298] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [299] = {
    [sym_import] = STATE(1193),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1193),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1193),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1193),
    [sym_arrow_function] = STATE(1193),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1193),
    [sym_augmented_assignment_expression] = STATE(1193),
    [sym_ternary_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_update_expression] = STATE(1193),
    [sym_string] = STATE(1193),
    [sym_template_string] = STATE(1193),
    [sym_regex] = STATE(1193),
    [sym_meta_property] = STATE(1193),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1193),
    [sym_type_assertion] = STATE(1193),
    [sym_as_expression] = STATE(1193),
    [sym_internal_module] = STATE(1193),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2086),
    [sym_this] = ACTIONS(2088),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [sym_null] = ACTIONS(2088),
    [sym_undefined] = ACTIONS(2088),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [300] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(638),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(640),
    [sym_false] = ACTIONS(640),
    [sym_null] = ACTIONS(640),
    [sym_undefined] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [301] = {
    [sym_import] = STATE(1300),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1300),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1300),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1300),
    [sym_arrow_function] = STATE(1300),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1300),
    [sym_new_expression] = STATE(1300),
    [sym_await_expression] = STATE(1300),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1300),
    [sym_augmented_assignment_expression] = STATE(1300),
    [sym_ternary_expression] = STATE(1300),
    [sym_binary_expression] = STATE(1300),
    [sym_unary_expression] = STATE(1300),
    [sym_update_expression] = STATE(1300),
    [sym_string] = STATE(1300),
    [sym_template_string] = STATE(1300),
    [sym_regex] = STATE(1300),
    [sym_meta_property] = STATE(1300),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1300),
    [sym_type_assertion] = STATE(1300),
    [sym_as_expression] = STATE(1300),
    [sym_internal_module] = STATE(1300),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2090),
    [sym_this] = ACTIONS(2092),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_null] = ACTIONS(2092),
    [sym_undefined] = ACTIONS(2092),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [302] = {
    [sym_import] = STATE(1661),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1661),
    [sym_yield_expression] = STATE(1661),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1661),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1661),
    [sym_arrow_function] = STATE(1661),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1661),
    [sym_new_expression] = STATE(1661),
    [sym_await_expression] = STATE(1661),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1661),
    [sym_augmented_assignment_expression] = STATE(1661),
    [sym_ternary_expression] = STATE(1661),
    [sym_binary_expression] = STATE(1661),
    [sym_unary_expression] = STATE(1661),
    [sym_update_expression] = STATE(1661),
    [sym_string] = STATE(1661),
    [sym_template_string] = STATE(1661),
    [sym_regex] = STATE(1661),
    [sym_meta_property] = STATE(1661),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1661),
    [sym_type_assertion] = STATE(1661),
    [sym_as_expression] = STATE(1661),
    [sym_internal_module] = STATE(1661),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [sym_undefined] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [303] = {
    [sym_import] = STATE(1483),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1483),
    [sym_yield_expression] = STATE(1483),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1483),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1483),
    [sym_arrow_function] = STATE(1483),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1483),
    [sym_new_expression] = STATE(1483),
    [sym_await_expression] = STATE(1483),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1483),
    [sym_augmented_assignment_expression] = STATE(1483),
    [sym_ternary_expression] = STATE(1483),
    [sym_binary_expression] = STATE(1483),
    [sym_unary_expression] = STATE(1483),
    [sym_update_expression] = STATE(1483),
    [sym_string] = STATE(1483),
    [sym_template_string] = STATE(1483),
    [sym_regex] = STATE(1483),
    [sym_meta_property] = STATE(1483),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1483),
    [sym_type_assertion] = STATE(1483),
    [sym_as_expression] = STATE(1483),
    [sym_internal_module] = STATE(1483),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [304] = {
    [sym_import] = STATE(1249),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1249),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1249),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1249),
    [sym_arrow_function] = STATE(1249),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1249),
    [sym_new_expression] = STATE(1249),
    [sym_await_expression] = STATE(1249),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1249),
    [sym_augmented_assignment_expression] = STATE(1249),
    [sym_ternary_expression] = STATE(1249),
    [sym_binary_expression] = STATE(1249),
    [sym_unary_expression] = STATE(1249),
    [sym_update_expression] = STATE(1249),
    [sym_string] = STATE(1249),
    [sym_template_string] = STATE(1249),
    [sym_regex] = STATE(1249),
    [sym_meta_property] = STATE(1249),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1249),
    [sym_type_assertion] = STATE(1249),
    [sym_as_expression] = STATE(1249),
    [sym_internal_module] = STATE(1249),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [305] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1271),
    [sym_type_assertion] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(587),
    [sym_this] = ACTIONS(589),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(589),
    [sym_false] = ACTIONS(589),
    [sym_null] = ACTIONS(589),
    [sym_undefined] = ACTIONS(589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [306] = {
    [sym_import] = STATE(1485),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1485),
    [sym_yield_expression] = STATE(1485),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1485),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1485),
    [sym_arrow_function] = STATE(1485),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1485),
    [sym_new_expression] = STATE(1485),
    [sym_await_expression] = STATE(1485),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1485),
    [sym_augmented_assignment_expression] = STATE(1485),
    [sym_ternary_expression] = STATE(1485),
    [sym_binary_expression] = STATE(1485),
    [sym_unary_expression] = STATE(1485),
    [sym_update_expression] = STATE(1485),
    [sym_string] = STATE(1485),
    [sym_template_string] = STATE(1485),
    [sym_regex] = STATE(1485),
    [sym_meta_property] = STATE(1485),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1485),
    [sym_type_assertion] = STATE(1485),
    [sym_as_expression] = STATE(1485),
    [sym_internal_module] = STATE(1485),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [307] = {
    [sym_import] = STATE(1490),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1490),
    [sym_yield_expression] = STATE(1490),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1490),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1490),
    [sym_arrow_function] = STATE(1490),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1490),
    [sym_new_expression] = STATE(1490),
    [sym_await_expression] = STATE(1490),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1490),
    [sym_augmented_assignment_expression] = STATE(1490),
    [sym_ternary_expression] = STATE(1490),
    [sym_binary_expression] = STATE(1490),
    [sym_unary_expression] = STATE(1490),
    [sym_update_expression] = STATE(1490),
    [sym_string] = STATE(1490),
    [sym_template_string] = STATE(1490),
    [sym_regex] = STATE(1490),
    [sym_meta_property] = STATE(1490),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1490),
    [sym_type_assertion] = STATE(1490),
    [sym_as_expression] = STATE(1490),
    [sym_internal_module] = STATE(1490),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [308] = {
    [sym_import] = STATE(1498),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1498),
    [sym_yield_expression] = STATE(1498),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1498),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1498),
    [sym_arrow_function] = STATE(1498),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1498),
    [sym_new_expression] = STATE(1498),
    [sym_await_expression] = STATE(1498),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1498),
    [sym_augmented_assignment_expression] = STATE(1498),
    [sym_ternary_expression] = STATE(1498),
    [sym_binary_expression] = STATE(1498),
    [sym_unary_expression] = STATE(1498),
    [sym_update_expression] = STATE(1498),
    [sym_string] = STATE(1498),
    [sym_template_string] = STATE(1498),
    [sym_regex] = STATE(1498),
    [sym_meta_property] = STATE(1498),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1498),
    [sym_type_assertion] = STATE(1498),
    [sym_as_expression] = STATE(1498),
    [sym_internal_module] = STATE(1498),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(1049),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [309] = {
    [sym_import] = STATE(1639),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1639),
    [sym_yield_expression] = STATE(1639),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1639),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1639),
    [sym_arrow_function] = STATE(1639),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1639),
    [sym_new_expression] = STATE(1639),
    [sym_await_expression] = STATE(1639),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1639),
    [sym_augmented_assignment_expression] = STATE(1639),
    [sym_ternary_expression] = STATE(1639),
    [sym_binary_expression] = STATE(1639),
    [sym_unary_expression] = STATE(1639),
    [sym_update_expression] = STATE(1639),
    [sym_string] = STATE(1639),
    [sym_template_string] = STATE(1639),
    [sym_regex] = STATE(1639),
    [sym_meta_property] = STATE(1639),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1639),
    [sym_type_assertion] = STATE(1639),
    [sym_as_expression] = STATE(1639),
    [sym_internal_module] = STATE(1639),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2116),
    [sym_this] = ACTIONS(2118),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2118),
    [sym_false] = ACTIONS(2118),
    [sym_null] = ACTIONS(2118),
    [sym_undefined] = ACTIONS(2118),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [310] = {
    [sym_import] = STATE(1412),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1412),
    [sym_yield_expression] = STATE(1412),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1412),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1412),
    [sym_arrow_function] = STATE(1412),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1412),
    [sym_new_expression] = STATE(1412),
    [sym_await_expression] = STATE(1412),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1412),
    [sym_augmented_assignment_expression] = STATE(1412),
    [sym_ternary_expression] = STATE(1412),
    [sym_binary_expression] = STATE(1412),
    [sym_unary_expression] = STATE(1412),
    [sym_update_expression] = STATE(1412),
    [sym_string] = STATE(1412),
    [sym_template_string] = STATE(1412),
    [sym_regex] = STATE(1412),
    [sym_meta_property] = STATE(1412),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1412),
    [sym_type_assertion] = STATE(1412),
    [sym_as_expression] = STATE(1412),
    [sym_internal_module] = STATE(1412),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2120),
    [sym_this] = ACTIONS(2122),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [sym_null] = ACTIONS(2122),
    [sym_undefined] = ACTIONS(2122),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [311] = {
    [sym_import] = STATE(1510),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1510),
    [sym_yield_expression] = STATE(1510),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1510),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1510),
    [sym_arrow_function] = STATE(1510),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1510),
    [sym_new_expression] = STATE(1510),
    [sym_await_expression] = STATE(1510),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1510),
    [sym_augmented_assignment_expression] = STATE(1510),
    [sym_ternary_expression] = STATE(1510),
    [sym_binary_expression] = STATE(1510),
    [sym_unary_expression] = STATE(1510),
    [sym_update_expression] = STATE(1510),
    [sym_string] = STATE(1510),
    [sym_template_string] = STATE(1510),
    [sym_regex] = STATE(1510),
    [sym_meta_property] = STATE(1510),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1510),
    [sym_type_assertion] = STATE(1510),
    [sym_as_expression] = STATE(1510),
    [sym_internal_module] = STATE(1510),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2124),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [312] = {
    [sym_import] = STATE(1502),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1502),
    [sym_yield_expression] = STATE(1502),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1502),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1502),
    [sym_arrow_function] = STATE(1502),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1502),
    [sym_new_expression] = STATE(1502),
    [sym_await_expression] = STATE(1502),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1502),
    [sym_augmented_assignment_expression] = STATE(1502),
    [sym_ternary_expression] = STATE(1502),
    [sym_binary_expression] = STATE(1502),
    [sym_unary_expression] = STATE(1502),
    [sym_update_expression] = STATE(1502),
    [sym_string] = STATE(1502),
    [sym_template_string] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_meta_property] = STATE(1502),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1502),
    [sym_type_assertion] = STATE(1502),
    [sym_as_expression] = STATE(1502),
    [sym_internal_module] = STATE(1502),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2128),
    [sym_this] = ACTIONS(2130),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2130),
    [sym_false] = ACTIONS(2130),
    [sym_null] = ACTIONS(2130),
    [sym_undefined] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [313] = {
    [sym_import] = STATE(1493),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1493),
    [sym_yield_expression] = STATE(1493),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1493),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1493),
    [sym_arrow_function] = STATE(1493),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1493),
    [sym_new_expression] = STATE(1493),
    [sym_await_expression] = STATE(1493),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1493),
    [sym_augmented_assignment_expression] = STATE(1493),
    [sym_ternary_expression] = STATE(1493),
    [sym_binary_expression] = STATE(1493),
    [sym_unary_expression] = STATE(1493),
    [sym_update_expression] = STATE(1493),
    [sym_string] = STATE(1493),
    [sym_template_string] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_meta_property] = STATE(1493),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1493),
    [sym_type_assertion] = STATE(1493),
    [sym_as_expression] = STATE(1493),
    [sym_internal_module] = STATE(1493),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2132),
    [sym_this] = ACTIONS(2134),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [sym_null] = ACTIONS(2134),
    [sym_undefined] = ACTIONS(2134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [314] = {
    [sym_import] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1492),
    [sym_yield_expression] = STATE(1492),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1492),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1492),
    [sym_arrow_function] = STATE(1492),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1492),
    [sym_new_expression] = STATE(1492),
    [sym_await_expression] = STATE(1492),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1492),
    [sym_augmented_assignment_expression] = STATE(1492),
    [sym_ternary_expression] = STATE(1492),
    [sym_binary_expression] = STATE(1492),
    [sym_unary_expression] = STATE(1492),
    [sym_update_expression] = STATE(1492),
    [sym_string] = STATE(1492),
    [sym_template_string] = STATE(1492),
    [sym_regex] = STATE(1492),
    [sym_meta_property] = STATE(1492),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1492),
    [sym_type_assertion] = STATE(1492),
    [sym_as_expression] = STATE(1492),
    [sym_internal_module] = STATE(1492),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2136),
    [sym_this] = ACTIONS(2138),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_undefined] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [315] = {
    [sym_import] = STATE(1479),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1479),
    [sym_yield_expression] = STATE(1479),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1479),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1479),
    [sym_arrow_function] = STATE(1479),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1479),
    [sym_new_expression] = STATE(1479),
    [sym_await_expression] = STATE(1479),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1479),
    [sym_augmented_assignment_expression] = STATE(1479),
    [sym_ternary_expression] = STATE(1479),
    [sym_binary_expression] = STATE(1479),
    [sym_unary_expression] = STATE(1479),
    [sym_update_expression] = STATE(1479),
    [sym_string] = STATE(1479),
    [sym_template_string] = STATE(1479),
    [sym_regex] = STATE(1479),
    [sym_meta_property] = STATE(1479),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1479),
    [sym_type_assertion] = STATE(1479),
    [sym_as_expression] = STATE(1479),
    [sym_internal_module] = STATE(1479),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [316] = {
    [sym_import] = STATE(1325),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1325),
    [sym_arrow_function] = STATE(1325),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1325),
    [sym_type_assertion] = STATE(1325),
    [sym_as_expression] = STATE(1325),
    [sym_internal_module] = STATE(1325),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2144),
    [sym_this] = ACTIONS(2146),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_undefined] = ACTIONS(2146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [317] = {
    [sym_import] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1477),
    [sym_yield_expression] = STATE(1477),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1477),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1477),
    [sym_arrow_function] = STATE(1477),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1477),
    [sym_new_expression] = STATE(1477),
    [sym_await_expression] = STATE(1477),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1477),
    [sym_augmented_assignment_expression] = STATE(1477),
    [sym_ternary_expression] = STATE(1477),
    [sym_binary_expression] = STATE(1477),
    [sym_unary_expression] = STATE(1477),
    [sym_update_expression] = STATE(1477),
    [sym_string] = STATE(1477),
    [sym_template_string] = STATE(1477),
    [sym_regex] = STATE(1477),
    [sym_meta_property] = STATE(1477),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1477),
    [sym_type_assertion] = STATE(1477),
    [sym_as_expression] = STATE(1477),
    [sym_internal_module] = STATE(1477),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2148),
    [sym_this] = ACTIONS(2150),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2150),
    [sym_false] = ACTIONS(2150),
    [sym_null] = ACTIONS(2150),
    [sym_undefined] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [318] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1255),
    [sym_yield_expression] = STATE(1255),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1255),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1255),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1255),
    [sym_augmented_assignment_expression] = STATE(1255),
    [sym_ternary_expression] = STATE(1255),
    [sym_binary_expression] = STATE(1255),
    [sym_unary_expression] = STATE(1255),
    [sym_update_expression] = STATE(1255),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1255),
    [sym_type_assertion] = STATE(1255),
    [sym_as_expression] = STATE(1255),
    [sym_internal_module] = STATE(1255),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2152),
    [sym_this] = ACTIONS(2154),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [sym_null] = ACTIONS(2154),
    [sym_undefined] = ACTIONS(2154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [319] = {
    [sym_import] = STATE(1127),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1127),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1127),
    [sym_arrow_function] = STATE(1127),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1127),
    [sym_new_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_string] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_meta_property] = STATE(1127),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [320] = {
    [sym_import] = STATE(1693),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1693),
    [sym_yield_expression] = STATE(1693),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1693),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1693),
    [sym_arrow_function] = STATE(1693),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1693),
    [sym_new_expression] = STATE(1693),
    [sym_await_expression] = STATE(1693),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1693),
    [sym_augmented_assignment_expression] = STATE(1693),
    [sym_ternary_expression] = STATE(1693),
    [sym_binary_expression] = STATE(1693),
    [sym_unary_expression] = STATE(1693),
    [sym_update_expression] = STATE(1693),
    [sym_string] = STATE(1693),
    [sym_template_string] = STATE(1693),
    [sym_regex] = STATE(1693),
    [sym_meta_property] = STATE(1693),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1693),
    [sym_type_assertion] = STATE(1693),
    [sym_as_expression] = STATE(1693),
    [sym_internal_module] = STATE(1693),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(1702),
    [sym_this] = ACTIONS(1704),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1704),
    [sym_false] = ACTIONS(1704),
    [sym_null] = ACTIONS(1704),
    [sym_undefined] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [321] = {
    [sym_import] = STATE(1468),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1468),
    [sym_yield_expression] = STATE(1468),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1468),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1468),
    [sym_arrow_function] = STATE(1468),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1468),
    [sym_new_expression] = STATE(1468),
    [sym_await_expression] = STATE(1468),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1468),
    [sym_augmented_assignment_expression] = STATE(1468),
    [sym_ternary_expression] = STATE(1468),
    [sym_binary_expression] = STATE(1468),
    [sym_unary_expression] = STATE(1468),
    [sym_update_expression] = STATE(1468),
    [sym_string] = STATE(1468),
    [sym_template_string] = STATE(1468),
    [sym_regex] = STATE(1468),
    [sym_meta_property] = STATE(1468),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1468),
    [sym_type_assertion] = STATE(1468),
    [sym_as_expression] = STATE(1468),
    [sym_internal_module] = STATE(1468),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2162),
    [sym_this] = ACTIONS(2164),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_undefined] = ACTIONS(2164),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [322] = {
    [sym_import] = STATE(1092),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1092),
    [sym_yield_expression] = STATE(1092),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1092),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1092),
    [sym_arrow_function] = STATE(1092),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1092),
    [sym_new_expression] = STATE(1092),
    [sym_await_expression] = STATE(1092),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1092),
    [sym_augmented_assignment_expression] = STATE(1092),
    [sym_ternary_expression] = STATE(1092),
    [sym_binary_expression] = STATE(1092),
    [sym_unary_expression] = STATE(1092),
    [sym_update_expression] = STATE(1092),
    [sym_string] = STATE(1092),
    [sym_template_string] = STATE(1092),
    [sym_regex] = STATE(1092),
    [sym_meta_property] = STATE(1092),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1092),
    [sym_type_assertion] = STATE(1092),
    [sym_as_expression] = STATE(1092),
    [sym_internal_module] = STATE(1092),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [323] = {
    [sym_import] = STATE(1527),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1527),
    [sym_yield_expression] = STATE(1527),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1527),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1527),
    [sym_arrow_function] = STATE(1527),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1527),
    [sym_new_expression] = STATE(1527),
    [sym_await_expression] = STATE(1527),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1527),
    [sym_augmented_assignment_expression] = STATE(1527),
    [sym_ternary_expression] = STATE(1527),
    [sym_binary_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1527),
    [sym_update_expression] = STATE(1527),
    [sym_string] = STATE(1527),
    [sym_template_string] = STATE(1527),
    [sym_regex] = STATE(1527),
    [sym_meta_property] = STATE(1527),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1527),
    [sym_type_assertion] = STATE(1527),
    [sym_as_expression] = STATE(1527),
    [sym_internal_module] = STATE(1527),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2170),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [324] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2174),
    [sym_this] = ACTIONS(2176),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_undefined] = ACTIONS(2176),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [325] = {
    [sym_import] = STATE(1127),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1127),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1127),
    [sym_arrow_function] = STATE(1127),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1127),
    [sym_new_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_string] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_meta_property] = STATE(1127),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1127),
    [sym_type_assertion] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [326] = {
    [sym_import] = STATE(1270),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1270),
    [sym_type_assertion] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2178),
    [sym_this] = ACTIONS(2180),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_undefined] = ACTIONS(2180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [327] = {
    [sym_import] = STATE(1668),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1668),
    [sym_yield_expression] = STATE(1668),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1668),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1668),
    [sym_arrow_function] = STATE(1668),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1668),
    [sym_new_expression] = STATE(1668),
    [sym_await_expression] = STATE(1668),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1668),
    [sym_augmented_assignment_expression] = STATE(1668),
    [sym_ternary_expression] = STATE(1668),
    [sym_binary_expression] = STATE(1668),
    [sym_unary_expression] = STATE(1668),
    [sym_update_expression] = STATE(1668),
    [sym_string] = STATE(1668),
    [sym_template_string] = STATE(1668),
    [sym_regex] = STATE(1668),
    [sym_meta_property] = STATE(1668),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1668),
    [sym_type_assertion] = STATE(1668),
    [sym_as_expression] = STATE(1668),
    [sym_internal_module] = STATE(1668),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2184),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_undefined] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [328] = {
    [sym_import] = STATE(1234),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1234),
    [sym_type_assertion] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [329] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [330] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1346),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1346),
    [sym_await_expression] = STATE(1346),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1346),
    [sym_augmented_assignment_expression] = STATE(1346),
    [sym_ternary_expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_update_expression] = STATE(1346),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1346),
    [sym_type_assertion] = STATE(1346),
    [sym_as_expression] = STATE(1346),
    [sym_internal_module] = STATE(1346),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [331] = {
    [sym_import] = STATE(1341),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1341),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1341),
    [sym_arrow_function] = STATE(1341),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1341),
    [sym_new_expression] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_string] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1341),
    [sym_type_assertion] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [332] = {
    [sym_import] = STATE(1669),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1669),
    [sym_yield_expression] = STATE(1669),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1669),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1669),
    [sym_arrow_function] = STATE(1669),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1669),
    [sym_new_expression] = STATE(1669),
    [sym_await_expression] = STATE(1669),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1669),
    [sym_augmented_assignment_expression] = STATE(1669),
    [sym_ternary_expression] = STATE(1669),
    [sym_binary_expression] = STATE(1669),
    [sym_unary_expression] = STATE(1669),
    [sym_update_expression] = STATE(1669),
    [sym_string] = STATE(1669),
    [sym_template_string] = STATE(1669),
    [sym_regex] = STATE(1669),
    [sym_meta_property] = STATE(1669),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1669),
    [sym_type_assertion] = STATE(1669),
    [sym_as_expression] = STATE(1669),
    [sym_internal_module] = STATE(1669),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [333] = {
    [sym_import] = STATE(1048),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1048),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1048),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1048),
    [sym_arrow_function] = STATE(1048),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1048),
    [sym_new_expression] = STATE(1048),
    [sym_await_expression] = STATE(1048),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1048),
    [sym_augmented_assignment_expression] = STATE(1048),
    [sym_ternary_expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_update_expression] = STATE(1048),
    [sym_string] = STATE(1048),
    [sym_template_string] = STATE(1048),
    [sym_regex] = STATE(1048),
    [sym_meta_property] = STATE(1048),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1048),
    [sym_type_assertion] = STATE(1048),
    [sym_as_expression] = STATE(1048),
    [sym_internal_module] = STATE(1048),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [334] = {
    [sym_import] = STATE(1582),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1582),
    [sym_yield_expression] = STATE(1582),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1582),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1582),
    [sym_arrow_function] = STATE(1582),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1582),
    [sym_new_expression] = STATE(1582),
    [sym_await_expression] = STATE(1582),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1582),
    [sym_augmented_assignment_expression] = STATE(1582),
    [sym_ternary_expression] = STATE(1582),
    [sym_binary_expression] = STATE(1582),
    [sym_unary_expression] = STATE(1582),
    [sym_update_expression] = STATE(1582),
    [sym_string] = STATE(1582),
    [sym_template_string] = STATE(1582),
    [sym_regex] = STATE(1582),
    [sym_meta_property] = STATE(1582),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1582),
    [sym_type_assertion] = STATE(1582),
    [sym_as_expression] = STATE(1582),
    [sym_internal_module] = STATE(1582),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(2208),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_undefined] = ACTIONS(2208),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [335] = {
    [sym_import] = STATE(1333),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1333),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1333),
    [sym_arrow_function] = STATE(1333),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_ternary_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_update_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_regex] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1333),
    [sym_type_assertion] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_internal_module] = STATE(1333),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2210),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [336] = {
    [sym_import] = STATE(1512),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1512),
    [sym_yield_expression] = STATE(1512),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1512),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1512),
    [sym_arrow_function] = STATE(1512),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1512),
    [sym_new_expression] = STATE(1512),
    [sym_await_expression] = STATE(1512),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1512),
    [sym_augmented_assignment_expression] = STATE(1512),
    [sym_ternary_expression] = STATE(1512),
    [sym_binary_expression] = STATE(1512),
    [sym_unary_expression] = STATE(1512),
    [sym_update_expression] = STATE(1512),
    [sym_string] = STATE(1512),
    [sym_template_string] = STATE(1512),
    [sym_regex] = STATE(1512),
    [sym_meta_property] = STATE(1512),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1512),
    [sym_type_assertion] = STATE(1512),
    [sym_as_expression] = STATE(1512),
    [sym_internal_module] = STATE(1512),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [337] = {
    [sym_import] = STATE(1545),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1545),
    [sym_yield_expression] = STATE(1545),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1545),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1545),
    [sym_arrow_function] = STATE(1545),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1545),
    [sym_new_expression] = STATE(1545),
    [sym_await_expression] = STATE(1545),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1545),
    [sym_augmented_assignment_expression] = STATE(1545),
    [sym_ternary_expression] = STATE(1545),
    [sym_binary_expression] = STATE(1545),
    [sym_unary_expression] = STATE(1545),
    [sym_update_expression] = STATE(1545),
    [sym_string] = STATE(1545),
    [sym_template_string] = STATE(1545),
    [sym_regex] = STATE(1545),
    [sym_meta_property] = STATE(1545),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1545),
    [sym_type_assertion] = STATE(1545),
    [sym_as_expression] = STATE(1545),
    [sym_internal_module] = STATE(1545),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [338] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1312),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1312),
    [sym_await_expression] = STATE(1312),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1312),
    [sym_augmented_assignment_expression] = STATE(1312),
    [sym_ternary_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_update_expression] = STATE(1312),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1312),
    [sym_type_assertion] = STATE(1312),
    [sym_as_expression] = STATE(1312),
    [sym_internal_module] = STATE(1312),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [339] = {
    [sym_import] = STATE(1331),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1331),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1331),
    [sym_type_assertion] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [340] = {
    [sym_import] = STATE(1048),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1048),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1048),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1048),
    [sym_arrow_function] = STATE(1048),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1048),
    [sym_new_expression] = STATE(1048),
    [sym_await_expression] = STATE(1048),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1048),
    [sym_augmented_assignment_expression] = STATE(1048),
    [sym_ternary_expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_update_expression] = STATE(1048),
    [sym_string] = STATE(1048),
    [sym_template_string] = STATE(1048),
    [sym_regex] = STATE(1048),
    [sym_meta_property] = STATE(1048),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1048),
    [sym_type_assertion] = STATE(1048),
    [sym_as_expression] = STATE(1048),
    [sym_internal_module] = STATE(1048),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [341] = {
    [sym_import] = STATE(1667),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1667),
    [sym_yield_expression] = STATE(1667),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1667),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1667),
    [sym_arrow_function] = STATE(1667),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1667),
    [sym_new_expression] = STATE(1667),
    [sym_await_expression] = STATE(1667),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1667),
    [sym_augmented_assignment_expression] = STATE(1667),
    [sym_ternary_expression] = STATE(1667),
    [sym_binary_expression] = STATE(1667),
    [sym_unary_expression] = STATE(1667),
    [sym_update_expression] = STATE(1667),
    [sym_string] = STATE(1667),
    [sym_template_string] = STATE(1667),
    [sym_regex] = STATE(1667),
    [sym_meta_property] = STATE(1667),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1667),
    [sym_type_assertion] = STATE(1667),
    [sym_as_expression] = STATE(1667),
    [sym_internal_module] = STATE(1667),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [342] = {
    [sym_import] = STATE(1120),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1120),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1120),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1120),
    [sym_arrow_function] = STATE(1120),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1120),
    [sym_new_expression] = STATE(1120),
    [sym_await_expression] = STATE(1120),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1120),
    [sym_augmented_assignment_expression] = STATE(1120),
    [sym_ternary_expression] = STATE(1120),
    [sym_binary_expression] = STATE(1120),
    [sym_unary_expression] = STATE(1120),
    [sym_update_expression] = STATE(1120),
    [sym_string] = STATE(1120),
    [sym_template_string] = STATE(1120),
    [sym_regex] = STATE(1120),
    [sym_meta_property] = STATE(1120),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1120),
    [sym_type_assertion] = STATE(1120),
    [sym_as_expression] = STATE(1120),
    [sym_internal_module] = STATE(1120),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(2236),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [sym_null] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [343] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [344] = {
    [sym_import] = STATE(1229),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1229),
    [sym_yield_expression] = STATE(1229),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1229),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1229),
    [sym_arrow_function] = STATE(1229),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1229),
    [sym_new_expression] = STATE(1229),
    [sym_await_expression] = STATE(1229),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1229),
    [sym_augmented_assignment_expression] = STATE(1229),
    [sym_ternary_expression] = STATE(1229),
    [sym_binary_expression] = STATE(1229),
    [sym_unary_expression] = STATE(1229),
    [sym_update_expression] = STATE(1229),
    [sym_string] = STATE(1229),
    [sym_template_string] = STATE(1229),
    [sym_regex] = STATE(1229),
    [sym_meta_property] = STATE(1229),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1229),
    [sym_type_assertion] = STATE(1229),
    [sym_as_expression] = STATE(1229),
    [sym_internal_module] = STATE(1229),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2238),
    [sym_this] = ACTIONS(2240),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [sym_null] = ACTIONS(2240),
    [sym_undefined] = ACTIONS(2240),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [345] = {
    [sym_import] = STATE(1358),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1358),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1358),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1358),
    [sym_arrow_function] = STATE(1358),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1358),
    [sym_new_expression] = STATE(1358),
    [sym_await_expression] = STATE(1358),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1358),
    [sym_augmented_assignment_expression] = STATE(1358),
    [sym_ternary_expression] = STATE(1358),
    [sym_binary_expression] = STATE(1358),
    [sym_unary_expression] = STATE(1358),
    [sym_update_expression] = STATE(1358),
    [sym_string] = STATE(1358),
    [sym_template_string] = STATE(1358),
    [sym_regex] = STATE(1358),
    [sym_meta_property] = STATE(1358),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1358),
    [sym_type_assertion] = STATE(1358),
    [sym_as_expression] = STATE(1358),
    [sym_internal_module] = STATE(1358),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2242),
    [sym_this] = ACTIONS(2244),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [346] = {
    [sym_import] = STATE(1115),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1115),
    [sym_yield_expression] = STATE(1115),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1115),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1115),
    [sym_arrow_function] = STATE(1115),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1115),
    [sym_new_expression] = STATE(1115),
    [sym_await_expression] = STATE(1115),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1115),
    [sym_augmented_assignment_expression] = STATE(1115),
    [sym_ternary_expression] = STATE(1115),
    [sym_binary_expression] = STATE(1115),
    [sym_unary_expression] = STATE(1115),
    [sym_update_expression] = STATE(1115),
    [sym_string] = STATE(1115),
    [sym_template_string] = STATE(1115),
    [sym_regex] = STATE(1115),
    [sym_meta_property] = STATE(1115),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1115),
    [sym_type_assertion] = STATE(1115),
    [sym_as_expression] = STATE(1115),
    [sym_internal_module] = STATE(1115),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [347] = {
    [sym_import] = STATE(1236),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1236),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1236),
    [sym_arrow_function] = STATE(1236),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_string] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_meta_property] = STATE(1236),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1236),
    [sym_type_assertion] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [348] = {
    [sym_import] = STATE(1430),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1430),
    [sym_yield_expression] = STATE(1430),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1430),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1430),
    [sym_arrow_function] = STATE(1430),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1430),
    [sym_new_expression] = STATE(1430),
    [sym_await_expression] = STATE(1430),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1430),
    [sym_augmented_assignment_expression] = STATE(1430),
    [sym_ternary_expression] = STATE(1430),
    [sym_binary_expression] = STATE(1430),
    [sym_unary_expression] = STATE(1430),
    [sym_update_expression] = STATE(1430),
    [sym_string] = STATE(1430),
    [sym_template_string] = STATE(1430),
    [sym_regex] = STATE(1430),
    [sym_meta_property] = STATE(1430),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1430),
    [sym_type_assertion] = STATE(1430),
    [sym_as_expression] = STATE(1430),
    [sym_internal_module] = STATE(1430),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [349] = {
    [sym_import] = STATE(1111),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1111),
    [sym_yield_expression] = STATE(1111),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1111),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1111),
    [sym_arrow_function] = STATE(1111),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1111),
    [sym_new_expression] = STATE(1111),
    [sym_await_expression] = STATE(1111),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1111),
    [sym_augmented_assignment_expression] = STATE(1111),
    [sym_ternary_expression] = STATE(1111),
    [sym_binary_expression] = STATE(1111),
    [sym_unary_expression] = STATE(1111),
    [sym_update_expression] = STATE(1111),
    [sym_string] = STATE(1111),
    [sym_template_string] = STATE(1111),
    [sym_regex] = STATE(1111),
    [sym_meta_property] = STATE(1111),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1111),
    [sym_type_assertion] = STATE(1111),
    [sym_as_expression] = STATE(1111),
    [sym_internal_module] = STATE(1111),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [350] = {
    [sym_import] = STATE(1504),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1504),
    [sym_yield_expression] = STATE(1504),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1504),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1504),
    [sym_arrow_function] = STATE(1504),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1504),
    [sym_new_expression] = STATE(1504),
    [sym_await_expression] = STATE(1504),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1504),
    [sym_augmented_assignment_expression] = STATE(1504),
    [sym_ternary_expression] = STATE(1504),
    [sym_binary_expression] = STATE(1504),
    [sym_unary_expression] = STATE(1504),
    [sym_update_expression] = STATE(1504),
    [sym_string] = STATE(1504),
    [sym_template_string] = STATE(1504),
    [sym_regex] = STATE(1504),
    [sym_meta_property] = STATE(1504),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1504),
    [sym_type_assertion] = STATE(1504),
    [sym_as_expression] = STATE(1504),
    [sym_internal_module] = STATE(1504),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2262),
    [sym_this] = ACTIONS(997),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(997),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [351] = {
    [sym_import] = STATE(1354),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_string] = STATE(1354),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2264),
    [sym_this] = ACTIONS(2266),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [sym_null] = ACTIONS(2266),
    [sym_undefined] = ACTIONS(2266),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [352] = {
    [sym__declaration] = STATE(663),
    [sym_variable_declaration] = STATE(663),
    [sym_lexical_declaration] = STATE(663),
    [sym_class_declaration] = STATE(663),
    [sym_function_declaration] = STATE(663),
    [sym_generator_function_declaration] = STATE(663),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(663),
    [sym_ambient_declaration] = STATE(663),
    [sym_abstract_class_declaration] = STATE(663),
    [sym_module] = STATE(663),
    [sym_internal_module] = STATE(663),
    [sym_import_alias] = STATE(663),
    [sym_interface_declaration] = STATE(663),
    [sym_enum_declaration] = STATE(663),
    [sym_type_alias_declaration] = STATE(663),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1594),
    [anon_sym_global] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [353] = {
    [sym_import] = STATE(1330),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1330),
    [sym_yield_expression] = STATE(1330),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1330),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1330),
    [sym_arrow_function] = STATE(1330),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1330),
    [sym_new_expression] = STATE(1330),
    [sym_await_expression] = STATE(1330),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1330),
    [sym_augmented_assignment_expression] = STATE(1330),
    [sym_ternary_expression] = STATE(1330),
    [sym_binary_expression] = STATE(1330),
    [sym_unary_expression] = STATE(1330),
    [sym_update_expression] = STATE(1330),
    [sym_string] = STATE(1330),
    [sym_template_string] = STATE(1330),
    [sym_regex] = STATE(1330),
    [sym_meta_property] = STATE(1330),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1330),
    [sym_type_assertion] = STATE(1330),
    [sym_as_expression] = STATE(1330),
    [sym_internal_module] = STATE(1330),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2268),
    [sym_this] = ACTIONS(2270),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [sym_null] = ACTIONS(2270),
    [sym_undefined] = ACTIONS(2270),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [354] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1326),
    [sym_type_assertion] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2272),
    [sym_this] = ACTIONS(2274),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [sym_null] = ACTIONS(2274),
    [sym_undefined] = ACTIONS(2274),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [355] = {
    [sym_import] = STATE(1666),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1666),
    [sym_yield_expression] = STATE(1666),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1666),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1666),
    [sym_arrow_function] = STATE(1666),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1666),
    [sym_new_expression] = STATE(1666),
    [sym_await_expression] = STATE(1666),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1666),
    [sym_augmented_assignment_expression] = STATE(1666),
    [sym_ternary_expression] = STATE(1666),
    [sym_binary_expression] = STATE(1666),
    [sym_unary_expression] = STATE(1666),
    [sym_update_expression] = STATE(1666),
    [sym_string] = STATE(1666),
    [sym_template_string] = STATE(1666),
    [sym_regex] = STATE(1666),
    [sym_meta_property] = STATE(1666),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1666),
    [sym_type_assertion] = STATE(1666),
    [sym_as_expression] = STATE(1666),
    [sym_internal_module] = STATE(1666),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2276),
    [sym_this] = ACTIONS(2278),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [sym_null] = ACTIONS(2278),
    [sym_undefined] = ACTIONS(2278),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [356] = {
    [sym_import] = STATE(1448),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1448),
    [sym_yield_expression] = STATE(1448),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1448),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1448),
    [sym_arrow_function] = STATE(1448),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1448),
    [sym_new_expression] = STATE(1448),
    [sym_await_expression] = STATE(1448),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1448),
    [sym_augmented_assignment_expression] = STATE(1448),
    [sym_ternary_expression] = STATE(1448),
    [sym_binary_expression] = STATE(1448),
    [sym_unary_expression] = STATE(1448),
    [sym_update_expression] = STATE(1448),
    [sym_string] = STATE(1448),
    [sym_template_string] = STATE(1448),
    [sym_regex] = STATE(1448),
    [sym_meta_property] = STATE(1448),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1448),
    [sym_type_assertion] = STATE(1448),
    [sym_as_expression] = STATE(1448),
    [sym_internal_module] = STATE(1448),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2280),
    [sym_this] = ACTIONS(2282),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2282),
    [sym_false] = ACTIONS(2282),
    [sym_null] = ACTIONS(2282),
    [sym_undefined] = ACTIONS(2282),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [357] = {
    [sym_import] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1401),
    [sym_yield_expression] = STATE(1401),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1401),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1401),
    [sym_arrow_function] = STATE(1401),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1401),
    [sym_new_expression] = STATE(1401),
    [sym_await_expression] = STATE(1401),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1401),
    [sym_augmented_assignment_expression] = STATE(1401),
    [sym_ternary_expression] = STATE(1401),
    [sym_binary_expression] = STATE(1401),
    [sym_unary_expression] = STATE(1401),
    [sym_update_expression] = STATE(1401),
    [sym_string] = STATE(1401),
    [sym_template_string] = STATE(1401),
    [sym_regex] = STATE(1401),
    [sym_meta_property] = STATE(1401),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1401),
    [sym_type_assertion] = STATE(1401),
    [sym_as_expression] = STATE(1401),
    [sym_internal_module] = STATE(1401),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2284),
    [sym_this] = ACTIONS(2286),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2286),
    [sym_false] = ACTIONS(2286),
    [sym_null] = ACTIONS(2286),
    [sym_undefined] = ACTIONS(2286),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [358] = {
    [sym_import] = STATE(1322),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1322),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_ternary_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_update_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_template_string] = STATE(1322),
    [sym_regex] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1322),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2288),
    [sym_this] = ACTIONS(2290),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2290),
    [sym_false] = ACTIONS(2290),
    [sym_null] = ACTIONS(2290),
    [sym_undefined] = ACTIONS(2290),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [359] = {
    [sym_import] = STATE(1447),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1447),
    [sym_yield_expression] = STATE(1447),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1447),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1447),
    [sym_arrow_function] = STATE(1447),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1447),
    [sym_new_expression] = STATE(1447),
    [sym_await_expression] = STATE(1447),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1447),
    [sym_augmented_assignment_expression] = STATE(1447),
    [sym_ternary_expression] = STATE(1447),
    [sym_binary_expression] = STATE(1447),
    [sym_unary_expression] = STATE(1447),
    [sym_update_expression] = STATE(1447),
    [sym_string] = STATE(1447),
    [sym_template_string] = STATE(1447),
    [sym_regex] = STATE(1447),
    [sym_meta_property] = STATE(1447),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1447),
    [sym_type_assertion] = STATE(1447),
    [sym_as_expression] = STATE(1447),
    [sym_internal_module] = STATE(1447),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2292),
    [sym_this] = ACTIONS(2294),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2294),
    [sym_false] = ACTIONS(2294),
    [sym_null] = ACTIONS(2294),
    [sym_undefined] = ACTIONS(2294),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [360] = {
    [sym_import] = STATE(1208),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1208),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1208),
    [sym_new_expression] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_string] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1208),
    [sym_type_assertion] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2296),
    [sym_this] = ACTIONS(2298),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_undefined] = ACTIONS(2298),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [361] = {
    [sym__declaration] = STATE(663),
    [sym_variable_declaration] = STATE(663),
    [sym_lexical_declaration] = STATE(663),
    [sym_class_declaration] = STATE(663),
    [sym_function_declaration] = STATE(663),
    [sym_generator_function_declaration] = STATE(663),
    [sym_decorator] = STATE(2013),
    [sym_function_signature] = STATE(663),
    [sym_ambient_declaration] = STATE(663),
    [sym_abstract_class_declaration] = STATE(663),
    [sym_module] = STATE(663),
    [sym_internal_module] = STATE(663),
    [sym_import_alias] = STATE(663),
    [sym_interface_declaration] = STATE(663),
    [sym_enum_declaration] = STATE(663),
    [sym_type_alias_declaration] = STATE(663),
    [aux_sym_export_statement_repeat1] = STATE(2592),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1507),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_import] = ACTIONS(1513),
    [anon_sym_var] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1517),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1592),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_global] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1538),
    [anon_sym_enum] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [362] = {
    [sym_import] = STATE(1476),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1476),
    [sym_yield_expression] = STATE(1476),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1476),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1476),
    [sym_arrow_function] = STATE(1476),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1476),
    [sym_new_expression] = STATE(1476),
    [sym_await_expression] = STATE(1476),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1476),
    [sym_augmented_assignment_expression] = STATE(1476),
    [sym_ternary_expression] = STATE(1476),
    [sym_binary_expression] = STATE(1476),
    [sym_unary_expression] = STATE(1476),
    [sym_update_expression] = STATE(1476),
    [sym_string] = STATE(1476),
    [sym_template_string] = STATE(1476),
    [sym_regex] = STATE(1476),
    [sym_meta_property] = STATE(1476),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1476),
    [sym_type_assertion] = STATE(1476),
    [sym_as_expression] = STATE(1476),
    [sym_internal_module] = STATE(1476),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [363] = {
    [sym_import] = STATE(1389),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1389),
    [sym_yield_expression] = STATE(1389),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1389),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1389),
    [sym_arrow_function] = STATE(1389),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1389),
    [sym_new_expression] = STATE(1389),
    [sym_await_expression] = STATE(1389),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1389),
    [sym_augmented_assignment_expression] = STATE(1389),
    [sym_ternary_expression] = STATE(1389),
    [sym_binary_expression] = STATE(1389),
    [sym_unary_expression] = STATE(1389),
    [sym_update_expression] = STATE(1389),
    [sym_string] = STATE(1389),
    [sym_template_string] = STATE(1389),
    [sym_regex] = STATE(1389),
    [sym_meta_property] = STATE(1389),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1389),
    [sym_type_assertion] = STATE(1389),
    [sym_as_expression] = STATE(1389),
    [sym_internal_module] = STATE(1389),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [364] = {
    [sym_import] = STATE(1270),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1270),
    [sym_type_assertion] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2178),
    [sym_this] = ACTIONS(2180),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_undefined] = ACTIONS(2180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [365] = {
    [sym_import] = STATE(1513),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1513),
    [sym_yield_expression] = STATE(1513),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1513),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1513),
    [sym_arrow_function] = STATE(1513),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1513),
    [sym_new_expression] = STATE(1513),
    [sym_await_expression] = STATE(1513),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1513),
    [sym_augmented_assignment_expression] = STATE(1513),
    [sym_ternary_expression] = STATE(1513),
    [sym_binary_expression] = STATE(1513),
    [sym_unary_expression] = STATE(1513),
    [sym_update_expression] = STATE(1513),
    [sym_string] = STATE(1513),
    [sym_template_string] = STATE(1513),
    [sym_regex] = STATE(1513),
    [sym_meta_property] = STATE(1513),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1513),
    [sym_type_assertion] = STATE(1513),
    [sym_as_expression] = STATE(1513),
    [sym_internal_module] = STATE(1513),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2310),
    [sym_this] = ACTIONS(2312),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_undefined] = ACTIONS(2312),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [366] = {
    [sym_import] = STATE(1512),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1512),
    [sym_yield_expression] = STATE(1512),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1512),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1512),
    [sym_arrow_function] = STATE(1512),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1512),
    [sym_new_expression] = STATE(1512),
    [sym_await_expression] = STATE(1512),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1512),
    [sym_augmented_assignment_expression] = STATE(1512),
    [sym_ternary_expression] = STATE(1512),
    [sym_binary_expression] = STATE(1512),
    [sym_unary_expression] = STATE(1512),
    [sym_update_expression] = STATE(1512),
    [sym_string] = STATE(1512),
    [sym_template_string] = STATE(1512),
    [sym_regex] = STATE(1512),
    [sym_meta_property] = STATE(1512),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1512),
    [sym_type_assertion] = STATE(1512),
    [sym_as_expression] = STATE(1512),
    [sym_internal_module] = STATE(1512),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2314),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [367] = {
    [sym_import] = STATE(1472),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1472),
    [sym_yield_expression] = STATE(1472),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1472),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1472),
    [sym_arrow_function] = STATE(1472),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1472),
    [sym_new_expression] = STATE(1472),
    [sym_await_expression] = STATE(1472),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1472),
    [sym_augmented_assignment_expression] = STATE(1472),
    [sym_ternary_expression] = STATE(1472),
    [sym_binary_expression] = STATE(1472),
    [sym_unary_expression] = STATE(1472),
    [sym_update_expression] = STATE(1472),
    [sym_string] = STATE(1472),
    [sym_template_string] = STATE(1472),
    [sym_regex] = STATE(1472),
    [sym_meta_property] = STATE(1472),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1472),
    [sym_type_assertion] = STATE(1472),
    [sym_as_expression] = STATE(1472),
    [sym_internal_module] = STATE(1472),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2316),
    [sym_this] = ACTIONS(2318),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_undefined] = ACTIONS(2318),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [368] = {
    [sym_import] = STATE(1467),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1467),
    [sym_yield_expression] = STATE(1467),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1467),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1467),
    [sym_arrow_function] = STATE(1467),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1467),
    [sym_new_expression] = STATE(1467),
    [sym_await_expression] = STATE(1467),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1467),
    [sym_augmented_assignment_expression] = STATE(1467),
    [sym_ternary_expression] = STATE(1467),
    [sym_binary_expression] = STATE(1467),
    [sym_unary_expression] = STATE(1467),
    [sym_update_expression] = STATE(1467),
    [sym_string] = STATE(1467),
    [sym_template_string] = STATE(1467),
    [sym_regex] = STATE(1467),
    [sym_meta_property] = STATE(1467),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1467),
    [sym_type_assertion] = STATE(1467),
    [sym_as_expression] = STATE(1467),
    [sym_internal_module] = STATE(1467),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2320),
    [sym_this] = ACTIONS(2322),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [sym_null] = ACTIONS(2322),
    [sym_undefined] = ACTIONS(2322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [369] = {
    [sym_import] = STATE(1506),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1506),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1506),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1506),
    [sym_arrow_function] = STATE(1506),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1506),
    [sym_new_expression] = STATE(1506),
    [sym_await_expression] = STATE(1506),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1506),
    [sym_augmented_assignment_expression] = STATE(1506),
    [sym_ternary_expression] = STATE(1506),
    [sym_binary_expression] = STATE(1506),
    [sym_unary_expression] = STATE(1506),
    [sym_update_expression] = STATE(1506),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1506),
    [sym_regex] = STATE(1506),
    [sym_meta_property] = STATE(1506),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1506),
    [sym_type_assertion] = STATE(1506),
    [sym_as_expression] = STATE(1506),
    [sym_internal_module] = STATE(1506),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2324),
    [sym_this] = ACTIONS(2326),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [sym_null] = ACTIONS(2326),
    [sym_undefined] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [370] = {
    [sym_import] = STATE(1505),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1505),
    [sym_yield_expression] = STATE(1505),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1505),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1505),
    [sym_arrow_function] = STATE(1505),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1505),
    [sym_new_expression] = STATE(1505),
    [sym_await_expression] = STATE(1505),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1505),
    [sym_augmented_assignment_expression] = STATE(1505),
    [sym_ternary_expression] = STATE(1505),
    [sym_binary_expression] = STATE(1505),
    [sym_unary_expression] = STATE(1505),
    [sym_update_expression] = STATE(1505),
    [sym_string] = STATE(1505),
    [sym_template_string] = STATE(1505),
    [sym_regex] = STATE(1505),
    [sym_meta_property] = STATE(1505),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1505),
    [sym_type_assertion] = STATE(1505),
    [sym_as_expression] = STATE(1505),
    [sym_internal_module] = STATE(1505),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(674),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(676),
    [sym_false] = ACTIONS(676),
    [sym_null] = ACTIONS(676),
    [sym_undefined] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [371] = {
    [sym_import] = STATE(1408),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1408),
    [sym_yield_expression] = STATE(1408),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1408),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1408),
    [sym_arrow_function] = STATE(1408),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1408),
    [sym_new_expression] = STATE(1408),
    [sym_await_expression] = STATE(1408),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1408),
    [sym_augmented_assignment_expression] = STATE(1408),
    [sym_ternary_expression] = STATE(1408),
    [sym_binary_expression] = STATE(1408),
    [sym_unary_expression] = STATE(1408),
    [sym_update_expression] = STATE(1408),
    [sym_string] = STATE(1408),
    [sym_template_string] = STATE(1408),
    [sym_regex] = STATE(1408),
    [sym_meta_property] = STATE(1408),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1408),
    [sym_type_assertion] = STATE(1408),
    [sym_as_expression] = STATE(1408),
    [sym_internal_module] = STATE(1408),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2328),
    [sym_this] = ACTIONS(2330),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_undefined] = ACTIONS(2330),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [372] = {
    [sym_import] = STATE(1640),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1640),
    [sym_yield_expression] = STATE(1640),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1640),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1640),
    [sym_arrow_function] = STATE(1640),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1640),
    [sym_new_expression] = STATE(1640),
    [sym_await_expression] = STATE(1640),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1640),
    [sym_augmented_assignment_expression] = STATE(1640),
    [sym_ternary_expression] = STATE(1640),
    [sym_binary_expression] = STATE(1640),
    [sym_unary_expression] = STATE(1640),
    [sym_update_expression] = STATE(1640),
    [sym_string] = STATE(1640),
    [sym_template_string] = STATE(1640),
    [sym_regex] = STATE(1640),
    [sym_meta_property] = STATE(1640),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1640),
    [sym_type_assertion] = STATE(1640),
    [sym_as_expression] = STATE(1640),
    [sym_internal_module] = STATE(1640),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2332),
    [sym_this] = ACTIONS(2334),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [sym_null] = ACTIONS(2334),
    [sym_undefined] = ACTIONS(2334),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [373] = {
    [sym_import] = STATE(1275),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1275),
    [sym_yield_expression] = STATE(1275),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1275),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1275),
    [sym_arrow_function] = STATE(1275),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1275),
    [sym_new_expression] = STATE(1275),
    [sym_await_expression] = STATE(1275),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1275),
    [sym_augmented_assignment_expression] = STATE(1275),
    [sym_ternary_expression] = STATE(1275),
    [sym_binary_expression] = STATE(1275),
    [sym_unary_expression] = STATE(1275),
    [sym_update_expression] = STATE(1275),
    [sym_string] = STATE(1275),
    [sym_template_string] = STATE(1275),
    [sym_regex] = STATE(1275),
    [sym_meta_property] = STATE(1275),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1275),
    [sym_type_assertion] = STATE(1275),
    [sym_as_expression] = STATE(1275),
    [sym_internal_module] = STATE(1275),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2336),
    [sym_this] = ACTIONS(1085),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(1085),
    [sym_false] = ACTIONS(1085),
    [sym_null] = ACTIONS(1085),
    [sym_undefined] = ACTIONS(1085),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [374] = {
    [sym_import] = STATE(1393),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1393),
    [sym_yield_expression] = STATE(1393),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1393),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1393),
    [sym_arrow_function] = STATE(1393),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1393),
    [sym_new_expression] = STATE(1393),
    [sym_await_expression] = STATE(1393),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1393),
    [sym_augmented_assignment_expression] = STATE(1393),
    [sym_ternary_expression] = STATE(1393),
    [sym_binary_expression] = STATE(1393),
    [sym_unary_expression] = STATE(1393),
    [sym_update_expression] = STATE(1393),
    [sym_string] = STATE(1393),
    [sym_template_string] = STATE(1393),
    [sym_regex] = STATE(1393),
    [sym_meta_property] = STATE(1393),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1393),
    [sym_type_assertion] = STATE(1393),
    [sym_as_expression] = STATE(1393),
    [sym_internal_module] = STATE(1393),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [375] = {
    [sym_import] = STATE(1665),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1665),
    [sym_yield_expression] = STATE(1665),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1665),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1665),
    [sym_arrow_function] = STATE(1665),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1665),
    [sym_new_expression] = STATE(1665),
    [sym_await_expression] = STATE(1665),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1665),
    [sym_augmented_assignment_expression] = STATE(1665),
    [sym_ternary_expression] = STATE(1665),
    [sym_binary_expression] = STATE(1665),
    [sym_unary_expression] = STATE(1665),
    [sym_update_expression] = STATE(1665),
    [sym_string] = STATE(1665),
    [sym_template_string] = STATE(1665),
    [sym_regex] = STATE(1665),
    [sym_meta_property] = STATE(1665),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1665),
    [sym_type_assertion] = STATE(1665),
    [sym_as_expression] = STATE(1665),
    [sym_internal_module] = STATE(1665),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [376] = {
    [sym_import] = STATE(1336),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1336),
    [sym_yield_expression] = STATE(1336),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1336),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1336),
    [sym_arrow_function] = STATE(1336),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1336),
    [sym_new_expression] = STATE(1336),
    [sym_await_expression] = STATE(1336),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1336),
    [sym_augmented_assignment_expression] = STATE(1336),
    [sym_ternary_expression] = STATE(1336),
    [sym_binary_expression] = STATE(1336),
    [sym_unary_expression] = STATE(1336),
    [sym_update_expression] = STATE(1336),
    [sym_string] = STATE(1336),
    [sym_template_string] = STATE(1336),
    [sym_regex] = STATE(1336),
    [sym_meta_property] = STATE(1336),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1336),
    [sym_type_assertion] = STATE(1336),
    [sym_as_expression] = STATE(1336),
    [sym_internal_module] = STATE(1336),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [377] = {
    [sym_import] = STATE(1662),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1662),
    [sym_yield_expression] = STATE(1662),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1662),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1662),
    [sym_arrow_function] = STATE(1662),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1662),
    [sym_new_expression] = STATE(1662),
    [sym_await_expression] = STATE(1662),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1662),
    [sym_augmented_assignment_expression] = STATE(1662),
    [sym_ternary_expression] = STATE(1662),
    [sym_binary_expression] = STATE(1662),
    [sym_unary_expression] = STATE(1662),
    [sym_update_expression] = STATE(1662),
    [sym_string] = STATE(1662),
    [sym_template_string] = STATE(1662),
    [sym_regex] = STATE(1662),
    [sym_meta_property] = STATE(1662),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1662),
    [sym_type_assertion] = STATE(1662),
    [sym_as_expression] = STATE(1662),
    [sym_internal_module] = STATE(1662),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2350),
    [sym_this] = ACTIONS(2352),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_undefined] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [378] = {
    [sym_import] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1660),
    [sym_yield_expression] = STATE(1660),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1660),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1660),
    [sym_arrow_function] = STATE(1660),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1660),
    [sym_new_expression] = STATE(1660),
    [sym_await_expression] = STATE(1660),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1660),
    [sym_augmented_assignment_expression] = STATE(1660),
    [sym_ternary_expression] = STATE(1660),
    [sym_binary_expression] = STATE(1660),
    [sym_unary_expression] = STATE(1660),
    [sym_update_expression] = STATE(1660),
    [sym_string] = STATE(1660),
    [sym_template_string] = STATE(1660),
    [sym_regex] = STATE(1660),
    [sym_meta_property] = STATE(1660),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1660),
    [sym_type_assertion] = STATE(1660),
    [sym_as_expression] = STATE(1660),
    [sym_internal_module] = STATE(1660),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [379] = {
    [sym_import] = STATE(1366),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1366),
    [sym_yield_expression] = STATE(1366),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1366),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1366),
    [sym_arrow_function] = STATE(1366),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1366),
    [sym_new_expression] = STATE(1366),
    [sym_await_expression] = STATE(1366),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1366),
    [sym_augmented_assignment_expression] = STATE(1366),
    [sym_ternary_expression] = STATE(1366),
    [sym_binary_expression] = STATE(1366),
    [sym_unary_expression] = STATE(1366),
    [sym_update_expression] = STATE(1366),
    [sym_string] = STATE(1366),
    [sym_template_string] = STATE(1366),
    [sym_regex] = STATE(1366),
    [sym_meta_property] = STATE(1366),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1366),
    [sym_type_assertion] = STATE(1366),
    [sym_as_expression] = STATE(1366),
    [sym_internal_module] = STATE(1366),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2358),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [sym_null] = ACTIONS(2358),
    [sym_undefined] = ACTIONS(2358),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [380] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1386),
    [sym_yield_expression] = STATE(1386),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1386),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1386),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1386),
    [sym_augmented_assignment_expression] = STATE(1386),
    [sym_ternary_expression] = STATE(1386),
    [sym_binary_expression] = STATE(1386),
    [sym_unary_expression] = STATE(1386),
    [sym_update_expression] = STATE(1386),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1386),
    [sym_type_assertion] = STATE(1386),
    [sym_as_expression] = STATE(1386),
    [sym_internal_module] = STATE(1386),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2360),
    [sym_this] = ACTIONS(2362),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [sym_null] = ACTIONS(2362),
    [sym_undefined] = ACTIONS(2362),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [381] = {
    [sym_import] = STATE(1692),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1692),
    [sym_yield_expression] = STATE(1692),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1692),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1692),
    [sym_arrow_function] = STATE(1692),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1692),
    [sym_new_expression] = STATE(1692),
    [sym_await_expression] = STATE(1692),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1692),
    [sym_augmented_assignment_expression] = STATE(1692),
    [sym_ternary_expression] = STATE(1692),
    [sym_binary_expression] = STATE(1692),
    [sym_unary_expression] = STATE(1692),
    [sym_update_expression] = STATE(1692),
    [sym_string] = STATE(1692),
    [sym_template_string] = STATE(1692),
    [sym_regex] = STATE(1692),
    [sym_meta_property] = STATE(1692),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1692),
    [sym_type_assertion] = STATE(1692),
    [sym_as_expression] = STATE(1692),
    [sym_internal_module] = STATE(1692),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2364),
    [sym_this] = ACTIONS(2366),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [sym_null] = ACTIONS(2366),
    [sym_undefined] = ACTIONS(2366),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [382] = {
    [sym_import] = STATE(1657),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1657),
    [sym_yield_expression] = STATE(1657),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1657),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1657),
    [sym_arrow_function] = STATE(1657),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1657),
    [sym_new_expression] = STATE(1657),
    [sym_await_expression] = STATE(1657),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1657),
    [sym_augmented_assignment_expression] = STATE(1657),
    [sym_ternary_expression] = STATE(1657),
    [sym_binary_expression] = STATE(1657),
    [sym_unary_expression] = STATE(1657),
    [sym_update_expression] = STATE(1657),
    [sym_string] = STATE(1657),
    [sym_template_string] = STATE(1657),
    [sym_regex] = STATE(1657),
    [sym_meta_property] = STATE(1657),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1657),
    [sym_type_assertion] = STATE(1657),
    [sym_as_expression] = STATE(1657),
    [sym_internal_module] = STATE(1657),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2368),
    [sym_this] = ACTIONS(2370),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [sym_null] = ACTIONS(2370),
    [sym_undefined] = ACTIONS(2370),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [383] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1294),
    [sym_type_assertion] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2372),
    [sym_this] = ACTIONS(2374),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_undefined] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [384] = {
    [sym_import] = STATE(1394),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1394),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1394),
    [sym_arrow_function] = STATE(1394),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1394),
    [sym_new_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1394),
    [sym_augmented_assignment_expression] = STATE(1394),
    [sym_ternary_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_unary_expression] = STATE(1394),
    [sym_update_expression] = STATE(1394),
    [sym_string] = STATE(1394),
    [sym_template_string] = STATE(1394),
    [sym_regex] = STATE(1394),
    [sym_meta_property] = STATE(1394),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1394),
    [sym_type_assertion] = STATE(1394),
    [sym_as_expression] = STATE(1394),
    [sym_internal_module] = STATE(1394),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2376),
    [sym_this] = ACTIONS(2378),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [sym_null] = ACTIONS(2378),
    [sym_undefined] = ACTIONS(2378),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [385] = {
    [sym_import] = STATE(1656),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1656),
    [sym_yield_expression] = STATE(1656),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1656),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1656),
    [sym_arrow_function] = STATE(1656),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1656),
    [sym_new_expression] = STATE(1656),
    [sym_await_expression] = STATE(1656),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1656),
    [sym_augmented_assignment_expression] = STATE(1656),
    [sym_ternary_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_unary_expression] = STATE(1656),
    [sym_update_expression] = STATE(1656),
    [sym_string] = STATE(1656),
    [sym_template_string] = STATE(1656),
    [sym_regex] = STATE(1656),
    [sym_meta_property] = STATE(1656),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1656),
    [sym_type_assertion] = STATE(1656),
    [sym_as_expression] = STATE(1656),
    [sym_internal_module] = STATE(1656),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2380),
    [sym_this] = ACTIONS(2382),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [sym_null] = ACTIONS(2382),
    [sym_undefined] = ACTIONS(2382),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [386] = {
    [sym_import] = STATE(1398),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1398),
    [sym_yield_expression] = STATE(1398),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1398),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1398),
    [sym_arrow_function] = STATE(1398),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1398),
    [sym_new_expression] = STATE(1398),
    [sym_await_expression] = STATE(1398),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1398),
    [sym_augmented_assignment_expression] = STATE(1398),
    [sym_ternary_expression] = STATE(1398),
    [sym_binary_expression] = STATE(1398),
    [sym_unary_expression] = STATE(1398),
    [sym_update_expression] = STATE(1398),
    [sym_string] = STATE(1398),
    [sym_template_string] = STATE(1398),
    [sym_regex] = STATE(1398),
    [sym_meta_property] = STATE(1398),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1398),
    [sym_type_assertion] = STATE(1398),
    [sym_as_expression] = STATE(1398),
    [sym_internal_module] = STATE(1398),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2384),
    [sym_this] = ACTIONS(2386),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [sym_null] = ACTIONS(2386),
    [sym_undefined] = ACTIONS(2386),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [387] = {
    [sym_import] = STATE(1655),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1655),
    [sym_yield_expression] = STATE(1655),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1655),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1655),
    [sym_arrow_function] = STATE(1655),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1655),
    [sym_new_expression] = STATE(1655),
    [sym_await_expression] = STATE(1655),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1655),
    [sym_augmented_assignment_expression] = STATE(1655),
    [sym_ternary_expression] = STATE(1655),
    [sym_binary_expression] = STATE(1655),
    [sym_unary_expression] = STATE(1655),
    [sym_update_expression] = STATE(1655),
    [sym_string] = STATE(1655),
    [sym_template_string] = STATE(1655),
    [sym_regex] = STATE(1655),
    [sym_meta_property] = STATE(1655),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1655),
    [sym_type_assertion] = STATE(1655),
    [sym_as_expression] = STATE(1655),
    [sym_internal_module] = STATE(1655),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2388),
    [sym_this] = ACTIONS(2390),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_null] = ACTIONS(2390),
    [sym_undefined] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [388] = {
    [sym_import] = STATE(1654),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1654),
    [sym_yield_expression] = STATE(1654),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1654),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1654),
    [sym_arrow_function] = STATE(1654),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1654),
    [sym_new_expression] = STATE(1654),
    [sym_await_expression] = STATE(1654),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1654),
    [sym_augmented_assignment_expression] = STATE(1654),
    [sym_ternary_expression] = STATE(1654),
    [sym_binary_expression] = STATE(1654),
    [sym_unary_expression] = STATE(1654),
    [sym_update_expression] = STATE(1654),
    [sym_string] = STATE(1654),
    [sym_template_string] = STATE(1654),
    [sym_regex] = STATE(1654),
    [sym_meta_property] = STATE(1654),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1654),
    [sym_type_assertion] = STATE(1654),
    [sym_as_expression] = STATE(1654),
    [sym_internal_module] = STATE(1654),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2392),
    [sym_this] = ACTIONS(2394),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [sym_null] = ACTIONS(2394),
    [sym_undefined] = ACTIONS(2394),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [389] = {
    [sym_import] = STATE(1048),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1048),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1048),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1048),
    [sym_arrow_function] = STATE(1048),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1048),
    [sym_new_expression] = STATE(1048),
    [sym_await_expression] = STATE(1048),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1048),
    [sym_augmented_assignment_expression] = STATE(1048),
    [sym_ternary_expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_update_expression] = STATE(1048),
    [sym_string] = STATE(1048),
    [sym_template_string] = STATE(1048),
    [sym_regex] = STATE(1048),
    [sym_meta_property] = STATE(1048),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1048),
    [sym_type_assertion] = STATE(1048),
    [sym_as_expression] = STATE(1048),
    [sym_internal_module] = STATE(1048),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [390] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [391] = {
    [sym_import] = STATE(1208),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1208),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1208),
    [sym_new_expression] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_string] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1208),
    [sym_type_assertion] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2296),
    [sym_this] = ACTIONS(2298),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_undefined] = ACTIONS(2298),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [392] = {
    [sym_import] = STATE(1652),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1652),
    [sym_yield_expression] = STATE(1652),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1652),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1652),
    [sym_arrow_function] = STATE(1652),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1652),
    [sym_new_expression] = STATE(1652),
    [sym_await_expression] = STATE(1652),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1652),
    [sym_augmented_assignment_expression] = STATE(1652),
    [sym_ternary_expression] = STATE(1652),
    [sym_binary_expression] = STATE(1652),
    [sym_unary_expression] = STATE(1652),
    [sym_update_expression] = STATE(1652),
    [sym_string] = STATE(1652),
    [sym_template_string] = STATE(1652),
    [sym_regex] = STATE(1652),
    [sym_meta_property] = STATE(1652),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1652),
    [sym_type_assertion] = STATE(1652),
    [sym_as_expression] = STATE(1652),
    [sym_internal_module] = STATE(1652),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2396),
    [sym_this] = ACTIONS(2398),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [sym_null] = ACTIONS(2398),
    [sym_undefined] = ACTIONS(2398),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [393] = {
    [sym_import] = STATE(1706),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1706),
    [sym_yield_expression] = STATE(1706),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1706),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1706),
    [sym_arrow_function] = STATE(1706),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1706),
    [sym_new_expression] = STATE(1706),
    [sym_await_expression] = STATE(1706),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1706),
    [sym_augmented_assignment_expression] = STATE(1706),
    [sym_ternary_expression] = STATE(1706),
    [sym_binary_expression] = STATE(1706),
    [sym_unary_expression] = STATE(1706),
    [sym_update_expression] = STATE(1706),
    [sym_string] = STATE(1706),
    [sym_template_string] = STATE(1706),
    [sym_regex] = STATE(1706),
    [sym_meta_property] = STATE(1706),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1706),
    [sym_type_assertion] = STATE(1706),
    [sym_as_expression] = STATE(1706),
    [sym_internal_module] = STATE(1706),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2400),
    [sym_this] = ACTIONS(2402),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2402),
    [sym_false] = ACTIONS(2402),
    [sym_null] = ACTIONS(2402),
    [sym_undefined] = ACTIONS(2402),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [394] = {
    [sym_import] = STATE(1705),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1705),
    [sym_yield_expression] = STATE(1705),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1705),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1705),
    [sym_arrow_function] = STATE(1705),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1705),
    [sym_new_expression] = STATE(1705),
    [sym_await_expression] = STATE(1705),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1705),
    [sym_augmented_assignment_expression] = STATE(1705),
    [sym_ternary_expression] = STATE(1705),
    [sym_binary_expression] = STATE(1705),
    [sym_unary_expression] = STATE(1705),
    [sym_update_expression] = STATE(1705),
    [sym_string] = STATE(1705),
    [sym_template_string] = STATE(1705),
    [sym_regex] = STATE(1705),
    [sym_meta_property] = STATE(1705),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1705),
    [sym_type_assertion] = STATE(1705),
    [sym_as_expression] = STATE(1705),
    [sym_internal_module] = STATE(1705),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2404),
    [sym_this] = ACTIONS(2406),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2406),
    [sym_false] = ACTIONS(2406),
    [sym_null] = ACTIONS(2406),
    [sym_undefined] = ACTIONS(2406),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [395] = {
    [sym_import] = STATE(1385),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1385),
    [sym_yield_expression] = STATE(1385),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1385),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1385),
    [sym_arrow_function] = STATE(1385),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1385),
    [sym_new_expression] = STATE(1385),
    [sym_await_expression] = STATE(1385),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1385),
    [sym_augmented_assignment_expression] = STATE(1385),
    [sym_ternary_expression] = STATE(1385),
    [sym_binary_expression] = STATE(1385),
    [sym_unary_expression] = STATE(1385),
    [sym_update_expression] = STATE(1385),
    [sym_string] = STATE(1385),
    [sym_template_string] = STATE(1385),
    [sym_regex] = STATE(1385),
    [sym_meta_property] = STATE(1385),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1385),
    [sym_type_assertion] = STATE(1385),
    [sym_as_expression] = STATE(1385),
    [sym_internal_module] = STATE(1385),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2408),
    [sym_this] = ACTIONS(2410),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [sym_null] = ACTIONS(2410),
    [sym_undefined] = ACTIONS(2410),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [396] = {
    [sym_import] = STATE(1411),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1411),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1411),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1411),
    [sym_arrow_function] = STATE(1411),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1411),
    [sym_new_expression] = STATE(1411),
    [sym_await_expression] = STATE(1411),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1411),
    [sym_augmented_assignment_expression] = STATE(1411),
    [sym_ternary_expression] = STATE(1411),
    [sym_binary_expression] = STATE(1411),
    [sym_unary_expression] = STATE(1411),
    [sym_update_expression] = STATE(1411),
    [sym_string] = STATE(1411),
    [sym_template_string] = STATE(1411),
    [sym_regex] = STATE(1411),
    [sym_meta_property] = STATE(1411),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1411),
    [sym_type_assertion] = STATE(1411),
    [sym_as_expression] = STATE(1411),
    [sym_internal_module] = STATE(1411),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2412),
    [sym_this] = ACTIONS(2414),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [sym_null] = ACTIONS(2414),
    [sym_undefined] = ACTIONS(2414),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [397] = {
    [sym_import] = STATE(1611),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1611),
    [sym_yield_expression] = STATE(1611),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1611),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1611),
    [sym_arrow_function] = STATE(1611),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1611),
    [sym_new_expression] = STATE(1611),
    [sym_await_expression] = STATE(1611),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1611),
    [sym_augmented_assignment_expression] = STATE(1611),
    [sym_ternary_expression] = STATE(1611),
    [sym_binary_expression] = STATE(1611),
    [sym_unary_expression] = STATE(1611),
    [sym_update_expression] = STATE(1611),
    [sym_string] = STATE(1611),
    [sym_template_string] = STATE(1611),
    [sym_regex] = STATE(1611),
    [sym_meta_property] = STATE(1611),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1611),
    [sym_type_assertion] = STATE(1611),
    [sym_as_expression] = STATE(1611),
    [sym_internal_module] = STATE(1611),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2416),
    [sym_this] = ACTIONS(2418),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [sym_null] = ACTIONS(2418),
    [sym_undefined] = ACTIONS(2418),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [398] = {
    [sym_import] = STATE(1651),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1651),
    [sym_yield_expression] = STATE(1651),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1651),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1651),
    [sym_arrow_function] = STATE(1651),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1651),
    [sym_new_expression] = STATE(1651),
    [sym_await_expression] = STATE(1651),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1651),
    [sym_augmented_assignment_expression] = STATE(1651),
    [sym_ternary_expression] = STATE(1651),
    [sym_binary_expression] = STATE(1651),
    [sym_unary_expression] = STATE(1651),
    [sym_update_expression] = STATE(1651),
    [sym_string] = STATE(1651),
    [sym_template_string] = STATE(1651),
    [sym_regex] = STATE(1651),
    [sym_meta_property] = STATE(1651),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1651),
    [sym_type_assertion] = STATE(1651),
    [sym_as_expression] = STATE(1651),
    [sym_internal_module] = STATE(1651),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2420),
    [sym_this] = ACTIONS(2422),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [sym_null] = ACTIONS(2422),
    [sym_undefined] = ACTIONS(2422),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [399] = {
    [sym_import] = STATE(1597),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1597),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1597),
    [sym_arrow_function] = STATE(1597),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(1597),
    [sym_template_string] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_meta_property] = STATE(1597),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2426),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_null] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [400] = {
    [sym_import] = STATE(1428),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1428),
    [sym_yield_expression] = STATE(1428),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1722),
    [sym_class] = STATE(1428),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1428),
    [sym_arrow_function] = STATE(1428),
    [sym__call_signature] = STATE(2996),
    [sym_call_expression] = STATE(1428),
    [sym_new_expression] = STATE(1428),
    [sym_await_expression] = STATE(1428),
    [sym_member_expression] = STATE(1008),
    [sym_subscript_expression] = STATE(1008),
    [sym_assignment_expression] = STATE(1428),
    [sym_augmented_assignment_expression] = STATE(1428),
    [sym_ternary_expression] = STATE(1428),
    [sym_binary_expression] = STATE(1428),
    [sym_unary_expression] = STATE(1428),
    [sym_update_expression] = STATE(1428),
    [sym_string] = STATE(1428),
    [sym_template_string] = STATE(1428),
    [sym_regex] = STATE(1428),
    [sym_meta_property] = STATE(1428),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1428),
    [sym_type_assertion] = STATE(1428),
    [sym_as_expression] = STATE(1428),
    [sym_internal_module] = STATE(1428),
    [sym_type_arguments] = STATE(360),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(660),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(668),
    [anon_sym_void] = ACTIONS(670),
    [anon_sym_delete] = ACTIONS(650),
    [anon_sym_PLUS_PLUS] = ACTIONS(672),
    [anon_sym_DASH_DASH] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2428),
    [sym_this] = ACTIONS(2430),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2430),
    [sym_false] = ACTIONS(2430),
    [sym_null] = ACTIONS(2430),
    [sym_undefined] = ACTIONS(2430),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [sym_readonly] = ACTIONS(644),
  },
  [401] = {
    [sym_import] = STATE(1327),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1327),
    [sym_arrow_function] = STATE(1327),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1327),
    [sym_type_assertion] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2432),
    [sym_this] = ACTIONS(2434),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2434),
    [sym_false] = ACTIONS(2434),
    [sym_null] = ACTIONS(2434),
    [sym_undefined] = ACTIONS(2434),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [402] = {
    [sym_import] = STATE(1191),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1191),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1191),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1191),
    [sym_arrow_function] = STATE(1191),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(1191),
    [sym_ternary_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_update_expression] = STATE(1191),
    [sym_string] = STATE(1191),
    [sym_template_string] = STATE(1191),
    [sym_regex] = STATE(1191),
    [sym_meta_property] = STATE(1191),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1191),
    [sym_type_assertion] = STATE(1191),
    [sym_as_expression] = STATE(1191),
    [sym_internal_module] = STATE(1191),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2436),
    [sym_this] = ACTIONS(2438),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2438),
    [sym_false] = ACTIONS(2438),
    [sym_null] = ACTIONS(2438),
    [sym_undefined] = ACTIONS(2438),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [403] = {
    [sym_import] = STATE(1314),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1314),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1314),
    [sym_arrow_function] = STATE(1314),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1314),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1314),
    [sym_template_string] = STATE(1314),
    [sym_regex] = STATE(1314),
    [sym_meta_property] = STATE(1314),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1314),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2440),
    [sym_this] = ACTIONS(2442),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2442),
    [sym_false] = ACTIONS(2442),
    [sym_null] = ACTIONS(2442),
    [sym_undefined] = ACTIONS(2442),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [404] = {
    [sym_import] = STATE(1650),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1650),
    [sym_yield_expression] = STATE(1650),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1650),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1650),
    [sym_arrow_function] = STATE(1650),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1650),
    [sym_new_expression] = STATE(1650),
    [sym_await_expression] = STATE(1650),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1650),
    [sym_augmented_assignment_expression] = STATE(1650),
    [sym_ternary_expression] = STATE(1650),
    [sym_binary_expression] = STATE(1650),
    [sym_unary_expression] = STATE(1650),
    [sym_update_expression] = STATE(1650),
    [sym_string] = STATE(1650),
    [sym_template_string] = STATE(1650),
    [sym_regex] = STATE(1650),
    [sym_meta_property] = STATE(1650),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1650),
    [sym_type_assertion] = STATE(1650),
    [sym_as_expression] = STATE(1650),
    [sym_internal_module] = STATE(1650),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2444),
    [sym_this] = ACTIONS(2446),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_null] = ACTIONS(2446),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [405] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1187),
    [sym_type_assertion] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [406] = {
    [sym_import] = STATE(1658),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1658),
    [sym_yield_expression] = STATE(1658),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1658),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1658),
    [sym_arrow_function] = STATE(1658),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1658),
    [sym_new_expression] = STATE(1658),
    [sym_await_expression] = STATE(1658),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1658),
    [sym_augmented_assignment_expression] = STATE(1658),
    [sym_ternary_expression] = STATE(1658),
    [sym_binary_expression] = STATE(1658),
    [sym_unary_expression] = STATE(1658),
    [sym_update_expression] = STATE(1658),
    [sym_string] = STATE(1658),
    [sym_template_string] = STATE(1658),
    [sym_regex] = STATE(1658),
    [sym_meta_property] = STATE(1658),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1658),
    [sym_type_assertion] = STATE(1658),
    [sym_as_expression] = STATE(1658),
    [sym_internal_module] = STATE(1658),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(832),
    [sym_this] = ACTIONS(834),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(834),
    [sym_false] = ACTIONS(834),
    [sym_null] = ACTIONS(834),
    [sym_undefined] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [407] = {
    [sym_import] = STATE(1603),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1603),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1603),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1603),
    [sym_arrow_function] = STATE(1603),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1603),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1603),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1603),
    [sym_template_string] = STATE(1603),
    [sym_regex] = STATE(1603),
    [sym_meta_property] = STATE(1603),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1603),
    [sym_type_assertion] = STATE(1603),
    [sym_as_expression] = STATE(1603),
    [sym_internal_module] = STATE(1603),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2448),
    [sym_this] = ACTIONS(2450),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2450),
    [sym_false] = ACTIONS(2450),
    [sym_null] = ACTIONS(2450),
    [sym_undefined] = ACTIONS(2450),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [408] = {
    [sym_import] = STATE(1313),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1313),
    [sym_yield_expression] = STATE(1313),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1313),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1313),
    [sym_arrow_function] = STATE(1313),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1313),
    [sym_new_expression] = STATE(1313),
    [sym_await_expression] = STATE(1313),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1313),
    [sym_augmented_assignment_expression] = STATE(1313),
    [sym_ternary_expression] = STATE(1313),
    [sym_binary_expression] = STATE(1313),
    [sym_unary_expression] = STATE(1313),
    [sym_update_expression] = STATE(1313),
    [sym_string] = STATE(1313),
    [sym_template_string] = STATE(1313),
    [sym_regex] = STATE(1313),
    [sym_meta_property] = STATE(1313),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1313),
    [sym_type_assertion] = STATE(1313),
    [sym_as_expression] = STATE(1313),
    [sym_internal_module] = STATE(1313),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2452),
    [sym_this] = ACTIONS(963),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(963),
    [sym_false] = ACTIONS(963),
    [sym_null] = ACTIONS(963),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [409] = {
    [sym_import] = STATE(1355),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1355),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1355),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1355),
    [sym_arrow_function] = STATE(1355),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_await_expression] = STATE(1355),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1355),
    [sym_augmented_assignment_expression] = STATE(1355),
    [sym_ternary_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_update_expression] = STATE(1355),
    [sym_string] = STATE(1355),
    [sym_template_string] = STATE(1355),
    [sym_regex] = STATE(1355),
    [sym_meta_property] = STATE(1355),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1355),
    [sym_type_assertion] = STATE(1355),
    [sym_as_expression] = STATE(1355),
    [sym_internal_module] = STATE(1355),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2454),
    [sym_this] = ACTIONS(2456),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2456),
    [sym_false] = ACTIONS(2456),
    [sym_null] = ACTIONS(2456),
    [sym_undefined] = ACTIONS(2456),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [410] = {
    [sym_import] = STATE(1696),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1696),
    [sym_yield_expression] = STATE(1696),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1696),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1696),
    [sym_arrow_function] = STATE(1696),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1696),
    [sym_new_expression] = STATE(1696),
    [sym_await_expression] = STATE(1696),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1696),
    [sym_augmented_assignment_expression] = STATE(1696),
    [sym_ternary_expression] = STATE(1696),
    [sym_binary_expression] = STATE(1696),
    [sym_unary_expression] = STATE(1696),
    [sym_update_expression] = STATE(1696),
    [sym_string] = STATE(1696),
    [sym_template_string] = STATE(1696),
    [sym_regex] = STATE(1696),
    [sym_meta_property] = STATE(1696),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1696),
    [sym_type_assertion] = STATE(1696),
    [sym_as_expression] = STATE(1696),
    [sym_internal_module] = STATE(1696),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2458),
    [sym_this] = ACTIONS(2460),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2460),
    [sym_false] = ACTIONS(2460),
    [sym_null] = ACTIONS(2460),
    [sym_undefined] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [411] = {
    [sym_import] = STATE(1379),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1379),
    [sym_yield_expression] = STATE(1379),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1379),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1379),
    [sym_arrow_function] = STATE(1379),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1379),
    [sym_new_expression] = STATE(1379),
    [sym_await_expression] = STATE(1379),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1379),
    [sym_augmented_assignment_expression] = STATE(1379),
    [sym_ternary_expression] = STATE(1379),
    [sym_binary_expression] = STATE(1379),
    [sym_unary_expression] = STATE(1379),
    [sym_update_expression] = STATE(1379),
    [sym_string] = STATE(1379),
    [sym_template_string] = STATE(1379),
    [sym_regex] = STATE(1379),
    [sym_meta_property] = STATE(1379),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1379),
    [sym_type_assertion] = STATE(1379),
    [sym_as_expression] = STATE(1379),
    [sym_internal_module] = STATE(1379),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2462),
    [sym_this] = ACTIONS(2464),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2464),
    [sym_false] = ACTIONS(2464),
    [sym_null] = ACTIONS(2464),
    [sym_undefined] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [412] = {
    [sym_import] = STATE(1320),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1320),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1320),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1320),
    [sym_arrow_function] = STATE(1320),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1320),
    [sym_new_expression] = STATE(1320),
    [sym_await_expression] = STATE(1320),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1320),
    [sym_augmented_assignment_expression] = STATE(1320),
    [sym_ternary_expression] = STATE(1320),
    [sym_binary_expression] = STATE(1320),
    [sym_unary_expression] = STATE(1320),
    [sym_update_expression] = STATE(1320),
    [sym_string] = STATE(1320),
    [sym_template_string] = STATE(1320),
    [sym_regex] = STATE(1320),
    [sym_meta_property] = STATE(1320),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1320),
    [sym_type_assertion] = STATE(1320),
    [sym_as_expression] = STATE(1320),
    [sym_internal_module] = STATE(1320),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2466),
    [sym_this] = ACTIONS(2468),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2468),
    [sym_false] = ACTIONS(2468),
    [sym_null] = ACTIONS(2468),
    [sym_undefined] = ACTIONS(2468),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [413] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2470),
    [sym_this] = ACTIONS(2472),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2472),
    [sym_false] = ACTIONS(2472),
    [sym_null] = ACTIONS(2472),
    [sym_undefined] = ACTIONS(2472),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [414] = {
    [sym_import] = STATE(1167),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1167),
    [sym_yield_expression] = STATE(1167),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1167),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1167),
    [sym_arrow_function] = STATE(1167),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1167),
    [sym_new_expression] = STATE(1167),
    [sym_await_expression] = STATE(1167),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1167),
    [sym_augmented_assignment_expression] = STATE(1167),
    [sym_ternary_expression] = STATE(1167),
    [sym_binary_expression] = STATE(1167),
    [sym_unary_expression] = STATE(1167),
    [sym_update_expression] = STATE(1167),
    [sym_string] = STATE(1167),
    [sym_template_string] = STATE(1167),
    [sym_regex] = STATE(1167),
    [sym_meta_property] = STATE(1167),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1167),
    [sym_type_assertion] = STATE(1167),
    [sym_as_expression] = STATE(1167),
    [sym_internal_module] = STATE(1167),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2474),
    [sym_this] = ACTIONS(2476),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [sym_null] = ACTIONS(2476),
    [sym_undefined] = ACTIONS(2476),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [415] = {
    [sym_import] = STATE(1352),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1352),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1352),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1352),
    [sym_arrow_function] = STATE(1352),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_await_expression] = STATE(1352),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1352),
    [sym_augmented_assignment_expression] = STATE(1352),
    [sym_ternary_expression] = STATE(1352),
    [sym_binary_expression] = STATE(1352),
    [sym_unary_expression] = STATE(1352),
    [sym_update_expression] = STATE(1352),
    [sym_string] = STATE(1352),
    [sym_template_string] = STATE(1352),
    [sym_regex] = STATE(1352),
    [sym_meta_property] = STATE(1352),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1352),
    [sym_type_assertion] = STATE(1352),
    [sym_as_expression] = STATE(1352),
    [sym_internal_module] = STATE(1352),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2478),
    [sym_this] = ACTIONS(2480),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_undefined] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [416] = {
    [sym_import] = STATE(1583),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1583),
    [sym_yield_expression] = STATE(1583),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1583),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1583),
    [sym_arrow_function] = STATE(1583),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1583),
    [sym_new_expression] = STATE(1583),
    [sym_await_expression] = STATE(1583),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1583),
    [sym_augmented_assignment_expression] = STATE(1583),
    [sym_ternary_expression] = STATE(1583),
    [sym_binary_expression] = STATE(1583),
    [sym_unary_expression] = STATE(1583),
    [sym_update_expression] = STATE(1583),
    [sym_string] = STATE(1583),
    [sym_template_string] = STATE(1583),
    [sym_regex] = STATE(1583),
    [sym_meta_property] = STATE(1583),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1583),
    [sym_type_assertion] = STATE(1583),
    [sym_as_expression] = STATE(1583),
    [sym_internal_module] = STATE(1583),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2482),
    [sym_this] = ACTIONS(2484),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [sym_null] = ACTIONS(2484),
    [sym_undefined] = ACTIONS(2484),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [417] = {
    [sym_import] = STATE(1374),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1374),
    [sym_yield_expression] = STATE(1374),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1374),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1374),
    [sym_arrow_function] = STATE(1374),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1374),
    [sym_new_expression] = STATE(1374),
    [sym_await_expression] = STATE(1374),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1374),
    [sym_augmented_assignment_expression] = STATE(1374),
    [sym_ternary_expression] = STATE(1374),
    [sym_binary_expression] = STATE(1374),
    [sym_unary_expression] = STATE(1374),
    [sym_update_expression] = STATE(1374),
    [sym_string] = STATE(1374),
    [sym_template_string] = STATE(1374),
    [sym_regex] = STATE(1374),
    [sym_meta_property] = STATE(1374),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1374),
    [sym_type_assertion] = STATE(1374),
    [sym_as_expression] = STATE(1374),
    [sym_internal_module] = STATE(1374),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2486),
    [sym_this] = ACTIONS(2488),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [sym_null] = ACTIONS(2488),
    [sym_undefined] = ACTIONS(2488),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [418] = {
    [sym_import] = STATE(1373),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1373),
    [sym_type_assertion] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(798),
    [sym_this] = ACTIONS(800),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(800),
    [sym_false] = ACTIONS(800),
    [sym_null] = ACTIONS(800),
    [sym_undefined] = ACTIONS(800),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [419] = {
    [sym_import] = STATE(1323),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1323),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1323),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1323),
    [sym_arrow_function] = STATE(1323),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1323),
    [sym_new_expression] = STATE(1323),
    [sym_await_expression] = STATE(1323),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1323),
    [sym_augmented_assignment_expression] = STATE(1323),
    [sym_ternary_expression] = STATE(1323),
    [sym_binary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(1323),
    [sym_update_expression] = STATE(1323),
    [sym_string] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_regex] = STATE(1323),
    [sym_meta_property] = STATE(1323),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1323),
    [sym_type_assertion] = STATE(1323),
    [sym_as_expression] = STATE(1323),
    [sym_internal_module] = STATE(1323),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2490),
    [sym_this] = ACTIONS(2492),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [sym_null] = ACTIONS(2492),
    [sym_undefined] = ACTIONS(2492),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [420] = {
    [sym_import] = STATE(1191),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1191),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1191),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1191),
    [sym_arrow_function] = STATE(1191),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(1191),
    [sym_ternary_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_update_expression] = STATE(1191),
    [sym_string] = STATE(1191),
    [sym_template_string] = STATE(1191),
    [sym_regex] = STATE(1191),
    [sym_meta_property] = STATE(1191),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1191),
    [sym_type_assertion] = STATE(1191),
    [sym_as_expression] = STATE(1191),
    [sym_internal_module] = STATE(1191),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2436),
    [sym_this] = ACTIONS(2438),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2438),
    [sym_false] = ACTIONS(2438),
    [sym_null] = ACTIONS(2438),
    [sym_undefined] = ACTIONS(2438),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [421] = {
    [sym_import] = STATE(1394),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1394),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1394),
    [sym_arrow_function] = STATE(1394),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1394),
    [sym_new_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1394),
    [sym_augmented_assignment_expression] = STATE(1394),
    [sym_ternary_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_unary_expression] = STATE(1394),
    [sym_update_expression] = STATE(1394),
    [sym_string] = STATE(1394),
    [sym_template_string] = STATE(1394),
    [sym_regex] = STATE(1394),
    [sym_meta_property] = STATE(1394),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1394),
    [sym_type_assertion] = STATE(1394),
    [sym_as_expression] = STATE(1394),
    [sym_internal_module] = STATE(1394),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2378),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [sym_null] = ACTIONS(2378),
    [sym_undefined] = ACTIONS(2378),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [422] = {
    [sym_import] = STATE(1597),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1597),
    [sym_yield_expression] = STATE(1597),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1597),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1597),
    [sym_arrow_function] = STATE(1597),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1597),
    [sym_new_expression] = STATE(1597),
    [sym_await_expression] = STATE(1597),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1597),
    [sym_augmented_assignment_expression] = STATE(1597),
    [sym_ternary_expression] = STATE(1597),
    [sym_binary_expression] = STATE(1597),
    [sym_unary_expression] = STATE(1597),
    [sym_update_expression] = STATE(1597),
    [sym_string] = STATE(1597),
    [sym_template_string] = STATE(1597),
    [sym_regex] = STATE(1597),
    [sym_meta_property] = STATE(1597),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1597),
    [sym_type_assertion] = STATE(1597),
    [sym_as_expression] = STATE(1597),
    [sym_internal_module] = STATE(1597),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2494),
    [sym_this] = ACTIONS(2426),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_null] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [423] = {
    [sym_import] = STATE(1595),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1595),
    [sym_yield_expression] = STATE(1595),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1595),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1595),
    [sym_arrow_function] = STATE(1595),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1595),
    [sym_new_expression] = STATE(1595),
    [sym_await_expression] = STATE(1595),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1595),
    [sym_augmented_assignment_expression] = STATE(1595),
    [sym_ternary_expression] = STATE(1595),
    [sym_binary_expression] = STATE(1595),
    [sym_unary_expression] = STATE(1595),
    [sym_update_expression] = STATE(1595),
    [sym_string] = STATE(1595),
    [sym_template_string] = STATE(1595),
    [sym_regex] = STATE(1595),
    [sym_meta_property] = STATE(1595),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1595),
    [sym_type_assertion] = STATE(1595),
    [sym_as_expression] = STATE(1595),
    [sym_internal_module] = STATE(1595),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2496),
    [sym_this] = ACTIONS(2498),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2498),
    [sym_false] = ACTIONS(2498),
    [sym_null] = ACTIONS(2498),
    [sym_undefined] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [424] = {
    [sym_import] = STATE(1048),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1048),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1048),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1048),
    [sym_arrow_function] = STATE(1048),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1048),
    [sym_new_expression] = STATE(1048),
    [sym_await_expression] = STATE(1048),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1048),
    [sym_augmented_assignment_expression] = STATE(1048),
    [sym_ternary_expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_update_expression] = STATE(1048),
    [sym_string] = STATE(1048),
    [sym_template_string] = STATE(1048),
    [sym_regex] = STATE(1048),
    [sym_meta_property] = STATE(1048),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1048),
    [sym_type_assertion] = STATE(1048),
    [sym_as_expression] = STATE(1048),
    [sym_internal_module] = STATE(1048),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [425] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2500),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [426] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1255),
    [sym_yield_expression] = STATE(1255),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1255),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1255),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1255),
    [sym_augmented_assignment_expression] = STATE(1255),
    [sym_ternary_expression] = STATE(1255),
    [sym_binary_expression] = STATE(1255),
    [sym_unary_expression] = STATE(1255),
    [sym_update_expression] = STATE(1255),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1255),
    [sym_type_assertion] = STATE(1255),
    [sym_as_expression] = STATE(1255),
    [sym_internal_module] = STATE(1255),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2154),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [sym_null] = ACTIONS(2154),
    [sym_undefined] = ACTIONS(2154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [427] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [428] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1319),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1319),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1319),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1319),
    [sym_augmented_assignment_expression] = STATE(1319),
    [sym_ternary_expression] = STATE(1319),
    [sym_binary_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1319),
    [sym_update_expression] = STATE(1319),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1319),
    [sym_type_assertion] = STATE(1319),
    [sym_as_expression] = STATE(1319),
    [sym_internal_module] = STATE(1319),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2502),
    [sym_this] = ACTIONS(2504),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [sym_null] = ACTIONS(2504),
    [sym_undefined] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [429] = {
    [sym_import] = STATE(1318),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1318),
    [sym_yield_expression] = STATE(1318),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1318),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1318),
    [sym_arrow_function] = STATE(1318),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1318),
    [sym_new_expression] = STATE(1318),
    [sym_await_expression] = STATE(1318),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1318),
    [sym_augmented_assignment_expression] = STATE(1318),
    [sym_ternary_expression] = STATE(1318),
    [sym_binary_expression] = STATE(1318),
    [sym_unary_expression] = STATE(1318),
    [sym_update_expression] = STATE(1318),
    [sym_string] = STATE(1318),
    [sym_template_string] = STATE(1318),
    [sym_regex] = STATE(1318),
    [sym_meta_property] = STATE(1318),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1318),
    [sym_type_assertion] = STATE(1318),
    [sym_as_expression] = STATE(1318),
    [sym_internal_module] = STATE(1318),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2506),
    [sym_this] = ACTIONS(2508),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [sym_null] = ACTIONS(2508),
    [sym_undefined] = ACTIONS(2508),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [430] = {
    [sym_import] = STATE(1152),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1152),
    [sym_yield_expression] = STATE(1152),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1152),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1152),
    [sym_arrow_function] = STATE(1152),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1152),
    [sym_new_expression] = STATE(1152),
    [sym_await_expression] = STATE(1152),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1152),
    [sym_augmented_assignment_expression] = STATE(1152),
    [sym_ternary_expression] = STATE(1152),
    [sym_binary_expression] = STATE(1152),
    [sym_unary_expression] = STATE(1152),
    [sym_update_expression] = STATE(1152),
    [sym_string] = STATE(1152),
    [sym_template_string] = STATE(1152),
    [sym_regex] = STATE(1152),
    [sym_meta_property] = STATE(1152),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1152),
    [sym_type_assertion] = STATE(1152),
    [sym_as_expression] = STATE(1152),
    [sym_internal_module] = STATE(1152),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2510),
    [sym_this] = ACTIONS(2512),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [sym_null] = ACTIONS(2512),
    [sym_undefined] = ACTIONS(2512),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [431] = {
    [sym_import] = STATE(1317),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1317),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1317),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1317),
    [sym_arrow_function] = STATE(1317),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1317),
    [sym_new_expression] = STATE(1317),
    [sym_await_expression] = STATE(1317),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1317),
    [sym_augmented_assignment_expression] = STATE(1317),
    [sym_ternary_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_unary_expression] = STATE(1317),
    [sym_update_expression] = STATE(1317),
    [sym_string] = STATE(1317),
    [sym_template_string] = STATE(1317),
    [sym_regex] = STATE(1317),
    [sym_meta_property] = STATE(1317),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1317),
    [sym_type_assertion] = STATE(1317),
    [sym_as_expression] = STATE(1317),
    [sym_internal_module] = STATE(1317),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2514),
    [sym_this] = ACTIONS(2516),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2516),
    [sym_false] = ACTIONS(2516),
    [sym_null] = ACTIONS(2516),
    [sym_undefined] = ACTIONS(2516),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [432] = {
    [sym_import] = STATE(1152),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1152),
    [sym_yield_expression] = STATE(1152),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1152),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1152),
    [sym_arrow_function] = STATE(1152),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1152),
    [sym_new_expression] = STATE(1152),
    [sym_await_expression] = STATE(1152),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1152),
    [sym_augmented_assignment_expression] = STATE(1152),
    [sym_ternary_expression] = STATE(1152),
    [sym_binary_expression] = STATE(1152),
    [sym_unary_expression] = STATE(1152),
    [sym_update_expression] = STATE(1152),
    [sym_string] = STATE(1152),
    [sym_template_string] = STATE(1152),
    [sym_regex] = STATE(1152),
    [sym_meta_property] = STATE(1152),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1152),
    [sym_type_assertion] = STATE(1152),
    [sym_as_expression] = STATE(1152),
    [sym_internal_module] = STATE(1152),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2510),
    [sym_this] = ACTIONS(2512),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [sym_null] = ACTIONS(2512),
    [sym_undefined] = ACTIONS(2512),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [433] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1315),
    [sym_type_assertion] = STATE(1315),
    [sym_as_expression] = STATE(1315),
    [sym_internal_module] = STATE(1315),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2520),
    [sym_this] = ACTIONS(2522),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_null] = ACTIONS(2522),
    [sym_undefined] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [434] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1308),
    [sym_type_assertion] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2524),
    [sym_this] = ACTIONS(2526),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2526),
    [sym_false] = ACTIONS(2526),
    [sym_null] = ACTIONS(2526),
    [sym_undefined] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [435] = {
    [sym_import] = STATE(1703),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1703),
    [sym_yield_expression] = STATE(1703),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1703),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1703),
    [sym_arrow_function] = STATE(1703),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1703),
    [sym_new_expression] = STATE(1703),
    [sym_await_expression] = STATE(1703),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1703),
    [sym_augmented_assignment_expression] = STATE(1703),
    [sym_ternary_expression] = STATE(1703),
    [sym_binary_expression] = STATE(1703),
    [sym_unary_expression] = STATE(1703),
    [sym_update_expression] = STATE(1703),
    [sym_string] = STATE(1703),
    [sym_template_string] = STATE(1703),
    [sym_regex] = STATE(1703),
    [sym_meta_property] = STATE(1703),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1703),
    [sym_type_assertion] = STATE(1703),
    [sym_as_expression] = STATE(1703),
    [sym_internal_module] = STATE(1703),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2528),
    [sym_this] = ACTIONS(2530),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2530),
    [sym_false] = ACTIONS(2530),
    [sym_null] = ACTIONS(2530),
    [sym_undefined] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [436] = {
    [sym_import] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1704),
    [sym_yield_expression] = STATE(1704),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1704),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1704),
    [sym_arrow_function] = STATE(1704),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1704),
    [sym_new_expression] = STATE(1704),
    [sym_await_expression] = STATE(1704),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1704),
    [sym_augmented_assignment_expression] = STATE(1704),
    [sym_ternary_expression] = STATE(1704),
    [sym_binary_expression] = STATE(1704),
    [sym_unary_expression] = STATE(1704),
    [sym_update_expression] = STATE(1704),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1704),
    [sym_regex] = STATE(1704),
    [sym_meta_property] = STATE(1704),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1704),
    [sym_type_assertion] = STATE(1704),
    [sym_as_expression] = STATE(1704),
    [sym_internal_module] = STATE(1704),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2532),
    [sym_this] = ACTIONS(2534),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [437] = {
    [sym_import] = STATE(1707),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1707),
    [sym_yield_expression] = STATE(1707),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1707),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1707),
    [sym_arrow_function] = STATE(1707),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1707),
    [sym_new_expression] = STATE(1707),
    [sym_await_expression] = STATE(1707),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1707),
    [sym_augmented_assignment_expression] = STATE(1707),
    [sym_ternary_expression] = STATE(1707),
    [sym_binary_expression] = STATE(1707),
    [sym_unary_expression] = STATE(1707),
    [sym_update_expression] = STATE(1707),
    [sym_string] = STATE(1707),
    [sym_template_string] = STATE(1707),
    [sym_regex] = STATE(1707),
    [sym_meta_property] = STATE(1707),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1707),
    [sym_type_assertion] = STATE(1707),
    [sym_as_expression] = STATE(1707),
    [sym_internal_module] = STATE(1707),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2536),
    [sym_this] = ACTIONS(2538),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [sym_null] = ACTIONS(2538),
    [sym_undefined] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [438] = {
    [sym_import] = STATE(1684),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1684),
    [sym_yield_expression] = STATE(1684),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1684),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1684),
    [sym_arrow_function] = STATE(1684),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1684),
    [sym_new_expression] = STATE(1684),
    [sym_await_expression] = STATE(1684),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1684),
    [sym_augmented_assignment_expression] = STATE(1684),
    [sym_ternary_expression] = STATE(1684),
    [sym_binary_expression] = STATE(1684),
    [sym_unary_expression] = STATE(1684),
    [sym_update_expression] = STATE(1684),
    [sym_string] = STATE(1684),
    [sym_template_string] = STATE(1684),
    [sym_regex] = STATE(1684),
    [sym_meta_property] = STATE(1684),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1684),
    [sym_type_assertion] = STATE(1684),
    [sym_as_expression] = STATE(1684),
    [sym_internal_module] = STATE(1684),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2540),
    [sym_this] = ACTIONS(1119),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [439] = {
    [sym_import] = STATE(1700),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1700),
    [sym_yield_expression] = STATE(1700),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1700),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1700),
    [sym_arrow_function] = STATE(1700),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1700),
    [sym_new_expression] = STATE(1700),
    [sym_await_expression] = STATE(1700),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1700),
    [sym_augmented_assignment_expression] = STATE(1700),
    [sym_ternary_expression] = STATE(1700),
    [sym_binary_expression] = STATE(1700),
    [sym_unary_expression] = STATE(1700),
    [sym_update_expression] = STATE(1700),
    [sym_string] = STATE(1700),
    [sym_template_string] = STATE(1700),
    [sym_regex] = STATE(1700),
    [sym_meta_property] = STATE(1700),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1700),
    [sym_type_assertion] = STATE(1700),
    [sym_as_expression] = STATE(1700),
    [sym_internal_module] = STATE(1700),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2542),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [440] = {
    [sym_import] = STATE(1699),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1699),
    [sym_yield_expression] = STATE(1699),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1699),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1699),
    [sym_arrow_function] = STATE(1699),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1699),
    [sym_new_expression] = STATE(1699),
    [sym_await_expression] = STATE(1699),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1699),
    [sym_augmented_assignment_expression] = STATE(1699),
    [sym_ternary_expression] = STATE(1699),
    [sym_binary_expression] = STATE(1699),
    [sym_unary_expression] = STATE(1699),
    [sym_update_expression] = STATE(1699),
    [sym_string] = STATE(1699),
    [sym_template_string] = STATE(1699),
    [sym_regex] = STATE(1699),
    [sym_meta_property] = STATE(1699),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1699),
    [sym_type_assertion] = STATE(1699),
    [sym_as_expression] = STATE(1699),
    [sym_internal_module] = STATE(1699),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2548),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [sym_null] = ACTIONS(2548),
    [sym_undefined] = ACTIONS(2548),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [441] = {
    [sym_import] = STATE(1697),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1697),
    [sym_yield_expression] = STATE(1697),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1697),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1697),
    [sym_arrow_function] = STATE(1697),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1697),
    [sym_new_expression] = STATE(1697),
    [sym_await_expression] = STATE(1697),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1697),
    [sym_augmented_assignment_expression] = STATE(1697),
    [sym_ternary_expression] = STATE(1697),
    [sym_binary_expression] = STATE(1697),
    [sym_unary_expression] = STATE(1697),
    [sym_update_expression] = STATE(1697),
    [sym_string] = STATE(1697),
    [sym_template_string] = STATE(1697),
    [sym_regex] = STATE(1697),
    [sym_meta_property] = STATE(1697),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1697),
    [sym_type_assertion] = STATE(1697),
    [sym_as_expression] = STATE(1697),
    [sym_internal_module] = STATE(1697),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2550),
    [sym_this] = ACTIONS(2552),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_undefined] = ACTIONS(2552),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [442] = {
    [sym_import] = STATE(1690),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1690),
    [sym_yield_expression] = STATE(1690),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1690),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1690),
    [sym_arrow_function] = STATE(1690),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1690),
    [sym_new_expression] = STATE(1690),
    [sym_await_expression] = STATE(1690),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1690),
    [sym_augmented_assignment_expression] = STATE(1690),
    [sym_ternary_expression] = STATE(1690),
    [sym_binary_expression] = STATE(1690),
    [sym_unary_expression] = STATE(1690),
    [sym_update_expression] = STATE(1690),
    [sym_string] = STATE(1690),
    [sym_template_string] = STATE(1690),
    [sym_regex] = STATE(1690),
    [sym_meta_property] = STATE(1690),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1690),
    [sym_type_assertion] = STATE(1690),
    [sym_as_expression] = STATE(1690),
    [sym_internal_module] = STATE(1690),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2554),
    [sym_this] = ACTIONS(2556),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [sym_null] = ACTIONS(2556),
    [sym_undefined] = ACTIONS(2556),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [443] = {
    [sym_import] = STATE(1204),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1204),
    [sym_type_assertion] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2558),
    [sym_this] = ACTIONS(1131),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1131),
    [sym_false] = ACTIONS(1131),
    [sym_null] = ACTIONS(1131),
    [sym_undefined] = ACTIONS(1131),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [444] = {
    [sym_import] = STATE(1307),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1307),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1307),
    [sym_arrow_function] = STATE(1307),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1307),
    [sym_new_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1307),
    [sym_augmented_assignment_expression] = STATE(1307),
    [sym_ternary_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_unary_expression] = STATE(1307),
    [sym_update_expression] = STATE(1307),
    [sym_string] = STATE(1307),
    [sym_template_string] = STATE(1307),
    [sym_regex] = STATE(1307),
    [sym_meta_property] = STATE(1307),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1307),
    [sym_type_assertion] = STATE(1307),
    [sym_as_expression] = STATE(1307),
    [sym_internal_module] = STATE(1307),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2560),
    [sym_this] = ACTIONS(2562),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_null] = ACTIONS(2562),
    [sym_undefined] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [445] = {
    [sym_import] = STATE(1689),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1689),
    [sym_yield_expression] = STATE(1689),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1689),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1689),
    [sym_arrow_function] = STATE(1689),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1689),
    [sym_new_expression] = STATE(1689),
    [sym_await_expression] = STATE(1689),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1689),
    [sym_augmented_assignment_expression] = STATE(1689),
    [sym_ternary_expression] = STATE(1689),
    [sym_binary_expression] = STATE(1689),
    [sym_unary_expression] = STATE(1689),
    [sym_update_expression] = STATE(1689),
    [sym_string] = STATE(1689),
    [sym_template_string] = STATE(1689),
    [sym_regex] = STATE(1689),
    [sym_meta_property] = STATE(1689),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1689),
    [sym_type_assertion] = STATE(1689),
    [sym_as_expression] = STATE(1689),
    [sym_internal_module] = STATE(1689),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2564),
    [sym_this] = ACTIONS(2566),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_null] = ACTIONS(2566),
    [sym_undefined] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [446] = {
    [sym_import] = STATE(1306),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1306),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1306),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1306),
    [sym_arrow_function] = STATE(1306),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1306),
    [sym_new_expression] = STATE(1306),
    [sym_await_expression] = STATE(1306),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1306),
    [sym_augmented_assignment_expression] = STATE(1306),
    [sym_ternary_expression] = STATE(1306),
    [sym_binary_expression] = STATE(1306),
    [sym_unary_expression] = STATE(1306),
    [sym_update_expression] = STATE(1306),
    [sym_string] = STATE(1306),
    [sym_template_string] = STATE(1306),
    [sym_regex] = STATE(1306),
    [sym_meta_property] = STATE(1306),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1306),
    [sym_type_assertion] = STATE(1306),
    [sym_as_expression] = STATE(1306),
    [sym_internal_module] = STATE(1306),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2568),
    [sym_this] = ACTIONS(2570),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2570),
    [sym_false] = ACTIONS(2570),
    [sym_null] = ACTIONS(2570),
    [sym_undefined] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [447] = {
    [sym_import] = STATE(1291),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1291),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1291),
    [sym_arrow_function] = STATE(1291),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1291),
    [sym_new_expression] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_string] = STATE(1291),
    [sym_template_string] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1291),
    [sym_type_assertion] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(1145),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [sym_null] = ACTIONS(1145),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [448] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2574),
    [sym_this] = ACTIONS(2576),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [sym_null] = ACTIONS(2576),
    [sym_undefined] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [449] = {
    [sym_import] = STATE(1290),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1290),
    [sym_yield_expression] = STATE(1290),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1290),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1290),
    [sym_new_expression] = STATE(1290),
    [sym_await_expression] = STATE(1290),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1290),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_ternary_expression] = STATE(1290),
    [sym_binary_expression] = STATE(1290),
    [sym_unary_expression] = STATE(1290),
    [sym_update_expression] = STATE(1290),
    [sym_string] = STATE(1290),
    [sym_template_string] = STATE(1290),
    [sym_regex] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1290),
    [sym_type_assertion] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2578),
    [sym_this] = ACTIONS(2580),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [sym_null] = ACTIONS(2580),
    [sym_undefined] = ACTIONS(2580),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [450] = {
    [sym_import] = STATE(1310),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1310),
    [sym_yield_expression] = STATE(1310),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1310),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1310),
    [sym_arrow_function] = STATE(1310),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_await_expression] = STATE(1310),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1310),
    [sym_augmented_assignment_expression] = STATE(1310),
    [sym_ternary_expression] = STATE(1310),
    [sym_binary_expression] = STATE(1310),
    [sym_unary_expression] = STATE(1310),
    [sym_update_expression] = STATE(1310),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_meta_property] = STATE(1310),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1310),
    [sym_type_assertion] = STATE(1310),
    [sym_as_expression] = STATE(1310),
    [sym_internal_module] = STATE(1310),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2582),
    [sym_this] = ACTIONS(2584),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [sym_null] = ACTIONS(2584),
    [sym_undefined] = ACTIONS(2584),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [451] = {
    [sym_import] = STATE(1683),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1683),
    [sym_yield_expression] = STATE(1683),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1683),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1683),
    [sym_arrow_function] = STATE(1683),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1683),
    [sym_new_expression] = STATE(1683),
    [sym_await_expression] = STATE(1683),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1683),
    [sym_augmented_assignment_expression] = STATE(1683),
    [sym_ternary_expression] = STATE(1683),
    [sym_binary_expression] = STATE(1683),
    [sym_unary_expression] = STATE(1683),
    [sym_update_expression] = STATE(1683),
    [sym_string] = STATE(1683),
    [sym_template_string] = STATE(1683),
    [sym_regex] = STATE(1683),
    [sym_meta_property] = STATE(1683),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1683),
    [sym_type_assertion] = STATE(1683),
    [sym_as_expression] = STATE(1683),
    [sym_internal_module] = STATE(1683),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2588),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [sym_null] = ACTIONS(2588),
    [sym_undefined] = ACTIONS(2588),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [452] = {
    [sym_import] = STATE(1309),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1309),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1309),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1309),
    [sym_arrow_function] = STATE(1309),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1309),
    [sym_new_expression] = STATE(1309),
    [sym_await_expression] = STATE(1309),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1309),
    [sym_augmented_assignment_expression] = STATE(1309),
    [sym_ternary_expression] = STATE(1309),
    [sym_binary_expression] = STATE(1309),
    [sym_unary_expression] = STATE(1309),
    [sym_update_expression] = STATE(1309),
    [sym_string] = STATE(1309),
    [sym_template_string] = STATE(1309),
    [sym_regex] = STATE(1309),
    [sym_meta_property] = STATE(1309),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1309),
    [sym_type_assertion] = STATE(1309),
    [sym_as_expression] = STATE(1309),
    [sym_internal_module] = STATE(1309),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2592),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [sym_null] = ACTIONS(2592),
    [sym_undefined] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [453] = {
    [sym_import] = STATE(1682),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1682),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1682),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1682),
    [sym_arrow_function] = STATE(1682),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1682),
    [sym_new_expression] = STATE(1682),
    [sym_await_expression] = STATE(1682),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1682),
    [sym_augmented_assignment_expression] = STATE(1682),
    [sym_ternary_expression] = STATE(1682),
    [sym_binary_expression] = STATE(1682),
    [sym_unary_expression] = STATE(1682),
    [sym_update_expression] = STATE(1682),
    [sym_string] = STATE(1682),
    [sym_template_string] = STATE(1682),
    [sym_regex] = STATE(1682),
    [sym_meta_property] = STATE(1682),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1682),
    [sym_type_assertion] = STATE(1682),
    [sym_as_expression] = STATE(1682),
    [sym_internal_module] = STATE(1682),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2594),
    [sym_this] = ACTIONS(2596),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [sym_null] = ACTIONS(2596),
    [sym_undefined] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [454] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1289),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1289),
    [sym_arrow_function] = STATE(1289),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1289),
    [sym_new_expression] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_string] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1289),
    [sym_type_assertion] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2598),
    [sym_this] = ACTIONS(2600),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [sym_null] = ACTIONS(2600),
    [sym_undefined] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [455] = {
    [sym_import] = STATE(1304),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1304),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1304),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1304),
    [sym_arrow_function] = STATE(1304),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1304),
    [sym_new_expression] = STATE(1304),
    [sym_await_expression] = STATE(1304),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1304),
    [sym_augmented_assignment_expression] = STATE(1304),
    [sym_ternary_expression] = STATE(1304),
    [sym_binary_expression] = STATE(1304),
    [sym_unary_expression] = STATE(1304),
    [sym_update_expression] = STATE(1304),
    [sym_string] = STATE(1304),
    [sym_template_string] = STATE(1304),
    [sym_regex] = STATE(1304),
    [sym_meta_property] = STATE(1304),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(1304),
    [sym_as_expression] = STATE(1304),
    [sym_internal_module] = STATE(1304),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2602),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [456] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1303),
    [sym_type_assertion] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [457] = {
    [sym_import] = STATE(1334),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1334),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1334),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1334),
    [sym_arrow_function] = STATE(1334),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1334),
    [sym_new_expression] = STATE(1334),
    [sym_await_expression] = STATE(1334),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1334),
    [sym_augmented_assignment_expression] = STATE(1334),
    [sym_ternary_expression] = STATE(1334),
    [sym_binary_expression] = STATE(1334),
    [sym_unary_expression] = STATE(1334),
    [sym_update_expression] = STATE(1334),
    [sym_string] = STATE(1334),
    [sym_template_string] = STATE(1334),
    [sym_regex] = STATE(1334),
    [sym_meta_property] = STATE(1334),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1334),
    [sym_type_assertion] = STATE(1334),
    [sym_as_expression] = STATE(1334),
    [sym_internal_module] = STATE(1334),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2612),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [sym_null] = ACTIONS(2612),
    [sym_undefined] = ACTIONS(2612),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [458] = {
    [sym_import] = STATE(1142),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1142),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1142),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1142),
    [sym_arrow_function] = STATE(1142),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1142),
    [sym_new_expression] = STATE(1142),
    [sym_await_expression] = STATE(1142),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1142),
    [sym_augmented_assignment_expression] = STATE(1142),
    [sym_ternary_expression] = STATE(1142),
    [sym_binary_expression] = STATE(1142),
    [sym_unary_expression] = STATE(1142),
    [sym_update_expression] = STATE(1142),
    [sym_string] = STATE(1142),
    [sym_template_string] = STATE(1142),
    [sym_regex] = STATE(1142),
    [sym_meta_property] = STATE(1142),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1142),
    [sym_type_assertion] = STATE(1142),
    [sym_as_expression] = STATE(1142),
    [sym_internal_module] = STATE(1142),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2614),
    [sym_this] = ACTIONS(2616),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [sym_null] = ACTIONS(2616),
    [sym_undefined] = ACTIONS(2616),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [459] = {
    [sym_import] = STATE(1285),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1285),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1285),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1285),
    [sym_arrow_function] = STATE(1285),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1285),
    [sym_new_expression] = STATE(1285),
    [sym_await_expression] = STATE(1285),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1285),
    [sym_augmented_assignment_expression] = STATE(1285),
    [sym_ternary_expression] = STATE(1285),
    [sym_binary_expression] = STATE(1285),
    [sym_unary_expression] = STATE(1285),
    [sym_update_expression] = STATE(1285),
    [sym_string] = STATE(1285),
    [sym_template_string] = STATE(1285),
    [sym_regex] = STATE(1285),
    [sym_meta_property] = STATE(1285),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1285),
    [sym_as_expression] = STATE(1285),
    [sym_internal_module] = STATE(1285),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2618),
    [sym_this] = ACTIONS(2620),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_null] = ACTIONS(2620),
    [sym_undefined] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [460] = {
    [sym_import] = STATE(1112),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1112),
    [sym_yield_expression] = STATE(1112),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1112),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1112),
    [sym_arrow_function] = STATE(1112),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1112),
    [sym_new_expression] = STATE(1112),
    [sym_await_expression] = STATE(1112),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1112),
    [sym_augmented_assignment_expression] = STATE(1112),
    [sym_ternary_expression] = STATE(1112),
    [sym_binary_expression] = STATE(1112),
    [sym_unary_expression] = STATE(1112),
    [sym_update_expression] = STATE(1112),
    [sym_string] = STATE(1112),
    [sym_template_string] = STATE(1112),
    [sym_regex] = STATE(1112),
    [sym_meta_property] = STATE(1112),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1112),
    [sym_type_assertion] = STATE(1112),
    [sym_as_expression] = STATE(1112),
    [sym_internal_module] = STATE(1112),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2622),
    [sym_this] = ACTIONS(2624),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_null] = ACTIONS(2624),
    [sym_undefined] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [461] = {
    [sym_import] = STATE(1301),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1301),
    [sym_arrow_function] = STATE(1301),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1301),
    [sym_type_assertion] = STATE(1301),
    [sym_as_expression] = STATE(1301),
    [sym_internal_module] = STATE(1301),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2626),
    [sym_this] = ACTIONS(2628),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_null] = ACTIONS(2628),
    [sym_undefined] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [462] = {
    [sym_import] = STATE(1105),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1105),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1105),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1105),
    [sym_arrow_function] = STATE(1105),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1105),
    [sym_new_expression] = STATE(1105),
    [sym_await_expression] = STATE(1105),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1105),
    [sym_augmented_assignment_expression] = STATE(1105),
    [sym_ternary_expression] = STATE(1105),
    [sym_binary_expression] = STATE(1105),
    [sym_unary_expression] = STATE(1105),
    [sym_update_expression] = STATE(1105),
    [sym_string] = STATE(1105),
    [sym_template_string] = STATE(1105),
    [sym_regex] = STATE(1105),
    [sym_meta_property] = STATE(1105),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1105),
    [sym_type_assertion] = STATE(1105),
    [sym_as_expression] = STATE(1105),
    [sym_internal_module] = STATE(1105),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2630),
    [sym_this] = ACTIONS(2632),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_null] = ACTIONS(2632),
    [sym_undefined] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [463] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2634),
    [sym_this] = ACTIONS(2176),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_undefined] = ACTIONS(2176),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [464] = {
    [sym_import] = STATE(1137),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1137),
    [sym_yield_expression] = STATE(1137),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1137),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1137),
    [sym_arrow_function] = STATE(1137),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1137),
    [sym_new_expression] = STATE(1137),
    [sym_await_expression] = STATE(1137),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1137),
    [sym_augmented_assignment_expression] = STATE(1137),
    [sym_ternary_expression] = STATE(1137),
    [sym_binary_expression] = STATE(1137),
    [sym_unary_expression] = STATE(1137),
    [sym_update_expression] = STATE(1137),
    [sym_string] = STATE(1137),
    [sym_template_string] = STATE(1137),
    [sym_regex] = STATE(1137),
    [sym_meta_property] = STATE(1137),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1137),
    [sym_type_assertion] = STATE(1137),
    [sym_as_expression] = STATE(1137),
    [sym_internal_module] = STATE(1137),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2638),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_undefined] = ACTIONS(2638),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [465] = {
    [sym_import] = STATE(1149),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1149),
    [sym_yield_expression] = STATE(1149),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1149),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1149),
    [sym_arrow_function] = STATE(1149),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1149),
    [sym_new_expression] = STATE(1149),
    [sym_await_expression] = STATE(1149),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1149),
    [sym_augmented_assignment_expression] = STATE(1149),
    [sym_ternary_expression] = STATE(1149),
    [sym_binary_expression] = STATE(1149),
    [sym_unary_expression] = STATE(1149),
    [sym_update_expression] = STATE(1149),
    [sym_string] = STATE(1149),
    [sym_template_string] = STATE(1149),
    [sym_regex] = STATE(1149),
    [sym_meta_property] = STATE(1149),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1149),
    [sym_type_assertion] = STATE(1149),
    [sym_as_expression] = STATE(1149),
    [sym_internal_module] = STATE(1149),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2640),
    [sym_this] = ACTIONS(2642),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_undefined] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [466] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2644),
    [sym_this] = ACTIONS(2646),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2646),
    [sym_false] = ACTIONS(2646),
    [sym_null] = ACTIONS(2646),
    [sym_undefined] = ACTIONS(2646),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [467] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1177),
    [sym_type_assertion] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_null] = ACTIONS(2650),
    [sym_undefined] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [468] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1187),
    [sym_type_assertion] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2652),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [469] = {
    [sym_import] = STATE(1183),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1183),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1183),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1183),
    [sym_arrow_function] = STATE(1183),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1183),
    [sym_new_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1183),
    [sym_augmented_assignment_expression] = STATE(1183),
    [sym_ternary_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_update_expression] = STATE(1183),
    [sym_string] = STATE(1183),
    [sym_template_string] = STATE(1183),
    [sym_regex] = STATE(1183),
    [sym_meta_property] = STATE(1183),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1183),
    [sym_type_assertion] = STATE(1183),
    [sym_as_expression] = STATE(1183),
    [sym_internal_module] = STATE(1183),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2654),
    [sym_this] = ACTIONS(2656),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [sym_null] = ACTIONS(2656),
    [sym_undefined] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [470] = {
    [sym_import] = STATE(1283),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1283),
    [sym_type_assertion] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2658),
    [sym_this] = ACTIONS(2660),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [sym_null] = ACTIONS(2660),
    [sym_undefined] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [471] = {
    [sym_import] = STATE(1221),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2662),
    [sym_this] = ACTIONS(2664),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [sym_null] = ACTIONS(2664),
    [sym_undefined] = ACTIONS(2664),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [472] = {
    [sym_import] = STATE(1545),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1545),
    [sym_yield_expression] = STATE(1545),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1545),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1545),
    [sym_arrow_function] = STATE(1545),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1545),
    [sym_new_expression] = STATE(1545),
    [sym_await_expression] = STATE(1545),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1545),
    [sym_augmented_assignment_expression] = STATE(1545),
    [sym_ternary_expression] = STATE(1545),
    [sym_binary_expression] = STATE(1545),
    [sym_unary_expression] = STATE(1545),
    [sym_update_expression] = STATE(1545),
    [sym_string] = STATE(1545),
    [sym_template_string] = STATE(1545),
    [sym_regex] = STATE(1545),
    [sym_meta_property] = STATE(1545),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1545),
    [sym_type_assertion] = STATE(1545),
    [sym_as_expression] = STATE(1545),
    [sym_internal_module] = STATE(1545),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [473] = {
    [sym_import] = STATE(1223),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1223),
    [sym_yield_expression] = STATE(1223),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1223),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1223),
    [sym_arrow_function] = STATE(1223),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1223),
    [sym_new_expression] = STATE(1223),
    [sym_await_expression] = STATE(1223),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1223),
    [sym_augmented_assignment_expression] = STATE(1223),
    [sym_ternary_expression] = STATE(1223),
    [sym_binary_expression] = STATE(1223),
    [sym_unary_expression] = STATE(1223),
    [sym_update_expression] = STATE(1223),
    [sym_string] = STATE(1223),
    [sym_template_string] = STATE(1223),
    [sym_regex] = STATE(1223),
    [sym_meta_property] = STATE(1223),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1223),
    [sym_type_assertion] = STATE(1223),
    [sym_as_expression] = STATE(1223),
    [sym_internal_module] = STATE(1223),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2666),
    [sym_this] = ACTIONS(2668),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [sym_null] = ACTIONS(2668),
    [sym_undefined] = ACTIONS(2668),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [474] = {
    [sym_import] = STATE(1225),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1225),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1225),
    [sym_arrow_function] = STATE(1225),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_string] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1225),
    [sym_type_assertion] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2670),
    [sym_this] = ACTIONS(2672),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_null] = ACTIONS(2672),
    [sym_undefined] = ACTIONS(2672),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [475] = {
    [sym_import] = STATE(1155),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1155),
    [sym_yield_expression] = STATE(1155),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1155),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1155),
    [sym_arrow_function] = STATE(1155),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1155),
    [sym_new_expression] = STATE(1155),
    [sym_await_expression] = STATE(1155),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1155),
    [sym_augmented_assignment_expression] = STATE(1155),
    [sym_ternary_expression] = STATE(1155),
    [sym_binary_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1155),
    [sym_update_expression] = STATE(1155),
    [sym_string] = STATE(1155),
    [sym_template_string] = STATE(1155),
    [sym_regex] = STATE(1155),
    [sym_meta_property] = STATE(1155),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1155),
    [sym_type_assertion] = STATE(1155),
    [sym_as_expression] = STATE(1155),
    [sym_internal_module] = STATE(1155),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2674),
    [sym_this] = ACTIONS(2676),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_null] = ACTIONS(2676),
    [sym_undefined] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [476] = {
    [sym_import] = STATE(1372),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1372),
    [sym_type_assertion] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(752),
    [sym_this] = ACTIONS(754),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(754),
    [sym_false] = ACTIONS(754),
    [sym_null] = ACTIONS(754),
    [sym_undefined] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [477] = {
    [sym_import] = STATE(1467),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1467),
    [sym_yield_expression] = STATE(1467),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1467),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1467),
    [sym_arrow_function] = STATE(1467),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1467),
    [sym_new_expression] = STATE(1467),
    [sym_await_expression] = STATE(1467),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1467),
    [sym_augmented_assignment_expression] = STATE(1467),
    [sym_ternary_expression] = STATE(1467),
    [sym_binary_expression] = STATE(1467),
    [sym_unary_expression] = STATE(1467),
    [sym_update_expression] = STATE(1467),
    [sym_string] = STATE(1467),
    [sym_template_string] = STATE(1467),
    [sym_regex] = STATE(1467),
    [sym_meta_property] = STATE(1467),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1467),
    [sym_type_assertion] = STATE(1467),
    [sym_as_expression] = STATE(1467),
    [sym_internal_module] = STATE(1467),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2320),
    [sym_this] = ACTIONS(2322),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [sym_null] = ACTIONS(2322),
    [sym_undefined] = ACTIONS(2322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [478] = {
    [sym_import] = STATE(1681),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1681),
    [sym_yield_expression] = STATE(1681),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1681),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1681),
    [sym_arrow_function] = STATE(1681),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1681),
    [sym_new_expression] = STATE(1681),
    [sym_await_expression] = STATE(1681),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1681),
    [sym_augmented_assignment_expression] = STATE(1681),
    [sym_ternary_expression] = STATE(1681),
    [sym_binary_expression] = STATE(1681),
    [sym_unary_expression] = STATE(1681),
    [sym_update_expression] = STATE(1681),
    [sym_string] = STATE(1681),
    [sym_template_string] = STATE(1681),
    [sym_regex] = STATE(1681),
    [sym_meta_property] = STATE(1681),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1681),
    [sym_type_assertion] = STATE(1681),
    [sym_as_expression] = STATE(1681),
    [sym_internal_module] = STATE(1681),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2682),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2682),
    [sym_false] = ACTIONS(2682),
    [sym_null] = ACTIONS(2682),
    [sym_undefined] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [479] = {
    [sym_import] = STATE(1533),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1533),
    [sym_arrow_function] = STATE(1533),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1533),
    [sym_type_assertion] = STATE(1533),
    [sym_as_expression] = STATE(1533),
    [sym_internal_module] = STATE(1533),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(535),
    [sym_this] = ACTIONS(537),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(537),
    [sym_false] = ACTIONS(537),
    [sym_null] = ACTIONS(537),
    [sym_undefined] = ACTIONS(537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [480] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(998),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1649),
    [sym_array] = STATE(1630),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(3185),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(998),
    [sym_subscript_expression] = STATE(998),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(343),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_export] = ACTIONS(610),
    [anon_sym_namespace] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(610),
    [anon_sym_typeof] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(632),
    [anon_sym_void] = ACTIONS(634),
    [anon_sym_delete] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2176),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_undefined] = ACTIONS(2176),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_get] = ACTIONS(610),
    [anon_sym_set] = ACTIONS(610),
    [anon_sym_declare] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_protected] = ACTIONS(610),
    [anon_sym_module] = ACTIONS(610),
    [anon_sym_any] = ACTIONS(610),
    [anon_sym_number] = ACTIONS(610),
    [anon_sym_boolean] = ACTIONS(610),
    [anon_sym_string] = ACTIONS(610),
    [anon_sym_symbol] = ACTIONS(610),
    [sym_readonly] = ACTIONS(610),
  },
  [481] = {
    [sym_import] = STATE(1233),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1233),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1233),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1233),
    [sym_arrow_function] = STATE(1233),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1233),
    [sym_new_expression] = STATE(1233),
    [sym_await_expression] = STATE(1233),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1233),
    [sym_augmented_assignment_expression] = STATE(1233),
    [sym_ternary_expression] = STATE(1233),
    [sym_binary_expression] = STATE(1233),
    [sym_unary_expression] = STATE(1233),
    [sym_update_expression] = STATE(1233),
    [sym_string] = STATE(1233),
    [sym_template_string] = STATE(1233),
    [sym_regex] = STATE(1233),
    [sym_meta_property] = STATE(1233),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1233),
    [sym_type_assertion] = STATE(1233),
    [sym_as_expression] = STATE(1233),
    [sym_internal_module] = STATE(1233),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2684),
    [sym_this] = ACTIONS(2686),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2686),
    [sym_false] = ACTIONS(2686),
    [sym_null] = ACTIONS(2686),
    [sym_undefined] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [482] = {
    [sym_import] = STATE(1378),
    [sym_parenthesized_expression] = STATE(975),
    [sym__expression] = STATE(1378),
    [sym_yield_expression] = STATE(1378),
    [sym_object] = STATE(1631),
    [sym_array] = STATE(1632),
    [sym_class] = STATE(1378),
    [sym_function] = STATE(1342),
    [sym_generator_function] = STATE(1378),
    [sym_arrow_function] = STATE(1378),
    [sym__call_signature] = STATE(3044),
    [sym_call_expression] = STATE(1378),
    [sym_new_expression] = STATE(1378),
    [sym_await_expression] = STATE(1378),
    [sym_member_expression] = STATE(975),
    [sym_subscript_expression] = STATE(975),
    [sym_assignment_expression] = STATE(1378),
    [sym_augmented_assignment_expression] = STATE(1378),
    [sym_ternary_expression] = STATE(1378),
    [sym_binary_expression] = STATE(1378),
    [sym_unary_expression] = STATE(1378),
    [sym_update_expression] = STATE(1378),
    [sym_string] = STATE(1378),
    [sym_template_string] = STATE(1378),
    [sym_regex] = STATE(1378),
    [sym_meta_property] = STATE(1378),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1378),
    [sym_type_assertion] = STATE(1378),
    [sym_as_expression] = STATE(1378),
    [sym_internal_module] = STATE(1378),
    [sym_type_arguments] = STATE(412),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2579),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_export] = ACTIONS(704),
    [anon_sym_namespace] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_type] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(712),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_await] = ACTIONS(718),
    [anon_sym_yield] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(722),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_class] = ACTIONS(726),
    [anon_sym_async] = ACTIONS(728),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_new] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_void] = ACTIONS(742),
    [anon_sym_delete] = ACTIONS(712),
    [anon_sym_PLUS_PLUS] = ACTIONS(744),
    [anon_sym_DASH_DASH] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [anon_sym_SQUOTE] = ACTIONS(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(750),
    [sym_number] = ACTIONS(2688),
    [sym_this] = ACTIONS(2690),
    [sym_super] = ACTIONS(756),
    [sym_true] = ACTIONS(2690),
    [sym_false] = ACTIONS(2690),
    [sym_null] = ACTIONS(2690),
    [sym_undefined] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_get] = ACTIONS(704),
    [anon_sym_set] = ACTIONS(704),
    [anon_sym_declare] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_protected] = ACTIONS(704),
    [anon_sym_module] = ACTIONS(704),
    [anon_sym_any] = ACTIONS(704),
    [anon_sym_number] = ACTIONS(704),
    [anon_sym_boolean] = ACTIONS(704),
    [anon_sym_string] = ACTIONS(704),
    [anon_sym_symbol] = ACTIONS(704),
    [sym_readonly] = ACTIONS(704),
  },
  [483] = {
    [sym_import] = STATE(1535),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__expression] = STATE(1535),
    [sym_yield_expression] = STATE(1535),
    [sym_object] = STATE(1872),
    [sym_array] = STATE(1880),
    [sym_class] = STATE(1535),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1535),
    [sym_arrow_function] = STATE(1535),
    [sym__call_signature] = STATE(3053),
    [sym_call_expression] = STATE(1535),
    [sym_new_expression] = STATE(1535),
    [sym_await_expression] = STATE(1535),
    [sym_member_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1535),
    [sym_augmented_assignment_expression] = STATE(1535),
    [sym_ternary_expression] = STATE(1535),
    [sym_binary_expression] = STATE(1535),
    [sym_unary_expression] = STATE(1535),
    [sym_update_expression] = STATE(1535),
    [sym_string] = STATE(1535),
    [sym_template_string] = STATE(1535),
    [sym_regex] = STATE(1535),
    [sym_meta_property] = STATE(1535),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1535),
    [sym_type_assertion] = STATE(1535),
    [sym_as_expression] = STATE(1535),
    [sym_internal_module] = STATE(1535),
    [sym_type_arguments] = STATE(329),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_namespace] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(529),
    [anon_sym_delete] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(764),
    [anon_sym_DASH_DASH] = ACTIONS(764),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2692),
    [sym_this] = ACTIONS(2694),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2694),
    [sym_false] = ACTIONS(2694),
    [sym_null] = ACTIONS(2694),
    [sym_undefined] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [anon_sym_declare] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(493),
    [anon_sym_private] = ACTIONS(493),
    [anon_sym_protected] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_any] = ACTIONS(493),
    [anon_sym_number] = ACTIONS(493),
    [anon_sym_boolean] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_symbol] = ACTIONS(493),
    [sym_readonly] = ACTIONS(493),
  },
  [484] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1279),
    [sym_type_assertion] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2696),
    [sym_this] = ACTIONS(2698),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [485] = {
    [sym_import] = STATE(1678),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1678),
    [sym_yield_expression] = STATE(1678),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1678),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1678),
    [sym_arrow_function] = STATE(1678),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1678),
    [sym_new_expression] = STATE(1678),
    [sym_await_expression] = STATE(1678),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1678),
    [sym_augmented_assignment_expression] = STATE(1678),
    [sym_ternary_expression] = STATE(1678),
    [sym_binary_expression] = STATE(1678),
    [sym_unary_expression] = STATE(1678),
    [sym_update_expression] = STATE(1678),
    [sym_string] = STATE(1678),
    [sym_template_string] = STATE(1678),
    [sym_regex] = STATE(1678),
    [sym_meta_property] = STATE(1678),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1678),
    [sym_type_assertion] = STATE(1678),
    [sym_as_expression] = STATE(1678),
    [sym_internal_module] = STATE(1678),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2702),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2702),
    [sym_false] = ACTIONS(2702),
    [sym_null] = ACTIONS(2702),
    [sym_undefined] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [486] = {
    [sym_import] = STATE(1384),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1384),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1384),
    [sym_arrow_function] = STATE(1384),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1384),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1384),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_string] = STATE(1384),
    [sym_template_string] = STATE(1384),
    [sym_regex] = STATE(1384),
    [sym_meta_property] = STATE(1384),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1384),
    [sym_type_assertion] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2704),
    [sym_this] = ACTIONS(2706),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [487] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(983),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1672),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3144),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(983),
    [sym_subscript_expression] = STATE(983),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1282),
    [sym_type_assertion] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_arguments] = STATE(390),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(766),
    [anon_sym_export] = ACTIONS(768),
    [anon_sym_namespace] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_typeof] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(776),
    [anon_sym_yield] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(784),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(792),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_void] = ACTIONS(794),
    [anon_sym_delete] = ACTIONS(774),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2708),
    [sym_this] = ACTIONS(2710),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_null] = ACTIONS(2710),
    [sym_undefined] = ACTIONS(2710),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(768),
    [anon_sym_get] = ACTIONS(768),
    [anon_sym_set] = ACTIONS(768),
    [anon_sym_declare] = ACTIONS(768),
    [anon_sym_public] = ACTIONS(768),
    [anon_sym_private] = ACTIONS(768),
    [anon_sym_protected] = ACTIONS(768),
    [anon_sym_module] = ACTIONS(768),
    [anon_sym_any] = ACTIONS(768),
    [anon_sym_number] = ACTIONS(768),
    [anon_sym_boolean] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_symbol] = ACTIONS(768),
    [sym_readonly] = ACTIONS(768),
  },
  [488] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_string] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1293),
    [sym_type_assertion] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2712),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [489] = {
    [sym_import] = STATE(1276),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1276),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1276),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1276),
    [sym_arrow_function] = STATE(1276),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1276),
    [sym_new_expression] = STATE(1276),
    [sym_await_expression] = STATE(1276),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1276),
    [sym_augmented_assignment_expression] = STATE(1276),
    [sym_ternary_expression] = STATE(1276),
    [sym_binary_expression] = STATE(1276),
    [sym_unary_expression] = STATE(1276),
    [sym_update_expression] = STATE(1276),
    [sym_string] = STATE(1276),
    [sym_template_string] = STATE(1276),
    [sym_regex] = STATE(1276),
    [sym_meta_property] = STATE(1276),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1276),
    [sym_type_assertion] = STATE(1276),
    [sym_as_expression] = STATE(1276),
    [sym_internal_module] = STATE(1276),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2718),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_null] = ACTIONS(2718),
    [sym_undefined] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [490] = {
    [sym_import] = STATE(1116),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1116),
    [sym_yield_expression] = STATE(1116),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1116),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1116),
    [sym_arrow_function] = STATE(1116),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1116),
    [sym_new_expression] = STATE(1116),
    [sym_await_expression] = STATE(1116),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(1116),
    [sym_ternary_expression] = STATE(1116),
    [sym_binary_expression] = STATE(1116),
    [sym_unary_expression] = STATE(1116),
    [sym_update_expression] = STATE(1116),
    [sym_string] = STATE(1116),
    [sym_template_string] = STATE(1116),
    [sym_regex] = STATE(1116),
    [sym_meta_property] = STATE(1116),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1116),
    [sym_type_assertion] = STATE(1116),
    [sym_as_expression] = STATE(1116),
    [sym_internal_module] = STATE(1116),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2720),
    [sym_this] = ACTIONS(2722),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2722),
    [sym_false] = ACTIONS(2722),
    [sym_null] = ACTIONS(2722),
    [sym_undefined] = ACTIONS(2722),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [491] = {
    [sym_import] = STATE(1235),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1235),
    [sym_yield_expression] = STATE(1235),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1235),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1235),
    [sym_arrow_function] = STATE(1235),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1235),
    [sym_new_expression] = STATE(1235),
    [sym_await_expression] = STATE(1235),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1235),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_ternary_expression] = STATE(1235),
    [sym_binary_expression] = STATE(1235),
    [sym_unary_expression] = STATE(1235),
    [sym_update_expression] = STATE(1235),
    [sym_string] = STATE(1235),
    [sym_template_string] = STATE(1235),
    [sym_regex] = STATE(1235),
    [sym_meta_property] = STATE(1235),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1235),
    [sym_type_assertion] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2724),
    [sym_this] = ACTIONS(2726),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2726),
    [sym_false] = ACTIONS(2726),
    [sym_null] = ACTIONS(2726),
    [sym_undefined] = ACTIONS(2726),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [492] = {
    [sym_import] = STATE(1277),
    [sym_parenthesized_expression] = STATE(946),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1473),
    [sym_array] = STATE(1455),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(1132),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(3179),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(946),
    [sym_subscript_expression] = STATE(946),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1277),
    [sym_type_assertion] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_arguments] = STATE(391),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2570),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2728),
    [sym_this] = ACTIONS(2730),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2730),
    [sym_false] = ACTIONS(2730),
    [sym_null] = ACTIONS(2730),
    [sym_undefined] = ACTIONS(2730),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [493] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [494] = {
    [sym_import] = STATE(1048),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1048),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1048),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1048),
    [sym_arrow_function] = STATE(1048),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1048),
    [sym_new_expression] = STATE(1048),
    [sym_await_expression] = STATE(1048),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1048),
    [sym_augmented_assignment_expression] = STATE(1048),
    [sym_ternary_expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_update_expression] = STATE(1048),
    [sym_string] = STATE(1048),
    [sym_template_string] = STATE(1048),
    [sym_regex] = STATE(1048),
    [sym_meta_property] = STATE(1048),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1048),
    [sym_type_assertion] = STATE(1048),
    [sym_as_expression] = STATE(1048),
    [sym_internal_module] = STATE(1048),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [495] = {
    [sym_import] = STATE(1166),
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(1166),
    [sym_yield_expression] = STATE(1166),
    [sym_object] = STATE(1494),
    [sym_array] = STATE(1459),
    [sym_class] = STATE(1166),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1166),
    [sym_arrow_function] = STATE(1166),
    [sym__call_signature] = STATE(3190),
    [sym_call_expression] = STATE(1166),
    [sym_new_expression] = STATE(1166),
    [sym_await_expression] = STATE(1166),
    [sym_member_expression] = STATE(972),
    [sym_subscript_expression] = STATE(972),
    [sym_assignment_expression] = STATE(1166),
    [sym_augmented_assignment_expression] = STATE(1166),
    [sym_ternary_expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_update_expression] = STATE(1166),
    [sym_string] = STATE(1166),
    [sym_template_string] = STATE(1166),
    [sym_regex] = STATE(1166),
    [sym_meta_property] = STATE(1166),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1166),
    [sym_type_assertion] = STATE(1166),
    [sym_as_expression] = STATE(1166),
    [sym_internal_module] = STATE(1166),
    [sym_type_arguments] = STATE(493),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(579),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_void] = ACTIONS(581),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2732),
    [sym_this] = ACTIONS(2734),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2734),
    [sym_false] = ACTIONS(2734),
    [sym_null] = ACTIONS(2734),
    [sym_undefined] = ACTIONS(2734),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [496] = {
    [sym_import] = STATE(1659),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__expression] = STATE(1659),
    [sym_yield_expression] = STATE(1659),
    [sym_object] = STATE(1871),
    [sym_array] = STATE(1873),
    [sym_class] = STATE(1659),
    [sym_function] = STATE(1053),
    [sym_generator_function] = STATE(1659),
    [sym_arrow_function] = STATE(1659),
    [sym__call_signature] = STATE(3037),
    [sym_call_expression] = STATE(1659),
    [sym_new_expression] = STATE(1659),
    [sym_await_expression] = STATE(1659),
    [sym_member_expression] = STATE(1020),
    [sym_subscript_expression] = STATE(1020),
    [sym_assignment_expression] = STATE(1659),
    [sym_augmented_assignment_expression] = STATE(1659),
    [sym_ternary_expression] = STATE(1659),
    [sym_binary_expression] = STATE(1659),
    [sym_unary_expression] = STATE(1659),
    [sym_update_expression] = STATE(1659),
    [sym_string] = STATE(1659),
    [sym_template_string] = STATE(1659),
    [sym_regex] = STATE(1659),
    [sym_meta_property] = STATE(1659),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(2576),
    [sym_non_null_expression] = STATE(1659),
    [sym_type_assertion] = STATE(1659),
    [sym_as_expression] = STATE(1659),
    [sym_internal_module] = STATE(1659),
    [sym_type_arguments] = STATE(427),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_export_statement_repeat1] = STATE(2554),
    [sym_identifier] = ACTIONS(802),
    [anon_sym_export] = ACTIONS(804),
    [anon_sym_namespace] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_typeof] = ACTIONS(810),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(812),
    [anon_sym_yield] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(828),
    [anon_sym_delete] = ACTIONS(810),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_number] = ACTIONS(2736),
    [sym_this] = ACTIONS(2738),
    [sym_super] = ACTIONS(539),
    [sym_true] = ACTIONS(2738),
    [sym_false] = ACTIONS(2738),
    [sym_null] = ACTIONS(2738),
    [sym_undefined] = ACTIONS(2738),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(804),
    [anon_sym_get] = ACTIONS(804),
    [anon_sym_set] = ACTIONS(804),
    [anon_sym_declare] = ACTIONS(804),
    [anon_sym_public] = ACTIONS(804),
    [anon_sym_private] = ACTIONS(804),
    [anon_sym_protected] = ACTIONS(804),
    [anon_sym_module] = ACTIONS(804),
    [anon_sym_any] = ACTIONS(804),
    [anon_sym_number] = ACTIONS(804),
    [anon_sym_boolean] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_symbol] = ACTIONS(804),
    [sym_readonly] = ACTIONS(804),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1285),
    [sym_identifier] = ACTIONS(1287),
    [anon_sym_export] = ACTIONS(1287),
    [anon_sym_default] = ACTIONS(1287),
    [anon_sym_EQ] = ACTIONS(1287),
    [anon_sym_namespace] = ACTIONS(1287),
    [anon_sym_LBRACE] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_type] = ACTIONS(1287),
    [anon_sym_typeof] = ACTIONS(1287),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1287),
    [anon_sym_const] = ACTIONS(1287),
    [anon_sym_if] = ACTIONS(1287),
    [anon_sym_else] = ACTIONS(1287),
    [anon_sym_switch] = ACTIONS(1287),
    [anon_sym_for] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_await] = ACTIONS(1287),
    [anon_sym_while] = ACTIONS(1287),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_try] = ACTIONS(1287),
    [anon_sym_with] = ACTIONS(1287),
    [anon_sym_break] = ACTIONS(1287),
    [anon_sym_continue] = ACTIONS(1287),
    [anon_sym_debugger] = ACTIONS(1287),
    [anon_sym_return] = ACTIONS(1287),
    [anon_sym_throw] = ACTIONS(1287),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1287),
    [anon_sym_yield] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_SLASH] = ACTIONS(1287),
    [anon_sym_class] = ACTIONS(1287),
    [anon_sym_async] = ACTIONS(1287),
    [anon_sym_function] = ACTIONS(1287),
    [anon_sym_EQ_GT] = ACTIONS(1285),
    [anon_sym_new] = ACTIONS(1287),
    [anon_sym_QMARK] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1285),
    [anon_sym_void] = ACTIONS(1287),
    [anon_sym_delete] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_SQUOTE] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [sym_number] = ACTIONS(1285),
    [sym_this] = ACTIONS(1287),
    [sym_super] = ACTIONS(1287),
    [sym_true] = ACTIONS(1287),
    [sym_false] = ACTIONS(1287),
    [sym_null] = ACTIONS(1287),
    [sym_undefined] = ACTIONS(1287),
    [anon_sym_AT] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1287),
    [anon_sym_abstract] = ACTIONS(1287),
    [anon_sym_get] = ACTIONS(1287),
    [anon_sym_set] = ACTIONS(1287),
    [anon_sym_declare] = ACTIONS(1287),
    [anon_sym_public] = ACTIONS(1287),
    [anon_sym_private] = ACTIONS(1287),
    [anon_sym_protected] = ACTIONS(1287),
    [anon_sym_module] = ACTIONS(1287),
    [anon_sym_any] = ACTIONS(1287),
    [anon_sym_number] = ACTIONS(1287),
    [anon_sym_boolean] = ACTIONS(1287),
    [anon_sym_string] = ACTIONS(1287),
    [anon_sym_symbol] = ACTIONS(1287),
    [anon_sym_interface] = ACTIONS(1287),
    [anon_sym_enum] = ACTIONS(1287),
    [sym_readonly] = ACTIONS(1287),
  },
  [498] = {
    [sym__call_signature] = STATE(3088),
    [sym_string] = STATE(2292),
    [sym_formal_parameters] = STATE(2576),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_object_repeat1] = STATE(2788),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2742),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2742),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2742),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_get] = ACTIONS(2766),
    [anon_sym_set] = ACTIONS(2766),
    [anon_sym_declare] = ACTIONS(2742),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_module] = ACTIONS(2742),
    [anon_sym_any] = ACTIONS(2742),
    [anon_sym_number] = ACTIONS(2742),
    [anon_sym_boolean] = ACTIONS(2742),
    [anon_sym_string] = ACTIONS(2742),
    [anon_sym_symbol] = ACTIONS(2742),
    [sym_readonly] = ACTIONS(2742),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [499] = {
    [sym__call_signature] = STATE(3088),
    [sym_string] = STATE(2292),
    [sym_formal_parameters] = STATE(2576),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_object_repeat1] = STATE(2635),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(2742),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2742),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2742),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_get] = ACTIONS(2766),
    [anon_sym_set] = ACTIONS(2766),
    [anon_sym_declare] = ACTIONS(2742),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_module] = ACTIONS(2742),
    [anon_sym_any] = ACTIONS(2742),
    [anon_sym_number] = ACTIONS(2742),
    [anon_sym_boolean] = ACTIONS(2742),
    [anon_sym_string] = ACTIONS(2742),
    [anon_sym_symbol] = ACTIONS(2742),
    [sym_readonly] = ACTIONS(2742),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1325),
    [anon_sym_export] = ACTIONS(1325),
    [anon_sym_default] = ACTIONS(1325),
    [anon_sym_EQ] = ACTIONS(1325),
    [anon_sym_namespace] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_COMMA] = ACTIONS(1323),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_type] = ACTIONS(1325),
    [anon_sym_typeof] = ACTIONS(1325),
    [anon_sym_import] = ACTIONS(1325),
    [anon_sym_var] = ACTIONS(1325),
    [anon_sym_let] = ACTIONS(1325),
    [anon_sym_const] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1325),
    [anon_sym_else] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1325),
    [anon_sym_for] = ACTIONS(1325),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_RPAREN] = ACTIONS(1323),
    [anon_sym_await] = ACTIONS(1325),
    [anon_sym_while] = ACTIONS(1325),
    [anon_sym_do] = ACTIONS(1325),
    [anon_sym_try] = ACTIONS(1325),
    [anon_sym_with] = ACTIONS(1325),
    [anon_sym_break] = ACTIONS(1325),
    [anon_sym_continue] = ACTIONS(1325),
    [anon_sym_debugger] = ACTIONS(1325),
    [anon_sym_return] = ACTIONS(1325),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(1323),
    [anon_sym_case] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1323),
    [anon_sym_RBRACK] = ACTIONS(1323),
    [anon_sym_LT] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1323),
    [anon_sym_SLASH] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1325),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_function] = ACTIONS(1325),
    [anon_sym_EQ_GT] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1325),
    [anon_sym_QMARK] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_PIPE] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_void] = ACTIONS(1325),
    [anon_sym_delete] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1323),
    [sym_number] = ACTIONS(1323),
    [sym_this] = ACTIONS(1325),
    [sym_super] = ACTIONS(1325),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [sym_null] = ACTIONS(1325),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(1323),
    [anon_sym_static] = ACTIONS(1325),
    [anon_sym_abstract] = ACTIONS(1325),
    [anon_sym_get] = ACTIONS(1325),
    [anon_sym_set] = ACTIONS(1325),
    [anon_sym_declare] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1325),
    [anon_sym_private] = ACTIONS(1325),
    [anon_sym_protected] = ACTIONS(1325),
    [anon_sym_module] = ACTIONS(1325),
    [anon_sym_any] = ACTIONS(1325),
    [anon_sym_number] = ACTIONS(1325),
    [anon_sym_boolean] = ACTIONS(1325),
    [anon_sym_string] = ACTIONS(1325),
    [anon_sym_symbol] = ACTIONS(1325),
    [anon_sym_interface] = ACTIONS(1325),
    [anon_sym_enum] = ACTIONS(1325),
    [sym_readonly] = ACTIONS(1325),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(2768),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_export] = ACTIONS(2770),
    [anon_sym_default] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2770),
    [anon_sym_namespace] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2770),
    [anon_sym_typeof] = ACTIONS(2770),
    [anon_sym_import] = ACTIONS(2770),
    [anon_sym_var] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_const] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_else] = ACTIONS(2770),
    [anon_sym_switch] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_RPAREN] = ACTIONS(2768),
    [anon_sym_await] = ACTIONS(2770),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_break] = ACTIONS(2770),
    [anon_sym_continue] = ACTIONS(2770),
    [anon_sym_debugger] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_throw] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2768),
    [anon_sym_case] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_RBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_GT] = ACTIONS(2768),
    [anon_sym_SLASH] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(2770),
    [anon_sym_async] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_EQ_GT] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_BANG] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2768),
    [anon_sym_void] = ACTIONS(2770),
    [anon_sym_delete] = ACTIONS(2770),
    [anon_sym_PLUS_PLUS] = ACTIONS(2768),
    [anon_sym_DASH_DASH] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2768),
    [sym_number] = ACTIONS(2768),
    [sym_this] = ACTIONS(2770),
    [sym_super] = ACTIONS(2770),
    [sym_true] = ACTIONS(2770),
    [sym_false] = ACTIONS(2770),
    [sym_null] = ACTIONS(2770),
    [sym_undefined] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2768),
    [anon_sym_static] = ACTIONS(2770),
    [anon_sym_abstract] = ACTIONS(2770),
    [anon_sym_get] = ACTIONS(2770),
    [anon_sym_set] = ACTIONS(2770),
    [anon_sym_declare] = ACTIONS(2770),
    [anon_sym_public] = ACTIONS(2770),
    [anon_sym_private] = ACTIONS(2770),
    [anon_sym_protected] = ACTIONS(2770),
    [anon_sym_module] = ACTIONS(2770),
    [anon_sym_any] = ACTIONS(2770),
    [anon_sym_number] = ACTIONS(2770),
    [anon_sym_boolean] = ACTIONS(2770),
    [anon_sym_string] = ACTIONS(2770),
    [anon_sym_symbol] = ACTIONS(2770),
    [anon_sym_implements] = ACTIONS(2770),
    [anon_sym_interface] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2770),
    [sym_readonly] = ACTIONS(2770),
  },
  [502] = {
    [sym__call_signature] = STATE(3088),
    [sym_string] = STATE(2292),
    [sym_formal_parameters] = STATE(2576),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym_type_parameters] = STATE(2837),
    [aux_sym_object_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2742),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2742),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2742),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2742),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_get] = ACTIONS(2766),
    [anon_sym_set] = ACTIONS(2766),
    [anon_sym_declare] = ACTIONS(2742),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_module] = ACTIONS(2742),
    [anon_sym_any] = ACTIONS(2742),
    [anon_sym_number] = ACTIONS(2742),
    [anon_sym_boolean] = ACTIONS(2742),
    [anon_sym_string] = ACTIONS(2742),
    [anon_sym_symbol] = ACTIONS(2742),
    [sym_readonly] = ACTIONS(2742),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(2772),
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_default] = ACTIONS(2774),
    [anon_sym_EQ] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_var] = ACTIONS(2774),
    [anon_sym_let] = ACTIONS(2774),
    [anon_sym_const] = ACTIONS(2774),
    [anon_sym_if] = ACTIONS(2774),
    [anon_sym_else] = ACTIONS(2774),
    [anon_sym_switch] = ACTIONS(2774),
    [anon_sym_for] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2772),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_while] = ACTIONS(2774),
    [anon_sym_do] = ACTIONS(2774),
    [anon_sym_try] = ACTIONS(2774),
    [anon_sym_with] = ACTIONS(2774),
    [anon_sym_break] = ACTIONS(2774),
    [anon_sym_continue] = ACTIONS(2774),
    [anon_sym_debugger] = ACTIONS(2774),
    [anon_sym_return] = ACTIONS(2774),
    [anon_sym_throw] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_case] = ACTIONS(2774),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [anon_sym_RBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_GT] = ACTIONS(2772),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_EQ_GT] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PIPE] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2772),
    [anon_sym_TILDE] = ACTIONS(2772),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2772),
    [sym_number] = ACTIONS(2772),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_abstract] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [anon_sym_implements] = ACTIONS(2774),
    [anon_sym_interface] = ACTIONS(2774),
    [anon_sym_enum] = ACTIONS(2774),
    [sym_readonly] = ACTIONS(2774),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(2776),
    [sym_identifier] = ACTIONS(2778),
    [anon_sym_export] = ACTIONS(2778),
    [anon_sym_default] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2778),
    [anon_sym_namespace] = ACTIONS(2778),
    [anon_sym_LBRACE] = ACTIONS(2776),
    [anon_sym_COMMA] = ACTIONS(2776),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_type] = ACTIONS(2778),
    [anon_sym_typeof] = ACTIONS(2778),
    [anon_sym_import] = ACTIONS(2778),
    [anon_sym_var] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_const] = ACTIONS(2778),
    [anon_sym_if] = ACTIONS(2778),
    [anon_sym_else] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2778),
    [anon_sym_for] = ACTIONS(2778),
    [anon_sym_LPAREN] = ACTIONS(2776),
    [anon_sym_RPAREN] = ACTIONS(2776),
    [anon_sym_await] = ACTIONS(2778),
    [anon_sym_while] = ACTIONS(2778),
    [anon_sym_do] = ACTIONS(2778),
    [anon_sym_try] = ACTIONS(2778),
    [anon_sym_with] = ACTIONS(2778),
    [anon_sym_break] = ACTIONS(2778),
    [anon_sym_continue] = ACTIONS(2778),
    [anon_sym_debugger] = ACTIONS(2778),
    [anon_sym_return] = ACTIONS(2778),
    [anon_sym_throw] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_case] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_LBRACK] = ACTIONS(2776),
    [anon_sym_RBRACK] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2776),
    [anon_sym_GT] = ACTIONS(2776),
    [anon_sym_SLASH] = ACTIONS(2778),
    [anon_sym_DOT] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2778),
    [anon_sym_async] = ACTIONS(2778),
    [anon_sym_function] = ACTIONS(2778),
    [anon_sym_EQ_GT] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2778),
    [anon_sym_AMP] = ACTIONS(2776),
    [anon_sym_PIPE] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2778),
    [anon_sym_DASH] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2776),
    [anon_sym_TILDE] = ACTIONS(2776),
    [anon_sym_void] = ACTIONS(2778),
    [anon_sym_delete] = ACTIONS(2778),
    [anon_sym_PLUS_PLUS] = ACTIONS(2776),
    [anon_sym_DASH_DASH] = ACTIONS(2776),
    [anon_sym_DQUOTE] = ACTIONS(2776),
    [anon_sym_SQUOTE] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2776),
    [sym_number] = ACTIONS(2776),
    [sym_this] = ACTIONS(2778),
    [sym_super] = ACTIONS(2778),
    [sym_true] = ACTIONS(2778),
    [sym_false] = ACTIONS(2778),
    [sym_null] = ACTIONS(2778),
    [sym_undefined] = ACTIONS(2778),
    [anon_sym_AT] = ACTIONS(2776),
    [anon_sym_static] = ACTIONS(2778),
    [anon_sym_abstract] = ACTIONS(2778),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_declare] = ACTIONS(2778),
    [anon_sym_public] = ACTIONS(2778),
    [anon_sym_private] = ACTIONS(2778),
    [anon_sym_protected] = ACTIONS(2778),
    [anon_sym_module] = ACTIONS(2778),
    [anon_sym_any] = ACTIONS(2778),
    [anon_sym_number] = ACTIONS(2778),
    [anon_sym_boolean] = ACTIONS(2778),
    [anon_sym_string] = ACTIONS(2778),
    [anon_sym_symbol] = ACTIONS(2778),
    [anon_sym_interface] = ACTIONS(2778),
    [anon_sym_enum] = ACTIONS(2778),
    [sym_readonly] = ACTIONS(2778),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_EQ] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_RBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_EQ_GT] = ACTIONS(2782),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_implements] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1367),
    [sym_identifier] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1369),
    [anon_sym_EQ] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_COMMA] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1369),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_var] = ACTIONS(1369),
    [anon_sym_let] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_await] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_try] = ACTIONS(1369),
    [anon_sym_with] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_debugger] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_throw] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_case] = ACTIONS(1369),
    [anon_sym_yield] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1367),
    [anon_sym_RBRACK] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1367),
    [anon_sym_GT] = ACTIONS(1367),
    [anon_sym_SLASH] = ACTIONS(1369),
    [anon_sym_DOT] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(1369),
    [anon_sym_EQ_GT] = ACTIONS(1367),
    [anon_sym_new] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_void] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [sym_number] = ACTIONS(1367),
    [sym_this] = ACTIONS(1369),
    [sym_super] = ACTIONS(1369),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [sym_null] = ACTIONS(1369),
    [sym_undefined] = ACTIONS(1369),
    [anon_sym_AT] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1369),
    [anon_sym_abstract] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_interface] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [sym_readonly] = ACTIONS(1369),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_EQ] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_RBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_EQ_GT] = ACTIONS(2786),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_implements] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_EQ] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2792),
    [anon_sym_var] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_await] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_do] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [anon_sym_with] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_debugger] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_throw] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_case] = ACTIONS(2792),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_RBRACK] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_class] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2792),
    [anon_sym_EQ_GT] = ACTIONS(2790),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_TILDE] = ACTIONS(2790),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_delete] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_implements] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_EQ] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_RPAREN] = ACTIONS(2794),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_RBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_EQ_GT] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_AMP] = ACTIONS(2794),
    [anon_sym_PIPE] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_implements] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [sym_readonly] = ACTIONS(2796),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_EQ] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_COMMA] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_RPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_RBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_GT] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_EQ_GT] = ACTIONS(2798),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_PIPE] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [sym_readonly] = ACTIONS(2800),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_export] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_COMMA] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_import] = ACTIONS(2804),
    [anon_sym_var] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_RPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_debugger] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_throw] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2804),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_RBRACK] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_GT] = ACTIONS(2802),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_EQ_GT] = ACTIONS(2802),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_AMP] = ACTIONS(2802),
    [anon_sym_PIPE] = ACTIONS(2802),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_delete] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_declare] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_module] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [sym_readonly] = ACTIONS(2804),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(2806),
    [sym_identifier] = ACTIONS(2808),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_default] = ACTIONS(2808),
    [anon_sym_EQ] = ACTIONS(2808),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_LBRACE] = ACTIONS(2806),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_import] = ACTIONS(2808),
    [anon_sym_var] = ACTIONS(2808),
    [anon_sym_let] = ACTIONS(2808),
    [anon_sym_const] = ACTIONS(2808),
    [anon_sym_if] = ACTIONS(2808),
    [anon_sym_else] = ACTIONS(2808),
    [anon_sym_switch] = ACTIONS(2808),
    [anon_sym_for] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_RPAREN] = ACTIONS(2806),
    [anon_sym_await] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2808),
    [anon_sym_do] = ACTIONS(2808),
    [anon_sym_try] = ACTIONS(2808),
    [anon_sym_with] = ACTIONS(2808),
    [anon_sym_break] = ACTIONS(2808),
    [anon_sym_continue] = ACTIONS(2808),
    [anon_sym_debugger] = ACTIONS(2808),
    [anon_sym_return] = ACTIONS(2808),
    [anon_sym_throw] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_yield] = ACTIONS(2808),
    [anon_sym_LBRACK] = ACTIONS(2806),
    [anon_sym_RBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_GT] = ACTIONS(2806),
    [anon_sym_SLASH] = ACTIONS(2808),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2808),
    [anon_sym_EQ_GT] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(2806),
    [anon_sym_PIPE] = ACTIONS(2806),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_BANG] = ACTIONS(2806),
    [anon_sym_TILDE] = ACTIONS(2806),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(2806),
    [anon_sym_DASH_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(2806),
    [anon_sym_SQUOTE] = ACTIONS(2806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2806),
    [sym_number] = ACTIONS(2806),
    [sym_this] = ACTIONS(2808),
    [sym_super] = ACTIONS(2808),
    [sym_true] = ACTIONS(2808),
    [sym_false] = ACTIONS(2808),
    [sym_null] = ACTIONS(2808),
    [sym_undefined] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(2806),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_abstract] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [anon_sym_interface] = ACTIONS(2808),
    [anon_sym_enum] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(2810),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2812),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_COMMA] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_import] = ACTIONS(2812),
    [anon_sym_var] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_switch] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_RPAREN] = ACTIONS(2810),
    [anon_sym_await] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_debugger] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_throw] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2812),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_RBRACK] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_GT] = ACTIONS(2810),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_class] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_EQ_GT] = ACTIONS(2810),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(2810),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_TILDE] = ACTIONS(2810),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_delete] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2810),
    [sym_number] = ACTIONS(2810),
    [sym_this] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_AT] = ACTIONS(2810),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_interface] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [sym_readonly] = ACTIONS(2812),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_EQ] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_EQ_GT] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [sym_readonly] = ACTIONS(2816),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_EQ] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_COMMA] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_RBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_EQ_GT] = ACTIONS(2818),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [sym_readonly] = ACTIONS(2820),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_RBRACK] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_GT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_EQ_GT] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_PIPE] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [sym_readonly] = ACTIONS(2824),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_export] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_namespace] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_COMMA] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_import] = ACTIONS(2828),
    [anon_sym_var] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_else] = ACTIONS(2828),
    [anon_sym_switch] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_RPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_do] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [anon_sym_with] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_debugger] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_throw] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_RBRACK] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_class] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2828),
    [anon_sym_EQ_GT] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_delete] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_declare] = ACTIONS(2828),
    [anon_sym_public] = ACTIONS(2828),
    [anon_sym_private] = ACTIONS(2828),
    [anon_sym_protected] = ACTIONS(2828),
    [anon_sym_module] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_interface] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
    [sym_readonly] = ACTIONS(2828),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_export] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_EQ] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2832),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_COMMA] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_typeof] = ACTIONS(2832),
    [anon_sym_import] = ACTIONS(2832),
    [anon_sym_var] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_else] = ACTIONS(2832),
    [anon_sym_switch] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_await] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_do] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [anon_sym_with] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_debugger] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_throw] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2832),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_RBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_GT] = ACTIONS(2830),
    [anon_sym_SLASH] = ACTIONS(2832),
    [anon_sym_class] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_function] = ACTIONS(2832),
    [anon_sym_EQ_GT] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_void] = ACTIONS(2832),
    [anon_sym_delete] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_true] = ACTIONS(2832),
    [sym_false] = ACTIONS(2832),
    [sym_null] = ACTIONS(2832),
    [sym_undefined] = ACTIONS(2832),
    [anon_sym_AT] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_abstract] = ACTIONS(2832),
    [anon_sym_get] = ACTIONS(2832),
    [anon_sym_set] = ACTIONS(2832),
    [anon_sym_declare] = ACTIONS(2832),
    [anon_sym_public] = ACTIONS(2832),
    [anon_sym_private] = ACTIONS(2832),
    [anon_sym_protected] = ACTIONS(2832),
    [anon_sym_module] = ACTIONS(2832),
    [anon_sym_any] = ACTIONS(2832),
    [anon_sym_number] = ACTIONS(2832),
    [anon_sym_boolean] = ACTIONS(2832),
    [anon_sym_string] = ACTIONS(2832),
    [anon_sym_symbol] = ACTIONS(2832),
    [anon_sym_interface] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
    [sym_readonly] = ACTIONS(2832),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_EQ] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2836),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_RPAREN] = ACTIONS(2834),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_with] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_debugger] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_RBRACK] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_EQ_GT] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_PIPE] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_TILDE] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_number] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [sym_readonly] = ACTIONS(2836),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(2840),
    [sym_identifier] = ACTIONS(2842),
    [anon_sym_export] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_EQ] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2840),
    [anon_sym_COMMA] = ACTIONS(2840),
    [anon_sym_RBRACE] = ACTIONS(2840),
    [anon_sym_type] = ACTIONS(2842),
    [anon_sym_typeof] = ACTIONS(2842),
    [anon_sym_import] = ACTIONS(2842),
    [anon_sym_var] = ACTIONS(2842),
    [anon_sym_let] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_else] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2840),
    [anon_sym_RPAREN] = ACTIONS(2840),
    [anon_sym_await] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_with] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_debugger] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_yield] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2840),
    [anon_sym_RBRACK] = ACTIONS(2840),
    [anon_sym_LT] = ACTIONS(2840),
    [anon_sym_GT] = ACTIONS(2840),
    [anon_sym_SLASH] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_async] = ACTIONS(2842),
    [anon_sym_function] = ACTIONS(2842),
    [anon_sym_EQ_GT] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_AMP] = ACTIONS(2840),
    [anon_sym_PIPE] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_void] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_PLUS_PLUS] = ACTIONS(2840),
    [anon_sym_DASH_DASH] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2840),
    [sym_number] = ACTIONS(2840),
    [sym_this] = ACTIONS(2842),
    [sym_super] = ACTIONS(2842),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [sym_null] = ACTIONS(2842),
    [sym_undefined] = ACTIONS(2842),
    [anon_sym_AT] = ACTIONS(2840),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_abstract] = ACTIONS(2842),
    [anon_sym_get] = ACTIONS(2842),
    [anon_sym_set] = ACTIONS(2842),
    [anon_sym_declare] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_module] = ACTIONS(2842),
    [anon_sym_any] = ACTIONS(2842),
    [anon_sym_number] = ACTIONS(2842),
    [anon_sym_boolean] = ACTIONS(2842),
    [anon_sym_string] = ACTIONS(2842),
    [anon_sym_symbol] = ACTIONS(2842),
    [anon_sym_interface] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [sym_readonly] = ACTIONS(2842),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(2844),
    [sym_identifier] = ACTIONS(2846),
    [anon_sym_export] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_EQ] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_COMMA] = ACTIONS(2844),
    [anon_sym_RBRACE] = ACTIONS(2844),
    [anon_sym_type] = ACTIONS(2846),
    [anon_sym_typeof] = ACTIONS(2846),
    [anon_sym_import] = ACTIONS(2846),
    [anon_sym_var] = ACTIONS(2846),
    [anon_sym_let] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_else] = ACTIONS(2846),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_LPAREN] = ACTIONS(2844),
    [anon_sym_RPAREN] = ACTIONS(2844),
    [anon_sym_await] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_with] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_debugger] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_yield] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2844),
    [anon_sym_RBRACK] = ACTIONS(2844),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_async] = ACTIONS(2846),
    [anon_sym_function] = ACTIONS(2846),
    [anon_sym_EQ_GT] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_void] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2844),
    [sym_number] = ACTIONS(2844),
    [sym_this] = ACTIONS(2846),
    [sym_super] = ACTIONS(2846),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [sym_null] = ACTIONS(2846),
    [sym_undefined] = ACTIONS(2846),
    [anon_sym_AT] = ACTIONS(2844),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_abstract] = ACTIONS(2846),
    [anon_sym_get] = ACTIONS(2846),
    [anon_sym_set] = ACTIONS(2846),
    [anon_sym_declare] = ACTIONS(2846),
    [anon_sym_public] = ACTIONS(2846),
    [anon_sym_private] = ACTIONS(2846),
    [anon_sym_protected] = ACTIONS(2846),
    [anon_sym_module] = ACTIONS(2846),
    [anon_sym_any] = ACTIONS(2846),
    [anon_sym_number] = ACTIONS(2846),
    [anon_sym_boolean] = ACTIONS(2846),
    [anon_sym_string] = ACTIONS(2846),
    [anon_sym_symbol] = ACTIONS(2846),
    [anon_sym_interface] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [sym_readonly] = ACTIONS(2846),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(2848),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_export] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_COMMA] = ACTIONS(2848),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_type] = ACTIONS(2850),
    [anon_sym_typeof] = ACTIONS(2850),
    [anon_sym_import] = ACTIONS(2850),
    [anon_sym_var] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_else] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_LPAREN] = ACTIONS(2848),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_await] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_with] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_debugger] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2848),
    [anon_sym_RBRACK] = ACTIONS(2848),
    [anon_sym_LT] = ACTIONS(2848),
    [anon_sym_GT] = ACTIONS(2848),
    [anon_sym_SLASH] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_async] = ACTIONS(2850),
    [anon_sym_function] = ACTIONS(2850),
    [anon_sym_EQ_GT] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2848),
    [anon_sym_PIPE] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_void] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2848),
    [sym_number] = ACTIONS(2848),
    [sym_this] = ACTIONS(2850),
    [sym_super] = ACTIONS(2850),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [sym_null] = ACTIONS(2850),
    [sym_undefined] = ACTIONS(2850),
    [anon_sym_AT] = ACTIONS(2848),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_abstract] = ACTIONS(2850),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_declare] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_module] = ACTIONS(2850),
    [anon_sym_any] = ACTIONS(2850),
    [anon_sym_number] = ACTIONS(2850),
    [anon_sym_boolean] = ACTIONS(2850),
    [anon_sym_string] = ACTIONS(2850),
    [anon_sym_symbol] = ACTIONS(2850),
    [anon_sym_interface] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [sym_readonly] = ACTIONS(2850),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(2852),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_export] = ACTIONS(2854),
    [anon_sym_default] = ACTIONS(2854),
    [anon_sym_EQ] = ACTIONS(2854),
    [anon_sym_namespace] = ACTIONS(2854),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_type] = ACTIONS(2854),
    [anon_sym_typeof] = ACTIONS(2854),
    [anon_sym_import] = ACTIONS(2854),
    [anon_sym_var] = ACTIONS(2854),
    [anon_sym_let] = ACTIONS(2854),
    [anon_sym_const] = ACTIONS(2854),
    [anon_sym_if] = ACTIONS(2854),
    [anon_sym_else] = ACTIONS(2854),
    [anon_sym_switch] = ACTIONS(2854),
    [anon_sym_for] = ACTIONS(2854),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_await] = ACTIONS(2854),
    [anon_sym_while] = ACTIONS(2854),
    [anon_sym_do] = ACTIONS(2854),
    [anon_sym_try] = ACTIONS(2854),
    [anon_sym_with] = ACTIONS(2854),
    [anon_sym_break] = ACTIONS(2854),
    [anon_sym_continue] = ACTIONS(2854),
    [anon_sym_debugger] = ACTIONS(2854),
    [anon_sym_return] = ACTIONS(2854),
    [anon_sym_throw] = ACTIONS(2854),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym_case] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(2854),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_RBRACK] = ACTIONS(2852),
    [anon_sym_LT] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2852),
    [anon_sym_SLASH] = ACTIONS(2854),
    [anon_sym_class] = ACTIONS(2854),
    [anon_sym_async] = ACTIONS(2854),
    [anon_sym_function] = ACTIONS(2854),
    [anon_sym_EQ_GT] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2852),
    [anon_sym_PIPE] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(2854),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_void] = ACTIONS(2854),
    [anon_sym_delete] = ACTIONS(2854),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2852),
    [sym_number] = ACTIONS(2852),
    [sym_this] = ACTIONS(2854),
    [sym_super] = ACTIONS(2854),
    [sym_true] = ACTIONS(2854),
    [sym_false] = ACTIONS(2854),
    [sym_null] = ACTIONS(2854),
    [sym_undefined] = ACTIONS(2854),
    [anon_sym_AT] = ACTIONS(2852),
    [anon_sym_static] = ACTIONS(2854),
    [anon_sym_abstract] = ACTIONS(2854),
    [anon_sym_get] = ACTIONS(2854),
    [anon_sym_set] = ACTIONS(2854),
    [anon_sym_declare] = ACTIONS(2854),
    [anon_sym_public] = ACTIONS(2854),
    [anon_sym_private] = ACTIONS(2854),
    [anon_sym_protected] = ACTIONS(2854),
    [anon_sym_module] = ACTIONS(2854),
    [anon_sym_any] = ACTIONS(2854),
    [anon_sym_number] = ACTIONS(2854),
    [anon_sym_boolean] = ACTIONS(2854),
    [anon_sym_string] = ACTIONS(2854),
    [anon_sym_symbol] = ACTIONS(2854),
    [anon_sym_interface] = ACTIONS(2854),
    [anon_sym_enum] = ACTIONS(2854),
    [sym_readonly] = ACTIONS(2854),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(2856),
    [sym_identifier] = ACTIONS(2858),
    [anon_sym_export] = ACTIONS(2858),
    [anon_sym_default] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2858),
    [anon_sym_namespace] = ACTIONS(2858),
    [anon_sym_LBRACE] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2856),
    [anon_sym_type] = ACTIONS(2858),
    [anon_sym_typeof] = ACTIONS(2858),
    [anon_sym_import] = ACTIONS(2858),
    [anon_sym_var] = ACTIONS(2858),
    [anon_sym_let] = ACTIONS(2858),
    [anon_sym_const] = ACTIONS(2858),
    [anon_sym_if] = ACTIONS(2858),
    [anon_sym_else] = ACTIONS(2858),
    [anon_sym_switch] = ACTIONS(2858),
    [anon_sym_for] = ACTIONS(2858),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [anon_sym_RPAREN] = ACTIONS(2856),
    [anon_sym_await] = ACTIONS(2858),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(2858),
    [anon_sym_try] = ACTIONS(2858),
    [anon_sym_with] = ACTIONS(2858),
    [anon_sym_break] = ACTIONS(2858),
    [anon_sym_continue] = ACTIONS(2858),
    [anon_sym_debugger] = ACTIONS(2858),
    [anon_sym_return] = ACTIONS(2858),
    [anon_sym_throw] = ACTIONS(2858),
    [anon_sym_SEMI] = ACTIONS(2856),
    [anon_sym_case] = ACTIONS(2858),
    [anon_sym_yield] = ACTIONS(2858),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_RBRACK] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_GT] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2858),
    [anon_sym_class] = ACTIONS(2858),
    [anon_sym_async] = ACTIONS(2858),
    [anon_sym_function] = ACTIONS(2858),
    [anon_sym_EQ_GT] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2856),
    [anon_sym_TILDE] = ACTIONS(2856),
    [anon_sym_void] = ACTIONS(2858),
    [anon_sym_delete] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2856),
    [anon_sym_DASH_DASH] = ACTIONS(2856),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [anon_sym_SQUOTE] = ACTIONS(2856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2856),
    [sym_number] = ACTIONS(2856),
    [sym_this] = ACTIONS(2858),
    [sym_super] = ACTIONS(2858),
    [sym_true] = ACTIONS(2858),
    [sym_false] = ACTIONS(2858),
    [sym_null] = ACTIONS(2858),
    [sym_undefined] = ACTIONS(2858),
    [anon_sym_AT] = ACTIONS(2856),
    [anon_sym_static] = ACTIONS(2858),
    [anon_sym_abstract] = ACTIONS(2858),
    [anon_sym_get] = ACTIONS(2858),
    [anon_sym_set] = ACTIONS(2858),
    [anon_sym_declare] = ACTIONS(2858),
    [anon_sym_public] = ACTIONS(2858),
    [anon_sym_private] = ACTIONS(2858),
    [anon_sym_protected] = ACTIONS(2858),
    [anon_sym_module] = ACTIONS(2858),
    [anon_sym_any] = ACTIONS(2858),
    [anon_sym_number] = ACTIONS(2858),
    [anon_sym_boolean] = ACTIONS(2858),
    [anon_sym_string] = ACTIONS(2858),
    [anon_sym_symbol] = ACTIONS(2858),
    [anon_sym_interface] = ACTIONS(2858),
    [anon_sym_enum] = ACTIONS(2858),
    [sym_readonly] = ACTIONS(2858),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(2860),
    [sym_identifier] = ACTIONS(2862),
    [anon_sym_export] = ACTIONS(2862),
    [anon_sym_default] = ACTIONS(2862),
    [anon_sym_EQ] = ACTIONS(2862),
    [anon_sym_namespace] = ACTIONS(2862),
    [anon_sym_LBRACE] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2860),
    [anon_sym_RBRACE] = ACTIONS(2860),
    [anon_sym_type] = ACTIONS(2862),
    [anon_sym_typeof] = ACTIONS(2862),
    [anon_sym_import] = ACTIONS(2862),
    [anon_sym_var] = ACTIONS(2862),
    [anon_sym_let] = ACTIONS(2862),
    [anon_sym_const] = ACTIONS(2862),
    [anon_sym_if] = ACTIONS(2862),
    [anon_sym_else] = ACTIONS(2862),
    [anon_sym_switch] = ACTIONS(2862),
    [anon_sym_for] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2860),
    [anon_sym_RPAREN] = ACTIONS(2860),
    [anon_sym_await] = ACTIONS(2862),
    [anon_sym_while] = ACTIONS(2862),
    [anon_sym_do] = ACTIONS(2862),
    [anon_sym_try] = ACTIONS(2862),
    [anon_sym_with] = ACTIONS(2862),
    [anon_sym_break] = ACTIONS(2862),
    [anon_sym_continue] = ACTIONS(2862),
    [anon_sym_debugger] = ACTIONS(2862),
    [anon_sym_return] = ACTIONS(2862),
    [anon_sym_throw] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2862),
    [anon_sym_yield] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [anon_sym_RBRACK] = ACTIONS(2860),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_SLASH] = ACTIONS(2862),
    [anon_sym_class] = ACTIONS(2862),
    [anon_sym_async] = ACTIONS(2862),
    [anon_sym_function] = ACTIONS(2862),
    [anon_sym_EQ_GT] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_PIPE] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2862),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_TILDE] = ACTIONS(2860),
    [anon_sym_void] = ACTIONS(2862),
    [anon_sym_delete] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2860),
    [anon_sym_DQUOTE] = ACTIONS(2860),
    [anon_sym_SQUOTE] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2860),
    [sym_number] = ACTIONS(2860),
    [sym_this] = ACTIONS(2862),
    [sym_super] = ACTIONS(2862),
    [sym_true] = ACTIONS(2862),
    [sym_false] = ACTIONS(2862),
    [sym_null] = ACTIONS(2862),
    [sym_undefined] = ACTIONS(2862),
    [anon_sym_AT] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2862),
    [anon_sym_abstract] = ACTIONS(2862),
    [anon_sym_get] = ACTIONS(2862),
    [anon_sym_set] = ACTIONS(2862),
    [anon_sym_declare] = ACTIONS(2862),
    [anon_sym_public] = ACTIONS(2862),
    [anon_sym_private] = ACTIONS(2862),
    [anon_sym_protected] = ACTIONS(2862),
    [anon_sym_module] = ACTIONS(2862),
    [anon_sym_any] = ACTIONS(2862),
    [anon_sym_number] = ACTIONS(2862),
    [anon_sym_boolean] = ACTIONS(2862),
    [anon_sym_string] = ACTIONS(2862),
    [anon_sym_symbol] = ACTIONS(2862),
    [anon_sym_interface] = ACTIONS(2862),
    [anon_sym_enum] = ACTIONS(2862),
    [sym_readonly] = ACTIONS(2862),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(2864),
    [sym_identifier] = ACTIONS(2866),
    [anon_sym_export] = ACTIONS(2866),
    [anon_sym_default] = ACTIONS(2866),
    [anon_sym_EQ] = ACTIONS(2866),
    [anon_sym_namespace] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(2864),
    [anon_sym_COMMA] = ACTIONS(2864),
    [anon_sym_RBRACE] = ACTIONS(2864),
    [anon_sym_type] = ACTIONS(2866),
    [anon_sym_typeof] = ACTIONS(2866),
    [anon_sym_import] = ACTIONS(2866),
    [anon_sym_var] = ACTIONS(2866),
    [anon_sym_let] = ACTIONS(2866),
    [anon_sym_const] = ACTIONS(2866),
    [anon_sym_if] = ACTIONS(2866),
    [anon_sym_else] = ACTIONS(2866),
    [anon_sym_switch] = ACTIONS(2866),
    [anon_sym_for] = ACTIONS(2866),
    [anon_sym_LPAREN] = ACTIONS(2864),
    [anon_sym_RPAREN] = ACTIONS(2864),
    [anon_sym_await] = ACTIONS(2866),
    [anon_sym_while] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2866),
    [anon_sym_try] = ACTIONS(2866),
    [anon_sym_with] = ACTIONS(2866),
    [anon_sym_break] = ACTIONS(2866),
    [anon_sym_continue] = ACTIONS(2866),
    [anon_sym_debugger] = ACTIONS(2866),
    [anon_sym_return] = ACTIONS(2866),
    [anon_sym_throw] = ACTIONS(2866),
    [anon_sym_SEMI] = ACTIONS(2864),
    [anon_sym_case] = ACTIONS(2866),
    [anon_sym_yield] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2864),
    [anon_sym_RBRACK] = ACTIONS(2864),
    [anon_sym_LT] = ACTIONS(2864),
    [anon_sym_GT] = ACTIONS(2864),
    [anon_sym_SLASH] = ACTIONS(2866),
    [anon_sym_class] = ACTIONS(2866),
    [anon_sym_async] = ACTIONS(2866),
    [anon_sym_function] = ACTIONS(2866),
    [anon_sym_EQ_GT] = ACTIONS(2864),
    [anon_sym_new] = ACTIONS(2866),
    [anon_sym_AMP] = ACTIONS(2864),
    [anon_sym_PIPE] = ACTIONS(2864),
    [anon_sym_PLUS] = ACTIONS(2866),
    [anon_sym_DASH] = ACTIONS(2866),
    [anon_sym_BANG] = ACTIONS(2864),
    [anon_sym_TILDE] = ACTIONS(2864),
    [anon_sym_void] = ACTIONS(2866),
    [anon_sym_delete] = ACTIONS(2866),
    [anon_sym_PLUS_PLUS] = ACTIONS(2864),
    [anon_sym_DASH_DASH] = ACTIONS(2864),
    [anon_sym_DQUOTE] = ACTIONS(2864),
    [anon_sym_SQUOTE] = ACTIONS(2864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2864),
    [sym_number] = ACTIONS(2864),
    [sym_this] = ACTIONS(2866),
    [sym_super] = ACTIONS(2866),
    [sym_true] = ACTIONS(2866),
    [sym_false] = ACTIONS(2866),
    [sym_null] = ACTIONS(2866),
    [sym_undefined] = ACTIONS(2866),
    [anon_sym_AT] = ACTIONS(2864),
    [anon_sym_static] = ACTIONS(2866),
    [anon_sym_abstract] = ACTIONS(2866),
    [anon_sym_get] = ACTIONS(2866),
    [anon_sym_set] = ACTIONS(2866),
    [anon_sym_declare] = ACTIONS(2866),
    [anon_sym_public] = ACTIONS(2866),
    [anon_sym_private] = ACTIONS(2866),
    [anon_sym_protected] = ACTIONS(2866),
    [anon_sym_module] = ACTIONS(2866),
    [anon_sym_any] = ACTIONS(2866),
    [anon_sym_number] = ACTIONS(2866),
    [anon_sym_boolean] = ACTIONS(2866),
    [anon_sym_string] = ACTIONS(2866),
    [anon_sym_symbol] = ACTIONS(2866),
    [anon_sym_interface] = ACTIONS(2866),
    [anon_sym_enum] = ACTIONS(2866),
    [sym_readonly] = ACTIONS(2866),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(2868),
    [sym_identifier] = ACTIONS(2870),
    [anon_sym_export] = ACTIONS(2870),
    [anon_sym_default] = ACTIONS(2870),
    [anon_sym_EQ] = ACTIONS(2870),
    [anon_sym_namespace] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2868),
    [anon_sym_COMMA] = ACTIONS(2868),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_type] = ACTIONS(2870),
    [anon_sym_typeof] = ACTIONS(2870),
    [anon_sym_import] = ACTIONS(2870),
    [anon_sym_var] = ACTIONS(2870),
    [anon_sym_let] = ACTIONS(2870),
    [anon_sym_const] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_switch] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2868),
    [anon_sym_RPAREN] = ACTIONS(2868),
    [anon_sym_await] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_with] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_debugger] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_throw] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_case] = ACTIONS(2870),
    [anon_sym_yield] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2868),
    [anon_sym_LT] = ACTIONS(2868),
    [anon_sym_GT] = ACTIONS(2868),
    [anon_sym_SLASH] = ACTIONS(2870),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_async] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2870),
    [anon_sym_EQ_GT] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(2870),
    [anon_sym_AMP] = ACTIONS(2868),
    [anon_sym_PIPE] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2868),
    [anon_sym_TILDE] = ACTIONS(2868),
    [anon_sym_void] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2868),
    [anon_sym_DASH_DASH] = ACTIONS(2868),
    [anon_sym_DQUOTE] = ACTIONS(2868),
    [anon_sym_SQUOTE] = ACTIONS(2868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2868),
    [sym_number] = ACTIONS(2868),
    [sym_this] = ACTIONS(2870),
    [sym_super] = ACTIONS(2870),
    [sym_true] = ACTIONS(2870),
    [sym_false] = ACTIONS(2870),
    [sym_null] = ACTIONS(2870),
    [sym_undefined] = ACTIONS(2870),
    [anon_sym_AT] = ACTIONS(2868),
    [anon_sym_static] = ACTIONS(2870),
    [anon_sym_abstract] = ACTIONS(2870),
    [anon_sym_get] = ACTIONS(2870),
    [anon_sym_set] = ACTIONS(2870),
    [anon_sym_declare] = ACTIONS(2870),
    [anon_sym_public] = ACTIONS(2870),
    [anon_sym_private] = ACTIONS(2870),
    [anon_sym_protected] = ACTIONS(2870),
    [anon_sym_module] = ACTIONS(2870),
    [anon_sym_any] = ACTIONS(2870),
    [anon_sym_number] = ACTIONS(2870),
    [anon_sym_boolean] = ACTIONS(2870),
    [anon_sym_string] = ACTIONS(2870),
    [anon_sym_symbol] = ACTIONS(2870),
    [anon_sym_interface] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2870),
    [sym_readonly] = ACTIONS(2870),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(558),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_export] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(2872),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_typeof] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2872),
    [anon_sym_var] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2872),
    [anon_sym_switch] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_do] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [anon_sym_with] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_debugger] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_throw] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(558),
    [anon_sym_case] = ACTIONS(2872),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_new] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(558),
    [anon_sym_void] = ACTIONS(2872),
    [anon_sym_delete] = ACTIONS(2872),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [anon_sym_SQUOTE] = ACTIONS(558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(558),
    [sym_number] = ACTIONS(558),
    [sym_this] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_undefined] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_abstract] = ACTIONS(2872),
    [anon_sym_get] = ACTIONS(2872),
    [anon_sym_set] = ACTIONS(2872),
    [anon_sym_declare] = ACTIONS(2872),
    [anon_sym_public] = ACTIONS(2872),
    [anon_sym_private] = ACTIONS(2872),
    [anon_sym_protected] = ACTIONS(2872),
    [anon_sym_module] = ACTIONS(2872),
    [anon_sym_any] = ACTIONS(2872),
    [anon_sym_number] = ACTIONS(2872),
    [anon_sym_boolean] = ACTIONS(2872),
    [anon_sym_string] = ACTIONS(2872),
    [anon_sym_symbol] = ACTIONS(2872),
    [anon_sym_interface] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
    [sym_readonly] = ACTIONS(2872),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_typeof] = ACTIONS(2876),
    [anon_sym_import] = ACTIONS(2876),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2876),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_await] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_do] = ACTIONS(2876),
    [anon_sym_try] = ACTIONS(2876),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_debugger] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_throw] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_case] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [anon_sym_RBRACK] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_class] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_function] = ACTIONS(2876),
    [anon_sym_EQ_GT] = ACTIONS(2874),
    [anon_sym_new] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2874),
    [anon_sym_PIPE] = ACTIONS(2874),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_void] = ACTIONS(2876),
    [anon_sym_delete] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [sym_number] = ACTIONS(2874),
    [sym_this] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_undefined] = ACTIONS(2876),
    [anon_sym_AT] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2876),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2876),
    [anon_sym_private] = ACTIONS(2876),
    [anon_sym_protected] = ACTIONS(2876),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_interface] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [sym_readonly] = ACTIONS(2876),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(2878),
    [sym_identifier] = ACTIONS(2880),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_default] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(2880),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_COMMA] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_typeof] = ACTIONS(2880),
    [anon_sym_import] = ACTIONS(2880),
    [anon_sym_var] = ACTIONS(2880),
    [anon_sym_let] = ACTIONS(2880),
    [anon_sym_const] = ACTIONS(2880),
    [anon_sym_if] = ACTIONS(2880),
    [anon_sym_else] = ACTIONS(2880),
    [anon_sym_switch] = ACTIONS(2880),
    [anon_sym_for] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2878),
    [anon_sym_await] = ACTIONS(2880),
    [anon_sym_while] = ACTIONS(2880),
    [anon_sym_do] = ACTIONS(2880),
    [anon_sym_try] = ACTIONS(2880),
    [anon_sym_with] = ACTIONS(2880),
    [anon_sym_break] = ACTIONS(2880),
    [anon_sym_continue] = ACTIONS(2880),
    [anon_sym_debugger] = ACTIONS(2880),
    [anon_sym_return] = ACTIONS(2880),
    [anon_sym_throw] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_case] = ACTIONS(2880),
    [anon_sym_yield] = ACTIONS(2880),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_RBRACK] = ACTIONS(2878),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_SLASH] = ACTIONS(2880),
    [anon_sym_class] = ACTIONS(2880),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_function] = ACTIONS(2880),
    [anon_sym_EQ_GT] = ACTIONS(2878),
    [anon_sym_new] = ACTIONS(2880),
    [anon_sym_AMP] = ACTIONS(2878),
    [anon_sym_PIPE] = ACTIONS(2878),
    [anon_sym_PLUS] = ACTIONS(2880),
    [anon_sym_DASH] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(2878),
    [anon_sym_TILDE] = ACTIONS(2878),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_delete] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_DQUOTE] = ACTIONS(2878),
    [anon_sym_SQUOTE] = ACTIONS(2878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2878),
    [sym_number] = ACTIONS(2878),
    [sym_this] = ACTIONS(2880),
    [sym_super] = ACTIONS(2880),
    [sym_true] = ACTIONS(2880),
    [sym_false] = ACTIONS(2880),
    [sym_null] = ACTIONS(2880),
    [sym_undefined] = ACTIONS(2880),
    [anon_sym_AT] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_abstract] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [anon_sym_interface] = ACTIONS(2880),
    [anon_sym_enum] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [531] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2882),
    [anon_sym_set] = ACTIONS(2882),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [532] = {
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_as] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2772),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_in] = ACTIONS(2774),
    [anon_sym_COLON] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [anon_sym_RBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_DOT] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_GT_GT] = ACTIONS(2774),
    [anon_sym_GT_GT_GT] = ACTIONS(2772),
    [anon_sym_LT_LT] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2774),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_PIPE] = ACTIONS(2774),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_PERCENT] = ACTIONS(2772),
    [anon_sym_STAR_STAR] = ACTIONS(2772),
    [anon_sym_LT_EQ] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(2774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2772),
    [anon_sym_BANG_EQ] = ACTIONS(2774),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2772),
    [anon_sym_GT_EQ] = ACTIONS(2772),
    [anon_sym_QMARK_QMARK] = ACTIONS(2772),
    [anon_sym_instanceof] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2772),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2772),
    [sym_number] = ACTIONS(2772),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [anon_sym_implements] = ACTIONS(2774),
    [sym_readonly] = ACTIONS(2774),
  },
  [533] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2635),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2882),
    [anon_sym_set] = ACTIONS(2882),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [534] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2788),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [535] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2788),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2888),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [536] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2635),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2888),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [537] = {
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_in] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2782),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_RBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2784),
    [anon_sym_GT_GT_GT] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_instanceof] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2784),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_implements] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [538] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2788),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2882),
    [anon_sym_set] = ACTIONS(2882),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [539] = {
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_as] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_in] = ACTIONS(2788),
    [anon_sym_COLON] = ACTIONS(2786),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_RBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_DOT] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_GT_GT_GT] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_STAR_STAR] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2788),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_QMARK_QMARK] = ACTIONS(2786),
    [anon_sym_instanceof] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2788),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_implements] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [540] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2888),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [541] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [542] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(2635),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_export] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2884),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2764),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_declare] = ACTIONS(2882),
    [anon_sym_public] = ACTIONS(2882),
    [anon_sym_private] = ACTIONS(2882),
    [anon_sym_protected] = ACTIONS(2882),
    [anon_sym_module] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [sym_readonly] = ACTIONS(2882),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [543] = {
    [sym_type_arguments] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(2890),
    [sym_identifier] = ACTIONS(2892),
    [anon_sym_export] = ACTIONS(2892),
    [anon_sym_default] = ACTIONS(2892),
    [anon_sym_namespace] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_type] = ACTIONS(2892),
    [anon_sym_typeof] = ACTIONS(2892),
    [anon_sym_import] = ACTIONS(2892),
    [anon_sym_var] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_const] = ACTIONS(2892),
    [anon_sym_if] = ACTIONS(2892),
    [anon_sym_else] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_for] = ACTIONS(2892),
    [anon_sym_LPAREN] = ACTIONS(2890),
    [anon_sym_await] = ACTIONS(2892),
    [anon_sym_while] = ACTIONS(2892),
    [anon_sym_do] = ACTIONS(2892),
    [anon_sym_try] = ACTIONS(2892),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_break] = ACTIONS(2892),
    [anon_sym_continue] = ACTIONS(2892),
    [anon_sym_debugger] = ACTIONS(2892),
    [anon_sym_return] = ACTIONS(2892),
    [anon_sym_throw] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2890),
    [anon_sym_case] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2894),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2892),
    [anon_sym_async] = ACTIONS(2892),
    [anon_sym_function] = ACTIONS(2892),
    [anon_sym_new] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2890),
    [anon_sym_PIPE] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2890),
    [anon_sym_TILDE] = ACTIONS(2890),
    [anon_sym_void] = ACTIONS(2892),
    [anon_sym_delete] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(2890),
    [anon_sym_SQUOTE] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2890),
    [sym_number] = ACTIONS(2890),
    [sym_this] = ACTIONS(2892),
    [sym_super] = ACTIONS(2892),
    [sym_true] = ACTIONS(2892),
    [sym_false] = ACTIONS(2892),
    [sym_null] = ACTIONS(2892),
    [sym_undefined] = ACTIONS(2892),
    [anon_sym_AT] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2892),
    [anon_sym_abstract] = ACTIONS(2892),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_declare] = ACTIONS(2892),
    [anon_sym_public] = ACTIONS(2892),
    [anon_sym_private] = ACTIONS(2892),
    [anon_sym_protected] = ACTIONS(2892),
    [anon_sym_module] = ACTIONS(2892),
    [anon_sym_any] = ACTIONS(2892),
    [anon_sym_number] = ACTIONS(2892),
    [anon_sym_boolean] = ACTIONS(2892),
    [anon_sym_string] = ACTIONS(2892),
    [anon_sym_symbol] = ACTIONS(2892),
    [anon_sym_interface] = ACTIONS(2892),
    [anon_sym_enum] = ACTIONS(2892),
    [sym_readonly] = ACTIONS(2892),
    [anon_sym_is] = ACTIONS(2899),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_as] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_in] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_DOT] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_GT_GT_GT] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_STAR_STAR] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2788),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_QMARK_QMARK] = ACTIONS(2786),
    [anon_sym_instanceof] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2788),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
    [sym__automatic_semicolon] = ACTIONS(2786),
  },
  [545] = {
    [sym__call_signature] = STATE(3088),
    [sym_arguments] = STATE(1641),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1496),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_any] = ACTIONS(2903),
    [anon_sym_number] = ACTIONS(2903),
    [anon_sym_boolean] = ACTIONS(2903),
    [anon_sym_string] = ACTIONS(2903),
    [anon_sym_symbol] = ACTIONS(2903),
    [sym_readonly] = ACTIONS(2903),
    [sym__automatic_semicolon] = ACTIONS(503),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_catch] = ACTIONS(1235),
    [anon_sym_finally] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(2907),
  },
  [547] = {
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_as] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_in] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_DOT] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_GT_GT] = ACTIONS(2774),
    [anon_sym_GT_GT_GT] = ACTIONS(2772),
    [anon_sym_LT_LT] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2774),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_PIPE] = ACTIONS(2774),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_PERCENT] = ACTIONS(2772),
    [anon_sym_STAR_STAR] = ACTIONS(2772),
    [anon_sym_LT_EQ] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(2774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2772),
    [anon_sym_BANG_EQ] = ACTIONS(2774),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2772),
    [anon_sym_GT_EQ] = ACTIONS(2772),
    [anon_sym_QMARK_QMARK] = ACTIONS(2772),
    [anon_sym_instanceof] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2772),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2772),
    [sym_number] = ACTIONS(2772),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [sym_readonly] = ACTIONS(2774),
    [sym__automatic_semicolon] = ACTIONS(2772),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_catch] = ACTIONS(1197),
    [anon_sym_finally] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [sym__automatic_semicolon] = ACTIONS(1203),
  },
  [549] = {
    [sym_catch_clause] = STATE(577),
    [sym_finally_clause] = STATE(648),
    [ts_builtin_sym_end] = ACTIONS(2909),
    [sym_identifier] = ACTIONS(2911),
    [anon_sym_export] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_type] = ACTIONS(2911),
    [anon_sym_typeof] = ACTIONS(2911),
    [anon_sym_import] = ACTIONS(2911),
    [anon_sym_var] = ACTIONS(2911),
    [anon_sym_let] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_await] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_with] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_debugger] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_catch] = ACTIONS(2913),
    [anon_sym_finally] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_async] = ACTIONS(2911),
    [anon_sym_function] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_void] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2909),
    [sym_number] = ACTIONS(2909),
    [sym_this] = ACTIONS(2911),
    [sym_super] = ACTIONS(2911),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [sym_null] = ACTIONS(2911),
    [sym_undefined] = ACTIONS(2911),
    [anon_sym_AT] = ACTIONS(2909),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_abstract] = ACTIONS(2911),
    [anon_sym_get] = ACTIONS(2911),
    [anon_sym_set] = ACTIONS(2911),
    [anon_sym_declare] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_module] = ACTIONS(2911),
    [anon_sym_any] = ACTIONS(2911),
    [anon_sym_number] = ACTIONS(2911),
    [anon_sym_boolean] = ACTIONS(2911),
    [anon_sym_string] = ACTIONS(2911),
    [anon_sym_symbol] = ACTIONS(2911),
    [anon_sym_interface] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [sym_readonly] = ACTIONS(2911),
  },
  [550] = {
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_in] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2784),
    [anon_sym_GT_GT_GT] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_instanceof] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2784),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
    [sym__automatic_semicolon] = ACTIONS(2782),
  },
  [551] = {
    [sym__call_signature] = STATE(3193),
    [sym_arguments] = STATE(1151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1084),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_RPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_RBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [552] = {
    [sym_type_arguments] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(2925),
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_await] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_debugger] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_yield] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2927),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_async] = ACTIONS(2927),
    [anon_sym_function] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_void] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2925),
    [sym_number] = ACTIONS(2925),
    [sym_this] = ACTIONS(2927),
    [sym_super] = ACTIONS(2927),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_undefined] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_abstract] = ACTIONS(2927),
    [anon_sym_get] = ACTIONS(2927),
    [anon_sym_set] = ACTIONS(2927),
    [anon_sym_declare] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_any] = ACTIONS(2927),
    [anon_sym_number] = ACTIONS(2927),
    [anon_sym_boolean] = ACTIONS(2927),
    [anon_sym_string] = ACTIONS(2927),
    [anon_sym_symbol] = ACTIONS(2927),
    [anon_sym_interface] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [sym_readonly] = ACTIONS(2927),
  },
  [553] = {
    [sym__call_signature] = STATE(3141),
    [sym_arguments] = STATE(1151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1084),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(606),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_get] = ACTIONS(2931),
    [anon_sym_set] = ACTIONS(2931),
    [anon_sym_declare] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_any] = ACTIONS(2931),
    [anon_sym_number] = ACTIONS(2931),
    [anon_sym_boolean] = ACTIONS(2931),
    [anon_sym_string] = ACTIONS(2931),
    [anon_sym_symbol] = ACTIONS(2931),
    [anon_sym_implements] = ACTIONS(495),
    [sym_readonly] = ACTIONS(2931),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_catch] = ACTIONS(1235),
    [anon_sym_finally] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
  },
  [555] = {
    [sym_type_arguments] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [sym_readonly] = ACTIONS(2820),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1249),
    [anon_sym_export] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1249),
    [anon_sym_import] = ACTIONS(1249),
    [anon_sym_var] = ACTIONS(1249),
    [anon_sym_let] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_with] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_debugger] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_throw] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_SLASH] = ACTIONS(1249),
    [anon_sym_class] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1249),
    [anon_sym_function] = ACTIONS(1249),
    [anon_sym_new] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1249),
    [anon_sym_delete] = ACTIONS(1249),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [sym_number] = ACTIONS(1247),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(1249),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [sym_null] = ACTIONS(1249),
    [sym_undefined] = ACTIONS(1249),
    [anon_sym_AT] = ACTIONS(1247),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_abstract] = ACTIONS(1249),
    [anon_sym_get] = ACTIONS(1249),
    [anon_sym_set] = ACTIONS(1249),
    [anon_sym_declare] = ACTIONS(1249),
    [anon_sym_public] = ACTIONS(1249),
    [anon_sym_private] = ACTIONS(1249),
    [anon_sym_protected] = ACTIONS(1249),
    [anon_sym_module] = ACTIONS(1249),
    [anon_sym_any] = ACTIONS(1249),
    [anon_sym_number] = ACTIONS(1249),
    [anon_sym_boolean] = ACTIONS(1249),
    [anon_sym_string] = ACTIONS(1249),
    [anon_sym_symbol] = ACTIONS(1249),
    [anon_sym_interface] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [sym_readonly] = ACTIONS(1249),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1247),
    [sym__automatic_semicolon] = ACTIONS(1247),
  },
  [557] = {
    [sym_object] = STATE(2500),
    [sym_array] = STATE(2499),
    [sym_nested_identifier] = STATE(3104),
    [sym_string] = STATE(525),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(3103),
    [sym_rest_parameter] = STATE(2708),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2699),
    [sym_constructor_type] = STATE(2699),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2889),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2699),
    [sym_intersection_type] = STATE(2699),
    [sym_function_type] = STATE(2699),
    [aux_sym_export_statement_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2961),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(2963),
  },
  [559] = {
    [sym_type_arguments] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_export] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2967),
    [anon_sym_import] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_await] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_with] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_debugger] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_function] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_void] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_DQUOTE] = ACTIONS(2965),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2965),
    [sym_number] = ACTIONS(2965),
    [sym_this] = ACTIONS(2967),
    [sym_super] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_null] = ACTIONS(2967),
    [sym_undefined] = ACTIONS(2967),
    [anon_sym_AT] = ACTIONS(2965),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2967),
    [anon_sym_set] = ACTIONS(2967),
    [anon_sym_declare] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_module] = ACTIONS(2967),
    [anon_sym_any] = ACTIONS(2967),
    [anon_sym_number] = ACTIONS(2967),
    [anon_sym_boolean] = ACTIONS(2967),
    [anon_sym_string] = ACTIONS(2967),
    [anon_sym_symbol] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [sym_readonly] = ACTIONS(2967),
  },
  [560] = {
    [sym_object] = STATE(2500),
    [sym_array] = STATE(2499),
    [sym_nested_identifier] = STATE(3104),
    [sym_string] = STATE(525),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(3103),
    [sym_rest_parameter] = STATE(2708),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2643),
    [sym_constructor_type] = STATE(2643),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2889),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2643),
    [sym_intersection_type] = STATE(2643),
    [sym_function_type] = STATE(2643),
    [aux_sym_export_statement_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2961),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1233),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [562] = {
    [sym__call_signature] = STATE(3151),
    [sym_arguments] = STATE(1151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1084),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_RPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_COLON] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_get] = ACTIONS(2974),
    [anon_sym_set] = ACTIONS(2974),
    [anon_sym_declare] = ACTIONS(2974),
    [anon_sym_public] = ACTIONS(2974),
    [anon_sym_private] = ACTIONS(2974),
    [anon_sym_protected] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_any] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2974),
    [anon_sym_string] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2974),
    [sym_readonly] = ACTIONS(2974),
  },
  [563] = {
    [aux_sym_object_repeat1] = STATE(2788),
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_symbol] = ACTIONS(2976),
    [sym_readonly] = ACTIONS(2976),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [564] = {
    [sym_object] = STATE(2500),
    [sym_array] = STATE(2499),
    [sym_nested_identifier] = STATE(3104),
    [sym_string] = STATE(525),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(3103),
    [sym_rest_parameter] = STATE(2708),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2715),
    [sym_constructor_type] = STATE(2715),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2889),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2715),
    [sym_intersection_type] = STATE(2715),
    [sym_function_type] = STATE(2715),
    [aux_sym_export_statement_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2961),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_namespace] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_typeof] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1265),
    [anon_sym_var] = ACTIONS(1265),
    [anon_sym_let] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_await] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_with] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_debugger] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_catch] = ACTIONS(1265),
    [anon_sym_finally] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(1265),
    [anon_sym_function] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_void] = ACTIONS(1265),
    [anon_sym_delete] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_number] = ACTIONS(1263),
    [sym_this] = ACTIONS(1265),
    [sym_super] = ACTIONS(1265),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [sym_null] = ACTIONS(1265),
    [sym_undefined] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(1263),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_abstract] = ACTIONS(1265),
    [anon_sym_get] = ACTIONS(1265),
    [anon_sym_set] = ACTIONS(1265),
    [anon_sym_declare] = ACTIONS(1265),
    [anon_sym_public] = ACTIONS(1265),
    [anon_sym_private] = ACTIONS(1265),
    [anon_sym_protected] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_any] = ACTIONS(1265),
    [anon_sym_number] = ACTIONS(1265),
    [anon_sym_boolean] = ACTIONS(1265),
    [anon_sym_string] = ACTIONS(1265),
    [anon_sym_symbol] = ACTIONS(1265),
    [anon_sym_interface] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [sym_readonly] = ACTIONS(1265),
  },
  [566] = {
    [sym_object] = STATE(2500),
    [sym_array] = STATE(2499),
    [sym_nested_identifier] = STATE(3104),
    [sym_string] = STATE(525),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(3103),
    [sym_rest_parameter] = STATE(2708),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2628),
    [sym_constructor_type] = STATE(2628),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2889),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2628),
    [sym_intersection_type] = STATE(2628),
    [sym_function_type] = STATE(2628),
    [aux_sym_export_statement_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2961),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_namespace] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_type] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_var] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_switch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_await] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_do] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_with] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1351),
    [anon_sym_continue] = ACTIONS(1351),
    [anon_sym_debugger] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_throw] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1351),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_new] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_void] = ACTIONS(1351),
    [anon_sym_delete] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1349),
    [sym_number] = ACTIONS(1349),
    [sym_this] = ACTIONS(1351),
    [sym_super] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_undefined] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_get] = ACTIONS(1351),
    [anon_sym_set] = ACTIONS(1351),
    [anon_sym_declare] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_private] = ACTIONS(1351),
    [anon_sym_protected] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_any] = ACTIONS(1351),
    [anon_sym_number] = ACTIONS(1351),
    [anon_sym_boolean] = ACTIONS(1351),
    [anon_sym_string] = ACTIONS(1351),
    [anon_sym_symbol] = ACTIONS(1351),
    [anon_sym_interface] = ACTIONS(1351),
    [anon_sym_enum] = ACTIONS(1351),
    [sym_readonly] = ACTIONS(1351),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1349),
    [sym__automatic_semicolon] = ACTIONS(1349),
  },
  [568] = {
    [sym__call_signature] = STATE(3009),
    [sym_arguments] = STATE(1741),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1653),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2980),
    [anon_sym_export] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_async] = ACTIONS(2982),
    [anon_sym_function] = ACTIONS(2986),
    [anon_sym_EQ_GT] = ACTIONS(693),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_get] = ACTIONS(2982),
    [anon_sym_set] = ACTIONS(2982),
    [anon_sym_declare] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_any] = ACTIONS(2982),
    [anon_sym_number] = ACTIONS(2982),
    [anon_sym_boolean] = ACTIONS(2982),
    [anon_sym_string] = ACTIONS(2982),
    [anon_sym_symbol] = ACTIONS(2982),
    [sym_readonly] = ACTIONS(2982),
    [anon_sym_LBRACE_PIPE] = ACTIONS(503),
  },
  [569] = {
    [aux_sym_object_repeat1] = STATE(2635),
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_symbol] = ACTIONS(2976),
    [sym_readonly] = ACTIONS(2976),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1233),
    [sym__automatic_semicolon] = ACTIONS(2988),
  },
  [571] = {
    [aux_sym_object_repeat1] = STATE(2624),
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_symbol] = ACTIONS(2976),
    [sym_readonly] = ACTIONS(2976),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [572] = {
    [sym_object] = STATE(2500),
    [sym_array] = STATE(2499),
    [sym_nested_identifier] = STATE(3104),
    [sym_string] = STATE(525),
    [sym_decorator] = STATE(2013),
    [sym_formal_parameters] = STATE(3103),
    [sym_rest_parameter] = STATE(2708),
    [sym_nested_type_identifier] = STATE(2028),
    [sym_accessibility_modifier] = STATE(2014),
    [sym_required_parameter] = STATE(2708),
    [sym_optional_parameter] = STATE(2708),
    [sym__parameter_name] = STATE(2175),
    [sym__type] = STATE(2627),
    [sym_constructor_type] = STATE(2627),
    [sym__primary_type] = STATE(519),
    [sym_generic_type] = STATE(519),
    [sym_type_predicate] = STATE(519),
    [sym_type_query] = STATE(519),
    [sym_index_type_query] = STATE(519),
    [sym_lookup_type] = STATE(519),
    [sym_literal_type] = STATE(519),
    [sym__number] = STATE(525),
    [sym_existential_type] = STATE(519),
    [sym_flow_maybe_type] = STATE(519),
    [sym_parenthesized_type] = STATE(519),
    [sym_predefined_type] = STATE(519),
    [sym_object_type] = STATE(519),
    [sym_type_parameters] = STATE(2889),
    [sym_array_type] = STATE(519),
    [sym_tuple_type] = STATE(519),
    [sym_union_type] = STATE(2627),
    [sym_intersection_type] = STATE(2627),
    [sym_function_type] = STATE(2627),
    [aux_sym_export_statement_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(867),
    [anon_sym_PIPE] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2961),
    [anon_sym_keyof] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(891),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_namespace] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_type] = ACTIONS(1265),
    [anon_sym_typeof] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1265),
    [anon_sym_var] = ACTIONS(1265),
    [anon_sym_let] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_await] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_with] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_debugger] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(1265),
    [anon_sym_function] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_void] = ACTIONS(1265),
    [anon_sym_delete] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_number] = ACTIONS(1263),
    [sym_this] = ACTIONS(1265),
    [sym_super] = ACTIONS(1265),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [sym_null] = ACTIONS(1265),
    [sym_undefined] = ACTIONS(1265),
    [anon_sym_AT] = ACTIONS(1263),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_abstract] = ACTIONS(1265),
    [anon_sym_get] = ACTIONS(1265),
    [anon_sym_set] = ACTIONS(1265),
    [anon_sym_declare] = ACTIONS(1265),
    [anon_sym_public] = ACTIONS(1265),
    [anon_sym_private] = ACTIONS(1265),
    [anon_sym_protected] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_any] = ACTIONS(1265),
    [anon_sym_number] = ACTIONS(1265),
    [anon_sym_boolean] = ACTIONS(1265),
    [anon_sym_string] = ACTIONS(1265),
    [anon_sym_symbol] = ACTIONS(1265),
    [anon_sym_interface] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [sym_readonly] = ACTIONS(1265),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1263),
    [sym__automatic_semicolon] = ACTIONS(1263),
  },
  [574] = {
    [sym__call_signature] = STATE(3088),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_any] = ACTIONS(2903),
    [anon_sym_number] = ACTIONS(2903),
    [anon_sym_boolean] = ACTIONS(2903),
    [anon_sym_string] = ACTIONS(2903),
    [anon_sym_symbol] = ACTIONS(2903),
    [sym_readonly] = ACTIONS(2903),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [575] = {
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_in] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2784),
    [anon_sym_GT_GT_GT] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_instanceof] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2784),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2782),
  },
  [576] = {
    [sym__call_signature] = STATE(3088),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(595),
    [anon_sym_of] = ACTIONS(598),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_any] = ACTIONS(2903),
    [anon_sym_number] = ACTIONS(2903),
    [anon_sym_boolean] = ACTIONS(2903),
    [anon_sym_string] = ACTIONS(2903),
    [anon_sym_symbol] = ACTIONS(2903),
    [sym_readonly] = ACTIONS(2903),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [577] = {
    [sym_finally_clause] = STATE(649),
    [ts_builtin_sym_end] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_export] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2998),
    [anon_sym_namespace] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_type] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(2998),
    [anon_sym_import] = ACTIONS(2998),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_switch] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_await] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_try] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_continue] = ACTIONS(2998),
    [anon_sym_debugger] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_throw] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_finally] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(2996),
    [anon_sym_SLASH] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_async] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_void] = ACTIONS(2998),
    [anon_sym_delete] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_SQUOTE] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2996),
    [sym_number] = ACTIONS(2996),
    [sym_this] = ACTIONS(2998),
    [sym_super] = ACTIONS(2998),
    [sym_true] = ACTIONS(2998),
    [sym_false] = ACTIONS(2998),
    [sym_null] = ACTIONS(2998),
    [sym_undefined] = ACTIONS(2998),
    [anon_sym_AT] = ACTIONS(2996),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_abstract] = ACTIONS(2998),
    [anon_sym_get] = ACTIONS(2998),
    [anon_sym_set] = ACTIONS(2998),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_public] = ACTIONS(2998),
    [anon_sym_private] = ACTIONS(2998),
    [anon_sym_protected] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_any] = ACTIONS(2998),
    [anon_sym_number] = ACTIONS(2998),
    [anon_sym_boolean] = ACTIONS(2998),
    [anon_sym_string] = ACTIONS(2998),
    [anon_sym_symbol] = ACTIONS(2998),
    [anon_sym_interface] = ACTIONS(2998),
    [anon_sym_enum] = ACTIONS(2998),
    [sym_readonly] = ACTIONS(2998),
  },
  [578] = {
    [sym_statement_block] = STATE(665),
    [ts_builtin_sym_end] = ACTIONS(1205),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [anon_sym_default] = ACTIONS(1207),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_var] = ACTIONS(1207),
    [anon_sym_let] = ACTIONS(1207),
    [anon_sym_const] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1207),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_do] = ACTIONS(1207),
    [anon_sym_try] = ACTIONS(1207),
    [anon_sym_with] = ACTIONS(1207),
    [anon_sym_break] = ACTIONS(1207),
    [anon_sym_continue] = ACTIONS(1207),
    [anon_sym_debugger] = ACTIONS(1207),
    [anon_sym_return] = ACTIONS(1207),
    [anon_sym_throw] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(1207),
    [anon_sym_new] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym_number] = ACTIONS(1205),
    [sym_this] = ACTIONS(1207),
    [sym_super] = ACTIONS(1207),
    [sym_true] = ACTIONS(1207),
    [sym_false] = ACTIONS(1207),
    [sym_null] = ACTIONS(1207),
    [sym_undefined] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_abstract] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1207),
    [anon_sym_protected] = ACTIONS(1207),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1207),
    [anon_sym_enum] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(1207),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(3002),
    [sym_identifier] = ACTIONS(3004),
    [anon_sym_export] = ACTIONS(3004),
    [anon_sym_default] = ACTIONS(3004),
    [anon_sym_namespace] = ACTIONS(3004),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_type] = ACTIONS(3004),
    [anon_sym_typeof] = ACTIONS(3004),
    [anon_sym_import] = ACTIONS(3004),
    [anon_sym_var] = ACTIONS(3004),
    [anon_sym_let] = ACTIONS(3004),
    [anon_sym_const] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3004),
    [anon_sym_else] = ACTIONS(3004),
    [anon_sym_switch] = ACTIONS(3004),
    [anon_sym_for] = ACTIONS(3004),
    [anon_sym_LPAREN] = ACTIONS(3002),
    [anon_sym_await] = ACTIONS(3004),
    [anon_sym_while] = ACTIONS(3004),
    [anon_sym_do] = ACTIONS(3004),
    [anon_sym_try] = ACTIONS(3004),
    [anon_sym_with] = ACTIONS(3004),
    [anon_sym_break] = ACTIONS(3004),
    [anon_sym_continue] = ACTIONS(3004),
    [anon_sym_debugger] = ACTIONS(3004),
    [anon_sym_return] = ACTIONS(3004),
    [anon_sym_throw] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_yield] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_LT] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_class] = ACTIONS(3004),
    [anon_sym_async] = ACTIONS(3004),
    [anon_sym_function] = ACTIONS(3004),
    [anon_sym_new] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_DASH] = ACTIONS(3004),
    [anon_sym_BANG] = ACTIONS(3002),
    [anon_sym_TILDE] = ACTIONS(3002),
    [anon_sym_void] = ACTIONS(3004),
    [anon_sym_delete] = ACTIONS(3004),
    [anon_sym_PLUS_PLUS] = ACTIONS(3002),
    [anon_sym_DASH_DASH] = ACTIONS(3002),
    [anon_sym_DQUOTE] = ACTIONS(3002),
    [anon_sym_SQUOTE] = ACTIONS(3002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3002),
    [sym_number] = ACTIONS(3002),
    [sym_this] = ACTIONS(3004),
    [sym_super] = ACTIONS(3004),
    [sym_true] = ACTIONS(3004),
    [sym_false] = ACTIONS(3004),
    [sym_null] = ACTIONS(3004),
    [sym_undefined] = ACTIONS(3004),
    [anon_sym_AT] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3004),
    [anon_sym_abstract] = ACTIONS(3004),
    [anon_sym_get] = ACTIONS(3004),
    [anon_sym_set] = ACTIONS(3004),
    [anon_sym_declare] = ACTIONS(3004),
    [anon_sym_public] = ACTIONS(3004),
    [anon_sym_private] = ACTIONS(3004),
    [anon_sym_protected] = ACTIONS(3004),
    [anon_sym_module] = ACTIONS(3004),
    [anon_sym_any] = ACTIONS(3004),
    [anon_sym_number] = ACTIONS(3004),
    [anon_sym_boolean] = ACTIONS(3004),
    [anon_sym_string] = ACTIONS(3004),
    [anon_sym_symbol] = ACTIONS(3004),
    [anon_sym_interface] = ACTIONS(3004),
    [anon_sym_enum] = ACTIONS(3004),
    [sym_readonly] = ACTIONS(3004),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_as] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_in] = ACTIONS(2774),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_DOT] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_GT_GT] = ACTIONS(2774),
    [anon_sym_GT_GT_GT] = ACTIONS(2772),
    [anon_sym_LT_LT] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2774),
    [anon_sym_CARET] = ACTIONS(2772),
    [anon_sym_PIPE] = ACTIONS(2774),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_PERCENT] = ACTIONS(2772),
    [anon_sym_STAR_STAR] = ACTIONS(2772),
    [anon_sym_LT_EQ] = ACTIONS(2772),
    [anon_sym_EQ_EQ] = ACTIONS(2774),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2772),
    [anon_sym_BANG_EQ] = ACTIONS(2774),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2772),
    [anon_sym_GT_EQ] = ACTIONS(2772),
    [anon_sym_QMARK_QMARK] = ACTIONS(2772),
    [anon_sym_instanceof] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2772),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2772),
    [sym_number] = ACTIONS(2772),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [sym_readonly] = ACTIONS(2774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3012),
    [anon_sym_export] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_type] = ACTIONS(3012),
    [anon_sym_typeof] = ACTIONS(3012),
    [anon_sym_import] = ACTIONS(3012),
    [anon_sym_var] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_await] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_debugger] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_async] = ACTIONS(3012),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_void] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3010),
    [sym_number] = ACTIONS(3010),
    [sym_this] = ACTIONS(3012),
    [sym_super] = ACTIONS(3012),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [sym_null] = ACTIONS(3012),
    [sym_undefined] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3010),
    [anon_sym_static] = ACTIONS(3012),
    [anon_sym_abstract] = ACTIONS(3012),
    [anon_sym_get] = ACTIONS(3012),
    [anon_sym_set] = ACTIONS(3012),
    [anon_sym_declare] = ACTIONS(3012),
    [anon_sym_public] = ACTIONS(3012),
    [anon_sym_private] = ACTIONS(3012),
    [anon_sym_protected] = ACTIONS(3012),
    [anon_sym_module] = ACTIONS(3012),
    [anon_sym_any] = ACTIONS(3012),
    [anon_sym_number] = ACTIONS(3012),
    [anon_sym_boolean] = ACTIONS(3012),
    [anon_sym_string] = ACTIONS(3012),
    [anon_sym_symbol] = ACTIONS(3012),
    [anon_sym_interface] = ACTIONS(3012),
    [anon_sym_enum] = ACTIONS(3012),
    [sym_readonly] = ACTIONS(3012),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(3014),
    [sym_identifier] = ACTIONS(3016),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_yield] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [sym_this] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3014),
    [anon_sym_static] = ACTIONS(3016),
    [anon_sym_abstract] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_interface] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [sym_readonly] = ACTIONS(3016),
  },
  [583] = {
    [sym__call_signature] = STATE(3088),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_any] = ACTIONS(2903),
    [anon_sym_number] = ACTIONS(2903),
    [anon_sym_boolean] = ACTIONS(2903),
    [anon_sym_string] = ACTIONS(2903),
    [anon_sym_symbol] = ACTIONS(2903),
    [sym_readonly] = ACTIONS(2903),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(3018),
    [sym_identifier] = ACTIONS(3020),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_typeof] = ACTIONS(3020),
    [anon_sym_import] = ACTIONS(3020),
    [anon_sym_var] = ACTIONS(3020),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_else] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_await] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_with] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_debugger] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_yield] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_function] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3018),
    [anon_sym_void] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [sym_number] = ACTIONS(3018),
    [sym_this] = ACTIONS(3020),
    [sym_super] = ACTIONS(3020),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [sym_null] = ACTIONS(3020),
    [sym_undefined] = ACTIONS(3020),
    [anon_sym_AT] = ACTIONS(3018),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_abstract] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_interface] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [sym_readonly] = ACTIONS(3020),
  },
  [585] = {
    [sym__call_signature] = STATE(3088),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_function] = ACTIONS(3022),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_any] = ACTIONS(2903),
    [anon_sym_number] = ACTIONS(2903),
    [anon_sym_boolean] = ACTIONS(2903),
    [anon_sym_string] = ACTIONS(2903),
    [anon_sym_symbol] = ACTIONS(2903),
    [sym_readonly] = ACTIONS(2903),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(3024),
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_export] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_type] = ACTIONS(3026),
    [anon_sym_typeof] = ACTIONS(3026),
    [anon_sym_import] = ACTIONS(3026),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_with] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_debugger] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_yield] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_async] = ACTIONS(3026),
    [anon_sym_function] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [sym_number] = ACTIONS(3024),
    [sym_this] = ACTIONS(3026),
    [sym_super] = ACTIONS(3026),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [sym_null] = ACTIONS(3026),
    [sym_undefined] = ACTIONS(3026),
    [anon_sym_AT] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_abstract] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3026),
    [anon_sym_set] = ACTIONS(3026),
    [anon_sym_declare] = ACTIONS(3026),
    [anon_sym_public] = ACTIONS(3026),
    [anon_sym_private] = ACTIONS(3026),
    [anon_sym_protected] = ACTIONS(3026),
    [anon_sym_module] = ACTIONS(3026),
    [anon_sym_any] = ACTIONS(3026),
    [anon_sym_number] = ACTIONS(3026),
    [anon_sym_boolean] = ACTIONS(3026),
    [anon_sym_string] = ACTIONS(3026),
    [anon_sym_symbol] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [sym_readonly] = ACTIONS(3026),
  },
  [587] = {
    [sym__call_signature] = STATE(3193),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_as] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2788),
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_in] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2788),
    [anon_sym_GT] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_DOT] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2788),
    [anon_sym_GT_GT_GT] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_STAR_STAR] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2788),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_QMARK_QMARK] = ACTIONS(2786),
    [anon_sym_instanceof] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2788),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2786),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_export] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_type] = ACTIONS(3030),
    [anon_sym_typeof] = ACTIONS(3030),
    [anon_sym_import] = ACTIONS(3030),
    [anon_sym_var] = ACTIONS(3030),
    [anon_sym_let] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3028),
    [anon_sym_await] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_with] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_debugger] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_yield] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_LT] = ACTIONS(3028),
    [anon_sym_SLASH] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_async] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3006),
    [anon_sym_PIPE] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_void] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3028),
    [sym_number] = ACTIONS(3028),
    [sym_this] = ACTIONS(3030),
    [sym_super] = ACTIONS(3030),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [sym_null] = ACTIONS(3030),
    [sym_undefined] = ACTIONS(3030),
    [anon_sym_AT] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_abstract] = ACTIONS(3030),
    [anon_sym_get] = ACTIONS(3030),
    [anon_sym_set] = ACTIONS(3030),
    [anon_sym_declare] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_module] = ACTIONS(3030),
    [anon_sym_any] = ACTIONS(3030),
    [anon_sym_number] = ACTIONS(3030),
    [anon_sym_boolean] = ACTIONS(3030),
    [anon_sym_string] = ACTIONS(3030),
    [anon_sym_symbol] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [sym_readonly] = ACTIONS(3030),
  },
  [590] = {
    [sym__call_signature] = STATE(3007),
    [sym_arguments] = STATE(1641),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1496),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_export] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_type] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(3034),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_get] = ACTIONS(3034),
    [anon_sym_set] = ACTIONS(3034),
    [anon_sym_declare] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_module] = ACTIONS(3034),
    [anon_sym_any] = ACTIONS(3034),
    [anon_sym_number] = ACTIONS(3034),
    [anon_sym_boolean] = ACTIONS(3034),
    [anon_sym_string] = ACTIONS(3034),
    [anon_sym_symbol] = ACTIONS(3034),
    [sym_readonly] = ACTIONS(3034),
    [sym__automatic_semicolon] = ACTIONS(503),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [sym_this] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [592] = {
    [sym__call_signature] = STATE(3033),
    [sym_arguments] = STATE(1151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1084),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3036),
    [anon_sym_export] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_type] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_COLON] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3038),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(700),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_get] = ACTIONS(3038),
    [anon_sym_set] = ACTIONS(3038),
    [anon_sym_declare] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_module] = ACTIONS(3038),
    [anon_sym_any] = ACTIONS(3038),
    [anon_sym_number] = ACTIONS(3038),
    [anon_sym_boolean] = ACTIONS(3038),
    [anon_sym_string] = ACTIONS(3038),
    [anon_sym_symbol] = ACTIONS(3038),
    [sym_readonly] = ACTIONS(3038),
  },
  [593] = {
    [sym_object] = STATE(2502),
    [sym_array] = STATE(2503),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_export] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_get] = ACTIONS(3042),
    [anon_sym_set] = ACTIONS(3042),
    [anon_sym_declare] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_any] = ACTIONS(3042),
    [anon_sym_number] = ACTIONS(3042),
    [anon_sym_boolean] = ACTIONS(3042),
    [anon_sym_string] = ACTIONS(3042),
    [anon_sym_symbol] = ACTIONS(3042),
    [sym_readonly] = ACTIONS(3042),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(3049),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_default] = ACTIONS(3051),
    [anon_sym_namespace] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_type] = ACTIONS(3051),
    [anon_sym_typeof] = ACTIONS(3051),
    [anon_sym_import] = ACTIONS(3051),
    [anon_sym_var] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_else] = ACTIONS(3051),
    [anon_sym_switch] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3049),
    [anon_sym_await] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_with] = ACTIONS(3051),
    [anon_sym_break] = ACTIONS(3051),
    [anon_sym_continue] = ACTIONS(3051),
    [anon_sym_debugger] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_throw] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3051),
    [anon_sym_class] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_void] = ACTIONS(3051),
    [anon_sym_delete] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3049),
    [sym_number] = ACTIONS(3049),
    [sym_this] = ACTIONS(3051),
    [sym_super] = ACTIONS(3051),
    [sym_true] = ACTIONS(3051),
    [sym_false] = ACTIONS(3051),
    [sym_null] = ACTIONS(3051),
    [sym_undefined] = ACTIONS(3051),
    [anon_sym_AT] = ACTIONS(3049),
    [anon_sym_static] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_get] = ACTIONS(3051),
    [anon_sym_set] = ACTIONS(3051),
    [anon_sym_declare] = ACTIONS(3051),
    [anon_sym_public] = ACTIONS(3051),
    [anon_sym_private] = ACTIONS(3051),
    [anon_sym_protected] = ACTIONS(3051),
    [anon_sym_module] = ACTIONS(3051),
    [anon_sym_any] = ACTIONS(3051),
    [anon_sym_number] = ACTIONS(3051),
    [anon_sym_boolean] = ACTIONS(3051),
    [anon_sym_string] = ACTIONS(3051),
    [anon_sym_symbol] = ACTIONS(3051),
    [anon_sym_interface] = ACTIONS(3051),
    [anon_sym_enum] = ACTIONS(3051),
    [sym_readonly] = ACTIONS(3051),
  },
  [595] = {
    [sym__call_signature] = STATE(3151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_get] = ACTIONS(2974),
    [anon_sym_set] = ACTIONS(2974),
    [anon_sym_declare] = ACTIONS(2974),
    [anon_sym_public] = ACTIONS(2974),
    [anon_sym_private] = ACTIONS(2974),
    [anon_sym_protected] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_any] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2974),
    [anon_sym_string] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2974),
    [sym_readonly] = ACTIONS(2974),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3055),
    [anon_sym_default] = ACTIONS(3055),
    [anon_sym_namespace] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_RBRACE] = ACTIONS(3053),
    [anon_sym_type] = ACTIONS(3055),
    [anon_sym_typeof] = ACTIONS(3055),
    [anon_sym_import] = ACTIONS(3055),
    [anon_sym_var] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_else] = ACTIONS(3055),
    [anon_sym_switch] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_RPAREN] = ACTIONS(3053),
    [anon_sym_await] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_with] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_debugger] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_throw] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_case] = ACTIONS(3055),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_SLASH] = ACTIONS(3055),
    [anon_sym_class] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(3055),
    [anon_sym_delete] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3053),
    [sym_number] = ACTIONS(3053),
    [sym_this] = ACTIONS(3055),
    [sym_super] = ACTIONS(3055),
    [sym_true] = ACTIONS(3055),
    [sym_false] = ACTIONS(3055),
    [sym_null] = ACTIONS(3055),
    [sym_undefined] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3053),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_get] = ACTIONS(3055),
    [anon_sym_set] = ACTIONS(3055),
    [anon_sym_declare] = ACTIONS(3055),
    [anon_sym_public] = ACTIONS(3055),
    [anon_sym_private] = ACTIONS(3055),
    [anon_sym_protected] = ACTIONS(3055),
    [anon_sym_module] = ACTIONS(3055),
    [anon_sym_any] = ACTIONS(3055),
    [anon_sym_number] = ACTIONS(3055),
    [anon_sym_boolean] = ACTIONS(3055),
    [anon_sym_string] = ACTIONS(3055),
    [anon_sym_symbol] = ACTIONS(3055),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [sym_readonly] = ACTIONS(3055),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(3057),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(3059),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_namespace] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3057),
    [anon_sym_type] = ACTIONS(3059),
    [anon_sym_typeof] = ACTIONS(3059),
    [anon_sym_import] = ACTIONS(3059),
    [anon_sym_var] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_await] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_debugger] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_throw] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_case] = ACTIONS(3059),
    [anon_sym_finally] = ACTIONS(3059),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_SLASH] = ACTIONS(3059),
    [anon_sym_class] = ACTIONS(3059),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_void] = ACTIONS(3059),
    [anon_sym_delete] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3057),
    [anon_sym_DASH_DASH] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3057),
    [sym_number] = ACTIONS(3057),
    [sym_this] = ACTIONS(3059),
    [sym_super] = ACTIONS(3059),
    [sym_true] = ACTIONS(3059),
    [sym_false] = ACTIONS(3059),
    [sym_null] = ACTIONS(3059),
    [sym_undefined] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3057),
    [anon_sym_static] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_get] = ACTIONS(3059),
    [anon_sym_set] = ACTIONS(3059),
    [anon_sym_declare] = ACTIONS(3059),
    [anon_sym_public] = ACTIONS(3059),
    [anon_sym_private] = ACTIONS(3059),
    [anon_sym_protected] = ACTIONS(3059),
    [anon_sym_module] = ACTIONS(3059),
    [anon_sym_any] = ACTIONS(3059),
    [anon_sym_number] = ACTIONS(3059),
    [anon_sym_boolean] = ACTIONS(3059),
    [anon_sym_string] = ACTIONS(3059),
    [anon_sym_symbol] = ACTIONS(3059),
    [anon_sym_interface] = ACTIONS(3059),
    [anon_sym_enum] = ACTIONS(3059),
    [sym_readonly] = ACTIONS(3059),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(3061),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_export] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_type] = ACTIONS(3063),
    [anon_sym_typeof] = ACTIONS(3063),
    [anon_sym_import] = ACTIONS(3063),
    [anon_sym_var] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_await] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_with] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_debugger] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_finally] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_SLASH] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_async] = ACTIONS(3063),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_void] = ACTIONS(3063),
    [anon_sym_delete] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3061),
    [sym_number] = ACTIONS(3061),
    [sym_this] = ACTIONS(3063),
    [sym_super] = ACTIONS(3063),
    [sym_true] = ACTIONS(3063),
    [sym_false] = ACTIONS(3063),
    [sym_null] = ACTIONS(3063),
    [sym_undefined] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3061),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_get] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(3063),
    [anon_sym_declare] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_module] = ACTIONS(3063),
    [anon_sym_any] = ACTIONS(3063),
    [anon_sym_number] = ACTIONS(3063),
    [anon_sym_boolean] = ACTIONS(3063),
    [anon_sym_string] = ACTIONS(3063),
    [anon_sym_symbol] = ACTIONS(3063),
    [anon_sym_interface] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [sym_readonly] = ACTIONS(3063),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_type] = ACTIONS(3067),
    [anon_sym_typeof] = ACTIONS(3067),
    [anon_sym_import] = ACTIONS(3067),
    [anon_sym_var] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_else] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_await] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_debugger] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_finally] = ACTIONS(3067),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_void] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3065),
    [sym_number] = ACTIONS(3065),
    [sym_this] = ACTIONS(3067),
    [sym_super] = ACTIONS(3067),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [sym_null] = ACTIONS(3067),
    [sym_undefined] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3065),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_get] = ACTIONS(3067),
    [anon_sym_set] = ACTIONS(3067),
    [anon_sym_declare] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_module] = ACTIONS(3067),
    [anon_sym_any] = ACTIONS(3067),
    [anon_sym_number] = ACTIONS(3067),
    [anon_sym_boolean] = ACTIONS(3067),
    [anon_sym_string] = ACTIONS(3067),
    [anon_sym_symbol] = ACTIONS(3067),
    [anon_sym_interface] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [sym_readonly] = ACTIONS(3067),
  },
  [600] = {
    [sym__call_signature] = STATE(3151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_get] = ACTIONS(2974),
    [anon_sym_set] = ACTIONS(2974),
    [anon_sym_declare] = ACTIONS(2974),
    [anon_sym_public] = ACTIONS(2974),
    [anon_sym_private] = ACTIONS(2974),
    [anon_sym_protected] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_any] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2974),
    [anon_sym_string] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2974),
    [sym_readonly] = ACTIONS(2974),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(1239),
    [anon_sym_namespace] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1239),
    [anon_sym_typeof] = ACTIONS(1239),
    [anon_sym_import] = ACTIONS(1239),
    [anon_sym_var] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1239),
    [anon_sym_const] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1239),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1239),
    [anon_sym_debugger] = ACTIONS(1239),
    [anon_sym_return] = ACTIONS(1239),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_class] = ACTIONS(1239),
    [anon_sym_async] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_new] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1239),
    [anon_sym_delete] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_number] = ACTIONS(1237),
    [sym_this] = ACTIONS(1239),
    [sym_super] = ACTIONS(1239),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_null] = ACTIONS(1239),
    [sym_undefined] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1239),
    [anon_sym_abstract] = ACTIONS(1239),
    [anon_sym_get] = ACTIONS(1239),
    [anon_sym_set] = ACTIONS(1239),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_public] = ACTIONS(1239),
    [anon_sym_private] = ACTIONS(1239),
    [anon_sym_protected] = ACTIONS(1239),
    [anon_sym_module] = ACTIONS(1239),
    [anon_sym_any] = ACTIONS(1239),
    [anon_sym_number] = ACTIONS(1239),
    [anon_sym_boolean] = ACTIONS(1239),
    [anon_sym_string] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1239),
    [anon_sym_enum] = ACTIONS(1239),
    [sym_readonly] = ACTIONS(1239),
    [sym__automatic_semicolon] = ACTIONS(1245),
  },
  [602] = {
    [sym__call_signature] = STATE(3009),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2980),
    [anon_sym_export] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_async] = ACTIONS(2982),
    [anon_sym_function] = ACTIONS(2986),
    [anon_sym_EQ_GT] = ACTIONS(693),
    [anon_sym_PLUS_EQ] = ACTIONS(734),
    [anon_sym_DASH_EQ] = ACTIONS(734),
    [anon_sym_STAR_EQ] = ACTIONS(734),
    [anon_sym_SLASH_EQ] = ACTIONS(734),
    [anon_sym_PERCENT_EQ] = ACTIONS(734),
    [anon_sym_CARET_EQ] = ACTIONS(734),
    [anon_sym_AMP_EQ] = ACTIONS(734),
    [anon_sym_PIPE_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(734),
    [anon_sym_LT_LT_EQ] = ACTIONS(734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(734),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_get] = ACTIONS(2982),
    [anon_sym_set] = ACTIONS(2982),
    [anon_sym_declare] = ACTIONS(2982),
    [anon_sym_public] = ACTIONS(2982),
    [anon_sym_private] = ACTIONS(2982),
    [anon_sym_protected] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_any] = ACTIONS(2982),
    [anon_sym_number] = ACTIONS(2982),
    [anon_sym_boolean] = ACTIONS(2982),
    [anon_sym_string] = ACTIONS(2982),
    [anon_sym_symbol] = ACTIONS(2982),
    [sym_readonly] = ACTIONS(2982),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(1313),
    [sym_identifier] = ACTIONS(1315),
    [anon_sym_export] = ACTIONS(1315),
    [anon_sym_default] = ACTIONS(1315),
    [anon_sym_namespace] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1313),
    [anon_sym_RBRACE] = ACTIONS(1313),
    [anon_sym_type] = ACTIONS(1315),
    [anon_sym_typeof] = ACTIONS(1315),
    [anon_sym_import] = ACTIONS(1315),
    [anon_sym_var] = ACTIONS(1315),
    [anon_sym_let] = ACTIONS(1315),
    [anon_sym_const] = ACTIONS(1315),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_else] = ACTIONS(1315),
    [anon_sym_switch] = ACTIONS(1315),
    [anon_sym_for] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_while] = ACTIONS(1315),
    [anon_sym_do] = ACTIONS(1315),
    [anon_sym_try] = ACTIONS(1315),
    [anon_sym_with] = ACTIONS(1315),
    [anon_sym_break] = ACTIONS(1315),
    [anon_sym_continue] = ACTIONS(1315),
    [anon_sym_debugger] = ACTIONS(1315),
    [anon_sym_return] = ACTIONS(1315),
    [anon_sym_throw] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1315),
    [anon_sym_yield] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_LT] = ACTIONS(1313),
    [anon_sym_SLASH] = ACTIONS(1315),
    [anon_sym_class] = ACTIONS(1315),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_function] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(1315),
    [anon_sym_PLUS] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [anon_sym_void] = ACTIONS(1315),
    [anon_sym_delete] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(1313),
    [anon_sym_SQUOTE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1313),
    [sym_number] = ACTIONS(1313),
    [sym_this] = ACTIONS(1315),
    [sym_super] = ACTIONS(1315),
    [sym_true] = ACTIONS(1315),
    [sym_false] = ACTIONS(1315),
    [sym_null] = ACTIONS(1315),
    [sym_undefined] = ACTIONS(1315),
    [anon_sym_AT] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1315),
    [anon_sym_abstract] = ACTIONS(1315),
    [anon_sym_get] = ACTIONS(1315),
    [anon_sym_set] = ACTIONS(1315),
    [anon_sym_declare] = ACTIONS(1315),
    [anon_sym_public] = ACTIONS(1315),
    [anon_sym_private] = ACTIONS(1315),
    [anon_sym_protected] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(1315),
    [anon_sym_any] = ACTIONS(1315),
    [anon_sym_number] = ACTIONS(1315),
    [anon_sym_boolean] = ACTIONS(1315),
    [anon_sym_string] = ACTIONS(1315),
    [anon_sym_symbol] = ACTIONS(1315),
    [anon_sym_interface] = ACTIONS(1315),
    [anon_sym_enum] = ACTIONS(1315),
    [sym_readonly] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1321),
  },
  [604] = {
    [sym__call_signature] = STATE(3048),
    [sym_arguments] = STATE(1151),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_arguments] = STATE(1084),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_type] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_RBRACK] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(495),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_STAR_STAR] = ACTIONS(495),
    [anon_sym_LT_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(503),
    [anon_sym_GT_EQ] = ACTIONS(503),
    [anon_sym_QMARK_QMARK] = ACTIONS(503),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_void] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_get] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(3071),
    [anon_sym_declare] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_any] = ACTIONS(3071),
    [anon_sym_number] = ACTIONS(3071),
    [anon_sym_boolean] = ACTIONS(3071),
    [anon_sym_string] = ACTIONS(3071),
    [anon_sym_symbol] = ACTIONS(3071),
    [sym_readonly] = ACTIONS(3071),
  },
  [605] = {
    [sym__call_signature] = STATE(3193),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(604),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(1371),
    [sym_identifier] = ACTIONS(1373),
    [anon_sym_export] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_namespace] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_type] = ACTIONS(1373),
    [anon_sym_typeof] = ACTIONS(1373),
    [anon_sym_import] = ACTIONS(1373),
    [anon_sym_var] = ACTIONS(1373),
    [anon_sym_let] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_try] = ACTIONS(1373),
    [anon_sym_with] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_debugger] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_throw] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_yield] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_SLASH] = ACTIONS(1373),
    [anon_sym_class] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1373),
    [anon_sym_function] = ACTIONS(1373),
    [anon_sym_new] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1371),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_delete] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [sym_number] = ACTIONS(1371),
    [sym_this] = ACTIONS(1373),
    [sym_super] = ACTIONS(1373),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_undefined] = ACTIONS(1373),
    [anon_sym_AT] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_abstract] = ACTIONS(1373),
    [anon_sym_get] = ACTIONS(1373),
    [anon_sym_set] = ACTIONS(1373),
    [anon_sym_declare] = ACTIONS(1373),
    [anon_sym_public] = ACTIONS(1373),
    [anon_sym_private] = ACTIONS(1373),
    [anon_sym_protected] = ACTIONS(1373),
    [anon_sym_module] = ACTIONS(1373),
    [anon_sym_any] = ACTIONS(1373),
    [anon_sym_number] = ACTIONS(1373),
    [anon_sym_boolean] = ACTIONS(1373),
    [anon_sym_string] = ACTIONS(1373),
    [anon_sym_symbol] = ACTIONS(1373),
    [anon_sym_interface] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [sym_readonly] = ACTIONS(1373),
    [sym__automatic_semicolon] = ACTIONS(1379),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1225),
    [anon_sym_export] = ACTIONS(1225),
    [anon_sym_default] = ACTIONS(1225),
    [anon_sym_namespace] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_type] = ACTIONS(1225),
    [anon_sym_typeof] = ACTIONS(1225),
    [anon_sym_import] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(1225),
    [anon_sym_let] = ACTIONS(1225),
    [anon_sym_const] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_await] = ACTIONS(1225),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_do] = ACTIONS(1225),
    [anon_sym_try] = ACTIONS(1225),
    [anon_sym_with] = ACTIONS(1225),
    [anon_sym_break] = ACTIONS(1225),
    [anon_sym_continue] = ACTIONS(1225),
    [anon_sym_debugger] = ACTIONS(1225),
    [anon_sym_return] = ACTIONS(1225),
    [anon_sym_throw] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_case] = ACTIONS(1225),
    [anon_sym_yield] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1225),
    [anon_sym_class] = ACTIONS(1225),
    [anon_sym_async] = ACTIONS(1225),
    [anon_sym_function] = ACTIONS(1225),
    [anon_sym_new] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1225),
    [anon_sym_DASH] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_TILDE] = ACTIONS(1223),
    [anon_sym_void] = ACTIONS(1225),
    [anon_sym_delete] = ACTIONS(1225),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1223),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym_number] = ACTIONS(1223),
    [sym_this] = ACTIONS(1225),
    [sym_super] = ACTIONS(1225),
    [sym_true] = ACTIONS(1225),
    [sym_false] = ACTIONS(1225),
    [sym_null] = ACTIONS(1225),
    [sym_undefined] = ACTIONS(1225),
    [anon_sym_AT] = ACTIONS(1223),
    [anon_sym_static] = ACTIONS(1225),
    [anon_sym_abstract] = ACTIONS(1225),
    [anon_sym_get] = ACTIONS(1225),
    [anon_sym_set] = ACTIONS(1225),
    [anon_sym_declare] = ACTIONS(1225),
    [anon_sym_public] = ACTIONS(1225),
    [anon_sym_private] = ACTIONS(1225),
    [anon_sym_protected] = ACTIONS(1225),
    [anon_sym_module] = ACTIONS(1225),
    [anon_sym_any] = ACTIONS(1225),
    [anon_sym_number] = ACTIONS(1225),
    [anon_sym_boolean] = ACTIONS(1225),
    [anon_sym_string] = ACTIONS(1225),
    [anon_sym_symbol] = ACTIONS(1225),
    [anon_sym_interface] = ACTIONS(1225),
    [anon_sym_enum] = ACTIONS(1225),
    [sym_readonly] = ACTIONS(1225),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(3073),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_var] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_await] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_debugger] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_finally] = ACTIONS(3075),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_SLASH] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_void] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3073),
    [sym_number] = ACTIONS(3073),
    [sym_this] = ACTIONS(3075),
    [sym_super] = ACTIONS(3075),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [sym_null] = ACTIONS(3075),
    [sym_undefined] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3073),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_interface] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [sym_readonly] = ACTIONS(3075),
  },
  [609] = {
    [sym_statement_block] = STATE(665),
    [ts_builtin_sym_end] = ACTIONS(1205),
    [sym_identifier] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [anon_sym_default] = ACTIONS(1207),
    [anon_sym_namespace] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_type] = ACTIONS(1207),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_import] = ACTIONS(1207),
    [anon_sym_var] = ACTIONS(1207),
    [anon_sym_let] = ACTIONS(1207),
    [anon_sym_const] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1207),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_await] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_do] = ACTIONS(1207),
    [anon_sym_try] = ACTIONS(1207),
    [anon_sym_with] = ACTIONS(1207),
    [anon_sym_break] = ACTIONS(1207),
    [anon_sym_continue] = ACTIONS(1207),
    [anon_sym_debugger] = ACTIONS(1207),
    [anon_sym_return] = ACTIONS(1207),
    [anon_sym_throw] = ACTIONS(1207),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_case] = ACTIONS(1207),
    [anon_sym_yield] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_class] = ACTIONS(1207),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_function] = ACTIONS(1207),
    [anon_sym_new] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym_number] = ACTIONS(1205),
    [sym_this] = ACTIONS(1207),
    [sym_super] = ACTIONS(1207),
    [sym_true] = ACTIONS(1207),
    [sym_false] = ACTIONS(1207),
    [sym_null] = ACTIONS(1207),
    [sym_undefined] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_abstract] = ACTIONS(1207),
    [anon_sym_get] = ACTIONS(1207),
    [anon_sym_set] = ACTIONS(1207),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(1207),
    [anon_sym_private] = ACTIONS(1207),
    [anon_sym_protected] = ACTIONS(1207),
    [anon_sym_module] = ACTIONS(1207),
    [anon_sym_any] = ACTIONS(1207),
    [anon_sym_number] = ACTIONS(1207),
    [anon_sym_boolean] = ACTIONS(1207),
    [anon_sym_string] = ACTIONS(1207),
    [anon_sym_symbol] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1207),
    [anon_sym_enum] = ACTIONS(1207),
    [sym_readonly] = ACTIONS(1207),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(1299),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_namespace] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_type] = ACTIONS(1301),
    [anon_sym_typeof] = ACTIONS(1301),
    [anon_sym_import] = ACTIONS(1301),
    [anon_sym_var] = ACTIONS(1301),
    [anon_sym_let] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [anon_sym_await] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_try] = ACTIONS(1301),
    [anon_sym_with] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_debugger] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_throw] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_yield] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_class] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1301),
    [anon_sym_function] = ACTIONS(1301),
    [anon_sym_new] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_void] = ACTIONS(1301),
    [anon_sym_delete] = ACTIONS(1301),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1299),
    [sym_number] = ACTIONS(1299),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(1301),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_AT] = ACTIONS(1299),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_abstract] = ACTIONS(1301),
    [anon_sym_get] = ACTIONS(1301),
    [anon_sym_set] = ACTIONS(1301),
    [anon_sym_declare] = ACTIONS(1301),
    [anon_sym_public] = ACTIONS(1301),
    [anon_sym_private] = ACTIONS(1301),
    [anon_sym_protected] = ACTIONS(1301),
    [anon_sym_module] = ACTIONS(1301),
    [anon_sym_any] = ACTIONS(1301),
    [anon_sym_number] = ACTIONS(1301),
    [anon_sym_boolean] = ACTIONS(1301),
    [anon_sym_string] = ACTIONS(1301),
    [anon_sym_symbol] = ACTIONS(1301),
    [anon_sym_interface] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [sym_readonly] = ACTIONS(1301),
    [sym__automatic_semicolon] = ACTIONS(1307),
  },
  [611] = {
    [sym__call_signature] = STATE(3193),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2917),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_export] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_namespace] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1327),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_type] = ACTIONS(1329),
    [anon_sym_typeof] = ACTIONS(1329),
    [anon_sym_import] = ACTIONS(1329),
    [anon_sym_var] = ACTIONS(1329),
    [anon_sym_let] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_LPAREN] = ACTIONS(1327),
    [anon_sym_await] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_try] = ACTIONS(1329),
    [anon_sym_with] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_debugger] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_throw] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_yield] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_SLASH] = ACTIONS(1329),
    [anon_sym_class] = ACTIONS(1329),
    [anon_sym_async] = ACTIONS(1329),
    [anon_sym_function] = ACTIONS(1329),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1327),
    [anon_sym_void] = ACTIONS(1329),
    [anon_sym_delete] = ACTIONS(1329),
    [anon_sym_PLUS_PLUS] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1327),
    [sym_number] = ACTIONS(1327),
    [sym_this] = ACTIONS(1329),
    [sym_super] = ACTIONS(1329),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [sym_null] = ACTIONS(1329),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_abstract] = ACTIONS(1329),
    [anon_sym_get] = ACTIONS(1329),
    [anon_sym_set] = ACTIONS(1329),
    [anon_sym_declare] = ACTIONS(1329),
    [anon_sym_public] = ACTIONS(1329),
    [anon_sym_private] = ACTIONS(1329),
    [anon_sym_protected] = ACTIONS(1329),
    [anon_sym_module] = ACTIONS(1329),
    [anon_sym_any] = ACTIONS(1329),
    [anon_sym_number] = ACTIONS(1329),
    [anon_sym_boolean] = ACTIONS(1329),
    [anon_sym_string] = ACTIONS(1329),
    [anon_sym_symbol] = ACTIONS(1329),
    [anon_sym_interface] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [sym_readonly] = ACTIONS(1329),
    [sym__automatic_semicolon] = ACTIONS(1335),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(1289),
    [sym_identifier] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1291),
    [anon_sym_default] = ACTIONS(1291),
    [anon_sym_namespace] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1289),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_type] = ACTIONS(1291),
    [anon_sym_typeof] = ACTIONS(1291),
    [anon_sym_import] = ACTIONS(1291),
    [anon_sym_var] = ACTIONS(1291),
    [anon_sym_let] = ACTIONS(1291),
    [anon_sym_const] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_switch] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_await] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_try] = ACTIONS(1291),
    [anon_sym_with] = ACTIONS(1291),
    [anon_sym_break] = ACTIONS(1291),
    [anon_sym_continue] = ACTIONS(1291),
    [anon_sym_debugger] = ACTIONS(1291),
    [anon_sym_return] = ACTIONS(1291),
    [anon_sym_throw] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1291),
    [anon_sym_yield] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1289),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_class] = ACTIONS(1291),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(1291),
    [anon_sym_new] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [anon_sym_void] = ACTIONS(1291),
    [anon_sym_delete] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(1289),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [sym_number] = ACTIONS(1289),
    [sym_this] = ACTIONS(1291),
    [sym_super] = ACTIONS(1291),
    [sym_true] = ACTIONS(1291),
    [sym_false] = ACTIONS(1291),
    [sym_null] = ACTIONS(1291),
    [sym_undefined] = ACTIONS(1291),
    [anon_sym_AT] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_abstract] = ACTIONS(1291),
    [anon_sym_get] = ACTIONS(1291),
    [anon_sym_set] = ACTIONS(1291),
    [anon_sym_declare] = ACTIONS(1291),
    [anon_sym_public] = ACTIONS(1291),
    [anon_sym_private] = ACTIONS(1291),
    [anon_sym_protected] = ACTIONS(1291),
    [anon_sym_module] = ACTIONS(1291),
    [anon_sym_any] = ACTIONS(1291),
    [anon_sym_number] = ACTIONS(1291),
    [anon_sym_boolean] = ACTIONS(1291),
    [anon_sym_string] = ACTIONS(1291),
    [anon_sym_symbol] = ACTIONS(1291),
    [anon_sym_interface] = ACTIONS(1291),
    [anon_sym_enum] = ACTIONS(1291),
    [sym_readonly] = ACTIONS(1291),
    [sym__automatic_semicolon] = ACTIONS(1297),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1277),
    [anon_sym_export] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_namespace] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_type] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1277),
    [anon_sym_import] = ACTIONS(1277),
    [anon_sym_var] = ACTIONS(1277),
    [anon_sym_let] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_await] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_try] = ACTIONS(1277),
    [anon_sym_with] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_debugger] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_throw] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_yield] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1277),
    [anon_sym_class] = ACTIONS(1277),
    [anon_sym_async] = ACTIONS(1277),
    [anon_sym_function] = ACTIONS(1277),
    [anon_sym_new] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_void] = ACTIONS(1277),
    [anon_sym_delete] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1275),
    [sym_number] = ACTIONS(1275),
    [sym_this] = ACTIONS(1277),
    [sym_super] = ACTIONS(1277),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [sym_null] = ACTIONS(1277),
    [sym_undefined] = ACTIONS(1277),
    [anon_sym_AT] = ACTIONS(1275),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_abstract] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(1277),
    [anon_sym_set] = ACTIONS(1277),
    [anon_sym_declare] = ACTIONS(1277),
    [anon_sym_public] = ACTIONS(1277),
    [anon_sym_private] = ACTIONS(1277),
    [anon_sym_protected] = ACTIONS(1277),
    [anon_sym_module] = ACTIONS(1277),
    [anon_sym_any] = ACTIONS(1277),
    [anon_sym_number] = ACTIONS(1277),
    [anon_sym_boolean] = ACTIONS(1277),
    [anon_sym_string] = ACTIONS(1277),
    [anon_sym_symbol] = ACTIONS(1277),
    [anon_sym_interface] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [sym_readonly] = ACTIONS(1277),
    [sym__automatic_semicolon] = ACTIONS(1283),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1221),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(1357),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_default] = ACTIONS(1359),
    [anon_sym_namespace] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1359),
    [anon_sym_typeof] = ACTIONS(1359),
    [anon_sym_import] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_let] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_await] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_try] = ACTIONS(1359),
    [anon_sym_with] = ACTIONS(1359),
    [anon_sym_break] = ACTIONS(1359),
    [anon_sym_continue] = ACTIONS(1359),
    [anon_sym_debugger] = ACTIONS(1359),
    [anon_sym_return] = ACTIONS(1359),
    [anon_sym_throw] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1359),
    [anon_sym_yield] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_class] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_function] = ACTIONS(1359),
    [anon_sym_new] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_TILDE] = ACTIONS(1357),
    [anon_sym_void] = ACTIONS(1359),
    [anon_sym_delete] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1357),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [anon_sym_SQUOTE] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1357),
    [sym_number] = ACTIONS(1357),
    [sym_this] = ACTIONS(1359),
    [sym_super] = ACTIONS(1359),
    [sym_true] = ACTIONS(1359),
    [sym_false] = ACTIONS(1359),
    [sym_null] = ACTIONS(1359),
    [sym_undefined] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_abstract] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(1359),
    [anon_sym_set] = ACTIONS(1359),
    [anon_sym_declare] = ACTIONS(1359),
    [anon_sym_public] = ACTIONS(1359),
    [anon_sym_private] = ACTIONS(1359),
    [anon_sym_protected] = ACTIONS(1359),
    [anon_sym_module] = ACTIONS(1359),
    [anon_sym_any] = ACTIONS(1359),
    [anon_sym_number] = ACTIONS(1359),
    [anon_sym_boolean] = ACTIONS(1359),
    [anon_sym_string] = ACTIONS(1359),
    [anon_sym_symbol] = ACTIONS(1359),
    [anon_sym_interface] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [sym_readonly] = ACTIONS(1359),
    [sym__automatic_semicolon] = ACTIONS(1365),
  },
  [617] = {
    [sym_object] = STATE(2502),
    [sym_array] = STATE(2503),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_export] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3042),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_get] = ACTIONS(3042),
    [anon_sym_set] = ACTIONS(3042),
    [anon_sym_declare] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_any] = ACTIONS(3042),
    [anon_sym_number] = ACTIONS(3042),
    [anon_sym_boolean] = ACTIONS(3042),
    [anon_sym_string] = ACTIONS(3042),
    [anon_sym_symbol] = ACTIONS(3042),
    [sym_readonly] = ACTIONS(3042),
  },
  [618] = {
    [sym__call_signature] = STATE(3141),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(606),
    [anon_sym_PLUS_EQ] = ACTIONS(786),
    [anon_sym_DASH_EQ] = ACTIONS(786),
    [anon_sym_STAR_EQ] = ACTIONS(786),
    [anon_sym_SLASH_EQ] = ACTIONS(786),
    [anon_sym_PERCENT_EQ] = ACTIONS(786),
    [anon_sym_CARET_EQ] = ACTIONS(786),
    [anon_sym_AMP_EQ] = ACTIONS(786),
    [anon_sym_PIPE_EQ] = ACTIONS(786),
    [anon_sym_GT_GT_EQ] = ACTIONS(786),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(786),
    [anon_sym_LT_LT_EQ] = ACTIONS(786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_get] = ACTIONS(2931),
    [anon_sym_set] = ACTIONS(2931),
    [anon_sym_declare] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_any] = ACTIONS(2931),
    [anon_sym_number] = ACTIONS(2931),
    [anon_sym_boolean] = ACTIONS(2931),
    [anon_sym_string] = ACTIONS(2931),
    [anon_sym_symbol] = ACTIONS(2931),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(2931),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_export] = ACTIONS(1339),
    [anon_sym_default] = ACTIONS(1339),
    [anon_sym_namespace] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_type] = ACTIONS(1339),
    [anon_sym_typeof] = ACTIONS(1339),
    [anon_sym_import] = ACTIONS(1339),
    [anon_sym_var] = ACTIONS(1339),
    [anon_sym_let] = ACTIONS(1339),
    [anon_sym_const] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [anon_sym_switch] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_await] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_do] = ACTIONS(1339),
    [anon_sym_try] = ACTIONS(1339),
    [anon_sym_with] = ACTIONS(1339),
    [anon_sym_break] = ACTIONS(1339),
    [anon_sym_continue] = ACTIONS(1339),
    [anon_sym_debugger] = ACTIONS(1339),
    [anon_sym_return] = ACTIONS(1339),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1339),
    [anon_sym_yield] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_class] = ACTIONS(1339),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_function] = ACTIONS(1339),
    [anon_sym_new] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1337),
    [anon_sym_TILDE] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(1339),
    [anon_sym_delete] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1337),
    [anon_sym_DQUOTE] = ACTIONS(1337),
    [anon_sym_SQUOTE] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1337),
    [sym_number] = ACTIONS(1337),
    [sym_this] = ACTIONS(1339),
    [sym_super] = ACTIONS(1339),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_undefined] = ACTIONS(1339),
    [anon_sym_AT] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1339),
    [anon_sym_abstract] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(1339),
    [anon_sym_set] = ACTIONS(1339),
    [anon_sym_declare] = ACTIONS(1339),
    [anon_sym_public] = ACTIONS(1339),
    [anon_sym_private] = ACTIONS(1339),
    [anon_sym_protected] = ACTIONS(1339),
    [anon_sym_module] = ACTIONS(1339),
    [anon_sym_any] = ACTIONS(1339),
    [anon_sym_number] = ACTIONS(1339),
    [anon_sym_boolean] = ACTIONS(1339),
    [anon_sym_string] = ACTIONS(1339),
    [anon_sym_symbol] = ACTIONS(1339),
    [anon_sym_interface] = ACTIONS(1339),
    [anon_sym_enum] = ACTIONS(1339),
    [sym_readonly] = ACTIONS(1339),
    [sym__automatic_semicolon] = ACTIONS(1345),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(3077),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_export] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_type] = ACTIONS(3079),
    [anon_sym_typeof] = ACTIONS(3079),
    [anon_sym_import] = ACTIONS(3079),
    [anon_sym_var] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_else] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [anon_sym_await] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_with] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_debugger] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_SLASH] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_async] = ACTIONS(3079),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_void] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3077),
    [sym_number] = ACTIONS(3077),
    [sym_this] = ACTIONS(3079),
    [sym_super] = ACTIONS(3079),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [sym_null] = ACTIONS(3079),
    [sym_undefined] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3077),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_abstract] = ACTIONS(3079),
    [anon_sym_get] = ACTIONS(3079),
    [anon_sym_set] = ACTIONS(3079),
    [anon_sym_declare] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_module] = ACTIONS(3079),
    [anon_sym_any] = ACTIONS(3079),
    [anon_sym_number] = ACTIONS(3079),
    [anon_sym_boolean] = ACTIONS(3079),
    [anon_sym_string] = ACTIONS(3079),
    [anon_sym_symbol] = ACTIONS(3079),
    [anon_sym_interface] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [sym_readonly] = ACTIONS(3079),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(3081),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_export] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_type] = ACTIONS(3083),
    [anon_sym_typeof] = ACTIONS(3083),
    [anon_sym_import] = ACTIONS(3083),
    [anon_sym_var] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_else] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_await] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_with] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_debugger] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_SLASH] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3083),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_void] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3081),
    [sym_number] = ACTIONS(3081),
    [sym_this] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [sym_null] = ACTIONS(3083),
    [sym_undefined] = ACTIONS(3083),
    [anon_sym_AT] = ACTIONS(3081),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_get] = ACTIONS(3083),
    [anon_sym_set] = ACTIONS(3083),
    [anon_sym_declare] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_module] = ACTIONS(3083),
    [anon_sym_any] = ACTIONS(3083),
    [anon_sym_number] = ACTIONS(3083),
    [anon_sym_boolean] = ACTIONS(3083),
    [anon_sym_string] = ACTIONS(3083),
    [anon_sym_symbol] = ACTIONS(3083),
    [anon_sym_interface] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [sym_readonly] = ACTIONS(3083),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(3085),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_export] = ACTIONS(3087),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_type] = ACTIONS(3087),
    [anon_sym_typeof] = ACTIONS(3087),
    [anon_sym_import] = ACTIONS(3087),
    [anon_sym_var] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_const] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [anon_sym_switch] = ACTIONS(3087),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_await] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_with] = ACTIONS(3087),
    [anon_sym_break] = ACTIONS(3087),
    [anon_sym_continue] = ACTIONS(3087),
    [anon_sym_debugger] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_throw] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_case] = ACTIONS(3087),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3087),
    [anon_sym_class] = ACTIONS(3087),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_void] = ACTIONS(3087),
    [anon_sym_delete] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3085),
    [sym_number] = ACTIONS(3085),
    [sym_this] = ACTIONS(3087),
    [sym_super] = ACTIONS(3087),
    [sym_true] = ACTIONS(3087),
    [sym_false] = ACTIONS(3087),
    [sym_null] = ACTIONS(3087),
    [sym_undefined] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3085),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_get] = ACTIONS(3087),
    [anon_sym_set] = ACTIONS(3087),
    [anon_sym_declare] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_module] = ACTIONS(3087),
    [anon_sym_any] = ACTIONS(3087),
    [anon_sym_number] = ACTIONS(3087),
    [anon_sym_boolean] = ACTIONS(3087),
    [anon_sym_string] = ACTIONS(3087),
    [anon_sym_symbol] = ACTIONS(3087),
    [anon_sym_interface] = ACTIONS(3087),
    [anon_sym_enum] = ACTIONS(3087),
    [sym_readonly] = ACTIONS(3087),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(3089),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_export] = ACTIONS(3091),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_type] = ACTIONS(3091),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym_import] = ACTIONS(3091),
    [anon_sym_var] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_else] = ACTIONS(3091),
    [anon_sym_switch] = ACTIONS(3091),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_with] = ACTIONS(3091),
    [anon_sym_break] = ACTIONS(3091),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_debugger] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_throw] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_case] = ACTIONS(3091),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_SLASH] = ACTIONS(3091),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_delete] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3089),
    [sym_number] = ACTIONS(3089),
    [sym_this] = ACTIONS(3091),
    [sym_super] = ACTIONS(3091),
    [sym_true] = ACTIONS(3091),
    [sym_false] = ACTIONS(3091),
    [sym_null] = ACTIONS(3091),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(3089),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3091),
    [anon_sym_get] = ACTIONS(3091),
    [anon_sym_set] = ACTIONS(3091),
    [anon_sym_declare] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_module] = ACTIONS(3091),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_interface] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [sym_readonly] = ACTIONS(3091),
  },
  [624] = {
    [ts_builtin_sym_end] = ACTIONS(3093),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_export] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_typeof] = ACTIONS(3095),
    [anon_sym_import] = ACTIONS(3095),
    [anon_sym_var] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_const] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_switch] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_await] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_with] = ACTIONS(3095),
    [anon_sym_break] = ACTIONS(3095),
    [anon_sym_continue] = ACTIONS(3095),
    [anon_sym_debugger] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_throw] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_case] = ACTIONS(3095),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_SLASH] = ACTIONS(3095),
    [anon_sym_class] = ACTIONS(3095),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_void] = ACTIONS(3095),
    [anon_sym_delete] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3093),
    [sym_this] = ACTIONS(3095),
    [sym_super] = ACTIONS(3095),
    [sym_true] = ACTIONS(3095),
    [sym_false] = ACTIONS(3095),
    [sym_null] = ACTIONS(3095),
    [sym_undefined] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3093),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3095),
    [anon_sym_get] = ACTIONS(3095),
    [anon_sym_set] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_interface] = ACTIONS(3095),
    [anon_sym_enum] = ACTIONS(3095),
    [sym_readonly] = ACTIONS(3095),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(3097),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_typeof] = ACTIONS(3099),
    [anon_sym_import] = ACTIONS(3099),
    [anon_sym_var] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_const] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_else] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_await] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_break] = ACTIONS(3099),
    [anon_sym_continue] = ACTIONS(3099),
    [anon_sym_debugger] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_throw] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_case] = ACTIONS(3099),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_SLASH] = ACTIONS(3099),
    [anon_sym_class] = ACTIONS(3099),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_void] = ACTIONS(3099),
    [anon_sym_delete] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3097),
    [sym_number] = ACTIONS(3097),
    [sym_this] = ACTIONS(3099),
    [sym_super] = ACTIONS(3099),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3097),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_abstract] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_interface] = ACTIONS(3099),
    [anon_sym_enum] = ACTIONS(3099),
    [sym_readonly] = ACTIONS(3099),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(3101),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_RBRACE] = ACTIONS(3101),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_typeof] = ACTIONS(3103),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_else] = ACTIONS(3103),
    [anon_sym_switch] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_await] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_break] = ACTIONS(3103),
    [anon_sym_continue] = ACTIONS(3103),
    [anon_sym_debugger] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_throw] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_case] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_SLASH] = ACTIONS(3103),
    [anon_sym_class] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_void] = ACTIONS(3103),
    [anon_sym_delete] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3101),
    [sym_number] = ACTIONS(3101),
    [sym_this] = ACTIONS(3103),
    [sym_super] = ACTIONS(3103),
    [sym_true] = ACTIONS(3103),
    [sym_false] = ACTIONS(3103),
    [sym_null] = ACTIONS(3103),
    [sym_undefined] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3101),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_interface] = ACTIONS(3103),
    [anon_sym_enum] = ACTIONS(3103),
    [sym_readonly] = ACTIONS(3103),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(3105),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_type] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_debugger] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_case] = ACTIONS(3107),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_void] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3105),
    [sym_number] = ACTIONS(3105),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(3107),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3105),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3107),
    [anon_sym_set] = ACTIONS(3107),
    [anon_sym_declare] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_any] = ACTIONS(3107),
    [anon_sym_number] = ACTIONS(3107),
    [anon_sym_boolean] = ACTIONS(3107),
    [anon_sym_string] = ACTIONS(3107),
    [anon_sym_symbol] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [sym_readonly] = ACTIONS(3107),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(3111),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_export] = ACTIONS(3113),
    [anon_sym_default] = ACTIONS(3113),
    [anon_sym_namespace] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_type] = ACTIONS(3113),
    [anon_sym_typeof] = ACTIONS(3113),
    [anon_sym_import] = ACTIONS(3113),
    [anon_sym_var] = ACTIONS(3113),
    [anon_sym_let] = ACTIONS(3113),
    [anon_sym_const] = ACTIONS(3113),
    [anon_sym_if] = ACTIONS(3113),
    [anon_sym_else] = ACTIONS(3113),
    [anon_sym_switch] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_await] = ACTIONS(3113),
    [anon_sym_while] = ACTIONS(3113),
    [anon_sym_do] = ACTIONS(3113),
    [anon_sym_try] = ACTIONS(3113),
    [anon_sym_with] = ACTIONS(3113),
    [anon_sym_break] = ACTIONS(3113),
    [anon_sym_continue] = ACTIONS(3113),
    [anon_sym_debugger] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3113),
    [anon_sym_throw] = ACTIONS(3113),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3113),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LT] = ACTIONS(3111),
    [anon_sym_SLASH] = ACTIONS(3113),
    [anon_sym_class] = ACTIONS(3113),
    [anon_sym_async] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3111),
    [anon_sym_void] = ACTIONS(3113),
    [anon_sym_delete] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3111),
    [sym_number] = ACTIONS(3111),
    [sym_this] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_true] = ACTIONS(3113),
    [sym_false] = ACTIONS(3113),
    [sym_null] = ACTIONS(3113),
    [sym_undefined] = ACTIONS(3113),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3113),
    [anon_sym_abstract] = ACTIONS(3113),
    [anon_sym_get] = ACTIONS(3113),
    [anon_sym_set] = ACTIONS(3113),
    [anon_sym_declare] = ACTIONS(3113),
    [anon_sym_public] = ACTIONS(3113),
    [anon_sym_private] = ACTIONS(3113),
    [anon_sym_protected] = ACTIONS(3113),
    [anon_sym_module] = ACTIONS(3113),
    [anon_sym_any] = ACTIONS(3113),
    [anon_sym_number] = ACTIONS(3113),
    [anon_sym_boolean] = ACTIONS(3113),
    [anon_sym_string] = ACTIONS(3113),
    [anon_sym_symbol] = ACTIONS(3113),
    [anon_sym_interface] = ACTIONS(3113),
    [anon_sym_enum] = ACTIONS(3113),
    [sym_readonly] = ACTIONS(3113),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(3115),
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_export] = ACTIONS(3117),
    [anon_sym_default] = ACTIONS(3117),
    [anon_sym_namespace] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_type] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3117),
    [anon_sym_import] = ACTIONS(3117),
    [anon_sym_var] = ACTIONS(3117),
    [anon_sym_let] = ACTIONS(3117),
    [anon_sym_const] = ACTIONS(3117),
    [anon_sym_if] = ACTIONS(3117),
    [anon_sym_else] = ACTIONS(3117),
    [anon_sym_switch] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_await] = ACTIONS(3117),
    [anon_sym_while] = ACTIONS(3117),
    [anon_sym_do] = ACTIONS(3117),
    [anon_sym_try] = ACTIONS(3117),
    [anon_sym_with] = ACTIONS(3117),
    [anon_sym_break] = ACTIONS(3117),
    [anon_sym_continue] = ACTIONS(3117),
    [anon_sym_debugger] = ACTIONS(3117),
    [anon_sym_return] = ACTIONS(3117),
    [anon_sym_throw] = ACTIONS(3117),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_case] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3117),
    [anon_sym_class] = ACTIONS(3117),
    [anon_sym_async] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3117),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3115),
    [anon_sym_void] = ACTIONS(3117),
    [anon_sym_delete] = ACTIONS(3117),
    [anon_sym_PLUS_PLUS] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_SQUOTE] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [sym_number] = ACTIONS(3115),
    [sym_this] = ACTIONS(3117),
    [sym_super] = ACTIONS(3117),
    [sym_true] = ACTIONS(3117),
    [sym_false] = ACTIONS(3117),
    [sym_null] = ACTIONS(3117),
    [sym_undefined] = ACTIONS(3117),
    [anon_sym_AT] = ACTIONS(3115),
    [anon_sym_static] = ACTIONS(3117),
    [anon_sym_abstract] = ACTIONS(3117),
    [anon_sym_get] = ACTIONS(3117),
    [anon_sym_set] = ACTIONS(3117),
    [anon_sym_declare] = ACTIONS(3117),
    [anon_sym_public] = ACTIONS(3117),
    [anon_sym_private] = ACTIONS(3117),
    [anon_sym_protected] = ACTIONS(3117),
    [anon_sym_module] = ACTIONS(3117),
    [anon_sym_any] = ACTIONS(3117),
    [anon_sym_number] = ACTIONS(3117),
    [anon_sym_boolean] = ACTIONS(3117),
    [anon_sym_string] = ACTIONS(3117),
    [anon_sym_symbol] = ACTIONS(3117),
    [anon_sym_interface] = ACTIONS(3117),
    [anon_sym_enum] = ACTIONS(3117),
    [sym_readonly] = ACTIONS(3117),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(3119),
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_export] = ACTIONS(3121),
    [anon_sym_default] = ACTIONS(3121),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_type] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3121),
    [anon_sym_import] = ACTIONS(3121),
    [anon_sym_var] = ACTIONS(3121),
    [anon_sym_let] = ACTIONS(3121),
    [anon_sym_const] = ACTIONS(3121),
    [anon_sym_if] = ACTIONS(3121),
    [anon_sym_else] = ACTIONS(3121),
    [anon_sym_switch] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_await] = ACTIONS(3121),
    [anon_sym_while] = ACTIONS(3121),
    [anon_sym_do] = ACTIONS(3121),
    [anon_sym_try] = ACTIONS(3121),
    [anon_sym_with] = ACTIONS(3121),
    [anon_sym_break] = ACTIONS(3121),
    [anon_sym_continue] = ACTIONS(3121),
    [anon_sym_debugger] = ACTIONS(3121),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_throw] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_case] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3121),
    [anon_sym_class] = ACTIONS(3121),
    [anon_sym_async] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3119),
    [anon_sym_void] = ACTIONS(3121),
    [anon_sym_delete] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3119),
    [anon_sym_DASH_DASH] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_SQUOTE] = ACTIONS(3119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3119),
    [sym_number] = ACTIONS(3119),
    [sym_this] = ACTIONS(3121),
    [sym_super] = ACTIONS(3121),
    [sym_true] = ACTIONS(3121),
    [sym_false] = ACTIONS(3121),
    [sym_null] = ACTIONS(3121),
    [sym_undefined] = ACTIONS(3121),
    [anon_sym_AT] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3121),
    [anon_sym_abstract] = ACTIONS(3121),
    [anon_sym_get] = ACTIONS(3121),
    [anon_sym_set] = ACTIONS(3121),
    [anon_sym_declare] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3121),
    [anon_sym_private] = ACTIONS(3121),
    [anon_sym_protected] = ACTIONS(3121),
    [anon_sym_module] = ACTIONS(3121),
    [anon_sym_any] = ACTIONS(3121),
    [anon_sym_number] = ACTIONS(3121),
    [anon_sym_boolean] = ACTIONS(3121),
    [anon_sym_string] = ACTIONS(3121),
    [anon_sym_symbol] = ACTIONS(3121),
    [anon_sym_interface] = ACTIONS(3121),
    [anon_sym_enum] = ACTIONS(3121),
    [sym_readonly] = ACTIONS(3121),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(3123),
    [sym_identifier] = ACTIONS(3125),
    [anon_sym_export] = ACTIONS(3125),
    [anon_sym_default] = ACTIONS(3125),
    [anon_sym_namespace] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_RBRACE] = ACTIONS(3123),
    [anon_sym_type] = ACTIONS(3125),
    [anon_sym_typeof] = ACTIONS(3125),
    [anon_sym_import] = ACTIONS(3125),
    [anon_sym_var] = ACTIONS(3125),
    [anon_sym_let] = ACTIONS(3125),
    [anon_sym_const] = ACTIONS(3125),
    [anon_sym_if] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(3125),
    [anon_sym_switch] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_await] = ACTIONS(3125),
    [anon_sym_while] = ACTIONS(3125),
    [anon_sym_do] = ACTIONS(3125),
    [anon_sym_try] = ACTIONS(3125),
    [anon_sym_with] = ACTIONS(3125),
    [anon_sym_break] = ACTIONS(3125),
    [anon_sym_continue] = ACTIONS(3125),
    [anon_sym_debugger] = ACTIONS(3125),
    [anon_sym_return] = ACTIONS(3125),
    [anon_sym_throw] = ACTIONS(3125),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_case] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3125),
    [anon_sym_class] = ACTIONS(3125),
    [anon_sym_async] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(3125),
    [anon_sym_DASH] = ACTIONS(3125),
    [anon_sym_BANG] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3123),
    [anon_sym_void] = ACTIONS(3125),
    [anon_sym_delete] = ACTIONS(3125),
    [anon_sym_PLUS_PLUS] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_SQUOTE] = ACTIONS(3123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3123),
    [sym_number] = ACTIONS(3123),
    [sym_this] = ACTIONS(3125),
    [sym_super] = ACTIONS(3125),
    [sym_true] = ACTIONS(3125),
    [sym_false] = ACTIONS(3125),
    [sym_null] = ACTIONS(3125),
    [sym_undefined] = ACTIONS(3125),
    [anon_sym_AT] = ACTIONS(3123),
    [anon_sym_static] = ACTIONS(3125),
    [anon_sym_abstract] = ACTIONS(3125),
    [anon_sym_get] = ACTIONS(3125),
    [anon_sym_set] = ACTIONS(3125),
    [anon_sym_declare] = ACTIONS(3125),
    [anon_sym_public] = ACTIONS(3125),
    [anon_sym_private] = ACTIONS(3125),
    [anon_sym_protected] = ACTIONS(3125),
    [anon_sym_module] = ACTIONS(3125),
    [anon_sym_any] = ACTIONS(3125),
    [anon_sym_number] = ACTIONS(3125),
    [anon_sym_boolean] = ACTIONS(3125),
    [anon_sym_string] = ACTIONS(3125),
    [anon_sym_symbol] = ACTIONS(3125),
    [anon_sym_interface] = ACTIONS(3125),
    [anon_sym_enum] = ACTIONS(3125),
    [sym_readonly] = ACTIONS(3125),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(3127),
    [sym_identifier] = ACTIONS(3129),
    [anon_sym_export] = ACTIONS(3129),
    [anon_sym_default] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_RBRACE] = ACTIONS(3127),
    [anon_sym_type] = ACTIONS(3129),
    [anon_sym_typeof] = ACTIONS(3129),
    [anon_sym_import] = ACTIONS(3129),
    [anon_sym_var] = ACTIONS(3129),
    [anon_sym_let] = ACTIONS(3129),
    [anon_sym_const] = ACTIONS(3129),
    [anon_sym_if] = ACTIONS(3129),
    [anon_sym_else] = ACTIONS(3129),
    [anon_sym_switch] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_await] = ACTIONS(3129),
    [anon_sym_while] = ACTIONS(3129),
    [anon_sym_do] = ACTIONS(3129),
    [anon_sym_try] = ACTIONS(3129),
    [anon_sym_with] = ACTIONS(3129),
    [anon_sym_break] = ACTIONS(3129),
    [anon_sym_continue] = ACTIONS(3129),
    [anon_sym_debugger] = ACTIONS(3129),
    [anon_sym_return] = ACTIONS(3129),
    [anon_sym_throw] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3127),
    [anon_sym_case] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_SLASH] = ACTIONS(3129),
    [anon_sym_class] = ACTIONS(3129),
    [anon_sym_async] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3129),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3127),
    [anon_sym_void] = ACTIONS(3129),
    [anon_sym_delete] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3127),
    [anon_sym_DASH_DASH] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3127),
    [sym_number] = ACTIONS(3127),
    [sym_this] = ACTIONS(3129),
    [sym_super] = ACTIONS(3129),
    [sym_true] = ACTIONS(3129),
    [sym_false] = ACTIONS(3129),
    [sym_null] = ACTIONS(3129),
    [sym_undefined] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3127),
    [anon_sym_static] = ACTIONS(3129),
    [anon_sym_abstract] = ACTIONS(3129),
    [anon_sym_get] = ACTIONS(3129),
    [anon_sym_set] = ACTIONS(3129),
    [anon_sym_declare] = ACTIONS(3129),
    [anon_sym_public] = ACTIONS(3129),
    [anon_sym_private] = ACTIONS(3129),
    [anon_sym_protected] = ACTIONS(3129),
    [anon_sym_module] = ACTIONS(3129),
    [anon_sym_any] = ACTIONS(3129),
    [anon_sym_number] = ACTIONS(3129),
    [anon_sym_boolean] = ACTIONS(3129),
    [anon_sym_string] = ACTIONS(3129),
    [anon_sym_symbol] = ACTIONS(3129),
    [anon_sym_interface] = ACTIONS(3129),
    [anon_sym_enum] = ACTIONS(3129),
    [sym_readonly] = ACTIONS(3129),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(3131),
    [sym_identifier] = ACTIONS(3133),
    [anon_sym_export] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3133),
    [anon_sym_namespace] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_RBRACE] = ACTIONS(3131),
    [anon_sym_type] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3133),
    [anon_sym_import] = ACTIONS(3133),
    [anon_sym_var] = ACTIONS(3133),
    [anon_sym_let] = ACTIONS(3133),
    [anon_sym_const] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_switch] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_await] = ACTIONS(3133),
    [anon_sym_while] = ACTIONS(3133),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(3133),
    [anon_sym_with] = ACTIONS(3133),
    [anon_sym_break] = ACTIONS(3133),
    [anon_sym_continue] = ACTIONS(3133),
    [anon_sym_debugger] = ACTIONS(3133),
    [anon_sym_return] = ACTIONS(3133),
    [anon_sym_throw] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3131),
    [anon_sym_case] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LT] = ACTIONS(3131),
    [anon_sym_SLASH] = ACTIONS(3133),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_async] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_BANG] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3131),
    [anon_sym_void] = ACTIONS(3133),
    [anon_sym_delete] = ACTIONS(3133),
    [anon_sym_PLUS_PLUS] = ACTIONS(3131),
    [anon_sym_DASH_DASH] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_SQUOTE] = ACTIONS(3131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3131),
    [sym_number] = ACTIONS(3131),
    [sym_this] = ACTIONS(3133),
    [sym_super] = ACTIONS(3133),
    [sym_true] = ACTIONS(3133),
    [sym_false] = ACTIONS(3133),
    [sym_null] = ACTIONS(3133),
    [sym_undefined] = ACTIONS(3133),
    [anon_sym_AT] = ACTIONS(3131),
    [anon_sym_static] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(3133),
    [anon_sym_get] = ACTIONS(3133),
    [anon_sym_set] = ACTIONS(3133),
    [anon_sym_declare] = ACTIONS(3133),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_module] = ACTIONS(3133),
    [anon_sym_any] = ACTIONS(3133),
    [anon_sym_number] = ACTIONS(3133),
    [anon_sym_boolean] = ACTIONS(3133),
    [anon_sym_string] = ACTIONS(3133),
    [anon_sym_symbol] = ACTIONS(3133),
    [anon_sym_interface] = ACTIONS(3133),
    [anon_sym_enum] = ACTIONS(3133),
    [sym_readonly] = ACTIONS(3133),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(3135),
    [sym_identifier] = ACTIONS(3137),
    [anon_sym_export] = ACTIONS(3137),
    [anon_sym_default] = ACTIONS(3137),
    [anon_sym_namespace] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_RBRACE] = ACTIONS(3135),
    [anon_sym_type] = ACTIONS(3137),
    [anon_sym_typeof] = ACTIONS(3137),
    [anon_sym_import] = ACTIONS(3137),
    [anon_sym_var] = ACTIONS(3137),
    [anon_sym_let] = ACTIONS(3137),
    [anon_sym_const] = ACTIONS(3137),
    [anon_sym_if] = ACTIONS(3137),
    [anon_sym_else] = ACTIONS(3137),
    [anon_sym_switch] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_await] = ACTIONS(3137),
    [anon_sym_while] = ACTIONS(3137),
    [anon_sym_do] = ACTIONS(3137),
    [anon_sym_try] = ACTIONS(3137),
    [anon_sym_with] = ACTIONS(3137),
    [anon_sym_break] = ACTIONS(3137),
    [anon_sym_continue] = ACTIONS(3137),
    [anon_sym_debugger] = ACTIONS(3137),
    [anon_sym_return] = ACTIONS(3137),
    [anon_sym_throw] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_case] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3137),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_SLASH] = ACTIONS(3137),
    [anon_sym_class] = ACTIONS(3137),
    [anon_sym_async] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3137),
    [anon_sym_BANG] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3135),
    [anon_sym_void] = ACTIONS(3137),
    [anon_sym_delete] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3135),
    [anon_sym_DASH_DASH] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3135),
    [sym_number] = ACTIONS(3135),
    [sym_this] = ACTIONS(3137),
    [sym_super] = ACTIONS(3137),
    [sym_true] = ACTIONS(3137),
    [sym_false] = ACTIONS(3137),
    [sym_null] = ACTIONS(3137),
    [sym_undefined] = ACTIONS(3137),
    [anon_sym_AT] = ACTIONS(3135),
    [anon_sym_static] = ACTIONS(3137),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_get] = ACTIONS(3137),
    [anon_sym_set] = ACTIONS(3137),
    [anon_sym_declare] = ACTIONS(3137),
    [anon_sym_public] = ACTIONS(3137),
    [anon_sym_private] = ACTIONS(3137),
    [anon_sym_protected] = ACTIONS(3137),
    [anon_sym_module] = ACTIONS(3137),
    [anon_sym_any] = ACTIONS(3137),
    [anon_sym_number] = ACTIONS(3137),
    [anon_sym_boolean] = ACTIONS(3137),
    [anon_sym_string] = ACTIONS(3137),
    [anon_sym_symbol] = ACTIONS(3137),
    [anon_sym_interface] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3137),
    [sym_readonly] = ACTIONS(3137),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(3139),
    [sym_identifier] = ACTIONS(3141),
    [anon_sym_export] = ACTIONS(3141),
    [anon_sym_default] = ACTIONS(3141),
    [anon_sym_namespace] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_type] = ACTIONS(3141),
    [anon_sym_typeof] = ACTIONS(3141),
    [anon_sym_import] = ACTIONS(3141),
    [anon_sym_var] = ACTIONS(3141),
    [anon_sym_let] = ACTIONS(3141),
    [anon_sym_const] = ACTIONS(3141),
    [anon_sym_if] = ACTIONS(3141),
    [anon_sym_else] = ACTIONS(3141),
    [anon_sym_switch] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_await] = ACTIONS(3141),
    [anon_sym_while] = ACTIONS(3141),
    [anon_sym_do] = ACTIONS(3141),
    [anon_sym_try] = ACTIONS(3141),
    [anon_sym_with] = ACTIONS(3141),
    [anon_sym_break] = ACTIONS(3141),
    [anon_sym_continue] = ACTIONS(3141),
    [anon_sym_debugger] = ACTIONS(3141),
    [anon_sym_return] = ACTIONS(3141),
    [anon_sym_throw] = ACTIONS(3141),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_case] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3141),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3139),
    [anon_sym_SLASH] = ACTIONS(3141),
    [anon_sym_class] = ACTIONS(3141),
    [anon_sym_async] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3141),
    [anon_sym_DASH] = ACTIONS(3141),
    [anon_sym_BANG] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3139),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_delete] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3139),
    [sym_number] = ACTIONS(3139),
    [sym_this] = ACTIONS(3141),
    [sym_super] = ACTIONS(3141),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [sym_null] = ACTIONS(3141),
    [sym_undefined] = ACTIONS(3141),
    [anon_sym_AT] = ACTIONS(3139),
    [anon_sym_static] = ACTIONS(3141),
    [anon_sym_abstract] = ACTIONS(3141),
    [anon_sym_get] = ACTIONS(3141),
    [anon_sym_set] = ACTIONS(3141),
    [anon_sym_declare] = ACTIONS(3141),
    [anon_sym_public] = ACTIONS(3141),
    [anon_sym_private] = ACTIONS(3141),
    [anon_sym_protected] = ACTIONS(3141),
    [anon_sym_module] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_enum] = ACTIONS(3141),
    [sym_readonly] = ACTIONS(3141),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(3143),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_export] = ACTIONS(3145),
    [anon_sym_default] = ACTIONS(3145),
    [anon_sym_namespace] = ACTIONS(3145),
    [anon_sym_LBRACE] = ACTIONS(3143),
    [anon_sym_RBRACE] = ACTIONS(3143),
    [anon_sym_type] = ACTIONS(3145),
    [anon_sym_typeof] = ACTIONS(3145),
    [anon_sym_import] = ACTIONS(3145),
    [anon_sym_var] = ACTIONS(3145),
    [anon_sym_let] = ACTIONS(3145),
    [anon_sym_const] = ACTIONS(3145),
    [anon_sym_if] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(3145),
    [anon_sym_switch] = ACTIONS(3145),
    [anon_sym_for] = ACTIONS(3145),
    [anon_sym_LPAREN] = ACTIONS(3143),
    [anon_sym_await] = ACTIONS(3145),
    [anon_sym_while] = ACTIONS(3145),
    [anon_sym_do] = ACTIONS(3145),
    [anon_sym_try] = ACTIONS(3145),
    [anon_sym_with] = ACTIONS(3145),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_continue] = ACTIONS(3145),
    [anon_sym_debugger] = ACTIONS(3145),
    [anon_sym_return] = ACTIONS(3145),
    [anon_sym_throw] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(3143),
    [anon_sym_case] = ACTIONS(3145),
    [anon_sym_yield] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(3143),
    [anon_sym_LT] = ACTIONS(3143),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_class] = ACTIONS(3145),
    [anon_sym_async] = ACTIONS(3145),
    [anon_sym_function] = ACTIONS(3145),
    [anon_sym_new] = ACTIONS(3145),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_BANG] = ACTIONS(3143),
    [anon_sym_TILDE] = ACTIONS(3143),
    [anon_sym_void] = ACTIONS(3145),
    [anon_sym_delete] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(3143),
    [anon_sym_DASH_DASH] = ACTIONS(3143),
    [anon_sym_DQUOTE] = ACTIONS(3143),
    [anon_sym_SQUOTE] = ACTIONS(3143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3143),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_undefined] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3143),
    [anon_sym_static] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(3145),
    [anon_sym_get] = ACTIONS(3145),
    [anon_sym_set] = ACTIONS(3145),
    [anon_sym_declare] = ACTIONS(3145),
    [anon_sym_public] = ACTIONS(3145),
    [anon_sym_private] = ACTIONS(3145),
    [anon_sym_protected] = ACTIONS(3145),
    [anon_sym_module] = ACTIONS(3145),
    [anon_sym_any] = ACTIONS(3145),
    [anon_sym_number] = ACTIONS(3145),
    [anon_sym_boolean] = ACTIONS(3145),
    [anon_sym_string] = ACTIONS(3145),
    [anon_sym_symbol] = ACTIONS(3145),
    [anon_sym_interface] = ACTIONS(3145),
    [anon_sym_enum] = ACTIONS(3145),
    [sym_readonly] = ACTIONS(3145),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(3147),
    [sym_identifier] = ACTIONS(3149),
    [anon_sym_export] = ACTIONS(3149),
    [anon_sym_default] = ACTIONS(3149),
    [anon_sym_namespace] = ACTIONS(3149),
    [anon_sym_LBRACE] = ACTIONS(3147),
    [anon_sym_RBRACE] = ACTIONS(3147),
    [anon_sym_type] = ACTIONS(3149),
    [anon_sym_typeof] = ACTIONS(3149),
    [anon_sym_import] = ACTIONS(3149),
    [anon_sym_var] = ACTIONS(3149),
    [anon_sym_let] = ACTIONS(3149),
    [anon_sym_const] = ACTIONS(3149),
    [anon_sym_if] = ACTIONS(3149),
    [anon_sym_else] = ACTIONS(3149),
    [anon_sym_switch] = ACTIONS(3149),
    [anon_sym_for] = ACTIONS(3149),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_await] = ACTIONS(3149),
    [anon_sym_while] = ACTIONS(3149),
    [anon_sym_do] = ACTIONS(3149),
    [anon_sym_try] = ACTIONS(3149),
    [anon_sym_with] = ACTIONS(3149),
    [anon_sym_break] = ACTIONS(3149),
    [anon_sym_continue] = ACTIONS(3149),
    [anon_sym_debugger] = ACTIONS(3149),
    [anon_sym_return] = ACTIONS(3149),
    [anon_sym_throw] = ACTIONS(3149),
    [anon_sym_SEMI] = ACTIONS(3147),
    [anon_sym_case] = ACTIONS(3149),
    [anon_sym_yield] = ACTIONS(3149),
    [anon_sym_LBRACK] = ACTIONS(3147),
    [anon_sym_LT] = ACTIONS(3147),
    [anon_sym_SLASH] = ACTIONS(3149),
    [anon_sym_class] = ACTIONS(3149),
    [anon_sym_async] = ACTIONS(3149),
    [anon_sym_function] = ACTIONS(3149),
    [anon_sym_new] = ACTIONS(3149),
    [anon_sym_PLUS] = ACTIONS(3149),
    [anon_sym_DASH] = ACTIONS(3149),
    [anon_sym_BANG] = ACTIONS(3147),
    [anon_sym_TILDE] = ACTIONS(3147),
    [anon_sym_void] = ACTIONS(3149),
    [anon_sym_delete] = ACTIONS(3149),
    [anon_sym_PLUS_PLUS] = ACTIONS(3147),
    [anon_sym_DASH_DASH] = ACTIONS(3147),
    [anon_sym_DQUOTE] = ACTIONS(3147),
    [anon_sym_SQUOTE] = ACTIONS(3147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3147),
    [sym_number] = ACTIONS(3147),
    [sym_this] = ACTIONS(3149),
    [sym_super] = ACTIONS(3149),
    [sym_true] = ACTIONS(3149),
    [sym_false] = ACTIONS(3149),
    [sym_null] = ACTIONS(3149),
    [sym_undefined] = ACTIONS(3149),
    [anon_sym_AT] = ACTIONS(3147),
    [anon_sym_static] = ACTIONS(3149),
    [anon_sym_abstract] = ACTIONS(3149),
    [anon_sym_get] = ACTIONS(3149),
    [anon_sym_set] = ACTIONS(3149),
    [anon_sym_declare] = ACTIONS(3149),
    [anon_sym_public] = ACTIONS(3149),
    [anon_sym_private] = ACTIONS(3149),
    [anon_sym_protected] = ACTIONS(3149),
    [anon_sym_module] = ACTIONS(3149),
    [anon_sym_any] = ACTIONS(3149),
    [anon_sym_number] = ACTIONS(3149),
    [anon_sym_boolean] = ACTIONS(3149),
    [anon_sym_string] = ACTIONS(3149),
    [anon_sym_symbol] = ACTIONS(3149),
    [anon_sym_interface] = ACTIONS(3149),
    [anon_sym_enum] = ACTIONS(3149),
    [sym_readonly] = ACTIONS(3149),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(3151),
    [sym_identifier] = ACTIONS(3153),
    [anon_sym_export] = ACTIONS(3153),
    [anon_sym_default] = ACTIONS(3153),
    [anon_sym_namespace] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3151),
    [anon_sym_RBRACE] = ACTIONS(3151),
    [anon_sym_type] = ACTIONS(3153),
    [anon_sym_typeof] = ACTIONS(3153),
    [anon_sym_import] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3153),
    [anon_sym_let] = ACTIONS(3153),
    [anon_sym_const] = ACTIONS(3153),
    [anon_sym_if] = ACTIONS(3153),
    [anon_sym_else] = ACTIONS(3153),
    [anon_sym_switch] = ACTIONS(3153),
    [anon_sym_for] = ACTIONS(3153),
    [anon_sym_LPAREN] = ACTIONS(3151),
    [anon_sym_await] = ACTIONS(3153),
    [anon_sym_while] = ACTIONS(3153),
    [anon_sym_do] = ACTIONS(3153),
    [anon_sym_try] = ACTIONS(3153),
    [anon_sym_with] = ACTIONS(3153),
    [anon_sym_break] = ACTIONS(3153),
    [anon_sym_continue] = ACTIONS(3153),
    [anon_sym_debugger] = ACTIONS(3153),
    [anon_sym_return] = ACTIONS(3153),
    [anon_sym_throw] = ACTIONS(3153),
    [anon_sym_SEMI] = ACTIONS(3151),
    [anon_sym_case] = ACTIONS(3153),
    [anon_sym_yield] = ACTIONS(3153),
    [anon_sym_LBRACK] = ACTIONS(3151),
    [anon_sym_LT] = ACTIONS(3151),
    [anon_sym_SLASH] = ACTIONS(3153),
    [anon_sym_class] = ACTIONS(3153),
    [anon_sym_async] = ACTIONS(3153),
    [anon_sym_function] = ACTIONS(3153),
    [anon_sym_new] = ACTIONS(3153),
    [anon_sym_PLUS] = ACTIONS(3153),
    [anon_sym_DASH] = ACTIONS(3153),
    [anon_sym_BANG] = ACTIONS(3151),
    [anon_sym_TILDE] = ACTIONS(3151),
    [anon_sym_void] = ACTIONS(3153),
    [anon_sym_delete] = ACTIONS(3153),
    [anon_sym_PLUS_PLUS] = ACTIONS(3151),
    [anon_sym_DASH_DASH] = ACTIONS(3151),
    [anon_sym_DQUOTE] = ACTIONS(3151),
    [anon_sym_SQUOTE] = ACTIONS(3151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3151),
    [sym_number] = ACTIONS(3151),
    [sym_this] = ACTIONS(3153),
    [sym_super] = ACTIONS(3153),
    [sym_true] = ACTIONS(3153),
    [sym_false] = ACTIONS(3153),
    [sym_null] = ACTIONS(3153),
    [sym_undefined] = ACTIONS(3153),
    [anon_sym_AT] = ACTIONS(3151),
    [anon_sym_static] = ACTIONS(3153),
    [anon_sym_abstract] = ACTIONS(3153),
    [anon_sym_get] = ACTIONS(3153),
    [anon_sym_set] = ACTIONS(3153),
    [anon_sym_declare] = ACTIONS(3153),
    [anon_sym_public] = ACTIONS(3153),
    [anon_sym_private] = ACTIONS(3153),
    [anon_sym_protected] = ACTIONS(3153),
    [anon_sym_module] = ACTIONS(3153),
    [anon_sym_any] = ACTIONS(3153),
    [anon_sym_number] = ACTIONS(3153),
    [anon_sym_boolean] = ACTIONS(3153),
    [anon_sym_string] = ACTIONS(3153),
    [anon_sym_symbol] = ACTIONS(3153),
    [anon_sym_interface] = ACTIONS(3153),
    [anon_sym_enum] = ACTIONS(3153),
    [sym_readonly] = ACTIONS(3153),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(3155),
    [sym_identifier] = ACTIONS(3157),
    [anon_sym_export] = ACTIONS(3157),
    [anon_sym_default] = ACTIONS(3157),
    [anon_sym_namespace] = ACTIONS(3157),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_type] = ACTIONS(3157),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_import] = ACTIONS(3157),
    [anon_sym_var] = ACTIONS(3157),
    [anon_sym_let] = ACTIONS(3157),
    [anon_sym_const] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3157),
    [anon_sym_else] = ACTIONS(3157),
    [anon_sym_switch] = ACTIONS(3157),
    [anon_sym_for] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_await] = ACTIONS(3157),
    [anon_sym_while] = ACTIONS(3157),
    [anon_sym_do] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_with] = ACTIONS(3157),
    [anon_sym_break] = ACTIONS(3157),
    [anon_sym_continue] = ACTIONS(3157),
    [anon_sym_debugger] = ACTIONS(3157),
    [anon_sym_return] = ACTIONS(3157),
    [anon_sym_throw] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_case] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3157),
    [anon_sym_LBRACK] = ACTIONS(3155),
    [anon_sym_LT] = ACTIONS(3155),
    [anon_sym_SLASH] = ACTIONS(3157),
    [anon_sym_class] = ACTIONS(3157),
    [anon_sym_async] = ACTIONS(3157),
    [anon_sym_function] = ACTIONS(3157),
    [anon_sym_new] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_BANG] = ACTIONS(3155),
    [anon_sym_TILDE] = ACTIONS(3155),
    [anon_sym_void] = ACTIONS(3157),
    [anon_sym_delete] = ACTIONS(3157),
    [anon_sym_PLUS_PLUS] = ACTIONS(3155),
    [anon_sym_DASH_DASH] = ACTIONS(3155),
    [anon_sym_DQUOTE] = ACTIONS(3155),
    [anon_sym_SQUOTE] = ACTIONS(3155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [sym_number] = ACTIONS(3155),
    [sym_this] = ACTIONS(3157),
    [sym_super] = ACTIONS(3157),
    [sym_true] = ACTIONS(3157),
    [sym_false] = ACTIONS(3157),
    [sym_null] = ACTIONS(3157),
    [sym_undefined] = ACTIONS(3157),
    [anon_sym_AT] = ACTIONS(3155),
    [anon_sym_static] = ACTIONS(3157),
    [anon_sym_abstract] = ACTIONS(3157),
    [anon_sym_get] = ACTIONS(3157),
    [anon_sym_set] = ACTIONS(3157),
    [anon_sym_declare] = ACTIONS(3157),
    [anon_sym_public] = ACTIONS(3157),
    [anon_sym_private] = ACTIONS(3157),
    [anon_sym_protected] = ACTIONS(3157),
    [anon_sym_module] = ACTIONS(3157),
    [anon_sym_any] = ACTIONS(3157),
    [anon_sym_number] = ACTIONS(3157),
    [anon_sym_boolean] = ACTIONS(3157),
    [anon_sym_string] = ACTIONS(3157),
    [anon_sym_symbol] = ACTIONS(3157),
    [anon_sym_interface] = ACTIONS(3157),
    [anon_sym_enum] = ACTIONS(3157),
    [sym_readonly] = ACTIONS(3157),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(3159),
    [sym_identifier] = ACTIONS(3161),
    [anon_sym_export] = ACTIONS(3161),
    [anon_sym_default] = ACTIONS(3161),
    [anon_sym_namespace] = ACTIONS(3161),
    [anon_sym_LBRACE] = ACTIONS(3159),
    [anon_sym_RBRACE] = ACTIONS(3159),
    [anon_sym_type] = ACTIONS(3161),
    [anon_sym_typeof] = ACTIONS(3161),
    [anon_sym_import] = ACTIONS(3161),
    [anon_sym_var] = ACTIONS(3161),
    [anon_sym_let] = ACTIONS(3161),
    [anon_sym_const] = ACTIONS(3161),
    [anon_sym_if] = ACTIONS(3161),
    [anon_sym_else] = ACTIONS(3161),
    [anon_sym_switch] = ACTIONS(3161),
    [anon_sym_for] = ACTIONS(3161),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_await] = ACTIONS(3161),
    [anon_sym_while] = ACTIONS(3161),
    [anon_sym_do] = ACTIONS(3161),
    [anon_sym_try] = ACTIONS(3161),
    [anon_sym_with] = ACTIONS(3161),
    [anon_sym_break] = ACTIONS(3161),
    [anon_sym_continue] = ACTIONS(3161),
    [anon_sym_debugger] = ACTIONS(3161),
    [anon_sym_return] = ACTIONS(3161),
    [anon_sym_throw] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_case] = ACTIONS(3161),
    [anon_sym_yield] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3159),
    [anon_sym_LT] = ACTIONS(3159),
    [anon_sym_SLASH] = ACTIONS(3161),
    [anon_sym_class] = ACTIONS(3161),
    [anon_sym_async] = ACTIONS(3161),
    [anon_sym_function] = ACTIONS(3161),
    [anon_sym_new] = ACTIONS(3161),
    [anon_sym_PLUS] = ACTIONS(3161),
    [anon_sym_DASH] = ACTIONS(3161),
    [anon_sym_BANG] = ACTIONS(3159),
    [anon_sym_TILDE] = ACTIONS(3159),
    [anon_sym_void] = ACTIONS(3161),
    [anon_sym_delete] = ACTIONS(3161),
    [anon_sym_PLUS_PLUS] = ACTIONS(3159),
    [anon_sym_DASH_DASH] = ACTIONS(3159),
    [anon_sym_DQUOTE] = ACTIONS(3159),
    [anon_sym_SQUOTE] = ACTIONS(3159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3159),
    [sym_number] = ACTIONS(3159),
    [sym_this] = ACTIONS(3161),
    [sym_super] = ACTIONS(3161),
    [sym_true] = ACTIONS(3161),
    [sym_false] = ACTIONS(3161),
    [sym_null] = ACTIONS(3161),
    [sym_undefined] = ACTIONS(3161),
    [anon_sym_AT] = ACTIONS(3159),
    [anon_sym_static] = ACTIONS(3161),
    [anon_sym_abstract] = ACTIONS(3161),
    [anon_sym_get] = ACTIONS(3161),
    [anon_sym_set] = ACTIONS(3161),
    [anon_sym_declare] = ACTIONS(3161),
    [anon_sym_public] = ACTIONS(3161),
    [anon_sym_private] = ACTIONS(3161),
    [anon_sym_protected] = ACTIONS(3161),
    [anon_sym_module] = ACTIONS(3161),
    [anon_sym_any] = ACTIONS(3161),
    [anon_sym_number] = ACTIONS(3161),
    [anon_sym_boolean] = ACTIONS(3161),
    [anon_sym_string] = ACTIONS(3161),
    [anon_sym_symbol] = ACTIONS(3161),
    [anon_sym_interface] = ACTIONS(3161),
    [anon_sym_enum] = ACTIONS(3161),
    [sym_readonly] = ACTIONS(3161),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(3163),
    [sym_identifier] = ACTIONS(3165),
    [anon_sym_export] = ACTIONS(3165),
    [anon_sym_default] = ACTIONS(3165),
    [anon_sym_namespace] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3163),
    [anon_sym_type] = ACTIONS(3165),
    [anon_sym_typeof] = ACTIONS(3165),
    [anon_sym_import] = ACTIONS(3165),
    [anon_sym_var] = ACTIONS(3165),
    [anon_sym_let] = ACTIONS(3165),
    [anon_sym_const] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3165),
    [anon_sym_else] = ACTIONS(3165),
    [anon_sym_switch] = ACTIONS(3165),
    [anon_sym_for] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_await] = ACTIONS(3165),
    [anon_sym_while] = ACTIONS(3165),
    [anon_sym_do] = ACTIONS(3165),
    [anon_sym_try] = ACTIONS(3165),
    [anon_sym_with] = ACTIONS(3165),
    [anon_sym_break] = ACTIONS(3165),
    [anon_sym_continue] = ACTIONS(3165),
    [anon_sym_debugger] = ACTIONS(3165),
    [anon_sym_return] = ACTIONS(3165),
    [anon_sym_throw] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_case] = ACTIONS(3165),
    [anon_sym_yield] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3163),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_class] = ACTIONS(3165),
    [anon_sym_async] = ACTIONS(3165),
    [anon_sym_function] = ACTIONS(3165),
    [anon_sym_new] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_void] = ACTIONS(3165),
    [anon_sym_delete] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3163),
    [anon_sym_DQUOTE] = ACTIONS(3163),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3163),
    [sym_number] = ACTIONS(3163),
    [sym_this] = ACTIONS(3165),
    [sym_super] = ACTIONS(3165),
    [sym_true] = ACTIONS(3165),
    [sym_false] = ACTIONS(3165),
    [sym_null] = ACTIONS(3165),
    [sym_undefined] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3163),
    [anon_sym_static] = ACTIONS(3165),
    [anon_sym_abstract] = ACTIONS(3165),
    [anon_sym_get] = ACTIONS(3165),
    [anon_sym_set] = ACTIONS(3165),
    [anon_sym_declare] = ACTIONS(3165),
    [anon_sym_public] = ACTIONS(3165),
    [anon_sym_private] = ACTIONS(3165),
    [anon_sym_protected] = ACTIONS(3165),
    [anon_sym_module] = ACTIONS(3165),
    [anon_sym_any] = ACTIONS(3165),
    [anon_sym_number] = ACTIONS(3165),
    [anon_sym_boolean] = ACTIONS(3165),
    [anon_sym_string] = ACTIONS(3165),
    [anon_sym_symbol] = ACTIONS(3165),
    [anon_sym_interface] = ACTIONS(3165),
    [anon_sym_enum] = ACTIONS(3165),
    [sym_readonly] = ACTIONS(3165),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(3167),
    [sym_identifier] = ACTIONS(3169),
    [anon_sym_export] = ACTIONS(3169),
    [anon_sym_default] = ACTIONS(3169),
    [anon_sym_namespace] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_type] = ACTIONS(3169),
    [anon_sym_typeof] = ACTIONS(3169),
    [anon_sym_import] = ACTIONS(3169),
    [anon_sym_var] = ACTIONS(3169),
    [anon_sym_let] = ACTIONS(3169),
    [anon_sym_const] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3169),
    [anon_sym_else] = ACTIONS(3169),
    [anon_sym_switch] = ACTIONS(3169),
    [anon_sym_for] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3169),
    [anon_sym_while] = ACTIONS(3169),
    [anon_sym_do] = ACTIONS(3169),
    [anon_sym_try] = ACTIONS(3169),
    [anon_sym_with] = ACTIONS(3169),
    [anon_sym_break] = ACTIONS(3169),
    [anon_sym_continue] = ACTIONS(3169),
    [anon_sym_debugger] = ACTIONS(3169),
    [anon_sym_return] = ACTIONS(3169),
    [anon_sym_throw] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_case] = ACTIONS(3169),
    [anon_sym_yield] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3169),
    [anon_sym_class] = ACTIONS(3169),
    [anon_sym_async] = ACTIONS(3169),
    [anon_sym_function] = ACTIONS(3169),
    [anon_sym_new] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_void] = ACTIONS(3169),
    [anon_sym_delete] = ACTIONS(3169),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3167),
    [sym_number] = ACTIONS(3167),
    [sym_this] = ACTIONS(3169),
    [sym_super] = ACTIONS(3169),
    [sym_true] = ACTIONS(3169),
    [sym_false] = ACTIONS(3169),
    [sym_null] = ACTIONS(3169),
    [sym_undefined] = ACTIONS(3169),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3169),
    [anon_sym_abstract] = ACTIONS(3169),
    [anon_sym_get] = ACTIONS(3169),
    [anon_sym_set] = ACTIONS(3169),
    [anon_sym_declare] = ACTIONS(3169),
    [anon_sym_public] = ACTIONS(3169),
    [anon_sym_private] = ACTIONS(3169),
    [anon_sym_protected] = ACTIONS(3169),
    [anon_sym_module] = ACTIONS(3169),
    [anon_sym_any] = ACTIONS(3169),
    [anon_sym_number] = ACTIONS(3169),
    [anon_sym_boolean] = ACTIONS(3169),
    [anon_sym_string] = ACTIONS(3169),
    [anon_sym_symbol] = ACTIONS(3169),
    [anon_sym_interface] = ACTIONS(3169),
    [anon_sym_enum] = ACTIONS(3169),
    [sym_readonly] = ACTIONS(3169),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(3171),
    [sym_identifier] = ACTIONS(3173),
    [anon_sym_export] = ACTIONS(3173),
    [anon_sym_default] = ACTIONS(3173),
    [anon_sym_namespace] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3171),
    [anon_sym_RBRACE] = ACTIONS(3171),
    [anon_sym_type] = ACTIONS(3173),
    [anon_sym_typeof] = ACTIONS(3173),
    [anon_sym_import] = ACTIONS(3173),
    [anon_sym_var] = ACTIONS(3173),
    [anon_sym_let] = ACTIONS(3173),
    [anon_sym_const] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3173),
    [anon_sym_else] = ACTIONS(3173),
    [anon_sym_switch] = ACTIONS(3173),
    [anon_sym_for] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(3171),
    [anon_sym_await] = ACTIONS(3173),
    [anon_sym_while] = ACTIONS(3173),
    [anon_sym_do] = ACTIONS(3173),
    [anon_sym_try] = ACTIONS(3173),
    [anon_sym_with] = ACTIONS(3173),
    [anon_sym_break] = ACTIONS(3173),
    [anon_sym_continue] = ACTIONS(3173),
    [anon_sym_debugger] = ACTIONS(3173),
    [anon_sym_return] = ACTIONS(3173),
    [anon_sym_throw] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3171),
    [anon_sym_case] = ACTIONS(3173),
    [anon_sym_yield] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(3171),
    [anon_sym_LT] = ACTIONS(3171),
    [anon_sym_SLASH] = ACTIONS(3173),
    [anon_sym_class] = ACTIONS(3173),
    [anon_sym_async] = ACTIONS(3173),
    [anon_sym_function] = ACTIONS(3173),
    [anon_sym_new] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3173),
    [anon_sym_DASH] = ACTIONS(3173),
    [anon_sym_BANG] = ACTIONS(3171),
    [anon_sym_TILDE] = ACTIONS(3171),
    [anon_sym_void] = ACTIONS(3173),
    [anon_sym_delete] = ACTIONS(3173),
    [anon_sym_PLUS_PLUS] = ACTIONS(3171),
    [anon_sym_DASH_DASH] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(3171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3171),
    [sym_number] = ACTIONS(3171),
    [sym_this] = ACTIONS(3173),
    [sym_super] = ACTIONS(3173),
    [sym_true] = ACTIONS(3173),
    [sym_false] = ACTIONS(3173),
    [sym_null] = ACTIONS(3173),
    [sym_undefined] = ACTIONS(3173),
    [anon_sym_AT] = ACTIONS(3171),
    [anon_sym_static] = ACTIONS(3173),
    [anon_sym_abstract] = ACTIONS(3173),
    [anon_sym_get] = ACTIONS(3173),
    [anon_sym_set] = ACTIONS(3173),
    [anon_sym_declare] = ACTIONS(3173),
    [anon_sym_public] = ACTIONS(3173),
    [anon_sym_private] = ACTIONS(3173),
    [anon_sym_protected] = ACTIONS(3173),
    [anon_sym_module] = ACTIONS(3173),
    [anon_sym_any] = ACTIONS(3173),
    [anon_sym_number] = ACTIONS(3173),
    [anon_sym_boolean] = ACTIONS(3173),
    [anon_sym_string] = ACTIONS(3173),
    [anon_sym_symbol] = ACTIONS(3173),
    [anon_sym_interface] = ACTIONS(3173),
    [anon_sym_enum] = ACTIONS(3173),
    [sym_readonly] = ACTIONS(3173),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(3175),
    [sym_identifier] = ACTIONS(3177),
    [anon_sym_export] = ACTIONS(3177),
    [anon_sym_default] = ACTIONS(3177),
    [anon_sym_namespace] = ACTIONS(3177),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_RBRACE] = ACTIONS(3175),
    [anon_sym_type] = ACTIONS(3177),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_import] = ACTIONS(3177),
    [anon_sym_var] = ACTIONS(3177),
    [anon_sym_let] = ACTIONS(3177),
    [anon_sym_const] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3177),
    [anon_sym_else] = ACTIONS(3177),
    [anon_sym_switch] = ACTIONS(3177),
    [anon_sym_for] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3175),
    [anon_sym_await] = ACTIONS(3177),
    [anon_sym_while] = ACTIONS(3177),
    [anon_sym_do] = ACTIONS(3177),
    [anon_sym_try] = ACTIONS(3177),
    [anon_sym_with] = ACTIONS(3177),
    [anon_sym_break] = ACTIONS(3177),
    [anon_sym_continue] = ACTIONS(3177),
    [anon_sym_debugger] = ACTIONS(3177),
    [anon_sym_return] = ACTIONS(3177),
    [anon_sym_throw] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3177),
    [anon_sym_yield] = ACTIONS(3177),
    [anon_sym_LBRACK] = ACTIONS(3175),
    [anon_sym_LT] = ACTIONS(3175),
    [anon_sym_SLASH] = ACTIONS(3177),
    [anon_sym_class] = ACTIONS(3177),
    [anon_sym_async] = ACTIONS(3177),
    [anon_sym_function] = ACTIONS(3177),
    [anon_sym_new] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3177),
    [anon_sym_DASH] = ACTIONS(3177),
    [anon_sym_BANG] = ACTIONS(3175),
    [anon_sym_TILDE] = ACTIONS(3175),
    [anon_sym_void] = ACTIONS(3177),
    [anon_sym_delete] = ACTIONS(3177),
    [anon_sym_PLUS_PLUS] = ACTIONS(3175),
    [anon_sym_DASH_DASH] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3175),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3177),
    [sym_super] = ACTIONS(3177),
    [sym_true] = ACTIONS(3177),
    [sym_false] = ACTIONS(3177),
    [sym_null] = ACTIONS(3177),
    [sym_undefined] = ACTIONS(3177),
    [anon_sym_AT] = ACTIONS(3175),
    [anon_sym_static] = ACTIONS(3177),
    [anon_sym_abstract] = ACTIONS(3177),
    [anon_sym_get] = ACTIONS(3177),
    [anon_sym_set] = ACTIONS(3177),
    [anon_sym_declare] = ACTIONS(3177),
    [anon_sym_public] = ACTIONS(3177),
    [anon_sym_private] = ACTIONS(3177),
    [anon_sym_protected] = ACTIONS(3177),
    [anon_sym_module] = ACTIONS(3177),
    [anon_sym_any] = ACTIONS(3177),
    [anon_sym_number] = ACTIONS(3177),
    [anon_sym_boolean] = ACTIONS(3177),
    [anon_sym_string] = ACTIONS(3177),
    [anon_sym_symbol] = ACTIONS(3177),
    [anon_sym_interface] = ACTIONS(3177),
    [anon_sym_enum] = ACTIONS(3177),
    [sym_readonly] = ACTIONS(3177),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym_identifier] = ACTIONS(1355),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_typeof] = ACTIONS(1355),
    [anon_sym_import] = ACTIONS(1355),
    [anon_sym_var] = ACTIONS(1355),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_await] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_do] = ACTIONS(1355),
    [anon_sym_try] = ACTIONS(1355),
    [anon_sym_with] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_debugger] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_throw] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_case] = ACTIONS(1355),
    [anon_sym_yield] = ACTIONS(1355),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_class] = ACTIONS(1355),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_function] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_void] = ACTIONS(1355),
    [anon_sym_delete] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1353),
    [sym_number] = ACTIONS(1353),
    [sym_this] = ACTIONS(1355),
    [sym_super] = ACTIONS(1355),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_null] = ACTIONS(1355),
    [sym_undefined] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_abstract] = ACTIONS(1355),
    [anon_sym_get] = ACTIONS(1355),
    [anon_sym_set] = ACTIONS(1355),
    [anon_sym_declare] = ACTIONS(1355),
    [anon_sym_public] = ACTIONS(1355),
    [anon_sym_private] = ACTIONS(1355),
    [anon_sym_protected] = ACTIONS(1355),
    [anon_sym_module] = ACTIONS(1355),
    [anon_sym_any] = ACTIONS(1355),
    [anon_sym_number] = ACTIONS(1355),
    [anon_sym_boolean] = ACTIONS(1355),
    [anon_sym_string] = ACTIONS(1355),
    [anon_sym_symbol] = ACTIONS(1355),
    [anon_sym_interface] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [sym_readonly] = ACTIONS(1355),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(3179),
    [sym_identifier] = ACTIONS(3181),
    [anon_sym_export] = ACTIONS(3181),
    [anon_sym_default] = ACTIONS(3181),
    [anon_sym_namespace] = ACTIONS(3181),
    [anon_sym_LBRACE] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(3179),
    [anon_sym_type] = ACTIONS(3181),
    [anon_sym_typeof] = ACTIONS(3181),
    [anon_sym_import] = ACTIONS(3181),
    [anon_sym_var] = ACTIONS(3181),
    [anon_sym_let] = ACTIONS(3181),
    [anon_sym_const] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3181),
    [anon_sym_else] = ACTIONS(3181),
    [anon_sym_switch] = ACTIONS(3181),
    [anon_sym_for] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_await] = ACTIONS(3181),
    [anon_sym_while] = ACTIONS(3181),
    [anon_sym_do] = ACTIONS(3181),
    [anon_sym_try] = ACTIONS(3181),
    [anon_sym_with] = ACTIONS(3181),
    [anon_sym_break] = ACTIONS(3181),
    [anon_sym_continue] = ACTIONS(3181),
    [anon_sym_debugger] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3181),
    [anon_sym_throw] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_case] = ACTIONS(3181),
    [anon_sym_yield] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3179),
    [anon_sym_LT] = ACTIONS(3179),
    [anon_sym_SLASH] = ACTIONS(3181),
    [anon_sym_class] = ACTIONS(3181),
    [anon_sym_async] = ACTIONS(3181),
    [anon_sym_function] = ACTIONS(3181),
    [anon_sym_new] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_BANG] = ACTIONS(3179),
    [anon_sym_TILDE] = ACTIONS(3179),
    [anon_sym_void] = ACTIONS(3181),
    [anon_sym_delete] = ACTIONS(3181),
    [anon_sym_PLUS_PLUS] = ACTIONS(3179),
    [anon_sym_DASH_DASH] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3179),
    [sym_number] = ACTIONS(3179),
    [sym_this] = ACTIONS(3181),
    [sym_super] = ACTIONS(3181),
    [sym_true] = ACTIONS(3181),
    [sym_false] = ACTIONS(3181),
    [sym_null] = ACTIONS(3181),
    [sym_undefined] = ACTIONS(3181),
    [anon_sym_AT] = ACTIONS(3179),
    [anon_sym_static] = ACTIONS(3181),
    [anon_sym_abstract] = ACTIONS(3181),
    [anon_sym_get] = ACTIONS(3181),
    [anon_sym_set] = ACTIONS(3181),
    [anon_sym_declare] = ACTIONS(3181),
    [anon_sym_public] = ACTIONS(3181),
    [anon_sym_private] = ACTIONS(3181),
    [anon_sym_protected] = ACTIONS(3181),
    [anon_sym_module] = ACTIONS(3181),
    [anon_sym_any] = ACTIONS(3181),
    [anon_sym_number] = ACTIONS(3181),
    [anon_sym_boolean] = ACTIONS(3181),
    [anon_sym_string] = ACTIONS(3181),
    [anon_sym_symbol] = ACTIONS(3181),
    [anon_sym_interface] = ACTIONS(3181),
    [anon_sym_enum] = ACTIONS(3181),
    [sym_readonly] = ACTIONS(3181),
  },
  [647] = {
    [sym__call_signature] = STATE(3048),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_type] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(604),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_get] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(3071),
    [anon_sym_declare] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_any] = ACTIONS(3071),
    [anon_sym_number] = ACTIONS(3071),
    [anon_sym_boolean] = ACTIONS(3071),
    [anon_sym_string] = ACTIONS(3071),
    [anon_sym_symbol] = ACTIONS(3071),
    [sym_readonly] = ACTIONS(3071),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(3183),
    [sym_identifier] = ACTIONS(3185),
    [anon_sym_export] = ACTIONS(3185),
    [anon_sym_default] = ACTIONS(3185),
    [anon_sym_namespace] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_type] = ACTIONS(3185),
    [anon_sym_typeof] = ACTIONS(3185),
    [anon_sym_import] = ACTIONS(3185),
    [anon_sym_var] = ACTIONS(3185),
    [anon_sym_let] = ACTIONS(3185),
    [anon_sym_const] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3185),
    [anon_sym_else] = ACTIONS(3185),
    [anon_sym_switch] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3185),
    [anon_sym_while] = ACTIONS(3185),
    [anon_sym_do] = ACTIONS(3185),
    [anon_sym_try] = ACTIONS(3185),
    [anon_sym_with] = ACTIONS(3185),
    [anon_sym_break] = ACTIONS(3185),
    [anon_sym_continue] = ACTIONS(3185),
    [anon_sym_debugger] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3185),
    [anon_sym_throw] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_case] = ACTIONS(3185),
    [anon_sym_yield] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LT] = ACTIONS(3183),
    [anon_sym_SLASH] = ACTIONS(3185),
    [anon_sym_class] = ACTIONS(3185),
    [anon_sym_async] = ACTIONS(3185),
    [anon_sym_function] = ACTIONS(3185),
    [anon_sym_new] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3185),
    [anon_sym_DASH] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_void] = ACTIONS(3185),
    [anon_sym_delete] = ACTIONS(3185),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3183),
    [sym_number] = ACTIONS(3183),
    [sym_this] = ACTIONS(3185),
    [sym_super] = ACTIONS(3185),
    [sym_true] = ACTIONS(3185),
    [sym_false] = ACTIONS(3185),
    [sym_null] = ACTIONS(3185),
    [sym_undefined] = ACTIONS(3185),
    [anon_sym_AT] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3185),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_get] = ACTIONS(3185),
    [anon_sym_set] = ACTIONS(3185),
    [anon_sym_declare] = ACTIONS(3185),
    [anon_sym_public] = ACTIONS(3185),
    [anon_sym_private] = ACTIONS(3185),
    [anon_sym_protected] = ACTIONS(3185),
    [anon_sym_module] = ACTIONS(3185),
    [anon_sym_any] = ACTIONS(3185),
    [anon_sym_number] = ACTIONS(3185),
    [anon_sym_boolean] = ACTIONS(3185),
    [anon_sym_string] = ACTIONS(3185),
    [anon_sym_symbol] = ACTIONS(3185),
    [anon_sym_interface] = ACTIONS(3185),
    [anon_sym_enum] = ACTIONS(3185),
    [sym_readonly] = ACTIONS(3185),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(3187),
    [sym_identifier] = ACTIONS(3189),
    [anon_sym_export] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_namespace] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_type] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym_import] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_with] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_debugger] = ACTIONS(3189),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3187),
    [anon_sym_SLASH] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_function] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_void] = ACTIONS(3189),
    [anon_sym_delete] = ACTIONS(3189),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3187),
    [sym_number] = ACTIONS(3187),
    [sym_this] = ACTIONS(3189),
    [sym_super] = ACTIONS(3189),
    [sym_true] = ACTIONS(3189),
    [sym_false] = ACTIONS(3189),
    [sym_null] = ACTIONS(3189),
    [sym_undefined] = ACTIONS(3189),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_get] = ACTIONS(3189),
    [anon_sym_set] = ACTIONS(3189),
    [anon_sym_declare] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_module] = ACTIONS(3189),
    [anon_sym_any] = ACTIONS(3189),
    [anon_sym_number] = ACTIONS(3189),
    [anon_sym_boolean] = ACTIONS(3189),
    [anon_sym_string] = ACTIONS(3189),
    [anon_sym_symbol] = ACTIONS(3189),
    [anon_sym_interface] = ACTIONS(3189),
    [anon_sym_enum] = ACTIONS(3189),
    [sym_readonly] = ACTIONS(3189),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_export] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_type] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym_import] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_with] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_debugger] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_case] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_SLASH] = ACTIONS(3193),
    [anon_sym_class] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_delete] = ACTIONS(3193),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3191),
    [sym_number] = ACTIONS(3191),
    [sym_this] = ACTIONS(3193),
    [sym_super] = ACTIONS(3193),
    [sym_true] = ACTIONS(3193),
    [sym_false] = ACTIONS(3193),
    [sym_null] = ACTIONS(3193),
    [sym_undefined] = ACTIONS(3193),
    [anon_sym_AT] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_get] = ACTIONS(3193),
    [anon_sym_set] = ACTIONS(3193),
    [anon_sym_declare] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_enum] = ACTIONS(3193),
    [sym_readonly] = ACTIONS(3193),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(3195),
    [sym_identifier] = ACTIONS(3197),
    [anon_sym_export] = ACTIONS(3197),
    [anon_sym_default] = ACTIONS(3197),
    [anon_sym_namespace] = ACTIONS(3197),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_RBRACE] = ACTIONS(3195),
    [anon_sym_type] = ACTIONS(3197),
    [anon_sym_typeof] = ACTIONS(3197),
    [anon_sym_import] = ACTIONS(3197),
    [anon_sym_var] = ACTIONS(3197),
    [anon_sym_let] = ACTIONS(3197),
    [anon_sym_const] = ACTIONS(3197),
    [anon_sym_if] = ACTIONS(3197),
    [anon_sym_else] = ACTIONS(3197),
    [anon_sym_switch] = ACTIONS(3197),
    [anon_sym_for] = ACTIONS(3197),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_await] = ACTIONS(3197),
    [anon_sym_while] = ACTIONS(3197),
    [anon_sym_do] = ACTIONS(3197),
    [anon_sym_try] = ACTIONS(3197),
    [anon_sym_with] = ACTIONS(3197),
    [anon_sym_break] = ACTIONS(3197),
    [anon_sym_continue] = ACTIONS(3197),
    [anon_sym_debugger] = ACTIONS(3197),
    [anon_sym_return] = ACTIONS(3197),
    [anon_sym_throw] = ACTIONS(3197),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_case] = ACTIONS(3197),
    [anon_sym_yield] = ACTIONS(3197),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LT] = ACTIONS(3195),
    [anon_sym_SLASH] = ACTIONS(3197),
    [anon_sym_class] = ACTIONS(3197),
    [anon_sym_async] = ACTIONS(3197),
    [anon_sym_function] = ACTIONS(3197),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_PLUS] = ACTIONS(3197),
    [anon_sym_DASH] = ACTIONS(3197),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_void] = ACTIONS(3197),
    [anon_sym_delete] = ACTIONS(3197),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3195),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_super] = ACTIONS(3197),
    [sym_true] = ACTIONS(3197),
    [sym_false] = ACTIONS(3197),
    [sym_null] = ACTIONS(3197),
    [sym_undefined] = ACTIONS(3197),
    [anon_sym_AT] = ACTIONS(3195),
    [anon_sym_static] = ACTIONS(3197),
    [anon_sym_abstract] = ACTIONS(3197),
    [anon_sym_get] = ACTIONS(3197),
    [anon_sym_set] = ACTIONS(3197),
    [anon_sym_declare] = ACTIONS(3197),
    [anon_sym_public] = ACTIONS(3197),
    [anon_sym_private] = ACTIONS(3197),
    [anon_sym_protected] = ACTIONS(3197),
    [anon_sym_module] = ACTIONS(3197),
    [anon_sym_any] = ACTIONS(3197),
    [anon_sym_number] = ACTIONS(3197),
    [anon_sym_boolean] = ACTIONS(3197),
    [anon_sym_string] = ACTIONS(3197),
    [anon_sym_symbol] = ACTIONS(3197),
    [anon_sym_interface] = ACTIONS(3197),
    [anon_sym_enum] = ACTIONS(3197),
    [sym_readonly] = ACTIONS(3197),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(3199),
    [sym_identifier] = ACTIONS(3201),
    [anon_sym_export] = ACTIONS(3201),
    [anon_sym_default] = ACTIONS(3201),
    [anon_sym_namespace] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3199),
    [anon_sym_RBRACE] = ACTIONS(3199),
    [anon_sym_type] = ACTIONS(3201),
    [anon_sym_typeof] = ACTIONS(3201),
    [anon_sym_import] = ACTIONS(3201),
    [anon_sym_var] = ACTIONS(3201),
    [anon_sym_let] = ACTIONS(3201),
    [anon_sym_const] = ACTIONS(3201),
    [anon_sym_if] = ACTIONS(3201),
    [anon_sym_else] = ACTIONS(3201),
    [anon_sym_switch] = ACTIONS(3201),
    [anon_sym_for] = ACTIONS(3201),
    [anon_sym_LPAREN] = ACTIONS(3199),
    [anon_sym_await] = ACTIONS(3201),
    [anon_sym_while] = ACTIONS(3201),
    [anon_sym_do] = ACTIONS(3201),
    [anon_sym_try] = ACTIONS(3201),
    [anon_sym_with] = ACTIONS(3201),
    [anon_sym_break] = ACTIONS(3201),
    [anon_sym_continue] = ACTIONS(3201),
    [anon_sym_debugger] = ACTIONS(3201),
    [anon_sym_return] = ACTIONS(3201),
    [anon_sym_throw] = ACTIONS(3201),
    [anon_sym_SEMI] = ACTIONS(3199),
    [anon_sym_case] = ACTIONS(3201),
    [anon_sym_yield] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3199),
    [anon_sym_LT] = ACTIONS(3199),
    [anon_sym_SLASH] = ACTIONS(3201),
    [anon_sym_class] = ACTIONS(3201),
    [anon_sym_async] = ACTIONS(3201),
    [anon_sym_function] = ACTIONS(3201),
    [anon_sym_new] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(3201),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_TILDE] = ACTIONS(3199),
    [anon_sym_void] = ACTIONS(3201),
    [anon_sym_delete] = ACTIONS(3201),
    [anon_sym_PLUS_PLUS] = ACTIONS(3199),
    [anon_sym_DASH_DASH] = ACTIONS(3199),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_SQUOTE] = ACTIONS(3199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3199),
    [sym_number] = ACTIONS(3199),
    [sym_this] = ACTIONS(3201),
    [sym_super] = ACTIONS(3201),
    [sym_true] = ACTIONS(3201),
    [sym_false] = ACTIONS(3201),
    [sym_null] = ACTIONS(3201),
    [sym_undefined] = ACTIONS(3201),
    [anon_sym_AT] = ACTIONS(3199),
    [anon_sym_static] = ACTIONS(3201),
    [anon_sym_abstract] = ACTIONS(3201),
    [anon_sym_get] = ACTIONS(3201),
    [anon_sym_set] = ACTIONS(3201),
    [anon_sym_declare] = ACTIONS(3201),
    [anon_sym_public] = ACTIONS(3201),
    [anon_sym_private] = ACTIONS(3201),
    [anon_sym_protected] = ACTIONS(3201),
    [anon_sym_module] = ACTIONS(3201),
    [anon_sym_any] = ACTIONS(3201),
    [anon_sym_number] = ACTIONS(3201),
    [anon_sym_boolean] = ACTIONS(3201),
    [anon_sym_string] = ACTIONS(3201),
    [anon_sym_symbol] = ACTIONS(3201),
    [anon_sym_interface] = ACTIONS(3201),
    [anon_sym_enum] = ACTIONS(3201),
    [sym_readonly] = ACTIONS(3201),
  },
  [653] = {
    [sym__call_signature] = STATE(3007),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3032),
    [anon_sym_export] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_type] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(3034),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_PLUS_EQ] = ACTIONS(662),
    [anon_sym_DASH_EQ] = ACTIONS(662),
    [anon_sym_STAR_EQ] = ACTIONS(662),
    [anon_sym_SLASH_EQ] = ACTIONS(662),
    [anon_sym_PERCENT_EQ] = ACTIONS(662),
    [anon_sym_CARET_EQ] = ACTIONS(662),
    [anon_sym_AMP_EQ] = ACTIONS(662),
    [anon_sym_PIPE_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(662),
    [anon_sym_LT_LT_EQ] = ACTIONS(662),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_get] = ACTIONS(3034),
    [anon_sym_set] = ACTIONS(3034),
    [anon_sym_declare] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_module] = ACTIONS(3034),
    [anon_sym_any] = ACTIONS(3034),
    [anon_sym_number] = ACTIONS(3034),
    [anon_sym_boolean] = ACTIONS(3034),
    [anon_sym_string] = ACTIONS(3034),
    [anon_sym_symbol] = ACTIONS(3034),
    [sym_readonly] = ACTIONS(3034),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(3203),
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_export] = ACTIONS(3205),
    [anon_sym_default] = ACTIONS(3205),
    [anon_sym_namespace] = ACTIONS(3205),
    [anon_sym_LBRACE] = ACTIONS(3203),
    [anon_sym_RBRACE] = ACTIONS(3203),
    [anon_sym_type] = ACTIONS(3205),
    [anon_sym_typeof] = ACTIONS(3205),
    [anon_sym_import] = ACTIONS(3205),
    [anon_sym_var] = ACTIONS(3205),
    [anon_sym_let] = ACTIONS(3205),
    [anon_sym_const] = ACTIONS(3205),
    [anon_sym_if] = ACTIONS(3205),
    [anon_sym_else] = ACTIONS(3205),
    [anon_sym_switch] = ACTIONS(3205),
    [anon_sym_for] = ACTIONS(3205),
    [anon_sym_LPAREN] = ACTIONS(3203),
    [anon_sym_await] = ACTIONS(3205),
    [anon_sym_while] = ACTIONS(3205),
    [anon_sym_do] = ACTIONS(3205),
    [anon_sym_try] = ACTIONS(3205),
    [anon_sym_with] = ACTIONS(3205),
    [anon_sym_break] = ACTIONS(3205),
    [anon_sym_continue] = ACTIONS(3205),
    [anon_sym_debugger] = ACTIONS(3205),
    [anon_sym_return] = ACTIONS(3205),
    [anon_sym_throw] = ACTIONS(3205),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_case] = ACTIONS(3205),
    [anon_sym_yield] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3203),
    [anon_sym_LT] = ACTIONS(3203),
    [anon_sym_SLASH] = ACTIONS(3205),
    [anon_sym_class] = ACTIONS(3205),
    [anon_sym_async] = ACTIONS(3205),
    [anon_sym_function] = ACTIONS(3205),
    [anon_sym_new] = ACTIONS(3205),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_BANG] = ACTIONS(3203),
    [anon_sym_TILDE] = ACTIONS(3203),
    [anon_sym_void] = ACTIONS(3205),
    [anon_sym_delete] = ACTIONS(3205),
    [anon_sym_PLUS_PLUS] = ACTIONS(3203),
    [anon_sym_DASH_DASH] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3203),
    [sym_number] = ACTIONS(3203),
    [sym_this] = ACTIONS(3205),
    [sym_super] = ACTIONS(3205),
    [sym_true] = ACTIONS(3205),
    [sym_false] = ACTIONS(3205),
    [sym_null] = ACTIONS(3205),
    [sym_undefined] = ACTIONS(3205),
    [anon_sym_AT] = ACTIONS(3203),
    [anon_sym_static] = ACTIONS(3205),
    [anon_sym_abstract] = ACTIONS(3205),
    [anon_sym_get] = ACTIONS(3205),
    [anon_sym_set] = ACTIONS(3205),
    [anon_sym_declare] = ACTIONS(3205),
    [anon_sym_public] = ACTIONS(3205),
    [anon_sym_private] = ACTIONS(3205),
    [anon_sym_protected] = ACTIONS(3205),
    [anon_sym_module] = ACTIONS(3205),
    [anon_sym_any] = ACTIONS(3205),
    [anon_sym_number] = ACTIONS(3205),
    [anon_sym_boolean] = ACTIONS(3205),
    [anon_sym_string] = ACTIONS(3205),
    [anon_sym_symbol] = ACTIONS(3205),
    [anon_sym_interface] = ACTIONS(3205),
    [anon_sym_enum] = ACTIONS(3205),
    [sym_readonly] = ACTIONS(3205),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(3207),
    [sym_identifier] = ACTIONS(3209),
    [anon_sym_export] = ACTIONS(3209),
    [anon_sym_default] = ACTIONS(3209),
    [anon_sym_namespace] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_type] = ACTIONS(3209),
    [anon_sym_typeof] = ACTIONS(3209),
    [anon_sym_import] = ACTIONS(3209),
    [anon_sym_var] = ACTIONS(3209),
    [anon_sym_let] = ACTIONS(3209),
    [anon_sym_const] = ACTIONS(3209),
    [anon_sym_if] = ACTIONS(3209),
    [anon_sym_else] = ACTIONS(3209),
    [anon_sym_switch] = ACTIONS(3209),
    [anon_sym_for] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3209),
    [anon_sym_while] = ACTIONS(3209),
    [anon_sym_do] = ACTIONS(3209),
    [anon_sym_try] = ACTIONS(3209),
    [anon_sym_with] = ACTIONS(3209),
    [anon_sym_break] = ACTIONS(3209),
    [anon_sym_continue] = ACTIONS(3209),
    [anon_sym_debugger] = ACTIONS(3209),
    [anon_sym_return] = ACTIONS(3209),
    [anon_sym_throw] = ACTIONS(3209),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_case] = ACTIONS(3209),
    [anon_sym_yield] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3209),
    [anon_sym_class] = ACTIONS(3209),
    [anon_sym_async] = ACTIONS(3209),
    [anon_sym_function] = ACTIONS(3209),
    [anon_sym_new] = ACTIONS(3209),
    [anon_sym_PLUS] = ACTIONS(3209),
    [anon_sym_DASH] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_void] = ACTIONS(3209),
    [anon_sym_delete] = ACTIONS(3209),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3207),
    [sym_number] = ACTIONS(3207),
    [sym_this] = ACTIONS(3209),
    [sym_super] = ACTIONS(3209),
    [sym_true] = ACTIONS(3209),
    [sym_false] = ACTIONS(3209),
    [sym_null] = ACTIONS(3209),
    [sym_undefined] = ACTIONS(3209),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3209),
    [anon_sym_abstract] = ACTIONS(3209),
    [anon_sym_get] = ACTIONS(3209),
    [anon_sym_set] = ACTIONS(3209),
    [anon_sym_declare] = ACTIONS(3209),
    [anon_sym_public] = ACTIONS(3209),
    [anon_sym_private] = ACTIONS(3209),
    [anon_sym_protected] = ACTIONS(3209),
    [anon_sym_module] = ACTIONS(3209),
    [anon_sym_any] = ACTIONS(3209),
    [anon_sym_number] = ACTIONS(3209),
    [anon_sym_boolean] = ACTIONS(3209),
    [anon_sym_string] = ACTIONS(3209),
    [anon_sym_symbol] = ACTIONS(3209),
    [anon_sym_interface] = ACTIONS(3209),
    [anon_sym_enum] = ACTIONS(3209),
    [sym_readonly] = ACTIONS(3209),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(3211),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_default] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_type] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_with] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_debugger] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_case] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_SLASH] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_void] = ACTIONS(3213),
    [anon_sym_delete] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3211),
    [sym_number] = ACTIONS(3211),
    [sym_this] = ACTIONS(3213),
    [sym_super] = ACTIONS(3213),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [sym_null] = ACTIONS(3213),
    [sym_undefined] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_get] = ACTIONS(3213),
    [anon_sym_set] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3213),
    [anon_sym_number] = ACTIONS(3213),
    [anon_sym_boolean] = ACTIONS(3213),
    [anon_sym_string] = ACTIONS(3213),
    [anon_sym_symbol] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [sym_readonly] = ACTIONS(3213),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(3215),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_default] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_type] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3215),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_with] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_debugger] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3215),
    [anon_sym_case] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3215),
    [anon_sym_LT] = ACTIONS(3215),
    [anon_sym_SLASH] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3215),
    [anon_sym_TILDE] = ACTIONS(3215),
    [anon_sym_void] = ACTIONS(3217),
    [anon_sym_delete] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3215),
    [anon_sym_DASH_DASH] = ACTIONS(3215),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_SQUOTE] = ACTIONS(3215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3215),
    [sym_number] = ACTIONS(3215),
    [sym_this] = ACTIONS(3217),
    [sym_super] = ACTIONS(3217),
    [sym_true] = ACTIONS(3217),
    [sym_false] = ACTIONS(3217),
    [sym_null] = ACTIONS(3217),
    [sym_undefined] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3215),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_get] = ACTIONS(3217),
    [anon_sym_set] = ACTIONS(3217),
    [anon_sym_declare] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_any] = ACTIONS(3217),
    [anon_sym_number] = ACTIONS(3217),
    [anon_sym_boolean] = ACTIONS(3217),
    [anon_sym_string] = ACTIONS(3217),
    [anon_sym_symbol] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [sym_readonly] = ACTIONS(3217),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_namespace] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_type] = ACTIONS(1351),
    [anon_sym_typeof] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_var] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_switch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_await] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_do] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_with] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1351),
    [anon_sym_continue] = ACTIONS(1351),
    [anon_sym_debugger] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_throw] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1351),
    [anon_sym_yield] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_class] = ACTIONS(1351),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_new] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_TILDE] = ACTIONS(1349),
    [anon_sym_void] = ACTIONS(1351),
    [anon_sym_delete] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1349),
    [sym_number] = ACTIONS(1349),
    [sym_this] = ACTIONS(1351),
    [sym_super] = ACTIONS(1351),
    [sym_true] = ACTIONS(1351),
    [sym_false] = ACTIONS(1351),
    [sym_null] = ACTIONS(1351),
    [sym_undefined] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_get] = ACTIONS(1351),
    [anon_sym_set] = ACTIONS(1351),
    [anon_sym_declare] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_private] = ACTIONS(1351),
    [anon_sym_protected] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_any] = ACTIONS(1351),
    [anon_sym_number] = ACTIONS(1351),
    [anon_sym_boolean] = ACTIONS(1351),
    [anon_sym_string] = ACTIONS(1351),
    [anon_sym_symbol] = ACTIONS(1351),
    [anon_sym_interface] = ACTIONS(1351),
    [anon_sym_enum] = ACTIONS(1351),
    [sym_readonly] = ACTIONS(1351),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(3219),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_export] = ACTIONS(3221),
    [anon_sym_default] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_with] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_debugger] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_function] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3221),
    [anon_sym_delete] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_this] = ACTIONS(3221),
    [sym_super] = ACTIONS(3221),
    [sym_true] = ACTIONS(3221),
    [sym_false] = ACTIONS(3221),
    [sym_null] = ACTIONS(3221),
    [sym_undefined] = ACTIONS(3221),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_module] = ACTIONS(3221),
    [anon_sym_any] = ACTIONS(3221),
    [anon_sym_number] = ACTIONS(3221),
    [anon_sym_boolean] = ACTIONS(3221),
    [anon_sym_string] = ACTIONS(3221),
    [anon_sym_symbol] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [sym_readonly] = ACTIONS(3221),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(3223),
    [sym_identifier] = ACTIONS(3225),
    [anon_sym_export] = ACTIONS(3225),
    [anon_sym_default] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_type] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_with] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_debugger] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_case] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_function] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_void] = ACTIONS(3225),
    [anon_sym_delete] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_number] = ACTIONS(3223),
    [sym_this] = ACTIONS(3225),
    [sym_super] = ACTIONS(3225),
    [sym_true] = ACTIONS(3225),
    [sym_false] = ACTIONS(3225),
    [sym_null] = ACTIONS(3225),
    [sym_undefined] = ACTIONS(3225),
    [anon_sym_AT] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_get] = ACTIONS(3225),
    [anon_sym_set] = ACTIONS(3225),
    [anon_sym_declare] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3225),
    [anon_sym_any] = ACTIONS(3225),
    [anon_sym_number] = ACTIONS(3225),
    [anon_sym_boolean] = ACTIONS(3225),
    [anon_sym_string] = ACTIONS(3225),
    [anon_sym_symbol] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [sym_readonly] = ACTIONS(3225),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(3227),
    [sym_identifier] = ACTIONS(3229),
    [anon_sym_export] = ACTIONS(3229),
    [anon_sym_default] = ACTIONS(3229),
    [anon_sym_namespace] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_type] = ACTIONS(3229),
    [anon_sym_typeof] = ACTIONS(3229),
    [anon_sym_import] = ACTIONS(3229),
    [anon_sym_var] = ACTIONS(3229),
    [anon_sym_let] = ACTIONS(3229),
    [anon_sym_const] = ACTIONS(3229),
    [anon_sym_if] = ACTIONS(3229),
    [anon_sym_else] = ACTIONS(3229),
    [anon_sym_switch] = ACTIONS(3229),
    [anon_sym_for] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3229),
    [anon_sym_while] = ACTIONS(3229),
    [anon_sym_do] = ACTIONS(3229),
    [anon_sym_try] = ACTIONS(3229),
    [anon_sym_with] = ACTIONS(3229),
    [anon_sym_break] = ACTIONS(3229),
    [anon_sym_continue] = ACTIONS(3229),
    [anon_sym_debugger] = ACTIONS(3229),
    [anon_sym_return] = ACTIONS(3229),
    [anon_sym_throw] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_case] = ACTIONS(3229),
    [anon_sym_yield] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [anon_sym_SLASH] = ACTIONS(3229),
    [anon_sym_class] = ACTIONS(3229),
    [anon_sym_async] = ACTIONS(3229),
    [anon_sym_function] = ACTIONS(3229),
    [anon_sym_new] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_void] = ACTIONS(3229),
    [anon_sym_delete] = ACTIONS(3229),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [sym_number] = ACTIONS(3227),
    [sym_this] = ACTIONS(3229),
    [sym_super] = ACTIONS(3229),
    [sym_true] = ACTIONS(3229),
    [sym_false] = ACTIONS(3229),
    [sym_null] = ACTIONS(3229),
    [sym_undefined] = ACTIONS(3229),
    [anon_sym_AT] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3229),
    [anon_sym_abstract] = ACTIONS(3229),
    [anon_sym_get] = ACTIONS(3229),
    [anon_sym_set] = ACTIONS(3229),
    [anon_sym_declare] = ACTIONS(3229),
    [anon_sym_public] = ACTIONS(3229),
    [anon_sym_private] = ACTIONS(3229),
    [anon_sym_protected] = ACTIONS(3229),
    [anon_sym_module] = ACTIONS(3229),
    [anon_sym_any] = ACTIONS(3229),
    [anon_sym_number] = ACTIONS(3229),
    [anon_sym_boolean] = ACTIONS(3229),
    [anon_sym_string] = ACTIONS(3229),
    [anon_sym_symbol] = ACTIONS(3229),
    [anon_sym_interface] = ACTIONS(3229),
    [anon_sym_enum] = ACTIONS(3229),
    [sym_readonly] = ACTIONS(3229),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(3231),
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_with] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_this] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [sym_false] = ACTIONS(3233),
    [sym_null] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [sym_readonly] = ACTIONS(3233),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(3235),
    [sym_identifier] = ACTIONS(3237),
    [anon_sym_export] = ACTIONS(3237),
    [anon_sym_default] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_type] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym_import] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_with] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_debugger] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LT] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_function] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_void] = ACTIONS(3237),
    [anon_sym_delete] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_super] = ACTIONS(3237),
    [sym_true] = ACTIONS(3237),
    [sym_false] = ACTIONS(3237),
    [sym_null] = ACTIONS(3237),
    [sym_undefined] = ACTIONS(3237),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_get] = ACTIONS(3237),
    [anon_sym_set] = ACTIONS(3237),
    [anon_sym_declare] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_module] = ACTIONS(3237),
    [anon_sym_any] = ACTIONS(3237),
    [anon_sym_number] = ACTIONS(3237),
    [anon_sym_boolean] = ACTIONS(3237),
    [anon_sym_string] = ACTIONS(3237),
    [anon_sym_symbol] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [sym_readonly] = ACTIONS(3237),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(3239),
    [sym_identifier] = ACTIONS(3241),
    [anon_sym_export] = ACTIONS(3241),
    [anon_sym_default] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_type] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym_import] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_else] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_with] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_debugger] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_case] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LT] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_function] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_delete] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [sym_number] = ACTIONS(3239),
    [sym_this] = ACTIONS(3241),
    [sym_super] = ACTIONS(3241),
    [sym_true] = ACTIONS(3241),
    [sym_false] = ACTIONS(3241),
    [sym_null] = ACTIONS(3241),
    [sym_undefined] = ACTIONS(3241),
    [anon_sym_AT] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_get] = ACTIONS(3241),
    [anon_sym_set] = ACTIONS(3241),
    [anon_sym_declare] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_module] = ACTIONS(3241),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [sym_readonly] = ACTIONS(3241),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(1309),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_namespace] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_typeof] = ACTIONS(1311),
    [anon_sym_import] = ACTIONS(1311),
    [anon_sym_var] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_else] = ACTIONS(1311),
    [anon_sym_switch] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1309),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [anon_sym_do] = ACTIONS(1311),
    [anon_sym_try] = ACTIONS(1311),
    [anon_sym_with] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_debugger] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_throw] = ACTIONS(1311),
    [anon_sym_SEMI] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1311),
    [anon_sym_yield] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_class] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(1311),
    [anon_sym_new] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_TILDE] = ACTIONS(1309),
    [anon_sym_void] = ACTIONS(1311),
    [anon_sym_delete] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1309),
    [anon_sym_DQUOTE] = ACTIONS(1309),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1309),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_null] = ACTIONS(1311),
    [sym_undefined] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_abstract] = ACTIONS(1311),
    [anon_sym_get] = ACTIONS(1311),
    [anon_sym_set] = ACTIONS(1311),
    [anon_sym_declare] = ACTIONS(1311),
    [anon_sym_public] = ACTIONS(1311),
    [anon_sym_private] = ACTIONS(1311),
    [anon_sym_protected] = ACTIONS(1311),
    [anon_sym_module] = ACTIONS(1311),
    [anon_sym_any] = ACTIONS(1311),
    [anon_sym_number] = ACTIONS(1311),
    [anon_sym_boolean] = ACTIONS(1311),
    [anon_sym_string] = ACTIONS(1311),
    [anon_sym_symbol] = ACTIONS(1311),
    [anon_sym_interface] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [sym_readonly] = ACTIONS(1311),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1249),
    [anon_sym_export] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_type] = ACTIONS(1249),
    [anon_sym_typeof] = ACTIONS(1249),
    [anon_sym_import] = ACTIONS(1249),
    [anon_sym_var] = ACTIONS(1249),
    [anon_sym_let] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_await] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_with] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_debugger] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_throw] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_SLASH] = ACTIONS(1249),
    [anon_sym_class] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1249),
    [anon_sym_function] = ACTIONS(1249),
    [anon_sym_new] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_void] = ACTIONS(1249),
    [anon_sym_delete] = ACTIONS(1249),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [sym_number] = ACTIONS(1247),
    [sym_this] = ACTIONS(1249),
    [sym_super] = ACTIONS(1249),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [sym_null] = ACTIONS(1249),
    [sym_undefined] = ACTIONS(1249),
    [anon_sym_AT] = ACTIONS(1247),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_abstract] = ACTIONS(1249),
    [anon_sym_get] = ACTIONS(1249),
    [anon_sym_set] = ACTIONS(1249),
    [anon_sym_declare] = ACTIONS(1249),
    [anon_sym_public] = ACTIONS(1249),
    [anon_sym_private] = ACTIONS(1249),
    [anon_sym_protected] = ACTIONS(1249),
    [anon_sym_module] = ACTIONS(1249),
    [anon_sym_any] = ACTIONS(1249),
    [anon_sym_number] = ACTIONS(1249),
    [anon_sym_boolean] = ACTIONS(1249),
    [anon_sym_string] = ACTIONS(1249),
    [anon_sym_symbol] = ACTIONS(1249),
    [anon_sym_interface] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [sym_readonly] = ACTIONS(1249),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(3243),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3245),
    [anon_sym_default] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3243),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym_import] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_else] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_with] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_debugger] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_case] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LT] = ACTIONS(3243),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_function] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_delete] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3243),
    [sym_number] = ACTIONS(3243),
    [sym_this] = ACTIONS(3245),
    [sym_super] = ACTIONS(3245),
    [sym_true] = ACTIONS(3245),
    [sym_false] = ACTIONS(3245),
    [sym_null] = ACTIONS(3245),
    [sym_undefined] = ACTIONS(3245),
    [anon_sym_AT] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_get] = ACTIONS(3245),
    [anon_sym_set] = ACTIONS(3245),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [sym_readonly] = ACTIONS(3245),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(3247),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_export] = ACTIONS(3249),
    [anon_sym_default] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym_import] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_debugger] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_case] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3247),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_void] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [sym_number] = ACTIONS(3247),
    [sym_this] = ACTIONS(3249),
    [sym_super] = ACTIONS(3249),
    [sym_true] = ACTIONS(3249),
    [sym_false] = ACTIONS(3249),
    [sym_null] = ACTIONS(3249),
    [sym_undefined] = ACTIONS(3249),
    [anon_sym_AT] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_get] = ACTIONS(3249),
    [anon_sym_set] = ACTIONS(3249),
    [anon_sym_declare] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_any] = ACTIONS(3249),
    [anon_sym_number] = ACTIONS(3249),
    [anon_sym_boolean] = ACTIONS(3249),
    [anon_sym_string] = ACTIONS(3249),
    [anon_sym_symbol] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [sym_readonly] = ACTIONS(3249),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(3251),
    [sym_identifier] = ACTIONS(3253),
    [anon_sym_export] = ACTIONS(3253),
    [anon_sym_default] = ACTIONS(3253),
    [anon_sym_namespace] = ACTIONS(3253),
    [anon_sym_LBRACE] = ACTIONS(3251),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [anon_sym_type] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3253),
    [anon_sym_import] = ACTIONS(3253),
    [anon_sym_var] = ACTIONS(3253),
    [anon_sym_let] = ACTIONS(3253),
    [anon_sym_const] = ACTIONS(3253),
    [anon_sym_if] = ACTIONS(3253),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_switch] = ACTIONS(3253),
    [anon_sym_for] = ACTIONS(3253),
    [anon_sym_LPAREN] = ACTIONS(3251),
    [anon_sym_await] = ACTIONS(3253),
    [anon_sym_while] = ACTIONS(3253),
    [anon_sym_do] = ACTIONS(3253),
    [anon_sym_try] = ACTIONS(3253),
    [anon_sym_with] = ACTIONS(3253),
    [anon_sym_break] = ACTIONS(3253),
    [anon_sym_continue] = ACTIONS(3253),
    [anon_sym_debugger] = ACTIONS(3253),
    [anon_sym_return] = ACTIONS(3253),
    [anon_sym_throw] = ACTIONS(3253),
    [anon_sym_SEMI] = ACTIONS(3251),
    [anon_sym_case] = ACTIONS(3253),
    [anon_sym_yield] = ACTIONS(3253),
    [anon_sym_LBRACK] = ACTIONS(3251),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_SLASH] = ACTIONS(3253),
    [anon_sym_class] = ACTIONS(3253),
    [anon_sym_async] = ACTIONS(3253),
    [anon_sym_function] = ACTIONS(3253),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_BANG] = ACTIONS(3251),
    [anon_sym_TILDE] = ACTIONS(3251),
    [anon_sym_void] = ACTIONS(3253),
    [anon_sym_delete] = ACTIONS(3253),
    [anon_sym_PLUS_PLUS] = ACTIONS(3251),
    [anon_sym_DASH_DASH] = ACTIONS(3251),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3251),
    [sym_number] = ACTIONS(3251),
    [sym_this] = ACTIONS(3253),
    [sym_super] = ACTIONS(3253),
    [sym_true] = ACTIONS(3253),
    [sym_false] = ACTIONS(3253),
    [sym_null] = ACTIONS(3253),
    [sym_undefined] = ACTIONS(3253),
    [anon_sym_AT] = ACTIONS(3251),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_abstract] = ACTIONS(3253),
    [anon_sym_get] = ACTIONS(3253),
    [anon_sym_set] = ACTIONS(3253),
    [anon_sym_declare] = ACTIONS(3253),
    [anon_sym_public] = ACTIONS(3253),
    [anon_sym_private] = ACTIONS(3253),
    [anon_sym_protected] = ACTIONS(3253),
    [anon_sym_module] = ACTIONS(3253),
    [anon_sym_any] = ACTIONS(3253),
    [anon_sym_number] = ACTIONS(3253),
    [anon_sym_boolean] = ACTIONS(3253),
    [anon_sym_string] = ACTIONS(3253),
    [anon_sym_symbol] = ACTIONS(3253),
    [anon_sym_interface] = ACTIONS(3253),
    [anon_sym_enum] = ACTIONS(3253),
    [sym_readonly] = ACTIONS(3253),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(3255),
    [sym_identifier] = ACTIONS(3257),
    [anon_sym_export] = ACTIONS(3257),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3257),
    [anon_sym_typeof] = ACTIONS(3257),
    [anon_sym_import] = ACTIONS(3257),
    [anon_sym_var] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_const] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_else] = ACTIONS(3257),
    [anon_sym_switch] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_with] = ACTIONS(3257),
    [anon_sym_break] = ACTIONS(3257),
    [anon_sym_continue] = ACTIONS(3257),
    [anon_sym_debugger] = ACTIONS(3257),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_throw] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3257),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_class] = ACTIONS(3257),
    [anon_sym_async] = ACTIONS(3257),
    [anon_sym_function] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3257),
    [anon_sym_delete] = ACTIONS(3257),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_this] = ACTIONS(3257),
    [sym_super] = ACTIONS(3257),
    [sym_true] = ACTIONS(3257),
    [sym_false] = ACTIONS(3257),
    [sym_null] = ACTIONS(3257),
    [sym_undefined] = ACTIONS(3257),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_get] = ACTIONS(3257),
    [anon_sym_set] = ACTIONS(3257),
    [anon_sym_declare] = ACTIONS(3257),
    [anon_sym_public] = ACTIONS(3257),
    [anon_sym_private] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3257),
    [anon_sym_any] = ACTIONS(3257),
    [anon_sym_number] = ACTIONS(3257),
    [anon_sym_boolean] = ACTIONS(3257),
    [anon_sym_string] = ACTIONS(3257),
    [anon_sym_symbol] = ACTIONS(3257),
    [anon_sym_interface] = ACTIONS(3257),
    [anon_sym_enum] = ACTIONS(3257),
    [sym_readonly] = ACTIONS(3257),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym_identifier] = ACTIONS(3261),
    [anon_sym_export] = ACTIONS(3261),
    [anon_sym_default] = ACTIONS(3261),
    [anon_sym_namespace] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_type] = ACTIONS(3261),
    [anon_sym_typeof] = ACTIONS(3261),
    [anon_sym_import] = ACTIONS(3261),
    [anon_sym_var] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_const] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_else] = ACTIONS(3261),
    [anon_sym_switch] = ACTIONS(3261),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_LPAREN] = ACTIONS(3259),
    [anon_sym_await] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_with] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3261),
    [anon_sym_continue] = ACTIONS(3261),
    [anon_sym_debugger] = ACTIONS(3261),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_throw] = ACTIONS(3261),
    [anon_sym_SEMI] = ACTIONS(3259),
    [anon_sym_case] = ACTIONS(3261),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(3261),
    [anon_sym_class] = ACTIONS(3261),
    [anon_sym_async] = ACTIONS(3261),
    [anon_sym_function] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [anon_sym_void] = ACTIONS(3261),
    [anon_sym_delete] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3259),
    [anon_sym_DASH_DASH] = ACTIONS(3259),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_SQUOTE] = ACTIONS(3259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3259),
    [sym_number] = ACTIONS(3259),
    [sym_this] = ACTIONS(3261),
    [sym_super] = ACTIONS(3261),
    [sym_true] = ACTIONS(3261),
    [sym_false] = ACTIONS(3261),
    [sym_null] = ACTIONS(3261),
    [sym_undefined] = ACTIONS(3261),
    [anon_sym_AT] = ACTIONS(3259),
    [anon_sym_static] = ACTIONS(3261),
    [anon_sym_abstract] = ACTIONS(3261),
    [anon_sym_get] = ACTIONS(3261),
    [anon_sym_set] = ACTIONS(3261),
    [anon_sym_declare] = ACTIONS(3261),
    [anon_sym_public] = ACTIONS(3261),
    [anon_sym_private] = ACTIONS(3261),
    [anon_sym_protected] = ACTIONS(3261),
    [anon_sym_module] = ACTIONS(3261),
    [anon_sym_any] = ACTIONS(3261),
    [anon_sym_number] = ACTIONS(3261),
    [anon_sym_boolean] = ACTIONS(3261),
    [anon_sym_string] = ACTIONS(3261),
    [anon_sym_symbol] = ACTIONS(3261),
    [anon_sym_interface] = ACTIONS(3261),
    [anon_sym_enum] = ACTIONS(3261),
    [sym_readonly] = ACTIONS(3261),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(3263),
    [sym_identifier] = ACTIONS(3265),
    [anon_sym_export] = ACTIONS(3265),
    [anon_sym_default] = ACTIONS(3265),
    [anon_sym_namespace] = ACTIONS(3265),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_type] = ACTIONS(3265),
    [anon_sym_typeof] = ACTIONS(3265),
    [anon_sym_import] = ACTIONS(3265),
    [anon_sym_var] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_const] = ACTIONS(3265),
    [anon_sym_if] = ACTIONS(3265),
    [anon_sym_else] = ACTIONS(3265),
    [anon_sym_switch] = ACTIONS(3265),
    [anon_sym_for] = ACTIONS(3265),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_await] = ACTIONS(3265),
    [anon_sym_while] = ACTIONS(3265),
    [anon_sym_do] = ACTIONS(3265),
    [anon_sym_try] = ACTIONS(3265),
    [anon_sym_with] = ACTIONS(3265),
    [anon_sym_break] = ACTIONS(3265),
    [anon_sym_continue] = ACTIONS(3265),
    [anon_sym_debugger] = ACTIONS(3265),
    [anon_sym_return] = ACTIONS(3265),
    [anon_sym_throw] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_case] = ACTIONS(3265),
    [anon_sym_yield] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3263),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_class] = ACTIONS(3265),
    [anon_sym_async] = ACTIONS(3265),
    [anon_sym_function] = ACTIONS(3265),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_void] = ACTIONS(3265),
    [anon_sym_delete] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_SQUOTE] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3263),
    [sym_number] = ACTIONS(3263),
    [sym_this] = ACTIONS(3265),
    [sym_super] = ACTIONS(3265),
    [sym_true] = ACTIONS(3265),
    [sym_false] = ACTIONS(3265),
    [sym_null] = ACTIONS(3265),
    [sym_undefined] = ACTIONS(3265),
    [anon_sym_AT] = ACTIONS(3263),
    [anon_sym_static] = ACTIONS(3265),
    [anon_sym_abstract] = ACTIONS(3265),
    [anon_sym_get] = ACTIONS(3265),
    [anon_sym_set] = ACTIONS(3265),
    [anon_sym_declare] = ACTIONS(3265),
    [anon_sym_public] = ACTIONS(3265),
    [anon_sym_private] = ACTIONS(3265),
    [anon_sym_protected] = ACTIONS(3265),
    [anon_sym_module] = ACTIONS(3265),
    [anon_sym_any] = ACTIONS(3265),
    [anon_sym_number] = ACTIONS(3265),
    [anon_sym_boolean] = ACTIONS(3265),
    [anon_sym_string] = ACTIONS(3265),
    [anon_sym_symbol] = ACTIONS(3265),
    [anon_sym_interface] = ACTIONS(3265),
    [anon_sym_enum] = ACTIONS(3265),
    [sym_readonly] = ACTIONS(3265),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(3267),
    [sym_identifier] = ACTIONS(3269),
    [anon_sym_export] = ACTIONS(3269),
    [anon_sym_default] = ACTIONS(3269),
    [anon_sym_namespace] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3267),
    [anon_sym_type] = ACTIONS(3269),
    [anon_sym_typeof] = ACTIONS(3269),
    [anon_sym_import] = ACTIONS(3269),
    [anon_sym_var] = ACTIONS(3269),
    [anon_sym_let] = ACTIONS(3269),
    [anon_sym_const] = ACTIONS(3269),
    [anon_sym_if] = ACTIONS(3269),
    [anon_sym_else] = ACTIONS(3269),
    [anon_sym_switch] = ACTIONS(3269),
    [anon_sym_for] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3269),
    [anon_sym_while] = ACTIONS(3269),
    [anon_sym_do] = ACTIONS(3269),
    [anon_sym_try] = ACTIONS(3269),
    [anon_sym_with] = ACTIONS(3269),
    [anon_sym_break] = ACTIONS(3269),
    [anon_sym_continue] = ACTIONS(3269),
    [anon_sym_debugger] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3269),
    [anon_sym_throw] = ACTIONS(3269),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_case] = ACTIONS(3269),
    [anon_sym_yield] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_SLASH] = ACTIONS(3269),
    [anon_sym_class] = ACTIONS(3269),
    [anon_sym_async] = ACTIONS(3269),
    [anon_sym_function] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_void] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3267),
    [sym_number] = ACTIONS(3267),
    [sym_this] = ACTIONS(3269),
    [sym_super] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_null] = ACTIONS(3269),
    [sym_undefined] = ACTIONS(3269),
    [anon_sym_AT] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3269),
    [anon_sym_abstract] = ACTIONS(3269),
    [anon_sym_get] = ACTIONS(3269),
    [anon_sym_set] = ACTIONS(3269),
    [anon_sym_declare] = ACTIONS(3269),
    [anon_sym_public] = ACTIONS(3269),
    [anon_sym_private] = ACTIONS(3269),
    [anon_sym_protected] = ACTIONS(3269),
    [anon_sym_module] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(3269),
    [anon_sym_number] = ACTIONS(3269),
    [anon_sym_boolean] = ACTIONS(3269),
    [anon_sym_string] = ACTIONS(3269),
    [anon_sym_symbol] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3269),
    [anon_sym_enum] = ACTIONS(3269),
    [sym_readonly] = ACTIONS(3269),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(3271),
    [sym_identifier] = ACTIONS(3273),
    [anon_sym_export] = ACTIONS(3273),
    [anon_sym_default] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3271),
    [anon_sym_type] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym_import] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_with] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_debugger] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3271),
    [anon_sym_case] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3271),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_SLASH] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_function] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3271),
    [anon_sym_void] = ACTIONS(3273),
    [anon_sym_delete] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3271),
    [anon_sym_DASH_DASH] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3271),
    [sym_number] = ACTIONS(3271),
    [sym_this] = ACTIONS(3273),
    [sym_super] = ACTIONS(3273),
    [sym_true] = ACTIONS(3273),
    [sym_false] = ACTIONS(3273),
    [sym_null] = ACTIONS(3273),
    [sym_undefined] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_get] = ACTIONS(3273),
    [anon_sym_set] = ACTIONS(3273),
    [anon_sym_declare] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(3273),
    [anon_sym_number] = ACTIONS(3273),
    [anon_sym_boolean] = ACTIONS(3273),
    [anon_sym_string] = ACTIONS(3273),
    [anon_sym_symbol] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [sym_readonly] = ACTIONS(3273),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(3275),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_case] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LT] = ACTIONS(3275),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3275),
    [sym_number] = ACTIONS(3275),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_readonly] = ACTIONS(3277),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_export] = ACTIONS(3281),
    [anon_sym_default] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym_import] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_debugger] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_case] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LT] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_void] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3279),
    [sym_number] = ACTIONS(3279),
    [sym_this] = ACTIONS(3281),
    [sym_super] = ACTIONS(3281),
    [sym_true] = ACTIONS(3281),
    [sym_false] = ACTIONS(3281),
    [sym_null] = ACTIONS(3281),
    [sym_undefined] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_get] = ACTIONS(3281),
    [anon_sym_set] = ACTIONS(3281),
    [anon_sym_declare] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_any] = ACTIONS(3281),
    [anon_sym_number] = ACTIONS(3281),
    [anon_sym_boolean] = ACTIONS(3281),
    [anon_sym_string] = ACTIONS(3281),
    [anon_sym_symbol] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [sym_readonly] = ACTIONS(3281),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(3283),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [sym_number] = ACTIONS(3283),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_readonly] = ACTIONS(3285),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3289),
    [anon_sym_export] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_type] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym_import] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_with] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_debugger] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_case] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_function] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_void] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [sym_number] = ACTIONS(3287),
    [sym_this] = ACTIONS(3289),
    [sym_super] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_null] = ACTIONS(3289),
    [sym_undefined] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_get] = ACTIONS(3289),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_module] = ACTIONS(3289),
    [anon_sym_any] = ACTIONS(3289),
    [anon_sym_number] = ACTIONS(3289),
    [anon_sym_boolean] = ACTIONS(3289),
    [anon_sym_string] = ACTIONS(3289),
    [anon_sym_symbol] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [sym_readonly] = ACTIONS(3289),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(3291),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_with] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_SLASH] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [sym_number] = ACTIONS(3291),
    [sym_this] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [sym_null] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [sym_readonly] = ACTIONS(3293),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(3295),
    [sym_identifier] = ACTIONS(3297),
    [anon_sym_export] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_type] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_with] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_debugger] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_function] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_void] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [sym_this] = ACTIONS(3297),
    [sym_super] = ACTIONS(3297),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [sym_null] = ACTIONS(3297),
    [sym_undefined] = ACTIONS(3297),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_get] = ACTIONS(3297),
    [anon_sym_set] = ACTIONS(3297),
    [anon_sym_declare] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_module] = ACTIONS(3297),
    [anon_sym_any] = ACTIONS(3297),
    [anon_sym_number] = ACTIONS(3297),
    [anon_sym_boolean] = ACTIONS(3297),
    [anon_sym_string] = ACTIONS(3297),
    [anon_sym_symbol] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [sym_readonly] = ACTIONS(3297),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(3299),
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_with] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LT] = ACTIONS(3299),
    [anon_sym_SLASH] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3299),
    [sym_number] = ACTIONS(3299),
    [sym_this] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [sym_null] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [sym_readonly] = ACTIONS(3301),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(3303),
    [sym_identifier] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_default] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_type] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_with] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_debugger] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_case] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_void] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [sym_this] = ACTIONS(3305),
    [sym_super] = ACTIONS(3305),
    [sym_true] = ACTIONS(3305),
    [sym_false] = ACTIONS(3305),
    [sym_null] = ACTIONS(3305),
    [sym_undefined] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_get] = ACTIONS(3305),
    [anon_sym_set] = ACTIONS(3305),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_any] = ACTIONS(3305),
    [anon_sym_number] = ACTIONS(3305),
    [anon_sym_boolean] = ACTIONS(3305),
    [anon_sym_string] = ACTIONS(3305),
    [anon_sym_symbol] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [sym_readonly] = ACTIONS(3305),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(3307),
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [sym_number] = ACTIONS(3307),
    [sym_this] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3307),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [sym_readonly] = ACTIONS(3309),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(3311),
    [sym_identifier] = ACTIONS(3313),
    [anon_sym_export] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_type] = ACTIONS(3313),
    [anon_sym_typeof] = ACTIONS(3313),
    [anon_sym_import] = ACTIONS(3313),
    [anon_sym_var] = ACTIONS(3313),
    [anon_sym_let] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_else] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_with] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_debugger] = ACTIONS(3313),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_case] = ACTIONS(3313),
    [anon_sym_yield] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_SLASH] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_async] = ACTIONS(3313),
    [anon_sym_function] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_void] = ACTIONS(3313),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_this] = ACTIONS(3313),
    [sym_super] = ACTIONS(3313),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [sym_null] = ACTIONS(3313),
    [sym_undefined] = ACTIONS(3313),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_abstract] = ACTIONS(3313),
    [anon_sym_get] = ACTIONS(3313),
    [anon_sym_set] = ACTIONS(3313),
    [anon_sym_declare] = ACTIONS(3313),
    [anon_sym_public] = ACTIONS(3313),
    [anon_sym_private] = ACTIONS(3313),
    [anon_sym_protected] = ACTIONS(3313),
    [anon_sym_module] = ACTIONS(3313),
    [anon_sym_any] = ACTIONS(3313),
    [anon_sym_number] = ACTIONS(3313),
    [anon_sym_boolean] = ACTIONS(3313),
    [anon_sym_string] = ACTIONS(3313),
    [anon_sym_symbol] = ACTIONS(3313),
    [anon_sym_interface] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [sym_readonly] = ACTIONS(3313),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(3315),
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_default] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_else] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_with] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_debugger] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_case] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LT] = ACTIONS(3315),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_function] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_delete] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_this] = ACTIONS(3317),
    [sym_super] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [sym_readonly] = ACTIONS(3317),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(3319),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_export] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym_import] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_debugger] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3319),
    [anon_sym_SLASH] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_function] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3321),
    [anon_sym_delete] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_this] = ACTIONS(3321),
    [sym_super] = ACTIONS(3321),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_undefined] = ACTIONS(3321),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_declare] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_module] = ACTIONS(3321),
    [anon_sym_any] = ACTIONS(3321),
    [anon_sym_number] = ACTIONS(3321),
    [anon_sym_boolean] = ACTIONS(3321),
    [anon_sym_string] = ACTIONS(3321),
    [anon_sym_symbol] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [sym_readonly] = ACTIONS(3321),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(3323),
    [sym_identifier] = ACTIONS(3325),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_default] = ACTIONS(3325),
    [anon_sym_namespace] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_type] = ACTIONS(3325),
    [anon_sym_typeof] = ACTIONS(3325),
    [anon_sym_import] = ACTIONS(3325),
    [anon_sym_var] = ACTIONS(3325),
    [anon_sym_let] = ACTIONS(3325),
    [anon_sym_const] = ACTIONS(3325),
    [anon_sym_if] = ACTIONS(3325),
    [anon_sym_else] = ACTIONS(3325),
    [anon_sym_switch] = ACTIONS(3325),
    [anon_sym_for] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3325),
    [anon_sym_while] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3325),
    [anon_sym_try] = ACTIONS(3325),
    [anon_sym_with] = ACTIONS(3325),
    [anon_sym_break] = ACTIONS(3325),
    [anon_sym_continue] = ACTIONS(3325),
    [anon_sym_debugger] = ACTIONS(3325),
    [anon_sym_return] = ACTIONS(3325),
    [anon_sym_throw] = ACTIONS(3325),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_case] = ACTIONS(3325),
    [anon_sym_yield] = ACTIONS(3325),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3325),
    [anon_sym_class] = ACTIONS(3325),
    [anon_sym_async] = ACTIONS(3325),
    [anon_sym_function] = ACTIONS(3325),
    [anon_sym_new] = ACTIONS(3325),
    [anon_sym_PLUS] = ACTIONS(3325),
    [anon_sym_DASH] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_void] = ACTIONS(3325),
    [anon_sym_delete] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym_this] = ACTIONS(3325),
    [sym_super] = ACTIONS(3325),
    [sym_true] = ACTIONS(3325),
    [sym_false] = ACTIONS(3325),
    [sym_null] = ACTIONS(3325),
    [sym_undefined] = ACTIONS(3325),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3325),
    [anon_sym_abstract] = ACTIONS(3325),
    [anon_sym_get] = ACTIONS(3325),
    [anon_sym_set] = ACTIONS(3325),
    [anon_sym_declare] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3325),
    [anon_sym_private] = ACTIONS(3325),
    [anon_sym_protected] = ACTIONS(3325),
    [anon_sym_module] = ACTIONS(3325),
    [anon_sym_any] = ACTIONS(3325),
    [anon_sym_number] = ACTIONS(3325),
    [anon_sym_boolean] = ACTIONS(3325),
    [anon_sym_string] = ACTIONS(3325),
    [anon_sym_symbol] = ACTIONS(3325),
    [anon_sym_interface] = ACTIONS(3325),
    [anon_sym_enum] = ACTIONS(3325),
    [sym_readonly] = ACTIONS(3325),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(3327),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_export] = ACTIONS(3329),
    [anon_sym_default] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_type] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_else] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_with] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_debugger] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_case] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_SLASH] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_void] = ACTIONS(3329),
    [anon_sym_delete] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym_this] = ACTIONS(3329),
    [sym_super] = ACTIONS(3329),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_null] = ACTIONS(3329),
    [sym_undefined] = ACTIONS(3329),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_get] = ACTIONS(3329),
    [anon_sym_set] = ACTIONS(3329),
    [anon_sym_declare] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_module] = ACTIONS(3329),
    [anon_sym_any] = ACTIONS(3329),
    [anon_sym_number] = ACTIONS(3329),
    [anon_sym_boolean] = ACTIONS(3329),
    [anon_sym_string] = ACTIONS(3329),
    [anon_sym_symbol] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [sym_readonly] = ACTIONS(3329),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(3331),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_export] = ACTIONS(3333),
    [anon_sym_default] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym_import] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_with] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_debugger] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_case] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_function] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_void] = ACTIONS(3333),
    [anon_sym_delete] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym_this] = ACTIONS(3333),
    [sym_super] = ACTIONS(3333),
    [sym_true] = ACTIONS(3333),
    [sym_false] = ACTIONS(3333),
    [sym_null] = ACTIONS(3333),
    [sym_undefined] = ACTIONS(3333),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_get] = ACTIONS(3333),
    [anon_sym_set] = ACTIONS(3333),
    [anon_sym_declare] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_module] = ACTIONS(3333),
    [anon_sym_any] = ACTIONS(3333),
    [anon_sym_number] = ACTIONS(3333),
    [anon_sym_boolean] = ACTIONS(3333),
    [anon_sym_string] = ACTIONS(3333),
    [anon_sym_symbol] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [sym_readonly] = ACTIONS(3333),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(3335),
    [sym_identifier] = ACTIONS(3337),
    [anon_sym_export] = ACTIONS(3337),
    [anon_sym_default] = ACTIONS(3337),
    [anon_sym_namespace] = ACTIONS(3337),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3335),
    [anon_sym_type] = ACTIONS(3337),
    [anon_sym_typeof] = ACTIONS(3337),
    [anon_sym_import] = ACTIONS(3337),
    [anon_sym_var] = ACTIONS(3337),
    [anon_sym_let] = ACTIONS(3337),
    [anon_sym_const] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(3337),
    [anon_sym_else] = ACTIONS(3337),
    [anon_sym_switch] = ACTIONS(3337),
    [anon_sym_for] = ACTIONS(3337),
    [anon_sym_LPAREN] = ACTIONS(3335),
    [anon_sym_await] = ACTIONS(3337),
    [anon_sym_while] = ACTIONS(3337),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_try] = ACTIONS(3337),
    [anon_sym_with] = ACTIONS(3337),
    [anon_sym_break] = ACTIONS(3337),
    [anon_sym_continue] = ACTIONS(3337),
    [anon_sym_debugger] = ACTIONS(3337),
    [anon_sym_return] = ACTIONS(3337),
    [anon_sym_throw] = ACTIONS(3337),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym_case] = ACTIONS(3337),
    [anon_sym_yield] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3335),
    [anon_sym_LT] = ACTIONS(3335),
    [anon_sym_SLASH] = ACTIONS(3337),
    [anon_sym_class] = ACTIONS(3337),
    [anon_sym_async] = ACTIONS(3337),
    [anon_sym_function] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(3337),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3335),
    [anon_sym_void] = ACTIONS(3337),
    [anon_sym_delete] = ACTIONS(3337),
    [anon_sym_PLUS_PLUS] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3335),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_SQUOTE] = ACTIONS(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3335),
    [sym_number] = ACTIONS(3335),
    [sym_this] = ACTIONS(3337),
    [sym_super] = ACTIONS(3337),
    [sym_true] = ACTIONS(3337),
    [sym_false] = ACTIONS(3337),
    [sym_null] = ACTIONS(3337),
    [sym_undefined] = ACTIONS(3337),
    [anon_sym_AT] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3337),
    [anon_sym_get] = ACTIONS(3337),
    [anon_sym_set] = ACTIONS(3337),
    [anon_sym_declare] = ACTIONS(3337),
    [anon_sym_public] = ACTIONS(3337),
    [anon_sym_private] = ACTIONS(3337),
    [anon_sym_protected] = ACTIONS(3337),
    [anon_sym_module] = ACTIONS(3337),
    [anon_sym_any] = ACTIONS(3337),
    [anon_sym_number] = ACTIONS(3337),
    [anon_sym_boolean] = ACTIONS(3337),
    [anon_sym_string] = ACTIONS(3337),
    [anon_sym_symbol] = ACTIONS(3337),
    [anon_sym_interface] = ACTIONS(3337),
    [anon_sym_enum] = ACTIONS(3337),
    [sym_readonly] = ACTIONS(3337),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(3339),
    [sym_identifier] = ACTIONS(3341),
    [anon_sym_export] = ACTIONS(3341),
    [anon_sym_default] = ACTIONS(3341),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_LBRACE] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_type] = ACTIONS(3341),
    [anon_sym_typeof] = ACTIONS(3341),
    [anon_sym_import] = ACTIONS(3341),
    [anon_sym_var] = ACTIONS(3341),
    [anon_sym_let] = ACTIONS(3341),
    [anon_sym_const] = ACTIONS(3341),
    [anon_sym_if] = ACTIONS(3341),
    [anon_sym_else] = ACTIONS(3341),
    [anon_sym_switch] = ACTIONS(3341),
    [anon_sym_for] = ACTIONS(3341),
    [anon_sym_LPAREN] = ACTIONS(3339),
    [anon_sym_await] = ACTIONS(3341),
    [anon_sym_while] = ACTIONS(3341),
    [anon_sym_do] = ACTIONS(3341),
    [anon_sym_try] = ACTIONS(3341),
    [anon_sym_with] = ACTIONS(3341),
    [anon_sym_break] = ACTIONS(3341),
    [anon_sym_continue] = ACTIONS(3341),
    [anon_sym_debugger] = ACTIONS(3341),
    [anon_sym_return] = ACTIONS(3341),
    [anon_sym_throw] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_case] = ACTIONS(3341),
    [anon_sym_yield] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3339),
    [anon_sym_LT] = ACTIONS(3339),
    [anon_sym_SLASH] = ACTIONS(3341),
    [anon_sym_class] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3341),
    [anon_sym_function] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(3341),
    [anon_sym_PLUS] = ACTIONS(3341),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3339),
    [anon_sym_TILDE] = ACTIONS(3339),
    [anon_sym_void] = ACTIONS(3341),
    [anon_sym_delete] = ACTIONS(3341),
    [anon_sym_PLUS_PLUS] = ACTIONS(3339),
    [anon_sym_DASH_DASH] = ACTIONS(3339),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3339),
    [sym_number] = ACTIONS(3339),
    [sym_this] = ACTIONS(3341),
    [sym_super] = ACTIONS(3341),
    [sym_true] = ACTIONS(3341),
    [sym_false] = ACTIONS(3341),
    [sym_null] = ACTIONS(3341),
    [sym_undefined] = ACTIONS(3341),
    [anon_sym_AT] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3341),
    [anon_sym_abstract] = ACTIONS(3341),
    [anon_sym_get] = ACTIONS(3341),
    [anon_sym_set] = ACTIONS(3341),
    [anon_sym_declare] = ACTIONS(3341),
    [anon_sym_public] = ACTIONS(3341),
    [anon_sym_private] = ACTIONS(3341),
    [anon_sym_protected] = ACTIONS(3341),
    [anon_sym_module] = ACTIONS(3341),
    [anon_sym_any] = ACTIONS(3341),
    [anon_sym_number] = ACTIONS(3341),
    [anon_sym_boolean] = ACTIONS(3341),
    [anon_sym_string] = ACTIONS(3341),
    [anon_sym_symbol] = ACTIONS(3341),
    [anon_sym_interface] = ACTIONS(3341),
    [anon_sym_enum] = ACTIONS(3341),
    [sym_readonly] = ACTIONS(3341),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(3343),
    [sym_identifier] = ACTIONS(3345),
    [anon_sym_export] = ACTIONS(3345),
    [anon_sym_default] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_type] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym_import] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_with] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_debugger] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_case] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_SLASH] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_function] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_void] = ACTIONS(3345),
    [anon_sym_delete] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [sym_number] = ACTIONS(3343),
    [sym_this] = ACTIONS(3345),
    [sym_super] = ACTIONS(3345),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_AT] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_get] = ACTIONS(3345),
    [anon_sym_set] = ACTIONS(3345),
    [anon_sym_declare] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_module] = ACTIONS(3345),
    [anon_sym_any] = ACTIONS(3345),
    [anon_sym_number] = ACTIONS(3345),
    [anon_sym_boolean] = ACTIONS(3345),
    [anon_sym_string] = ACTIONS(3345),
    [anon_sym_symbol] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [sym_readonly] = ACTIONS(3345),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_export] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym_import] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_with] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_debugger] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_case] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LT] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_function] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_void] = ACTIONS(3349),
    [anon_sym_delete] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3347),
    [sym_number] = ACTIONS(3347),
    [sym_this] = ACTIONS(3349),
    [sym_super] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [sym_false] = ACTIONS(3349),
    [sym_null] = ACTIONS(3349),
    [sym_undefined] = ACTIONS(3349),
    [anon_sym_AT] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_get] = ACTIONS(3349),
    [anon_sym_set] = ACTIONS(3349),
    [anon_sym_declare] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_module] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3349),
    [anon_sym_number] = ACTIONS(3349),
    [anon_sym_boolean] = ACTIONS(3349),
    [anon_sym_string] = ACTIONS(3349),
    [anon_sym_symbol] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [sym_readonly] = ACTIONS(3349),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(3351),
    [sym_identifier] = ACTIONS(3353),
    [anon_sym_export] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_import] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_else] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_debugger] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3351),
    [sym_number] = ACTIONS(3351),
    [sym_this] = ACTIONS(3353),
    [sym_super] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_null] = ACTIONS(3353),
    [sym_undefined] = ACTIONS(3353),
    [anon_sym_AT] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_get] = ACTIONS(3353),
    [anon_sym_set] = ACTIONS(3353),
    [anon_sym_declare] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_any] = ACTIONS(3353),
    [anon_sym_number] = ACTIONS(3353),
    [anon_sym_boolean] = ACTIONS(3353),
    [anon_sym_string] = ACTIONS(3353),
    [anon_sym_symbol] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [sym_readonly] = ACTIONS(3353),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(3355),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [sym_number] = ACTIONS(3355),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_readonly] = ACTIONS(3357),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(3359),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_export] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_import] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_debugger] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(3359),
    [anon_sym_SLASH] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3359),
    [sym_number] = ACTIONS(3359),
    [sym_this] = ACTIONS(3361),
    [sym_super] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_AT] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_declare] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [sym_readonly] = ACTIONS(3361),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_export] = ACTIONS(3365),
    [anon_sym_default] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_type] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym_import] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_with] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_debugger] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_case] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_void] = ACTIONS(3365),
    [anon_sym_delete] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [sym_this] = ACTIONS(3365),
    [sym_super] = ACTIONS(3365),
    [sym_true] = ACTIONS(3365),
    [sym_false] = ACTIONS(3365),
    [sym_null] = ACTIONS(3365),
    [sym_undefined] = ACTIONS(3365),
    [anon_sym_AT] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3365),
    [anon_sym_set] = ACTIONS(3365),
    [anon_sym_declare] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_module] = ACTIONS(3365),
    [anon_sym_any] = ACTIONS(3365),
    [anon_sym_number] = ACTIONS(3365),
    [anon_sym_boolean] = ACTIONS(3365),
    [anon_sym_string] = ACTIONS(3365),
    [anon_sym_symbol] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [sym_readonly] = ACTIONS(3365),
  },
  [698] = {
    [sym__call_signature] = STATE(3048),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_type] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(595),
    [anon_sym_of] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_get] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(3071),
    [anon_sym_declare] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_any] = ACTIONS(3071),
    [anon_sym_number] = ACTIONS(3071),
    [anon_sym_boolean] = ACTIONS(3071),
    [anon_sym_string] = ACTIONS(3071),
    [anon_sym_symbol] = ACTIONS(3071),
    [sym_readonly] = ACTIONS(3071),
  },
  [699] = {
    [sym__call_signature] = STATE(3048),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_type] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(836),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_get] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(3071),
    [anon_sym_declare] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_any] = ACTIONS(3071),
    [anon_sym_number] = ACTIONS(3071),
    [anon_sym_boolean] = ACTIONS(3071),
    [anon_sym_string] = ACTIONS(3071),
    [anon_sym_symbol] = ACTIONS(3071),
    [sym_readonly] = ACTIONS(3071),
  },
  [700] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3036),
    [anon_sym_export] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(806),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_type] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3038),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(700),
    [anon_sym_PLUS_EQ] = ACTIONS(820),
    [anon_sym_DASH_EQ] = ACTIONS(820),
    [anon_sym_STAR_EQ] = ACTIONS(820),
    [anon_sym_SLASH_EQ] = ACTIONS(820),
    [anon_sym_PERCENT_EQ] = ACTIONS(820),
    [anon_sym_CARET_EQ] = ACTIONS(820),
    [anon_sym_AMP_EQ] = ACTIONS(820),
    [anon_sym_PIPE_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_LT_LT_EQ] = ACTIONS(820),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_get] = ACTIONS(3038),
    [anon_sym_set] = ACTIONS(3038),
    [anon_sym_declare] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_module] = ACTIONS(3038),
    [anon_sym_any] = ACTIONS(3038),
    [anon_sym_number] = ACTIONS(3038),
    [anon_sym_boolean] = ACTIONS(3038),
    [anon_sym_string] = ACTIONS(3038),
    [anon_sym_symbol] = ACTIONS(3038),
    [sym_readonly] = ACTIONS(3038),
  },
  [701] = {
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(600),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_symbol] = ACTIONS(2976),
    [sym_readonly] = ACTIONS(2976),
  },
  [702] = {
    [sym__call_signature] = STATE(3048),
    [sym_formal_parameters] = STATE(2576),
    [sym_type_parameters] = STATE(2837),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(497),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_type] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(2990),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(758),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_STAR_EQ] = ACTIONS(525),
    [anon_sym_SLASH_EQ] = ACTIONS(525),
    [anon_sym_PERCENT_EQ] = ACTIONS(525),
    [anon_sym_CARET_EQ] = ACTIONS(525),
    [anon_sym_AMP_EQ] = ACTIONS(525),
    [anon_sym_PIPE_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(525),
    [anon_sym_LT_LT_EQ] = ACTIONS(525),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_get] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(3071),
    [anon_sym_declare] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_any] = ACTIONS(3071),
    [anon_sym_number] = ACTIONS(3071),
    [anon_sym_boolean] = ACTIONS(3071),
    [anon_sym_string] = ACTIONS(3071),
    [anon_sym_symbol] = ACTIONS(3071),
    [sym_readonly] = ACTIONS(3071),
  },
  [703] = {
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(695),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(681),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(681),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_EQ_GT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_symbol] = ACTIONS(2976),
    [sym_readonly] = ACTIONS(2976),
  },
  [704] = {
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_number] = ACTIONS(3369),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_readonly] = ACTIONS(3367),
  },
  [705] = {
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_export] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_type] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym_import] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_with] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_debugger] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_SLASH] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_function] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_void] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [sym_number] = ACTIONS(3373),
    [sym_this] = ACTIONS(3371),
    [sym_super] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_null] = ACTIONS(3371),
    [sym_undefined] = ACTIONS(3371),
    [anon_sym_AT] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_get] = ACTIONS(3371),
    [anon_sym_set] = ACTIONS(3371),
    [anon_sym_declare] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_module] = ACTIONS(3371),
    [anon_sym_any] = ACTIONS(3371),
    [anon_sym_number] = ACTIONS(3371),
    [anon_sym_boolean] = ACTIONS(3371),
    [anon_sym_string] = ACTIONS(3371),
    [anon_sym_symbol] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [sym_readonly] = ACTIONS(3371),
  },
  [706] = {
    [sym_identifier] = ACTIONS(3375),
    [anon_sym_export] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym_import] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_with] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_debugger] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_function] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [sym_this] = ACTIONS(3375),
    [sym_super] = ACTIONS(3375),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_undefined] = ACTIONS(3375),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_get] = ACTIONS(3375),
    [anon_sym_set] = ACTIONS(3375),
    [anon_sym_declare] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_module] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3375),
    [anon_sym_number] = ACTIONS(3375),
    [anon_sym_boolean] = ACTIONS(3375),
    [anon_sym_string] = ACTIONS(3375),
    [anon_sym_symbol] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [sym_readonly] = ACTIONS(3375),
  },
  [707] = {
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3381),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_SLASH] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3381),
    [anon_sym_TILDE] = ACTIONS(3381),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3381),
    [sym_number] = ACTIONS(3381),
    [sym_this] = ACTIONS(3379),
    [sym_super] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_null] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3381),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [sym_readonly] = ACTIONS(3379),
  },
  [708] = {
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_export] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_type] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym_import] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_with] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_debugger] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_function] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_void] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym_number] = ACTIONS(3385),
    [sym_this] = ACTIONS(3383),
    [sym_super] = ACTIONS(3383),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [sym_null] = ACTIONS(3383),
    [sym_undefined] = ACTIONS(3383),
    [anon_sym_AT] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_get] = ACTIONS(3383),
    [anon_sym_set] = ACTIONS(3383),
    [anon_sym_declare] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_module] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3383),
    [anon_sym_number] = ACTIONS(3383),
    [anon_sym_boolean] = ACTIONS(3383),
    [anon_sym_string] = ACTIONS(3383),
    [anon_sym_symbol] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [sym_readonly] = ACTIONS(3383),
  },
  [709] = {
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym_import] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_debugger] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_void] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [sym_number] = ACTIONS(3389),
    [sym_this] = ACTIONS(3387),
    [sym_super] = ACTIONS(3387),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [sym_null] = ACTIONS(3387),
    [sym_undefined] = ACTIONS(3387),
    [anon_sym_AT] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_get] = ACTIONS(3387),
    [anon_sym_set] = ACTIONS(3387),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_any] = ACTIONS(3387),
    [anon_sym_number] = ACTIONS(3387),
    [anon_sym_boolean] = ACTIONS(3387),
    [anon_sym_string] = ACTIONS(3387),
    [anon_sym_symbol] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [sym_readonly] = ACTIONS(3387),
  },
  [710] = {
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_with] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_debugger] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym_number] = ACTIONS(3393),
    [sym_this] = ACTIONS(3391),
    [sym_super] = ACTIONS(3391),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [sym_null] = ACTIONS(3391),
    [sym_undefined] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_get] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3391),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [sym_readonly] = ACTIONS(3391),
  },
  [711] = {
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3397),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3397),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3397),
    [anon_sym_LT] = ACTIONS(3397),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_TILDE] = ACTIONS(3397),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3397),
    [anon_sym_DASH_DASH] = ACTIONS(3397),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_SQUOTE] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3397),
    [sym_number] = ACTIONS(3397),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_readonly] = ACTIONS(3395),
  },
  [712] = {
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_with] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_debugger] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_this] = ACTIONS(3399),
    [sym_super] = ACTIONS(3399),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_undefined] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_get] = ACTIONS(3399),
    [anon_sym_set] = ACTIONS(3399),
    [anon_sym_declare] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [sym_readonly] = ACTIONS(3399),
  },
  [713] = {
    [sym_identifier] = ACTIONS(3403),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_with] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_debugger] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_SLASH] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3405),
    [sym_number] = ACTIONS(3405),
    [sym_this] = ACTIONS(3403),
    [sym_super] = ACTIONS(3403),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [sym_null] = ACTIONS(3403),
    [sym_undefined] = ACTIONS(3403),
    [anon_sym_AT] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [sym_readonly] = ACTIONS(3403),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1087), 1,
      sym_string,
    STATE(1151), 1,
      sym_arguments,
    STATE(1195), 1,
      sym__module,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 15,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [96] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3413), 1,
      sym_identifier,
    ACTIONS(3415), 1,
      anon_sym_DQUOTE,
    ACTIONS(3417), 1,
      anon_sym_SQUOTE,
    STATE(118), 1,
      sym_string,
    STATE(119), 1,
      sym_nested_identifier,
    STATE(140), 1,
      sym__module,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [194] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3413), 1,
      sym_identifier,
    ACTIONS(3415), 1,
      anon_sym_DQUOTE,
    ACTIONS(3417), 1,
      anon_sym_SQUOTE,
    STATE(118), 1,
      sym_string,
    STATE(119), 1,
      sym_nested_identifier,
    STATE(140), 1,
      sym__module,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [292] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3419), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [390] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    STATE(1496), 1,
      sym_type_arguments,
    STATE(1641), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [486] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3419), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [584] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3419), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [682] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3413), 1,
      sym_identifier,
    ACTIONS(3415), 1,
      anon_sym_DQUOTE,
    ACTIONS(3417), 1,
      anon_sym_SQUOTE,
    STATE(118), 1,
      sym_string,
    STATE(119), 1,
      sym_nested_identifier,
    STATE(140), 1,
      sym__module,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [780] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1087), 1,
      sym_string,
    STATE(1151), 1,
      sym_arguments,
    STATE(1195), 1,
      sym__module,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [875] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(693), 1,
      anon_sym_EQ_GT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    STATE(1653), 1,
      sym_type_arguments,
    STATE(1741), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 13,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(495), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [970] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(606), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1087), 1,
      sym_string,
    STATE(1151), 1,
      sym_arguments,
    STATE(1195), 1,
      sym__module,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [1065] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3429), 1,
      sym_identifier,
    STATE(1080), 1,
      sym_string,
    STATE(1081), 1,
      sym_nested_identifier,
    STATE(1362), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1151] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_in,
    ACTIONS(598), 1,
      anon_sym_of,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3429), 1,
      sym_identifier,
    STATE(1080), 1,
      sym_string,
    STATE(1081), 1,
      sym_nested_identifier,
    STATE(1362), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1241] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(602), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3413), 1,
      sym_identifier,
    ACTIONS(3415), 1,
      anon_sym_DQUOTE,
    ACTIONS(3417), 1,
      anon_sym_SQUOTE,
    STATE(118), 1,
      sym_string,
    STATE(119), 1,
      sym_nested_identifier,
    STATE(140), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1329] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3429), 1,
      sym_identifier,
    STATE(1080), 1,
      sym_string,
    STATE(1081), 1,
      sym_nested_identifier,
    STATE(1362), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1417] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(602), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3419), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1505] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_EQ_GT,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    STATE(1496), 1,
      sym_type_arguments,
    STATE(1641), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1599] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3419), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1687] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1773] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(688), 1,
      anon_sym_QMARK,
    ACTIONS(695), 1,
      anon_sym_EQ,
    ACTIONS(698), 1,
      anon_sym_COLON,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(681), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1864] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3433), 1,
      anon_sym_export,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3439), 1,
      anon_sym_RBRACE,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3447), 1,
      anon_sym_async,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3457), 1,
      anon_sym_static,
    ACTIONS(3463), 1,
      sym_readonly,
    ACTIONS(3465), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2676), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3459), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3461), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3431), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1993] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(604), 1,
      anon_sym_COLON,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2080] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3433), 1,
      anon_sym_export,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3447), 1,
      anon_sym_async,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3457), 1,
      anon_sym_static,
    ACTIONS(3463), 1,
      sym_readonly,
    ACTIONS(3465), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3467), 1,
      anon_sym_RBRACE,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2676), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3459), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3461), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3431), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2209] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(606), 1,
      anon_sym_EQ_GT,
    ACTIONS(770), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(786), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [2294] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3433), 1,
      anon_sym_export,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3447), 1,
      anon_sym_async,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3457), 1,
      anon_sym_static,
    ACTIONS(3463), 1,
      sym_readonly,
    ACTIONS(3465), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3469), 1,
      anon_sym_RBRACE,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2676), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3459), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3461), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3431), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2423] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3465), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3473), 1,
      anon_sym_export,
    ACTIONS(3475), 1,
      anon_sym_RBRACE,
    ACTIONS(3477), 1,
      anon_sym_async,
    ACTIONS(3479), 1,
      anon_sym_static,
    ACTIONS(3485), 1,
      sym_readonly,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3481), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3483), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2654), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3471), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2552] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1087), 1,
      sym_string,
    STATE(1151), 1,
      sym_arguments,
    STATE(1195), 1,
      sym__module,
    ACTIONS(503), 12,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(495), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2645] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(678), 1,
      anon_sym_EQ,
    ACTIONS(688), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(681), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(626), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2734] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3465), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3489), 1,
      anon_sym_export,
    ACTIONS(3491), 1,
      anon_sym_RBRACE,
    ACTIONS(3493), 1,
      anon_sym_async,
    ACTIONS(3495), 1,
      anon_sym_static,
    ACTIONS(3501), 1,
      sym_readonly,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2764), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3497), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3499), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2766), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3487), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2863] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3465), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3505), 1,
      anon_sym_export,
    ACTIONS(3507), 1,
      anon_sym_RBRACE,
    ACTIONS(3509), 1,
      anon_sym_async,
    ACTIONS(3511), 1,
      anon_sym_static,
    ACTIONS(3517), 1,
      sym_readonly,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2613), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3513), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3515), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2612), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3503), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2992] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3433), 1,
      anon_sym_export,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3447), 1,
      anon_sym_async,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3457), 1,
      anon_sym_static,
    ACTIONS(3463), 1,
      sym_readonly,
    ACTIONS(3519), 1,
      anon_sym_COMMA,
    ACTIONS(3521), 1,
      anon_sym_RBRACE,
    ACTIONS(3523), 1,
      anon_sym_SEMI,
    ACTIONS(3525), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2676), 1,
      aux_sym_object_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3459), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3461), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2295), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3431), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [3121] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(700), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1087), 1,
      sym_string,
    STATE(1151), 1,
      sym_arguments,
    STATE(1195), 1,
      sym__module,
    ACTIONS(503), 12,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(495), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3214] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_EQ_GT,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3527), 1,
      sym_identifier,
    STATE(1604), 1,
      sym_nested_identifier,
    STATE(1609), 1,
      sym_string,
    STATE(1779), 1,
      sym__module,
    ACTIONS(734), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(445), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3299] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(612), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(626), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3384] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(604), 1,
      anon_sym_COLON,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3470] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(646), 1,
      anon_sym_EQ,
    ACTIONS(658), 1,
      anon_sym_EQ_GT,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3429), 1,
      sym_identifier,
    STATE(1080), 1,
      sym_string,
    STATE(1081), 1,
      sym_nested_identifier,
    STATE(1362), 1,
      sym__module,
    ACTIONS(662), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3630] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(836), 1,
      anon_sym_in,
    ACTIONS(839), 1,
      anon_sym_of,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3405), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3843] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3546), 1,
      anon_sym_LT,
    ACTIONS(3549), 1,
      anon_sym_DOT,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3558), 1,
      anon_sym_is,
    STATE(2097), 1,
      sym_type_arguments,
    ACTIONS(3555), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2890), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3543), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [3926] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3560), 1,
      sym_identifier,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4009] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4092] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3560), 1,
      sym_identifier,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3377), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3564), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4301] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3560), 1,
      sym_identifier,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4384] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(700), 1,
      anon_sym_EQ_GT,
    ACTIONS(806), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(820), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3568), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4530] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(595), 1,
      anon_sym_in,
    ACTIONS(598), 1,
      anon_sym_of,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3407), 1,
      sym_identifier,
    STATE(1076), 1,
      sym_nested_identifier,
    STATE(1087), 1,
      sym_string,
    STATE(1195), 1,
      sym__module,
    ACTIONS(453), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4617] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_EQ,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    STATE(2484), 1,
      sym_type_annotation,
    STATE(2675), 1,
      sym__initializer,
    ACTIONS(3572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    STATE(1463), 1,
      sym_type_arguments,
    STATE(1626), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ,
    ACTIONS(3377), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3589), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3591), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4844] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3593), 1,
      anon_sym_EQ,
    ACTIONS(3595), 1,
      anon_sym_LPAREN,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(3598), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4924] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3605), 1,
      anon_sym_export,
    ACTIONS(3609), 1,
      anon_sym_async,
    ACTIONS(3611), 1,
      anon_sym_static,
    ACTIONS(3617), 1,
      sym_readonly,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3613), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3615), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2962), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2250), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3603), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5042] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    STATE(1496), 1,
      sym_type_arguments,
    STATE(1641), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5120] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5200] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5280] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(1133), 1,
      sym_template_string,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1131), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5396] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3593), 1,
      anon_sym_EQ,
    ACTIONS(3595), 1,
      anon_sym_LPAREN,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(3598), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1151), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3656), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [5620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3662), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_is,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [5700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5778] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(447), 1,
      anon_sym_EQ,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(1521), 1,
      anon_sym_LPAREN,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(476), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(1759), 1,
      sym_template_string,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1760), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(459), 1,
      anon_sym_COLON,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3593), 1,
      anon_sym_EQ,
    ACTIONS(3595), 1,
      anon_sym_LPAREN,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(3598), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6054] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3702), 1,
      anon_sym_DOT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6134] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_STAR,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3445), 1,
      anon_sym_LBRACK,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3455), 1,
      sym_number,
    ACTIONS(3605), 1,
      anon_sym_export,
    ACTIONS(3609), 1,
      anon_sym_async,
    ACTIONS(3611), 1,
      anon_sym_static,
    ACTIONS(3617), 1,
      sym_readonly,
    STATE(1980), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3613), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3615), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2035), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2962), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2239), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3603), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [6252] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(1590), 1,
      sym_template_string,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1588), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3741), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6436] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3750), 1,
      anon_sym_GT,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6549] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(693), 1,
      anon_sym_EQ_GT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    STATE(1653), 1,
      sym_type_arguments,
    STATE(1741), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(495), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6626] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3756), 1,
      sym_identifier,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2758), 1,
      sym_type_parameter,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2342), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6739] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3758), 1,
      anon_sym_EQ,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    ACTIONS(3764), 1,
      anon_sym_DOT,
    ACTIONS(3766), 1,
      anon_sym_EQ_GT,
    STATE(508), 1,
      sym_type_arguments,
    STATE(2590), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3760), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3768), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6818] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym_COMMA,
    ACTIONS(3543), 1,
      anon_sym_LBRACK,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(3772), 1,
      anon_sym_DOT,
    ACTIONS(3774), 1,
      anon_sym_EQ_GT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3776), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6899] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(572), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(549), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(558), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6974] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3778), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7087] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3780), 1,
      anon_sym_RBRACK,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2639), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7200] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3782), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7313] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3662), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3758), 1,
      anon_sym_EQ,
    ACTIONS(3766), 1,
      anon_sym_EQ_GT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3768), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [7392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3766), 1,
      anon_sym_EQ_GT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7469] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(3786), 1,
      anon_sym_EQ_GT,
    STATE(1648), 1,
      sym_type_arguments,
    STATE(1745), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3529), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7546] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3788), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7659] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3790), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7772] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3786), 1,
      anon_sym_EQ_GT,
    ACTIONS(3792), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_LBRACE,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
    ACTIONS(3798), 1,
      anon_sym_LT,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    STATE(2572), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2671), 1,
      sym_type_arguments,
    ACTIONS(3803), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7853] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3805), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7966] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3807), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8079] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(606), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1151), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8156] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3786), 1,
      anon_sym_EQ_GT,
    ACTIONS(3792), 1,
      anon_sym_EQ,
    ACTIONS(3809), 1,
      anon_sym_DOT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3803), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8235] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3811), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1151), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8425] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3813), 1,
      anon_sym_RBRACK,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2679), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8538] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3815), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8651] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3817), 1,
      anon_sym_RBRACK,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2792), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8764] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    STATE(1463), 1,
      sym_type_arguments,
    STATE(1626), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8837] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [8914] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3821), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9027] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3823), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9140] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3825), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9253] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3827), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9366] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3829), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9479] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3831), 1,
      anon_sym_RBRACK,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2696), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9592] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_LBRACK,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    ACTIONS(3833), 1,
      anon_sym_EQ,
    ACTIONS(3839), 1,
      anon_sym_RPAREN,
    ACTIONS(3843), 1,
      anon_sym_DOT,
    ACTIONS(3847), 1,
      anon_sym_QMARK,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3555), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3836), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [9677] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3850), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9790] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3852), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9903] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3854), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10016] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3560), 1,
      sym_identifier,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [10089] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3856), 1,
      anon_sym_GT,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10202] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3858), 1,
      anon_sym_RBRACK,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2610), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10315] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(602), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3560), 1,
      sym_identifier,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [10388] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3662), 1,
      anon_sym_DOT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3543), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10467] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3862), 1,
      anon_sym_DOT,
    ACTIONS(2778), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2776), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [10540] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [10608] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2494), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10718] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(582), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10828] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2529), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10938] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2416), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11048] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1172), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3405), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11218] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2452), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11328] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(658), 1,
      anon_sym_EQ_GT,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    STATE(1496), 1,
      sym_type_arguments,
    STATE(1641), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11404] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2373), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(602), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11584] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2074), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11694] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2715), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3568), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11864] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2534), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11974] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1201), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12084] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2699), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12194] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_in,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_of,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [12266] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(579), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12376] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1203), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12486] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3774), 1,
      anon_sym_EQ_GT,
    STATE(1463), 1,
      sym_type_arguments,
    STATE(1626), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [12562] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3900), 1,
      anon_sym_in,
    ACTIONS(3903), 1,
      anon_sym_of,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [12634] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3905), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [12704] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2520), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12814] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2407), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12924] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2523), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13034] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3907), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13106] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2130), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13216] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2525), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13326] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(522), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13436] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2487), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13546] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2472), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13656] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2420), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13766] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(523), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13876] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(523), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13986] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(522), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3377), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14156] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2410), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14266] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(589), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14376] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1560), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14486] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1556), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14596] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    STATE(2824), 1,
      sym_type_annotation,
    ACTIONS(3909), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [14670] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym_COMMA,
    ACTIONS(3543), 1,
      anon_sym_LBRACK,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3914), 1,
      anon_sym_EQ,
    ACTIONS(3916), 1,
      anon_sym_DOT,
    ACTIONS(3918), 1,
      anon_sym_EQ_GT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3920), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [14750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14810] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3758), 1,
      anon_sym_EQ,
    ACTIONS(3764), 1,
      anon_sym_DOT,
    ACTIONS(3766), 1,
      anon_sym_EQ_GT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3922), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3768), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [14884] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    STATE(1648), 1,
      sym_type_arguments,
    STATE(1745), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3529), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [14956] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(581), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15066] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3564), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15194] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15266] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1262), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15376] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3924), 1,
      anon_sym_DOT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3555), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3543), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15454] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1260), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15564] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(584), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15674] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(517), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15784] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(516), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15894] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3786), 1,
      anon_sym_EQ_GT,
    ACTIONS(3792), 1,
      anon_sym_EQ,
    ACTIONS(3798), 1,
      anon_sym_LT,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3926), 1,
      anon_sym_LBRACE,
    STATE(2671), 1,
      sym_type_arguments,
    ACTIONS(3922), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3803), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15970] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1516), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16080] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1839), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16190] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1565), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16300] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1566), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16410] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1258), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16520] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(602), 1,
      anon_sym_COLON,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16658] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1186), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16768] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3866), 1,
      anon_sym_new,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3870), 1,
      anon_sym_AMP,
    ACTIONS(3872), 1,
      anon_sym_PIPE,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(2976), 1,
      sym_type_parameters,
    STATE(3087), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(586), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16878] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2199), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16988] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2079), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_EQ_GT,
    ACTIONS(591), 1,
      anon_sym_EQ,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(474), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17168] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1517), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17278] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(593), 1,
      anon_sym_COLON,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17348] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1602), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17458] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17526] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1257), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17636] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2342), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17746] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1519), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17856] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(453), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17928] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2100), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18038] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2102), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18148] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3712), 1,
      anon_sym_LPAREN,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3716), 1,
      anon_sym_new,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3720), 1,
      anon_sym_AMP,
    ACTIONS(3722), 1,
      anon_sym_PIPE,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3730), 1,
      sym_this,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(2828), 1,
      sym_type_parameters,
    STATE(3156), 1,
      sym_formal_parameters,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    STATE(1520), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1586), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3587), 1,
      anon_sym_EQ_GT,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3928), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18328] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3627), 1,
      anon_sym_LPAREN,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3631), 1,
      anon_sym_new,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3635), 1,
      anon_sym_AMP,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3645), 1,
      sym_this,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(2950), 1,
      sym_type_parameters,
    STATE(3045), 1,
      sym_nested_identifier,
    STATE(3065), 1,
      sym_formal_parameters,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    STATE(1219), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1214), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18438] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2050), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18548] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1766), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18658] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1828), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(2768), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3738), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3741), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18836] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2643), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18946] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2084), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19056] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1765), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19166] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1791), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19276] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2575), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19386] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1790), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19496] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2412), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19606] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2042), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19716] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2628), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19826] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2082), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19936] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2073), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20046] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2263), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20156] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym_COMMA,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3543), 1,
      anon_sym_LBRACK,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    ACTIONS(3659), 1,
      anon_sym_LT,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(3916), 1,
      anon_sym_DOT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(3555), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20236] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1762), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20346] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2054), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20456] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2057), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20566] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1761), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20676] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(517), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20786] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2433), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20896] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(516), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21006] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2454), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21116] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2736), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1367), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3653), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3537), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21292] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2080), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21402] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3678), 1,
      anon_sym_new,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3682), 1,
      anon_sym_AMP,
    ACTIONS(3684), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3692), 1,
      sym_this,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_type_parameters,
    STATE(3026), 1,
      sym_nested_identifier,
    STATE(3186), 1,
      sym_formal_parameters,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    STATE(1758), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1815), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21512] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3930), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21584] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2203), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21694] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2627), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21804] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(867), 1,
      anon_sym_AMP,
    ACTIONS(869), 1,
      anon_sym_PIPE,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2941), 1,
      anon_sym_LPAREN,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(2947), 1,
      anon_sym_new,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3103), 1,
      sym_formal_parameters,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    STATE(2053), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(519), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [21914] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(983), 1,
      anon_sym_AMP,
    ACTIONS(985), 1,
      anon_sym_PIPE,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3882), 1,
      anon_sym_LPAREN,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_new,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(3894), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(2877), 1,
      sym_type_parameters,
    STATE(3018), 1,
      sym_formal_parameters,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    STATE(2081), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2106), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [22024] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3847), 1,
      anon_sym_QMARK,
    ACTIONS(3932), 1,
      anon_sym_EQ,
    ACTIONS(3935), 1,
      anon_sym_COLON,
    ACTIONS(3836), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22097] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1151), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 14,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ,
    ACTIONS(3377), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3589), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3591), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3656), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22361] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(700), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1084), 1,
      sym_type_arguments,
    STATE(1151), 1,
      sym_arguments,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(503), 14,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(495), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22436] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 1,
      anon_sym_EQ,
    ACTIONS(3766), 1,
      anon_sym_EQ_GT,
    ACTIONS(3930), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3768), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3741), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22572] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    ACTIONS(3937), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2778), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22643] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(688), 1,
      anon_sym_QMARK,
    ACTIONS(695), 1,
      anon_sym_EQ,
    ACTIONS(698), 1,
      anon_sym_COLON,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(681), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22716] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3918), 1,
      anon_sym_EQ_GT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 14,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22791] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_EQ_GT,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(734), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22862] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(612), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(626), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22933] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3758), 1,
      anon_sym_EQ,
    ACTIONS(3766), 1,
      anon_sym_EQ_GT,
    ACTIONS(3768), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23000] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3939), 1,
      anon_sym_in,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(604), 1,
      anon_sym_COLON,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23207] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(3774), 1,
      anon_sym_EQ_GT,
    ACTIONS(3943), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3776), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    ACTIONS(3930), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23349] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3533), 14,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3529), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23424] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(678), 1,
      anon_sym_EQ,
    ACTIONS(684), 1,
      anon_sym_RPAREN,
    ACTIONS(688), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(572), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(681), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(626), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_EQ_GT,
    ACTIONS(706), 1,
      anon_sym_EQ,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(734), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(445), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_EQ,
    ACTIONS(3900), 1,
      anon_sym_in,
    ACTIONS(3903), 1,
      anon_sym_of,
    ACTIONS(3601), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23635] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3786), 1,
      anon_sym_EQ_GT,
    ACTIONS(3792), 1,
      anon_sym_EQ,
    ACTIONS(3945), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3803), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23706] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(612), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(626), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23773] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_EQ_GT,
    ACTIONS(770), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(786), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23840] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 1,
      anon_sym_EQ_GT,
    ACTIONS(678), 1,
      anon_sym_EQ,
    ACTIONS(688), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(681), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(626), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23911] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(3786), 1,
      anon_sym_EQ_GT,
    ACTIONS(3792), 1,
      anon_sym_EQ,
    ACTIONS(3803), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1271), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23978] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_EQ_GT,
    ACTIONS(770), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(549), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(786), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3819), 1,
      anon_sym_EQ_GT,
    ACTIONS(3833), 1,
      anon_sym_EQ,
    ACTIONS(3847), 1,
      anon_sym_QMARK,
    ACTIONS(3836), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24183] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(558), 1,
      anon_sym_COMMA,
    ACTIONS(646), 1,
      anon_sym_EQ,
    ACTIONS(658), 1,
      anon_sym_EQ_GT,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(662), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3792), 1,
      anon_sym_EQ,
    ACTIONS(3803), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1271), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24318] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    ACTIONS(3939), 1,
      anon_sym_in,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24388] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      anon_sym_COMMA,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 1,
      anon_sym_LBRACK,
    ACTIONS(3741), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24454] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(558), 1,
      anon_sym_COMMA,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3562), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3564), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3656), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3741), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(3537), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24710] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(3774), 1,
      anon_sym_EQ_GT,
    ACTIONS(3776), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 1,
      anon_sym_EQ,
    ACTIONS(3768), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24838] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(558), 1,
      anon_sym_COMMA,
    ACTIONS(700), 1,
      anon_sym_EQ_GT,
    ACTIONS(806), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(572), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(820), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3741), 1,
      anon_sym_LT,
    ACTIONS(3738), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3537), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3377), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25090] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(604), 1,
      anon_sym_COLON,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3405), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3741), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25280] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(521), 1,
      anon_sym_EQ_GT,
    ACTIONS(545), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(572), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(549), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(570), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25350] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      anon_sym_COMMA,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 1,
      anon_sym_LBRACK,
    ACTIONS(3741), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ,
    ACTIONS(3377), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3591), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3589), 20,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_COMMA,
    ACTIONS(3653), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3656), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25542] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    ACTIONS(3947), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25612] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(3551), 1,
      anon_sym_EQ_GT,
    ACTIONS(3949), 1,
      anon_sym_DOT,
    ACTIONS(2778), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2776), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3553), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25682] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_COMMA,
    ACTIONS(3653), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3656), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 27,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 1,
      anon_sym_EQ,
    ACTIONS(3845), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3653), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3537), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 21,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3568), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_EQ,
    ACTIONS(658), 1,
      anon_sym_EQ_GT,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    ACTIONS(662), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 1,
      anon_sym_EQ,
    ACTIONS(3918), 1,
      anon_sym_EQ_GT,
    ACTIONS(3947), 1,
      anon_sym_DOT,
    ACTIONS(2776), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2778), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3920), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3741), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26128] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(595), 1,
      anon_sym_in,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3898), 1,
      anon_sym_of,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26197] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    ACTIONS(3900), 1,
      anon_sym_in,
    ACTIONS(3903), 1,
      anon_sym_of,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26266] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_EQ_GT,
    ACTIONS(806), 1,
      anon_sym_EQ,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(820), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3653), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
    ACTIONS(3537), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 1,
      anon_sym_EQ,
    ACTIONS(3776), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(836), 1,
      anon_sym_in,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(3951), 1,
      anon_sym_of,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26522] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3914), 1,
      anon_sym_EQ,
    ACTIONS(3918), 1,
      anon_sym_EQ_GT,
    ACTIONS(3920), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26652] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(758), 1,
      anon_sym_EQ_GT,
    ACTIONS(2921), 1,
      anon_sym_DOT,
    ACTIONS(525), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(453), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(445), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3583), 1,
      anon_sym_EQ_GT,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_DOT,
    ACTIONS(3738), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3741), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3537), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3539), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26909] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3959), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3961), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2298), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27013] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3443), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3465), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2288), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27117] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1509), 1,
      anon_sym_LBRACE,
    ACTIONS(3977), 1,
      anon_sym_STAR,
    ACTIONS(3979), 1,
      anon_sym_default,
    ACTIONS(3981), 1,
      anon_sym_EQ,
    ACTIONS(3983), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      sym_export_clause,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2463), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27221] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1509), 1,
      anon_sym_LBRACE,
    ACTIONS(3977), 1,
      anon_sym_STAR,
    ACTIONS(3979), 1,
      anon_sym_default,
    ACTIONS(3981), 1,
      anon_sym_EQ,
    ACTIONS(3983), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      sym_export_clause,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2463), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 1,
      anon_sym_EQ,
    ACTIONS(3920), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [27385] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1509), 1,
      anon_sym_LBRACE,
    ACTIONS(3977), 1,
      anon_sym_STAR,
    ACTIONS(3979), 1,
      anon_sym_default,
    ACTIONS(3981), 1,
      anon_sym_EQ,
    ACTIONS(3983), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      sym_export_clause,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2463), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27489] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4015), 1,
      sym_identifier,
    ACTIONS(4017), 1,
      anon_sym_STAR,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    STATE(2861), 1,
      sym_import_clause,
    ACTIONS(4025), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(2862), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3145), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(4019), 15,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4023), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27563] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4027), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4029), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2219), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27667] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4031), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4033), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3577), 1,
      anon_sym_of,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [27835] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1509), 1,
      anon_sym_LBRACE,
    ACTIONS(3977), 1,
      anon_sym_STAR,
    ACTIONS(3979), 1,
      anon_sym_default,
    ACTIONS(3981), 1,
      anon_sym_EQ,
    ACTIONS(3983), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      sym_export_clause,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2463), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27939] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3523), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3525), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2295), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      anon_sym_EQ,
    ACTIONS(3900), 1,
      anon_sym_in,
    ACTIONS(3903), 1,
      anon_sym_of,
    ACTIONS(3535), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1273), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1271), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [28107] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1509), 1,
      anon_sym_LBRACE,
    ACTIONS(3977), 1,
      anon_sym_STAR,
    ACTIONS(3979), 1,
      anon_sym_default,
    ACTIONS(3981), 1,
      anon_sym_EQ,
    ACTIONS(3983), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      sym_export_clause,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2463), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28210] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1509), 1,
      anon_sym_LBRACE,
    ACTIONS(3977), 1,
      anon_sym_STAR,
    ACTIONS(3979), 1,
      anon_sym_default,
    ACTIONS(3983), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    ACTIONS(4038), 1,
      anon_sym_EQ,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      sym_export_clause,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2463), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28311] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4040), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4042), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28511] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4044), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28611] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4046), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28711] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4048), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4050), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28911] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4052), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29011] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4054), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29111] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4056), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29211] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4058), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29311] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4060), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4062), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29511] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4064), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29611] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4066), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29711] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4068), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29811] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [29873] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2291), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4072), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4076), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30031] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2396), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30127] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2247), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4080), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4082), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30279] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2276), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30375] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(4084), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [30437] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4084), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [30503] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2250), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30661] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3449), 1,
      anon_sym_new,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3955), 1,
      anon_sym_export,
    ACTIONS(3957), 1,
      anon_sym_STAR,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_async,
    ACTIONS(3967), 1,
      sym_number,
    ACTIONS(3969), 1,
      anon_sym_static,
    ACTIONS(3975), 1,
      sym_readonly,
    STATE(1988), 1,
      sym_accessibility_modifier,
    STATE(2013), 1,
      sym_decorator,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2300), 1,
      sym__call_signature,
    STATE(2564), 1,
      aux_sym_export_statement_repeat1,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(3971), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2034), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2239), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3953), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1065), 1,
      sym_type_arguments,
    STATE(1145), 1,
      sym_arguments,
    STATE(1231), 1,
      sym_template_string,
    ACTIONS(3529), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3411), 1,
      anon_sym_LT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1148), 1,
      sym_arguments,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4088), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4090), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4094), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30976] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_LT,
    ACTIONS(4099), 1,
      anon_sym_DOT,
    ACTIONS(4101), 1,
      anon_sym_is,
    STATE(1188), 1,
      sym_type_arguments,
    ACTIONS(2892), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2890), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4105), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4109), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1097), 1,
      sym_arguments,
    STATE(1138), 1,
      sym_template_string,
    ACTIONS(4111), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4113), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4117), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4119), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4121), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1285), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [31345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1323), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [31396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 1,
      anon_sym_EQ,
    ACTIONS(4123), 1,
      sym__automatic_semicolon,
    ACTIONS(1197), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4127), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2800), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1199), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4123), 1,
      sym__automatic_semicolon,
    ACTIONS(1197), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31659] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_RPAREN,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2656), 1,
      aux_sym_array_repeat1,
    STATE(2998), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    ACTIONS(4165), 1,
      anon_sym_DOT,
    STATE(1261), 1,
      sym_statement_block,
    ACTIONS(1207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 1,
      sym__automatic_semicolon,
    ACTIONS(1235), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1233), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    STATE(1098), 1,
      sym_arguments,
    ACTIONS(4111), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4113), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_DOT,
    STATE(1188), 1,
      sym_type_arguments,
    ACTIONS(2927), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2925), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1387), 1,
      sym_statement_block,
    ACTIONS(1207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    ACTIONS(4171), 1,
      anon_sym_DOT,
    STATE(1387), 1,
      sym_statement_block,
    ACTIONS(1207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32085] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(4173), 1,
      anon_sym_EQ,
    ACTIONS(4177), 1,
      anon_sym_in,
    ACTIONS(4180), 1,
      anon_sym_of,
    STATE(2492), 1,
      sym_type_annotation,
    STATE(2722), 1,
      sym__initializer,
    ACTIONS(4175), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(4182), 1,
      anon_sym_EQ,
    ACTIONS(4186), 1,
      anon_sym_in,
    ACTIONS(4189), 1,
      anon_sym_of,
    STATE(2489), 1,
      sym_type_annotation,
    STATE(2705), 1,
      sym__initializer,
    ACTIONS(4184), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [32213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_arguments,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(937), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32267] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4191), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2670), 1,
      aux_sym_array_repeat1,
    STATE(2998), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1180), 1,
      sym_type_arguments,
    ACTIONS(2820), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2818), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1261), 1,
      sym_statement_block,
    ACTIONS(1207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32473] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4193), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2686), 1,
      aux_sym_array_repeat1,
    STATE(2998), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_LT,
    STATE(1180), 1,
      sym_type_arguments,
    ACTIONS(2967), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2965), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4204), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4206), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32728] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [32797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4223), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4225), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4229), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2846), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3591), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4233), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4233), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4237), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33144] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4241), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4269), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4273), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4275), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4277), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4279), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4281), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33431] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4283), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4287), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4291), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4295), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4117), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33767] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4299), 1,
      anon_sym_COMMA,
    ACTIONS(4302), 1,
      anon_sym_RBRACE,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4306), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33862] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4306), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33953] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4330), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4088), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4090), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34093] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4332), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACE,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4283), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34188] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4337), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1343), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34328] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4287), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34419] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4283), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34510] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4339), 1,
      anon_sym_COMMA,
    ACTIONS(4342), 1,
      anon_sym_RBRACE,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4344), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34605] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      anon_sym_LT,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [34674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4330), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34772] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4277), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4105), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4351), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34965] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4342), 1,
      anon_sym_RBRACE,
    ACTIONS(4354), 1,
      anon_sym_COMMA,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4337), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4360), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35113] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_DQUOTE,
    ACTIONS(748), 1,
      anon_sym_SQUOTE,
    ACTIONS(3666), 1,
      sym_identifier,
    ACTIONS(3668), 1,
      anon_sym_STAR,
    ACTIONS(3670), 1,
      anon_sym_LBRACE,
    ACTIONS(3672), 1,
      anon_sym_typeof,
    ACTIONS(3676), 1,
      anon_sym_LBRACK,
    ACTIONS(3680), 1,
      anon_sym_QMARK,
    ACTIONS(3690), 1,
      sym_number,
    ACTIONS(3696), 1,
      anon_sym_keyof,
    ACTIONS(3698), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4363), 1,
      anon_sym_LPAREN,
    ACTIONS(4365), 1,
      sym_this,
    STATE(1515), 1,
      sym_nested_type_identifier,
    STATE(3026), 1,
      sym_nested_identifier,
    ACTIONS(3686), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3694), 2,
      sym_true,
      sym_false,
    STATE(1814), 2,
      sym_string,
      sym__number,
    ACTIONS(3688), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1825), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35198] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4369), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4373), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35340] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(4084), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [35399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4373), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35448] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4084), 1,
      anon_sym_LT,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    STATE(2528), 1,
      sym_type_arguments,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [35511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1305), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35609] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [35698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4381), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4383), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4385), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35845] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3864), 1,
      sym_identifier,
    ACTIONS(3868), 1,
      anon_sym_QMARK,
    ACTIONS(3874), 1,
      anon_sym_keyof,
    ACTIONS(4387), 1,
      anon_sym_LPAREN,
    ACTIONS(4389), 1,
      sym_this,
    STATE(559), 1,
      sym_nested_type_identifier,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(524), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [35930] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4391), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4395), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36070] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4330), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4399), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4094), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36259] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(3135), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4399), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36405] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4403), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [36474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4408), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4412), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36572] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4414), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4416), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4418), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1229), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36761] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4420), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4424), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4428), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36950] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(3047), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37047] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4306), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37138] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4436), 1,
      anon_sym_LBRACE,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4468), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2571), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37235] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4470), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(3093), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4119), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4121), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1349), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1377), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4127), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37528] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4472), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37597] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4475), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2830), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37737] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4241), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [37917] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4477), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [37986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_AMP,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(3004), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3002), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2868), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38088] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4477), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [38163] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4273), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38254] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4403), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [38329] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [38414] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [38499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2786), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2794), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4486), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1285), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38695] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [38776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2818), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38825] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [38906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_AMP,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(3016), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3014), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38959] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4472), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2790), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2844), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39124] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_SQUOTE,
    ACTIONS(3619), 1,
      sym_identifier,
    ACTIONS(3621), 1,
      anon_sym_STAR,
    ACTIONS(3623), 1,
      anon_sym_LBRACE,
    ACTIONS(3625), 1,
      anon_sym_typeof,
    ACTIONS(3629), 1,
      anon_sym_LBRACK,
    ACTIONS(3633), 1,
      anon_sym_QMARK,
    ACTIONS(3643), 1,
      sym_number,
    ACTIONS(3649), 1,
      anon_sym_keyof,
    ACTIONS(3651), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4488), 1,
      anon_sym_LPAREN,
    ACTIONS(4490), 1,
      sym_this,
    STATE(1090), 1,
      sym_nested_type_identifier,
    STATE(3045), 1,
      sym_nested_identifier,
    ACTIONS(3639), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3647), 2,
      sym_true,
      sym_false,
    STATE(1211), 2,
      sym_string,
      sym__number,
    ACTIONS(3641), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1205), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39209] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4337), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4287), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39391] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4492), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39482] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_STAR,
    ACTIONS(981), 1,
      anon_sym_QMARK,
    ACTIONS(1001), 1,
      anon_sym_keyof,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(3880), 1,
      anon_sym_typeof,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3892), 1,
      sym_number,
    ACTIONS(4494), 1,
      anon_sym_LPAREN,
    ACTIONS(4496), 1,
      sym_this,
    STATE(2055), 1,
      sym_nested_type_identifier,
    STATE(3121), 1,
      sym_nested_identifier,
    ACTIONS(3888), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3896), 2,
      sym_true,
      sym_false,
    STATE(2108), 2,
      sym_string,
      sym__number,
    ACTIONS(3890), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(2103), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [39567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1353), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39616] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4277), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39707] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4273), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39798] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4498), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4109), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4502), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2848), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2804), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2802), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2852), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40134] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 13,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4504), 1,
      anon_sym_LBRACK,
    ACTIONS(2858), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2856), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 1,
      anon_sym_DOT,
    ACTIONS(2778), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2776), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2782), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2528), 1,
      sym_type_arguments,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4080), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4082), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2798), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(558), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2860), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2814), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40611] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4504), 1,
      anon_sym_LBRACK,
    ACTIONS(2836), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2834), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4241), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40788] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2998), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40885] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4477), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1367), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [41005] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_AMP,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(3026), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3024), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4512), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41107] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4403), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4516), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41227] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4518), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41318] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4385), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41409] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4344), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41500] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(3069), 1,
      sym_type_annotation,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41597] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_STAR,
    ACTIONS(865), 1,
      anon_sym_QMARK,
    ACTIONS(889), 1,
      anon_sym_keyof,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2939), 1,
      anon_sym_typeof,
    ACTIONS(2953), 1,
      sym_number,
    ACTIONS(3744), 1,
      sym_identifier,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(4387), 1,
      anon_sym_LPAREN,
    ACTIONS(4389), 1,
      sym_this,
    STATE(2028), 1,
      sym_nested_type_identifier,
    STATE(3104), 1,
      sym_nested_identifier,
    ACTIONS(2949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2957), 2,
      sym_true,
      sym_false,
    STATE(525), 2,
      sym_string,
      sym__number,
    ACTIONS(3752), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(524), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [41682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2874), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41731] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4518), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41822] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4385), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4524), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4528), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42011] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4420), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42102] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4391), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42193] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4475), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42284] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4344), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42375] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4498), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42466] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2589), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4468), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1323), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2810), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4558), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42708] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(3704), 1,
      sym_identifier,
    ACTIONS(3706), 1,
      anon_sym_STAR,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(3710), 1,
      anon_sym_typeof,
    ACTIONS(3714), 1,
      anon_sym_LBRACK,
    ACTIONS(3718), 1,
      anon_sym_QMARK,
    ACTIONS(3728), 1,
      sym_number,
    ACTIONS(3734), 1,
      anon_sym_keyof,
    ACTIONS(3736), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4560), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      sym_this,
    STATE(1461), 1,
      sym_nested_type_identifier,
    STATE(3184), 1,
      sym_nested_identifier,
    ACTIONS(3724), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3732), 2,
      sym_true,
      sym_false,
    STATE(1587), 2,
      sym_string,
      sym__number,
    ACTIONS(3726), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1567), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [42793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    STATE(1463), 1,
      sym_type_arguments,
    STATE(1626), 1,
      sym_arguments,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42852] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    STATE(1463), 1,
      sym_type_arguments,
    STATE(1626), 1,
      sym_arguments,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1367), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1263), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2878), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43058] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1231), 1,
      sym_template_string,
    STATE(1316), 1,
      sym_type_arguments,
    STATE(1625), 1,
      sym_arguments,
    ACTIONS(3529), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [43113] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4492), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1243), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1233), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1319), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2864), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2840), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43449] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4216), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_DOT,
    ACTIONS(2770), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2768), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_AMP,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(3012), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3010), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      anon_sym_AMP,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(3020), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3018), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2772), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2826), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1309), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2822), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2806), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1219), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1363), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1281), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1295), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1333), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4023), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44212] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    STATE(2528), 1,
      sym_type_arguments,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4072), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4076), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44271] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4472), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44340] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4273), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44430] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4241), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44570] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 8,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 11,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [44646] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44736] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44826] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4273), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44916] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4337), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45006] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4277), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 1,
      sym__automatic_semicolon,
    ACTIONS(1195), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1199), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45148] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4475), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45238] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4420), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45328] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4287), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45418] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4344), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45508] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4383), 1,
      anon_sym_LBRACE,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4385), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45600] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4569), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2670), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45694] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4571), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45762] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4518), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45852] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4574), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [45922] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [45998] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4577), 1,
      anon_sym_COMMA,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4579), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46090] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4567), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46180] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4581), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4344), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1263), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46320] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(4585), 1,
      anon_sym_RBRACE,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4589), 1,
      anon_sym_async,
    ACTIONS(4591), 1,
      sym_number,
    ACTIONS(4593), 1,
      anon_sym_static,
    ACTIONS(4599), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(2753), 1,
      aux_sym_object_repeat1,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(4595), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2159), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2654), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4583), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46406] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4601), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4391), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46498] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4330), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46588] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4603), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2704), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46682] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4492), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46772] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4306), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46862] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4498), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46952] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4283), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47042] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4605), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2718), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47224] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [47304] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [47388] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4574), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [47462] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4607), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47530] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4607), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47604] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47688] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47768] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47844] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4607), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47914] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4574), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [47982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1138), 1,
      sym_template_string,
    STATE(1675), 1,
      sym_arguments,
    ACTIONS(4111), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4113), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48034] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4375), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48122] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4283), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48212] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4306), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2605), 1,
      sym_type_arguments,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4080), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4082), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [48354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2798), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1199), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48406] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 4,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 6,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
  [48486] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4391), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48576] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4571), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48642] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4571), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48710] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 3,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 5,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48794] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4518), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48884] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4385), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LT,
    STATE(1463), 1,
      sym_type_arguments,
    STATE(1626), 1,
      sym_arguments,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49030] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4610), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 10,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 11,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49104] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4610), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49172] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4613), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2714), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49266] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4377), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4375), 3,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49354] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4391), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49444] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4084), 1,
      anon_sym_LT,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    STATE(2605), 1,
      sym_type_arguments,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [49506] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4344), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49596] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4271), 1,
      anon_sym_LBRACE,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4273), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49688] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4275), 1,
      anon_sym_LBRACE,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4277), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49780] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      sym_number,
    ACTIONS(4617), 1,
      anon_sym_RBRACE,
    ACTIONS(4619), 1,
      anon_sym_async,
    ACTIONS(4621), 1,
      anon_sym_static,
    ACTIONS(4627), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(2764), 1,
      aux_sym_object_repeat1,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(4623), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4625), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2159), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2766), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4615), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49866] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      sym_number,
    ACTIONS(4631), 1,
      anon_sym_RBRACE,
    ACTIONS(4633), 1,
      anon_sym_async,
    ACTIONS(4635), 1,
      anon_sym_static,
    ACTIONS(4641), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(2632), 1,
      aux_sym_object_repeat1,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(4637), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4639), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2159), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2631), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4629), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49952] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4643), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4283), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50044] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(4084), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [50102] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4285), 1,
      anon_sym_LBRACE,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4287), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50194] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4645), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2704), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50288] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4330), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50378] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4647), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4306), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50470] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4649), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2686), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50564] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4651), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2704), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50658] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4346), 1,
      anon_sym_LBRACE,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4330), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1349), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50798] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    STATE(2605), 1,
      sym_type_arguments,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4072), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4076), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [50856] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4653), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [50924] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4656), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2630), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51018] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4337), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51108] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4658), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4337), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51200] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4653), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [51266] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4241), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51356] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4475), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51446] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      sym_number,
    ACTIONS(4662), 1,
      anon_sym_RBRACE,
    ACTIONS(4664), 1,
      anon_sym_async,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4672), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(2676), 1,
      aux_sym_object_repeat1,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(4668), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4670), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2159), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2678), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4660), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51532] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4577), 1,
      anon_sym_COMMA,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51624] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4674), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2626), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1353), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51766] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4676), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2760), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51860] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4678), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1233), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51998] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4680), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4518), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4682), 1,
      sym__automatic_semicolon,
    ACTIONS(1235), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1233), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52140] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4684), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2760), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1231), 1,
      sym_template_string,
    STATE(1465), 1,
      sym_type_arguments,
    STATE(1747), 1,
      sym_arguments,
    ACTIONS(3529), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [52288] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    STATE(1648), 1,
      sym_type_arguments,
    STATE(1745), 1,
      sym_arguments,
    ACTIONS(3529), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [52346] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4241), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52438] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4653), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 15,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [52506] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4686), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [52574] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4492), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52664] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4577), 1,
      anon_sym_COMMA,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4689), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52756] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4577), 1,
      anon_sym_COMMA,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4691), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52848] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4693), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(2656), 1,
      aux_sym_array_repeat1,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52942] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4695), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4492), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53034] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4697), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4475), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53126] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4699), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4498), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53218] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4277), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4705), 1,
      sym_regex_flags,
    ACTIONS(4701), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4703), 23,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53358] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4287), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53448] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53538] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4707), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4420), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53630] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4310), 1,
      anon_sym_QMARK,
    ACTIONS(4312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4318), 1,
      anon_sym_AMP,
    ACTIONS(4320), 1,
      anon_sym_PIPE,
    ACTIONS(4324), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4328), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4314), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4322), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4297), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4316), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4304), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4326), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1309), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53768] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      sym_number,
    ACTIONS(4711), 1,
      anon_sym_RBRACE,
    ACTIONS(4713), 1,
      anon_sym_async,
    ACTIONS(4715), 1,
      anon_sym_static,
    ACTIONS(4721), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(2613), 1,
      aux_sym_object_repeat1,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(4717), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4719), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2159), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2612), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4709), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53854] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4420), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 1,
      sym__automatic_semicolon,
    ACTIONS(1197), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53994] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4498), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54084] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4385), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54174] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4610), 1,
      anon_sym_LT,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 14,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54244] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4686), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [54310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_LT,
    ACTIONS(4728), 1,
      anon_sym_DOT,
    ACTIONS(4730), 1,
      anon_sym_is,
    STATE(1563), 1,
      sym_type_arguments,
    ACTIONS(2892), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2890), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54414] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_as,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4442), 1,
      anon_sym_LT,
    ACTIONS(4444), 1,
      anon_sym_QMARK,
    ACTIONS(4446), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4452), 1,
      anon_sym_AMP,
    ACTIONS(4454), 1,
      anon_sym_PIPE,
    ACTIONS(4458), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4464), 1,
      anon_sym_BANG,
    ACTIONS(4732), 1,
      anon_sym_LBRACE,
    STATE(2605), 1,
      sym_type_arguments,
    ACTIONS(4448), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4466), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4734), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1727), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4432), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4450), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4438), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4460), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54506] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4686), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [54574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    STATE(1648), 1,
      sym_type_arguments,
    STATE(1745), 1,
      sym_arguments,
    ACTIONS(3529), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [54632] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4534), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_QMARK,
    ACTIONS(4538), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4544), 1,
      anon_sym_AMP,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4554), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4540), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4548), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4530), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4542), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4734), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4532), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54722] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4475), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54811] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4762), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1561), 1,
      sym_type_arguments,
    ACTIONS(2820), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2818), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 1,
      sym__automatic_semicolon,
    ACTIONS(1327), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1331), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1333), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    ACTIONS(3427), 1,
      anon_sym_LT,
    STATE(1648), 1,
      sym_type_arguments,
    STATE(1745), 1,
      sym_arguments,
    ACTIONS(3529), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3533), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [55057] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 1,
      anon_sym_EQ,
    ACTIONS(4780), 1,
      sym__automatic_semicolon,
    ACTIONS(1197), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [55189] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4391), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1297), 1,
      sym__automatic_semicolon,
    ACTIONS(1289), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1293), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1295), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 1,
      sym__automatic_semicolon,
    ACTIONS(1275), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1279), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1281), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4782), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55469] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4375), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [55548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 1,
      sym__automatic_semicolon,
    ACTIONS(1337), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1341), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1343), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55599] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4369), 1,
      anon_sym_COLON,
    ACTIONS(4784), 1,
      anon_sym_COMMA,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55690] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [55757] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55846] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4798), 1,
      sym_readonly,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2844), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 1,
      anon_sym_EQ,
    ACTIONS(4723), 1,
      sym__automatic_semicolon,
    ACTIONS(1197), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56017] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4800), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4802), 1,
      sym_regex_flags,
    ACTIONS(4701), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4703), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56147] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4804), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1425), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4360), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2860), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4357), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56281] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4806), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1420), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56362] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4808), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56443] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4810), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56534] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4812), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56625] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4814), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56714] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4816), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56805] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4818), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56894] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4820), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1406), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [56975] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4273), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57064] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4277), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57153] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4822), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57244] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4824), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1443), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57325] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4826), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57416] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4828), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_in,
    ACTIONS(4833), 1,
      anon_sym_of,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57469] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(4587), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      sym_number,
    ACTIONS(4837), 1,
      anon_sym_async,
    ACTIONS(4839), 1,
      anon_sym_static,
    ACTIONS(4845), 1,
      sym_readonly,
    STATE(1985), 1,
      sym_accessibility_modifier,
    STATE(3039), 1,
      sym_array,
    STATE(3041), 1,
      sym_object,
    ACTIONS(3607), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4841), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4843), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2159), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2962), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4835), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57550] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_EQ,
    ACTIONS(4849), 1,
      anon_sym_in,
    ACTIONS(4852), 1,
      anon_sym_of,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57603] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4287), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57692] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4854), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1480), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57773] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4856), 1,
      anon_sym_RBRACE,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57864] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4858), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57945] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4860), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58026] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58093] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58158] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4868), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58247] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4337), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4870), 1,
      anon_sym_LPAREN,
    ACTIONS(4873), 1,
      anon_sym_COLON,
    ACTIONS(4875), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4119), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4121), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58389] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4878), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58480] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58547] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4798), 1,
      sym_readonly,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58616] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58681] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4241), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58819] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4351), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2965), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4348), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_DOT,
    STATE(1563), 1,
      sym_type_arguments,
    ACTIONS(2927), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2925), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1365), 1,
      sym__automatic_semicolon,
    ACTIONS(1357), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1361), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1363), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4882), 1,
      anon_sym_LT,
    STATE(1561), 1,
      sym_type_arguments,
    ACTIONS(2967), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2965), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      sym__automatic_semicolon,
    ACTIONS(1213), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1217), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1219), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    STATE(1580), 1,
      sym_arguments,
    ACTIONS(4111), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4113), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59241] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4137), 1,
      anon_sym_LT,
    ACTIONS(4139), 1,
      anon_sym_QMARK,
    ACTIONS(4141), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4147), 1,
      anon_sym_AMP,
    ACTIONS(4149), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4157), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4784), 1,
      anon_sym_COMMA,
    ACTIONS(4885), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4143), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4151), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4129), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4145), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4135), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4155), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1138), 1,
      sym_template_string,
    STATE(1813), 1,
      sym_arguments,
    ACTIONS(4111), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4113), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4195), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [59432] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4342), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59521] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59610] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59677] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4887), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59768] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4330), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59857] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4335), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4828), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59995] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4798), 1,
      sym_readonly,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60064] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60129] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4302), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60218] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4306), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60307] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4889), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1444), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60388] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4283), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60477] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(3963), 1,
      anon_sym_LBRACK,
    ACTIONS(4764), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_async,
    ACTIONS(4770), 1,
      sym_number,
    ACTIONS(4772), 1,
      anon_sym_static,
    ACTIONS(4774), 1,
      anon_sym_abstract,
    ACTIONS(4778), 1,
      sym_readonly,
    ACTIONS(4891), 1,
      anon_sym_RBRACE,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4776), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3973), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3953), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2800), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1199), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60658] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4344), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60747] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4385), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60836] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4518), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 1,
      sym__automatic_semicolon,
    ACTIONS(1237), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1241), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1243), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 1,
      sym__automatic_semicolon,
    ACTIONS(1299), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1303), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1305), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 1,
      sym__automatic_semicolon,
    ACTIONS(1251), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1255), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61078] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61169] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 14,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61238] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_STAR,
    ACTIONS(4904), 1,
      anon_sym_RBRACE,
    ACTIONS(4906), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4912), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4918), 1,
      sym_number,
    ACTIONS(4921), 1,
      anon_sym_AT,
    ACTIONS(4924), 1,
      anon_sym_static,
    ACTIONS(4927), 1,
      anon_sym_abstract,
    ACTIONS(4936), 1,
      sym_readonly,
    STATE(1945), 1,
      sym_method_definition,
    STATE(1976), 1,
      sym_accessibility_modifier,
    ACTIONS(4930), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1491), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4933), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2029), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2659), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4898), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61319] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4375), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61406] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 24,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61522] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4798), 1,
      sym_readonly,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61591] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    STATE(1578), 1,
      sym_arguments,
    ACTIONS(935), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(937), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61642] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4941), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61733] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1227), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1229), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61859] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4943), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1321), 1,
      sym__automatic_semicolon,
    ACTIONS(1313), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1317), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1319), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62001] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4895), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62074] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4945), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62165] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4947), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62254] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4949), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62321] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4492), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62410] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4952), 1,
      anon_sym_LT,
    ACTIONS(4955), 1,
      anon_sym_DOT,
    ACTIONS(4957), 1,
      anon_sym_is,
    STATE(1775), 1,
      sym_type_arguments,
    ACTIONS(2892), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2890), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62465] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4742), 1,
      anon_sym_QMARK,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4752), 1,
      anon_sym_PIPE,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4760), 1,
      anon_sym_QMARK_QMARK,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4498), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 1,
      sym__automatic_semicolon,
    ACTIONS(1371), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1375), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1377), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62605] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4740), 1,
      anon_sym_LT,
    ACTIONS(4744), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4750), 1,
      anon_sym_AMP,
    ACTIONS(4756), 1,
      anon_sym_STAR_STAR,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4754), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4736), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4748), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4738), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(4758), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62688] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4245), 1,
      anon_sym_LT,
    ACTIONS(4247), 1,
      anon_sym_QMARK,
    ACTIONS(4249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4255), 1,
      anon_sym_AMP,
    ACTIONS(4257), 1,
      anon_sym_PIPE,
    ACTIONS(4261), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4367), 1,
      anon_sym_COMMA,
    ACTIONS(4959), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4251), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4259), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4239), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4253), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4243), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62779] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4949), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62844] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4210), 1,
      anon_sym_as,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4219), 1,
      anon_sym_BANG,
    ACTIONS(4949), 1,
      anon_sym_LT,
    STATE(2528), 1,
      sym_type_arguments,
    ACTIONS(4221), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1601), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62911] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4961), 1,
      anon_sym_LT,
    STATE(1773), 1,
      sym_type_arguments,
    ACTIONS(2967), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2965), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_AMP,
    ACTIONS(4966), 1,
      anon_sym_PIPE,
    ACTIONS(3012), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3010), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_AMP,
    ACTIONS(4966), 1,
      anon_sym_PIPE,
    ACTIONS(3020), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3018), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2772), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2826), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2822), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2806), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 1,
      anon_sym_EQ_GT,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63359] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4968), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4023), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1343), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63559] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4974), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      sym__automatic_semicolon,
    ACTIONS(1235), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1233), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4094), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63787] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5000), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5002), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 14,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4125), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4127), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64007] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4492), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4119), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4121), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2878), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64187] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4498), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2864), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4330), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2840), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4295), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64459] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 1,
      anon_sym_STAR,
    ACTIONS(5007), 1,
      anon_sym_async,
    ACTIONS(5009), 1,
      sym_number,
    ACTIONS(5011), 1,
      anon_sym_abstract,
    ACTIONS(5013), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [64523] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5019), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64611] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(5002), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 14,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [64675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_LPAREN,
    ACTIONS(5046), 1,
      anon_sym_COLON,
    ACTIONS(5048), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4291), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4105), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4088), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4090), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_QMARK,
    ACTIONS(5051), 1,
      anon_sym_EQ,
    ACTIONS(3836), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4287), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4109), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2810), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4117), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2874), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_AMP,
    ACTIONS(4966), 1,
      anon_sym_PIPE,
    ACTIONS(3026), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3024), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2786), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2782), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2804), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2802), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_AMP,
    ACTIONS(4966), 1,
      anon_sym_PIPE,
    ACTIONS(3016), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3014), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2794), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2818), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2790), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2844), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2848), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2852), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5053), 1,
      anon_sym_LBRACK,
    ACTIONS(2858), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2856), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65709] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5055), 1,
      anon_sym_EQ,
    ACTIONS(5061), 1,
      anon_sym_QMARK,
    ACTIONS(5058), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4279), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4281), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 1,
      anon_sym_DOT,
    ACTIONS(2778), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2776), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2798), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4275), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4277), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5064), 1,
      anon_sym_EQ,
    ACTIONS(5070), 1,
      anon_sym_QMARK,
    ACTIONS(5067), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2800), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1199), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4273), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4269), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4351), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4237), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4360), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4233), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3591), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66379] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5002), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 14,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [66445] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5073), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4558), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4780), 1,
      sym__automatic_semicolon,
    ACTIONS(1197), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5053), 1,
      anon_sym_LBRACK,
    ACTIONS(2836), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2834), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2860), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4373), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(558), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4373), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2814), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66905] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 1,
      anon_sym_QMARK,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5078), 1,
      anon_sym_COLON,
    ACTIONS(5067), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5061), 1,
      anon_sym_QMARK,
    ACTIONS(5080), 1,
      anon_sym_EQ,
    ACTIONS(5083), 1,
      anon_sym_COLON,
    ACTIONS(5058), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67013] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_QMARK,
    ACTIONS(3935), 1,
      anon_sym_COLON,
    ACTIONS(5051), 1,
      anon_sym_EQ,
    ACTIONS(3836), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67067] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5085), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 14,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4528), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67179] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(5085), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4212), 14,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [67243] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4498), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4381), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2868), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4524), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_AMP,
    ACTIONS(4966), 1,
      anon_sym_PIPE,
    ACTIONS(3004), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3002), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67519] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4492), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5088), 1,
      anon_sym_LBRACE,
    ACTIONS(5090), 1,
      anon_sym_DOT,
    STATE(1776), 1,
      sym_statement_block,
    ACTIONS(1207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67659] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3847), 1,
      anon_sym_QMARK,
    ACTIONS(4348), 1,
      anon_sym_LBRACK,
    ACTIONS(5051), 1,
      anon_sym_EQ,
    ACTIONS(5092), 1,
      anon_sym_RPAREN,
    ACTIONS(3836), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4351), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4273), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67805] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4277), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67893] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4287), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5088), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_statement_block,
    ACTIONS(1207), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2846), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68081] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4420), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4229), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4383), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4385), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 1,
      anon_sym_DOT,
    STATE(1775), 1,
      sym_type_arguments,
    ACTIONS(2927), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2925), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1773), 1,
      sym_type_arguments,
    ACTIONS(2820), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2818), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [68405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2830), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4223), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4225), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4395), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68543] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4273), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68631] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4277), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68719] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4330), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68807] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4287), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68895] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4330), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4399), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4399), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69075] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4385), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4408), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1305), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 1,
      anon_sym_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5100), 1,
      anon_sym_EQ,
    ACTIONS(1271), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69399] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4241), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1229), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4516), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4512), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1377), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5102), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69805] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5104), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4412), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2800), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1199), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69989] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4385), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4416), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4418), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4424), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70169] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4241), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4428), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    STATE(1812), 1,
      sym_arguments,
    ACTIONS(4111), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4113), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5106), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70401] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70489] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4306), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70577] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4283), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    STATE(1810), 1,
      sym_arguments,
    ACTIONS(935), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(937), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70715] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4375), 2,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70801] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5108), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 14,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70867] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5108), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 10,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70939] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4375), 4,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71021] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5085), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4208), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4212), 14,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71087] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5111), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71175] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 10,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71249] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5113), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71337] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5108), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 13,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1243), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1319), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71497] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4518), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71585] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4344), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71673] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4420), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71761] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71849] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4337), 1,
      anon_sym_COLON,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4241), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5115), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [72031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [72079] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 1,
      anon_sym_STAR,
    ACTIONS(5121), 1,
      anon_sym_async,
    ACTIONS(5123), 1,
      sym_number,
    ACTIONS(5125), 1,
      anon_sym_abstract,
    ACTIONS(5127), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4705), 1,
      sym_regex_flags,
    ACTIONS(4701), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
    ACTIONS(4703), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4233), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_DOT,
    ACTIONS(2770), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2768), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72285] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72345] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5129), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72433] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4866), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72497] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4798), 1,
      sym_readonly,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72565] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4391), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72653] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4306), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72741] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4283), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72829] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 7,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 10,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [72903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1219), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1363), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1281), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1295), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73087] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4377), 1,
      anon_sym_QMARK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4375), 2,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73173] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5131), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 14,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1333), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73285] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 5,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73363] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5134), 1,
      anon_sym_RBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73451] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4204), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4206), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73557] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(5021), 1,
      anon_sym_LT,
    ACTIONS(5023), 1,
      anon_sym_QMARK,
    ACTIONS(5025), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5031), 1,
      anon_sym_AMP,
    ACTIONS(5033), 1,
      anon_sym_PIPE,
    ACTIONS(5037), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5041), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5136), 1,
      anon_sym_COLON,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5027), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5015), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(5029), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(5017), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5039), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73645] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5131), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4377), 9,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 10,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [73717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4502), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73763] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4377), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4375), 4,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73845] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 5,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4486), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      sym_regex_flags,
    ACTIONS(4701), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4703), 20,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74017] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4344), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74105] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4518), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74193] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4337), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74281] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4475), 1,
      anon_sym_RBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74369] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5131), 1,
      anon_sym_LT,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4377), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 13,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [74437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4528), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3987), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2976), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4084), 1,
      anon_sym_LT,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [74588] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5140), 1,
      anon_sym_STAR,
    ACTIONS(5142), 1,
      anon_sym_async,
    ACTIONS(5144), 1,
      sym_number,
    ACTIONS(5146), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74649] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5148), 1,
      anon_sym_STAR,
    ACTIONS(5150), 1,
      anon_sym_async,
    ACTIONS(5152), 1,
      sym_number,
    ACTIONS(5154), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2023), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74710] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5156), 1,
      anon_sym_STAR,
    ACTIONS(5158), 1,
      sym_number,
    ACTIONS(5160), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2227), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(4357), 1,
      anon_sym_LBRACK,
    ACTIONS(4360), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74820] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5140), 1,
      anon_sym_STAR,
    ACTIONS(5142), 1,
      anon_sym_async,
    ACTIONS(5144), 1,
      sym_number,
    ACTIONS(5162), 1,
      sym_readonly,
    ACTIONS(5146), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74883] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5140), 1,
      anon_sym_STAR,
    ACTIONS(5164), 1,
      sym_number,
    ACTIONS(5166), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2237), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5148), 1,
      anon_sym_STAR,
    ACTIONS(5168), 1,
      sym_number,
    ACTIONS(5170), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2255), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4241), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4512), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4516), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75230] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5176), 1,
      anon_sym_STAR,
    ACTIONS(5178), 1,
      anon_sym_async,
    ACTIONS(5180), 1,
      sym_number,
    ACTIONS(5184), 1,
      sym_readonly,
    ACTIONS(5182), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2037), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75293] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5176), 1,
      anon_sym_STAR,
    ACTIONS(5178), 1,
      anon_sym_async,
    ACTIONS(5180), 1,
      sym_number,
    ACTIONS(5182), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2037), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75354] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5186), 1,
      anon_sym_STAR,
    ACTIONS(5188), 1,
      sym_number,
    ACTIONS(5190), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4524), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75517] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5156), 1,
      anon_sym_STAR,
    ACTIONS(5192), 1,
      anon_sym_async,
    ACTIONS(5194), 1,
      sym_number,
    ACTIONS(5196), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2031), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75578] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5198), 1,
      anon_sym_STAR,
    ACTIONS(5200), 1,
      anon_sym_async,
    ACTIONS(5202), 1,
      sym_number,
    ACTIONS(5204), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2030), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5176), 1,
      anon_sym_STAR,
    ACTIONS(5206), 1,
      sym_number,
    ACTIONS(5208), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2281), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75698] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 1,
      anon_sym_STAR,
    ACTIONS(5210), 1,
      sym_number,
    ACTIONS(5212), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2269), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75757] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 1,
      anon_sym_STAR,
    ACTIONS(5121), 1,
      anon_sym_async,
    ACTIONS(5123), 1,
      sym_number,
    ACTIONS(5214), 1,
      sym_readonly,
    ACTIONS(5127), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75820] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5216), 1,
      anon_sym_STAR,
    ACTIONS(5218), 1,
      sym_number,
    ACTIONS(5220), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75879] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4428), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4424), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76054] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5198), 1,
      anon_sym_STAR,
    ACTIONS(5222), 1,
      sym_number,
    ACTIONS(5224), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76113] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5226), 1,
      anon_sym_STAR,
    ACTIONS(5228), 1,
      sym_number,
    ACTIONS(5230), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4558), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4416), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4418), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4412), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4197), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4408), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2844), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4399), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2782), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4399), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2772), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2786), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4395), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4360), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4019), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4023), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4383), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4385), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1263), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4351), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1233), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4381), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(3004), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3002), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4373), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4373), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(3016), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3014), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(3026), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3024), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2846), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(3020), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3018), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5234), 1,
      anon_sym_PIPE,
    ACTIONS(3012), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3010), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4564), 1,
      anon_sym_DOT,
    ACTIONS(2770), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2768), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1367), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(4357), 1,
      anon_sym_LBRACK,
    ACTIONS(4360), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_COMMA,
    ACTIONS(4348), 1,
      anon_sym_LBRACK,
    ACTIONS(4351), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1285), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1349), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2794), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2798), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1199), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1201), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2790), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1309), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4330), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [77977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1323), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1353), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78067] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3585), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4214), 1,
      anon_sym_LBRACK,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2830), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3591), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2846), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1343), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2868), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78381] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3581), 1,
      anon_sym_DOT,
    ACTIONS(4074), 1,
      anon_sym_as,
    ACTIONS(4078), 1,
      anon_sym_LBRACK,
    ACTIONS(4159), 1,
      anon_sym_BANG,
    ACTIONS(4976), 1,
      anon_sym_LT,
    ACTIONS(4978), 1,
      anon_sym_QMARK,
    ACTIONS(4980), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4986), 1,
      anon_sym_AMP,
    ACTIONS(4988), 1,
      anon_sym_PIPE,
    ACTIONS(4992), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    STATE(2567), 1,
      sym_type_arguments,
    ACTIONS(4161), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4982), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4990), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4970), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4984), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4972), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2874), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2810), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2806), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2822), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2826), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2840), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2864), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2878), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4502), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2814), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [78916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_COMMA,
    ACTIONS(4348), 1,
      anon_sym_LBRACK,
    ACTIONS(4351), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2804), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2802), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4295), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2818), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4291), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4287), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79192] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 1,
      anon_sym_STAR,
    ACTIONS(5007), 1,
      anon_sym_async,
    ACTIONS(5009), 1,
      sym_number,
    ACTIONS(5236), 1,
      sym_readonly,
    ACTIONS(5013), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4279), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4281), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4275), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4277), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79345] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 1,
      anon_sym_STAR,
    ACTIONS(5007), 1,
      anon_sym_async,
    ACTIONS(5009), 1,
      sym_number,
    ACTIONS(5013), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4271), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4273), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79451] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 1,
      anon_sym_STAR,
    ACTIONS(5238), 1,
      sym_number,
    ACTIONS(5240), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2235), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4267), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4269), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4235), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4237), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(558), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4233), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4233), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2860), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 1,
      anon_sym_LBRACK,
    ACTIONS(2836), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2834), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4360), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4229), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4223), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4225), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [79966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1305), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1229), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1377), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2798), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80191] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    ACTIONS(3784), 1,
      anon_sym_DOT,
    ACTIONS(4084), 1,
      anon_sym_LT,
    ACTIONS(4440), 1,
      anon_sym_LBRACK,
    STATE(2567), 1,
      sym_type_arguments,
    STATE(1231), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 16,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [80250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 1,
      anon_sym_LBRACK,
    ACTIONS(2858), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2856), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4486), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80342] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5244), 1,
      anon_sym_STAR,
    ACTIONS(5246), 1,
      anon_sym_async,
    ACTIONS(5248), 1,
      sym_number,
    ACTIONS(5252), 1,
      sym_readonly,
    ACTIONS(5250), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2033), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2852), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5244), 1,
      anon_sym_STAR,
    ACTIONS(5246), 1,
      anon_sym_async,
    ACTIONS(5248), 1,
      sym_number,
    ACTIONS(5250), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2033), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4204), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4206), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1333), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1295), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1281), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1363), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1219), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80781] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5244), 1,
      anon_sym_STAR,
    ACTIONS(5254), 1,
      sym_number,
    ACTIONS(5256), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1319), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1243), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2848), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [80975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5090), 1,
      anon_sym_DOT,
    ACTIONS(2778), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2776), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [81022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5188), 1,
      sym_number,
    STATE(2242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81076] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      sym_number,
    STATE(2255), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81130] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5164), 1,
      sym_number,
    STATE(2237), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81184] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    ACTIONS(4186), 1,
      anon_sym_in,
    ACTIONS(4189), 1,
      anon_sym_of,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81302] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    ACTIONS(4177), 1,
      anon_sym_in,
    ACTIONS(4180), 1,
      anon_sym_of,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81352] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5260), 1,
      sym_number,
    STATE(2118), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81472] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81592] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2844), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81708] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5264), 1,
      sym_number,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81762] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_in,
    ACTIONS(4833), 1,
      anon_sym_of,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    ACTIONS(4849), 1,
      anon_sym_in,
    ACTIONS(4852), 1,
      anon_sym_of,
    ACTIONS(1271), 13,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81932] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81998] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5210), 1,
      sym_number,
    STATE(2269), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82052] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5254), 1,
      sym_number,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82156] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5238), 1,
      sym_number,
    STATE(2235), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82210] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82328] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82398] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4351), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4348), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4360), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4357), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1271), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5228), 1,
      sym_number,
    STATE(2221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82614] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      sym_number,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82668] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5206), 1,
      sym_number,
    STATE(2281), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82860] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82926] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5158), 1,
      sym_number,
    STATE(2227), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83050] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5272), 1,
      sym_number,
    STATE(2289), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83104] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    ACTIONS(1271), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1273), 21,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83268] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83336] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5218), 1,
      sym_number,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5274), 1,
      sym_number,
    STATE(2132), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3953), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83444] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83514] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83580] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83641] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83702] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5278), 1,
      anon_sym_RPAREN,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83773] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5282), 1,
      anon_sym_RPAREN,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83844] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      anon_sym_DOT,
    STATE(1930), 1,
      sym_arguments,
    ACTIONS(5286), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5284), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83954] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5296), 1,
      anon_sym_DOT,
    STATE(1924), 1,
      sym_arguments,
    ACTIONS(5294), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5292), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84064] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(855), 1,
      anon_sym_RPAREN,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(1910), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2708), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84135] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84247] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84308] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84373] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84434] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5300), 1,
      anon_sym_RPAREN,
    STATE(1909), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2655), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84505] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84576] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5304), 1,
      anon_sym_RPAREN,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84647] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5306), 1,
      anon_sym_RPAREN,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84718] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5308), 1,
      anon_sym_RPAREN,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84789] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5310), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2768), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84860] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2794), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5314), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5312), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [84970] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85026] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2712), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85094] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2768), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5318), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5316), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85204] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(863), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2961), 1,
      sym_readonly,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(1906), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    STATE(2014), 1,
      sym_accessibility_modifier,
    STATE(2175), 1,
      sym__parameter_name,
    STATE(2499), 1,
      sym_array,
    STATE(2500), 1,
      sym_object,
    ACTIONS(5276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2959), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2826), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2935), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85272] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85374] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1507), 1,
      anon_sym_namespace,
    ACTIONS(1511), 1,
      anon_sym_type,
    ACTIONS(1513), 1,
      anon_sym_import,
    ACTIONS(1515), 1,
      anon_sym_var,
    ACTIONS(1517), 1,
      anon_sym_let,
    ACTIONS(1519), 1,
      anon_sym_const,
    ACTIONS(1526), 1,
      anon_sym_class,
    ACTIONS(1528), 1,
      anon_sym_async,
    ACTIONS(1530), 1,
      anon_sym_function,
    ACTIONS(1532), 1,
      anon_sym_abstract,
    ACTIONS(1536), 1,
      anon_sym_module,
    ACTIONS(1538), 1,
      anon_sym_interface,
    ACTIONS(1540), 1,
      anon_sym_enum,
    ACTIONS(1592), 1,
      anon_sym_declare,
    ACTIONS(5320), 1,
      anon_sym_default,
    STATE(2013), 1,
      sym_decorator,
    STATE(2592), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85449] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85500] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85551] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1507), 1,
      anon_sym_namespace,
    ACTIONS(1511), 1,
      anon_sym_type,
    ACTIONS(1513), 1,
      anon_sym_import,
    ACTIONS(1515), 1,
      anon_sym_var,
    ACTIONS(1517), 1,
      anon_sym_let,
    ACTIONS(1519), 1,
      anon_sym_const,
    ACTIONS(1526), 1,
      anon_sym_class,
    ACTIONS(1528), 1,
      anon_sym_async,
    ACTIONS(1530), 1,
      anon_sym_function,
    ACTIONS(1532), 1,
      anon_sym_abstract,
    ACTIONS(1534), 1,
      anon_sym_declare,
    ACTIONS(1538), 1,
      anon_sym_interface,
    ACTIONS(1540), 1,
      anon_sym_enum,
    ACTIONS(1594), 1,
      anon_sym_module,
    ACTIONS(1596), 1,
      anon_sym_global,
    STATE(2013), 1,
      sym_decorator,
    STATE(2592), 1,
      aux_sym_export_statement_repeat1,
    STATE(663), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85626] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    ACTIONS(5322), 1,
      anon_sym_module,
    ACTIONS(5324), 1,
      anon_sym_global,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2453), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [85752] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1507), 1,
      anon_sym_namespace,
    ACTIONS(1511), 1,
      anon_sym_type,
    ACTIONS(1513), 1,
      anon_sym_import,
    ACTIONS(1515), 1,
      anon_sym_var,
    ACTIONS(1517), 1,
      anon_sym_let,
    ACTIONS(1519), 1,
      anon_sym_const,
    ACTIONS(1526), 1,
      anon_sym_class,
    ACTIONS(1528), 1,
      anon_sym_async,
    ACTIONS(1530), 1,
      anon_sym_function,
    ACTIONS(1532), 1,
      anon_sym_abstract,
    ACTIONS(1538), 1,
      anon_sym_interface,
    ACTIONS(1540), 1,
      anon_sym_enum,
    ACTIONS(1592), 1,
      anon_sym_declare,
    ACTIONS(1596), 1,
      anon_sym_global,
    ACTIONS(2300), 1,
      anon_sym_module,
    STATE(2013), 1,
      sym_decorator,
    STATE(2592), 1,
      aux_sym_export_statement_repeat1,
    STATE(663), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85827] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1507), 1,
      anon_sym_namespace,
    ACTIONS(1511), 1,
      anon_sym_type,
    ACTIONS(1513), 1,
      anon_sym_import,
    ACTIONS(1515), 1,
      anon_sym_var,
    ACTIONS(1517), 1,
      anon_sym_let,
    ACTIONS(1519), 1,
      anon_sym_const,
    ACTIONS(1526), 1,
      anon_sym_class,
    ACTIONS(1528), 1,
      anon_sym_async,
    ACTIONS(1530), 1,
      anon_sym_function,
    ACTIONS(1532), 1,
      anon_sym_abstract,
    ACTIONS(1534), 1,
      anon_sym_declare,
    ACTIONS(1536), 1,
      anon_sym_module,
    ACTIONS(1538), 1,
      anon_sym_interface,
    ACTIONS(1540), 1,
      anon_sym_enum,
    ACTIONS(5320), 1,
      anon_sym_default,
    STATE(2013), 1,
      sym_decorator,
    STATE(2592), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85902] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3985), 1,
      anon_sym_namespace,
    ACTIONS(3989), 1,
      anon_sym_type,
    ACTIONS(3991), 1,
      anon_sym_import,
    ACTIONS(3993), 1,
      anon_sym_var,
    ACTIONS(3995), 1,
      anon_sym_let,
    ACTIONS(3997), 1,
      anon_sym_const,
    ACTIONS(3999), 1,
      anon_sym_class,
    ACTIONS(4001), 1,
      anon_sym_async,
    ACTIONS(4003), 1,
      anon_sym_function,
    ACTIONS(4005), 1,
      anon_sym_abstract,
    ACTIONS(4007), 1,
      anon_sym_declare,
    ACTIONS(4009), 1,
      anon_sym_module,
    ACTIONS(4011), 1,
      anon_sym_interface,
    ACTIONS(4013), 1,
      anon_sym_enum,
    ACTIONS(5326), 1,
      anon_sym_default,
    STATE(2013), 1,
      sym_decorator,
    STATE(2601), 1,
      aux_sym_export_statement_repeat1,
    STATE(2432), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [85977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5330), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5328), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5284), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3589), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4500), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86137] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2978), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2976), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4197), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4195), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5334), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5332), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86263] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5336), 1,
      anon_sym_STAR,
    ACTIONS(5338), 1,
      sym_number,
    ACTIONS(5340), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86316] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5336), 1,
      anon_sym_STAR,
    ACTIONS(5338), 1,
      sym_number,
    ACTIONS(5342), 1,
      anon_sym_async,
    ACTIONS(5340), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86371] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5338), 1,
      sym_number,
    ACTIONS(5344), 1,
      anon_sym_EQ_GT,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86422] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5346), 1,
      anon_sym_STAR,
    ACTIONS(5348), 1,
      sym_number,
    ACTIONS(5350), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86475] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5352), 1,
      anon_sym_STAR,
    ACTIONS(5354), 1,
      anon_sym_async,
    ACTIONS(5356), 1,
      sym_number,
    ACTIONS(5358), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86530] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5352), 1,
      anon_sym_STAR,
    ACTIONS(5356), 1,
      sym_number,
    ACTIONS(5358), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86583] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5336), 1,
      anon_sym_STAR,
    ACTIONS(5338), 1,
      sym_number,
    ACTIONS(5342), 1,
      anon_sym_async,
    ACTIONS(5360), 1,
      sym_readonly,
    ACTIONS(5340), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86640] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5362), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5366), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86764] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5188), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86812] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2255), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86860] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5370), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2297), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5372), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5380), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5378), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5376), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [86986] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5206), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2281), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5218), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5384), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5382), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1265), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(2364), 1,
      sym_object,
    STATE(2366), 1,
      sym_array,
    ACTIONS(5386), 2,
      sym_identifier,
      sym_this,
    ACTIONS(5390), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(5388), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87206] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5254), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5348), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1233), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1235), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5394), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5392), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5396), 1,
      sym__automatic_semicolon,
    ACTIONS(1233), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1235), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5238), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2235), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5400), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5398), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      sym__automatic_semicolon,
    ACTIONS(1195), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1197), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5404), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5338), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5408), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5406), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    STATE(2502), 1,
      sym_object,
    STATE(2503), 1,
      sym_array,
    ACTIONS(3040), 2,
      sym_identifier,
      sym_this,
    ACTIONS(698), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3042), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5412), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5410), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87764] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5356), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5416), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5414), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87850] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5418), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2225), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5422), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5420), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5426), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5424), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [87974] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5428), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2218), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5158), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2227), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5228), 1,
      sym_number,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5430), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88156] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5434), 1,
      anon_sym_RBRACE,
    ACTIONS(5436), 1,
      sym_number,
    STATE(2852), 1,
      sym_enum_assignment,
    STATE(2565), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88205] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5436), 1,
      sym_number,
    ACTIONS(5438), 1,
      anon_sym_RBRACE,
    STATE(2852), 1,
      sym_enum_assignment,
    STATE(2565), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88254] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5436), 1,
      sym_number,
    ACTIONS(5440), 1,
      anon_sym_RBRACE,
    STATE(2852), 1,
      sym_enum_assignment,
    STATE(2565), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88303] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 1,
      anon_sym_STAR,
    ACTIONS(5121), 1,
      anon_sym_async,
    ACTIONS(5123), 1,
      sym_number,
    ACTIONS(5442), 1,
      anon_sym_static,
    ACTIONS(5444), 1,
      anon_sym_abstract,
    ACTIONS(5446), 1,
      sym_readonly,
    ACTIONS(5127), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2027), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88360] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5448), 1,
      anon_sym_RBRACE,
    ACTIONS(5450), 1,
      sym_number,
    STATE(2789), 1,
      sym_enum_assignment,
    STATE(2306), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5452), 1,
      anon_sym_RBRACE,
    ACTIONS(5454), 1,
      sym_number,
    STATE(2727), 1,
      sym_enum_assignment,
    STATE(2491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88458] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5436), 1,
      sym_number,
    ACTIONS(5456), 1,
      anon_sym_RBRACE,
    STATE(2852), 1,
      sym_enum_assignment,
    STATE(2565), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88507] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4786), 1,
      anon_sym_STAR,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(4792), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      sym_number,
    ACTIONS(4798), 1,
      sym_readonly,
    ACTIONS(5458), 1,
      anon_sym_static,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2038), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(698), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2976), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_AT,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
    ACTIONS(5462), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5460), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88641] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5436), 1,
      sym_number,
    STATE(2852), 1,
      sym_enum_assignment,
    STATE(2565), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4904), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5467), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88723] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(2884), 1,
      anon_sym_async,
    ACTIONS(2888), 1,
      sym_readonly,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5258), 1,
      anon_sym_STAR,
    ACTIONS(5469), 1,
      anon_sym_static,
    ACTIONS(2886), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5471), 1,
      anon_sym_STAR,
    ACTIONS(5473), 1,
      sym_number,
    ACTIONS(5477), 1,
      sym_readonly,
    ACTIONS(5475), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2026), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88827] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5479), 1,
      anon_sym_STAR,
    ACTIONS(5481), 1,
      sym_number,
    ACTIONS(5485), 1,
      sym_readonly,
    ACTIONS(5483), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2020), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88877] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5140), 1,
      anon_sym_STAR,
    ACTIONS(5142), 1,
      anon_sym_async,
    ACTIONS(5144), 1,
      sym_number,
    ACTIONS(5162), 1,
      sym_readonly,
    ACTIONS(5487), 1,
      anon_sym_static,
    ACTIONS(5146), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5338), 1,
      sym_number,
    STATE(2261), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [88974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5188), 1,
      sym_number,
    STATE(2242), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5218), 1,
      sym_number,
    STATE(2252), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89060] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5210), 1,
      sym_number,
    STATE(2269), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89103] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      sym_number,
    STATE(2294), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5206), 1,
      sym_number,
    STATE(2281), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5228), 1,
      sym_number,
    STATE(2221), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89232] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5254), 1,
      sym_number,
    STATE(2265), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5238), 1,
      sym_number,
    STATE(2235), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89318] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5348), 1,
      sym_number,
    STATE(2273), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5164), 1,
      sym_number,
    STATE(2237), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89404] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(4864), 1,
      sym_number,
    STATE(2257), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5356), 1,
      sym_number,
    STATE(2277), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      sym_number,
    STATE(2255), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89533] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5418), 1,
      sym_number,
    STATE(2225), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89576] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5260), 1,
      sym_number,
    STATE(2118), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89619] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5404), 1,
      sym_number,
    STATE(2287), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      sym_number,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    STATE(2292), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5272), 1,
      sym_number,
    STATE(2289), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89748] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5370), 1,
      sym_number,
    STATE(2297), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5264), 1,
      sym_number,
    STATE(2223), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89834] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5158), 1,
      sym_number,
    STATE(2227), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89877] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4790), 1,
      anon_sym_LBRACK,
    ACTIONS(5274), 1,
      sym_number,
    STATE(2132), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3953), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LBRACK,
    ACTIONS(5428), 1,
      sym_number,
    STATE(2218), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2882), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(5489), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [89997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(5493), 1,
      sym_readonly,
    STATE(2502), 1,
      sym_object,
    STATE(2503), 1,
      sym_array,
    ACTIONS(3040), 2,
      sym_identifier,
      sym_this,
    ACTIONS(3042), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      sym_identifier,
    STATE(1891), 1,
      sym_decorator_member_expression,
    STATE(1925), 1,
      sym_decorator_call_expression,
    ACTIONS(5497), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [90074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      anon_sym_EQ,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(5499), 1,
      anon_sym_LT,
    ACTIONS(5501), 1,
      anon_sym_DOT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(2890), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [90106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_PIPE,
    ACTIONS(1323), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [90129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 1,
      anon_sym_PIPE,
    ACTIONS(1285), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [90152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_EQ,
    ACTIONS(5499), 1,
      anon_sym_LT,
    ACTIONS(5501), 1,
      anon_sym_DOT,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(2925), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [90181] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5507), 1,
      anon_sym_QMARK,
    ACTIONS(5509), 1,
      anon_sym_BANG,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2415), 1,
      sym_type_annotation,
    STATE(2653), 1,
      sym__call_signature,
    STATE(2673), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5505), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90223] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(5499), 1,
      anon_sym_LT,
    ACTIONS(5501), 1,
      anon_sym_DOT,
    ACTIONS(5511), 1,
      anon_sym_EQ,
    STATE(508), 1,
      sym_type_arguments,
    STATE(2596), 1,
      sym_constraint,
    STATE(2898), 1,
      sym_default_type,
    ACTIONS(5513), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(5516), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(2890), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [90261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      anon_sym_PIPE,
    ACTIONS(3558), 1,
      anon_sym_is,
    ACTIONS(5518), 1,
      anon_sym_LT,
    ACTIONS(5520), 1,
      anon_sym_DOT,
    STATE(2097), 1,
      sym_type_arguments,
    ACTIONS(2890), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [90291] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5524), 1,
      anon_sym_QMARK,
    ACTIONS(5526), 1,
      anon_sym_BANG,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2485), 1,
      sym__call_signature,
    STATE(2510), 1,
      sym_type_annotation,
    STATE(2783), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_EQ,
    ACTIONS(5499), 1,
      anon_sym_LT,
    STATE(509), 1,
      sym_type_arguments,
    ACTIONS(2818), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [90359] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5509), 1,
      anon_sym_BANG,
    ACTIONS(5528), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2399), 1,
      sym__call_signature,
    STATE(2415), 1,
      sym_type_annotation,
    STATE(2673), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5505), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90401] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5532), 1,
      anon_sym_QMARK,
    ACTIONS(5534), 1,
      anon_sym_BANG,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2370), 1,
      sym_type_annotation,
    STATE(2720), 1,
      sym__initializer,
    STATE(2724), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5530), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90443] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5534), 1,
      anon_sym_BANG,
    ACTIONS(5536), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2370), 1,
      sym_type_annotation,
    STATE(2378), 1,
      sym__call_signature,
    STATE(2720), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5530), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_EQ,
    ACTIONS(5499), 1,
      anon_sym_LT,
    STATE(509), 1,
      sym_type_arguments,
    ACTIONS(2965), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [90511] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    ACTIONS(5540), 1,
      anon_sym_QMARK,
    ACTIONS(5542), 1,
      anon_sym_BANG,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2468), 1,
      sym__call_signature,
    STATE(2470), 1,
      sym_type_annotation,
    STATE(2616), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90553] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5546), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2198), 1,
      sym__call_signature,
    STATE(2479), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90588] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5548), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2475), 1,
      sym__call_signature,
    STATE(2479), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90623] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_PIPE,
    ACTIONS(5518), 1,
      anon_sym_LT,
    ACTIONS(5520), 1,
      anon_sym_DOT,
    STATE(2097), 1,
      sym_type_arguments,
    ACTIONS(2925), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [90650] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5552), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2369), 1,
      sym__call_signature,
    STATE(2385), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5550), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90685] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5556), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2391), 1,
      sym__call_signature,
    STATE(2392), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5554), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90720] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5558), 1,
      anon_sym_COLON,
    ACTIONS(5560), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2148), 1,
      sym__call_signature,
    STATE(2392), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5554), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90755] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2397), 1,
      sym_type_annotation,
    STATE(2411), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5562), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90790] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5566), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2190), 1,
      sym__call_signature,
    STATE(2385), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5550), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90825] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5568), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2397), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5562), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90860] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2195), 1,
      sym__call_signature,
    STATE(2477), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5570), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90892] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2496), 1,
      sym_type_annotation,
    STATE(2735), 1,
      sym__initializer,
    STATE(2782), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90928] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2158), 1,
      sym__call_signature,
    STATE(2388), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_EQ,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(3010), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [90984] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2182), 1,
      sym__call_signature,
    STATE(2387), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5580), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91016] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2395), 1,
      sym__call_signature,
    STATE(2427), 1,
      sym_type_annotation,
    STATE(2660), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5582), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_PIPE,
    ACTIONS(5518), 1,
      anon_sym_LT,
    STATE(2094), 1,
      sym_type_arguments,
    ACTIONS(2818), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91076] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2495), 1,
      sym_type_annotation,
    STATE(2505), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5584), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91108] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2427), 1,
      sym_type_annotation,
    STATE(2649), 1,
      sym__call_signature,
    STATE(2660), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5582), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91144] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 1,
      anon_sym_is,
    ACTIONS(5499), 1,
      anon_sym_LT,
    ACTIONS(5501), 1,
      anon_sym_DOT,
    ACTIONS(5586), 1,
      anon_sym_RPAREN,
    STATE(508), 1,
      sym_type_arguments,
    ACTIONS(2890), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3935), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [91174] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2480), 1,
      sym__call_signature,
    STATE(2496), 1,
      sym_type_annotation,
    STATE(2735), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 1,
      anon_sym_EQ,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(3002), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [91234] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2388), 1,
      sym_type_annotation,
    STATE(2389), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2459), 1,
      sym_type_annotation,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2611), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5589), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3016), 1,
      anon_sym_EQ,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(3014), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [91326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_EQ,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(3018), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [91350] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_PIPE,
    ACTIONS(5518), 1,
      anon_sym_LT,
    STATE(2094), 1,
      sym_type_arguments,
    ACTIONS(2965), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2352), 1,
      sym__call_signature,
    STATE(2387), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5580), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_EQ,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(3024), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [91430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2363), 1,
      sym_type_annotation,
    STATE(2365), 1,
      sym__call_signature,
    STATE(2725), 1,
      sym__initializer,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5591), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_DOT,
    ACTIONS(2770), 1,
      anon_sym_PIPE,
    ACTIONS(2768), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91488] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2200), 1,
      sym__call_signature,
    STATE(2495), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5584), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91520] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2464), 1,
      sym__call_signature,
    STATE(2477), 1,
      sym_type_annotation,
    STATE(2830), 1,
      sym_type_parameters,
    ACTIONS(5570), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [91573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 1,
      anon_sym_PIPE,
    ACTIONS(5593), 1,
      anon_sym_DOT,
    ACTIONS(2776), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [91615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [91636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [91657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [91674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      anon_sym_PIPE,
    ACTIONS(1367), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [91710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_PIPE,
    ACTIONS(2806), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 1,
      anon_sym_PIPE,
    ACTIONS(2786), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_PIPE,
    ACTIONS(2868), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(3002), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [91784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(3024), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [91804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 1,
      anon_sym_PIPE,
    ACTIONS(2830), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91822] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5599), 1,
      sym_identifier,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    STATE(1647), 1,
      sym_class_body,
    STATE(2212), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2823), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [91856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2804), 1,
      anon_sym_PIPE,
    ACTIONS(2802), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_PIPE,
    ACTIONS(2772), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(3014), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [91912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_PIPE,
    ACTIONS(2822), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_PIPE,
    ACTIONS(2826), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(3018), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [91968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_PIPE,
    ACTIONS(2782), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [91986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(3010), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(2840), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_PIPE,
    ACTIONS(2864), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92042] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5607), 1,
      sym_identifier,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1739), 1,
      sym_class_body,
    STATE(2153), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2989), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92076] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5611), 1,
      sym_identifier,
    STATE(1584), 1,
      sym_class_body,
    STATE(2178), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2890), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(4035), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3987), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [92130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 1,
      anon_sym_PIPE,
    ACTIONS(2810), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 1,
      anon_sym_PIPE,
    ACTIONS(2878), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 1,
      anon_sym_EQ,
    ACTIONS(4873), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [92184] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5613), 1,
      sym_identifier,
    STATE(1584), 1,
      sym_class_body,
    STATE(2178), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2890), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_PIPE,
    ACTIONS(2794), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92236] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5615), 1,
      sym_identifier,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1241), 1,
      sym_class_body,
    STATE(2169), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2859), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_PIPE,
    ACTIONS(2818), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_PIPE,
    ACTIONS(2790), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(5619), 1,
      sym_identifier,
    ACTIONS(5621), 1,
      anon_sym_STAR,
    STATE(2972), 1,
      sym_import_clause,
    STATE(2971), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3145), 2,
      sym_namespace_import,
      sym_named_imports,
  [92336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_PIPE,
    ACTIONS(2844), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_PIPE,
    ACTIONS(2848), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_PIPE,
    ACTIONS(2874), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      anon_sym_PIPE,
    ACTIONS(2852), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_PIPE,
    ACTIONS(2798), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92446] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5625), 1,
      sym_identifier,
    STATE(1735), 1,
      sym_class_body,
    STATE(2189), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2973), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 1,
      anon_sym_PIPE,
    ACTIONS(5623), 1,
      anon_sym_LBRACK,
    ACTIONS(2834), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92500] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5627), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_class_body,
    STATE(2212), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2823), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_PIPE,
    ACTIONS(2860), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_PIPE,
    ACTIONS(558), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 1,
      anon_sym_PIPE,
    ACTIONS(2814), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [92588] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5629), 1,
      sym_identifier,
    STATE(1584), 1,
      sym_class_body,
    STATE(2178), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2890), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92622] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5631), 1,
      sym_identifier,
    STATE(1157), 1,
      sym_class_body,
    STATE(2172), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2893), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92656] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5603), 1,
      anon_sym_implements,
    ACTIONS(5605), 1,
      anon_sym_extends,
    ACTIONS(5633), 1,
      sym_identifier,
    STATE(1647), 1,
      sym_class_body,
    STATE(2212), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2823), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92690] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(606), 1,
      sym_class_body,
    STATE(2147), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2882), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1526), 1,
      sym_class_body,
    STATE(2216), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2796), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92752] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(143), 1,
      sym_class_body,
    STATE(2181), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2922), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92783] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    ACTIONS(5643), 1,
      anon_sym_LBRACE,
    STATE(656), 1,
      sym_class_body,
    STATE(2217), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2937), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2415), 1,
      sym_type_annotation,
    STATE(2673), 1,
      sym__initializer,
    ACTIONS(5509), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5505), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92839] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1117), 1,
      sym_class_body,
    STATE(2157), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2904), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92870] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(2166), 1,
      sym_type_parameters,
    STATE(2426), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2895), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92901] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1638), 1,
      sym_class_body,
    STATE(2161), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2946), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92932] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(2186), 1,
      sym_type_parameters,
    STATE(2404), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2925), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92963] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1822), 1,
      sym_class_body,
    STATE(2163), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2952), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [92994] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1784), 1,
      sym_class_body,
    STATE(2180), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2966), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93025] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1413), 1,
      sym_class_body,
    STATE(2211), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2870), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93056] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(137), 1,
      sym_class_body,
    STATE(2179), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2867), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93087] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1509), 1,
      sym_class_body,
    STATE(2188), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2940), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93118] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(2197), 1,
      sym_type_parameters,
    STATE(2382), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2943), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1164), 1,
      sym_class_body,
    STATE(2184), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2959), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(5645), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93199] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(619), 1,
      sym_class_body,
    STATE(2208), 1,
      sym_type_parameters,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2812), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2510), 1,
      sym_type_annotation,
    STATE(2783), 1,
      sym__initializer,
    ACTIONS(5526), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5522), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2268), 1,
      sym_type_annotation,
    ACTIONS(5647), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(487), 1,
      anon_sym_RBRACE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2788), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(455), 1,
      anon_sym_RBRACE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2624), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2296), 1,
      sym_type_annotation,
    ACTIONS(5649), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      anon_sym_DOT,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2390), 1,
      sym_statement_block,
    ACTIONS(1205), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(489), 1,
      anon_sym_RBRACE,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    STATE(2635), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5653), 1,
      anon_sym_RPAREN,
    ACTIONS(558), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(698), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(5262), 1,
      anon_sym_RBRACE,
    STATE(2697), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_RPAREN,
    ACTIONS(2965), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3935), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2717), 1,
      aux_sym_object_repeat1,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2798), 4,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [93473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5659), 1,
      sym_identifier,
    ACTIONS(5661), 1,
      anon_sym_STAR,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2849), 1,
      sym__call_signature,
  [93498] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(5665), 1,
      sym_identifier,
    ACTIONS(5667), 1,
      anon_sym_DOT,
    STATE(2137), 1,
      sym_nested_identifier,
    STATE(2196), 1,
      sym_string,
    STATE(2449), 1,
      sym__module,
  [93523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [93536] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(615), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2907), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2992), 1,
      sym_statement_block,
    ACTIONS(5671), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93578] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(5673), 1,
      sym_identifier,
    ACTIONS(5675), 1,
      anon_sym_DOT,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
  [93603] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5677), 1,
      sym_identifier,
    ACTIONS(5679), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2849), 1,
      sym__call_signature,
  [93628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5681), 1,
      sym_identifier,
    ACTIONS(5683), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2897), 1,
      sym__call_signature,
  [93653] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(5673), 1,
      sym_identifier,
    ACTIONS(5685), 1,
      anon_sym_DOT,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
  [93678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1736), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2988), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [93716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2933), 1,
      sym_statement_block,
    ACTIONS(5687), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2459), 1,
      sym_type_annotation,
    STATE(2611), 1,
      sym__initializer,
    ACTIONS(5589), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1136), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2945), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2935), 1,
      sym_statement_block,
    ACTIONS(5689), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93796] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5691), 1,
      anon_sym_COLON,
    ACTIONS(5693), 1,
      anon_sym_QMARK,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2985), 1,
      sym__call_signature,
  [93821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2496), 1,
      sym_type_annotation,
    STATE(2735), 1,
      sym__initializer,
    ACTIONS(5572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93842] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1685), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2891), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93867] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5695), 1,
      sym_identifier,
    ACTIONS(5697), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2987), 1,
      sym__call_signature,
  [93892] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1835), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2947), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3113), 1,
      sym_predefined_type,
    ACTIONS(5699), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3115), 1,
      sym_predefined_type,
    ACTIONS(5699), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(2384), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2942), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [93972] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5701), 1,
      sym_identifier,
    ACTIONS(5703), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2991), 1,
      sym__call_signature,
  [93997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(5705), 1,
      anon_sym_LT,
    ACTIONS(5707), 1,
      anon_sym_extends,
    STATE(652), 1,
      sym_object_type,
    STATE(2368), 1,
      sym_type_parameters,
    STATE(2721), 1,
      sym_extends_clause,
  [94022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1156), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2875), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5709), 1,
      sym_identifier,
    ACTIONS(5711), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2897), 1,
      sym__call_signature,
  [94072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2372), 1,
      sym_type_annotation,
    ACTIONS(5713), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1093), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2941), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94114] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5715), 1,
      sym_identifier,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5721), 1,
      anon_sym_enum,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2603), 1,
      sym_variable_declarator,
  [94139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [94152] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    ACTIONS(5729), 1,
      anon_sym_QMARK,
    STATE(2517), 1,
      sym_type_annotation,
    STATE(2931), 1,
      sym__initializer,
    ACTIONS(5727), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [94175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2363), 1,
      sym_type_annotation,
    STATE(2725), 1,
      sym__initializer,
    ACTIONS(5591), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2484), 1,
      sym_type_annotation,
    STATE(2675), 1,
      sym__initializer,
    ACTIONS(3572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1645), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2853), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(125), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2902), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94267] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1820), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2957), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94292] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(120), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2916), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2906), 1,
      sym_statement_block,
    ACTIONS(5731), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94334] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(5705), 1,
      anon_sym_LT,
    ACTIONS(5707), 1,
      anon_sym_extends,
    STATE(2346), 1,
      sym_type_parameters,
    STATE(2435), 1,
      sym_object_type,
    STATE(2771), 1,
      sym_extends_clause,
  [94359] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1264), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2975), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2489), 1,
      sym_type_annotation,
    STATE(2705), 1,
      sym__initializer,
    ACTIONS(4184), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94405] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(2355), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2967), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2492), 1,
      sym_type_annotation,
    STATE(2722), 1,
      sym__initializer,
    ACTIONS(4175), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94451] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1462), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2969), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1818), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2958), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2903), 1,
      sym_statement_block,
    ACTIONS(5733), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3987), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [94535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2403), 1,
      sym_type_annotation,
    ACTIONS(5735), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5737), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [94565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [94578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2850), 1,
      sym_statement_block,
    ACTIONS(5741), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2390), 1,
      sym_statement_block,
    ACTIONS(1205), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94612] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(2340), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2970), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2844), 1,
      sym_statement_block,
    ACTIONS(5743), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(5597), 1,
      anon_sym_PIPE,
    ACTIONS(3028), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_statement_block,
    ACTIONS(5745), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94688] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5747), 1,
      sym_identifier,
    ACTIONS(5749), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2860), 1,
      sym__call_signature,
  [94713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2818), 1,
      sym_statement_block,
    ACTIONS(5751), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5753), 1,
      anon_sym_EQ,
    ACTIONS(5645), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
  [94749] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5755), 1,
      sym_identifier,
    ACTIONS(5757), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2897), 1,
      sym__call_signature,
  [94774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_EQ,
    STATE(2596), 1,
      sym_constraint,
    STATE(2898), 1,
      sym_default_type,
    ACTIONS(5516), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(5759), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [94795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2814), 1,
      sym_statement_block,
    ACTIONS(5761), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2807), 1,
      sym_statement_block,
    ACTIONS(5763), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94829] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(591), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2928), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2854), 1,
      sym_statement_block,
    ACTIONS(5765), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5767), 1,
      sym_identifier,
    ACTIONS(5769), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2849), 1,
      sym__call_signature,
  [94896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1488), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2913), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1618), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2924), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [94946] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5771), 1,
      sym_identifier,
    ACTIONS(5773), 1,
      anon_sym_STAR,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2878), 1,
      sym__call_signature,
  [94971] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5715), 1,
      sym_identifier,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5775), 1,
      anon_sym_enum,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2566), 1,
      sym_variable_declarator,
  [94996] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2427), 1,
      sym_type_annotation,
    STATE(2660), 1,
      sym__initializer,
    ACTIONS(5582), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    STATE(1634), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2936), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [95042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(5639), 1,
      anon_sym_extends,
    ACTIONS(5643), 1,
      anon_sym_LBRACE,
    STATE(642), 1,
      sym_class_body,
    STATE(2759), 1,
      sym_extends_clause,
    STATE(2960), 1,
      sym_class_heritage,
    STATE(3095), 1,
      sym_implements_clause,
  [95067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5777), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2207), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2286), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5781), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5779), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4056), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5783), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95121] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5785), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2202), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5787), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2905), 1,
      sym__call_signature,
  [95165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5789), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2653), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5791), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2915), 1,
      sym__call_signature,
  [95209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5793), 1,
      anon_sym_QMARK,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2817), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [95231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5795), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2879), 1,
      sym__call_signature,
  [95253] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5797), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2475), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 1,
      anon_sym_BQUOTE,
    ACTIONS(5803), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5799), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2256), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95293] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(5665), 1,
      sym_identifier,
    STATE(2137), 1,
      sym_nested_identifier,
    STATE(2196), 1,
      sym_string,
    STATE(2376), 1,
      sym__module,
  [95315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2278), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5807), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5805), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4046), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5809), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95347] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5811), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2847), 1,
      sym__call_signature,
  [95369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_default,
    ACTIONS(5815), 1,
      anon_sym_RBRACE,
    ACTIONS(5817), 1,
      anon_sym_case,
    STATE(2241), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [95387] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    ACTIONS(5499), 1,
      anon_sym_LT,
    STATE(509), 1,
      sym_type_arguments,
    STATE(2589), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4468), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [95407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5819), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2399), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    ACTIONS(5665), 1,
      sym_identifier,
    STATE(2137), 1,
      sym_nested_identifier,
    STATE(2196), 1,
      sym_string,
    STATE(2449), 1,
      sym__module,
  [95451] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5821), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2411), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(5673), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(645), 1,
      sym__module,
  [95495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2266), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4068), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5823), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5827), 1,
      anon_sym_BQUOTE,
    ACTIONS(5825), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2285), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 1,
      anon_sym_default,
    ACTIONS(5832), 1,
      anon_sym_RBRACE,
    ACTIONS(5834), 1,
      anon_sym_case,
    STATE(2241), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [95547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5837), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2497), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5842), 1,
      anon_sym_BQUOTE,
    ACTIONS(5844), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5839), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2243), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(5849), 1,
      anon_sym_COMMA,
    ACTIONS(5851), 1,
      anon_sym_RBRACE,
    STATE(2773), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [95607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4068), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5823), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95623] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5855), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2905), 1,
      sym__call_signature,
  [95645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2231), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4056), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5783), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2515), 1,
      sym_variable_declarator,
  [95683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5862), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5859), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2267), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4044), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4044), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5866), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2488), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2566), 1,
      sym_variable_declarator,
  [95775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2603), 1,
      sym_variable_declarator,
  [95797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5868), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2485), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5872), 1,
      anon_sym_BQUOTE,
    ACTIONS(5870), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2243), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [95837] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5874), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2155), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [95859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2745), 1,
      sym_variable_declarator,
  [95881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5876), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2847), 1,
      sym__call_signature,
  [95903] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5717), 1,
      anon_sym_LBRACE,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    ACTIONS(5857), 1,
      sym_identifier,
    STATE(2185), 1,
      sym_object,
    STATE(2187), 1,
      sym_array,
    STATE(2609), 1,
      sym_variable_declarator,
  [95925] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5878), 1,
      anon_sym_QMARK,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2934), 1,
      sym__call_signature,
  [95947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5882), 1,
      anon_sym_RBRACE,
    STATE(2620), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [95967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5884), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
  [95983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5813), 1,
      anon_sym_default,
    ACTIONS(5817), 1,
      anon_sym_case,
    ACTIONS(5886), 1,
      anon_sym_RBRACE,
    STATE(2233), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [96001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5888), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2369), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4048), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5890), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4064), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5892), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5896), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2378), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_BQUOTE,
    ACTIONS(5870), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2243), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5900), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2986), 1,
      sym__call_signature,
  [96129] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5902), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2905), 1,
      sym__call_signature,
  [96151] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5904), 1,
      anon_sym_QMARK,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2842), 1,
      sym__call_signature,
  [96173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5908), 1,
      anon_sym_BQUOTE,
    ACTIONS(5906), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2270), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4062), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5910), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2275), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4066), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5912), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5914), 1,
      anon_sym_QMARK,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2901), 1,
      sym__call_signature,
  [96245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4066), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5912), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    STATE(2550), 1,
      sym_type_annotation,
    STATE(2832), 1,
      sym__initializer,
    ACTIONS(5916), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [96281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4040), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5918), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5920), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2190), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5922), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2847), 1,
      sym__call_signature,
  [96341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [96353] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
    ACTIONS(4436), 1,
      anon_sym_LBRACE,
    ACTIONS(4468), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5924), 1,
      anon_sym_LT,
    STATE(2571), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2665), 1,
      sym_type_arguments,
  [96375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5926), 1,
      anon_sym_BQUOTE,
    ACTIONS(5870), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2243), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [96393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2249), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4042), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5928), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5930), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2478), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2245), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5934), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5932), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2663), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3987), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [96481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2280), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4042), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5928), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5938), 1,
      anon_sym_QMARK,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2797), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [96519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    ACTIONS(5940), 1,
      sym_identifier,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2961), 1,
      sym__call_signature,
  [96541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5942), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2198), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2251), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5946), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5944), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5948), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    ACTIONS(5950), 1,
      anon_sym_QMARK,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2473), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2220), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5954), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5952), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96629] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    ACTIONS(5673), 1,
      sym_identifier,
    STATE(578), 1,
      sym_nested_identifier,
    STATE(609), 1,
      sym_string,
    STATE(667), 1,
      sym__module,
  [96651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5956), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3303), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96673] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2195), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2538), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2182), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    ACTIONS(5958), 1,
      anon_sym_COMMA,
    ACTIONS(5960), 1,
      anon_sym_RBRACE,
    STATE(2763), 1,
      aux_sym_enum_body_repeat1,
    STATE(2864), 1,
      sym__initializer,
  [96760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2932), 1,
      sym__call_signature,
  [96779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2974), 1,
      sym__call_signature,
  [96798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4094), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2964), 1,
      sym__call_signature,
  [96828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4105), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4090), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 1,
      sym__automatic_semicolon,
    ACTIONS(1223), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [96896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2951), 1,
      sym__call_signature,
  [96926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2949), 1,
      sym__call_signature,
  [96945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2519), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [96975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2938), 1,
      sym__call_signature,
  [97016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2200), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2848), 1,
      sym__call_signature,
  [97054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2920), 1,
      sym__call_signature,
  [97073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2944), 1,
      sym__call_signature,
  [97092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2524), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3227), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2206), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3223), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2209), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2899), 1,
      sym__call_signature,
  [97190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2558), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5964), 1,
      sym__automatic_semicolon,
    ACTIONS(1289), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      sym__automatic_semicolon,
    ACTIONS(1275), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(5968), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [97285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5970), 1,
      anon_sym_COMMA,
    ACTIONS(5972), 1,
      anon_sym_GT,
    STATE(2621), 1,
      aux_sym_implements_clause_repeat1,
  [97304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2535), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2929), 1,
      sym__call_signature,
  [97342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1357), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    ACTIONS(5707), 1,
      anon_sym_extends,
    STATE(2401), 1,
      sym_object_type,
    STATE(2790), 1,
      sym_extends_clause,
  [97372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5974), 1,
      sym__automatic_semicolon,
    ACTIONS(1313), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2522), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(5976), 1,
      anon_sym_RBRACE,
    STATE(2927), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [97432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5731), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym_LT,
    STATE(509), 1,
      sym_type_arguments,
    ACTIONS(4734), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [97502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97535] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2544), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3143), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2642), 1,
      sym__initializer,
    ACTIONS(5984), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1957), 1,
      sym_statement_block,
    ACTIONS(5689), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5990), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [97628] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2464), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    ACTIONS(5707), 1,
      anon_sym_extends,
    STATE(635), 1,
      sym_object_type,
    STATE(2702), 1,
      sym_extends_clause,
  [97666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5733), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2657), 1,
      sym__initializer,
    ACTIONS(5992), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5994), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97714] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(5998), 1,
      anon_sym_RBRACK,
    STATE(2785), 1,
      aux_sym_implements_clause_repeat1,
  [97733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_LBRACE,
    ACTIONS(5280), 1,
      anon_sym_LBRACK,
    ACTIONS(6000), 1,
      sym_identifier,
    STATE(3023), 1,
      sym_object,
    STATE(3024), 1,
      sym_array,
  [97752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      anon_sym_LBRACE,
    ACTIONS(5924), 1,
      anon_sym_LT,
    STATE(2665), 1,
      sym_type_arguments,
    ACTIONS(4734), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [97769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1954), 1,
      sym_statement_block,
    ACTIONS(5687), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2395), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [97825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [97847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97858] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2908), 1,
      sym__call_signature,
  [97877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5689), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1309), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5671), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2798), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [97995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2581), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [98014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1940), 1,
      sym_statement_block,
    ACTIONS(5731), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5862), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1963), 1,
      sym_statement_block,
    ACTIONS(5733), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3151), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5713), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4117), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6014), 1,
      anon_sym_COMMA,
    ACTIONS(6016), 1,
      anon_sym_GT,
    STATE(2723), 1,
      aux_sym_implements_clause_repeat1,
  [98173] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6018), 1,
      anon_sym_COMMA,
    ACTIONS(6020), 1,
      anon_sym_GT,
    STATE(2680), 1,
      aux_sym_implements_clause_repeat1,
  [98192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [98203] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6022), 1,
      anon_sym_LBRACE,
    STATE(2701), 1,
      aux_sym_implements_clause_repeat1,
  [98222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5687), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6024), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [98248] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2352), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [98267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2739), 1,
      sym__initializer,
    ACTIONS(6026), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6028), 1,
      anon_sym_COMMA,
    ACTIONS(6030), 1,
      anon_sym_GT,
    STATE(2674), 1,
      aux_sym_implements_clause_repeat1,
  [98312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4109), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [98323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4090), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2851), 1,
      sym__call_signature,
  [98353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6032), 1,
      anon_sym_COMMA,
    ACTIONS(6034), 1,
      anon_sym_GT,
    STATE(2668), 1,
      aux_sym_implements_clause_repeat1,
  [98372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2799), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [98391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3287), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(5884), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
  [98417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6039), 1,
      anon_sym_COMMA,
    ACTIONS(6041), 1,
      anon_sym_GT,
    STATE(2622), 1,
      aux_sym_implements_clause_repeat1,
  [98436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4105), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2762), 1,
      sym__initializer,
    ACTIONS(6043), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [98484] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2782), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [98503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3195), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6047), 1,
      anon_sym_COMMA,
    ACTIONS(6049), 1,
      anon_sym_GT,
    STATE(2658), 1,
      aux_sym_implements_clause_repeat1,
  [98555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3203), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2965), 1,
      sym__call_signature,
  [98607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2892), 1,
      sym__call_signature,
  [98626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 1,
      anon_sym_DOT,
    ACTIONS(2770), 1,
      anon_sym_LBRACE,
    ACTIONS(2768), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [98652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6051), 1,
      anon_sym_export,
    ACTIONS(6053), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [98704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4094), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3251), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2956), 1,
      sym__call_signature,
  [98756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3243), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98767] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2480), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [98786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2954), 1,
      sym__call_signature,
  [98805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6055), 1,
      anon_sym_RBRACK,
    STATE(2637), 1,
      aux_sym_implements_clause_repeat1,
  [98824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3235), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6057), 1,
      anon_sym_RBRACK,
    STATE(2677), 1,
      aux_sym_implements_clause_repeat1,
  [98854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4109), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [98865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2819), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [98884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6059), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [98895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6061), 1,
      anon_sym_export,
    ACTIONS(6063), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [98914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2644), 1,
      sym__initializer,
    ACTIONS(6065), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2486), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [98948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6067), 1,
      anon_sym_COMMA,
    ACTIONS(6069), 1,
      anon_sym_GT,
    STATE(2633), 1,
      aux_sym_implements_clause_repeat1,
  [98967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2803), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [98986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2948), 1,
      sym__call_signature,
  [99027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1944), 1,
      sym_statement_block,
    ACTIONS(5765), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2505), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [99061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1948), 1,
      sym_statement_block,
    ACTIONS(5671), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5765), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2726), 1,
      sym__initializer,
    ACTIONS(6071), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99102] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2977), 1,
      sym__call_signature,
  [99121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6073), 1,
      anon_sym_RBRACK,
    STATE(2684), 1,
      aux_sym_implements_clause_repeat1,
  [99140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1968), 1,
      sym_statement_block,
    ACTIONS(5763), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2466), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [99174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5743), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1972), 1,
      sym_statement_block,
    ACTIONS(5761), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5763), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6077), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1961), 1,
      sym_statement_block,
    ACTIONS(5741), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99248] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(6079), 1,
      anon_sym_RBRACE,
    STATE(2963), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [99265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2493), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [99284] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2469), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [99303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2746), 1,
      sym__initializer,
    ACTIONS(6081), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1939), 1,
      sym_statement_block,
    ACTIONS(5743), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5761), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99344] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6083), 1,
      anon_sym_RBRACK,
    STATE(2664), 1,
      aux_sym_implements_clause_repeat1,
  [99363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1967), 1,
      sym_statement_block,
    ACTIONS(5751), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2743), 1,
      sym__initializer,
    ACTIONS(6085), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2476), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [99412] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    ACTIONS(6087), 1,
      anon_sym_COMMA,
    ACTIONS(6089), 1,
      anon_sym_RBRACE,
    STATE(2787), 1,
      aux_sym_enum_body_repeat1,
    STATE(2864), 1,
      sym__initializer,
  [99431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2741), 1,
      sym__initializer,
    ACTIONS(6091), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      anon_sym_LBRACE,
    STATE(1965), 1,
      sym_statement_block,
    ACTIONS(5745), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6093), 1,
      anon_sym_COMMA,
    ACTIONS(6095), 1,
      anon_sym_GT,
    STATE(2695), 1,
      aux_sym_implements_clause_repeat1,
  [99480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6097), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2703), 1,
      sym__initializer,
    ACTIONS(6099), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4121), 1,
      anon_sym_EQ,
    ACTIONS(4873), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [99530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6101), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6105), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    ACTIONS(6107), 1,
      anon_sym_RBRACE,
    STATE(2927), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [99602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5745), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2909), 1,
      sym__call_signature,
  [99632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6109), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [99654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [99665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym_EQ,
    STATE(2698), 1,
      sym__initializer,
    ACTIONS(6113), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2811), 1,
      sym__call_signature,
    STATE(2837), 1,
      sym_type_parameters,
  [99699] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2136), 1,
      sym_formal_parameters,
    STATE(2692), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [99718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_formal_parameters,
    STATE(2837), 1,
      sym_type_parameters,
    STATE(2980), 1,
      sym__call_signature,
  [99737] = 5,
    ACTIONS(6115), 1,
      anon_sym_SQUOTE,
    ACTIONS(6117), 1,
      aux_sym_string_token2,
    ACTIONS(6119), 1,
      sym_escape_sequence,
    ACTIONS(6121), 1,
      sym_comment,
    STATE(2568), 1,
      aux_sym_string_repeat2,
  [99753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2563), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99767] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6127), 1,
      anon_sym_DQUOTE,
    ACTIONS(6129), 1,
      aux_sym_string_token1,
    ACTIONS(6131), 1,
      sym_escape_sequence,
    STATE(2536), 1,
      aux_sym_string_repeat1,
  [99783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    STATE(2834), 1,
      sym__initializer,
    ACTIONS(6133), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [99797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    STATE(2825), 1,
      sym_type_annotation,
    ACTIONS(5647), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [99811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2337), 1,
      sym_statement_block,
    ACTIONS(6135), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(6139), 1,
      anon_sym_PIPE,
    ACTIONS(6137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    STATE(2927), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [99853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_statement_block,
    ACTIONS(6141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(6139), 1,
      anon_sym_PIPE,
    ACTIONS(6143), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1409), 1,
      sym_statement_block,
    ACTIONS(6141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(6139), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5344), 1,
      anon_sym_EQ_GT,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [99921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2953), 1,
      sym_type_parameters,
    STATE(3071), 1,
      sym_formal_parameters,
  [99937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3421), 1,
      anon_sym_LPAREN,
    STATE(1599), 2,
      sym_template_string,
      sym_arguments,
  [99951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(3028), 2,
      anon_sym_else,
      anon_sym_while,
  [99965] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6147), 1,
      anon_sym_SQUOTE,
    ACTIONS(6149), 1,
      aux_sym_string_token2,
    ACTIONS(6151), 1,
      sym_escape_sequence,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [99981] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6153), 1,
      anon_sym_DQUOTE,
    ACTIONS(6155), 1,
      aux_sym_string_token1,
    ACTIONS(6157), 1,
      sym_escape_sequence,
    STATE(2551), 1,
      aux_sym_string_repeat1,
  [99997] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6153), 1,
      anon_sym_SQUOTE,
    ACTIONS(6159), 1,
      aux_sym_string_token2,
    ACTIONS(6161), 1,
      sym_escape_sequence,
    STATE(2552), 1,
      aux_sym_string_repeat2,
  [100013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_EQ_GT,
    ACTIONS(3987), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [100025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    ACTIONS(6139), 1,
      anon_sym_PIPE,
    ACTIONS(6165), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2315), 1,
      sym_statement_block,
    ACTIONS(6167), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100053] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6147), 1,
      anon_sym_DQUOTE,
    ACTIONS(6169), 1,
      aux_sym_string_token1,
    ACTIONS(6171), 1,
      sym_escape_sequence,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [100069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 1,
      sym_identifier,
    STATE(2963), 1,
      sym__import_export_specifier,
    ACTIONS(5853), 2,
      anon_sym_type,
      anon_sym_typeof,
  [100083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(607), 1,
      sym_statement_block,
    ACTIONS(6173), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4734), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [100111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 1,
      anon_sym_COMMA,
    STATE(2540), 1,
      aux_sym_array_repeat1,
    ACTIONS(4678), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [100125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 1,
      sym_identifier,
    STATE(515), 1,
      sym_generic_type,
    STATE(2024), 1,
      sym_nested_type_identifier,
    STATE(3104), 1,
      sym_nested_identifier,
  [100141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 1,
      anon_sym_COMMA,
    STATE(2542), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6186), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2900), 1,
      sym_type_parameters,
    STATE(3081), 1,
      sym_formal_parameters,
  [100171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1499), 1,
      sym_statement_block,
    ACTIONS(6173), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2192), 1,
      sym_formal_parameters,
    STATE(2845), 1,
      sym_type_parameters,
  [100201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 1,
      sym_identifier,
    STATE(1086), 1,
      sym_nested_type_identifier,
    STATE(1184), 1,
      sym_generic_type,
    STATE(3045), 1,
      sym_nested_identifier,
  [100217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    STATE(2824), 1,
      sym_type_annotation,
    ACTIONS(6190), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2804), 1,
      sym_type_parameters,
    STATE(3132), 1,
      sym_formal_parameters,
  [100247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2542), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6192), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    STATE(2968), 1,
      sym__initializer,
    ACTIONS(6194), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100275] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6169), 1,
      aux_sym_string_token1,
    ACTIONS(6171), 1,
      sym_escape_sequence,
    ACTIONS(6196), 1,
      anon_sym_DQUOTE,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [100291] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6149), 1,
      aux_sym_string_token2,
    ACTIONS(6151), 1,
      sym_escape_sequence,
    ACTIONS(6196), 1,
      anon_sym_SQUOTE,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [100307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      anon_sym_LBRACE,
    ACTIONS(4734), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6198), 1,
      anon_sym_COMMA,
    STATE(2553), 1,
      aux_sym_extends_clause_repeat1,
  [100323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6201), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [100339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
    ACTIONS(4436), 1,
      anon_sym_LBRACE,
    ACTIONS(4468), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2571), 1,
      aux_sym_extends_clause_repeat1,
  [100355] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_SQUOTE,
    ACTIONS(6205), 1,
      aux_sym_string_token2,
    ACTIONS(6208), 1,
      sym_escape_sequence,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [100371] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6211), 1,
      anon_sym_DQUOTE,
    ACTIONS(6213), 1,
      aux_sym_string_token1,
    ACTIONS(6216), 1,
      sym_escape_sequence,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [100387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_statement_block,
    ACTIONS(6173), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2542), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6219), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2542), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6221), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100429] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6223), 1,
      anon_sym_DQUOTE,
    ACTIONS(6225), 1,
      aux_sym_string_token1,
    ACTIONS(6227), 1,
      sym_escape_sequence,
    STATE(2600), 1,
      aux_sym_string_repeat1,
  [100445] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6223), 1,
      anon_sym_SQUOTE,
    ACTIONS(6229), 1,
      aux_sym_string_token2,
    ACTIONS(6231), 1,
      sym_escape_sequence,
    STATE(2598), 1,
      aux_sym_string_repeat2,
  [100461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2542), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6233), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6235), 1,
      anon_sym_export,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [100491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      anon_sym_EQ,
    STATE(2864), 1,
      sym__initializer,
    ACTIONS(6237), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2549), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6239), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(3409), 1,
      anon_sym_LPAREN,
    STATE(1138), 2,
      sym_template_string,
      sym_arguments,
  [100533] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6149), 1,
      aux_sym_string_token2,
    ACTIONS(6151), 1,
      sym_escape_sequence,
    ACTIONS(6241), 1,
      anon_sym_SQUOTE,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [100549] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6169), 1,
      aux_sym_string_token1,
    ACTIONS(6171), 1,
      sym_escape_sequence,
    ACTIONS(6241), 1,
      anon_sym_DQUOTE,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [100565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6243), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [100581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
    ACTIONS(6245), 1,
      anon_sym_LBRACE,
    ACTIONS(6247), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2553), 1,
      aux_sym_extends_clause_repeat1,
  [100597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 1,
      anon_sym_COMMA,
    ACTIONS(6249), 1,
      anon_sym_LBRACE,
    ACTIONS(6251), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2553), 1,
      aux_sym_extends_clause_repeat1,
  [100613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [100623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    STATE(2589), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4468), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [100637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6255), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [100651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    STATE(2912), 1,
      sym_type_annotation,
    ACTIONS(5649), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [100665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6257), 1,
      sym_identifier,
    STATE(1403), 1,
      sym_nested_type_identifier,
    STATE(1562), 1,
      sym_generic_type,
    STATE(3184), 1,
      sym_nested_identifier,
  [100681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 1,
      sym_identifier,
    STATE(2045), 1,
      sym_nested_type_identifier,
    STATE(2096), 1,
      sym_generic_type,
    STATE(3121), 1,
      sym_nested_identifier,
  [100697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6261), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [100713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2885), 1,
      sym_type_parameters,
    STATE(2997), 1,
      sym_formal_parameters,
  [100729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_LBRACE,
    STATE(131), 1,
      sym_statement_block,
    ACTIONS(6141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100743] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6127), 1,
      anon_sym_SQUOTE,
    ACTIONS(6263), 1,
      aux_sym_string_token2,
    ACTIONS(6265), 1,
      sym_escape_sequence,
    STATE(2530), 1,
      aux_sym_string_repeat2,
  [100759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACE,
    ACTIONS(5621), 1,
      anon_sym_STAR,
    STATE(3188), 2,
      sym_namespace_import,
      sym_named_imports,
  [100773] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6149), 1,
      aux_sym_string_token2,
    ACTIONS(6151), 1,
      sym_escape_sequence,
    ACTIONS(6267), 1,
      anon_sym_SQUOTE,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [100789] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6169), 1,
      aux_sym_string_token1,
    ACTIONS(6171), 1,
      sym_escape_sequence,
    ACTIONS(6267), 1,
      anon_sym_DQUOTE,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [100805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6269), 1,
      sym_identifier,
    STATE(1616), 1,
      sym_nested_type_identifier,
    STATE(1800), 1,
      sym_generic_type,
    STATE(3026), 1,
      sym_nested_identifier,
  [100821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [100831] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_SQUOTE,
    ACTIONS(6273), 1,
      aux_sym_string_token2,
    ACTIONS(6275), 1,
      sym_escape_sequence,
    STATE(2584), 1,
      aux_sym_string_repeat2,
  [100847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6247), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [100861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_COMMA,
    STATE(2539), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6251), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [100875] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6271), 1,
      anon_sym_DQUOTE,
    ACTIONS(6277), 1,
      aux_sym_string_token1,
    ACTIONS(6279), 1,
      sym_escape_sequence,
    STATE(2585), 1,
      aux_sym_string_repeat1,
  [100891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6281), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [100907] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6283), 1,
      anon_sym_DQUOTE,
    ACTIONS(6285), 1,
      aux_sym_string_token1,
    ACTIONS(6287), 1,
      sym_escape_sequence,
    STATE(2595), 1,
      aux_sym_string_repeat1,
  [100923] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6283), 1,
      anon_sym_SQUOTE,
    ACTIONS(6289), 1,
      aux_sym_string_token2,
    ACTIONS(6291), 1,
      sym_escape_sequence,
    STATE(2597), 1,
      aux_sym_string_repeat2,
  [100939] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6169), 1,
      aux_sym_string_token1,
    ACTIONS(6171), 1,
      sym_escape_sequence,
    ACTIONS(6293), 1,
      anon_sym_DQUOTE,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [100955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_EQ,
    STATE(2871), 1,
      sym_default_type,
    ACTIONS(6295), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [100969] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6149), 1,
      aux_sym_string_token2,
    ACTIONS(6151), 1,
      sym_escape_sequence,
    ACTIONS(6293), 1,
      anon_sym_SQUOTE,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [100985] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6149), 1,
      aux_sym_string_token2,
    ACTIONS(6151), 1,
      sym_escape_sequence,
    ACTIONS(6297), 1,
      anon_sym_SQUOTE,
    STATE(2556), 1,
      aux_sym_string_repeat2,
  [101001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2979), 1,
      sym_type_parameters,
    STATE(3096), 1,
      sym_formal_parameters,
  [101017] = 5,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6169), 1,
      aux_sym_string_token1,
    ACTIONS(6171), 1,
      sym_escape_sequence,
    ACTIONS(6297), 1,
      anon_sym_DQUOTE,
    STATE(2557), 1,
      aux_sym_string_repeat1,
  [101033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6299), 1,
      anon_sym_class,
    STATE(1982), 1,
      aux_sym_export_statement_repeat1,
    STATE(2013), 1,
      sym_decorator,
  [101049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_from,
    STATE(2865), 1,
      sym__from_clause,
    ACTIONS(6303), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2559), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6305), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_from,
    STATE(2917), 1,
      sym__from_clause,
    ACTIONS(6307), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(750), 1,
      anon_sym_BQUOTE,
    ACTIONS(3425), 1,
      anon_sym_LPAREN,
    STATE(1757), 2,
      sym_template_string,
      sym_arguments,
  [101105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2983), 1,
      sym_type_parameters,
    STATE(3119), 1,
      sym_formal_parameters,
  [101121] = 5,
    ACTIONS(6115), 1,
      anon_sym_DQUOTE,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6309), 1,
      aux_sym_string_token1,
    ACTIONS(6311), 1,
      sym_escape_sequence,
    STATE(2569), 1,
      aux_sym_string_repeat1,
  [101137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 1,
      sym_identifier,
    STATE(515), 1,
      sym_generic_type,
    STATE(555), 1,
      sym_nested_type_identifier,
    STATE(3104), 1,
      sym_nested_identifier,
  [101153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6123), 1,
      anon_sym_COMMA,
    STATE(2560), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6315), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6317), 1,
      anon_sym_RBRACK,
  [101180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6321), 1,
      anon_sym_RBRACE,
    STATE(2625), 1,
      aux_sym_object_repeat1,
  [101202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6321), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      anon_sym_LPAREN,
    ACTIONS(6325), 1,
      anon_sym_await,
    STATE(39), 1,
      sym__for_header,
  [101228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4605), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4605), 1,
      anon_sym_RPAREN,
    STATE(2718), 1,
      aux_sym_array_repeat1,
  [101263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4674), 1,
      anon_sym_RBRACK,
    STATE(2626), 1,
      aux_sym_array_repeat1,
  [101276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4674), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      anon_sym_COMMA,
    ACTIONS(6331), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_named_imports_repeat1,
  [101302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 1,
      anon_sym_GT,
    ACTIONS(6333), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 1,
      anon_sym_GT,
    ACTIONS(6335), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    ACTIONS(6339), 1,
      anon_sym_GT,
    STATE(2880), 1,
      sym_type_parameter,
  [101341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6341), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6343), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6345), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6347), 1,
      anon_sym_RPAREN,
  [101393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6349), 1,
      anon_sym_RPAREN,
  [101406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 1,
      anon_sym_RBRACE,
    ACTIONS(6351), 1,
      anon_sym_COMMA,
    STATE(2629), 1,
      aux_sym_enum_body_repeat1,
  [101419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6354), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6356), 1,
      anon_sym_RBRACE,
    STATE(2700), 1,
      aux_sym_object_repeat1,
  [101445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6356), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3782), 1,
      anon_sym_GT,
    ACTIONS(6358), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6360), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6362), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [101506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6364), 1,
      anon_sym_RBRACK,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_GT,
    ACTIONS(6366), 1,
      anon_sym_COMMA,
    STATE(2646), 1,
      aux_sym_type_parameters_repeat1,
  [101532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6368), 1,
      anon_sym_RBRACK,
  [101545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(6370), 1,
      anon_sym_EQ,
    STATE(3013), 1,
      sym_type_parameters,
  [101558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(6059), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [101569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6376), 1,
      anon_sym_RPAREN,
  [101591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_EQ,
    ACTIONS(6382), 1,
      anon_sym_COMMA,
    ACTIONS(6384), 1,
      anon_sym_from,
  [101613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 1,
      anon_sym_COMMA,
    ACTIONS(6389), 1,
      anon_sym_GT,
    STATE(2646), 1,
      aux_sym_type_parameters_repeat1,
  [101626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DQUOTE,
    ACTIONS(2762), 1,
      anon_sym_SQUOTE,
    STATE(3097), 1,
      sym_string,
  [101639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6391), 1,
      anon_sym_EQ_GT,
    STATE(2912), 1,
      sym_type_annotation,
  [101652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    ACTIONS(6396), 1,
      anon_sym_GT,
    STATE(2880), 1,
      sym_type_parameter,
  [101674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 1,
      anon_sym_COMMA,
    ACTIONS(6401), 1,
      anon_sym_RBRACE,
    STATE(2651), 1,
      aux_sym_named_imports_repeat1,
  [101687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6403), 1,
      sym_identifier,
    ACTIONS(6405), 1,
      anon_sym_require,
    STATE(2749), 1,
      sym_nested_identifier,
  [101700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6409), 1,
      anon_sym_RBRACE,
    STATE(2672), 1,
      aux_sym_object_repeat1,
  [101722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6411), 1,
      anon_sym_COMMA,
    ACTIONS(6413), 1,
      anon_sym_RPAREN,
    STATE(2709), 1,
      aux_sym_formal_parameters_repeat1,
  [101735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6415), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6417), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_GT,
    ACTIONS(6419), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5380), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6421), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4613), 1,
      anon_sym_RBRACK,
    STATE(2714), 1,
      aux_sym_array_repeat1,
  [101801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_COMMA,
    ACTIONS(6426), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6430), 1,
      anon_sym_RBRACK,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_LBRACE,
    ACTIONS(2794), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [101847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4613), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4656), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3821), 1,
      anon_sym_GT,
    ACTIONS(6432), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4656), 1,
      anon_sym_RBRACK,
    STATE(2630), 1,
      aux_sym_array_repeat1,
  [101899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6434), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [101912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_LBRACE,
    ACTIONS(2790), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [101923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6436), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3825), 1,
      anon_sym_GT,
    ACTIONS(6440), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6442), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6444), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [101980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6446), 1,
      anon_sym_RBRACK,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [101993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6444), 1,
      anon_sym_RBRACE,
    STATE(2634), 1,
      aux_sym_object_repeat1,
  [102006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6448), 1,
      anon_sym_RBRACK,
  [102019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3829), 1,
      anon_sym_GT,
    ACTIONS(6450), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [102032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4693), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6452), 1,
      anon_sym_COMMA,
    ACTIONS(6454), 1,
      anon_sym_GT,
    STATE(2730), 1,
      aux_sym_type_parameters_repeat1,
  [102058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 1,
      anon_sym_LBRACE,
    ACTIONS(6045), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [102069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6458), 1,
      anon_sym_RBRACK,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [102082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4693), 1,
      anon_sym_RPAREN,
    STATE(2656), 1,
      aux_sym_array_repeat1,
  [102095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6460), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_LT,
    ACTIONS(6462), 1,
      anon_sym_EQ,
    STATE(3014), 1,
      sym_type_parameters,
  [102121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_identifier,
    ACTIONS(6466), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 1,
      anon_sym_COMMA,
    ACTIONS(6384), 1,
      anon_sym_from,
    ACTIONS(6468), 1,
      anon_sym_EQ,
  [102145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_LPAREN,
    ACTIONS(6472), 1,
      anon_sym_await,
    STATE(34), 1,
      sym__for_header,
  [102158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      sym_identifier,
    ACTIONS(6476), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6478), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6480), 1,
      anon_sym_EQ_GT,
    STATE(2912), 1,
      sym_type_annotation,
  [102191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6483), 1,
      anon_sym_EQ_GT,
    STATE(2825), 1,
      sym_type_annotation,
  [102204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_GT,
    ACTIONS(6486), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [102217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6488), 1,
      anon_sym_RBRACK,
  [102230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6490), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [102243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6494), 1,
      anon_sym_RPAREN,
  [102265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6496), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [102278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6498), 1,
      anon_sym_LBRACE,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [102291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    STATE(691), 1,
      sym_object_type,
  [102304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6500), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6502), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4199), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [102344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6506), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [102357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6508), 1,
      anon_sym_COMMA,
    ACTIONS(6510), 1,
      anon_sym_RPAREN,
    STATE(2781), 1,
      aux_sym_formal_parameters_repeat1,
  [102370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 1,
      anon_sym_RPAREN,
    ACTIONS(6512), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_formal_parameters_repeat1,
  [102383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4649), 1,
      anon_sym_RPAREN,
    STATE(2686), 1,
      aux_sym_array_repeat1,
  [102396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6002), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [102407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 1,
      anon_sym_RPAREN,
    ACTIONS(6512), 1,
      anon_sym_COMMA,
    STATE(2769), 1,
      aux_sym_formal_parameters_repeat1,
  [102420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4649), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6516), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6518), 1,
      anon_sym_RPAREN,
  [102459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4732), 1,
      anon_sym_LBRACE,
    ACTIONS(4734), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [102470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6520), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [102483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6522), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_formal_parameters_repeat1,
  [102509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6526), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3746), 1,
      anon_sym_LBRACE,
    STATE(655), 1,
      sym_object_type,
  [102531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6528), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_GT,
    ACTIONS(6530), 1,
      anon_sym_COMMA,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [102553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6534), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6536), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 1,
      anon_sym_COMMA,
    ACTIONS(6089), 1,
      anon_sym_RBRACE,
    STATE(2787), 1,
      aux_sym_enum_body_repeat1,
  [102593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6538), 1,
      anon_sym_EQ_GT,
    STATE(2912), 1,
      sym_type_annotation,
  [102606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    ACTIONS(6541), 1,
      anon_sym_GT,
    STATE(2880), 1,
      sym_type_parameter,
  [102619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 1,
      anon_sym_GT,
    ACTIONS(6543), 1,
      anon_sym_COMMA,
    STATE(2646), 1,
      aux_sym_type_parameters_repeat1,
  [102632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4684), 1,
      anon_sym_RBRACK,
    STATE(2760), 1,
      aux_sym_array_repeat1,
  [102645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4684), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6545), 1,
      anon_sym_COMMA,
    ACTIONS(6548), 1,
      anon_sym_RPAREN,
    STATE(2733), 1,
      aux_sym_formal_parameters_repeat1,
  [102671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4734), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [102680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6550), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6552), 1,
      anon_sym_RBRACK,
  [102702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [102711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6554), 1,
      anon_sym_EQ_GT,
    STATE(2825), 1,
      sym_type_annotation,
  [102724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6557), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [102742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6561), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_as,
    ACTIONS(6565), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [102762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6569), 1,
      anon_sym_EQ_GT,
    STATE(2912), 1,
      sym_type_annotation,
  [102784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6572), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4569), 1,
      anon_sym_RPAREN,
    STATE(2670), 1,
      aux_sym_array_repeat1,
  [102815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [102824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      anon_sym_DOT,
    ACTIONS(6576), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_RBRACE,
    ACTIONS(6578), 1,
      anon_sym_COMMA,
    STATE(2778), 1,
      aux_sym_export_clause_repeat1,
  [102848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4569), 1,
      anon_sym_RPAREN,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_RBRACE,
    ACTIONS(6580), 1,
      anon_sym_COMMA,
    STATE(2651), 1,
      aux_sym_named_imports_repeat1,
  [102874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6409), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [102887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5737), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [102896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACK,
    STATE(2704), 1,
      aux_sym_array_repeat1,
  [102922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6582), 1,
      anon_sym_EQ_GT,
    STATE(2825), 1,
      sym_type_annotation,
  [102935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6585), 1,
      anon_sym_COMMA,
    ACTIONS(6587), 1,
      anon_sym_GT,
    STATE(2638), 1,
      aux_sym_type_parameters_repeat1,
  [102948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5637), 1,
      anon_sym_implements,
    ACTIONS(6589), 1,
      anon_sym_LBRACE,
    STATE(3159), 1,
      sym_implements_clause,
  [102961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(901), 1,
      anon_sym_COMMA,
    ACTIONS(6591), 1,
      anon_sym_RBRACK,
    STATE(2540), 1,
      aux_sym_array_repeat1,
  [102974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [102983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6593), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5434), 1,
      anon_sym_RBRACE,
    ACTIONS(6595), 1,
      anon_sym_COMMA,
    STATE(2629), 1,
      aux_sym_enum_body_repeat1,
  [103005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6597), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [103018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    ACTIONS(6599), 1,
      anon_sym_LPAREN,
    STATE(608), 1,
      sym_statement_block,
  [103031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6597), 1,
      anon_sym_RBRACE,
    STATE(2707), 1,
      aux_sym_object_repeat1,
  [103044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5593), 1,
      anon_sym_DOT,
    ACTIONS(6601), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 1,
      anon_sym_RPAREN,
    ACTIONS(6603), 1,
      anon_sym_COMMA,
    STATE(2719), 1,
      aux_sym_formal_parameters_repeat1,
  [103068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5278), 1,
      anon_sym_RPAREN,
    ACTIONS(6605), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_formal_parameters_repeat1,
  [103081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [103092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    STATE(2402), 1,
      sym_object_type,
  [103105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6607), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [103114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 1,
      anon_sym_COMMA,
    ACTIONS(6611), 1,
      anon_sym_RBRACE,
    STATE(2750), 1,
      aux_sym_export_clause_repeat1,
  [103127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 1,
      anon_sym_as,
    ACTIONS(6615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3912), 1,
      anon_sym_COLON,
    ACTIONS(6617), 1,
      anon_sym_EQ_GT,
    STATE(2825), 1,
      sym_type_annotation,
  [103151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_LBRACE,
    ACTIONS(2772), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [103162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6620), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [103171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6622), 1,
      anon_sym_COMMA,
    ACTIONS(6625), 1,
      anon_sym_RBRACE,
    STATE(2778), 1,
      aux_sym_export_clause_repeat1,
  [103184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5669), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [103193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_DQUOTE,
    ACTIONS(3453), 1,
      anon_sym_SQUOTE,
    STATE(2821), 1,
      sym_string,
  [103206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 1,
      anon_sym_RPAREN,
    ACTIONS(6603), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_formal_parameters_repeat1,
  [103219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [103246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_COMMA,
    ACTIONS(6633), 1,
      anon_sym_RBRACK,
    STATE(2423), 1,
      aux_sym_implements_clause_repeat1,
  [103259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 1,
      anon_sym_LBRACE,
    ACTIONS(2786), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [103270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5438), 1,
      anon_sym_RBRACE,
    ACTIONS(6635), 1,
      anon_sym_COMMA,
    STATE(2629), 1,
      aux_sym_enum_body_repeat1,
  [103283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6637), 1,
      anon_sym_RBRACE,
    STATE(2662), 1,
      aux_sym_object_repeat1,
  [103296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_COMMA,
    ACTIONS(5960), 1,
      anon_sym_RBRACE,
    STATE(2763), 1,
      aux_sym_enum_body_repeat1,
  [103309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3878), 1,
      anon_sym_LBRACE,
    STATE(2354), 1,
      sym_object_type,
  [103322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    ACTIONS(6639), 1,
      anon_sym_GT,
    STATE(2880), 1,
      sym_type_parameter,
  [103335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5576), 1,
      anon_sym_AMP,
    ACTIONS(5578), 1,
      anon_sym_PIPE,
    ACTIONS(6641), 1,
      anon_sym_RBRACK,
  [103348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_LBRACE,
    STATE(2434), 1,
      sym_enum_body,
  [103358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6645), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3405), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1629), 1,
      sym_class_body,
  [103384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2933), 1,
      sym_statement_block,
  [103394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2347), 1,
      sym_statement_block,
  [103404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2338), 1,
      sym_statement_block,
  [103414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      sym_identifier,
    STATE(2767), 1,
      sym_nested_identifier,
  [103424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym_parenthesized_expression,
  [103442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1635), 1,
      sym_statement_block,
  [103452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3072), 1,
      sym_formal_parameters,
  [103462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(2868), 1,
      sym_parenthesized_expression,
  [103472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      anon_sym_while,
    ACTIONS(6651), 1,
      anon_sym_else,
  [103482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5426), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [103500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(549), 1,
      sym_statement_block,
  [103510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [103520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2854), 1,
      sym_statement_block,
  [103530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(610), 1,
      sym_class_body,
  [103540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6653), 1,
      sym_identifier,
    STATE(2749), 1,
      sym_nested_identifier,
  [103550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2807), 1,
      sym_statement_block,
  [103584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5422), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2814), 1,
      sym_statement_block,
  [103602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6661), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5416), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1613), 1,
      sym_class_body,
  [103636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5894), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [103652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6665), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2757), 1,
      sym_formal_parameters,
  [103670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3130), 1,
      sym_formal_parameters,
  [103680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2133), 1,
      sym_formal_parameters,
  [103698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    STATE(2682), 1,
      sym_type_parameter,
  [103708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6669), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [103732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym__for_header,
  [103742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2507), 1,
      sym_type_annotation,
  [103752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2518), 1,
      sym_formal_parameters,
  [103762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2509), 1,
      sym_type_annotation,
  [103772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_from,
    STATE(2917), 1,
      sym__from_clause,
  [103782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6675), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2818), 1,
      sym_statement_block,
  [103808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6677), 1,
      sym_identifier,
    ACTIONS(6679), 1,
      anon_sym_STAR,
  [103818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_LPAREN,
    STATE(2171), 1,
      sym_formal_parameters,
  [103836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_from,
    STATE(2865), 1,
      sym__from_clause,
  [103846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1576), 1,
      sym_statement_block,
  [103856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_statement_block,
  [103866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1569), 1,
      sym_statement_block,
  [103876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5408), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2935), 1,
      sym_statement_block,
  [103894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1547), 1,
      sym_class_body,
  [103912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [103920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
  [103930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [103940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym_parenthesized_expression,
  [103950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 1,
      sym_identifier,
    STATE(1570), 1,
      sym_nested_identifier,
  [103960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1157), 1,
      sym_class_body,
  [103970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1153), 1,
      sym_statement_block,
  [103980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_from,
    STATE(2971), 1,
      sym__from_clause,
  [103990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6683), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(2436), 1,
      sym_statement_block,
  [104008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6685), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_LBRACE,
    STATE(2414), 1,
      sym_enum_body,
  [104034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(132), 1,
      sym_class_body,
  [104044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_switch_body,
  [104054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym__for_header,
  [104064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1487), 1,
      sym_class_body,
  [104074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [104082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_class_body,
  [104116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4689), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3012), 1,
      sym_formal_parameters,
  [104134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1104), 1,
      sym_statement_block,
  [104144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1101), 1,
      sym_statement_block,
  [104154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6389), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [104162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 1,
      sym_identifier,
    STATE(504), 1,
      sym_nested_identifier,
  [104172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_class_body,
  [104182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_statement_block,
  [104192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    STATE(2758), 1,
      sym_type_parameter,
  [104202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3038), 1,
      sym_formal_parameters,
  [104212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(598), 1,
      sym_statement_block,
  [104222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(599), 1,
      sym_statement_block,
  [104232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2694), 1,
      sym_formal_parameters,
  [104242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3091), 1,
      sym_formal_parameters,
  [104252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1647), 1,
      sym_class_body,
  [104262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym_class_body,
  [104272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1664), 1,
      sym_statement_block,
  [104282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1094), 1,
      sym_class_body,
  [104292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6697), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(2386), 1,
      sym_class_body,
  [104310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 1,
      sym_identifier,
    STATE(1840), 1,
      sym_nested_identifier,
  [104320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1644), 1,
      sym_statement_block,
  [104330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [104338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1154), 1,
      sym_statement_block,
  [104348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
  [104358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2844), 1,
      sym_statement_block,
  [104368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(136), 1,
      sym_class_body,
  [104378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5412), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1135), 1,
      sym_class_body,
  [104396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1701), 1,
      sym_statement_block,
  [104406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(601), 1,
      sym_class_body,
  [104424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_statement_block,
  [104434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_statement_block,
  [104444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(644), 1,
      sym_statement_block,
  [104454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6701), 1,
      anon_sym_LBRACE,
    STATE(654), 1,
      sym_enum_body,
  [104464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5948), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [104472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1404), 1,
      sym_class_body,
  [104482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1181), 1,
      sym_statement_block,
  [104500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_class_body,
  [104510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [104518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6705), 1,
      sym_identifier,
    STATE(1206), 1,
      sym_nested_identifier,
  [104528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2775), 1,
      sym_formal_parameters,
  [104538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1410), 1,
      sym_statement_block,
  [104548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(650), 1,
      sym_statement_block,
  [104558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5641), 1,
      anon_sym_LBRACE,
    STATE(141), 1,
      sym_class_body,
  [104568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 1,
      anon_sym_LPAREN,
    STATE(2840), 1,
      sym_parenthesized_expression,
  [104578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1695), 1,
      sym_class_body,
  [104588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(2361), 1,
      sym_class_body,
  [104598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6709), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_class_body,
  [104624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5651), 1,
      anon_sym_LBRACE,
    STATE(614), 1,
      sym_statement_block,
  [104634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6713), 1,
      sym_identifier,
    ACTIONS(6715), 1,
      anon_sym_STAR,
  [104644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6717), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [104652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2906), 1,
      sym_statement_block,
  [104662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5394), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2903), 1,
      sym_statement_block,
  [104680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1691), 1,
      sym_class_body,
  [104698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5643), 1,
      anon_sym_LBRACE,
    STATE(634), 1,
      sym_class_body,
  [104708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1688), 1,
      sym_statement_block,
  [104718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(2738), 1,
      sym_formal_parameters,
  [104728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1460), 1,
      sym_class_body,
  [104738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1091), 1,
      sym_class_body,
  [104748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(2349), 1,
      sym_class_body,
  [104758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(2345), 1,
      sym_class_body,
  [104768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1687), 1,
      sym_statement_block,
  [104778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1268), 1,
      sym_class_body,
  [104788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1686), 1,
      sym_class_body,
  [104798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1838), 1,
      sym_class_body,
  [104808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1837), 1,
      sym_statement_block,
  [104818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1267), 1,
      sym_statement_block,
  [104828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3074), 1,
      sym_formal_parameters,
  [104838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1266), 1,
      sym_statement_block,
  [104848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1834), 1,
      sym_class_body,
  [104858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3076), 1,
      sym_formal_parameters,
  [104868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1833), 1,
      sym_statement_block,
  [104878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6701), 1,
      anon_sym_LBRACE,
    STATE(683), 1,
      sym_enum_body,
  [104888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1832), 1,
      sym_statement_block,
  [104898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1831), 1,
      sym_class_body,
  [104908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1830), 1,
      sym_class_body,
  [104918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1265), 1,
      sym_class_body,
  [104928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5643), 1,
      anon_sym_LBRACE,
    STATE(661), 1,
      sym_class_body,
  [104938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1826), 1,
      sym_statement_block,
  [104948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [104964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 1,
      anon_sym_LBRACE,
    STATE(1501), 1,
      sym_statement_block,
  [104974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1821), 1,
      sym_statement_block,
  [104984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1819), 1,
      sym_class_body,
  [104994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(2330), 1,
      sym_class_body,
  [105004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [105012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1486), 1,
      sym_class_body,
  [105022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5635), 1,
      anon_sym_LBRACE,
    STATE(2322), 1,
      sym_class_body,
  [105032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6725), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_from,
    STATE(2815), 1,
      sym__from_clause,
  [105050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1817), 1,
      sym_class_body,
  [105060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4163), 1,
      anon_sym_LBRACE,
    STATE(1252), 1,
      sym_statement_block,
  [105070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5617), 1,
      anon_sym_LBRACE,
    STATE(1250), 1,
      sym_class_body,
  [105080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3105), 1,
      sym_formal_parameters,
  [105090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_LBRACE,
    STATE(134), 1,
      sym_statement_block,
  [105100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 1,
      sym_identifier,
    STATE(2880), 1,
      sym_type_parameter,
  [105110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3107), 1,
      sym_formal_parameters,
  [105120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2850), 1,
      sym_statement_block,
  [105130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_COLON,
    STATE(2359), 1,
      sym_type_annotation,
  [105140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
  [105150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5663), 1,
      anon_sym_LPAREN,
    STATE(3125), 1,
      sym_formal_parameters,
  [105160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6727), 1,
      sym_identifier,
    STATE(2063), 1,
      sym_nested_identifier,
  [105170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 1,
      anon_sym_LBRACE,
    STATE(2992), 1,
      sym_statement_block,
  [105180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1809), 1,
      sym_statement_block,
  [105190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1804), 1,
      sym_statement_block,
  [105200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1801), 1,
      sym_class_body,
  [105210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5609), 1,
      anon_sym_LBRACE,
    STATE(1735), 1,
      sym_class_body,
  [105220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6729), 1,
      sym_identifier,
    ACTIONS(6731), 1,
      anon_sym_STAR,
  [105230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      anon_sym_LBRACE,
    STATE(1740), 1,
      sym_statement_block,
  [105240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5384), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [105248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6733), 1,
      sym_identifier,
    ACTIONS(6735), 1,
      anon_sym_STAR,
  [105258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6737), 1,
      sym_identifier,
  [105265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 1,
      anon_sym_RPAREN,
  [105272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      anon_sym_EQ_GT,
  [105279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6741), 1,
      anon_sym_EQ_GT,
  [105286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6743), 1,
      anon_sym_RPAREN,
  [105293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_namespace,
  [105300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 1,
      anon_sym_RPAREN,
  [105307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6747), 1,
      anon_sym_class,
  [105314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      sym_identifier,
  [105321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6751), 1,
      sym_identifier,
  [105328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_EQ_GT,
  [105335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_target,
  [105342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6757), 1,
      anon_sym_EQ_GT,
  [105349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6759), 1,
      anon_sym_EQ_GT,
  [105356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 1,
      anon_sym_RPAREN,
  [105363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_EQ_GT,
  [105370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_EQ_GT,
  [105377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6765), 1,
      anon_sym_EQ,
  [105384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6767), 1,
      anon_sym_EQ_GT,
  [105391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6769), 1,
      anon_sym_EQ,
  [105398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6771), 1,
      anon_sym_EQ,
  [105405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6773), 1,
      anon_sym_EQ_GT,
  [105412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 1,
      anon_sym_RPAREN,
  [105419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6775), 1,
      anon_sym_SLASH2,
  [105426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6777), 1,
      anon_sym_EQ_GT,
  [105433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6779), 1,
      sym_number,
  [105440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      sym_identifier,
  [105447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 1,
      anon_sym_RBRACE,
  [105454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6785), 1,
      anon_sym_RPAREN,
  [105461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym_RPAREN,
  [105468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_RPAREN,
  [105475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4508), 1,
      anon_sym_RPAREN,
  [105482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 1,
      anon_sym_DOT,
  [105489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6791), 1,
      sym_identifier,
  [105496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_RPAREN,
  [105503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_from,
  [105510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_COLON,
  [105517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 1,
      anon_sym_DOT,
  [105524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_RBRACK,
  [105531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6797), 1,
      anon_sym_EQ_GT,
  [105538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6799), 1,
      anon_sym_EQ_GT,
  [105545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_EQ_GT,
  [105552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6803), 1,
      sym_identifier,
  [105559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_EQ_GT,
  [105566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_EQ_GT,
  [105573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_EQ,
  [105580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      sym_identifier,
  [105587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_EQ,
  [105594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6815), 1,
      anon_sym_from,
  [105601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6817), 1,
      anon_sym_COLON,
  [105608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6819), 1,
      anon_sym_EQ_GT,
  [105615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_DOT,
  [105622] = 2,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6821), 1,
      sym_regex_pattern,
  [105629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6823), 1,
      anon_sym_RPAREN,
  [105636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym_EQ_GT,
  [105643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6827), 1,
      anon_sym_EQ_GT,
  [105650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6829), 1,
      anon_sym_EQ_GT,
  [105657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6831), 1,
      sym_identifier,
  [105664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6833), 1,
      sym_identifier,
  [105671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6835), 1,
      anon_sym_EQ_GT,
  [105678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6837), 1,
      sym_identifier,
  [105685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      sym_identifier,
  [105692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6841), 1,
      anon_sym_COLON,
  [105699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 1,
      anon_sym_EQ,
  [105706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6845), 1,
      sym_identifier,
  [105713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 1,
      sym_identifier,
  [105720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6849), 1,
      sym_identifier,
  [105727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4520), 1,
      anon_sym_RPAREN,
  [105734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6851), 1,
      anon_sym_RBRACE,
  [105741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      sym_identifier,
  [105748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6855), 1,
      sym_number,
  [105755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6857), 1,
      anon_sym_EQ_GT,
  [105762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6859), 1,
      anon_sym_SLASH2,
  [105769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6861), 1,
      sym_identifier,
  [105776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6863), 1,
      sym_identifier,
  [105783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 1,
      anon_sym_RPAREN,
  [105790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 1,
      anon_sym_COLON,
  [105797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 1,
      anon_sym_EQ_GT,
  [105804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6871), 1,
      anon_sym_EQ_GT,
  [105811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 1,
      sym_identifier,
  [105818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 1,
      anon_sym_EQ_GT,
  [105825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6877), 1,
      sym_identifier,
  [105832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6879), 1,
      anon_sym_EQ_GT,
  [105839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6881), 1,
      sym_identifier,
  [105846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6883), 1,
      sym_identifier,
  [105853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6885), 1,
      sym_identifier,
  [105860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 1,
      sym_identifier,
  [105867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6889), 1,
      anon_sym_EQ_GT,
  [105874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      sym_identifier,
  [105881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
  [105888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_target,
  [105895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_RPAREN,
  [105902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      sym_number,
  [105909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6897), 1,
      anon_sym_EQ_GT,
  [105916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      anon_sym_EQ_GT,
  [105923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 1,
      anon_sym_EQ_GT,
  [105930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 1,
      sym_identifier,
  [105937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      anon_sym_EQ_GT,
  [105944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5344), 1,
      anon_sym_EQ_GT,
  [105951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_RPAREN,
  [105958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_from,
  [105965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6589), 1,
      anon_sym_LBRACE,
  [105972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6909), 1,
      anon_sym_EQ_GT,
  [105979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      anon_sym_RPAREN,
  [105986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6913), 1,
      anon_sym_SLASH2,
  [105993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 1,
      anon_sym_RPAREN,
  [106000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 1,
      sym_identifier,
  [106007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4959), 1,
      anon_sym_RPAREN,
  [106014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_RPAREN,
  [106021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_EQ_GT,
  [106028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5501), 1,
      anon_sym_DOT,
  [106035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 1,
      anon_sym_EQ_GT,
  [106042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4943), 1,
      anon_sym_RPAREN,
  [106049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 1,
      anon_sym_EQ_GT,
  [106056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4893), 1,
      anon_sym_RBRACK,
  [106063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      sym_number,
  [106070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6925), 1,
      sym_identifier,
  [106077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6927), 1,
      sym_identifier,
  [106084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 1,
      sym_identifier,
  [106091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 1,
      anon_sym_RBRACK,
  [106098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 1,
      sym_identifier,
  [106105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      anon_sym_RBRACK,
  [106112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      sym_identifier,
  [106119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6939), 1,
      sym_identifier,
  [106126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_function,
  [106133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6943), 1,
      anon_sym_EQ_GT,
  [106140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 1,
      sym_identifier,
  [106147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5520), 1,
      anon_sym_DOT,
  [106154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6947), 1,
      anon_sym_EQ_GT,
  [106161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      sym_identifier,
  [106168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6951), 1,
      sym_identifier,
  [106175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      anon_sym_EQ_GT,
  [106182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      sym_identifier,
  [106189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6957), 1,
      sym_identifier,
  [106196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym_while,
  [106203] = 2,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(6961), 1,
      sym_regex_pattern,
  [106210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_EQ_GT,
  [106217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6965), 1,
      sym_identifier,
  [106224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym_EQ_GT,
  [106231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
  [106238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6969), 1,
      sym_identifier,
  [106245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6971), 1,
      anon_sym_RPAREN,
  [106252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 1,
      sym_identifier,
  [106259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 1,
      sym_identifier,
  [106266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      sym_identifier,
  [106273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      sym_identifier,
  [106280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 1,
      sym_identifier,
  [106287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 1,
      anon_sym_EQ_GT,
  [106294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6985), 1,
      anon_sym_EQ_GT,
  [106301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6987), 1,
      anon_sym_EQ_GT,
  [106308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6989), 1,
      anon_sym_EQ_GT,
  [106315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_from,
  [106322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6991), 1,
      sym_identifier,
  [106329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6993), 1,
      sym_identifier,
  [106336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6995), 1,
      anon_sym_target,
  [106343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6997), 1,
      anon_sym_EQ_GT,
  [106350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_as,
  [106357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_EQ_GT,
  [106364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_EQ_GT,
  [106371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7005), 1,
      anon_sym_EQ_GT,
  [106378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7007), 1,
      sym_identifier,
  [106385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7009), 1,
      anon_sym_SLASH2,
  [106392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7011), 1,
      anon_sym_EQ_GT,
  [106399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7013), 1,
      sym_number,
  [106406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 1,
      sym_identifier,
  [106413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 1,
      anon_sym_LBRACE,
  [106420] = 2,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(7019), 1,
      sym_regex_pattern,
  [106427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 1,
      sym_identifier,
  [106434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7023), 1,
      sym_identifier,
  [106441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7025), 1,
      sym_identifier,
  [106448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4856), 1,
      anon_sym_RBRACE,
  [106455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      anon_sym_function,
  [106462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 1,
      sym_identifier,
  [106469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      sym_identifier,
  [106476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 1,
      sym_identifier,
  [106483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7035), 1,
      sym_identifier,
  [106490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_RBRACK,
  [106497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7039), 1,
      sym_identifier,
  [106504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 1,
      anon_sym_namespace,
  [106511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_RBRACK,
  [106518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      sym_identifier,
  [106525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      sym_identifier,
  [106532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7047), 1,
      sym_identifier,
  [106539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      sym_identifier,
  [106546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7051), 1,
      sym_identifier,
  [106553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 1,
      anon_sym_EQ_GT,
  [106560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 1,
      ts_builtin_sym_end,
  [106567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7057), 1,
      sym_identifier,
  [106574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      sym_identifier,
  [106581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 1,
      anon_sym_class,
  [106588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_DOT,
  [106595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7063), 1,
      anon_sym_EQ_GT,
  [106602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7065), 1,
      anon_sym_EQ_GT,
  [106609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      sym_identifier,
  [106616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7069), 1,
      anon_sym_from,
  [106623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7071), 1,
      sym_identifier,
  [106630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 1,
      anon_sym_EQ_GT,
  [106637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7075), 1,
      anon_sym_EQ_GT,
  [106644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7077), 1,
      anon_sym_EQ_GT,
  [106651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 1,
      anon_sym_EQ_GT,
  [106658] = 2,
    ACTIONS(6121), 1,
      sym_comment,
    ACTIONS(7081), 1,
      sym_regex_pattern,
  [106665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym_LPAREN,
  [106672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 1,
      anon_sym_require,
  [106679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_from,
  [106686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7089), 1,
      sym_identifier,
  [106693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      sym_identifier,
  [106700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7093), 1,
      sym_identifier,
  [106707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7095), 1,
      anon_sym_from,
  [106714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7097), 1,
      anon_sym_from,
  [106721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7099), 1,
      sym_identifier,
  [106728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7101), 1,
      anon_sym_COLON,
  [106735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 1,
      anon_sym_RPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(714)] = 0,
  [SMALL_STATE(715)] = 96,
  [SMALL_STATE(716)] = 194,
  [SMALL_STATE(717)] = 292,
  [SMALL_STATE(718)] = 390,
  [SMALL_STATE(719)] = 486,
  [SMALL_STATE(720)] = 584,
  [SMALL_STATE(721)] = 682,
  [SMALL_STATE(722)] = 780,
  [SMALL_STATE(723)] = 875,
  [SMALL_STATE(724)] = 970,
  [SMALL_STATE(725)] = 1065,
  [SMALL_STATE(726)] = 1151,
  [SMALL_STATE(727)] = 1241,
  [SMALL_STATE(728)] = 1329,
  [SMALL_STATE(729)] = 1417,
  [SMALL_STATE(730)] = 1505,
  [SMALL_STATE(731)] = 1599,
  [SMALL_STATE(732)] = 1687,
  [SMALL_STATE(733)] = 1773,
  [SMALL_STATE(734)] = 1864,
  [SMALL_STATE(735)] = 1993,
  [SMALL_STATE(736)] = 2080,
  [SMALL_STATE(737)] = 2209,
  [SMALL_STATE(738)] = 2294,
  [SMALL_STATE(739)] = 2423,
  [SMALL_STATE(740)] = 2552,
  [SMALL_STATE(741)] = 2645,
  [SMALL_STATE(742)] = 2734,
  [SMALL_STATE(743)] = 2863,
  [SMALL_STATE(744)] = 2992,
  [SMALL_STATE(745)] = 3121,
  [SMALL_STATE(746)] = 3214,
  [SMALL_STATE(747)] = 3299,
  [SMALL_STATE(748)] = 3384,
  [SMALL_STATE(749)] = 3470,
  [SMALL_STATE(750)] = 3546,
  [SMALL_STATE(751)] = 3630,
  [SMALL_STATE(752)] = 3717,
  [SMALL_STATE(753)] = 3780,
  [SMALL_STATE(754)] = 3843,
  [SMALL_STATE(755)] = 3926,
  [SMALL_STATE(756)] = 4009,
  [SMALL_STATE(757)] = 4092,
  [SMALL_STATE(758)] = 4175,
  [SMALL_STATE(759)] = 4238,
  [SMALL_STATE(760)] = 4301,
  [SMALL_STATE(761)] = 4384,
  [SMALL_STATE(762)] = 4467,
  [SMALL_STATE(763)] = 4530,
  [SMALL_STATE(764)] = 4617,
  [SMALL_STATE(765)] = 4700,
  [SMALL_STATE(766)] = 4778,
  [SMALL_STATE(767)] = 4844,
  [SMALL_STATE(768)] = 4924,
  [SMALL_STATE(769)] = 5042,
  [SMALL_STATE(770)] = 5120,
  [SMALL_STATE(771)] = 5200,
  [SMALL_STATE(772)] = 5280,
  [SMALL_STATE(773)] = 5396,
  [SMALL_STATE(774)] = 5476,
  [SMALL_STATE(775)] = 5554,
  [SMALL_STATE(776)] = 5620,
  [SMALL_STATE(777)] = 5700,
  [SMALL_STATE(778)] = 5778,
  [SMALL_STATE(779)] = 5858,
  [SMALL_STATE(780)] = 5974,
  [SMALL_STATE(781)] = 6054,
  [SMALL_STATE(782)] = 6134,
  [SMALL_STATE(783)] = 6252,
  [SMALL_STATE(784)] = 6368,
  [SMALL_STATE(785)] = 6436,
  [SMALL_STATE(786)] = 6549,
  [SMALL_STATE(787)] = 6626,
  [SMALL_STATE(788)] = 6739,
  [SMALL_STATE(789)] = 6818,
  [SMALL_STATE(790)] = 6899,
  [SMALL_STATE(791)] = 6974,
  [SMALL_STATE(792)] = 7087,
  [SMALL_STATE(793)] = 7200,
  [SMALL_STATE(794)] = 7313,
  [SMALL_STATE(795)] = 7392,
  [SMALL_STATE(796)] = 7469,
  [SMALL_STATE(797)] = 7546,
  [SMALL_STATE(798)] = 7659,
  [SMALL_STATE(799)] = 7772,
  [SMALL_STATE(800)] = 7853,
  [SMALL_STATE(801)] = 7966,
  [SMALL_STATE(802)] = 8079,
  [SMALL_STATE(803)] = 8156,
  [SMALL_STATE(804)] = 8235,
  [SMALL_STATE(805)] = 8348,
  [SMALL_STATE(806)] = 8425,
  [SMALL_STATE(807)] = 8538,
  [SMALL_STATE(808)] = 8651,
  [SMALL_STATE(809)] = 8764,
  [SMALL_STATE(810)] = 8837,
  [SMALL_STATE(811)] = 8914,
  [SMALL_STATE(812)] = 9027,
  [SMALL_STATE(813)] = 9140,
  [SMALL_STATE(814)] = 9253,
  [SMALL_STATE(815)] = 9366,
  [SMALL_STATE(816)] = 9479,
  [SMALL_STATE(817)] = 9592,
  [SMALL_STATE(818)] = 9677,
  [SMALL_STATE(819)] = 9790,
  [SMALL_STATE(820)] = 9903,
  [SMALL_STATE(821)] = 10016,
  [SMALL_STATE(822)] = 10089,
  [SMALL_STATE(823)] = 10202,
  [SMALL_STATE(824)] = 10315,
  [SMALL_STATE(825)] = 10388,
  [SMALL_STATE(826)] = 10467,
  [SMALL_STATE(827)] = 10540,
  [SMALL_STATE(828)] = 10608,
  [SMALL_STATE(829)] = 10718,
  [SMALL_STATE(830)] = 10828,
  [SMALL_STATE(831)] = 10938,
  [SMALL_STATE(832)] = 11048,
  [SMALL_STATE(833)] = 11158,
  [SMALL_STATE(834)] = 11218,
  [SMALL_STATE(835)] = 11328,
  [SMALL_STATE(836)] = 11404,
  [SMALL_STATE(837)] = 11514,
  [SMALL_STATE(838)] = 11584,
  [SMALL_STATE(839)] = 11694,
  [SMALL_STATE(840)] = 11804,
  [SMALL_STATE(841)] = 11864,
  [SMALL_STATE(842)] = 11974,
  [SMALL_STATE(843)] = 12084,
  [SMALL_STATE(844)] = 12194,
  [SMALL_STATE(845)] = 12266,
  [SMALL_STATE(846)] = 12376,
  [SMALL_STATE(847)] = 12486,
  [SMALL_STATE(848)] = 12562,
  [SMALL_STATE(849)] = 12634,
  [SMALL_STATE(850)] = 12704,
  [SMALL_STATE(851)] = 12814,
  [SMALL_STATE(852)] = 12924,
  [SMALL_STATE(853)] = 13034,
  [SMALL_STATE(854)] = 13106,
  [SMALL_STATE(855)] = 13216,
  [SMALL_STATE(856)] = 13326,
  [SMALL_STATE(857)] = 13436,
  [SMALL_STATE(858)] = 13546,
  [SMALL_STATE(859)] = 13656,
  [SMALL_STATE(860)] = 13766,
  [SMALL_STATE(861)] = 13876,
  [SMALL_STATE(862)] = 13986,
  [SMALL_STATE(863)] = 14096,
  [SMALL_STATE(864)] = 14156,
  [SMALL_STATE(865)] = 14266,
  [SMALL_STATE(866)] = 14376,
  [SMALL_STATE(867)] = 14486,
  [SMALL_STATE(868)] = 14596,
  [SMALL_STATE(869)] = 14670,
  [SMALL_STATE(870)] = 14750,
  [SMALL_STATE(871)] = 14810,
  [SMALL_STATE(872)] = 14884,
  [SMALL_STATE(873)] = 14956,
  [SMALL_STATE(874)] = 15066,
  [SMALL_STATE(875)] = 15134,
  [SMALL_STATE(876)] = 15194,
  [SMALL_STATE(877)] = 15266,
  [SMALL_STATE(878)] = 15376,
  [SMALL_STATE(879)] = 15454,
  [SMALL_STATE(880)] = 15564,
  [SMALL_STATE(881)] = 15674,
  [SMALL_STATE(882)] = 15784,
  [SMALL_STATE(883)] = 15894,
  [SMALL_STATE(884)] = 15970,
  [SMALL_STATE(885)] = 16080,
  [SMALL_STATE(886)] = 16190,
  [SMALL_STATE(887)] = 16300,
  [SMALL_STATE(888)] = 16410,
  [SMALL_STATE(889)] = 16520,
  [SMALL_STATE(890)] = 16590,
  [SMALL_STATE(891)] = 16658,
  [SMALL_STATE(892)] = 16768,
  [SMALL_STATE(893)] = 16878,
  [SMALL_STATE(894)] = 16988,
  [SMALL_STATE(895)] = 17098,
  [SMALL_STATE(896)] = 17168,
  [SMALL_STATE(897)] = 17278,
  [SMALL_STATE(898)] = 17348,
  [SMALL_STATE(899)] = 17458,
  [SMALL_STATE(900)] = 17526,
  [SMALL_STATE(901)] = 17636,
  [SMALL_STATE(902)] = 17746,
  [SMALL_STATE(903)] = 17856,
  [SMALL_STATE(904)] = 17928,
  [SMALL_STATE(905)] = 18038,
  [SMALL_STATE(906)] = 18148,
  [SMALL_STATE(907)] = 18258,
  [SMALL_STATE(908)] = 18328,
  [SMALL_STATE(909)] = 18438,
  [SMALL_STATE(910)] = 18548,
  [SMALL_STATE(911)] = 18658,
  [SMALL_STATE(912)] = 18768,
  [SMALL_STATE(913)] = 18836,
  [SMALL_STATE(914)] = 18946,
  [SMALL_STATE(915)] = 19056,
  [SMALL_STATE(916)] = 19166,
  [SMALL_STATE(917)] = 19276,
  [SMALL_STATE(918)] = 19386,
  [SMALL_STATE(919)] = 19496,
  [SMALL_STATE(920)] = 19606,
  [SMALL_STATE(921)] = 19716,
  [SMALL_STATE(922)] = 19826,
  [SMALL_STATE(923)] = 19936,
  [SMALL_STATE(924)] = 20046,
  [SMALL_STATE(925)] = 20156,
  [SMALL_STATE(926)] = 20236,
  [SMALL_STATE(927)] = 20346,
  [SMALL_STATE(928)] = 20456,
  [SMALL_STATE(929)] = 20566,
  [SMALL_STATE(930)] = 20676,
  [SMALL_STATE(931)] = 20786,
  [SMALL_STATE(932)] = 20896,
  [SMALL_STATE(933)] = 21006,
  [SMALL_STATE(934)] = 21116,
  [SMALL_STATE(935)] = 21226,
  [SMALL_STATE(936)] = 21292,
  [SMALL_STATE(937)] = 21402,
  [SMALL_STATE(938)] = 21512,
  [SMALL_STATE(939)] = 21584,
  [SMALL_STATE(940)] = 21694,
  [SMALL_STATE(941)] = 21804,
  [SMALL_STATE(942)] = 21914,
  [SMALL_STATE(943)] = 22024,
  [SMALL_STATE(944)] = 22097,
  [SMALL_STATE(945)] = 22172,
  [SMALL_STATE(946)] = 22235,
  [SMALL_STATE(947)] = 22298,
  [SMALL_STATE(948)] = 22361,
  [SMALL_STATE(949)] = 22436,
  [SMALL_STATE(950)] = 22507,
  [SMALL_STATE(951)] = 22572,
  [SMALL_STATE(952)] = 22643,
  [SMALL_STATE(953)] = 22716,
  [SMALL_STATE(954)] = 22791,
  [SMALL_STATE(955)] = 22862,
  [SMALL_STATE(956)] = 22933,
  [SMALL_STATE(957)] = 23000,
  [SMALL_STATE(958)] = 23071,
  [SMALL_STATE(959)] = 23138,
  [SMALL_STATE(960)] = 23207,
  [SMALL_STATE(961)] = 23278,
  [SMALL_STATE(962)] = 23349,
  [SMALL_STATE(963)] = 23424,
  [SMALL_STATE(964)] = 23501,
  [SMALL_STATE(965)] = 23568,
  [SMALL_STATE(966)] = 23635,
  [SMALL_STATE(967)] = 23706,
  [SMALL_STATE(968)] = 23773,
  [SMALL_STATE(969)] = 23840,
  [SMALL_STATE(970)] = 23911,
  [SMALL_STATE(971)] = 23978,
  [SMALL_STATE(972)] = 24049,
  [SMALL_STATE(973)] = 24112,
  [SMALL_STATE(974)] = 24183,
  [SMALL_STATE(975)] = 24256,
  [SMALL_STATE(976)] = 24318,
  [SMALL_STATE(977)] = 24388,
  [SMALL_STATE(978)] = 24454,
  [SMALL_STATE(979)] = 24526,
  [SMALL_STATE(980)] = 24584,
  [SMALL_STATE(981)] = 24646,
  [SMALL_STATE(982)] = 24710,
  [SMALL_STATE(983)] = 24776,
  [SMALL_STATE(984)] = 24838,
  [SMALL_STATE(985)] = 24910,
  [SMALL_STATE(986)] = 24968,
  [SMALL_STATE(987)] = 25032,
  [SMALL_STATE(988)] = 25090,
  [SMALL_STATE(989)] = 25158,
  [SMALL_STATE(990)] = 25216,
  [SMALL_STATE(991)] = 25280,
  [SMALL_STATE(992)] = 25350,
  [SMALL_STATE(993)] = 25416,
  [SMALL_STATE(994)] = 25478,
  [SMALL_STATE(995)] = 25542,
  [SMALL_STATE(996)] = 25612,
  [SMALL_STATE(997)] = 25682,
  [SMALL_STATE(998)] = 25746,
  [SMALL_STATE(999)] = 25808,
  [SMALL_STATE(1000)] = 25870,
  [SMALL_STATE(1001)] = 25928,
  [SMALL_STATE(1002)] = 25994,
  [SMALL_STATE(1003)] = 26064,
  [SMALL_STATE(1004)] = 26128,
  [SMALL_STATE(1005)] = 26197,
  [SMALL_STATE(1006)] = 26266,
  [SMALL_STATE(1007)] = 26331,
  [SMALL_STATE(1008)] = 26392,
  [SMALL_STATE(1009)] = 26453,
  [SMALL_STATE(1010)] = 26522,
  [SMALL_STATE(1011)] = 26587,
  [SMALL_STATE(1012)] = 26652,
  [SMALL_STATE(1013)] = 26717,
  [SMALL_STATE(1014)] = 26786,
  [SMALL_STATE(1015)] = 26849,
  [SMALL_STATE(1016)] = 26909,
  [SMALL_STATE(1017)] = 27013,
  [SMALL_STATE(1018)] = 27117,
  [SMALL_STATE(1019)] = 27221,
  [SMALL_STATE(1020)] = 27325,
  [SMALL_STATE(1021)] = 27385,
  [SMALL_STATE(1022)] = 27489,
  [SMALL_STATE(1023)] = 27563,
  [SMALL_STATE(1024)] = 27667,
  [SMALL_STATE(1025)] = 27771,
  [SMALL_STATE(1026)] = 27835,
  [SMALL_STATE(1027)] = 27939,
  [SMALL_STATE(1028)] = 28043,
  [SMALL_STATE(1029)] = 28107,
  [SMALL_STATE(1030)] = 28210,
  [SMALL_STATE(1031)] = 28311,
  [SMALL_STATE(1032)] = 28411,
  [SMALL_STATE(1033)] = 28511,
  [SMALL_STATE(1034)] = 28611,
  [SMALL_STATE(1035)] = 28711,
  [SMALL_STATE(1036)] = 28811,
  [SMALL_STATE(1037)] = 28911,
  [SMALL_STATE(1038)] = 29011,
  [SMALL_STATE(1039)] = 29111,
  [SMALL_STATE(1040)] = 29211,
  [SMALL_STATE(1041)] = 29311,
  [SMALL_STATE(1042)] = 29411,
  [SMALL_STATE(1043)] = 29511,
  [SMALL_STATE(1044)] = 29611,
  [SMALL_STATE(1045)] = 29711,
  [SMALL_STATE(1046)] = 29811,
  [SMALL_STATE(1047)] = 29873,
  [SMALL_STATE(1048)] = 29969,
  [SMALL_STATE(1049)] = 30031,
  [SMALL_STATE(1050)] = 30127,
  [SMALL_STATE(1051)] = 30223,
  [SMALL_STATE(1052)] = 30279,
  [SMALL_STATE(1053)] = 30375,
  [SMALL_STATE(1054)] = 30437,
  [SMALL_STATE(1055)] = 30503,
  [SMALL_STATE(1056)] = 30599,
  [SMALL_STATE(1057)] = 30661,
  [SMALL_STATE(1058)] = 30757,
  [SMALL_STATE(1059)] = 30815,
  [SMALL_STATE(1060)] = 30874,
  [SMALL_STATE(1061)] = 30925,
  [SMALL_STATE(1062)] = 30976,
  [SMALL_STATE(1063)] = 31035,
  [SMALL_STATE(1064)] = 31086,
  [SMALL_STATE(1065)] = 31137,
  [SMALL_STATE(1066)] = 31192,
  [SMALL_STATE(1067)] = 31243,
  [SMALL_STATE(1068)] = 31294,
  [SMALL_STATE(1069)] = 31345,
  [SMALL_STATE(1070)] = 31396,
  [SMALL_STATE(1071)] = 31451,
  [SMALL_STATE(1072)] = 31502,
  [SMALL_STATE(1073)] = 31553,
  [SMALL_STATE(1074)] = 31607,
  [SMALL_STATE(1075)] = 31659,
  [SMALL_STATE(1076)] = 31759,
  [SMALL_STATE(1077)] = 31815,
  [SMALL_STATE(1078)] = 31867,
  [SMALL_STATE(1079)] = 31921,
  [SMALL_STATE(1080)] = 31975,
  [SMALL_STATE(1081)] = 32029,
  [SMALL_STATE(1082)] = 32085,
  [SMALL_STATE(1083)] = 32149,
  [SMALL_STATE(1084)] = 32213,
  [SMALL_STATE(1085)] = 32267,
  [SMALL_STATE(1086)] = 32367,
  [SMALL_STATE(1087)] = 32419,
  [SMALL_STATE(1088)] = 32473,
  [SMALL_STATE(1089)] = 32573,
  [SMALL_STATE(1090)] = 32625,
  [SMALL_STATE(1091)] = 32679,
  [SMALL_STATE(1092)] = 32728,
  [SMALL_STATE(1093)] = 32797,
  [SMALL_STATE(1094)] = 32846,
  [SMALL_STATE(1095)] = 32895,
  [SMALL_STATE(1096)] = 32948,
  [SMALL_STATE(1097)] = 32997,
  [SMALL_STATE(1098)] = 33046,
  [SMALL_STATE(1099)] = 33095,
  [SMALL_STATE(1100)] = 33144,
  [SMALL_STATE(1101)] = 33235,
  [SMALL_STATE(1102)] = 33284,
  [SMALL_STATE(1103)] = 33333,
  [SMALL_STATE(1104)] = 33382,
  [SMALL_STATE(1105)] = 33431,
  [SMALL_STATE(1106)] = 33522,
  [SMALL_STATE(1107)] = 33571,
  [SMALL_STATE(1108)] = 33620,
  [SMALL_STATE(1109)] = 33669,
  [SMALL_STATE(1110)] = 33718,
  [SMALL_STATE(1111)] = 33767,
  [SMALL_STATE(1112)] = 33862,
  [SMALL_STATE(1113)] = 33953,
  [SMALL_STATE(1114)] = 34044,
  [SMALL_STATE(1115)] = 34093,
  [SMALL_STATE(1116)] = 34188,
  [SMALL_STATE(1117)] = 34279,
  [SMALL_STATE(1118)] = 34328,
  [SMALL_STATE(1119)] = 34419,
  [SMALL_STATE(1120)] = 34510,
  [SMALL_STATE(1121)] = 34605,
  [SMALL_STATE(1122)] = 34674,
  [SMALL_STATE(1123)] = 34723,
  [SMALL_STATE(1124)] = 34772,
  [SMALL_STATE(1125)] = 34863,
  [SMALL_STATE(1126)] = 34912,
  [SMALL_STATE(1127)] = 34965,
  [SMALL_STATE(1128)] = 35060,
  [SMALL_STATE(1129)] = 35113,
  [SMALL_STATE(1130)] = 35198,
  [SMALL_STATE(1131)] = 35291,
  [SMALL_STATE(1132)] = 35340,
  [SMALL_STATE(1133)] = 35399,
  [SMALL_STATE(1134)] = 35448,
  [SMALL_STATE(1135)] = 35511,
  [SMALL_STATE(1136)] = 35560,
  [SMALL_STATE(1137)] = 35609,
  [SMALL_STATE(1138)] = 35698,
  [SMALL_STATE(1139)] = 35747,
  [SMALL_STATE(1140)] = 35796,
  [SMALL_STATE(1141)] = 35845,
  [SMALL_STATE(1142)] = 35930,
  [SMALL_STATE(1143)] = 36021,
  [SMALL_STATE(1144)] = 36070,
  [SMALL_STATE(1145)] = 36161,
  [SMALL_STATE(1146)] = 36210,
  [SMALL_STATE(1147)] = 36259,
  [SMALL_STATE(1148)] = 36356,
  [SMALL_STATE(1149)] = 36405,
  [SMALL_STATE(1150)] = 36474,
  [SMALL_STATE(1151)] = 36523,
  [SMALL_STATE(1152)] = 36572,
  [SMALL_STATE(1153)] = 36663,
  [SMALL_STATE(1154)] = 36712,
  [SMALL_STATE(1155)] = 36761,
  [SMALL_STATE(1156)] = 36852,
  [SMALL_STATE(1157)] = 36901,
  [SMALL_STATE(1158)] = 36950,
  [SMALL_STATE(1159)] = 37047,
  [SMALL_STATE(1160)] = 37138,
  [SMALL_STATE(1161)] = 37235,
  [SMALL_STATE(1162)] = 37332,
  [SMALL_STATE(1163)] = 37381,
  [SMALL_STATE(1164)] = 37430,
  [SMALL_STATE(1165)] = 37479,
  [SMALL_STATE(1166)] = 37528,
  [SMALL_STATE(1167)] = 37597,
  [SMALL_STATE(1168)] = 37688,
  [SMALL_STATE(1169)] = 37737,
  [SMALL_STATE(1170)] = 37828,
  [SMALL_STATE(1171)] = 37917,
  [SMALL_STATE(1172)] = 37986,
  [SMALL_STATE(1173)] = 38039,
  [SMALL_STATE(1174)] = 38088,
  [SMALL_STATE(1175)] = 38163,
  [SMALL_STATE(1176)] = 38254,
  [SMALL_STATE(1177)] = 38329,
  [SMALL_STATE(1178)] = 38414,
  [SMALL_STATE(1179)] = 38499,
  [SMALL_STATE(1180)] = 38548,
  [SMALL_STATE(1181)] = 38597,
  [SMALL_STATE(1182)] = 38646,
  [SMALL_STATE(1183)] = 38695,
  [SMALL_STATE(1184)] = 38776,
  [SMALL_STATE(1185)] = 38825,
  [SMALL_STATE(1186)] = 38906,
  [SMALL_STATE(1187)] = 38959,
  [SMALL_STATE(1188)] = 39026,
  [SMALL_STATE(1189)] = 39075,
  [SMALL_STATE(1190)] = 39124,
  [SMALL_STATE(1191)] = 39209,
  [SMALL_STATE(1192)] = 39300,
  [SMALL_STATE(1193)] = 39391,
  [SMALL_STATE(1194)] = 39482,
  [SMALL_STATE(1195)] = 39567,
  [SMALL_STATE(1196)] = 39616,
  [SMALL_STATE(1197)] = 39707,
  [SMALL_STATE(1198)] = 39798,
  [SMALL_STATE(1199)] = 39889,
  [SMALL_STATE(1200)] = 39938,
  [SMALL_STATE(1201)] = 39987,
  [SMALL_STATE(1202)] = 40036,
  [SMALL_STATE(1203)] = 40085,
  [SMALL_STATE(1204)] = 40134,
  [SMALL_STATE(1205)] = 40211,
  [SMALL_STATE(1206)] = 40262,
  [SMALL_STATE(1207)] = 40313,
  [SMALL_STATE(1208)] = 40362,
  [SMALL_STATE(1209)] = 40415,
  [SMALL_STATE(1210)] = 40464,
  [SMALL_STATE(1211)] = 40513,
  [SMALL_STATE(1212)] = 40562,
  [SMALL_STATE(1213)] = 40611,
  [SMALL_STATE(1214)] = 40688,
  [SMALL_STATE(1215)] = 40739,
  [SMALL_STATE(1216)] = 40788,
  [SMALL_STATE(1217)] = 40885,
  [SMALL_STATE(1218)] = 40956,
  [SMALL_STATE(1219)] = 41005,
  [SMALL_STATE(1220)] = 41058,
  [SMALL_STATE(1221)] = 41107,
  [SMALL_STATE(1222)] = 41178,
  [SMALL_STATE(1223)] = 41227,
  [SMALL_STATE(1224)] = 41318,
  [SMALL_STATE(1225)] = 41409,
  [SMALL_STATE(1226)] = 41500,
  [SMALL_STATE(1227)] = 41597,
  [SMALL_STATE(1228)] = 41682,
  [SMALL_STATE(1229)] = 41731,
  [SMALL_STATE(1230)] = 41822,
  [SMALL_STATE(1231)] = 41913,
  [SMALL_STATE(1232)] = 41962,
  [SMALL_STATE(1233)] = 42011,
  [SMALL_STATE(1234)] = 42102,
  [SMALL_STATE(1235)] = 42193,
  [SMALL_STATE(1236)] = 42284,
  [SMALL_STATE(1237)] = 42375,
  [SMALL_STATE(1238)] = 42466,
  [SMALL_STATE(1239)] = 42561,
  [SMALL_STATE(1240)] = 42610,
  [SMALL_STATE(1241)] = 42659,
  [SMALL_STATE(1242)] = 42708,
  [SMALL_STATE(1243)] = 42793,
  [SMALL_STATE(1244)] = 42852,
  [SMALL_STATE(1245)] = 42911,
  [SMALL_STATE(1246)] = 42960,
  [SMALL_STATE(1247)] = 43009,
  [SMALL_STATE(1248)] = 43058,
  [SMALL_STATE(1249)] = 43113,
  [SMALL_STATE(1250)] = 43204,
  [SMALL_STATE(1251)] = 43253,
  [SMALL_STATE(1252)] = 43302,
  [SMALL_STATE(1253)] = 43351,
  [SMALL_STATE(1254)] = 43400,
  [SMALL_STATE(1255)] = 43449,
  [SMALL_STATE(1256)] = 43516,
  [SMALL_STATE(1257)] = 43567,
  [SMALL_STATE(1258)] = 43620,
  [SMALL_STATE(1259)] = 43673,
  [SMALL_STATE(1260)] = 43722,
  [SMALL_STATE(1261)] = 43771,
  [SMALL_STATE(1262)] = 43820,
  [SMALL_STATE(1263)] = 43869,
  [SMALL_STATE(1264)] = 43918,
  [SMALL_STATE(1265)] = 43967,
  [SMALL_STATE(1266)] = 44016,
  [SMALL_STATE(1267)] = 44065,
  [SMALL_STATE(1268)] = 44114,
  [SMALL_STATE(1269)] = 44163,
  [SMALL_STATE(1270)] = 44212,
  [SMALL_STATE(1271)] = 44271,
  [SMALL_STATE(1272)] = 44340,
  [SMALL_STATE(1273)] = 44430,
  [SMALL_STATE(1274)] = 44520,
  [SMALL_STATE(1275)] = 44570,
  [SMALL_STATE(1276)] = 44646,
  [SMALL_STATE(1277)] = 44736,
  [SMALL_STATE(1278)] = 44826,
  [SMALL_STATE(1279)] = 44916,
  [SMALL_STATE(1280)] = 45006,
  [SMALL_STATE(1281)] = 45096,
  [SMALL_STATE(1282)] = 45148,
  [SMALL_STATE(1283)] = 45238,
  [SMALL_STATE(1284)] = 45328,
  [SMALL_STATE(1285)] = 45418,
  [SMALL_STATE(1286)] = 45508,
  [SMALL_STATE(1287)] = 45600,
  [SMALL_STATE(1288)] = 45694,
  [SMALL_STATE(1289)] = 45762,
  [SMALL_STATE(1290)] = 45852,
  [SMALL_STATE(1291)] = 45922,
  [SMALL_STATE(1292)] = 45998,
  [SMALL_STATE(1293)] = 46090,
  [SMALL_STATE(1294)] = 46180,
  [SMALL_STATE(1295)] = 46272,
  [SMALL_STATE(1296)] = 46320,
  [SMALL_STATE(1297)] = 46406,
  [SMALL_STATE(1298)] = 46498,
  [SMALL_STATE(1299)] = 46588,
  [SMALL_STATE(1300)] = 46682,
  [SMALL_STATE(1301)] = 46772,
  [SMALL_STATE(1302)] = 46862,
  [SMALL_STATE(1303)] = 46952,
  [SMALL_STATE(1304)] = 47042,
  [SMALL_STATE(1305)] = 47130,
  [SMALL_STATE(1306)] = 47224,
  [SMALL_STATE(1307)] = 47304,
  [SMALL_STATE(1308)] = 47388,
  [SMALL_STATE(1309)] = 47462,
  [SMALL_STATE(1310)] = 47530,
  [SMALL_STATE(1311)] = 47604,
  [SMALL_STATE(1312)] = 47688,
  [SMALL_STATE(1313)] = 47768,
  [SMALL_STATE(1314)] = 47844,
  [SMALL_STATE(1315)] = 47914,
  [SMALL_STATE(1316)] = 47982,
  [SMALL_STATE(1317)] = 48034,
  [SMALL_STATE(1318)] = 48122,
  [SMALL_STATE(1319)] = 48212,
  [SMALL_STATE(1320)] = 48302,
  [SMALL_STATE(1321)] = 48354,
  [SMALL_STATE(1322)] = 48406,
  [SMALL_STATE(1323)] = 48486,
  [SMALL_STATE(1324)] = 48576,
  [SMALL_STATE(1325)] = 48642,
  [SMALL_STATE(1326)] = 48710,
  [SMALL_STATE(1327)] = 48794,
  [SMALL_STATE(1328)] = 48884,
  [SMALL_STATE(1329)] = 48974,
  [SMALL_STATE(1330)] = 49030,
  [SMALL_STATE(1331)] = 49104,
  [SMALL_STATE(1332)] = 49172,
  [SMALL_STATE(1333)] = 49266,
  [SMALL_STATE(1334)] = 49354,
  [SMALL_STATE(1335)] = 49444,
  [SMALL_STATE(1336)] = 49506,
  [SMALL_STATE(1337)] = 49596,
  [SMALL_STATE(1338)] = 49688,
  [SMALL_STATE(1339)] = 49780,
  [SMALL_STATE(1340)] = 49866,
  [SMALL_STATE(1341)] = 49952,
  [SMALL_STATE(1342)] = 50044,
  [SMALL_STATE(1343)] = 50102,
  [SMALL_STATE(1344)] = 50194,
  [SMALL_STATE(1345)] = 50288,
  [SMALL_STATE(1346)] = 50378,
  [SMALL_STATE(1347)] = 50470,
  [SMALL_STATE(1348)] = 50564,
  [SMALL_STATE(1349)] = 50658,
  [SMALL_STATE(1350)] = 50750,
  [SMALL_STATE(1351)] = 50798,
  [SMALL_STATE(1352)] = 50856,
  [SMALL_STATE(1353)] = 50924,
  [SMALL_STATE(1354)] = 51018,
  [SMALL_STATE(1355)] = 51108,
  [SMALL_STATE(1356)] = 51200,
  [SMALL_STATE(1357)] = 51266,
  [SMALL_STATE(1358)] = 51356,
  [SMALL_STATE(1359)] = 51446,
  [SMALL_STATE(1360)] = 51532,
  [SMALL_STATE(1361)] = 51624,
  [SMALL_STATE(1362)] = 51718,
  [SMALL_STATE(1363)] = 51766,
  [SMALL_STATE(1364)] = 51860,
  [SMALL_STATE(1365)] = 51950,
  [SMALL_STATE(1366)] = 51998,
  [SMALL_STATE(1367)] = 52090,
  [SMALL_STATE(1368)] = 52140,
  [SMALL_STATE(1369)] = 52234,
  [SMALL_STATE(1370)] = 52288,
  [SMALL_STATE(1371)] = 52346,
  [SMALL_STATE(1372)] = 52438,
  [SMALL_STATE(1373)] = 52506,
  [SMALL_STATE(1374)] = 52574,
  [SMALL_STATE(1375)] = 52664,
  [SMALL_STATE(1376)] = 52756,
  [SMALL_STATE(1377)] = 52848,
  [SMALL_STATE(1378)] = 52942,
  [SMALL_STATE(1379)] = 53034,
  [SMALL_STATE(1380)] = 53126,
  [SMALL_STATE(1381)] = 53218,
  [SMALL_STATE(1382)] = 53308,
  [SMALL_STATE(1383)] = 53358,
  [SMALL_STATE(1384)] = 53448,
  [SMALL_STATE(1385)] = 53538,
  [SMALL_STATE(1386)] = 53630,
  [SMALL_STATE(1387)] = 53720,
  [SMALL_STATE(1388)] = 53768,
  [SMALL_STATE(1389)] = 53854,
  [SMALL_STATE(1390)] = 53944,
  [SMALL_STATE(1391)] = 53994,
  [SMALL_STATE(1392)] = 54084,
  [SMALL_STATE(1393)] = 54174,
  [SMALL_STATE(1394)] = 54244,
  [SMALL_STATE(1395)] = 54310,
  [SMALL_STATE(1396)] = 54366,
  [SMALL_STATE(1397)] = 54414,
  [SMALL_STATE(1398)] = 54506,
  [SMALL_STATE(1399)] = 54574,
  [SMALL_STATE(1400)] = 54632,
  [SMALL_STATE(1401)] = 54722,
  [SMALL_STATE(1402)] = 54811,
  [SMALL_STATE(1403)] = 54902,
  [SMALL_STATE(1404)] = 54951,
  [SMALL_STATE(1405)] = 55002,
  [SMALL_STATE(1406)] = 55057,
  [SMALL_STATE(1407)] = 55138,
  [SMALL_STATE(1408)] = 55189,
  [SMALL_STATE(1409)] = 55278,
  [SMALL_STATE(1410)] = 55329,
  [SMALL_STATE(1411)] = 55380,
  [SMALL_STATE(1412)] = 55469,
  [SMALL_STATE(1413)] = 55548,
  [SMALL_STATE(1414)] = 55599,
  [SMALL_STATE(1415)] = 55690,
  [SMALL_STATE(1416)] = 55757,
  [SMALL_STATE(1417)] = 55846,
  [SMALL_STATE(1418)] = 55915,
  [SMALL_STATE(1419)] = 55966,
  [SMALL_STATE(1420)] = 56017,
  [SMALL_STATE(1421)] = 56098,
  [SMALL_STATE(1422)] = 56147,
  [SMALL_STATE(1423)] = 56228,
  [SMALL_STATE(1424)] = 56281,
  [SMALL_STATE(1425)] = 56362,
  [SMALL_STATE(1426)] = 56443,
  [SMALL_STATE(1427)] = 56534,
  [SMALL_STATE(1428)] = 56625,
  [SMALL_STATE(1429)] = 56714,
  [SMALL_STATE(1430)] = 56805,
  [SMALL_STATE(1431)] = 56894,
  [SMALL_STATE(1432)] = 56975,
  [SMALL_STATE(1433)] = 57064,
  [SMALL_STATE(1434)] = 57153,
  [SMALL_STATE(1435)] = 57244,
  [SMALL_STATE(1436)] = 57325,
  [SMALL_STATE(1437)] = 57416,
  [SMALL_STATE(1438)] = 57469,
  [SMALL_STATE(1439)] = 57550,
  [SMALL_STATE(1440)] = 57603,
  [SMALL_STATE(1441)] = 57692,
  [SMALL_STATE(1442)] = 57773,
  [SMALL_STATE(1443)] = 57864,
  [SMALL_STATE(1444)] = 57945,
  [SMALL_STATE(1445)] = 58026,
  [SMALL_STATE(1446)] = 58093,
  [SMALL_STATE(1447)] = 58158,
  [SMALL_STATE(1448)] = 58247,
  [SMALL_STATE(1449)] = 58336,
  [SMALL_STATE(1450)] = 58389,
  [SMALL_STATE(1451)] = 58480,
  [SMALL_STATE(1452)] = 58547,
  [SMALL_STATE(1453)] = 58616,
  [SMALL_STATE(1454)] = 58681,
  [SMALL_STATE(1455)] = 58770,
  [SMALL_STATE(1456)] = 58819,
  [SMALL_STATE(1457)] = 58884,
  [SMALL_STATE(1458)] = 58937,
  [SMALL_STATE(1459)] = 58988,
  [SMALL_STATE(1460)] = 59037,
  [SMALL_STATE(1461)] = 59088,
  [SMALL_STATE(1462)] = 59139,
  [SMALL_STATE(1463)] = 59190,
  [SMALL_STATE(1464)] = 59241,
  [SMALL_STATE(1465)] = 59332,
  [SMALL_STATE(1466)] = 59383,
  [SMALL_STATE(1467)] = 59432,
  [SMALL_STATE(1468)] = 59521,
  [SMALL_STATE(1469)] = 59610,
  [SMALL_STATE(1470)] = 59677,
  [SMALL_STATE(1471)] = 59768,
  [SMALL_STATE(1472)] = 59857,
  [SMALL_STATE(1473)] = 59946,
  [SMALL_STATE(1474)] = 59995,
  [SMALL_STATE(1475)] = 60064,
  [SMALL_STATE(1476)] = 60129,
  [SMALL_STATE(1477)] = 60218,
  [SMALL_STATE(1478)] = 60307,
  [SMALL_STATE(1479)] = 60388,
  [SMALL_STATE(1480)] = 60477,
  [SMALL_STATE(1481)] = 60558,
  [SMALL_STATE(1482)] = 60607,
  [SMALL_STATE(1483)] = 60658,
  [SMALL_STATE(1484)] = 60747,
  [SMALL_STATE(1485)] = 60836,
  [SMALL_STATE(1486)] = 60925,
  [SMALL_STATE(1487)] = 60976,
  [SMALL_STATE(1488)] = 61027,
  [SMALL_STATE(1489)] = 61078,
  [SMALL_STATE(1490)] = 61169,
  [SMALL_STATE(1491)] = 61238,
  [SMALL_STATE(1492)] = 61319,
  [SMALL_STATE(1493)] = 61406,
  [SMALL_STATE(1494)] = 61473,
  [SMALL_STATE(1495)] = 61522,
  [SMALL_STATE(1496)] = 61591,
  [SMALL_STATE(1497)] = 61642,
  [SMALL_STATE(1498)] = 61733,
  [SMALL_STATE(1499)] = 61808,
  [SMALL_STATE(1500)] = 61859,
  [SMALL_STATE(1501)] = 61950,
  [SMALL_STATE(1502)] = 62001,
  [SMALL_STATE(1503)] = 62074,
  [SMALL_STATE(1504)] = 62165,
  [SMALL_STATE(1505)] = 62254,
  [SMALL_STATE(1506)] = 62321,
  [SMALL_STATE(1507)] = 62410,
  [SMALL_STATE(1508)] = 62465,
  [SMALL_STATE(1509)] = 62554,
  [SMALL_STATE(1510)] = 62605,
  [SMALL_STATE(1511)] = 62688,
  [SMALL_STATE(1512)] = 62779,
  [SMALL_STATE(1513)] = 62844,
  [SMALL_STATE(1514)] = 62911,
  [SMALL_STATE(1515)] = 62977,
  [SMALL_STATE(1516)] = 63027,
  [SMALL_STATE(1517)] = 63077,
  [SMALL_STATE(1518)] = 63127,
  [SMALL_STATE(1519)] = 63173,
  [SMALL_STATE(1520)] = 63219,
  [SMALL_STATE(1521)] = 63265,
  [SMALL_STATE(1522)] = 63311,
  [SMALL_STATE(1523)] = 63359,
  [SMALL_STATE(1524)] = 63419,
  [SMALL_STATE(1525)] = 63467,
  [SMALL_STATE(1526)] = 63513,
  [SMALL_STATE(1527)] = 63559,
  [SMALL_STATE(1528)] = 63647,
  [SMALL_STATE(1529)] = 63693,
  [SMALL_STATE(1530)] = 63741,
  [SMALL_STATE(1531)] = 63787,
  [SMALL_STATE(1532)] = 63847,
  [SMALL_STATE(1533)] = 63895,
  [SMALL_STATE(1534)] = 63961,
  [SMALL_STATE(1535)] = 64007,
  [SMALL_STATE(1536)] = 64095,
  [SMALL_STATE(1537)] = 64141,
  [SMALL_STATE(1538)] = 64187,
  [SMALL_STATE(1539)] = 64275,
  [SMALL_STATE(1540)] = 64321,
  [SMALL_STATE(1541)] = 64367,
  [SMALL_STATE(1542)] = 64413,
  [SMALL_STATE(1543)] = 64459,
  [SMALL_STATE(1544)] = 64523,
  [SMALL_STATE(1545)] = 64611,
  [SMALL_STATE(1546)] = 64675,
  [SMALL_STATE(1547)] = 64727,
  [SMALL_STATE(1548)] = 64773,
  [SMALL_STATE(1549)] = 64819,
  [SMALL_STATE(1550)] = 64865,
  [SMALL_STATE(1551)] = 64917,
  [SMALL_STATE(1552)] = 64963,
  [SMALL_STATE(1553)] = 65009,
  [SMALL_STATE(1554)] = 65055,
  [SMALL_STATE(1555)] = 65101,
  [SMALL_STATE(1556)] = 65147,
  [SMALL_STATE(1557)] = 65197,
  [SMALL_STATE(1558)] = 65243,
  [SMALL_STATE(1559)] = 65289,
  [SMALL_STATE(1560)] = 65335,
  [SMALL_STATE(1561)] = 65385,
  [SMALL_STATE(1562)] = 65431,
  [SMALL_STATE(1563)] = 65477,
  [SMALL_STATE(1564)] = 65523,
  [SMALL_STATE(1565)] = 65569,
  [SMALL_STATE(1566)] = 65615,
  [SMALL_STATE(1567)] = 65661,
  [SMALL_STATE(1568)] = 65709,
  [SMALL_STATE(1569)] = 65761,
  [SMALL_STATE(1570)] = 65807,
  [SMALL_STATE(1571)] = 65855,
  [SMALL_STATE(1572)] = 65901,
  [SMALL_STATE(1573)] = 65947,
  [SMALL_STATE(1574)] = 65999,
  [SMALL_STATE(1575)] = 66049,
  [SMALL_STATE(1576)] = 66095,
  [SMALL_STATE(1577)] = 66141,
  [SMALL_STATE(1578)] = 66191,
  [SMALL_STATE(1579)] = 66237,
  [SMALL_STATE(1580)] = 66287,
  [SMALL_STATE(1581)] = 66333,
  [SMALL_STATE(1582)] = 66379,
  [SMALL_STATE(1583)] = 66445,
  [SMALL_STATE(1584)] = 66533,
  [SMALL_STATE(1585)] = 66579,
  [SMALL_STATE(1586)] = 66627,
  [SMALL_STATE(1587)] = 66675,
  [SMALL_STATE(1588)] = 66721,
  [SMALL_STATE(1589)] = 66767,
  [SMALL_STATE(1590)] = 66813,
  [SMALL_STATE(1591)] = 66859,
  [SMALL_STATE(1592)] = 66905,
  [SMALL_STATE(1593)] = 66959,
  [SMALL_STATE(1594)] = 67013,
  [SMALL_STATE(1595)] = 67067,
  [SMALL_STATE(1596)] = 67133,
  [SMALL_STATE(1597)] = 67179,
  [SMALL_STATE(1598)] = 67243,
  [SMALL_STATE(1599)] = 67331,
  [SMALL_STATE(1600)] = 67377,
  [SMALL_STATE(1601)] = 67423,
  [SMALL_STATE(1602)] = 67469,
  [SMALL_STATE(1603)] = 67519,
  [SMALL_STATE(1604)] = 67607,
  [SMALL_STATE(1605)] = 67659,
  [SMALL_STATE(1606)] = 67717,
  [SMALL_STATE(1607)] = 67805,
  [SMALL_STATE(1608)] = 67893,
  [SMALL_STATE(1609)] = 67981,
  [SMALL_STATE(1610)] = 68031,
  [SMALL_STATE(1611)] = 68081,
  [SMALL_STATE(1612)] = 68169,
  [SMALL_STATE(1613)] = 68215,
  [SMALL_STATE(1614)] = 68261,
  [SMALL_STATE(1615)] = 68307,
  [SMALL_STATE(1616)] = 68357,
  [SMALL_STATE(1617)] = 68405,
  [SMALL_STATE(1618)] = 68451,
  [SMALL_STATE(1619)] = 68497,
  [SMALL_STATE(1620)] = 68543,
  [SMALL_STATE(1621)] = 68631,
  [SMALL_STATE(1622)] = 68719,
  [SMALL_STATE(1623)] = 68807,
  [SMALL_STATE(1624)] = 68895,
  [SMALL_STATE(1625)] = 68983,
  [SMALL_STATE(1626)] = 69029,
  [SMALL_STATE(1627)] = 69075,
  [SMALL_STATE(1628)] = 69163,
  [SMALL_STATE(1629)] = 69209,
  [SMALL_STATE(1630)] = 69255,
  [SMALL_STATE(1631)] = 69303,
  [SMALL_STATE(1632)] = 69351,
  [SMALL_STATE(1633)] = 69399,
  [SMALL_STATE(1634)] = 69487,
  [SMALL_STATE(1635)] = 69533,
  [SMALL_STATE(1636)] = 69579,
  [SMALL_STATE(1637)] = 69625,
  [SMALL_STATE(1638)] = 69671,
  [SMALL_STATE(1639)] = 69717,
  [SMALL_STATE(1640)] = 69805,
  [SMALL_STATE(1641)] = 69893,
  [SMALL_STATE(1642)] = 69939,
  [SMALL_STATE(1643)] = 69989,
  [SMALL_STATE(1644)] = 70077,
  [SMALL_STATE(1645)] = 70123,
  [SMALL_STATE(1646)] = 70169,
  [SMALL_STATE(1647)] = 70257,
  [SMALL_STATE(1648)] = 70303,
  [SMALL_STATE(1649)] = 70353,
  [SMALL_STATE(1650)] = 70401,
  [SMALL_STATE(1651)] = 70489,
  [SMALL_STATE(1652)] = 70577,
  [SMALL_STATE(1653)] = 70665,
  [SMALL_STATE(1654)] = 70715,
  [SMALL_STATE(1655)] = 70801,
  [SMALL_STATE(1656)] = 70867,
  [SMALL_STATE(1657)] = 70939,
  [SMALL_STATE(1658)] = 71021,
  [SMALL_STATE(1659)] = 71087,
  [SMALL_STATE(1660)] = 71175,
  [SMALL_STATE(1661)] = 71249,
  [SMALL_STATE(1662)] = 71337,
  [SMALL_STATE(1663)] = 71405,
  [SMALL_STATE(1664)] = 71451,
  [SMALL_STATE(1665)] = 71497,
  [SMALL_STATE(1666)] = 71585,
  [SMALL_STATE(1667)] = 71673,
  [SMALL_STATE(1668)] = 71761,
  [SMALL_STATE(1669)] = 71849,
  [SMALL_STATE(1670)] = 71937,
  [SMALL_STATE(1671)] = 71983,
  [SMALL_STATE(1672)] = 72031,
  [SMALL_STATE(1673)] = 72079,
  [SMALL_STATE(1674)] = 72143,
  [SMALL_STATE(1675)] = 72191,
  [SMALL_STATE(1676)] = 72237,
  [SMALL_STATE(1677)] = 72285,
  [SMALL_STATE(1678)] = 72345,
  [SMALL_STATE(1679)] = 72433,
  [SMALL_STATE(1680)] = 72497,
  [SMALL_STATE(1681)] = 72565,
  [SMALL_STATE(1682)] = 72653,
  [SMALL_STATE(1683)] = 72741,
  [SMALL_STATE(1684)] = 72829,
  [SMALL_STATE(1685)] = 72903,
  [SMALL_STATE(1686)] = 72949,
  [SMALL_STATE(1687)] = 72995,
  [SMALL_STATE(1688)] = 73041,
  [SMALL_STATE(1689)] = 73087,
  [SMALL_STATE(1690)] = 73173,
  [SMALL_STATE(1691)] = 73239,
  [SMALL_STATE(1692)] = 73285,
  [SMALL_STATE(1693)] = 73363,
  [SMALL_STATE(1694)] = 73451,
  [SMALL_STATE(1695)] = 73511,
  [SMALL_STATE(1696)] = 73557,
  [SMALL_STATE(1697)] = 73645,
  [SMALL_STATE(1698)] = 73717,
  [SMALL_STATE(1699)] = 73763,
  [SMALL_STATE(1700)] = 73845,
  [SMALL_STATE(1701)] = 73923,
  [SMALL_STATE(1702)] = 73969,
  [SMALL_STATE(1703)] = 74017,
  [SMALL_STATE(1704)] = 74105,
  [SMALL_STATE(1705)] = 74193,
  [SMALL_STATE(1706)] = 74281,
  [SMALL_STATE(1707)] = 74369,
  [SMALL_STATE(1708)] = 74437,
  [SMALL_STATE(1709)] = 74482,
  [SMALL_STATE(1710)] = 74529,
  [SMALL_STATE(1711)] = 74588,
  [SMALL_STATE(1712)] = 74649,
  [SMALL_STATE(1713)] = 74710,
  [SMALL_STATE(1714)] = 74769,
  [SMALL_STATE(1715)] = 74820,
  [SMALL_STATE(1716)] = 74883,
  [SMALL_STATE(1717)] = 74942,
  [SMALL_STATE(1718)] = 75001,
  [SMALL_STATE(1719)] = 75046,
  [SMALL_STATE(1720)] = 75091,
  [SMALL_STATE(1721)] = 75136,
  [SMALL_STATE(1722)] = 75183,
  [SMALL_STATE(1723)] = 75230,
  [SMALL_STATE(1724)] = 75293,
  [SMALL_STATE(1725)] = 75354,
  [SMALL_STATE(1726)] = 75413,
  [SMALL_STATE(1727)] = 75472,
  [SMALL_STATE(1728)] = 75517,
  [SMALL_STATE(1729)] = 75578,
  [SMALL_STATE(1730)] = 75639,
  [SMALL_STATE(1731)] = 75698,
  [SMALL_STATE(1732)] = 75757,
  [SMALL_STATE(1733)] = 75820,
  [SMALL_STATE(1734)] = 75879,
  [SMALL_STATE(1735)] = 75964,
  [SMALL_STATE(1736)] = 76009,
  [SMALL_STATE(1737)] = 76054,
  [SMALL_STATE(1738)] = 76113,
  [SMALL_STATE(1739)] = 76172,
  [SMALL_STATE(1740)] = 76217,
  [SMALL_STATE(1741)] = 76262,
  [SMALL_STATE(1742)] = 76307,
  [SMALL_STATE(1743)] = 76352,
  [SMALL_STATE(1744)] = 76397,
  [SMALL_STATE(1745)] = 76442,
  [SMALL_STATE(1746)] = 76487,
  [SMALL_STATE(1747)] = 76532,
  [SMALL_STATE(1748)] = 76577,
  [SMALL_STATE(1749)] = 76622,
  [SMALL_STATE(1750)] = 76667,
  [SMALL_STATE(1751)] = 76712,
  [SMALL_STATE(1752)] = 76761,
  [SMALL_STATE(1753)] = 76806,
  [SMALL_STATE(1754)] = 76851,
  [SMALL_STATE(1755)] = 76896,
  [SMALL_STATE(1756)] = 76945,
  [SMALL_STATE(1757)] = 76990,
  [SMALL_STATE(1758)] = 77035,
  [SMALL_STATE(1759)] = 77084,
  [SMALL_STATE(1760)] = 77129,
  [SMALL_STATE(1761)] = 77174,
  [SMALL_STATE(1762)] = 77223,
  [SMALL_STATE(1763)] = 77272,
  [SMALL_STATE(1764)] = 77321,
  [SMALL_STATE(1765)] = 77366,
  [SMALL_STATE(1766)] = 77415,
  [SMALL_STATE(1767)] = 77464,
  [SMALL_STATE(1768)] = 77511,
  [SMALL_STATE(1769)] = 77556,
  [SMALL_STATE(1770)] = 77607,
  [SMALL_STATE(1771)] = 77658,
  [SMALL_STATE(1772)] = 77703,
  [SMALL_STATE(1773)] = 77748,
  [SMALL_STATE(1774)] = 77793,
  [SMALL_STATE(1775)] = 77842,
  [SMALL_STATE(1776)] = 77887,
  [SMALL_STATE(1777)] = 77932,
  [SMALL_STATE(1778)] = 77977,
  [SMALL_STATE(1779)] = 78022,
  [SMALL_STATE(1780)] = 78067,
  [SMALL_STATE(1781)] = 78152,
  [SMALL_STATE(1782)] = 78197,
  [SMALL_STATE(1783)] = 78242,
  [SMALL_STATE(1784)] = 78291,
  [SMALL_STATE(1785)] = 78336,
  [SMALL_STATE(1786)] = 78381,
  [SMALL_STATE(1787)] = 78466,
  [SMALL_STATE(1788)] = 78511,
  [SMALL_STATE(1789)] = 78556,
  [SMALL_STATE(1790)] = 78601,
  [SMALL_STATE(1791)] = 78646,
  [SMALL_STATE(1792)] = 78691,
  [SMALL_STATE(1793)] = 78736,
  [SMALL_STATE(1794)] = 78781,
  [SMALL_STATE(1795)] = 78826,
  [SMALL_STATE(1796)] = 78871,
  [SMALL_STATE(1797)] = 78916,
  [SMALL_STATE(1798)] = 78967,
  [SMALL_STATE(1799)] = 79012,
  [SMALL_STATE(1800)] = 79057,
  [SMALL_STATE(1801)] = 79102,
  [SMALL_STATE(1802)] = 79147,
  [SMALL_STATE(1803)] = 79192,
  [SMALL_STATE(1804)] = 79255,
  [SMALL_STATE(1805)] = 79300,
  [SMALL_STATE(1806)] = 79345,
  [SMALL_STATE(1807)] = 79406,
  [SMALL_STATE(1808)] = 79451,
  [SMALL_STATE(1809)] = 79510,
  [SMALL_STATE(1810)] = 79555,
  [SMALL_STATE(1811)] = 79600,
  [SMALL_STATE(1812)] = 79645,
  [SMALL_STATE(1813)] = 79690,
  [SMALL_STATE(1814)] = 79735,
  [SMALL_STATE(1815)] = 79780,
  [SMALL_STATE(1816)] = 79827,
  [SMALL_STATE(1817)] = 79876,
  [SMALL_STATE(1818)] = 79921,
  [SMALL_STATE(1819)] = 79966,
  [SMALL_STATE(1820)] = 80011,
  [SMALL_STATE(1821)] = 80056,
  [SMALL_STATE(1822)] = 80101,
  [SMALL_STATE(1823)] = 80146,
  [SMALL_STATE(1824)] = 80191,
  [SMALL_STATE(1825)] = 80250,
  [SMALL_STATE(1826)] = 80297,
  [SMALL_STATE(1827)] = 80342,
  [SMALL_STATE(1828)] = 80405,
  [SMALL_STATE(1829)] = 80450,
  [SMALL_STATE(1830)] = 80511,
  [SMALL_STATE(1831)] = 80556,
  [SMALL_STATE(1832)] = 80601,
  [SMALL_STATE(1833)] = 80646,
  [SMALL_STATE(1834)] = 80691,
  [SMALL_STATE(1835)] = 80736,
  [SMALL_STATE(1836)] = 80781,
  [SMALL_STATE(1837)] = 80840,
  [SMALL_STATE(1838)] = 80885,
  [SMALL_STATE(1839)] = 80930,
  [SMALL_STATE(1840)] = 80975,
  [SMALL_STATE(1841)] = 81022,
  [SMALL_STATE(1842)] = 81076,
  [SMALL_STATE(1843)] = 81130,
  [SMALL_STATE(1844)] = 81184,
  [SMALL_STATE(1845)] = 81252,
  [SMALL_STATE(1846)] = 81302,
  [SMALL_STATE(1847)] = 81352,
  [SMALL_STATE(1848)] = 81406,
  [SMALL_STATE(1849)] = 81472,
  [SMALL_STATE(1850)] = 81542,
  [SMALL_STATE(1851)] = 81592,
  [SMALL_STATE(1852)] = 81660,
  [SMALL_STATE(1853)] = 81708,
  [SMALL_STATE(1854)] = 81762,
  [SMALL_STATE(1855)] = 81832,
  [SMALL_STATE(1856)] = 81882,
  [SMALL_STATE(1857)] = 81932,
  [SMALL_STATE(1858)] = 81998,
  [SMALL_STATE(1859)] = 82052,
  [SMALL_STATE(1860)] = 82106,
  [SMALL_STATE(1861)] = 82156,
  [SMALL_STATE(1862)] = 82210,
  [SMALL_STATE(1863)] = 82278,
  [SMALL_STATE(1864)] = 82328,
  [SMALL_STATE(1865)] = 82398,
  [SMALL_STATE(1866)] = 82464,
  [SMALL_STATE(1867)] = 82512,
  [SMALL_STATE(1868)] = 82560,
  [SMALL_STATE(1869)] = 82614,
  [SMALL_STATE(1870)] = 82668,
  [SMALL_STATE(1871)] = 82722,
  [SMALL_STATE(1872)] = 82768,
  [SMALL_STATE(1873)] = 82814,
  [SMALL_STATE(1874)] = 82860,
  [SMALL_STATE(1875)] = 82926,
  [SMALL_STATE(1876)] = 82996,
  [SMALL_STATE(1877)] = 83050,
  [SMALL_STATE(1878)] = 83104,
  [SMALL_STATE(1879)] = 83172,
  [SMALL_STATE(1880)] = 83222,
  [SMALL_STATE(1881)] = 83268,
  [SMALL_STATE(1882)] = 83336,
  [SMALL_STATE(1883)] = 83390,
  [SMALL_STATE(1884)] = 83444,
  [SMALL_STATE(1885)] = 83514,
  [SMALL_STATE(1886)] = 83580,
  [SMALL_STATE(1887)] = 83641,
  [SMALL_STATE(1888)] = 83702,
  [SMALL_STATE(1889)] = 83773,
  [SMALL_STATE(1890)] = 83844,
  [SMALL_STATE(1891)] = 83905,
  [SMALL_STATE(1892)] = 83954,
  [SMALL_STATE(1893)] = 84015,
  [SMALL_STATE(1894)] = 84064,
  [SMALL_STATE(1895)] = 84135,
  [SMALL_STATE(1896)] = 84198,
  [SMALL_STATE(1897)] = 84247,
  [SMALL_STATE(1898)] = 84308,
  [SMALL_STATE(1899)] = 84373,
  [SMALL_STATE(1900)] = 84434,
  [SMALL_STATE(1901)] = 84505,
  [SMALL_STATE(1902)] = 84576,
  [SMALL_STATE(1903)] = 84647,
  [SMALL_STATE(1904)] = 84718,
  [SMALL_STATE(1905)] = 84789,
  [SMALL_STATE(1906)] = 84860,
  [SMALL_STATE(1907)] = 84928,
  [SMALL_STATE(1908)] = 84970,
  [SMALL_STATE(1909)] = 85026,
  [SMALL_STATE(1910)] = 85094,
  [SMALL_STATE(1911)] = 85162,
  [SMALL_STATE(1912)] = 85204,
  [SMALL_STATE(1913)] = 85272,
  [SMALL_STATE(1914)] = 85323,
  [SMALL_STATE(1915)] = 85374,
  [SMALL_STATE(1916)] = 85449,
  [SMALL_STATE(1917)] = 85500,
  [SMALL_STATE(1918)] = 85551,
  [SMALL_STATE(1919)] = 85626,
  [SMALL_STATE(1920)] = 85701,
  [SMALL_STATE(1921)] = 85752,
  [SMALL_STATE(1922)] = 85827,
  [SMALL_STATE(1923)] = 85902,
  [SMALL_STATE(1924)] = 85977,
  [SMALL_STATE(1925)] = 86017,
  [SMALL_STATE(1926)] = 86057,
  [SMALL_STATE(1927)] = 86097,
  [SMALL_STATE(1928)] = 86137,
  [SMALL_STATE(1929)] = 86183,
  [SMALL_STATE(1930)] = 86223,
  [SMALL_STATE(1931)] = 86263,
  [SMALL_STATE(1932)] = 86316,
  [SMALL_STATE(1933)] = 86371,
  [SMALL_STATE(1934)] = 86422,
  [SMALL_STATE(1935)] = 86475,
  [SMALL_STATE(1936)] = 86530,
  [SMALL_STATE(1937)] = 86583,
  [SMALL_STATE(1938)] = 86640,
  [SMALL_STATE(1939)] = 86688,
  [SMALL_STATE(1940)] = 86726,
  [SMALL_STATE(1941)] = 86764,
  [SMALL_STATE(1942)] = 86812,
  [SMALL_STATE(1943)] = 86860,
  [SMALL_STATE(1944)] = 86908,
  [SMALL_STATE(1945)] = 86946,
  [SMALL_STATE(1946)] = 86986,
  [SMALL_STATE(1947)] = 87034,
  [SMALL_STATE(1948)] = 87082,
  [SMALL_STATE(1949)] = 87120,
  [SMALL_STATE(1950)] = 87158,
  [SMALL_STATE(1951)] = 87206,
  [SMALL_STATE(1952)] = 87254,
  [SMALL_STATE(1953)] = 87302,
  [SMALL_STATE(1954)] = 87340,
  [SMALL_STATE(1955)] = 87378,
  [SMALL_STATE(1956)] = 87418,
  [SMALL_STATE(1957)] = 87466,
  [SMALL_STATE(1958)] = 87504,
  [SMALL_STATE(1959)] = 87544,
  [SMALL_STATE(1960)] = 87592,
  [SMALL_STATE(1961)] = 87640,
  [SMALL_STATE(1962)] = 87678,
  [SMALL_STATE(1963)] = 87726,
  [SMALL_STATE(1964)] = 87764,
  [SMALL_STATE(1965)] = 87812,
  [SMALL_STATE(1966)] = 87850,
  [SMALL_STATE(1967)] = 87898,
  [SMALL_STATE(1968)] = 87936,
  [SMALL_STATE(1969)] = 87974,
  [SMALL_STATE(1970)] = 88022,
  [SMALL_STATE(1971)] = 88070,
  [SMALL_STATE(1972)] = 88118,
  [SMALL_STATE(1973)] = 88156,
  [SMALL_STATE(1974)] = 88205,
  [SMALL_STATE(1975)] = 88254,
  [SMALL_STATE(1976)] = 88303,
  [SMALL_STATE(1977)] = 88360,
  [SMALL_STATE(1978)] = 88409,
  [SMALL_STATE(1979)] = 88458,
  [SMALL_STATE(1980)] = 88507,
  [SMALL_STATE(1981)] = 88561,
  [SMALL_STATE(1982)] = 88599,
  [SMALL_STATE(1983)] = 88641,
  [SMALL_STATE(1984)] = 88687,
  [SMALL_STATE(1985)] = 88723,
  [SMALL_STATE(1986)] = 88777,
  [SMALL_STATE(1987)] = 88827,
  [SMALL_STATE(1988)] = 88877,
  [SMALL_STATE(1989)] = 88931,
  [SMALL_STATE(1990)] = 88974,
  [SMALL_STATE(1991)] = 89017,
  [SMALL_STATE(1992)] = 89060,
  [SMALL_STATE(1993)] = 89103,
  [SMALL_STATE(1994)] = 89146,
  [SMALL_STATE(1995)] = 89189,
  [SMALL_STATE(1996)] = 89232,
  [SMALL_STATE(1997)] = 89275,
  [SMALL_STATE(1998)] = 89318,
  [SMALL_STATE(1999)] = 89361,
  [SMALL_STATE(2000)] = 89404,
  [SMALL_STATE(2001)] = 89447,
  [SMALL_STATE(2002)] = 89490,
  [SMALL_STATE(2003)] = 89533,
  [SMALL_STATE(2004)] = 89576,
  [SMALL_STATE(2005)] = 89619,
  [SMALL_STATE(2006)] = 89662,
  [SMALL_STATE(2007)] = 89705,
  [SMALL_STATE(2008)] = 89748,
  [SMALL_STATE(2009)] = 89791,
  [SMALL_STATE(2010)] = 89834,
  [SMALL_STATE(2011)] = 89877,
  [SMALL_STATE(2012)] = 89920,
  [SMALL_STATE(2013)] = 89963,
  [SMALL_STATE(2014)] = 89997,
  [SMALL_STATE(2015)] = 90040,
  [SMALL_STATE(2016)] = 90074,
  [SMALL_STATE(2017)] = 90106,
  [SMALL_STATE(2018)] = 90129,
  [SMALL_STATE(2019)] = 90152,
  [SMALL_STATE(2020)] = 90181,
  [SMALL_STATE(2021)] = 90223,
  [SMALL_STATE(2022)] = 90261,
  [SMALL_STATE(2023)] = 90291,
  [SMALL_STATE(2024)] = 90333,
  [SMALL_STATE(2025)] = 90359,
  [SMALL_STATE(2026)] = 90401,
  [SMALL_STATE(2027)] = 90443,
  [SMALL_STATE(2028)] = 90485,
  [SMALL_STATE(2029)] = 90511,
  [SMALL_STATE(2030)] = 90553,
  [SMALL_STATE(2031)] = 90588,
  [SMALL_STATE(2032)] = 90623,
  [SMALL_STATE(2033)] = 90650,
  [SMALL_STATE(2034)] = 90685,
  [SMALL_STATE(2035)] = 90720,
  [SMALL_STATE(2036)] = 90755,
  [SMALL_STATE(2037)] = 90790,
  [SMALL_STATE(2038)] = 90825,
  [SMALL_STATE(2039)] = 90860,
  [SMALL_STATE(2040)] = 90892,
  [SMALL_STATE(2041)] = 90928,
  [SMALL_STATE(2042)] = 90960,
  [SMALL_STATE(2043)] = 90984,
  [SMALL_STATE(2044)] = 91016,
  [SMALL_STATE(2045)] = 91052,
  [SMALL_STATE(2046)] = 91076,
  [SMALL_STATE(2047)] = 91108,
  [SMALL_STATE(2048)] = 91144,
  [SMALL_STATE(2049)] = 91174,
  [SMALL_STATE(2050)] = 91210,
  [SMALL_STATE(2051)] = 91234,
  [SMALL_STATE(2052)] = 91266,
  [SMALL_STATE(2053)] = 91302,
  [SMALL_STATE(2054)] = 91326,
  [SMALL_STATE(2055)] = 91350,
  [SMALL_STATE(2056)] = 91374,
  [SMALL_STATE(2057)] = 91406,
  [SMALL_STATE(2058)] = 91430,
  [SMALL_STATE(2059)] = 91466,
  [SMALL_STATE(2060)] = 91488,
  [SMALL_STATE(2061)] = 91520,
  [SMALL_STATE(2062)] = 91552,
  [SMALL_STATE(2063)] = 91573,
  [SMALL_STATE(2064)] = 91594,
  [SMALL_STATE(2065)] = 91615,
  [SMALL_STATE(2066)] = 91636,
  [SMALL_STATE(2067)] = 91657,
  [SMALL_STATE(2068)] = 91674,
  [SMALL_STATE(2069)] = 91693,
  [SMALL_STATE(2070)] = 91710,
  [SMALL_STATE(2071)] = 91728,
  [SMALL_STATE(2072)] = 91746,
  [SMALL_STATE(2073)] = 91764,
  [SMALL_STATE(2074)] = 91784,
  [SMALL_STATE(2075)] = 91804,
  [SMALL_STATE(2076)] = 91822,
  [SMALL_STATE(2077)] = 91856,
  [SMALL_STATE(2078)] = 91874,
  [SMALL_STATE(2079)] = 91892,
  [SMALL_STATE(2080)] = 91912,
  [SMALL_STATE(2081)] = 91930,
  [SMALL_STATE(2082)] = 91948,
  [SMALL_STATE(2083)] = 91968,
  [SMALL_STATE(2084)] = 91986,
  [SMALL_STATE(2085)] = 92006,
  [SMALL_STATE(2086)] = 92024,
  [SMALL_STATE(2087)] = 92042,
  [SMALL_STATE(2088)] = 92076,
  [SMALL_STATE(2089)] = 92110,
  [SMALL_STATE(2090)] = 92130,
  [SMALL_STATE(2091)] = 92148,
  [SMALL_STATE(2092)] = 92166,
  [SMALL_STATE(2093)] = 92184,
  [SMALL_STATE(2094)] = 92218,
  [SMALL_STATE(2095)] = 92236,
  [SMALL_STATE(2096)] = 92270,
  [SMALL_STATE(2097)] = 92288,
  [SMALL_STATE(2098)] = 92306,
  [SMALL_STATE(2099)] = 92336,
  [SMALL_STATE(2100)] = 92354,
  [SMALL_STATE(2101)] = 92372,
  [SMALL_STATE(2102)] = 92390,
  [SMALL_STATE(2103)] = 92408,
  [SMALL_STATE(2104)] = 92428,
  [SMALL_STATE(2105)] = 92446,
  [SMALL_STATE(2106)] = 92480,
  [SMALL_STATE(2107)] = 92500,
  [SMALL_STATE(2108)] = 92534,
  [SMALL_STATE(2109)] = 92552,
  [SMALL_STATE(2110)] = 92570,
  [SMALL_STATE(2111)] = 92588,
  [SMALL_STATE(2112)] = 92622,
  [SMALL_STATE(2113)] = 92656,
  [SMALL_STATE(2114)] = 92690,
  [SMALL_STATE(2115)] = 92721,
  [SMALL_STATE(2116)] = 92752,
  [SMALL_STATE(2117)] = 92783,
  [SMALL_STATE(2118)] = 92814,
  [SMALL_STATE(2119)] = 92839,
  [SMALL_STATE(2120)] = 92870,
  [SMALL_STATE(2121)] = 92901,
  [SMALL_STATE(2122)] = 92932,
  [SMALL_STATE(2123)] = 92963,
  [SMALL_STATE(2124)] = 92994,
  [SMALL_STATE(2125)] = 93025,
  [SMALL_STATE(2126)] = 93056,
  [SMALL_STATE(2127)] = 93087,
  [SMALL_STATE(2128)] = 93118,
  [SMALL_STATE(2129)] = 93149,
  [SMALL_STATE(2130)] = 93180,
  [SMALL_STATE(2131)] = 93199,
  [SMALL_STATE(2132)] = 93230,
  [SMALL_STATE(2133)] = 93255,
  [SMALL_STATE(2134)] = 93273,
  [SMALL_STATE(2135)] = 93295,
  [SMALL_STATE(2136)] = 93317,
  [SMALL_STATE(2137)] = 93335,
  [SMALL_STATE(2138)] = 93355,
  [SMALL_STATE(2139)] = 93377,
  [SMALL_STATE(2140)] = 93395,
  [SMALL_STATE(2141)] = 93417,
  [SMALL_STATE(2142)] = 93435,
  [SMALL_STATE(2143)] = 93457,
  [SMALL_STATE(2144)] = 93473,
  [SMALL_STATE(2145)] = 93498,
  [SMALL_STATE(2146)] = 93523,
  [SMALL_STATE(2147)] = 93536,
  [SMALL_STATE(2148)] = 93561,
  [SMALL_STATE(2149)] = 93578,
  [SMALL_STATE(2150)] = 93603,
  [SMALL_STATE(2151)] = 93628,
  [SMALL_STATE(2152)] = 93653,
  [SMALL_STATE(2153)] = 93678,
  [SMALL_STATE(2154)] = 93703,
  [SMALL_STATE(2155)] = 93716,
  [SMALL_STATE(2156)] = 93733,
  [SMALL_STATE(2157)] = 93754,
  [SMALL_STATE(2158)] = 93779,
  [SMALL_STATE(2159)] = 93796,
  [SMALL_STATE(2160)] = 93821,
  [SMALL_STATE(2161)] = 93842,
  [SMALL_STATE(2162)] = 93867,
  [SMALL_STATE(2163)] = 93892,
  [SMALL_STATE(2164)] = 93917,
  [SMALL_STATE(2165)] = 93932,
  [SMALL_STATE(2166)] = 93947,
  [SMALL_STATE(2167)] = 93972,
  [SMALL_STATE(2168)] = 93997,
  [SMALL_STATE(2169)] = 94022,
  [SMALL_STATE(2170)] = 94047,
  [SMALL_STATE(2171)] = 94072,
  [SMALL_STATE(2172)] = 94089,
  [SMALL_STATE(2173)] = 94114,
  [SMALL_STATE(2174)] = 94139,
  [SMALL_STATE(2175)] = 94152,
  [SMALL_STATE(2176)] = 94175,
  [SMALL_STATE(2177)] = 94196,
  [SMALL_STATE(2178)] = 94217,
  [SMALL_STATE(2179)] = 94242,
  [SMALL_STATE(2180)] = 94267,
  [SMALL_STATE(2181)] = 94292,
  [SMALL_STATE(2182)] = 94317,
  [SMALL_STATE(2183)] = 94334,
  [SMALL_STATE(2184)] = 94359,
  [SMALL_STATE(2185)] = 94384,
  [SMALL_STATE(2186)] = 94405,
  [SMALL_STATE(2187)] = 94430,
  [SMALL_STATE(2188)] = 94451,
  [SMALL_STATE(2189)] = 94476,
  [SMALL_STATE(2190)] = 94501,
  [SMALL_STATE(2191)] = 94518,
  [SMALL_STATE(2192)] = 94535,
  [SMALL_STATE(2193)] = 94552,
  [SMALL_STATE(2194)] = 94565,
  [SMALL_STATE(2195)] = 94578,
  [SMALL_STATE(2196)] = 94595,
  [SMALL_STATE(2197)] = 94612,
  [SMALL_STATE(2198)] = 94637,
  [SMALL_STATE(2199)] = 94654,
  [SMALL_STATE(2200)] = 94671,
  [SMALL_STATE(2201)] = 94688,
  [SMALL_STATE(2202)] = 94713,
  [SMALL_STATE(2203)] = 94730,
  [SMALL_STATE(2204)] = 94749,
  [SMALL_STATE(2205)] = 94774,
  [SMALL_STATE(2206)] = 94795,
  [SMALL_STATE(2207)] = 94812,
  [SMALL_STATE(2208)] = 94829,
  [SMALL_STATE(2209)] = 94854,
  [SMALL_STATE(2210)] = 94871,
  [SMALL_STATE(2211)] = 94896,
  [SMALL_STATE(2212)] = 94921,
  [SMALL_STATE(2213)] = 94946,
  [SMALL_STATE(2214)] = 94971,
  [SMALL_STATE(2215)] = 94996,
  [SMALL_STATE(2216)] = 95017,
  [SMALL_STATE(2217)] = 95042,
  [SMALL_STATE(2218)] = 95067,
  [SMALL_STATE(2219)] = 95089,
  [SMALL_STATE(2220)] = 95105,
  [SMALL_STATE(2221)] = 95121,
  [SMALL_STATE(2222)] = 95143,
  [SMALL_STATE(2223)] = 95165,
  [SMALL_STATE(2224)] = 95187,
  [SMALL_STATE(2225)] = 95209,
  [SMALL_STATE(2226)] = 95231,
  [SMALL_STATE(2227)] = 95253,
  [SMALL_STATE(2228)] = 95275,
  [SMALL_STATE(2229)] = 95293,
  [SMALL_STATE(2230)] = 95315,
  [SMALL_STATE(2231)] = 95331,
  [SMALL_STATE(2232)] = 95347,
  [SMALL_STATE(2233)] = 95369,
  [SMALL_STATE(2234)] = 95387,
  [SMALL_STATE(2235)] = 95407,
  [SMALL_STATE(2236)] = 95429,
  [SMALL_STATE(2237)] = 95451,
  [SMALL_STATE(2238)] = 95473,
  [SMALL_STATE(2239)] = 95495,
  [SMALL_STATE(2240)] = 95511,
  [SMALL_STATE(2241)] = 95529,
  [SMALL_STATE(2242)] = 95547,
  [SMALL_STATE(2243)] = 95569,
  [SMALL_STATE(2244)] = 95587,
  [SMALL_STATE(2245)] = 95607,
  [SMALL_STATE(2246)] = 95623,
  [SMALL_STATE(2247)] = 95645,
  [SMALL_STATE(2248)] = 95661,
  [SMALL_STATE(2249)] = 95683,
  [SMALL_STATE(2250)] = 95699,
  [SMALL_STATE(2251)] = 95715,
  [SMALL_STATE(2252)] = 95731,
  [SMALL_STATE(2253)] = 95753,
  [SMALL_STATE(2254)] = 95775,
  [SMALL_STATE(2255)] = 95797,
  [SMALL_STATE(2256)] = 95819,
  [SMALL_STATE(2257)] = 95837,
  [SMALL_STATE(2258)] = 95859,
  [SMALL_STATE(2259)] = 95881,
  [SMALL_STATE(2260)] = 95903,
  [SMALL_STATE(2261)] = 95925,
  [SMALL_STATE(2262)] = 95947,
  [SMALL_STATE(2263)] = 95967,
  [SMALL_STATE(2264)] = 95983,
  [SMALL_STATE(2265)] = 96001,
  [SMALL_STATE(2266)] = 96023,
  [SMALL_STATE(2267)] = 96039,
  [SMALL_STATE(2268)] = 96055,
  [SMALL_STATE(2269)] = 96067,
  [SMALL_STATE(2270)] = 96089,
  [SMALL_STATE(2271)] = 96107,
  [SMALL_STATE(2272)] = 96129,
  [SMALL_STATE(2273)] = 96151,
  [SMALL_STATE(2274)] = 96173,
  [SMALL_STATE(2275)] = 96191,
  [SMALL_STATE(2276)] = 96207,
  [SMALL_STATE(2277)] = 96223,
  [SMALL_STATE(2278)] = 96245,
  [SMALL_STATE(2279)] = 96261,
  [SMALL_STATE(2280)] = 96281,
  [SMALL_STATE(2281)] = 96297,
  [SMALL_STATE(2282)] = 96319,
  [SMALL_STATE(2283)] = 96341,
  [SMALL_STATE(2284)] = 96353,
  [SMALL_STATE(2285)] = 96375,
  [SMALL_STATE(2286)] = 96393,
  [SMALL_STATE(2287)] = 96409,
  [SMALL_STATE(2288)] = 96431,
  [SMALL_STATE(2289)] = 96447,
  [SMALL_STATE(2290)] = 96469,
  [SMALL_STATE(2291)] = 96481,
  [SMALL_STATE(2292)] = 96497,
  [SMALL_STATE(2293)] = 96519,
  [SMALL_STATE(2294)] = 96541,
  [SMALL_STATE(2295)] = 96563,
  [SMALL_STATE(2296)] = 96579,
  [SMALL_STATE(2297)] = 96591,
  [SMALL_STATE(2298)] = 96613,
  [SMALL_STATE(2299)] = 96629,
  [SMALL_STATE(2300)] = 96651,
  [SMALL_STATE(2301)] = 96662,
  [SMALL_STATE(2302)] = 96673,
  [SMALL_STATE(2303)] = 96692,
  [SMALL_STATE(2304)] = 96703,
  [SMALL_STATE(2305)] = 96722,
  [SMALL_STATE(2306)] = 96741,
  [SMALL_STATE(2307)] = 96760,
  [SMALL_STATE(2308)] = 96779,
  [SMALL_STATE(2309)] = 96798,
  [SMALL_STATE(2310)] = 96809,
  [SMALL_STATE(2311)] = 96828,
  [SMALL_STATE(2312)] = 96839,
  [SMALL_STATE(2313)] = 96850,
  [SMALL_STATE(2314)] = 96861,
  [SMALL_STATE(2315)] = 96872,
  [SMALL_STATE(2316)] = 96885,
  [SMALL_STATE(2317)] = 96896,
  [SMALL_STATE(2318)] = 96907,
  [SMALL_STATE(2319)] = 96926,
  [SMALL_STATE(2320)] = 96945,
  [SMALL_STATE(2321)] = 96956,
  [SMALL_STATE(2322)] = 96975,
  [SMALL_STATE(2323)] = 96986,
  [SMALL_STATE(2324)] = 96997,
  [SMALL_STATE(2325)] = 97016,
  [SMALL_STATE(2326)] = 97035,
  [SMALL_STATE(2327)] = 97054,
  [SMALL_STATE(2328)] = 97073,
  [SMALL_STATE(2329)] = 97092,
  [SMALL_STATE(2330)] = 97111,
  [SMALL_STATE(2331)] = 97122,
  [SMALL_STATE(2332)] = 97141,
  [SMALL_STATE(2333)] = 97152,
  [SMALL_STATE(2334)] = 97171,
  [SMALL_STATE(2335)] = 97190,
  [SMALL_STATE(2336)] = 97201,
  [SMALL_STATE(2337)] = 97220,
  [SMALL_STATE(2338)] = 97233,
  [SMALL_STATE(2339)] = 97246,
  [SMALL_STATE(2340)] = 97257,
  [SMALL_STATE(2341)] = 97268,
  [SMALL_STATE(2342)] = 97285,
  [SMALL_STATE(2343)] = 97304,
  [SMALL_STATE(2344)] = 97323,
  [SMALL_STATE(2345)] = 97342,
  [SMALL_STATE(2346)] = 97353,
  [SMALL_STATE(2347)] = 97372,
  [SMALL_STATE(2348)] = 97385,
  [SMALL_STATE(2349)] = 97404,
  [SMALL_STATE(2350)] = 97415,
  [SMALL_STATE(2351)] = 97432,
  [SMALL_STATE(2352)] = 97443,
  [SMALL_STATE(2353)] = 97454,
  [SMALL_STATE(2354)] = 97465,
  [SMALL_STATE(2355)] = 97476,
  [SMALL_STATE(2356)] = 97487,
  [SMALL_STATE(2357)] = 97502,
  [SMALL_STATE(2358)] = 97513,
  [SMALL_STATE(2359)] = 97524,
  [SMALL_STATE(2360)] = 97535,
  [SMALL_STATE(2361)] = 97554,
  [SMALL_STATE(2362)] = 97565,
  [SMALL_STATE(2363)] = 97576,
  [SMALL_STATE(2364)] = 97591,
  [SMALL_STATE(2365)] = 97602,
  [SMALL_STATE(2366)] = 97617,
  [SMALL_STATE(2367)] = 97628,
  [SMALL_STATE(2368)] = 97647,
  [SMALL_STATE(2369)] = 97666,
  [SMALL_STATE(2370)] = 97677,
  [SMALL_STATE(2371)] = 97692,
  [SMALL_STATE(2372)] = 97703,
  [SMALL_STATE(2373)] = 97714,
  [SMALL_STATE(2374)] = 97733,
  [SMALL_STATE(2375)] = 97752,
  [SMALL_STATE(2376)] = 97769,
  [SMALL_STATE(2377)] = 97780,
  [SMALL_STATE(2378)] = 97791,
  [SMALL_STATE(2379)] = 97806,
  [SMALL_STATE(2380)] = 97825,
  [SMALL_STATE(2381)] = 97836,
  [SMALL_STATE(2382)] = 97847,
  [SMALL_STATE(2383)] = 97858,
  [SMALL_STATE(2384)] = 97877,
  [SMALL_STATE(2385)] = 97888,
  [SMALL_STATE(2386)] = 97899,
  [SMALL_STATE(2387)] = 97910,
  [SMALL_STATE(2388)] = 97921,
  [SMALL_STATE(2389)] = 97932,
  [SMALL_STATE(2390)] = 97943,
  [SMALL_STATE(2391)] = 97954,
  [SMALL_STATE(2392)] = 97965,
  [SMALL_STATE(2393)] = 97976,
  [SMALL_STATE(2394)] = 97995,
  [SMALL_STATE(2395)] = 98014,
  [SMALL_STATE(2396)] = 98029,
  [SMALL_STATE(2397)] = 98040,
  [SMALL_STATE(2398)] = 98051,
  [SMALL_STATE(2399)] = 98062,
  [SMALL_STATE(2400)] = 98077,
  [SMALL_STATE(2401)] = 98088,
  [SMALL_STATE(2402)] = 98099,
  [SMALL_STATE(2403)] = 98110,
  [SMALL_STATE(2404)] = 98121,
  [SMALL_STATE(2405)] = 98132,
  [SMALL_STATE(2406)] = 98143,
  [SMALL_STATE(2407)] = 98154,
  [SMALL_STATE(2408)] = 98173,
  [SMALL_STATE(2409)] = 98192,
  [SMALL_STATE(2410)] = 98203,
  [SMALL_STATE(2411)] = 98222,
  [SMALL_STATE(2412)] = 98233,
  [SMALL_STATE(2413)] = 98248,
  [SMALL_STATE(2414)] = 98267,
  [SMALL_STATE(2415)] = 98278,
  [SMALL_STATE(2416)] = 98293,
  [SMALL_STATE(2417)] = 98312,
  [SMALL_STATE(2418)] = 98323,
  [SMALL_STATE(2419)] = 98334,
  [SMALL_STATE(2420)] = 98353,
  [SMALL_STATE(2421)] = 98372,
  [SMALL_STATE(2422)] = 98391,
  [SMALL_STATE(2423)] = 98402,
  [SMALL_STATE(2424)] = 98417,
  [SMALL_STATE(2425)] = 98436,
  [SMALL_STATE(2426)] = 98447,
  [SMALL_STATE(2427)] = 98458,
  [SMALL_STATE(2428)] = 98473,
  [SMALL_STATE(2429)] = 98484,
  [SMALL_STATE(2430)] = 98503,
  [SMALL_STATE(2431)] = 98514,
  [SMALL_STATE(2432)] = 98525,
  [SMALL_STATE(2433)] = 98536,
  [SMALL_STATE(2434)] = 98555,
  [SMALL_STATE(2435)] = 98566,
  [SMALL_STATE(2436)] = 98577,
  [SMALL_STATE(2437)] = 98588,
  [SMALL_STATE(2438)] = 98607,
  [SMALL_STATE(2439)] = 98626,
  [SMALL_STATE(2440)] = 98637,
  [SMALL_STATE(2441)] = 98652,
  [SMALL_STATE(2442)] = 98663,
  [SMALL_STATE(2443)] = 98674,
  [SMALL_STATE(2444)] = 98685,
  [SMALL_STATE(2445)] = 98704,
  [SMALL_STATE(2446)] = 98715,
  [SMALL_STATE(2447)] = 98726,
  [SMALL_STATE(2448)] = 98737,
  [SMALL_STATE(2449)] = 98756,
  [SMALL_STATE(2450)] = 98767,
  [SMALL_STATE(2451)] = 98786,
  [SMALL_STATE(2452)] = 98805,
  [SMALL_STATE(2453)] = 98824,
  [SMALL_STATE(2454)] = 98835,
  [SMALL_STATE(2455)] = 98854,
  [SMALL_STATE(2456)] = 98865,
  [SMALL_STATE(2457)] = 98884,
  [SMALL_STATE(2458)] = 98895,
  [SMALL_STATE(2459)] = 98914,
  [SMALL_STATE(2460)] = 98929,
  [SMALL_STATE(2461)] = 98948,
  [SMALL_STATE(2462)] = 98967,
  [SMALL_STATE(2463)] = 98986,
  [SMALL_STATE(2464)] = 98997,
  [SMALL_STATE(2465)] = 99008,
  [SMALL_STATE(2466)] = 99027,
  [SMALL_STATE(2467)] = 99042,
  [SMALL_STATE(2468)] = 99061,
  [SMALL_STATE(2469)] = 99076,
  [SMALL_STATE(2470)] = 99087,
  [SMALL_STATE(2471)] = 99102,
  [SMALL_STATE(2472)] = 99121,
  [SMALL_STATE(2473)] = 99140,
  [SMALL_STATE(2474)] = 99155,
  [SMALL_STATE(2475)] = 99174,
  [SMALL_STATE(2476)] = 99185,
  [SMALL_STATE(2477)] = 99200,
  [SMALL_STATE(2478)] = 99211,
  [SMALL_STATE(2479)] = 99222,
  [SMALL_STATE(2480)] = 99233,
  [SMALL_STATE(2481)] = 99248,
  [SMALL_STATE(2482)] = 99265,
  [SMALL_STATE(2483)] = 99284,
  [SMALL_STATE(2484)] = 99303,
  [SMALL_STATE(2485)] = 99318,
  [SMALL_STATE(2486)] = 99333,
  [SMALL_STATE(2487)] = 99344,
  [SMALL_STATE(2488)] = 99363,
  [SMALL_STATE(2489)] = 99378,
  [SMALL_STATE(2490)] = 99393,
  [SMALL_STATE(2491)] = 99412,
  [SMALL_STATE(2492)] = 99431,
  [SMALL_STATE(2493)] = 99446,
  [SMALL_STATE(2494)] = 99461,
  [SMALL_STATE(2495)] = 99480,
  [SMALL_STATE(2496)] = 99491,
  [SMALL_STATE(2497)] = 99506,
  [SMALL_STATE(2498)] = 99517,
  [SMALL_STATE(2499)] = 99530,
  [SMALL_STATE(2500)] = 99541,
  [SMALL_STATE(2501)] = 99552,
  [SMALL_STATE(2502)] = 99563,
  [SMALL_STATE(2503)] = 99574,
  [SMALL_STATE(2504)] = 99585,
  [SMALL_STATE(2505)] = 99602,
  [SMALL_STATE(2506)] = 99613,
  [SMALL_STATE(2507)] = 99632,
  [SMALL_STATE(2508)] = 99643,
  [SMALL_STATE(2509)] = 99654,
  [SMALL_STATE(2510)] = 99665,
  [SMALL_STATE(2511)] = 99680,
  [SMALL_STATE(2512)] = 99699,
  [SMALL_STATE(2513)] = 99718,
  [SMALL_STATE(2514)] = 99737,
  [SMALL_STATE(2515)] = 99753,
  [SMALL_STATE(2516)] = 99767,
  [SMALL_STATE(2517)] = 99783,
  [SMALL_STATE(2518)] = 99797,
  [SMALL_STATE(2519)] = 99811,
  [SMALL_STATE(2520)] = 99825,
  [SMALL_STATE(2521)] = 99839,
  [SMALL_STATE(2522)] = 99853,
  [SMALL_STATE(2523)] = 99867,
  [SMALL_STATE(2524)] = 99881,
  [SMALL_STATE(2525)] = 99895,
  [SMALL_STATE(2526)] = 99909,
  [SMALL_STATE(2527)] = 99921,
  [SMALL_STATE(2528)] = 99937,
  [SMALL_STATE(2529)] = 99951,
  [SMALL_STATE(2530)] = 99965,
  [SMALL_STATE(2531)] = 99981,
  [SMALL_STATE(2532)] = 99997,
  [SMALL_STATE(2533)] = 100013,
  [SMALL_STATE(2534)] = 100025,
  [SMALL_STATE(2535)] = 100039,
  [SMALL_STATE(2536)] = 100053,
  [SMALL_STATE(2537)] = 100069,
  [SMALL_STATE(2538)] = 100083,
  [SMALL_STATE(2539)] = 100097,
  [SMALL_STATE(2540)] = 100111,
  [SMALL_STATE(2541)] = 100125,
  [SMALL_STATE(2542)] = 100141,
  [SMALL_STATE(2543)] = 100155,
  [SMALL_STATE(2544)] = 100171,
  [SMALL_STATE(2545)] = 100185,
  [SMALL_STATE(2546)] = 100201,
  [SMALL_STATE(2547)] = 100217,
  [SMALL_STATE(2548)] = 100231,
  [SMALL_STATE(2549)] = 100247,
  [SMALL_STATE(2550)] = 100261,
  [SMALL_STATE(2551)] = 100275,
  [SMALL_STATE(2552)] = 100291,
  [SMALL_STATE(2553)] = 100307,
  [SMALL_STATE(2554)] = 100323,
  [SMALL_STATE(2555)] = 100339,
  [SMALL_STATE(2556)] = 100355,
  [SMALL_STATE(2557)] = 100371,
  [SMALL_STATE(2558)] = 100387,
  [SMALL_STATE(2559)] = 100401,
  [SMALL_STATE(2560)] = 100415,
  [SMALL_STATE(2561)] = 100429,
  [SMALL_STATE(2562)] = 100445,
  [SMALL_STATE(2563)] = 100461,
  [SMALL_STATE(2564)] = 100475,
  [SMALL_STATE(2565)] = 100491,
  [SMALL_STATE(2566)] = 100505,
  [SMALL_STATE(2567)] = 100519,
  [SMALL_STATE(2568)] = 100533,
  [SMALL_STATE(2569)] = 100549,
  [SMALL_STATE(2570)] = 100565,
  [SMALL_STATE(2571)] = 100581,
  [SMALL_STATE(2572)] = 100597,
  [SMALL_STATE(2573)] = 100613,
  [SMALL_STATE(2574)] = 100623,
  [SMALL_STATE(2575)] = 100637,
  [SMALL_STATE(2576)] = 100651,
  [SMALL_STATE(2577)] = 100665,
  [SMALL_STATE(2578)] = 100681,
  [SMALL_STATE(2579)] = 100697,
  [SMALL_STATE(2580)] = 100713,
  [SMALL_STATE(2581)] = 100729,
  [SMALL_STATE(2582)] = 100743,
  [SMALL_STATE(2583)] = 100759,
  [SMALL_STATE(2584)] = 100773,
  [SMALL_STATE(2585)] = 100789,
  [SMALL_STATE(2586)] = 100805,
  [SMALL_STATE(2587)] = 100821,
  [SMALL_STATE(2588)] = 100831,
  [SMALL_STATE(2589)] = 100847,
  [SMALL_STATE(2590)] = 100861,
  [SMALL_STATE(2591)] = 100875,
  [SMALL_STATE(2592)] = 100891,
  [SMALL_STATE(2593)] = 100907,
  [SMALL_STATE(2594)] = 100923,
  [SMALL_STATE(2595)] = 100939,
  [SMALL_STATE(2596)] = 100955,
  [SMALL_STATE(2597)] = 100969,
  [SMALL_STATE(2598)] = 100985,
  [SMALL_STATE(2599)] = 101001,
  [SMALL_STATE(2600)] = 101017,
  [SMALL_STATE(2601)] = 101033,
  [SMALL_STATE(2602)] = 101049,
  [SMALL_STATE(2603)] = 101063,
  [SMALL_STATE(2604)] = 101077,
  [SMALL_STATE(2605)] = 101091,
  [SMALL_STATE(2606)] = 101105,
  [SMALL_STATE(2607)] = 101121,
  [SMALL_STATE(2608)] = 101137,
  [SMALL_STATE(2609)] = 101153,
  [SMALL_STATE(2610)] = 101167,
  [SMALL_STATE(2611)] = 101180,
  [SMALL_STATE(2612)] = 101189,
  [SMALL_STATE(2613)] = 101202,
  [SMALL_STATE(2614)] = 101215,
  [SMALL_STATE(2615)] = 101228,
  [SMALL_STATE(2616)] = 101241,
  [SMALL_STATE(2617)] = 101250,
  [SMALL_STATE(2618)] = 101263,
  [SMALL_STATE(2619)] = 101276,
  [SMALL_STATE(2620)] = 101289,
  [SMALL_STATE(2621)] = 101302,
  [SMALL_STATE(2622)] = 101315,
  [SMALL_STATE(2623)] = 101328,
  [SMALL_STATE(2624)] = 101341,
  [SMALL_STATE(2625)] = 101354,
  [SMALL_STATE(2626)] = 101367,
  [SMALL_STATE(2627)] = 101380,
  [SMALL_STATE(2628)] = 101393,
  [SMALL_STATE(2629)] = 101406,
  [SMALL_STATE(2630)] = 101419,
  [SMALL_STATE(2631)] = 101432,
  [SMALL_STATE(2632)] = 101445,
  [SMALL_STATE(2633)] = 101458,
  [SMALL_STATE(2634)] = 101471,
  [SMALL_STATE(2635)] = 101484,
  [SMALL_STATE(2636)] = 101497,
  [SMALL_STATE(2637)] = 101506,
  [SMALL_STATE(2638)] = 101519,
  [SMALL_STATE(2639)] = 101532,
  [SMALL_STATE(2640)] = 101545,
  [SMALL_STATE(2641)] = 101558,
  [SMALL_STATE(2642)] = 101569,
  [SMALL_STATE(2643)] = 101578,
  [SMALL_STATE(2644)] = 101591,
  [SMALL_STATE(2645)] = 101600,
  [SMALL_STATE(2646)] = 101613,
  [SMALL_STATE(2647)] = 101626,
  [SMALL_STATE(2648)] = 101639,
  [SMALL_STATE(2649)] = 101652,
  [SMALL_STATE(2650)] = 101661,
  [SMALL_STATE(2651)] = 101674,
  [SMALL_STATE(2652)] = 101687,
  [SMALL_STATE(2653)] = 101700,
  [SMALL_STATE(2654)] = 101709,
  [SMALL_STATE(2655)] = 101722,
  [SMALL_STATE(2656)] = 101735,
  [SMALL_STATE(2657)] = 101748,
  [SMALL_STATE(2658)] = 101757,
  [SMALL_STATE(2659)] = 101770,
  [SMALL_STATE(2660)] = 101779,
  [SMALL_STATE(2661)] = 101788,
  [SMALL_STATE(2662)] = 101801,
  [SMALL_STATE(2663)] = 101814,
  [SMALL_STATE(2664)] = 101823,
  [SMALL_STATE(2665)] = 101836,
  [SMALL_STATE(2666)] = 101847,
  [SMALL_STATE(2667)] = 101860,
  [SMALL_STATE(2668)] = 101873,
  [SMALL_STATE(2669)] = 101886,
  [SMALL_STATE(2670)] = 101899,
  [SMALL_STATE(2671)] = 101912,
  [SMALL_STATE(2672)] = 101923,
  [SMALL_STATE(2673)] = 101936,
  [SMALL_STATE(2674)] = 101945,
  [SMALL_STATE(2675)] = 101958,
  [SMALL_STATE(2676)] = 101967,
  [SMALL_STATE(2677)] = 101980,
  [SMALL_STATE(2678)] = 101993,
  [SMALL_STATE(2679)] = 102006,
  [SMALL_STATE(2680)] = 102019,
  [SMALL_STATE(2681)] = 102032,
  [SMALL_STATE(2682)] = 102045,
  [SMALL_STATE(2683)] = 102058,
  [SMALL_STATE(2684)] = 102069,
  [SMALL_STATE(2685)] = 102082,
  [SMALL_STATE(2686)] = 102095,
  [SMALL_STATE(2687)] = 102108,
  [SMALL_STATE(2688)] = 102121,
  [SMALL_STATE(2689)] = 102132,
  [SMALL_STATE(2690)] = 102145,
  [SMALL_STATE(2691)] = 102158,
  [SMALL_STATE(2692)] = 102169,
  [SMALL_STATE(2693)] = 102178,
  [SMALL_STATE(2694)] = 102191,
  [SMALL_STATE(2695)] = 102204,
  [SMALL_STATE(2696)] = 102217,
  [SMALL_STATE(2697)] = 102230,
  [SMALL_STATE(2698)] = 102243,
  [SMALL_STATE(2699)] = 102252,
  [SMALL_STATE(2700)] = 102265,
  [SMALL_STATE(2701)] = 102278,
  [SMALL_STATE(2702)] = 102291,
  [SMALL_STATE(2703)] = 102304,
  [SMALL_STATE(2704)] = 102313,
  [SMALL_STATE(2705)] = 102326,
  [SMALL_STATE(2706)] = 102335,
  [SMALL_STATE(2707)] = 102344,
  [SMALL_STATE(2708)] = 102357,
  [SMALL_STATE(2709)] = 102370,
  [SMALL_STATE(2710)] = 102383,
  [SMALL_STATE(2711)] = 102396,
  [SMALL_STATE(2712)] = 102407,
  [SMALL_STATE(2713)] = 102420,
  [SMALL_STATE(2714)] = 102433,
  [SMALL_STATE(2715)] = 102446,
  [SMALL_STATE(2716)] = 102459,
  [SMALL_STATE(2717)] = 102470,
  [SMALL_STATE(2718)] = 102483,
  [SMALL_STATE(2719)] = 102496,
  [SMALL_STATE(2720)] = 102509,
  [SMALL_STATE(2721)] = 102518,
  [SMALL_STATE(2722)] = 102531,
  [SMALL_STATE(2723)] = 102540,
  [SMALL_STATE(2724)] = 102553,
  [SMALL_STATE(2725)] = 102562,
  [SMALL_STATE(2726)] = 102571,
  [SMALL_STATE(2727)] = 102580,
  [SMALL_STATE(2728)] = 102593,
  [SMALL_STATE(2729)] = 102606,
  [SMALL_STATE(2730)] = 102619,
  [SMALL_STATE(2731)] = 102632,
  [SMALL_STATE(2732)] = 102645,
  [SMALL_STATE(2733)] = 102658,
  [SMALL_STATE(2734)] = 102671,
  [SMALL_STATE(2735)] = 102680,
  [SMALL_STATE(2736)] = 102689,
  [SMALL_STATE(2737)] = 102702,
  [SMALL_STATE(2738)] = 102711,
  [SMALL_STATE(2739)] = 102724,
  [SMALL_STATE(2740)] = 102733,
  [SMALL_STATE(2741)] = 102742,
  [SMALL_STATE(2742)] = 102751,
  [SMALL_STATE(2743)] = 102762,
  [SMALL_STATE(2744)] = 102771,
  [SMALL_STATE(2745)] = 102784,
  [SMALL_STATE(2746)] = 102793,
  [SMALL_STATE(2747)] = 102802,
  [SMALL_STATE(2748)] = 102815,
  [SMALL_STATE(2749)] = 102824,
  [SMALL_STATE(2750)] = 102835,
  [SMALL_STATE(2751)] = 102848,
  [SMALL_STATE(2752)] = 102861,
  [SMALL_STATE(2753)] = 102874,
  [SMALL_STATE(2754)] = 102887,
  [SMALL_STATE(2755)] = 102896,
  [SMALL_STATE(2756)] = 102909,
  [SMALL_STATE(2757)] = 102922,
  [SMALL_STATE(2758)] = 102935,
  [SMALL_STATE(2759)] = 102948,
  [SMALL_STATE(2760)] = 102961,
  [SMALL_STATE(2761)] = 102974,
  [SMALL_STATE(2762)] = 102983,
  [SMALL_STATE(2763)] = 102992,
  [SMALL_STATE(2764)] = 103005,
  [SMALL_STATE(2765)] = 103018,
  [SMALL_STATE(2766)] = 103031,
  [SMALL_STATE(2767)] = 103044,
  [SMALL_STATE(2768)] = 103055,
  [SMALL_STATE(2769)] = 103068,
  [SMALL_STATE(2770)] = 103081,
  [SMALL_STATE(2771)] = 103092,
  [SMALL_STATE(2772)] = 103105,
  [SMALL_STATE(2773)] = 103114,
  [SMALL_STATE(2774)] = 103127,
  [SMALL_STATE(2775)] = 103138,
  [SMALL_STATE(2776)] = 103151,
  [SMALL_STATE(2777)] = 103162,
  [SMALL_STATE(2778)] = 103171,
  [SMALL_STATE(2779)] = 103184,
  [SMALL_STATE(2780)] = 103193,
  [SMALL_STATE(2781)] = 103206,
  [SMALL_STATE(2782)] = 103219,
  [SMALL_STATE(2783)] = 103228,
  [SMALL_STATE(2784)] = 103237,
  [SMALL_STATE(2785)] = 103246,
  [SMALL_STATE(2786)] = 103259,
  [SMALL_STATE(2787)] = 103270,
  [SMALL_STATE(2788)] = 103283,
  [SMALL_STATE(2789)] = 103296,
  [SMALL_STATE(2790)] = 103309,
  [SMALL_STATE(2791)] = 103322,
  [SMALL_STATE(2792)] = 103335,
  [SMALL_STATE(2793)] = 103348,
  [SMALL_STATE(2794)] = 103358,
  [SMALL_STATE(2795)] = 103366,
  [SMALL_STATE(2796)] = 103374,
  [SMALL_STATE(2797)] = 103384,
  [SMALL_STATE(2798)] = 103394,
  [SMALL_STATE(2799)] = 103404,
  [SMALL_STATE(2800)] = 103414,
  [SMALL_STATE(2801)] = 103424,
  [SMALL_STATE(2802)] = 103432,
  [SMALL_STATE(2803)] = 103442,
  [SMALL_STATE(2804)] = 103452,
  [SMALL_STATE(2805)] = 103462,
  [SMALL_STATE(2806)] = 103472,
  [SMALL_STATE(2807)] = 103482,
  [SMALL_STATE(2808)] = 103490,
  [SMALL_STATE(2809)] = 103500,
  [SMALL_STATE(2810)] = 103510,
  [SMALL_STATE(2811)] = 103520,
  [SMALL_STATE(2812)] = 103530,
  [SMALL_STATE(2813)] = 103540,
  [SMALL_STATE(2814)] = 103550,
  [SMALL_STATE(2815)] = 103558,
  [SMALL_STATE(2816)] = 103566,
  [SMALL_STATE(2817)] = 103574,
  [SMALL_STATE(2818)] = 103584,
  [SMALL_STATE(2819)] = 103592,
  [SMALL_STATE(2820)] = 103602,
  [SMALL_STATE(2821)] = 103610,
  [SMALL_STATE(2822)] = 103618,
  [SMALL_STATE(2823)] = 103626,
  [SMALL_STATE(2824)] = 103636,
  [SMALL_STATE(2825)] = 103644,
  [SMALL_STATE(2826)] = 103652,
  [SMALL_STATE(2827)] = 103660,
  [SMALL_STATE(2828)] = 103670,
  [SMALL_STATE(2829)] = 103680,
  [SMALL_STATE(2830)] = 103688,
  [SMALL_STATE(2831)] = 103698,
  [SMALL_STATE(2832)] = 103708,
  [SMALL_STATE(2833)] = 103716,
  [SMALL_STATE(2834)] = 103724,
  [SMALL_STATE(2835)] = 103732,
  [SMALL_STATE(2836)] = 103742,
  [SMALL_STATE(2837)] = 103752,
  [SMALL_STATE(2838)] = 103762,
  [SMALL_STATE(2839)] = 103772,
  [SMALL_STATE(2840)] = 103782,
  [SMALL_STATE(2841)] = 103790,
  [SMALL_STATE(2842)] = 103798,
  [SMALL_STATE(2843)] = 103808,
  [SMALL_STATE(2844)] = 103818,
  [SMALL_STATE(2845)] = 103826,
  [SMALL_STATE(2846)] = 103836,
  [SMALL_STATE(2847)] = 103846,
  [SMALL_STATE(2848)] = 103856,
  [SMALL_STATE(2849)] = 103866,
  [SMALL_STATE(2850)] = 103876,
  [SMALL_STATE(2851)] = 103884,
  [SMALL_STATE(2852)] = 103894,
  [SMALL_STATE(2853)] = 103902,
  [SMALL_STATE(2854)] = 103912,
  [SMALL_STATE(2855)] = 103920,
  [SMALL_STATE(2856)] = 103930,
  [SMALL_STATE(2857)] = 103940,
  [SMALL_STATE(2858)] = 103950,
  [SMALL_STATE(2859)] = 103960,
  [SMALL_STATE(2860)] = 103970,
  [SMALL_STATE(2861)] = 103980,
  [SMALL_STATE(2862)] = 103990,
  [SMALL_STATE(2863)] = 103998,
  [SMALL_STATE(2864)] = 104008,
  [SMALL_STATE(2865)] = 104016,
  [SMALL_STATE(2866)] = 104024,
  [SMALL_STATE(2867)] = 104034,
  [SMALL_STATE(2868)] = 104044,
  [SMALL_STATE(2869)] = 104054,
  [SMALL_STATE(2870)] = 104064,
  [SMALL_STATE(2871)] = 104074,
  [SMALL_STATE(2872)] = 104082,
  [SMALL_STATE(2873)] = 104090,
  [SMALL_STATE(2874)] = 104098,
  [SMALL_STATE(2875)] = 104106,
  [SMALL_STATE(2876)] = 104116,
  [SMALL_STATE(2877)] = 104124,
  [SMALL_STATE(2878)] = 104134,
  [SMALL_STATE(2879)] = 104144,
  [SMALL_STATE(2880)] = 104154,
  [SMALL_STATE(2881)] = 104162,
  [SMALL_STATE(2882)] = 104172,
  [SMALL_STATE(2883)] = 104182,
  [SMALL_STATE(2884)] = 104192,
  [SMALL_STATE(2885)] = 104202,
  [SMALL_STATE(2886)] = 104212,
  [SMALL_STATE(2887)] = 104222,
  [SMALL_STATE(2888)] = 104232,
  [SMALL_STATE(2889)] = 104242,
  [SMALL_STATE(2890)] = 104252,
  [SMALL_STATE(2891)] = 104262,
  [SMALL_STATE(2892)] = 104272,
  [SMALL_STATE(2893)] = 104282,
  [SMALL_STATE(2894)] = 104292,
  [SMALL_STATE(2895)] = 104300,
  [SMALL_STATE(2896)] = 104310,
  [SMALL_STATE(2897)] = 104320,
  [SMALL_STATE(2898)] = 104330,
  [SMALL_STATE(2899)] = 104338,
  [SMALL_STATE(2900)] = 104348,
  [SMALL_STATE(2901)] = 104358,
  [SMALL_STATE(2902)] = 104368,
  [SMALL_STATE(2903)] = 104378,
  [SMALL_STATE(2904)] = 104386,
  [SMALL_STATE(2905)] = 104396,
  [SMALL_STATE(2906)] = 104406,
  [SMALL_STATE(2907)] = 104414,
  [SMALL_STATE(2908)] = 104424,
  [SMALL_STATE(2909)] = 104434,
  [SMALL_STATE(2910)] = 104444,
  [SMALL_STATE(2911)] = 104454,
  [SMALL_STATE(2912)] = 104464,
  [SMALL_STATE(2913)] = 104472,
  [SMALL_STATE(2914)] = 104482,
  [SMALL_STATE(2915)] = 104490,
  [SMALL_STATE(2916)] = 104500,
  [SMALL_STATE(2917)] = 104510,
  [SMALL_STATE(2918)] = 104518,
  [SMALL_STATE(2919)] = 104528,
  [SMALL_STATE(2920)] = 104538,
  [SMALL_STATE(2921)] = 104548,
  [SMALL_STATE(2922)] = 104558,
  [SMALL_STATE(2923)] = 104568,
  [SMALL_STATE(2924)] = 104578,
  [SMALL_STATE(2925)] = 104588,
  [SMALL_STATE(2926)] = 104598,
  [SMALL_STATE(2927)] = 104606,
  [SMALL_STATE(2928)] = 104614,
  [SMALL_STATE(2929)] = 104624,
  [SMALL_STATE(2930)] = 104634,
  [SMALL_STATE(2931)] = 104644,
  [SMALL_STATE(2932)] = 104652,
  [SMALL_STATE(2933)] = 104662,
  [SMALL_STATE(2934)] = 104670,
  [SMALL_STATE(2935)] = 104680,
  [SMALL_STATE(2936)] = 104688,
  [SMALL_STATE(2937)] = 104698,
  [SMALL_STATE(2938)] = 104708,
  [SMALL_STATE(2939)] = 104718,
  [SMALL_STATE(2940)] = 104728,
  [SMALL_STATE(2941)] = 104738,
  [SMALL_STATE(2942)] = 104748,
  [SMALL_STATE(2943)] = 104758,
  [SMALL_STATE(2944)] = 104768,
  [SMALL_STATE(2945)] = 104778,
  [SMALL_STATE(2946)] = 104788,
  [SMALL_STATE(2947)] = 104798,
  [SMALL_STATE(2948)] = 104808,
  [SMALL_STATE(2949)] = 104818,
  [SMALL_STATE(2950)] = 104828,
  [SMALL_STATE(2951)] = 104838,
  [SMALL_STATE(2952)] = 104848,
  [SMALL_STATE(2953)] = 104858,
  [SMALL_STATE(2954)] = 104868,
  [SMALL_STATE(2955)] = 104878,
  [SMALL_STATE(2956)] = 104888,
  [SMALL_STATE(2957)] = 104898,
  [SMALL_STATE(2958)] = 104908,
  [SMALL_STATE(2959)] = 104918,
  [SMALL_STATE(2960)] = 104928,
  [SMALL_STATE(2961)] = 104938,
  [SMALL_STATE(2962)] = 104948,
  [SMALL_STATE(2963)] = 104956,
  [SMALL_STATE(2964)] = 104964,
  [SMALL_STATE(2965)] = 104974,
  [SMALL_STATE(2966)] = 104984,
  [SMALL_STATE(2967)] = 104994,
  [SMALL_STATE(2968)] = 105004,
  [SMALL_STATE(2969)] = 105012,
  [SMALL_STATE(2970)] = 105022,
  [SMALL_STATE(2971)] = 105032,
  [SMALL_STATE(2972)] = 105040,
  [SMALL_STATE(2973)] = 105050,
  [SMALL_STATE(2974)] = 105060,
  [SMALL_STATE(2975)] = 105070,
  [SMALL_STATE(2976)] = 105080,
  [SMALL_STATE(2977)] = 105090,
  [SMALL_STATE(2978)] = 105100,
  [SMALL_STATE(2979)] = 105110,
  [SMALL_STATE(2980)] = 105120,
  [SMALL_STATE(2981)] = 105130,
  [SMALL_STATE(2982)] = 105140,
  [SMALL_STATE(2983)] = 105150,
  [SMALL_STATE(2984)] = 105160,
  [SMALL_STATE(2985)] = 105170,
  [SMALL_STATE(2986)] = 105180,
  [SMALL_STATE(2987)] = 105190,
  [SMALL_STATE(2988)] = 105200,
  [SMALL_STATE(2989)] = 105210,
  [SMALL_STATE(2990)] = 105220,
  [SMALL_STATE(2991)] = 105230,
  [SMALL_STATE(2992)] = 105240,
  [SMALL_STATE(2993)] = 105248,
  [SMALL_STATE(2994)] = 105258,
  [SMALL_STATE(2995)] = 105265,
  [SMALL_STATE(2996)] = 105272,
  [SMALL_STATE(2997)] = 105279,
  [SMALL_STATE(2998)] = 105286,
  [SMALL_STATE(2999)] = 105293,
  [SMALL_STATE(3000)] = 105300,
  [SMALL_STATE(3001)] = 105307,
  [SMALL_STATE(3002)] = 105314,
  [SMALL_STATE(3003)] = 105321,
  [SMALL_STATE(3004)] = 105328,
  [SMALL_STATE(3005)] = 105335,
  [SMALL_STATE(3006)] = 105342,
  [SMALL_STATE(3007)] = 105349,
  [SMALL_STATE(3008)] = 105356,
  [SMALL_STATE(3009)] = 105363,
  [SMALL_STATE(3010)] = 105370,
  [SMALL_STATE(3011)] = 105377,
  [SMALL_STATE(3012)] = 105384,
  [SMALL_STATE(3013)] = 105391,
  [SMALL_STATE(3014)] = 105398,
  [SMALL_STATE(3015)] = 105405,
  [SMALL_STATE(3016)] = 105412,
  [SMALL_STATE(3017)] = 105419,
  [SMALL_STATE(3018)] = 105426,
  [SMALL_STATE(3019)] = 105433,
  [SMALL_STATE(3020)] = 105440,
  [SMALL_STATE(3021)] = 105447,
  [SMALL_STATE(3022)] = 105454,
  [SMALL_STATE(3023)] = 105461,
  [SMALL_STATE(3024)] = 105468,
  [SMALL_STATE(3025)] = 105475,
  [SMALL_STATE(3026)] = 105482,
  [SMALL_STATE(3027)] = 105489,
  [SMALL_STATE(3028)] = 105496,
  [SMALL_STATE(3029)] = 105503,
  [SMALL_STATE(3030)] = 105510,
  [SMALL_STATE(3031)] = 105517,
  [SMALL_STATE(3032)] = 105524,
  [SMALL_STATE(3033)] = 105531,
  [SMALL_STATE(3034)] = 105538,
  [SMALL_STATE(3035)] = 105545,
  [SMALL_STATE(3036)] = 105552,
  [SMALL_STATE(3037)] = 105559,
  [SMALL_STATE(3038)] = 105566,
  [SMALL_STATE(3039)] = 105573,
  [SMALL_STATE(3040)] = 105580,
  [SMALL_STATE(3041)] = 105587,
  [SMALL_STATE(3042)] = 105594,
  [SMALL_STATE(3043)] = 105601,
  [SMALL_STATE(3044)] = 105608,
  [SMALL_STATE(3045)] = 105615,
  [SMALL_STATE(3046)] = 105622,
  [SMALL_STATE(3047)] = 105629,
  [SMALL_STATE(3048)] = 105636,
  [SMALL_STATE(3049)] = 105643,
  [SMALL_STATE(3050)] = 105650,
  [SMALL_STATE(3051)] = 105657,
  [SMALL_STATE(3052)] = 105664,
  [SMALL_STATE(3053)] = 105671,
  [SMALL_STATE(3054)] = 105678,
  [SMALL_STATE(3055)] = 105685,
  [SMALL_STATE(3056)] = 105692,
  [SMALL_STATE(3057)] = 105699,
  [SMALL_STATE(3058)] = 105706,
  [SMALL_STATE(3059)] = 105713,
  [SMALL_STATE(3060)] = 105720,
  [SMALL_STATE(3061)] = 105727,
  [SMALL_STATE(3062)] = 105734,
  [SMALL_STATE(3063)] = 105741,
  [SMALL_STATE(3064)] = 105748,
  [SMALL_STATE(3065)] = 105755,
  [SMALL_STATE(3066)] = 105762,
  [SMALL_STATE(3067)] = 105769,
  [SMALL_STATE(3068)] = 105776,
  [SMALL_STATE(3069)] = 105783,
  [SMALL_STATE(3070)] = 105790,
  [SMALL_STATE(3071)] = 105797,
  [SMALL_STATE(3072)] = 105804,
  [SMALL_STATE(3073)] = 105811,
  [SMALL_STATE(3074)] = 105818,
  [SMALL_STATE(3075)] = 105825,
  [SMALL_STATE(3076)] = 105832,
  [SMALL_STATE(3077)] = 105839,
  [SMALL_STATE(3078)] = 105846,
  [SMALL_STATE(3079)] = 105853,
  [SMALL_STATE(3080)] = 105860,
  [SMALL_STATE(3081)] = 105867,
  [SMALL_STATE(3082)] = 105874,
  [SMALL_STATE(3083)] = 105881,
  [SMALL_STATE(3084)] = 105888,
  [SMALL_STATE(3085)] = 105895,
  [SMALL_STATE(3086)] = 105902,
  [SMALL_STATE(3087)] = 105909,
  [SMALL_STATE(3088)] = 105916,
  [SMALL_STATE(3089)] = 105923,
  [SMALL_STATE(3090)] = 105930,
  [SMALL_STATE(3091)] = 105937,
  [SMALL_STATE(3092)] = 105944,
  [SMALL_STATE(3093)] = 105951,
  [SMALL_STATE(3094)] = 105958,
  [SMALL_STATE(3095)] = 105965,
  [SMALL_STATE(3096)] = 105972,
  [SMALL_STATE(3097)] = 105979,
  [SMALL_STATE(3098)] = 105986,
  [SMALL_STATE(3099)] = 105993,
  [SMALL_STATE(3100)] = 106000,
  [SMALL_STATE(3101)] = 106007,
  [SMALL_STATE(3102)] = 106014,
  [SMALL_STATE(3103)] = 106021,
  [SMALL_STATE(3104)] = 106028,
  [SMALL_STATE(3105)] = 106035,
  [SMALL_STATE(3106)] = 106042,
  [SMALL_STATE(3107)] = 106049,
  [SMALL_STATE(3108)] = 106056,
  [SMALL_STATE(3109)] = 106063,
  [SMALL_STATE(3110)] = 106070,
  [SMALL_STATE(3111)] = 106077,
  [SMALL_STATE(3112)] = 106084,
  [SMALL_STATE(3113)] = 106091,
  [SMALL_STATE(3114)] = 106098,
  [SMALL_STATE(3115)] = 106105,
  [SMALL_STATE(3116)] = 106112,
  [SMALL_STATE(3117)] = 106119,
  [SMALL_STATE(3118)] = 106126,
  [SMALL_STATE(3119)] = 106133,
  [SMALL_STATE(3120)] = 106140,
  [SMALL_STATE(3121)] = 106147,
  [SMALL_STATE(3122)] = 106154,
  [SMALL_STATE(3123)] = 106161,
  [SMALL_STATE(3124)] = 106168,
  [SMALL_STATE(3125)] = 106175,
  [SMALL_STATE(3126)] = 106182,
  [SMALL_STATE(3127)] = 106189,
  [SMALL_STATE(3128)] = 106196,
  [SMALL_STATE(3129)] = 106203,
  [SMALL_STATE(3130)] = 106210,
  [SMALL_STATE(3131)] = 106217,
  [SMALL_STATE(3132)] = 106224,
  [SMALL_STATE(3133)] = 106231,
  [SMALL_STATE(3134)] = 106238,
  [SMALL_STATE(3135)] = 106245,
  [SMALL_STATE(3136)] = 106252,
  [SMALL_STATE(3137)] = 106259,
  [SMALL_STATE(3138)] = 106266,
  [SMALL_STATE(3139)] = 106273,
  [SMALL_STATE(3140)] = 106280,
  [SMALL_STATE(3141)] = 106287,
  [SMALL_STATE(3142)] = 106294,
  [SMALL_STATE(3143)] = 106301,
  [SMALL_STATE(3144)] = 106308,
  [SMALL_STATE(3145)] = 106315,
  [SMALL_STATE(3146)] = 106322,
  [SMALL_STATE(3147)] = 106329,
  [SMALL_STATE(3148)] = 106336,
  [SMALL_STATE(3149)] = 106343,
  [SMALL_STATE(3150)] = 106350,
  [SMALL_STATE(3151)] = 106357,
  [SMALL_STATE(3152)] = 106364,
  [SMALL_STATE(3153)] = 106371,
  [SMALL_STATE(3154)] = 106378,
  [SMALL_STATE(3155)] = 106385,
  [SMALL_STATE(3156)] = 106392,
  [SMALL_STATE(3157)] = 106399,
  [SMALL_STATE(3158)] = 106406,
  [SMALL_STATE(3159)] = 106413,
  [SMALL_STATE(3160)] = 106420,
  [SMALL_STATE(3161)] = 106427,
  [SMALL_STATE(3162)] = 106434,
  [SMALL_STATE(3163)] = 106441,
  [SMALL_STATE(3164)] = 106448,
  [SMALL_STATE(3165)] = 106455,
  [SMALL_STATE(3166)] = 106462,
  [SMALL_STATE(3167)] = 106469,
  [SMALL_STATE(3168)] = 106476,
  [SMALL_STATE(3169)] = 106483,
  [SMALL_STATE(3170)] = 106490,
  [SMALL_STATE(3171)] = 106497,
  [SMALL_STATE(3172)] = 106504,
  [SMALL_STATE(3173)] = 106511,
  [SMALL_STATE(3174)] = 106518,
  [SMALL_STATE(3175)] = 106525,
  [SMALL_STATE(3176)] = 106532,
  [SMALL_STATE(3177)] = 106539,
  [SMALL_STATE(3178)] = 106546,
  [SMALL_STATE(3179)] = 106553,
  [SMALL_STATE(3180)] = 106560,
  [SMALL_STATE(3181)] = 106567,
  [SMALL_STATE(3182)] = 106574,
  [SMALL_STATE(3183)] = 106581,
  [SMALL_STATE(3184)] = 106588,
  [SMALL_STATE(3185)] = 106595,
  [SMALL_STATE(3186)] = 106602,
  [SMALL_STATE(3187)] = 106609,
  [SMALL_STATE(3188)] = 106616,
  [SMALL_STATE(3189)] = 106623,
  [SMALL_STATE(3190)] = 106630,
  [SMALL_STATE(3191)] = 106637,
  [SMALL_STATE(3192)] = 106644,
  [SMALL_STATE(3193)] = 106651,
  [SMALL_STATE(3194)] = 106658,
  [SMALL_STATE(3195)] = 106665,
  [SMALL_STATE(3196)] = 106672,
  [SMALL_STATE(3197)] = 106679,
  [SMALL_STATE(3198)] = 106686,
  [SMALL_STATE(3199)] = 106693,
  [SMALL_STATE(3200)] = 106700,
  [SMALL_STATE(3201)] = 106707,
  [SMALL_STATE(3202)] = 106714,
  [SMALL_STATE(3203)] = 106721,
  [SMALL_STATE(3204)] = 106728,
  [SMALL_STATE(3205)] = 106735,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3182),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(889),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(184),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(727),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(824),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(297),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1022),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2248),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2253),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2214),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2802),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2805),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2614),
  [250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(151),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(299),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2808),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(38),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2809),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2810),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2688),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2691),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2816),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(176),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(253),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(596),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(103),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(155),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(787),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3194),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2093),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(574),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2151),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(241),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(318),
  [313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(322),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(61),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(326),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2516),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2582),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2274),
  [331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1292),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1292),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1134),
  [340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2015),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(837),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3183),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(352),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(729),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3182),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3181),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2856),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(32),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(259),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(351),
  [681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [684] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(490),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3129),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(250),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 132),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 132),
  [1217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 132),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 132),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 100),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 100),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 100),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 100),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 154),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 154),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 154),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 154),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 93),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 93),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 93),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 93),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 126),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 126),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 126),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 126),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 126),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 126),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 126),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 126),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 92),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 92),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 92),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 92),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 27),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 27),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 151),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 151),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 151),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 151),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 123),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 123),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 49),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 49),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 131),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 131),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 131),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 131),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [1373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 105),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 105),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 105),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [1521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [1668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [1682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [1688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [2030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [2394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [2744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1989),
  [2747] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1894),
  [2751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(323),
  [2754] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2884),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 90),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 90),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [2778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [2784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [2796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [2800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [2804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [2808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [2816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [2832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [2846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [2854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [2856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [2858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [2860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [2862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [2864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [2866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [2870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [2872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [2876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [2880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [2890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(901),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [2901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [2905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [2915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [2931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [2933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2543),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [2969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1), SHIFT(901),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [2976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [2978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [2980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [2982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1894),
  [2993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2884),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5),
  [3004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3),
  [3012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [3016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [3018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 6, .production_id = 153),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 6, .production_id = 153),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [3046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(164),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 163),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 163),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 162),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 162),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 161),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 161),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 92),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 126),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 126),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 136),
  [3121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 136),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [3125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 127),
  [3137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 127),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 93),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 93),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 100),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 100),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 139),
  [3149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 139),
  [3151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [3153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [3155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 125),
  [3157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 125),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 93),
  [3161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 93),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [3165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [3167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 128),
  [3169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 128),
  [3171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 99),
  [3173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 99),
  [3175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [3177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [3193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [3195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 68),
  [3197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 68),
  [3199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [3201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [3205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 92),
  [3209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 92),
  [3211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 104),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 104),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 123),
  [3217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 123),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 70),
  [3221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 70),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 126),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 126),
  [3227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 152),
  [3229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 152),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 110),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 110),
  [3235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 154),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 154),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [3253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 111),
  [3257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 111),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 131),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 131),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 132),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 132),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 105),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 112),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 112),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 160),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 160),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 130),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 130),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [3325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [3329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 123),
  [3341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 123),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [3347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 116),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 116),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 151),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 151),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [3367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 138),
  [3369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 138),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 137),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 137),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 158),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 158),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 157),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 157),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 156),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 156),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4),
  [3407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [3471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [3487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [3493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [3505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [3515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [3529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [3543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(931),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 103),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 103),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(216),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [3595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [3605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [3609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [3613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [3615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [3617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [3623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [3649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [3653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(901),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 90),
  [3741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 90),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [3760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [3794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(859),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1), SHIFT(376),
  [3836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3839] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(274),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [3909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [3932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1), SHIFT(474),
  [3935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [4019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [4023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [4035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [4072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [4088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [4090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [4092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [4096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(828),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [4103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 28),
  [4105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 28),
  [4107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [4111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [4117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [4119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [4121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [4125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 28),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 28),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [4137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [4173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [4175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [4177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(213),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [4186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(214),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [4197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [4199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [4201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(828),
  [4204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 133),
  [4206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 133),
  [4208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(101),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [4223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 107),
  [4225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 107),
  [4227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 106),
  [4229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 106),
  [4231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 102),
  [4233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 102),
  [4235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 101),
  [4237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 101),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [4241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [4243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 96),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 96),
  [4271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [4273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [4275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 97),
  [4277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 97),
  [4279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 96),
  [4281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 96),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [4289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 94),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 94),
  [4293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 91),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 91),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [4299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 65), REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 65),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [4306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 66),
  [4332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 74),
  [4344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 66),
  [4348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 57),
  [4371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [4375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [4377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [4379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [4385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [4391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 129),
  [4393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [4397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [4403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(107),
  [4406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [4408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [4410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [4412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 52),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 52),
  [4420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [4422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 51),
  [4424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 51),
  [4426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 50),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 50),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 2),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [4468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(107),
  [4475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [4477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(101),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [4484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 124),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 124),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [4498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [4500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [4506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [4510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [4516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [4522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 13),
  [4558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 13),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [4564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 90),
  [4567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 78),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [4571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(98),
  [4574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(108),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [4581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [4593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [4595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [4597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [4599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [4601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 129),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [4607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(98),
  [4610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(104),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [4623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [4625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [4629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [4633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [4637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [4643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [4647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(104),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [4658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [4686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(108),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [4697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [4699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [4701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 48),
  [4703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 48),
  [4705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [4707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [4719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(851),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [4752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [4830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(279),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [4841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [4849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(282),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [4870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [4882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(851),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(102),
  [4898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2069),
  [4901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1992),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(197),
  [4909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1731),
  [4912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2561),
  [4915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2562),
  [4918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2029),
  [4921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2015),
  [4924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1732),
  [4927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1986),
  [4930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1858),
  [4933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1709),
  [4936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1673),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [4947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 75),
  [4949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(102),
  [4952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(831),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1), SHIFT(831),
  [4964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [5002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(106),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [5007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [5013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [5015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [5017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [5021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [5023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [5035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [5043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [5046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [5048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [5051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(456),
  [5058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [5061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [5064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(461),
  [5067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [5070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(460),
  [5078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [5080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(462),
  [5083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [5085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(105),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [5092] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [5108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(105),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [5117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [5121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [5125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [5131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(106),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [5166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [5190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [5208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [5212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [5214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [5224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [5234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [5268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [5284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [5286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [5292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2, .production_id = 18),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, .production_id = 18),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [5298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [5312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [5314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [5316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [5318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [5328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [5330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [5332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [5334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [5342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [5350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [5354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [5358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [5362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [5364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [5366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 135),
  [5368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 135),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [5372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 185),
  [5374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 185),
  [5376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [5382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [5384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [5386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [5390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [5392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 100),
  [5394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 100),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 109),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 109),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [5406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 155),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 155),
  [5410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 126),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 126),
  [5414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 172),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 172),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [5420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 173),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 173),
  [5424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 181),
  [5426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 181),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [5430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 180),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 180),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [5460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [5462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [5464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(2015),
  [5467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [5475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [5477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [5483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [5485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [5487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [5489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 117),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [5513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 146),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 72),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 146),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 117),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 72),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 117),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 117),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 72),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 72),
  [5584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 146),
  [5586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [5589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 146),
  [5591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [5599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [5603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [5605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [5607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [5613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [5627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [5629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [5631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [5633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [5645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [5647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [5653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [5669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [5671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 89),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [5687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 99),
  [5689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 119),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3),
  [5715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [5721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [5723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [5731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 143),
  [5733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 125),
  [5735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2),
  [5737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 6, .production_id = 142),
  [5739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 114),
  [5741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 164),
  [5743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 165),
  [5745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 174),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [5751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 175),
  [5753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [5759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 182),
  [5763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 183),
  [5765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 186),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3204),
  [5832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(251),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [5839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2243),
  [5842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(248),
  [5847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [5853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [5859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1049),
  [5862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [5884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [5894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 67),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [5916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [5948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [5956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 46),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [5978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3),
  [5982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4),
  [5984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 120),
  [5986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 85),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [5990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [5992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 118),
  [5994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [6002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 144),
  [6006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 145),
  [6008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 120),
  [6010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [6012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 118),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [6022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [6024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 144),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [6036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(924),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [6043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 145),
  [6045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [6065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 176),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [6071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [6075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 166),
  [6077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 167),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [6081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [6085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [6091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 176),
  [6099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 166),
  [6101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2),
  [6103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [6105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [6109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6),
  [6111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [6113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 167),
  [6115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [6119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [6127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [6131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [6133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [6147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [6153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [6157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [6161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [6175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(174),
  [6178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(156),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [6183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2258),
  [6186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [6190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [6194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [6198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(177),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [6205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2556),
  [6208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2556),
  [6211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [6213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2557),
  [6216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2557),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [6231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [6237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [6241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3),
  [6247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3),
  [6249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [6251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [6253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [6255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [6287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [6293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [6311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 178),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [6327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [6351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1983),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [6372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 150),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [6378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 184),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [6384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [6386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2978),
  [6389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(922),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 143),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [6398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2537),
  [6401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [6407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 125),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [6417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 149),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [6421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 148),
  [6423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1438),
  [6426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 165),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [6438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 147),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [6442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [6456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [6478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 174),
  [6480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(838),
  [6483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(894),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [6492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 179),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [6498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [6500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 177),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [6504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [6514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [6526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 121),
  [6528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [6532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 99),
  [6534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 122),
  [6536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 79),
  [6538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(927),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [6545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1912),
  [6548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22),
  [6550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 168),
  [6552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [6554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(923),
  [6557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 169),
  [6559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [6561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [6565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 72),
  [6567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 80),
  [6569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(928),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [6574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 73),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [6582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(941),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [6589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [6593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 170),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [6607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 73),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [6615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(909),
  [6620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [6622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2521),
  [6625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 164),
  [6629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 171),
  [6631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 73),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [6645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 113),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [6661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 69),
  [6663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 3),
  [6665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [6669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 87),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [6675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [6685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 40),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [6689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [6703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 134),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [6709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 108),
  [6711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 73),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [6717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 40),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [6721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 77),
  [6723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 115),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [6775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [6793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [6815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 77),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [6821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [6907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 77),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [6913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [6961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [7009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [7055] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [7069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [7087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 77),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [7095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [7097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
